#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <set>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<ll> w;

ll n, m, p, g;

vector<vector<pair<ll, ll>>> G;

const ll INF = 2e18;
ll Ans = INF;
void dfs(ll v, ll mx, ll cur, ll cnt, ll cur_p) {
	if (v == n - 1) {
		Ans = min(Ans, cur);
		return;
	}
	if (cnt == 0 || cur >= Ans)
		return;
	for (auto [u, x] : G[v]) {
		ll new_cur_p, new_cur;
		if (x <= cur_p) {
			new_cur = 0;
		}
		else {
			new_cur = (x - cur_p - 1) / mx + 1;
		}
		dfs(u, max(w[u], mx), cur + new_cur, cnt - 1, cur_p + new_cur * mx - x);
	}
}

void solve() {
	cin >> n >> m >> p >> g;
	w.assign(n, 0);
	for (ll i = 0; i < n; i++) {
		cin >> w[i];
	}
	G.assign(n, {});
	ll a, b, s;
	for (ll i = 0; i < m; i++) {
		cin >> a >> b >> s; a--; b--;
		G[a].push_back({ b, s });
	}
	if (g == 2) {
		ll mx = w[0], ans = 0;
		for (ll i = 0; i < n - 1; i++) {
			mx = max(mx, w[i]);
			if (G[i][0].second > p) {
				ans += (G[i][0].second - p - 1) / mx + 1;
				p += ((G[i][0].second - p - 1) / mx + 1) * mx;
			}
			p -= G[i][0].second;
		}
		cout << ans;
		return;
	}
	if (g == 3 || g == 0) {
		dfs(0, w[0], 0, n - 1, p);
		if (Ans == INF) {
			cout << "-1";
		}
		else {
			cout << Ans;
		}
		return;
	}
}

int main() {
	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
	}
}

/*
5
10 4
5 4
3 4
1 4
7 4

*/