use std::io::{self, prelude::*};

#[allow(clippy::too_many_arguments)]
fn build(
    g: &[Vec<(usize, i64)>],
    w: &[i64],
    all: &mut Vec<Vec<usize>>,
    cnt: &mut [usize],
    path: &mut Vec<usize>,
    mx: i64,
    u: usize,
    to: usize,
) {
    if u == to {
        all.push([path.clone(), vec![u]].concat());
        return;
    }

    cnt[u] += 1;
    path.push(u);
    let mx = mx.max(w[u]);

    for &(v, _) in &g[u] {
        if cnt[v] != 0 && (cnt[v] >= g[v].len() || w[v] <= mx) {
            continue;
        }
        build(g, w, all, cnt, path, mx, v, to);
    }

    path.pop();
    cnt[u] -= 1;
}

fn solve10<R: BufRead, W: Write>(
    scan: &mut Scanner<R>,
    out: &mut W,
    n: usize,
    m: usize,
    money: i64,
) -> io::Result<()> {
    let w: Vec<_> = (0..n).map(|_| scan.token::<i64>()).collect();
    let mut g = vec![vec![]; n];
    let mut mat = vec![vec![i64::MAX; n]; n];
    for _ in 0..m {
        let (u, v, c) = (
            scan.token::<usize>() - 1,
            scan.token::<usize>() - 1,
            scan.token::<i64>(),
        );
        g[u].push((v, c));
        mat[u][v] = mat[u][v].min(c);
    }

    let mut paths = vec![];
    build(&g, &w, &mut paths, &mut vec![0; n], &mut vec![], 0, 0, n - 1);
    let path_ans = paths.iter().map(|p| {
        p.windows(2)
            .scan((money, 0), |(money, maxw), e| {
                let &[u, v] = e else { unreachable!() };
                let cst = mat[u][v];
                *maxw = (*maxw).max(w[u]);
                let add = if *money >= cst {
                    0
                } else {
                    (cst - *money + *maxw - 1) / *maxw
                };
                *money += add * (*maxw);
                *money -= cst;
                Some(add)
            })
            .sum::<i64>()
    }).collect::<Vec<_>>();

    writeln!(out, "{}", path_ans.iter().min().unwrap())
}

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());

    let (n, m, p, g) = (scan.token(), scan.token(), scan.token(), scan.token::<u8>());
    if g == 0 || g == 3 {
        return solve10(&mut scan, &mut w, n, m, p);
    }

    Ok(())
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
