use std::io::{self, prelude::*};

#[allow(clippy::too_many_arguments)]
fn build(
    g: &[Vec<(usize, i64)>],
    w: &[i64],
    ans: &mut Vec<(i64, i64)>,
    used: &mut [bool],
    u: usize,
    money: i64,
    max: i64,
    time: i64,
    to: usize,
) {
    if u == to {
        ans.push((time, money));
        return;
    }

    for &(v, s) in &g[u] {
        if used[v] {
            continue;
        }
        let add = (s - money + max - 1) / max;
        used[v] = true;
        build(g, w, ans, used, v, money - s + max * add, max.max(w[v]), time + add, to);
        used[v] = false;
    }
}

fn solve10<R: BufRead, W: Write>(
    scan: &mut Scanner<R>,
    out: &mut W,
    n: usize,
    m: usize,
    money: i64,
) -> io::Result<()> {
    let w: Vec<_> = (0..n).map(|_| scan.token::<i64>()).collect();
    let mut g = vec![vec![]; n];
    for _ in 0..m {
        let (u, v, c) = (
            scan.token::<usize>() - 1,
            scan.token::<usize>() - 1,
            scan.token::<i64>(),
        );
        g[u].push((v, c));
    }

    let mut answ = i64::MAX;
    for v in 0..n {
        let mut ans = vec![];
        let mut used = vec![false; n];
        used[0] = true;
        build(&g, &w, &mut ans, &mut used, 0, money, w[0], 0, v);

        for (time, money) in ans {
            let mut used = vec![false; n];
            let mut ans = vec![];
            used[0] = true;
            build(&g, &w, &mut ans, &mut used, v, money, w[v], time, n - 1);
            if let Some(cand) = ans.into_iter().min().map(|c| c.0) {
                answ = answ.min(cand);
            }
        }
    }

    writeln!(out, "{}", if answ == i64::MAX { -1 } else { answ })
}

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());

    let (n, m, p, g) = (scan.token(), scan.token(), scan.token(), scan.token::<u8>());
    if g == 0 || g == 3 {
        return solve10(&mut scan, &mut w, n, m, p);
    }

    Ok(())
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
