#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define int long long

const int INF = 1e18;

vector<vector<pair<int, int>>> g;
vector<int> d;

void dijkstra(int s) {
    d[s] = 0;
    set<pair<int, int>> q;
    q.insert({d[s], s});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [to, w] : g[v]) {
            if (d[to] > d[v] + w) {
                q.erase({d[to], to});
                d[to] = d[v] + w;
                q.insert({d[to], to});
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<int> w(n);
    for (auto& i : w) {
        cin >> i;
    }
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        g[v - 1].emplace_back(u - 1, s);
    }
    if (group == 1) {
        d.assign(n, INF);
        dijkstra(0);
        if (d[n - 1] == INF) {
            cout << -1 << '\n';
        } else {
            cout << max(0ll, d[n - 1] - p) << '\n';
        }
    } else {
        cout << 0 << '\n';
    }
}
