#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

#define int long long

const int INF = 1e18;

vector<int> salary;

vector<vector<pair<int, int>>> g;
vector<int> d;

void dijkstra(int s) {
    d[s] = 0;
    set<pair<int, int>> q;
    q.insert({d[s], s});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [to, w] : g[v]) {
            if (d[to] > d[v] + w) {
                q.erase({d[to], to});
                d[to] = d[v] + w;
                q.insert({d[to], to});
            }
        }
    }
}

signed main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    salary.resize(n);
    for (auto& i : salary) {
        cin >> i;
    }
    g.resize(n);
    vector<int> path;
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        g[v - 1].emplace_back(u - 1, s);
        if (group == 2) {
            path.push_back(s);
        }
    }
    if (group == 1) {
        d.assign(n, INF);
        dijkstra(0);
        if (d[n - 1] == INF) {
            cout << -1 << '\n';
        } else {
            cout << max(0ll, d[n - 1] - p) << '\n';
        }
    } else if (group == 2) {
        vector<int> cnt(n);
        cnt[0] = 0;
        int S = salary[0];
        int div = p;
        for (int i = 1; i < n; ++i) {
            cnt[i] = cnt[i - 1];
            if (div >= path[i - 1]) {
                div -= path[i - 1];
            } else {
                cnt[i] += (path[i - 1] - div + S - 1) / S;
                div = 0;
            }
            S = max(S, salary[i]);
        }
        cout << cnt[n - 1] << '\n';
    } else {
        cout << 0 << '\n';
    }
}
