#define _GLIBCXX_DEBUG

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cassert>
#include <functional>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>

using namespace std;

int main(){
    int n, m;
    uint64_t p;
    int g;
    cin >> n >> m >> p >> g;
    vector<uint64_t> W(n);
    for (int i = 0; i < n; i++){
        cin >> W[i];
    }
    vector<vector<pair<int, uint64_t>>> graph(n);
    for (int i = 0; i < m; i++){
        int v, u;
        uint64_t si;
        cin >> v >> u >> si;
        graph[v - 1].emplace_back(u - 1, si);
    }
    if (g == 1){
        vector<int64_t> dist(n, -1);
        set<pair<uint64_t, int>> djkstra = {{0, 0}};
        while (!djkstra.empty()){
            auto [nd, u] = *djkstra.begin();
            if (dist[u] == -1){
                dist[u] = nd;
            }
            for (auto [uu, cost] : graph[u]){
                djkstra.emplace(nd + cost, uu);
            }
        }
        if (dist[n - 1] == -1){
            printf("-1\n");
        } else if (dist[n - 1] <= p){
            printf("%lu\n", 0ul);
        } else {
            printf("%lu\n", dist[n - 1] - p);
        }
    }
    return 0;
}