#define _GLIBCXX_DEBUG

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cassert>
#include <functional>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>

using namespace std;

int main(){
    int n, m;
    uint64_t p;
    int g;
    cin >> n >> m >> p >> g;
    vector<uint64_t> W(n);
    for (int i = 0; i < n; i++){
        cin >> W[i];
    }
    vector<vector<pair<int, uint64_t>>> graph(n);
    for (int i = 0; i < m; i++){
        int v, u;
        uint64_t si;
        cin >> v >> u >> si;
        graph[v - 1].emplace_back(u - 1, si);
    }
    if (g == 1){
        vector<int64_t> dist(n, -1);
        set<pair<uint64_t, int>> djkstra = {{0, 0}};
        while (!djkstra.empty()){
            auto [nd, u] = *djkstra.begin();
            djkstra.erase(djkstra.begin());
            if (dist[u] == -1){
                dist[u] = nd;
                for (auto [uu, cost] : graph[u]){
                    djkstra.emplace(nd + cost, uu);
                }
            }
        }
        if (dist[n - 1] == -1){
            printf("-1\n");
        } else if (dist[n - 1] <= p){
            printf("%lu\n", 0ul);
        } else {
            printf("%lu\n", dist[n - 1] - p);
        }
    } else if (g == 3 || g == 0){
        vector<bool> used(n, false);
        used[0] = true;
        vector<pair<int, uint64_t>> path;
        uint64_t best_ans = 999999999999999;
        function<void(int)> dfs = [&](int v){
            if (v == n - 1){
                int d = path.size();
                uint64_t max_eff = W[path[0].first];
                uint64_t spectacli = 0;
                uint64_t dengi = p;
                for (int i = 0; i < d; i++){
                    max_eff = max(max_eff, W[path[i].first]);
                    uint64_t doroga = path[i].second;
                    if (doroga > dengi){
                        uint64_t N = doroga - dengi;
                        uint64_t K = N / max_eff + (N % max_eff ? 1 : 0);
                        dengi += K * max_eff;
                        spectacli += K;
                        assert(dengi >= doroga);
                    }
                    dengi -= doroga;
                }
                best_ans = min(best_ans, spectacli);
            } else {
                for (auto [u, pc] : graph[v]){
                    if (!used[u]){
                        used[u] = true;
                        path.emplace_back(v, pc);
                        dfs(u);
                        used[u] = false;
                        path.pop_back();
                    }
                }
            }
        };
        dfs(0);
        printf("%lu\n", best_ans);
    }
    return 0;
}