#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int INF = 1e9;
const int INFLL = 1e18;

#define int long long

vector<vector<pair<int, int> > > g;

vector<int> w;

struct state
{
    int d, cnt, last, v;
    state() {}
    state(int d, int cnt, int last, int v) : d(d), cnt(cnt), last(last), v(v) {}
    bool operator<(const state& o)
    {
        if (d != o.d)
            return d < o.d;
        if (last != o.last)
            return last < o.last;
        if (cnt != o.cnt)
            return cnt < o.cnt;
        return v < o.v;
    }
};

int dijkstra(int s, int t, int p, int n, int max_sum)
{
    vector<vector<int> > dist;
    dist.resize(n, vector<int>(max_sum, INF));
    set<array<int, 3> > st;
    dist[s][p] = 0;
    st.insert({0, p, s});
    while (!st.empty())
    {
        auto [d, bal, v] = *st.begin();
        st.erase(st.begin());
        if (bal + w[v] < max_sum &&
            dist[v][bal + w[v]] > dist[v][bal] + 1)
        {
            st.erase({dist[v][bal + w[v]], bal + w[v], v});
            dist[v][bal + w[v]] = dist[v][bal] + 1;
            st.insert({dist[v][bal + w[v]], bal + w[v], v});
        }
        for (auto& [u, w] : g[v])
        {
            if (w <= bal && dist[u][bal - w] > dist[v][bal])
            {
                st.erase({dist[u][bal - w], bal - w, u});
                dist[u][bal - w] = dist[v][bal];
                st.insert({dist[u][bal - w], bal - w, u});
            }
        }
    }
    int ans = *min_element(dist[t].begin(), dist[t].end());
//    for (int i = 0; i < n; i++)
//    {
//        cout << i + 1 << ": ";
//        for (int j = 0; j < dist[i].size(); j++)
//        {
//            cout << dist[i][j] << ' ';
//        }
//        cout << endl;
//    }
    return ans;
}

signed main()
{
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    long long sum = 0;
    g.resize(n);
    w.resize(n);
    int mxw = 0;
    for (int i = 0; i < n; i++)
    {
        cin >> w[i];
        mxw = max(mxw, w[i]);
    }
    for (int i = 0; i < m; i++)
    {
        int x, y, z;
        cin >> x >> y >> z;
        x--; y--;
        sum += z;
        g[x].push_back({y, z});
    }
    if (gr == 1 || mxw == 1)
    {
        vector<long long> dist(n, INFLL);
        set<pair<long long, int> > st;
        st.insert({0, 0});
        dist[0] = 0;
        while (!st.empty())
        {
            auto [d, v] = *st.begin();
            st.erase(st.begin());
            for (auto&[u, w] : g[v])
            {
                if (dist[u] > dist[v] + w)
                {
                    st.erase({dist[u], u});
                    dist[u] = dist[v] + w;
                    st.insert({dist[u], u});
                }
            }
        }
        if (dist[n - 1] == INFLL)
        {
            cout << -1;
            return 0;
        }
        long long ans = max(0ll, dist[n - 1] - p);
        cout << ans;
        return 0;
    }
    sum = 1000 * max(n, m);
    p = min((long long)p, sum);
    int ans = dijkstra(0,n  - 1, p, n, sum + 1);
    if (ans == INF)
    {
        cout << -1;
        return 0;
    }
    cout << ans;
//    int lt = 0, rt = sum;
//    while(rt - lt > 1)
//    {
//        int mid = (lt + rt) >> 1;
//    }
    return 0;
}
/*
4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

*/


/*
3 2 0 0
1 1 1
1 2 1
2 3 100
*/

/*
3 2 0 0
1 1 1
2 1 1
2 3 100
*/

/*
3 2 1 0
10 10 10
1 2 10
2 3 0
*/

/*
2 2 0 0
1 1
1 2 0
1 2 1
*/

/*
2 2 0 0
1 1
1 2 0
2 1 0
*/
