#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

#define int ll

const int mod = 1e9 + 7, k1 = 29, k2 = 31;

int add(int a, int b) {
    if (a + b >= mod)
        return a + b - mod;
    return a + b;
}

int mul(int a, int b) {
    return int(1LL * a * b % mod);
}

int sub(int a, int b) {
    if (a - b < 0)
        return a - b + mod;
    return a - b;
}

pair<int, int> operator+(pair<int, int> a, pair<int, int> b) {
    return {add(a.first, b.first), add(a.second, b.second)};
}

pair<int, int> operator*(pair<int, int> a, pair<int, int> b) {
    return {mul(a.first, b.first), mul(a.second, b.second)};
}

pair<int, int> operator-(pair<int, int> a, pair<int, int> b) {
    return {sub(a.first, b.first), sub(a.second, b.second)};
}

typedef pair<int, int> pii;

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n&1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

const int maxn = 5e6 + 100;
int deg1[maxn], deg2[maxn], inv_deg1[maxn], inv_deg2[maxn];

void precalc() {
    deg1[0] = deg2[0] = inv_deg1[0] = inv_deg2[0] = 1;
    int inv_k1 = binpow(k1, mod - 2);
    int inv_k2 = binpow(k2, mod - 2);
    for (int i = 1; i < maxn; ++i) {
        deg1[i] = mul(deg1[i - 1], k1);
        deg2[i] = mul(deg2[i - 1], k2);
        inv_deg1[i] = mul(inv_deg1[i - 1], inv_k1);
        inv_deg2[i] = mul(inv_deg2[i - 1], inv_k2);
    }
}

struct query {
    int l, r, ind;
};


const int INF = 1e18 + 7;

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;

    vector<vector<pair<int, int>>> g(n);
    vector<int> ws(n);
    for (auto &el : ws) cin >> el;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c, --a, --b;
        g[a].emplace_back(b, c);
    }


    if (G == 1) { // все веса единичка
        auto dijkstra = [&] () {
            vector<int> dist(n, INF);
            dist[0] = 0;
            set<pair<int, int>> q;
            q.insert({0, 0});

            while (!q.empty()) {
                int v = q.begin()->second;
                q.erase(q.begin());
                for (auto [to, w] : g[v]) {
                    if (dist[to] > dist[v] + w) {
                        q.erase({dist[to], to});
                        dist[to] = dist[v] + w;
                        q.insert({dist[to], to});
                    }
                }
            }

            return dist[n - 1];
        };

        int res = dijkstra();
        if (res < INF) {
            res = max(0LL, res - p);
            cout << res;
        } else {
            cout << -1;
        }
    } else if (G == 2) {
        vector<pii> dp(n, {INF, -INF});
        dp[0] = {0, p};
        vector<long long> sm(n);
        sm[0] = 0;

        for (int i = 1; i < n; ++i) {
            sm[i] = sm[i - 1] + g[i - 1][0].second;
        }

        auto best = [&] (pii a, pii b) {
            if (a.first < b.first)
                return a;
            if (a.first > b.first)
                return b;
            if (a.second >= b.second)
                return a;
            return b;
        };

        for (int i = 1; i < n; ++i) {
            for (int j = 0; j < i; ++j) {
                long long dist = sm[i] - sm[j];
                pair<int, int> f = dp[j];
                int need = dist - f.second;
                if (need <= 0) {
                    dp[i] = best(dp[i], pii{f.first, f.second - dist});
                } else {
                    int need_iterations = (need - 1) / ws[j] + 1;
                    int bal = f.second;
                    bal += need_iterations * ws[j];
                    int nw = bal - dist;
                    dp[i] = best(dp[i], pii{f.first + need_iterations, nw});
                }
            }
        }

        int ans = dp.back().first;
        if (ans < INF) {
            cout << ans;
        } else {
            assert(false);
            cout << -1;
        }
    } else if (G == 3 || G == 0) {
        vector<vector<int>> dist(n, vector<int>(n, INF));
        for (int i = 0; i < n; ++i) {
            for (auto [to, w] : g[i])
                dist[i][to] = w;
        }

        for (int i = 0; i < n; ++i) {
            dist[i][i] = 0;
        }

        for (int k = 0; k < n; ++k) {
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
                }
            }
        }

        auto best = [&] (pii a, pii b) {
            if (a.first < b.first)
                return a;
            if (a.first > b.first)
                return b;
            if (a.second >= b.second)
                return a;
            return b;
        };

        vector<vector<pii>> dp(1<<n, vector<pii>(n, {INF, -INF}));
        dp[1][0] = {0, p};

        for (int mask = 1; mask < (1<<n); ++mask) {
            for (int bit = 0; bit < n; ++bit) {
                if ((1<<bit)&mask) {
                    for (int nxt = 0; nxt < n; ++nxt) {
                        int nw_mask = mask|(1<<nxt);
                        int d = dist[bit][nxt];
                        if (d >= INF)
                            continue;
                        pair<int, int> f = dp[mask][bit];
                        int need = d - f.second;
                        if (need <= 0) {
                            dp[nw_mask][nxt] = best(dp[nw_mask][nxt], pii{dp[mask][bit].first, dp[mask][bit].second - d});
                        } else {
                            int need_iterations = (need - 1) / ws[bit] + 1;
                            int bal = dp[mask][bit].second;
                            bal += need_iterations * ws[bit];
                            bal -= d;
                            dp[nw_mask][nxt] = best(dp[nw_mask][nxt], pii{dp[mask][bit].first + need_iterations, bal});
                        }
                    }
                }
            }
        }

        int answer = INF;

        for (int mask = 0; mask < (1<<n); ++mask) {
            answer = min(answer, dp[mask][n - 1].first);
        }

        if (answer >= INF) {
            cout << -1;
        } else {
            cout << answer;
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    precalc();
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}