#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

v<ll> dij(v<v<pll>>& gr, ll a) {
	v<ll> dist(gr.size(), Max);
	std::set<pll> s;
	dist[a] = 0;
	for (int i = 0; i < gr.size(); ++i) {
		s.insert({ dist[i], i });
	}
	while (!s.empty()) {
		ll i = s.begin()->second;;
		s.erase(s.begin());
		for (auto j : gr[i]) {
			if (dist[j.first] > dist[i] + j.second) {
				s.erase({ dist[j.first], j.first });
				dist[j.first] = dist[i] + j.second;
				s.insert({ dist[j.first], j.first });
			}
		}
	}
	return dist;
}

ll count(v<v<ll>>& gr, v<ll>& now, v<ll>& w, ll p) {
	ll ans = 0;
	ll a = 0;
	ll sum = 0;
	for (int i = 0; i < now.size() - 1;) {
		while (a != now.size() - 1 && w[now[a]] <= w[now[i]]) {
			sum += gr[now[a]][now[a + 1]];
			++a;
		}
		if (p >= sum) {
			p -= sum;
		}
		else {
			ans += (sum - p + w[now[i]] - 1) / w[now[i]];
			p = w[now[i]] - (sum - p) % w[now[i]];
		}
		i = a;
		sum = 0;
	}
	return ans;
}

void solve() {
	ll n, m, p, g;
	std::cin >> n >> m >> p >> g;
	v<ll> w(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> w[i];
	}
	v<v<pll>> gr0(n);
	v<v<ll>> gr(n, v<ll>(n, Max));
	for (int i = 0; i < m; ++i) {
		ll a, b, c;
		std::cin >> a >> b >> c;
		--a, --b;
		gr0[a].push_back({ b, c });
		gr[a][b] = std::min(gr[a][b], c);
	}
	v<ll> dist = dij(gr0, 0);
	if (dist[n - 1] == Max) {
		std::cout << -1 << '\n';
		return;
	}
	if (g == 1) {
		if (p >= dist[n - 1]) {
			std::cout << 0 << '\n';
		}
		else {
			std::cout << (dist[n - 1] - p) << '\n';
		}
	}
	else if (g == 2) {
		v<ll> path;
		for (int i = 0; i < n; ++i) {
			path.push_back(i);
		}
		std::cout << count(gr, path, w, p) << '\n';
	}
	else if (g == 3) {

	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}