#pragma GCC optimize("O3", "Ofast")
#pragma GCC target("avx", "avx2")
#include <bits/stdc++.h>
using namespace std;
const int maxn = 800, infd = 1e9 + 10;
const long long infll = 1e18;
vector<pair<int, int>> g[maxn];
long long w[maxn];

void solve() {
    int n, m, stbal, group;
    cin >> n >> m >> stbal >> group;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        g[i].clear();
    }
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        --v, --u;
        g[v].emplace_back(u, s);
    }
    vector<vector<long long>> dist(n, vector<long long>(n, infll));
    vector<char> vis(n);
    priority_queue<pair<long long, int>, vector<pair<long long, int>>, greater<pair<long long, int>>> q;
    // apsp
    for (int start = 0; start < n; ++start) {
        vis.assign(n, false);
        dist[start][start] = 0;
        assert(q.empty());
        q.push(make_pair(0ll, start));
        while (!q.empty()) {
            int v = q.top().second;
            q.pop();
            if (vis[v]) {
                continue;
            }
            vis[v] = true;
            for (const auto& [u, s] : g[v]) {
                if (dist[start][u] > dist[start][v] + s) {
                    dist[start][u] = dist[start][v] + s;
                    q.push(make_pair(dist[start][u], u));
                }
            }
        }
    }
    vector<int> p(n);
    iota(p.begin(), p.end(), 0);
    sort(p.begin() + 1, p.end() - 1, [&](const int& A, const int& B) {
        return w[A] < w[B];
    });
    long long ans = infll;
    vector<pair<long long, long long>> dp(n);
    dp[0] = {0, stbal};
    int v, u;
    long long need;
    for (int i = 1; i < n; ++i) {
        dp[i] = {infll, -1};
        v = p[i];
        for (int j = 0; j < i; ++j) {
            u = p[j];
            if (dist[u][v] != infll) {
                // dp[j].second + need * w[u] >= dist[u][v]
                long long need = max(0ll, dist[u][v] - dp[j].second + w[u] - 1) / w[u];
                pair<long long, long long> way = {dp[j].first + need, dp[j].second - dist[u][v] + need * w[u]};
                if (way.first < dp[i].first || (way.first == dp[i].first && way.second > dp[i].second)) {
                    dp[i] = way;
                }
            }
        }
    }
    if (dp[n - 1].first != infll) {
        ans = min(ans, dp[n - 1].first);
    }
    if (ans == infll) {
        ans = -1;
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
