#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);



const ll MAXN = 800 + 2;
ll n, m, p, g;
ll w[MAXN];
vector<pair<ll, ll>> graph[MAXN];

ll get_deikstra() {
    vector<ll> dist(n, INF);
    dist[0] = 0;

    set<pair<ll, ll>> st;

    for (ll i = 0; i < n; ++i) st.insert({dist[i], i});

    while (st.size()) {
        ll v = st.begin()->second;
        st.erase(st.begin());

        for (auto i : graph[v]) {
            if (dist[i.first] > dist[v] + i.second) {
                st.erase({dist[i.first], i.first});
                dist[i.first] = dist[v] + i.second;
                st.insert({dist[i.first], i.first});
            }
        }
    }

    if (dist[n - 1] == INF) return -1;
    return max(0LL, dist[n - 1] - p);
}

ll get_bambuk() {
    ll ans = 0;
    ll max_prib = 0;

    ll now = p;

    for (ll i = 0; i < n - 1; ++i) {
        ll cost = graph[i][0].second;
        max_prib = max(max_prib, w[i]);

        if (now >= cost) {
            now -= cost;
        }
        else {
            ll need = cost - now;
            ll cnt = (need + max_prib - 1) / max_prib;

            now += cnt * max_prib;
            now -= cost;
            ans += cnt;
        }

        ans++;
    }

    return ans;
}

void solve() {
    cin >> n >> m >> p >> g;

    for (ll i = 0; i < n; ++i) cin >> w[i];

    for (ll i = 0; i < m; ++i) {
        ll a, b, s;
        cin >> a >> b >> s;

        --a, --b;

        graph[a].push_back({b, s});
    }

    if (g == 1) {
        cout << get_deikstra() << '\n';
        return;
    }
    if (g == 2) {
        cout << get_bambuk() << '\n';
        return;
    }
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}