#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
mt19937 rnd(time(0));




const ll MAXN = 800 + 2;
ll n, m, p, g;
ll w[MAXN];
vector<pair<ll, ll>> graph[MAXN];

ll get_deikstra() {
    vector<ll> dist(n, INF);
    dist[0] = 0;

    set<pair<ll, ll>> st;

    for (ll i = 0; i < n; ++i) st.insert({dist[i], i});

    while (st.size()) {
        ll v = st.begin()->second;
        st.erase(st.begin());

        for (auto i : graph[v]) {
            if (dist[i.first] > dist[v] + i.second) {
                st.erase({dist[i.first], i.first});
                dist[i.first] = dist[v] + i.second;
                st.insert({dist[i.first], i.first});
            }
        }
    }

    if (dist[n - 1] == INF) return -1;
    return max(0LL, dist[n - 1] - p);
}

ll get_bambuk() {
    ll ans = 0;
    ll max_prib = 0;

    ll now = p;

    for (ll i = 0; i < n - 1; ++i) {
        ll cost = graph[i][0].second;
        max_prib = max(max_prib, w[i]);

        if (now >= cost) {
            now -= cost;
        }
        else {
            ll need = cost - now;
            ll cnt = (need + max_prib - 1) / max_prib;

            now += cnt * max_prib;
            now -= cost;
            ans += cnt;
        }
    }

    return ans;
}

ll ans = INF;
vector<vector<ll>> used;

clock_t start;

void go(ll now_v, ll max_prib, ll money, ll now_ans) {
    if (ld(clock() - start) / CLOCKS_PER_SEC >= 0.98) {
        if (ans == INF) ans = -1;
        cout << ans;
        exit(0);
    }
    if (now_v == n - 1) {
        ans = min(ans, now_ans);
        return;
    }
    max_prib = max(max_prib, w[now_v]);

    for (auto i : graph[now_v]) {
        if (used[now_v][i.first]) continue;

        if (money >= i.second) {
            used[now_v][i.first] = 1;
            go(i.first, max_prib, money - i.second, now_ans);
        }
        else {
            used[now_v][i.first] = 1;
            ll need = i.second - money;
            ll cnt = (need + max_prib - 1) / max_prib;

            go(i.first, max_prib, money + cnt * max_prib - i.second, now_ans + cnt);
        }

        used[now_v][i.first] = 0;
    }
}

ll get_perebor() {
    used.resize(n, vector<ll> (n, 0));

    go(0, 0, p, 0);

    if (ans == INF) ans = -1;
    return ans;
}

void solve() {
    start = clock();
    cin >> n >> m >> p >> g;

    for (ll i = 0; i < n; ++i) cin >> w[i];

    map<pair<ll, ll>, ll> sd;

    for (ll i = 0; i < m; ++i) {
        ll a, b, s;
        cin >> a >> b >> s;

        --a, --b;

        if (sd.find({a, b}) == sd.end()) {
            sd[{a, b}] = s;
            continue;
        }

        sd[{a, b}] = min(sd[{a, b}], s);
    }

    for (auto i : sd) {
        graph[i.first.first].push_back({i.first.second, i.second});
    }

    for (ll i = 0; i < n; ++i) {
        shuffle(all(graph[i]), rnd);
    }

    if (g == 1) {
        cout << get_deikstra() << '\n';
        return;
    }
    if (g == 2) {
        cout << get_bambuk() << '\n';
        return;
    }
    cout << get_perebor() << '\n';
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}

/*

5 4 3 2
1 2 1 10 6
1 2 5

2 3 3
3 4 4
4 5 20

*/