#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

class SegmentTree {
private:
    vector<int> d;
    int n;

    void upd(int i) {
        d[i] = (d[2 * i] + d[2 * i + 1]);
    }

public:
    SegmentTree(const vector<int> &v) {
        n = 1;
        while (n < sz(v)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(v); ++i) {
            d[i + n] = v[i];
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res += d[l++];
            }
            if (r & 1) {
                res += d[--r];
            }
        }
        return res;
    }

    void upd(int i, int x) {
        d[i += n] = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};

using pii = pair<int, int>;

template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
}

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
};

const int MAXN = 800;
long long dp[MAXN][MAXN];

const long long INF = 1e14;

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector <int> v(n);
    for (auto&i : v) {
        cin >> i;
    }
    vector <vector <pii> > g(n);
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a, --b;
        g[a].emplace_back(b, w);
    }
    if (group == 1) {
        vector<long long> res(n, INF);
        set<pair<int, long long> > st;
        res[0] = 0;
        st.insert({0, 0});
        while (!st.empty()) {
            auto cur = st.begin()->second;
            st.erase(st.begin());
            for (auto[to, w]: g[cur]) {
                if (res[to] > res[cur] + w) {
                    st.erase({res[to], to});
                    res[to] = res[cur] + w;
                    st.insert({res[to], to});
                }
            }
        }
        if (res.back() >= INF) {
            cout << -1;
            return 0;
        }
        cout << max(0ll, res.back() - p);
    } else if (group == 2) {
        int mx = v[0];
        long long res = 0;
        int cur = 0;
        while (cur != n - 1) {
            int w = g[cur][0].ss;
            long long diff = w - cur;
            res += max(0ll, (diff + mx - 1) / mx);
            cur = cur + (diff + mx - 1) / mx * mx;
            cur -= w;
            mxr(mx, v[cur]);
        }
        cout << res << "\n";
    }
}
