#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

cosnt ll INF = 1e18 + 42;

struct Node {
    int cnt = 0, d = 0, maxw = 0, dist = INF;

    Node() = default;
    Node(int cnt, int d, int maxw, int dist) : cnt(cnt), d(d), maxw(maxw), dist(dist) {}
};

bool operator<(const Node& a, const Node& b) {
    return a.cnt + (a.dist + a.maxw - 1) / a.maxw < b.cnt + (b.dist + b.maxw - 1) / b.maxw;
}

int n, m, p, gr;
vector<int> a;
vector<vector<pair<int, ll>>> g;

void solve() {
    cin >> n >> m >> p >> gr;
    a.assing(n, 0);
    for (auto& i : a)
        cin >> i;
    g.assing(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }

    vector<vector<pair<int, ll>>> gr(n);
    for (int i = 0; i < n; ++i)
        for (auto& [j, w] : g[i])
            gr[j].push_back({i, w});
    vector<int> ndist(n, INF);
    ndist[n - 1] = 0;
    set<pair<int, int>> nq;
    nq.insert({0, n - 1});
    while (!nq.empty()) {
        auto [x, v] = *nq.begin();
        nq.erase(nq.begin());
        for (auto& [u, w] : gr[v])
            if (ndist[u] > ndist[v] + w) {
                nq.erase({ndist[u], u});
                ndist[u] = ndist[v] + w;
                nq.insert({ndist[u], u});
            }
    }

    vector<Node> dist(n, Node(INF, INF, -INF, INF));
    for (int i = 0; i < n; ++i) {
        dist[i].maxw = a[i];
        dist[i].dist = ndist[i];
    }
    dist[0] = Node(0, p, a[0], ndist[0]);
    set<pair<Node, int>> q;
    q.insert({dist[0], 0});
    while (!q.empty()) {
        auto [x, v] = *q.begin();
        q.erase(q.begin());
        for (auto& [u, w] : g[v]) {
            Node tmp = dist[v];
            if (tmp.d >= w)
                tmp.d -= w;
            else {
                int wait = (w - tmp.d + tmp.maxw - 1) / tmp.maxw;
                tmp.d += wait * tmp.maxw - w;
                tmp.cnt += wait;
            }
            tmp.maxw = max(tmp.maxw, dist[u].maxw);
            if (tmp < dist[u]) {
                q.erase({dist[u], u});
                dist[u] = tmp;
                q.insert({dist[u], u});
            }
        }
    }
    /*
    for (auto [cnt, d, maxw] : dist)
        cout << cnt << " " << d << " " << maxw << endl;
    */
    cout << (dist[n - 1].cnt == INF ? -1 : dist[n - 1].cnt) << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}