#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u: v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u: v) {
        os << u << ' ';
    }
    return os;
}


void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<int> win(n);
    cin >> win;
    for (int i = 0; i < n; ++i) {
        if (win[i] != 1) {
            exit(1);
        }
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u -= 1;
        v -= 1;
        g[u].emplace_back(v, w);
    }

    set<pair<int, int>> q;
    vector<int> d(n, INT64_MAX);
    q.insert({0, 0});
    d[0] = 0;

    while (!q.empty()) {
        auto [c, v] = *q.begin();
        q.erase(q.begin());
        for (auto [u, w]: g[v]) {
            if (d[v] + w < d[u]) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }

    if (d.back() == INT64_MAX) {
        cout << -1 << '\n';
    } else {
        cout << max(0ll, d.back() - p0 << '\n';
    }
}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day2/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}