#include <bits/stdc++.h>

using namespace std;

constexpr long long inf = 1e18 + 7;

const int maxn = 805;

long long cost[maxn][maxn];

const int maxn_part = 105;

long long dp[maxn_part][maxn_part * maxn_part];

void solve() {
    long long n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            cost[i][j] = inf;
        }
    }
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        cost[i][i] = 0;
    }
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        cost[a][b] = min(cost[a][b], (long long)s);
    }
    for (int mid = 0; mid < n; ++mid) {
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                cost[a][b] = min(cost[a][b], cost[a][mid] + cost[mid][b]);
            }
        }
    }
    if (cost[0][n - 1] == inf) {
        cout << -1 << '\n';
        return;
    }
    if (p >= cost[0][n - 1]) {
        cout << 0 << '\n';
        return;
    }
    if (g == 1) {
        cout << max(0LL, cost[0][n - 1] - p) << '\n';
    } else if (g == 2) {
        vector<long long> pr_sum(n);
        for (int i = 1; i < n; ++i) {
            pr_sum[i] = pr_sum[i - 1] + cost[i - 1][i];
        }
        long long ans = 0;
        for (int i = 0; i + 1 < n; ++i) {
            int nxt = n - 1;
            for (int j = i + 1; j < n; ++j) {
                if (w[j] > w[i]) {
                    nxt = j;
                    break;
                }
            }
            long long len = pr_sum[nxt] - pr_sum[i];
            if (p < len) {
                long long val = (len - p - 1) / w[i] + 1;
                ans += val;
                p += val * 1LL * w[i];
            }
            p -= cost[i][i + 1];
        }
        cout << ans << '\n';
    } else if (g != 0 && g == 3) {
        vector<pair<int, int>> ord;
        for (int i = 1; i + 1 < n; ++i) {
            ord.emplace_back(w[i], i);
        }
        sort(ord.begin(), ord.end());
        long long ans = inf;
        for (int mask = 0; mask < (1 << (n - 2)); ++mask) {
            vector<int> nw;
            for (int i = 0; i < (int)ord.size(); ++i) {
                if (mask & (1 << i)) {
                    nw.push_back(ord[i].second);
                }
            }
            bool check = true;
            if (!nw.empty()) {
                if (cost[0][nw[0]] == inf || cost[nw.back()][n - 1] == inf) {
                    check = false;
                }
            }
            for (int i = 0; i + 1 < (int)nw.size(); ++i) {
                if (cost[nw[i]][nw[i + 1]] == inf) {
                    check = false;
                }
            }
            if (!check) {
                continue;
            }
            long long p_old = p;
            int v = 0;
            long long ans_nw = 0;
            int pos = 0;
            while (v != n - 1) {
                if (pos < (int)nw.size()) {
                    if (p < cost[v][nw[pos]]) {
                        long long val = (cost[v][nw[pos]] - p - 1) / w[v] + 1;
                        ans_nw += val;
                        p += val * 1LL * w[v];
                    }
                    p -= cost[v][nw[pos]];
                    v = nw[pos];
                    pos++;
                } else {
                    if (p < cost[v][n - 1]) {
                        long long val = (cost[v][n - 1] - p - 1) / w[v] + 1;
                        ans_nw += val;
                        p += val * 1LL * w[v];
                    }
                    p -= cost[v][n - 1];
                    v = n - 1;
                }
            }
            ans = min(ans, ans_nw);
            p = p_old;
        }
        cout << ans << '\n';
    } else if (g == 0 || g == 4) {
        vector<pair<int, int>> ord;
        for (int i = 1; i + 1 < n; ++i) {
            ord.emplace_back(w[i], i);
        }
        sort(ord.begin(), ord.end());
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < maxn_part * maxn_part; ++j) {
                dp[i][j] = inf;
            }
        }
        dp[0][p] = 0;
        for (int vl = 0; vl < maxn_part * maxn_part; ++vl) {
            dp[0][min(vl + w[0], maxn_part * maxn_part - 1)] = min(dp[0][min(vl + w[0], maxn_part * maxn_part - 1)], dp[0][vl] + 1);
            for (int j = 1; j < n; ++j) {
                if (vl >= cost[0][j]) {
                    dp[j][vl - cost[0][j]] = min(dp[j][vl - cost[0][j]], dp[0][vl]);
                }
            }
        }
        for (auto [p, v] : ord) {
            for (int vl = 0; vl < maxn_part * maxn_part; ++vl) {
                dp[v][min(vl + w[v], maxn_part * maxn_part - 1)] = min(dp[v][min(vl + w[v], maxn_part * maxn_part - 1)], dp[v][vl] + 1);
                for (int j = 1; j < n; ++j) {
                    if (vl >= cost[v][j]) {
                        dp[j][vl - cost[v][j]] = min(dp[j][vl - cost[v][j]], dp[v][vl]);
                    }
                }
            }
        }
        long long ans = inf;
        for (int i = 0; i < maxn_part * maxn_part; ++i) {
            ans = min(ans, dp[n - 1][i]);
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
