﻿#include <algorithm>
#include <cassert>
#include <iostream>
#include <map>
#include <set>
#include <vector>

using namespace std;

#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define int long long

const int maxn = 805;
const int INF = 1e18;

int w[maxn], dist[maxn];

vector<pair<int, int>> g[maxn];

signed main() {
	fastio;
	int n, m, p, gr;
	cin >> n >> m >> p >> gr;
	for (int i = 1; i <= n; ++i)
		cin >> w[i];
	for (int i = 0; i < m; ++i) {
		int a, b, v;
		cin >> a >> b >> v;
		g[a].push_back({ b, v });
	}
	if (gr == 1) {
		for (int i = 0; i < maxn; ++i)
			dist[i] = INF;
		set<pair<int, int>> q;
		dist[1] = 0;
		q.insert({ 0, 1 });
		while (!q.empty()) {
			auto v = q.begin()->second;
			q.erase(q.begin());
			for (auto u : g[v]) {
				if (dist[v] + u.second < dist[u.first]) {
					q.erase({ dist[u.first], u.first });
					dist[u.first] = dist[v] + u.second;
					q.insert({ dist[u.first], u.first });
				}
			}
		}
		if (dist[n] == INF)
			cout << -1;
		else
			cout << max(0LL, dist[n] - p);
	}
	if (gr == 2) {
		int mx = 0, ans = 0;
		for (int i = 1; i < n; ++i) {
			mx = max(mx, w[i]);
			if (p < g[i][0].second) {
				ans += (g[i][0].second - p + mx - 1) / mx;
				p = (g[i][0].second - p + mx - 1) / mx * mx - (g[i][0].second - p);
			}
			else
				p -= g[i][0].second;
		}
		cout << ans;
	}
}