#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e15 + 7;

int n, m;
vector<vector<pair<int, int>>> g;

int dijkstra(int end_v) {
    vector<int> d(n, INF);
    set<pair<int, int>> q;
    d[0] = 0;
    q.insert({0, 0});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            if (d[v] + w < d[u]) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }
    return d[end_v];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int p, G;
    cin >> n >> m >> p >> G;
    g.resize(n);
    vector<int> wd(n);
    for (int &i : wd)
        cin >> i;
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a - 1].push_back({b - 1, s});
    }
    int res = dijkstra(n - 1);
    if (res == INF) {
        cout << -1 << "\n";
        return 0;
    }
    cout << res - p << "\n";
}