#include <bits/stdc++.h>

#define int long long

using namespace std;

const int INF = 1e15 + 7;

int n, m;
vector<vector<pair<int, int>>> g;

int dijkstra(int end_v) {
    vector<int> d(n, INF);
    set<pair<int, int>> q;
    d[0] = 0;
    q.insert({0, 0});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, w] : g[v]) {
            if (d[v] + w < d[u]) {
                q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }
    return d[end_v];
}

inline void solve2(int p) {
    int max_work = 0, res = 0;
    vector<int> wd(n);
    for (int &i : wd)
        cin >> i;
    vector<int> w(n);
    for (int i = 1; i < n; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        w[i] = s;
    }
    max_work = wd[0];
    for (int i = 1; i < n; i++) {
        int pl = (w[i] - p + max_work - 1) / max_work;
        res += pl;
        p += pl * max_work;
        p -= w[i];
        max_work = max(max_work, wd[i]);
    }
    cout << res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int p, G;
    cin >> n >> m >> p >> G;
    if (G == 2) {
        solve2(p);
        return 0;
    }
    g.resize(n);
    vector<int> wd(n);
    for (int &i : wd)
        cin >> i;
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a - 1].push_back({b - 1, s});
    }
    int res = dijkstra(n - 1);
    if (res == INF) {
        cout << -1 << "\n";
        return 0;
    }
    cout << max((int)0, res - p) << "\n";
}