#include "bits/stdc++.h"
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

constexpr ll INF64 = 0x3f3f3f3f3f3f3f3f;

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<ll> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    if (g == 2) {
        ll ans = 0;
        ll maxwi = 0;
        for (int i = 0; i < n - 1; ++i) {
            maxwi = max(maxwi, w[i]);
            ll cost;
            cin >> cost >> cost >> cost;
            if (cost <= p) {
                p -= cost;
                continue;
            }
            ll need = cost - p;
            ll ww = (need + maxwi - 1) / maxwi;
            ans += ww;
            p = (p - cost + ww * maxwi);
        }
        cout << ans << '\n';
    } else {
        vector<ll> dist(n, INF64);
        dist[0] = 0;
        vector<vector<pair<int, int>>> graph(n);
        for (int i = 0; i < m; ++i) {
            int u, v, cw;
            cin >> u >> v >> cw;
            graph[u - 1].emplace_back(v - 1, cw);
        }
        priority_queue<pair<int, int>> pq;
        pq.emplace(0, 0);
        while (!pq.empty()) {
            auto [md, v] = pq.top();
            pq.pop();
            md = -md;
            for (const auto &[u, c] : graph[v]) {
                if (dist[u] > dist[v] + c) {
                    dist[u] = dist[v] + c;
                    pq.emplace(-dist[u], u);
                }
            }
        }
        if (dist[n - 1] == INF64) {
            cout << "-1\n";
        } else {
            cout << dist[n - 1] << '\n';
        }
    }
    return 0;
}