#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;


//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e18+1;

void solve();



int n, m, p, g;
vll a;
vvii gr;

void solve_dijsktra() {
    vi d(n, INF);
    d[0] = 0;
    vi used(n);
    for (int it = 0; it < n; it++) {
        int u = -1;
        for (int i = 0; i < n; i++) {
            if (!used[i] && (u == -1 || d[i] < d[u])) u = i;
        }
        if (d[u] == INF) break;
        used[u] = 1;
        for (auto tmp : gr[u]) {
            int v = tmp.first, w = tmp.second;
            d[v] = min(d[u] + w, d[v]);
        }
    }
    if (d[n - 1] == INF) cout << -1;
    else cout << d[n - 1];
}

bool comp(ii a, ii b) {
    if (a.first != b.first) return a < b;
    return a > b;
}

void solve_stupid() {
    vvi matr(n, vi(n, INF));
    for (int u = 0; u < n; u++) {
        matr[u][u] = 0;
        for (auto tmp : gr[u]) {
            int v = tmp.first, w = tmp.second;
            matr[u][v] = min(w, matr[u][v]);
        }
    }
    print2d(matr);

    for (int k = 0; k < n; k++) {
        for (int u = 0; u < n; u++) {
            for (int v = 0; v < n; v++) {
                matr[u][v] = min(matr[u][v], matr[u][k] + matr[k][v]);
            }
        }
    }

    print2d(matr);


    vii dp(n, make_pair(INF, 0));
    dp[0] = {0, p};
    for (int it = 0; it < 2 * n; it++) {
        for (int u = 0; u < n; u++) {
            int k = dp[u].first;
            if (k == INF) continue;
            int money = dp[u].second;
            debnl(u);
            deb(k); debnl(money);
            for (int v = 0; v < n; v++) {
                int w = matr[u][v];
                if (w == INF) continue;
                int req = max(0LL,( w - money + a[u] - 1) / a[u]);
                int x = k + req;
                int y = money + (req * a[u]) - w;
                deb(v); deb(x); debnl(y);
                if (comp(make_pair(x, y), dp[v])) {
                    dp[v] = { x, y };
                }
            }
        }
        printpair(dp);
    }
    if (dp[n - 1].first == INF) cout << -1;
    else cout << dp[n - 1].first;
}

void solve_array(){
    vi ss(n - 1);
    for (int i = 0; i < n - 1; i++){
        ss[i] = gr[i][0].second;
    }

    vi st = {n - 1};
    a[n - 1] = INF;
    vi cbfr(n);
    for (int i = 0; i < n; i++){
        while ( a[st.back()] < a[i]){
            cbfr[st.back()] = i;
            st.pop_back();
        }
        st.push_back(i);
    }

    int last = 0;
    int mx = 0;
    int ans = 0;
    vi ps(n, 0);
    ps[0] = 0;
    for (int i = 0; i < n - 1; i++) {
        ps[i + 1] = ps[i] + ss[i];
    }
    for (int i = 0; i < n; i++){
        ll req = max((ps[cbfr[i]] - ps[last]) - p, 0LL);
        ll k = (req + a[i] - 1) / a[i];
        ans += k;
        p += k * a[i];
        p -= ps[cbfr[i]] - ps[last];
        last = cbfr[i];
        
    }
    cout << ans;
}

signed main() {
    cin >> n >> m >> p >> g;
    gr.resize(n);
    a.resize(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w, u--, v--;
        gr[u].push_back({v, w});
    }

    if (g == 1) solve_dijsktra();
    else if (g == 2) solve_array();
    else solve_stupid();
    
}





















