#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;


//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e18 + 1;

void solve();



int n, m, p, g;
vll a;
vvii gr;

vi solve_dijsktra(int s) {
	vi d(n, INF);
	d[s] = 0;
	vi used(n);
	priority_queue<ii> pq;
	pq.push({ 0, s });
	while (!pq.empty()) {
		ii buf = pq.top();
		int u = buf.second, du = -buf.first;
		pq.pop();
		if (d[u] < du) continue;
		if (d[u] == INF) break;

		for (auto tmp : gr[u]) {
			int v = tmp.first, w = tmp.second;
			if (d[u] + w < d[v]) {
				d[v] = min(d[u] + w, d[v]);
				pq.push({ -d[v], v });
			}

		}
	}
	return d;
}

bool comp(ii a, ii b) {
	if (a.first != b.first) return a < b;
	return a > b;
}

struct Vertex {
	int q, c, u;

	bool operator<(const Vertex& oth) const {
		if (q != oth.q) return q < oth.q;
		return c > oth.c;
	}
};

void solve_stupid() {
	vvi matr(n, vi(n, INF));
	for (int u = 0; u < n; u++) {
		matr[u] = solve_dijsktra(u);
	}
	print2d(matr);

	print2d(matr);


	vii dp(n, make_pair(INF, 0));
	dp[0] = { 0, p };
	priority_queue<Vertex> pq;
	pq.push({ 0, p, 0 });
	vi used(n);
	while (!pq.empty()) {
		int u = pq.top().u;
		int k = dp[u].first;
		if (used[u]) continue;
		if (k == INF) break;
		int money = dp[u].second;
		used[u] = 1;



		debnl(u);
		deb(k); debnl(money);
		for (int v = 0; v < n; v++) {
			int w = matr[u][v];
			if (w == INF) continue;
			int req = max(0LL, (w - money + a[u] - 1) / a[u]);
			int x = k + req;
			int y = money + (req * a[u]) - w;
			deb(v); deb(x); debnl(y);
			if (comp(make_pair(x, y), dp[v])) {
				dp[v] = { x, y };
				pq.push({ x, y, v });
			}
		}


		printpair(dp);
	}
	if (dp[n - 1].first == INF) cout << -1;
	else cout << dp[n - 1].first;
}

void solve_array() {
	vi ss(n - 1);
	for (int i = 0; i < n - 1; i++) {
		ss[i] = gr[i][0].second;
	}

	vi st = { n - 1 };
	a[n - 1] = INF;
	vi cbfr(n);
	for (int i = 0; i < n; i++) {
		while (a[st.back()] < a[i]) {
			cbfr[st.back()] = i;
			st.pop_back();
		}
		st.push_back(i);
	}

	int last = 0;
	int mx = 0;
	int ans = 0;
	vi ps(n, 0);
	ps[0] = 0;
	for (int i = 0; i < n - 1; i++) {
		ps[i + 1] = ps[i] + ss[i];
	}
	for (int i = 0; i < n; i++) {
		ll req = max((ps[cbfr[i]] - ps[last]) - p, 0LL);
		ll k = (req + a[i] - 1) / a[i];
		ans += k;
		p += k * a[i];
		p -= ps[cbfr[i]] - ps[last];
		last = cbfr[i];

	}
	cout << ans;
}

signed main() {
	cin >> n >> m >> p >> g;
	gr.resize(n);
	a.resize(n);
	for (int i = 0; i < n; i++) cin >> a[i];
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w, u--, v--;
		gr[u].push_back({ v, w });
	}

	solve_stupid();

}





















