#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
//#pragma GCC optimization("Ofast")
//#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

struct S{
    ll v, mx;
    pair<ll, ll> dist;
    bool operator<(const S& a) const{
        if (dist != a.dist) return dist < a.dist;
        if (v != a.v) return v < a.v;
        return mx < a.mx;
    }
};

int main() {
    fastio();
    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<ll> w(n);
    for (ll i = 0;i<n;i++) cin >> w[i];
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0;i<m;i++){
        ll u, v, s;
        cin >> u >> v >> s;
        g[u-1].push_back({v-1, s});
    }
    vector<vector<pair<ll, ll>>> d(n, vector<pair<ll, ll>>(n, {INF, INF}));
    d[0][0] = {0, p};
    set<S> st = {{0, 0, d[0][0]}};
    while(st.size()>0){
        ll v = st.begin()->v, mx = st.begin()->mx;
        st.erase(st.begin());
        for(auto& p : g[v]){
            ll nv = p.first, cost = p.second;
            ll nmx = mx;
            if (w[nv] > w[nmx]) nmx = nv;
            ll np = d[v][mx].first + max(0LL, (cost - d[v][mx].second + w[mx] - 1) / w[mx]);
            ll nc = d[v][mx].second + (np - d[v][mx].first) * w[mx] - cost;
            pair<ll, ll> nd = {np, nc};
            if (nd < d[nv][nmx]){
                st.erase({nv, nmx, d[nv][nmx]});
                d[nv][nmx] = nd;
                st.insert({nv, nmx, d[nv][nmx]});
            }
        }
    }
    pair<ll, ll> ans = {INF, INF};
    for (ll i = 0;i<n;i++){
        ans = min(ans, d[n-1][i]);
    }
    if (ans.first < INF) cout << ans.first << " ";
    else cout << "-1\n";
    return 0;
}