#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
#pragma GCC optimization("Ofast")
#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

struct S{
    ll v, mx;
    ll p, c;
    bool operator<(const S& a) const{
        if (p != a.p) return p < a.p;
        if (c != a.c) return c > a.c;
        if (v != a.v) return v < a.v;
        return mx < a.mx;
    }
};

int main() {
    fastio();
    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<ll> w(n);
    for (ll i = 0;i<n;i++) cin >> w[i];
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0;i<m;i++){
        ll u, v, s;
        cin >> u >> v >> s;
        g[u-1].push_back({v-1, s});
    }
    vector<vector<S>> d(n, vector<S>(n));
    for (ll i = 0;i<n;i++){
        for (ll mx = 0;mx<n;mx++){
            d[i][mx] = {i, mx, INF, 0};
        }
    }
    d[0][0] = {0, 0, 0, p};
    set<S> st = {d[0][0]};
    while(st.size()>0){
        ll v = st.begin()->v, mx = st.begin()->mx;
        st.erase(st.begin());
        for(auto& p : g[v]){
            ll nv = p.first, cost = p.second;
            ll nmx = mx;
            if (w[nv] > w[nmx]) nmx = nv;
            S ns = {nv, nmx, 0, 0};
            ns.p = d[v][mx].p + max(0LL, (cost - d[v][mx].c + w[mx] - 1) / w[mx]);
            ns.c = d[v][mx].c + (ns.p - d[v][mx].p) * w[mx] - cost;
            if (ns < d[nv][nmx]){
                st.erase(d[nv][nmx]);
                d[nv][nmx] = ns;
                st.insert(d[nv][nmx]);
            }
        }
    }
    S ans = {n-1, 0, INF, INF};
    for (ll i = 0;i<n;i++){
        ans = min(ans, d[n-1][i]);
    }
    if (ans.p < INF) cout << ans.p << " ";
    else cout << "-1\n";
    return 0;
}