#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
using namespace std;
typedef long long ll;

const ll INF = 1e18;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m; ll p;
    cin >> n >> m >> p;
    int gr; cin >> gr;
    vector<ll> w(n);
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    vector<vector<pair<int, ll>>> g(n);
    for (int _ = 0; _ < m; ++_) {
        int a, b; ll s;
        cin >> a >> b >> s;
        a--; b--;
        g[a].push_back({b, s});
    }
    vector<bool> visit(n, false);
    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> queue;
    queue.insert({0, 0});
    while (!queue.empty()) {
        int u = queue.begin()->second;
        queue.erase(queue.begin());
        visit[u] = true;
        for (auto el: g[u]) {
            int v = el.first; ll s = el.second;
            if (!visit[v] && dist[v] > dist[u] + s) {
                queue.erase({dist[v], v});
                dist[v] = dist[u] + s;
                queue.insert({dist[v], v});
            }
        }
    }
    if (dist[n - 1] == INF) cout << -1;
    else cout << max((ll)0, dist[n - 1] - p);

    return 0;
}