#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define ld long double
#define ull unsigned long long
#define x first
#define y second

const ll INF = 1e18, MOD1 = 1e9 + 7, MOD = 228228227, N = 2e5 + 2, MAXN = 1e5 + 2;
const ld EPS = 0.00000001;

random_device rd;
mt19937 rnd(rd());

struct HASH{
    int m, n, b;
    string s;
    vector<int> p, h;
    HASH(string s1, int B, int M) {
        b = B;
        m = M;
        s = s1;
        n = s.size();
        h.resize(n + 1);
        p.resize(n + 1);
        p[0] = 1;
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] * b) % m;
        }
        for (int i = 1; i <= n; i++) {
            h[i] = ((h[i - 1] * b) % m + s[i - 1] - 'a' + m) % m;
        }
    }
    int get(int l, int r) {
        return (h[r] - (h[l - 1] * p[r - l + 1]) % m + m) % m;
    }
};

/*
vector<int> a, b;
vector<vector<int>> dp(2, vector<int>(1LL << 22));

void rek(int n, int mask = 0, int sum = 0, int sum1 = 0) {
    dp[0][mask] = sum;
    dp[1][mask] = sum1;
    for (int i = 0; i < n; i++) {
        if ((mask | (1LL << i)) == mask) {
            continue;
        }
        rek(n, (mask | (1LL << i)), sum + a[i], sum1 + b[i]);
    }
}
*/

int ask(int p) {
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return x;
}

vector<int> w;
vector<vector<pair<int, int>>> v;

struct travel{
    int c, p, cnt;
};

vector<bool> used;

void dfs(int u) {
    used[u] = true;
    for (auto e : v[u]) {
        if (!used[e.x]) {
            dfs(e.x);
        }
    }
}

struct path{
    int mx, cnt, p;
};

vector<vector<path>> dp;

void dfs1(int u, int p, int cnt, int mx, int pr = -1) {
    used[u] = true;
    mx = max(mx, w[u]);
    dp[u].push_back({mx, cnt, p});
    for (auto e : v[u]) {
        if (e.first == pr) {
            continue;
        }
        if (used[e.first]) {
            bool fl = true;
            if (p >= e.second) {
                for (auto j: dp[e.first]) {
                    if (j.cnt == cnt && j.mx == mx && j.p == p - e.second) {
                        fl = false;
                    }
                }
                if (fl) {
                    dfs1(e.first, p - e.second, cnt, mx, u);
                }
            } else {
                int p1 = p;
                int need = e.second - p;
                int c = (need + mx - 1) / mx;
                p1 += c * mx;
                for (auto j : dp[e.first]) {
                    if (j.cnt == cnt + c && j.mx == mx && j.p == p1 - e.second) {
                        fl = false;
                    }
                }
                if (fl) {
                    dfs1(e.first, p1, c + cnt, mx, u);
                }
            }
        } else {
            if (p >= e.second) {
                dfs1(e.first, p - e.second, cnt, mx, u);
            } else {
                int p1 = p;
                int need = e.second - p;
                int c = (need + mx - 1) / mx;
                p1 += c * mx;
                dfs1(e.first, p1, c + cnt, mx, u);
            }
        }
    }
}

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    w.resize(n);
    v.resize(n);
    dp.assign(n, vector<path>());
    used.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        v[a].emplace_back(b, s);
    }
    if (g == 1) {
        dfs(0);
        if (!used[n - 1]) {
            cout << -1;
            return;
        }
        set<pair<int, int>> st;
        vector<travel> d(n, {INF, 0, 0});
        d[0] = {0, p, 0};
        st.insert({0, 0});
        while (!st.empty()) {
            auto k = *st.begin();
            st.erase(st.begin());
            int f = k.y;
            for (auto to : v[f]) {
//                cout << to.x << ' ' << f << '\n';
                if (d[to.x].c > d[f].c + to.y) {
                    d[to.x].cnt = d[f].cnt;
                    d[to.x].c = d[f].c + to.y;
                    d[to.x].p = d[f].p - to.y;
                    if (d[f].p < to.y) {
                        d[to.x].cnt = d[f].cnt + to.y - d[f].p;
                        d[to.x].p = 0;
                    }
                    st.insert({d[to.x].c, to.x});
                }
            }
        }
        cout << d[n - 1].cnt;
        return;
    }
    if (g == 2) {
        int mx = 0, ans = 0;
        for (int i = 0; i != n - 1; i = v[i][0].x) {
            mx = max(mx, w[i]);
            if (p < v[i][0].y) {
                int need = v[i][0].y - p;
                ans += (need + mx - 1) / mx;
                p += (need + mx - 1) / mx * mx;
//                cout << ans << ' ' << p << '\n';
            }
            p -= v[i][0].y;
        }
        cout << ans;
        return;
    }
    if (g == 3 || g == 0) {
        dp[0].push_back({w[0], 0, p});
        dfs1(0, p, 0, w[0]);
        if (!used[n - 1]) {
            cout << -1;
        } else {
            int ans = INF;
            for (auto e : dp[n - 1]) {
                ans = min(ans, e.cnt);
            }
            cout << ans;
        }
        return;
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}