#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n, m, test;
ll now;

struct edge {
    int from, to;
    ll w;

    bool operator < (edge a) const {
        if (w != a.w) {
            return w < a.w;
        }
        if (from != a.from) {
            return from < a.from;
        }
        return to < a.to;
    }
};

vector <vector<pair<int, ll>>> g;
vector <int> use, now_path;
ll total_ans = 1e18;

vector <edge> edges;
vector <ll> w;
map <pair<int, int>, ll> mp;
vector <vector <ll>> g1;

ll get_ans_for_path(vector <int> & path) {
    int len = path.size();
    vector <int> maxs(len);
    int maxx = -1;
    for (int i = 0; i < len; ++i) {
        if (w[path[i]] > maxx) {
            maxx = w[path[i]];
            maxs[i] = 1;
        }
    }
    int last = -1;
    for (int i = len - 1; i > -1; --i) {
        if (maxs[i] == 1) {
            if (last == -1) {
                maxs[i] = len - 1;
            } else {
                maxs[i] = last;
            }
            last = i;
        }
    }
    ll ans = 0;
    ll bal = now;
    for (int i = 0; i < len; ++i) {
        ll need = 0;
        if (maxs[i] != 0) {
            for (int j = i; j < maxs[i]; ++j) {
                need += mp[{path[j], path[j + 1]}];
            }
            if (bal < need) {
                ans += (need - bal + w[path[i]] - 1) / w[path[i]];
                bal = (need - bal + w[path[i]] - 1) / w[path[i]] * w[path[i]] - need + bal;
            } else {
                bal -= need;
            }
        }
    }
    return ans;
}



void gen(int v) {
    if (v == n - 1) {
        total_ans = min(total_ans, get_ans_for_path(now_path));
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (g1[v][i] == 0) {
            continue;
        }
        int u = i;
        if (!use[u]) {
            use[u] = 1;
            now_path.push_back(u);
            gen(u);
            now_path.pop_back();
            use[u] = 0;
        }
    }
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> now >> test;
    w.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    edges.resize(m);
    g.resize(n);
    use.resize(n);
    g1.resize(n, vector <ll> (n));
    for (int i = 0; i < m; ++i) {
        int a, b;
        ll x;
        cin >> a >> b >> x;
        a--;
        b--;
        edges[i] = {a, b, x};
        g[a].push_back({b, x});
        if (mp[{a, b}] == 0 || mp[{a, b}] > x) {
            mp[{a, b}] = x;
            g1[a][b] = x;
        }
    }
    if (test == 1) {
        ll inf = 1e16;
        vector <ll> dist(n, inf), par;
        dist[0] = 0;
        vector <int> pred(n, -1);
        vector <int> used(n);
        for (int i = 0; i < n - 1; ++i) {
            int min_v = -1;
            ll min_e = inf;
            for (int j = 0; j < n; ++j) {
                if (!used[j] && min_e > dist[j]) {
                    min_v = j;
                    min_e = dist[j];
                }
            }
            if (min_e != inf) {
                for (auto [to, x] : g[min_v]) {
                    if (dist[to] > dist[min_v] + x) {
                        dist[to] = dist[min_v] + x;
                        pred[to] = min_v;
                    }
                }
                used[min_v] = 1;
            }
        }
        if (dist[n - 1] == inf) {
            cout << -1;
            return 0;
        }
        cout << max(dist[n - 1] - now, 0 * 1ll);
        return 0;
    }
    if (test == 2) {
        vector <int> maxs(n);
        int maxx = -1;
        for (int i = 0; i < n; ++i) {
            if (w[i] > maxx) {
                maxx = w[i];
                maxs[i] = 1;
            }
        }
        int last = -1;
        for (int i = n - 1; i > -1; --i) {
            if (maxs[i] == 1) {
                if (last == -1) {
                    maxs[i] = n - 1;
                } else {
                    maxs[i] = last;
                }
                last = i;
            }
        }
        ll ans = 0;
        ll bal = now;
        for (int i = 0; i < n; ++i) {
            ll need = 0;
            if (maxs[i] != 0) {
                for (int j = i; j < maxs[i]; ++j) {
                    need += edges[j].w;
                }
                if (bal < need) {
                    ans += (need - bal + w[i] - 1) / w[i];
                    bal = (need - bal + w[i] - 1) / w[i] * w[i] - need + bal;
                } else {
                    bal -= need;
                }
            }
        }
        cout << ans;
        return 0;
    }
    if (test != 2) {
        use[0] = 1;
        now_path.push_back(0);
        gen(0);
        ll inf = 1e18;
        if (total_ans == inf) {
            cout << -1;
            return 0;
        }
        cout << total_ans;
    }
    return 0;
}
