#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>
#include<set>
#include<tuple>


using namespace std;
typedef long long ll;


vector<int> w;
vector<vector<int>> g;
vector<vector<int>> c;
const int INF = 2000000000;
const ll INFLL = 2000000000000000;

void solve1(int n, int m, int p)
{
    g.resize(n, vector<int> (n, -1));
    w.resize(n);
    c.resize(n, vector<int> (n, INF));
    for (int i = 0;i < n; i++)
    {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        u--;
        v--;
        c[u][v] = min(cost, c[u][v]);
        g[u][v] = 1;
    }
    vector<vector<ll>> d(n, vector<ll> (n, INFLL));
    for (int i = 0; i < n; i++)
    {
        d[i][i] = 0;
    }
    for (int k = 0; k < n; k++)
    {
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (g[i][j] != -1)
                {
                    d[i][j] = min(d[i][j], (ll)c[i][j]);
                }
                if (d[i][k] != INFLL && d[k][j] != INFLL)
                {
                    d[i][j] = min(d[i][k] + d[k][j], d[i][j]);
                }
            }
        }
    }
    if (d[0][n - 1] == INFLL)
    {
        cout << -1;
        return;
    }
    vector<vector<ll>> cntv(n, vector<ll> (n + 1, INFLL));
    return;
}


void solve2(int n, int m, int p) {
    g.resize(n);
    w.resize(n);
    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v, cost;
        cin >> u >> v >> cost;
        u--;
        v--;
        c[u][v] = min(cost, c[u][v]);
        g[u][v] = 1;
    }
    vector<ll> dist(n, INFLL);
    dist[0] = 0;
    set<pair<int, int>> s;
    s.insert({0, 0});
    while (!s.empty())
    {
        auto [cost, v] = *s.begin();
        s.erase(s.begin());
        for (int i = 0; i < g[v].size(); i++)
        {
            if (dist[g[v][i]] > dist[i] + c[v][i])
            {
                s.erase({dist[g[v][i]], g[v][i]});
                dist[g[v][i]] = dist[i] + c[v][i];
                s.insert({dist[g[v][i]], g[v][i]});
            }
        }
    }
    if (dist[n - 1] == INFLL)
    {cout << -1;}
    else
    {
        cout << max((ll)0, dist[n - 1] - p);
    }
    return;
}

int main()
{
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 1)
    {
        solve2(n, m, p);
    }
    return 0;
}