#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>
#include<set>
#include<tuple>


using namespace std;
typedef long long ll;


vector<int> w;
vector<vector<int>> g;
vector<vector<int>> c;
const int INF = 2000000000;
const ll INFLL = 2000000000000000;


void solve1(int n, int m, int p)
{
    vector<vector<ll>> d(n, vector<ll> (n, INFLL));
    for (int i = 0; i < n; i++)
    {
        d[i][i] = 0;
    }
    for (int k = 0; k < n; k++)
    {
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (g[i][j] != -1)
                {
                    d[i][j] = min(d[i][j], (ll)c[i][j]);
                }
                if (d[i][k] != INFLL && d[k][j] != INFLL)
                {
                    d[i][j] = min(d[i][k] + d[k][j], d[i][j]);
                }
            }
        }
    }
    if (d[0][n - 1] == INFLL)
    {
        cout << -1;
        return;
    }
    vector<vector<ll>> cntv(n, vector<ll> (n + 1, INFLL));
    return;
}


void solve2(int n, int m, int p) {
    g.resize(n);
    w.resize(n);
    c.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        int u, v, cost;
        cin >> u >> v >> cost;
        u--;
        v--;
        g[u].push_back(v);
        c[u].push_back(cost);
    }
    vector<ll> dist(n, INFLL);
    dist[0] = 0;
    set<pair<int, int>> s;
    s.insert({0, 0});
    while (!s.empty())
    {
        auto [cost, v] = *s.begin();
        s.erase(s.begin());
        for (int i = 0; i < g[v].size(); i++)
        {
            if (dist[g[v][i]] > dist[v] + c[v][i])
            {
                s.erase({dist[g[v][i]], g[v][i]});
                dist[g[v][i]] = dist[v] + c[v][i];
                s.insert({dist[g[v][i]], g[v][i]});
            }
        }
    }
    if (dist[n - 1] == INFLL)
    {cout << -1;}
    else
    {
        cout << max((ll)0, dist[n - 1] - p);
    }
    return;
}


bool way(int v, int p, vector<int>& order, int f, vector<int>& r)
{
    if (f == v)
    {
        order.push_back(v);
        r.push_back(0);
        return true;
    }
    for (int i = 0; i < g[v].size(); i++)
    {
        int el = g[v][i];
        if (el != p)
        {
            if (way(el, v, order, f, r))
            {
                order.push_back(v);
                r.push_back(c[v][i]);
                return true;
            }
        }
    }
    return false;
}


void solve3(int n, int m, int p)
{
    g.resize(n);
    w.resize(n);
    c.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        u--;
        v--;
        g[u].push_back(v);
        c[u].push_back(cost);
    }
    vector<int> order;
    vector<int> r;
    way(0, 0, order, n - 1, r);
    reverse(r.begin(), r.end());
    reverse(order.begin(), order.end());
    if (order.size() == 0)
    {
        cout << -1;
        return;
    }
    vector<ll> pref(order.size());
    pref[0] = 0;
    for (int i = 1; i < order.size(); i++)
    {
        pref[i] = pref[i - 1] + r[i - 1];
    }
    ll ans = 0;
    int prevmx = w[0];
    ll ost = p;
    ll sm = 0;
    for (int i = 1; i < order.size(); i++)
    {
        sm += r[i - 1];
        if (w[order[i]] > prevmx)
        {
            ll cntnow = max((ll)0, (sm - ost + prevmx - 1)) / prevmx;
            ans += cntnow;
            ost = ost + cntnow * prevmx - sm;
            prevmx = w[order[i]];
            sm = 0;
        }
    }
    ll cntnow = max((ll)0, (sm - ost + prevmx - 1)) / prevmx;
    ans += cntnow;
    cout << ans;
    return;
}


ll cnt(vector<int>& order, int p, vector<vector<ll>>& d, int finish)
{
    ll ans = 0;
    int prevmx = w[0];
    ll ost = p;
    ll sm = 0;
    for (int i = 1; i < order.size(); i++)
    {
        if (g[order[i - 1]][order[i]] == -1)
        {return INFLL;}
        sm += c[order[i - 1]][order[i]];
        if (w[order[i]] > prevmx)
        {
            ll cntnow = max((ll)0, (sm - ost + prevmx - 1)) / prevmx;
            ans += cntnow;
            ost = ost + cntnow * prevmx - sm;
            prevmx = w[order[i]];
            sm = 0;
        }
    }
    if (order.back() != finish)
    {
        sm += d[order.back()][finish];
    }
    ll cntnow = max((ll)0, (sm - ost + prevmx - 1)) / prevmx;
    ans += cntnow;
    return ans;
}


ll per(vector<int>& order, vector<bool>& used, int f, int p, vector<vector<ll>>& d)
{
    ll ans = cnt(order, p, d, f);
    for (int i = 0; i < used.size(); i++)
    {
        if (!used[i])
        {
            used[i] = true;
            order.push_back(i);
            ans = min(ans, per(order, used, f, p, d));
            order.pop_back();
            used[i] = false;
        }
    }
    return ans;
}


void solve4(int n, int m, int p)
{
    g.resize(n, vector<int> (n, -1));
    w.resize(n);
    c.resize(n, vector<int> (n, INF));
    for (int i = 0;i < n; i++)
    {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++)
    {
        int u, v, cost;
        cin >> u >> v >> cost;
        u--;
        v--;
        c[u][v] = min(cost, c[u][v]);
        g[u][v] = 1;
    }
    vector<vector<ll>> d(n, vector<ll> (n, INFLL));
    for (int i = 0; i < n; i++)
    {
        d[i][i] = 0;
    }
    for (int k = 0; k < n; k++)
    {
        for (int i = 0; i < n; i++)
        {
            for (int j = 0; j < n; j++)
            {
                if (g[i][j] != -1)
                {
                    d[i][j] = min(d[i][j], (ll)c[i][j]);
                }
                if (d[i][k] != INFLL && d[k][j] != INFLL)
                {
                    d[i][j] = min(d[i][k] + d[k][j], d[i][j]);
                }
            }
        }
    }
    if (d[0][n - 1] == INFLL)
    {
        cout << -1;
        return;
    }
    vector<bool> used(n, false);
    vector<int> order;
    used[0] = true;
    order.push_back(0);
    ll ans = per(order, used, n - 1, p, d);
    if (ans == INFLL)
    {
        cout << -1;
    } else
    {cout << ans;}
    return;
}


int main()
{
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 1)
    {
        solve2(n, m, p);
    }
    else if (g == 2)
    {
        solve3(n, m, p);
    }
    else if (g <= 3)
    {
        solve4(n, m, p);
    }
    return 0;
}