// #define _GLIBCXX_DEBUG_PEDANTIC
// думай о правильности перед написанием
// проверяй идеи
// проверяй правильность кода
// пробуй разные подходы
// не задерживайся слишком долго на одной задаче
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int long long

#define dbg(x) cerr << #x << ": " << x << endl;

const int INF = 1e16;
const int MAX_N = 800 + 5;
const int MAX_M = 3000 + 5;
vector<pair<int, int>> g[MAX_N];
bool used[MAX_N];
int dist[MAX_N];
int weight[MAX_N];


int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m, p, group;
    cin >> n >> m >> p >> group;

    for (int v = 0; v < n; ++v) {
        cin >> weight[v];
    }

    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
    }

    if (group == 1) {
        fill_n(dist, n, INF);

        priority_queue<pair<int, int>, vector<pair<int, int>>, greater<pair<int, int>>> pq;
        pq.emplace(0, 0);
        while (!pq.empty()) {
            auto [curr_dist, v] = pq.top();
            pq.pop();
            if (used[v]) continue;

            dist[v] = curr_dist;
            used[v] = true;
            for (const auto &[u, w]: g[v]) {
                if (used[u] || dist[u] <= dist[v] + w) continue;
                dist[u] = dist[v] + w;
                pq.emplace(dist[u], u);
            }
        }

        if (!used[n - 1]) {
            cout << "-1\n";
        } else {
            cout << max(0ll, dist[n - 1] - p) << '\n';
        }
    } else if (group == 2) {
        int ans = 0;
        int curr_money = p;
        int pref_max = 0;
        for (int v = 0; v < n - 1; ++v) {
            pref_max = max(pref_max, weight[v]);
            auto [u, w] = g[v][0];
            if (curr_money < w) {
                int k = (w - curr_money + pref_max - 1) / pref_max;
                ans += k;
                curr_money += k * pref_max;
                curr_money -= w;
            } else {
                curr_money -= w;
            }
        }
        cout << ans << '\n';
    }

    return 0;
}