#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

#define int long long
#define double long double

using namespace std;

const int MAXN = 1000;
const long long inf = 1e18;

int dist[MAXN];
int used[MAXN];
vector <pair<int, int>> g[MAXN];
int w[MAXN];

signed main() {
    ios_base::sync_with_stdio((0)); cin.tie(0); cout.tie(0);
    cout << setprecision(11) << fixed;
    int n, m, p, group; cin >> n >> m >> p >> group;
    for (int i = 0; i < n; i ++) cin >> w[i];
    for (int i =  0; i < m; i ++){
        int u, v, wi; cin >> u >> v >> wi;
        u--; v--;
        g[u].push_back({v, wi});
    }
    for (int i = 0; i < n; i ++) used[i] = 0;
    for (int i = 0; i < n; i ++) dist[i] = inf;
    dist[0] =0;
    if (group == 1){
        for (int i = 0; i < n; i ++){
            int v = -1;
            for (int j = 0; j < n;j ++){
                if (used[j]) continue;
                if (v == -1 || dist[v] > dist[j]) v = j;
            }
            used[v] = 1;
            for (auto& ed : g[v]){
                if (dist[ed.first] > dist[v] + ed.second){
                    dist[ed.first] = dist[v] + ed.second;
                }
            }
        }
        if (dist[n - 1] == inf) cout << -1;
        else cout << max((int)0, dist[n - 1] - p);
    }
    if (group == 2){
        int ans = 0;
        int v = 0;
        int mx = w[0];
        while (v != n - 1) {
            mx = max(mx, w[v]);
            int delta = max((int) 0, (g[v][0].second - p) / mx);
            ans += delta;
            p = p - g[v][0].second + delta * mx;
        }
        cout << ans;
    }
    return 0;
}