#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>
#include <chrono>
#include <cassert>
#include <climits>
#include <queue>

using namespace std;

using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
istream& operator>>(istream &in, vector <T> &arr) {
    for (T &i: arr) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream &out, const vector <T> &arr) {
    for (const T &i: arr) out << i << ' ';
    return out;
}

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define mp make_pair

//#define int int64_t
//#define multitest

//#pragma GCC target("fma")
//#pragma GCC optimize("O3")
//#pragma GCC optimize("trapv")

const int N = 878;

vector <pair <int, int>> g[N];

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    if (group != 1) assert(false);
    vector <int> w(n);
    cin >> w;
    for (int i = 0; i < m; ++i) {
        int v, u, c;
        cin >> v >> u >> c;
        g[v].emplace_back(u, c);
    }
    vector <long long> dists(n + 1, LLONG_MAX);
    vector <bool> used(n + 1, false);
    priority_queue <pair <int, int>, vector <pair <int, int>>, greater <>> pq;
    pq.emplace(w[1], 1);
    dists[1] = 0;
    while (!pq.empty()) {
        auto [c, v] = pq.top();
        pq.pop();
        for (auto [u, cost]: g[v]) {
            if (dists[u] > dists[v] + cost) {
                dists[u] = dists[v] + cost;
                pq.emplace(dists[u], u);
            }
        }
        used[v] = true;
    }
    cout << (dists[n] == LLONG_MAX ? -1 : max(0ll, dists[n] - p)) << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
    auto start = clock();
#endif
    int t;
#ifdef multitest
    cin >> t;
#else
    t = 1;
#endif
    while (t --> 0) solve();
#ifdef LOCAL
    auto end = clock();
    cerr << "time: " << end - start << endl;
#endif
    return 0;
}