#pragma GCC optimize("03", "unroll-loops")
#pragma GCC target("avx2");

#include <iostream>
#include "set"
#include "vector"
//#include <ext/pb_ds/assoc_container.hpp>

//#define int long long

const int INF = 1e9 + 7;

using namespace std;
//using namespace __gnu_pbds;
//using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

vector<int> w;
vector<vector<pair<int, int>>> g;
vector<int> best;
vector<int> dist;
vector<bool> used;

void dijkstra(int V) {
    set<pair<int, int>> d;
    d.insert(make_pair(0, V));
    dist[V] = 0;
    while (!d.empty()) {
        int cur = d.begin()->second;
        int len = d.begin()->first;
        d.erase(d.begin());
        used[cur] = true;
        for (auto [to, s]: g[cur]) {
            if (!used[to] && dist[to] > len + max(0, (s - best[cur] + w[cur] - 1) / w[cur]) ||
                dist[to] == max(0, (s - best[cur] + w[cur] - 1) / w[cur]) &&
                best[to] < best[cur] + w[cur] * ((s - best[cur] + w[cur] - 1) / w[cur]) - s) {
                d.erase({dist[to], to});
                dist[to] = len + max(0, (s - best[cur] + w[cur] - 1) / w[cur]);
                best[to] = best[cur] + w[cur] * max(0, ((s - best[cur] + w[cur] - 1) / w[cur])) - s;
                d.insert({dist[to], to});
            }
        }
    }
}

int ans;
vector<bool> use;

void aaaboba(int start, int back, int count, int balance, int mx) {
    if (start == back) {
        ans = min(ans, count);
        return;
    }
    for (auto [to, s] : g[start]) {
        if (use[to]) continue;
        int need = max(0, s - balance + mx - 1);
        int cntMx = need / mx;
        int newBalance = cntMx * mx + balance - s;
        int newMx = max(mx, w[to]);
        int newCount = count + cntMx;
        if (newCount > ans) continue;
        use[to] = true;
        aaaboba(to, back, newCount, newBalance, newMx);
        use[to] = false;
    }
}

void sf() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    sf();
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    w.resize(n);
    for (int &i: w) cin >> i;
    g.resize(n);
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g[a].emplace_back(make_pair(b, s));
    }
    if (group == 1) {
        dist.resize(n, INF);
        used.resize(n, false);
        best.resize(n, 0);
        best[0] = p;
        dijkstra(0);
        cout << (dist[n - 1] == INF ? -1 : dist[n - 1]);
    } else if (group == 2) {
        vector<int> s(n - 1);
        for (int i = 0; i < n - 1; i++) {
            s[i] = g[i][0].second;
        }
        vector<pair<int, int>> dp(n, {INF, 0});
        dp[0] = {0, p};
        vector<int> mx(n, -1);
        for (int i = 0; i < n - 1; i++) {
            mx[i] = max(mx[(i + n - 1) % n], w[i]);
            int cntMx = max(0, (s[i] - dp[i].second + mx[i] - 1)) / mx[i];
            int sm = dp[i].second + mx[i] * cntMx;
            dp[i + 1] = min(dp[i + 1], {dp[i].first + cntMx, sm - s[i]});
        }
        cout << dp.back().first;
    } else {
        use.resize(n, false);
        use[0] = true;
        int mx = w[0];
        ans = INF;
        aaaboba(0, n - 1, 0, p, mx);
        cout << (ans == INF ? -1 : ans);
    }
}