#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std; using namespace __gnu_pbds;
typedef long long ll; typedef long double ld;
typedef tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int rnd(){
    return (rand() >> 16);
}
struct Dtree{
    struct Node{
        Node *left = nullptr, *right = nullptr;
        int val; int sz = 0; int y;
        Node() = default;
        Node(Node *l, Node *r, int v) : left(l), right(r), val(v), sz(1), y(rnd()) {};
    };
    Node* root = nullptr;
    int get(Node *t){
        if(t == nullptr) return 0;
        else return t->sz;
    }
    void upd(Node *t){
        t->sz = get(t->left) + get(t->right) + 1;
    }
    pair<Node*, Node*>split(Node* r, int k){
        if(r == nullptr) return {nullptr, nullptr};
        if(r->val >= k){
            auto first = split(r->left, k);
            r->left = first.second; upd(r); upd(first.first);
            return {first.first, r};
        }else{
            auto second = split(r->right, k);
            r->right = second.first; upd(r); upd(second.second);
            return {r, second.second};
        }
    }
    Node* merge(Node *a, Node *b){
        if(a == nullptr) return b;
        if(b == nullptr) return a;
        if(a->y > b->y){
            auto p = merge(a->right, b);
            a->right = p; upd(a);
        }else{
            auto p = merge(a, b->left);
            b->left = p; upd(b);
        }
    }
};
vector<vector<pair<int, int>>>graph; vector<ll>dist;
void deikstra(int start){
    dist[start] = 0; set<pair<ll, int>>good;
    good.insert({0, start});
    while(!good.empty()){
        auto u = *good.begin(); good.erase(good.begin());
        for(auto val: graph[u.second]){
            if(dist[val.first] > dist[u.second] + val.second){
                good.erase({dist[val.first], val.first});
                dist[val.first] = dist[u.second] + val.second;
                good.insert({dist[val.first], val.first});
            }
        }
    }
}
vector<ll>w; ll p; ll cnt = 0; vector<bool>used; ll ans = 1e18; int n; vector<int>min_cnt;
void dfs(int start, ll mx){
    if(p > dist[n - 1] && cnt > ans) return;
    if(start == n - 1) ans = min(ans, cnt);
    used[start] = true;
    for(auto val: graph[start]){
        if(used[val.first]) continue;
        if(p > val.second){
            p -= val.second;
            dfs(val.first, max(mx, w[val.first]));
            p += val.second;
        }else{
            ll add = (val.second - p + mx - 1) / mx; auto v = p;
            p = p + add * mx - val.second;
            cnt += add;
            dfs(val.first, max(mx, w[val.first]));
            p = v; cnt -= add;
        }
    }
    used[start] = false;
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int m; int g; cin >> n >> m >> p >> g; dist.resize(n, 1e18); graph.resize(n); used.resize(n); min_cnt.resize(n);
    w.resize(n);
    for(int i = 0; i < n; i++){
        cin >> w[i];
    }
    for(int i = 0; i < m; i++){
        int a, b, s; cin >> a >> b >> s; a--; b--;
        graph[a].push_back({b, s});
    }
    deikstra(0);
    if(g == 1){
        if(dist[n - 1] == 1e18) cout << -1;
        else cout << max(0LL, dist[n - 1] - p);
    }else if(g == 2 || g == 3 || g == 0){
        dfs(0, w[0]);
        if(ans == 1e18) cout << -1;
        else cout << ans;
    }
}