#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

mt19937 rng(time(0));

const ll INF = 1e18;

vector<vector<pii>> gr;
vector<ll> w;

void solve() {
    ll v, u, s, n, m, p, g;
    cin >> n >> m >> p >> g;
    
    gr.resize(n);
    w.resize(n);
    for (ll i = 0; i < n; i++)
        cin >> w[i];
    for (ll i = 0; i < m; i++) {
        cin >> v >> u >> s;
        v--, u--;
        gr[v].emplace_back(u, s);
    }
    if (g <= 1) {
        vector<ll> d(n, INF), used(n, 0);
        d[0] = 0;
        priority_queue<pii> q;
        q.push({ -d[0], 0 });
        while (!q.empty()) {
            ll v = q.top().Y;
            q.pop();
            if (used[v]) continue;
            used[v] = 1;
            for (pii e : gr[v]) {
                tie(u, s) = e;
                if (d[u] > d[v] + s) {
                    d[u] = d[v] + s;
                    q.push({ -d[u], u });
                }
            }
        }
        if (d[n - 1] == INF)
            cout << -1 << '\n';
        else
            cout << max(0ll, d[n - 1] - p) << '\n';
    }
    else if (g == 2) {
        ll ans = 0, cost = 0;
        for (ll i = 0; i < n-1; i++) {
            cost = max(cost, w[i]);
            ll s = gr[v][0].Y;
            if (p < s) {
                ll cnt = (s - p + cost - 1) / cost;
                ans += cnt;
                p += cost * cnt;
            }
            p -= s;
        }
        cout << ans << '\n';
    }
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    solve();
}