#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES\n"
#define int long long
#define str string

const int INF = 1e14 + 10;

vector<int> dijkstra(int n, int s, vector<vector<pii>> &g) {
    vector<int> dist(n, INF), used(n, 0);
    dist[s] = 0;
    set<pair<int, int>> D;
    f (i, 0, n) D.insert({dist[i], i});

    f (iter, 0, n) {
        auto it = D.begin();
        auto p = *it;
        //cout << p.ff << ' ' << p.sc << '\n';
        D.erase(it);
        used[p.sc] = 1;
        for (auto &u : g[p.sc]) {
            if (!used[u.ff] && dist[u.ff] > p.ff + u.sc) {
                D.erase(D.find({dist[u.ff], u.ff}));
                dist[u.ff] = p.ff + u.sc;
                D.insert({dist[u.ff], u.ff});
            }
        }
    }
    return dist;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr); cin.tie(nullptr);
    cout << fixed << setprecision(10);

    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<int> w(n);
    bool flag = true;
    f (i, 0, n) {
        cin >> w[i];
        if (w[i] != 1) {
            flag = false;
        }
    }
    vector<vector<pii>> g(n);
    f (i, 0, m) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a-1].pb({b-1, s});
    }

    if (group == 1) {
        auto res = dijkstra(n, 0, g);
        if (res[n - 1] == INF) {
            cout << "-1\n";
        } else {
            cout << max(0ll, res[n - 1] - p) << '\n';
        }
        return 0;
    }

    vector<int> c(n-1);
    f(i,0,n-1)c[i]=g[i][0].sc;

    vector<int> pref(n, 0);
    f (i, 1, n) {
        pref[i] = pref[i - 1] + c[i - 1];
    }

    vector<int> right(n, n-1);
    f (i, 0, n) {
        f (j, i + 1, n) {
            if (w[j] > w[i]) {
                right[i] = j;
                break;
            }
        }
    }

    int i = 0, ans = 0;
    while (i != n - 1) {
        int ostat = pref[right[i]]-pref[i];
        int need = ceil((double) max(0ll, ostat - p) / w[i]);
        ans += need;
        p -= ostat;
        p += need * w[i];
        i = right[i];
    }
    cout << ans << '\n';


    return 0;
}