
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>

using namespace std;

typedef long long ll;


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<int> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
	}
	vector<vector<pair<int, int>>> graph(n);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--, b--;
		graph[a].push_back({ b, c });
	}
	if (g == 1) {
		p = min(p, n - 1);
		vector<vector<int>> dp(n, vector<int>(n, 1e9));
		for (int i = 0; i <= p; i++) {
			dp[0][i] = 0;
		}
		for (int i = p + 1; i < n; i++) {
			if (i < arr[0]) {
				dp[0][i] = 1;
			}
			else {
				dp[0][i] = 1 + dp[0][i - arr[0]];
			}
		}
		deque<int> dq;
		dq.push_back(0);
		while (!dq.empty()) {
			int v = dq.front();
			dq.pop_front();
			for (auto to : graph[v]) {
				bool f = 1;
				for (int j = to.second; j < n; j++) {
					if (dp[v][j] < dp[to.first][j - to.second]) {
						dp[to.first][j] = dp[v][j];
						f = 0;
					}
				}
				if (f) {
					for (int j = arr[to.first]; j < n; j++) {
						dp[to.first][j] = min(dp[to.first][j - arr[to.first]] + 1, dp[to.first][j]);
					}
					dq.push_back(to.first);
				}
			}
		}
		if (*min_element(dp[n - 1].begin(), dp[n - 1].end()) == 1e9) {
			cout << -1 << '\n';
		}
		else {
			cout << *min_element(dp[n - 1].begin(), dp[n - 1].end()) << '\n';
		}
		return 0;
	}
}