#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <algorithm>
#include <iomanip>
#include <deque>
#include <cassert>
#include <cmath>

using namespace std;
typedef long long ll;
#define int long long

const int N = 810;
int n, m, p, G;
int w[N];
int g[N][N];

const int inf = 1e18;

vector <pair <int, int>> a;/*
pair <int, int> cst[N];

pair <int, int> pay(pair <int, int> x, int u, int v)
{
	if (g[u][v] == inf) return { inf, inf };

	int need = max(0ll, (g[u][v] - x.second) / w[u]);
	x.first += need;
	x.second += w[u] * need;
	x.second -= g[u][v];
	return x;
}*/

const int K = 1000;

int dp[N][K];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m >> p >> G;

	for (int i = 1; i <= n; ++i) cin >> w[i];
	for (int i = 1; i <= n; ++i) for (int j = 1; j <= n; ++j) g[i][j] = i == j ? 0 : inf;
	for (int i = 1; i <= m; ++i)
	{
		int u, v, c;
		cin >> u >> v >> c;
		g[u][v] = min(g[u][v], c);
	}

	for (int k = 1; k <= n; ++k)
	{
		for (int i = 1; i <= n; ++i)
		{
			for (int j = 1; j <= n; ++j)
			{
				g[i][j] = min(g[i][j], g[i][k] + g[k][j]);
			}
		}
	}

	for (int i = 1; i <= n; ++i)
	{
		a.push_back({ w[i], i });
	}
	
	sort(a.begin(), a.end());

	for (int _ = 0; _ < n; ++_)
	{
		auto u = a[_].second;
		for (int j = 0; j < K; ++j) dp[_][j] = inf;
		if (u == 1)
		{
			for (int j = 0; j <= p; ++j) dp[_][j] = 0;
		}

		for (int __ = 0; __ < _; ++__)
		{
			auto v = a[__].second;

			for (int j = g[v][u]; j < K; ++j)
			{
				dp[_][j - g[v][u]] = min(dp[_][j - g[v][u]], dp[__][j]);
			}
		}
		for (int j = 0; j < K; ++j) dp[_][j] = min(dp[_][j], 1 + dp[_][max(0ll, j - w[u])]);
	}

	int ans = inf;
	for (int i = 0; i < n; ++i)
	{
		if (g[a[i].second][n] == inf) continue;
		ans = min(ans, dp[i][g[a[i].second][n]]);
	}

	cout << ans;

	return 0;
}				