#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

mt19937 rnd(0);

int n, m, p;
vector<int> w;
vector<vector<pair<int, int>>> g;
vector<bool> used;

const int inf = 1000000000000000;

void solve_1() {
    vector<pair<int, int>> pr(n, {-1, -1});
    vector<int> d(n, inf);
    used.assign(n, 0);
    d[0] = 0;
    set<pair<int, int>> q;
    for (int i = 0; i < n; ++i) q.emplace(d[i], i);
    while (!q.empty()) {
        auto [dist, v] = *q.begin();
        q.erase(q.begin());
        used[v] = true;
        for (auto [u, cost]: g[v]) {
            if (used[u]) continue;
            q.erase({d[u], u});
            if (d[u] > dist + cost) {
                d[u] = dist + cost;
                pr[u] = {v, cost};
            }
            q.insert({d[u], u});
        }
    }
    if (d[n - 1] == inf) {
        cout << -1;
        return;
    }
    int sm = 0, ind = n - 1;
    while (ind != 0) {
        sm += pr[ind].second;
        ind = pr[ind].first;
    }
    cout << max(0ll, sm - p);
}

void solve_2() {
    int mx = w[0], ans = 0;
    for (int i = 1; i < n; ++i) {
        int val = g[i - 1][0].second;
        if (p < val) {
            int k = (val - p + mx - 1) / mx;
            ans += k;
            p += k * mx;
        }
        p -= val;
        mx = max(mx, w[i]);
    }
    cout << ans;
}

int res = inf;

void dfs(int v, int t, int cnt, int mx) {
    if (cnt >= res) return;
    if (v == n - 1) {
        res = min(res, cnt);
        return;
    }
    for (auto [u, cost]: g[v]) {
        if (used[u] == 1) continue;
        if (t < cost) {
            int k = (cost - t + mx - 1) / mx;
            int val = t + mx * k - cost;
            assert(val >= 0);
            dfs(u, t + mx * k - cost, cnt + k, max(mx, w[u]));
        }
        else {
            dfs(u, t - cost, cnt, max(mx, w[u]));
        }
    }
    used[v] = false;
}

void solve_3() {
    used.assign(n, false);
    dfs(0, p, 0, w[0]);
    cout << (res == inf ? -1: res);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m >> p;
    int gr; cin >> gr;
    w.resize(n); cin >> w;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int ai, bi, si;
        cin >> ai >> bi >> si;
        --ai, --bi;
        g[ai].emplace_back(bi, si);
    }
    if (gr == 1) solve_1();
    else if (gr == 2) solve_2();
    else solve_3();
}