#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

random_device rd;
mt19937 rnd(rd());

int n, m;
ll p;
vector<ll> w;
vector<vector<pair<int, ll>>> g;
vector<int> used;
vector<pair<ll, ll>> vis;

const ll inf = 1000000000000000;

bool is_tl() {
    static int cnt = 0;
    cnt++;
    if (cnt % 100 == 0) {
        return (double)clock() / CLOCKS_PER_SEC > 0.95;
    }
    return false;
}

void solve_1() {
    vector<pair<int, ll>> pr(n, {-1, -1});
    vector<ll> d(n, inf);
    used.assign(n, 0);
    d[0] = 0;
    set<pair<ll, int>> q;
    for (int i = 0; i < n; ++i) q.emplace(d[i], i);
    while (!q.empty()) {
        auto [dist, v] = *q.begin();
        q.erase(q.begin());
        used[v] = true;
        for (auto [u, cost]: g[v]) {
            if (used[u]) continue;
            q.erase({d[u], u});
            if (d[u] > dist + cost) {
                d[u] = dist + cost;
                pr[u] = {v, cost};
            }
            q.insert({d[u], u});
        }
    }
    if (d[n - 1] == inf) {
        cout << -1;
        return;
    }
    ll sm = 0, ind = n - 1;
    while (ind != 0) {
        sm += pr[ind].second;
        ind = pr[ind].first;
    }
    cout << max(0ll, sm - p);
}

void solve_2() {
    ll mx = w[0], ans = 0;
    for (int i = 1; i < n; ++i) {
        ll val = g[i - 1][0].second;
        if (p < val) {
            ll k = (val - p + mx - 1) / mx;
            ans += k;
            p += k * mx;
        }
        p -= val;
        mx = max(mx, w[i]);
    }
    cout << ans;
}

ll res = inf;

void dfs(int v, ll t, ll cnt, ll mx) {
    if (is_tl()) {
        cout << (res == inf ? -1: res);
        exit(0);
    }
    if (cnt >= res) return;
    if (v == n - 1) {
        res = min(res, cnt);
        return;
    }
    vis[v] = max(make_pair(mx, cnt), vis[v]);
    for (auto [u, cost]: g[v]) {
        if (vis[u].first >= mx && cnt >= vis[u].second) continue;
        if (t < cost) {
            ll k = (cost - t + mx - 1) / mx;
            dfs(u, t - cost + k * mx, cnt + k, max(mx, w[u]));
        }
        else {
            dfs(u, t - cost, cnt, max(mx, w[u]));
        }
    }
}

void solve_3() {
    vis.assign(n, {-1, inf});
    dfs(0, p, 0, w[0]);
    cout << (res == inf ? -1: res);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> m >> p;
    int gr; cin >> gr;
    w.resize(n); cin >> w;
    g.resize(n);
    for (int i = 0; i < m; ++i) {
        int ai, bi; ll si;
        cin >> ai >> bi >> si;
        --ai, --bi;
        g[ai].emplace_back(bi, si);
    }
    for (int i = 0; i < n; ++i) {
        shuffle(all(g[i]), rnd);
    }
    if (gr == 1) solve_1();
    else if (gr == 2) solve_2();
    else solve_3();
}