#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

#define int ll

const int INF = 1e18;

int n, m, p;
vector<vector<pair<int, int>>> g;
vector<int> w;

void solve_case() {
	cin >> n >> m >> p;
	int group; cin >> group;
	w.resize(n);
	for (int& x : w)
		cin >> x;

	g.resize(n);
	vector<vector<int>> mn(n, vector<int>(n, INF));
	for (int i = 0; i < m; i++) {
		int a, b, w; cin >> a >> b >> w;
		a--; b--;
		mn[a][b] = min(mn[a][b], w);
	}

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (mn[i][j] != INF) {
				g[i].emplace_back(j, mn[i][j]);
			}
		}
	}

	if (group == 1) {
		vector<int> d(n, INF);
		d[0] = 0;
		set<pair<int, int>> q = { { 0, 0 } };

		while (sz(q)) {
			auto [D, v] = *q.begin();
			q.erase(q.begin());

			for (auto& [u, w] : g[v]) {
				if (d[u] > d[v] + w) {
					q.erase({ d[u], u });
					d[u] = d[v] + w;
					q.insert({ d[u], u });
				}
			}
		}

		if (d.back() == INF) {
			cout << "-1\n";
		}
		else {
			cout << max(int(0), d.back() - p) << '\n';
		}

		return;
	}
	if (group == 2) {
		int mx = w[0];

		int res = 0;
		for (int i = 0; i < n - 1; i++) {
			mx = max(mx, w[i]);

			auto [to, price] = g[i][0];
			int need = max(int(0), price - p);
			res += (need + mx - 1) / mx;
			p += (need + mx - 1) / mx * mx;
			p -= price;
		}

		cout << res << '\n';
		return;
	}

	vector<vector<int>> distance(n, vector<int>(n, INF));
	for (int s = 0; s < n; s++) {
		auto& d = distance[s];
		d[s] = 0;
		set<pair<int, int>> q = { { 0, s } };

		while (sz(q)) {
			auto [D, v] = *q.begin();
			q.erase(q.begin());

			for (auto& [u, w] : g[v]) {
				if (d[u] > d[v] + w) {
					q.erase({ d[u], u });
					d[u] = d[v] + w;
					q.insert({ d[u], u });
				}
			}
		}
	}

	vector<int> middle(n - 1);
	iota(all(middle), 1);

	int P = p;

	int res = INF;
	do {
		p = P;
		vector<int> order = { 0 };
		for (int x : middle)
			order.push_back(x);

		int mx = w[order[0]];

		int now = 0;
		for (int i = 0; order[i] != n - 1; i++) {
			mx = max(mx, w[order[i]]);

			int price = distance[order[i]][order[i + 1]];
			if (price == INF) {
				now = INF;
				break;
			}
			int need = max(int(0), price - p);
			now += (need + mx - 1) / mx;
			p += (need + mx - 1) / mx * mx;
			p -= price;
		}

		if (now != INF) {
			res = min(res, now);
		}
	} while (next_permutation(all(middle)));

	if (res == INF) {
		res = -1;
	}
	cout << res << '\n';
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
