#include <bits/stdc++.h>
#define int long long
#pragma GCC optimize("Ofast")
using namespace std;
const int inf = 1e18;
int deijkstra(int n, vector<vector<pair<int, int>>> &gr) {
    vector<int> d(n, inf);
    d[0] = 0;
    set<pair<int, int>> st;
    st.insert({0, 0});
    while (!st.empty()) {
        auto p = *st.begin();
        st.erase(st.begin());
        int dst = p.first;
        int v = p.second;
        for (auto &x : gr[v]) {
            int u = x.first;
            int w = x.second;
            if (d[u] > dst + w) {
                st.erase({d[u], u});
                d[u] = dst + w;
                st.insert({d[u], u});
            }
        }
    }
    return d[n - 1];
}


void solve0(int n, int m, int p) {
    vector<vector<pair<int, int>>> gr(n);
    vector<int> w(n);
    for (auto &x : w)
        cin >> x;
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        gr[a].emplace_back(b, s);
    }

    int dst = deijkstra(n, gr);
    if (dst == inf) {
        cout << -1 << '\n';
        return;
    }
    cout << max(0ll, dst - p) << '\n';
}

void solve1(int n, int m, int p) {
    vector<int> w(n);
    for (auto &x : w)
        cin >> x;
    vector<int> s(n);
    for (auto &x : s) {
        int a; cin >> a >> a >> x;
    }

    int mx = w[0];
    int res = 0;
    int cash = p;
    for (int i = 0; i < n; ++i) {
        mx = max(mx, w[i]);
        int nd = (s[i] - cash + mx - 1) / mx;
        if (nd < 0)
            nd = 0;
        res += nd;
        cash = cash - s[i] + mx * nd;
    }
    cout << res << '\n';
}
vector<bool> used;
inline void go(int v, int cash, int num, int mx, vector<vector<pair<int, int>>> &gr, vector<int> &w, int &res) {
    int n = (int)gr.size();
    if (v == n - 1) {
        res = min(res, num);
        return;
    }
    used[v] = 1;
    mx = max(mx, w[v]);
    for (auto &e : gr[v]) {
        int u = e.first;
        int s = e.second;
        if (used[u])
            continue;
        int nd = (s - cash + mx - 1) / mx;
        if (nd < 0) nd = 0;
        if (num + nd > res)
            continue;
        go(u, cash - s + mx * nd, num + nd, mx, gr, w, res);
    }
    used[v] = 0;
}

void solve_any(int n, int m, int p) {
    vector<int> w(n);
    vector<vector<pair<int, int>>> gr(n);
    for (auto &x : w)
        cin >> x;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        --a; --b;
        gr[a].push_back({b, c});
    }
    int res = 1e18;
    used.resize(n, 0);
    go(0, p, 0, w[0], gr, w, res);
    if (res == 1e18)
        cout << -1 << '\n';
    else
        cout << res << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    if (g == 1) {
        solve0(n, m, p);
    } else if (g == 2) {
        solve1(n, m, p);
    } else {
        solve_any(n, m, p);
    }
}