#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <queue>

#define int long long

using namespace std;

void minput(int v, vector<vector <pair<int, int> > > &graph, vector <int> &dist)
{
    queue<int> q;
    q.push(v);
    while (!q.empty())
    {
        int v=q.front();
        q.pop();
        for (auto el: graph[v])
        {
            if (dist[v]+el.second<dist[el.first])
            {
                dist[el.first]=dist[v]+el.second;
                q.push(el.first);
            }
        }
    }
}

void solve()
{
    //1 - min(мин путь - p, 0)
    //2 - жадно пытаемся набрать что бы сумма была больше нуля на префиксе
    int n,m,p,g;
    cin>>n>>m>>p>>g;
    vector <vector <pair<int, int> > > graph(n);
    vector <int> w(n);
    for (int i=0; i<n; i++) cin>>w[i];
    for (int i=0; i<m; i++)
    {
        int x,y,u;
        cin>>x>>y>>u;
        x--;
        y--;
        graph[x].push_back({y,u});
        //graph[y].push_back({x,u});
    }
    if (g==1)
    {
        vector <int> dist(n,1e15);
        dist[0]=0;
        minput(0,graph,dist);
        if (dist[n-1]==1e15)
        {
            cout<<"-1\n";
            return;
        }
        else cout<<max(dist[n-1]-p,0ll)<<endl;
    }
    if (g==2)
    {
        int ans=0, mmax=w[0];
        for (int i=1; i<n; i++)
        {
            ans+=max(graph[i-1][0].second-p,0ll)/mmax+(max(graph[i-1][0].second-p,0ll)%mmax!=0);
            p+=mmax*(max(graph[i-1][0].second-p,0ll)/mmax+(max(graph[i-1][0].second-p,0ll)%mmax!=0));
            p-=graph[i-1][0].second;
            mmax=max(mmax,w[i]);
        }
        cout<<ans<<"\n";
    }
}

signed main() {
    int t=1;
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    //cin>>t;
    while (t--)
    {
        solve();
    }
}