#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

const ll INF18 = 1e18;

ll n, m, cnt;

ll solveLine() {
    vector<ll> profit(n);
    for (auto &item: profit) {
        cin >> item;
    }

    vector<ll> cost(n);
    for (ll i = 1; i < n; ++i) {
        cin >> cost[i] >> cost[i] >> cost[i];
    }

    vector<ll> dp(n);
    ll maxProfit = profit[0];
    for (ll i = 1; i < n; ++i) {
        ll need = max(0LL, cost[i] - cnt);
        ll add = (need + maxProfit - 1) / maxProfit;
        cnt += maxProfit * add;
        cnt -= cost[i];
        dp[i] = add + dp[i - 1];
        maxProfit = max(maxProfit, profit[i]);
    }

    return dp[n - 1];
}

ll solveW1() {
    vector<vector<pair<ll, ll>>> graph(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u, cost;
        cin >> v >> u >> cost;
        --v;
        --u;
        graph[v].emplace_back(u, cost);
    }

    vector<ll> dist(n, INF18);
    dist[0] = 0;
    set<pair<ll, ll>> kids;
    kids.insert({0, 0});
    while (!kids.empty()) {
        ll from = kids.begin()->second;
        kids.erase(kids.begin());
        for (const auto &to: graph[from]) {
            if (dist[from] + to.second < dist[to.first]) {
                kids.erase({dist[to.first], to.first});
                dist[to.first] = dist[from] + to.second;
                kids.insert({dist[to.first], to.first});
            }
        }
    }

    if (dist[n - 1] == INF18) {
        return -1;
    }

    return max(0LL, dist[n - 1] - cnt);
}

void resolve() {
    ll testGroup;
    cin >> n >> m >> cnt >> testGroup;
    ll res = 0;
    if (testGroup == 1) {
        res = solveW1();
    } else if (testGroup == 2) {
        res = solveLine();
    }

    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve();
    return 0;
}
