#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 500500;
const ll mod = 1e13;

ll w[sz];
vector <pair <int, ll> > g[sz];
ll dist[sz];

ll stupid(int n, ll p) {
	ll ans = 0, mx = w[1];
	for (int i = 2; i <= n; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		mx = max(mx, w[i - 1]);
		if (p >= s) {
			p -= s;
			continue;
		}
		ll need = (s - p + mx - 1) / mx;
		ans += need;
		p += need * mx;
		p -= s;
	}
	return ans;
}

ll dk(int n, int m, ll p) {
	dist[1] = 0;
	for (int i = 0; i < m; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		g[a].push_back({ b, s });
	}
	set <pair <ll, int> > s;
	for (int i = 2; i <= n; ++i) {
		dist[i] = mod;
	}
	for (int i = 1; i <= n; ++i) {
		s.insert({ dist[i], i });
	}
	while (!s.empty() && (*s.begin()).first != mod) {
		int p = (*s.begin()).second;
		s.erase(s.begin());
		for (auto u : g[p]) {
			ll nd = dist[p] + u.second;
			if (dist[u.first] > nd) {
				s.erase({ dist[u.first], u.first });
				dist[u.first] = nd;
				s.insert({ dist[u.first], u.first });
			}
		}
	}
	if (dist[n] == mod) return -1;
	if (dist[n] <= p) return 0;
	return dist[n] - p;
}

int main() {
	int n, m, g;
	ll p;
	cin >> n >> m >> p >> g;
	for (int i = 1; i <= n; ++i) {
		cin >> w[i];
	}
	if (g == 1) {
		cout << dk(n, m, p);
		return 0;
	}
	if (g == 2) {
		cout << stupid(n, p);
		return 0;
	}
}