#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

void solve() {
	int n, m, p, group; cin >> n >> m >> p >> group;
	vector <int> prib(n); for (auto& x : prib) cin >> x;
	prib[n - 1] = 1e10;
	vector <vector <pair <int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w; cin >> u >> v >> w;
		--u; --v;
		g[u].push_back({ v, w });
	}

	vector <vector <int>> dist(n, vector <int>(n, 1e18));
	for (int i = 0; i < n; ++i) {
		dist[i][i] = 0;
	}
	for (int v = 0; v < n; ++v) {
		for (auto [u, w] : g[v]) {
			dist[v][u] = min(dist[v][u], w);
		}
	}
	for (int k = 0; k < n; ++k) {
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
			}
		}
	}

	if (dist[0][n - 1] > 1e17) {
		cout << -1;
		return;
	}

	vector <int> order(n); iota(all(order), 0);
	sort(all(order), [&](int a, int b) {return prib[a] < prib[b]; });

	if (group == 1) {
		cout << max(dist[0][n - 1] - p, 0ll);
		return;
	}
	if (true || group == 2) {
		vector <pair <int, int>> dp(n, { 1e18, -1e18 });
		dp[0] = { 0, -p };
		for (auto i : order) {
			if (dp[i].first > 1e17) continue;
			for (int j = 0; j < n; ++j) {
				if (prib[j] > prib[i] && dist[i][j] < 1e17) {
					if (dist[i][j] <= -dp[i].second) {
						dp[j] = min(dp[j], { dp[i].first, -(-dp[i].second - dist[i][j])});
					}
					else {
						int need = dist[i][j] + dp[i].second;
						int add = (need + prib[i] - 1) / prib[i];
						dp[j] = min(dp[j], { dp[i].first + add, -(-dp[i].second + add * prib[i] - dist[i][j])});
					}
				}
			}
		}

		cout << dp[n - 1].first;
		return;
	}
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}