#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll INF = 1e18;

void solve1(int n, int m, int p) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> st;
    st.insert({0, 0});
    while (not st.empty()) {
        auto x = *st.begin();
        int v = x.second;
        for (auto el: g[v]) {
            if (dist[el.first] > dist[v] + el.second) {
                st.erase({dist[el.first], el.first});
                dist[el.first] = dist[v] + el.second;
                st.insert({dist[el.first], el.first});
            }
        }
        st.erase(x);
    }
    if (dist[n - 1] == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << dist[n - 1] - (ll)p << '\n';
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int n, m, p, g; cin >> n >> m >> p >> g;
    if (g == 1) {
        solve1(n, m, p);
    }
}