#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll INF = 1e18;

void solve1(int n, int m, int p) {
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    vector<ll> dist(n, INF);
    dist[0] = 0;
    set<pair<ll, int>> st;
    st.insert({0, 0});
    while (not st.empty()) {
        auto x = *st.begin();
        int v = x.second;
        for (auto el: g[v]) {
            if (dist[el.first] > dist[v] + el.second) {
                st.erase({dist[el.first], el.first});
                dist[el.first] = dist[v] + el.second;
                st.insert({dist[el.first], el.first});
            }
        }
        st.erase(x);
    }
    if (dist[n - 1] == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << max(0ll, dist[n - 1] - (ll)p) << '\n';
}

void solve2(int n, int m, int p) {
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<int, ll>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    ll ans = 0, mx = 0, now = p;
    for (int i = 0; i < n - 1; ++i) {
        mx = max(mx, a[i]);
        if (g[i][0].second > now) {
            ll num = (g[i][0].second - now + mx - 1) / mx;
            ans += num;
            now += num * mx;
        }
        now -= g[i][0].second;
    }
    cout << ans << '\n';
}

void solve3(int n, int m, int p) {
    vector<ll> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<ll>> tab(n, vector<ll>(n, INF));
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        tab[u][v] = min(tab[u][v], (ll)w);
    }
    if (n == 2) {
        if (tab[0][1] == INF) {
            cout << -1 << '\n';
            return;
        }
        ll ans = 0;
        if (tab[0][1] > p) {
            ans += (tab[0][1] - p + a[0] - 1) / a[0];
        }
        cout << ans << '\n';
        return;
    }
    ll ans = INF;
    for (int i = 0; i < (1 << (n - 2)); ++i) {
        vector<int> path;
        for (int j = 0; j < n - 2; ++j) {
            if ((i >> j) % 2) {
                path.push_back(j + 1);
            }
            bool cont = true;
            while (cont) {
                path.push_back(n - 1);
                ll tr = 0, mx = a[0], bal = p;
                bool psbl = true;
                int now = 0;
                for (auto v: path) {
                    if (tab[now][v] == INF) {
                        psbl = false;
                        break;
                    }
                    if (tab[now][v] > bal) {
                        ll num = (tab[now][v] - bal + mx - 1) / mx;
                        tr += num;
                        bal += num * mx;
                    }
                    bal -= tab[now][v];
                    mx = max(mx, a[v]);
                    now = v;
                }
                path.pop_back();
                if (psbl) ans = min(ans, tr);
                cont = next_permutation(path.begin(), path.end());
            }
        }

    }
    if (ans == INF) {
        cout << -1 << '\n';
        return;
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int n, m, p, g; cin >> n >> m >> p >> g;
    if (g == 1) {
        solve1(n, m, p);
    } else if (g == 2) {
        solve2(n, m, p);
    } else if (g == 3 or g == 0) {
        solve3(n, m, p);
    }
}