#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll INF = 0x3f3f3f3f;
const ll INF_L = 0x3f3f3f3f3f3f3f3f;

struct edge {
    ll u, w;
};

ll n, m, p, gr;
vector<vector<edge>> g;
vector<ll> w;

void solve1() {
    vector<ll> d(n, INF_L);
    vector<bool> used(n);

    set<pair<ll, ll>> q;
    d[0] = 0;
    q.insert({0, 0});

    while (!q.empty()) {
        auto [dv, v] = *q.begin();
        q.erase(q.begin());
        used[v] = true;

        for (auto [ui, wi]: g[v]) {
            if (!used[ui] && dv + wi < d[ui]) {
                q.erase({d[ui], ui});
                d[ui] = dv + wi;
                q.insert({d[ui], ui});
            }
        }
    }

    if (d[n - 1] == INF_L) {
        cout << "-1\n";
    } else {
        cout << max(0ll, d[n - 1] - p);
    }
}

void solve2() {
    vector<ll> s(n - 1);
    for (ll i = 0; i < n - 1; ++i) {
        ll t;
        cin >> t >> t >> s[i];
    }

    ll ans = 0;
    ll ma = 0;
    for (ll i = 0; i < n - 1; ++i) {
        ma = max(ma, w[i]);
        ll z = (max(0ll, s[i] - p) + ma - 1) / ma;
        ans += z;
        p = p + z * 1ll * ma - s[i];
    }
    cout << ans << "\n";
}

void solve3() {
    vector<vector<ll>> mat(n, vector<ll>(n, INF));
    for (ll i = 0; i < m; ++i) {
        ll vi, ui, wi;
        cin >> vi >> ui >> wi;
        mat[vi - 1][ui - 1] = min(mat[vi - 1][ui - 1], wi);
    }

    ll ans = INF_L;
    vector<ll> order(n);
    iota(order.begin(), order.end(), 0);

    do {
        ll cans = 0, ps = p;
        ll ma = 0;
        bool ok = true;
        for (ll i = 0; order[i] != n - 1; ++i) {
            if (mat[order[i]][order[i + 1]] == INF) {
                ok = false;
                break;
            }
            ma = max(ma, w[order[i]]);
            ll z = (max(0ll, mat[order[i]][order[i + 1]] - ps) + ma - 1) / ma;
            cans += z;
            ps = ps + z * 1ll * ma - mat[order[i]][order[i + 1]];
        }
        if (ok) {
            ans = min(ans, cans);
        }
    } while (next_permutation(order.begin() + 1, order.end()));

    if (ans == INF_L) {
        cout << "-1\n";
    } else {
        cout << ans << "\n";
    }
}

void solve() {
    cin >> n >> m >> p >> gr;

    w.resize(n);
    g.resize(n);

    for (ll i = 0; i < n; ++i) {
        cin >> w[i];
    }

    if (gr == 1) {
        for (ll i = 0; i < m; ++i) {
            ll vi, ui, wi;
            cin >> vi >> ui >> wi;
            g[vi - 1].push_back({ui - 1, wi});
        }
    }

    if (gr == 1) {
        solve1();
    } else if (gr == 2) {
        solve2();
    } else if (gr == 0 || gr == 3) {
        solve3();
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    ll t = 1;
//    cin >> t;
    for (ll i = 0; i < t; ++i) {
        solve();
    }
}
