#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 5e6 + 300, mod = 1e9 + 7;
ll inf = 1e14;
void solve(){
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<ll> cost(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> cost[i];
    vector<vector<pair<ll, ll>>> graph(n + 1);
    for(int i = 0; i < m; i++){
        ll a, b, w;
        cin >> a >> b >> w;
        graph[a].push_back(make_pair(b, w));
    }
    vector<vector<bool>> edges(n + 1, vector<bool>(n + 1, false));
    for(int i = 1; i <= n; i++)
        for(pair<ll, ll> nxt : graph[i])
            edges[i][nxt.first] = true;
    vector<vector<ll>> shortest_path(n + 1, vector<ll>(n + 1, inf));
    auto dijkstra = [&](ll start){
        vector<ll> dst(n + 1, inf);
        dst[start] = 0;
        priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
        q.push(make_pair(0, start));
        while(!q.empty()){
            pair<ll, ll> cur = q.top();
            q.pop();
            if(dst[cur.second] < cur.first)
                continue;
            for(pair<ll, ll> nxt : graph[cur.second]){
                ll nv = nxt.first, ndst = cur.first + nxt.second;
                if(dst[nv] > ndst){
                    dst[nv] = ndst;
                    q.push(make_pair(ndst, nv));
                }
            }
        }
        return dst;
    };
    for(int i = 1; i <= n; i++)
        shortest_path[i] = dijkstra(i);
    if(g == 1){
        vector<ll> dst = dijkstra(1);
        if(dst[n] == inf){
            cout << -1 << "\n";
            return;
        }
        cout << max((ll)0, dst[n] - p);
    }
    if(n <= 10){
        vector<ll> order;
        for(int i = 1; i <= n; i++)
            order.push_back(i);
        ll ans = inf;
        do{
            if(order[0] != 1)
                continue;
            bool good = true;
            vector<ll> temp = order;
            while(temp.back() != n)
                temp.pop_back();
            for(int i = 0; i < temp.size() - 1; i++)
                    if(!edges[temp[i]][temp[i + 1]])
                        good = false;
            if(!good)
                continue;
            ll money = p, res = 0;
            for(int i = 0; i < temp.size() - 1; i++){
                ll need = max((ll)0, shortest_path[temp[i]][temp[i + 1]] - money);
                if(need > 0){
                    ll add = need / cost[temp[i]] + (need  % cost[temp[i]] > 0);
                    res += add;
                    money = add * cost[temp[i]] - need;
                }
                else
                    money -= shortest_path[temp[i]][temp[i + 1]];
            }
            /*cout << "PATH: ";
            for(ll num : temp)
                cout << num << " ";
            cout << "\n";
            cout << res << "\n";*/
            ans = min(ans, res);
        }while(next_permutation(order.begin(), order.end()));
        if(shortest_path[1][n] == inf)
            ans = -1;
        cout << ans;
    }
    else
        cout << 0;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}