#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 5e6 + 300, mod = 1e9 + 7;
ll inf = 1e14;
void solve(){
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<ll> cost(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> cost[i];
    vector<vector<pair<ll, ll>>> graph(n + 1);
    for(int i = 0; i < m; i++){
        ll a, b, w;
        cin >> a >> b >> w;
        graph[a].push_back(make_pair(b, w));
    }
    vector<vector<ll>> edges(n + 1, vector<ll>(n + 1, inf));
    for(int i = 1; i <= n; i++)
        for(pair<ll, ll> nxt : graph[i])
            edges[i][nxt.first] = min(edges[i][nxt.first], nxt.second);
    vector<vector<ll>> shortest_path(n + 1, vector<ll>(n + 1, inf));
    auto dijkstra = [&](ll start){
        vector<ll> dst(n + 1, inf);
        dst[start] = 0;
        priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
        q.push(make_pair(0, start));
        while(!q.empty()){
            pair<ll, ll> cur = q.top();
            q.pop();
            if(dst[cur.second] < cur.first)
                continue;
            for(pair<ll, ll> nxt : graph[cur.second]){
                ll nv = nxt.first, ndst = cur.first + nxt.second;
                if(dst[nv] > ndst){
                    dst[nv] = ndst;
                    q.push(make_pair(ndst, nv));
                }
            }
        }
        return dst;
    };
    for(int i = 1; i <= n; i++)
        shortest_path[i] = dijkstra(i);
    if(g == 1){
        vector<ll> dst = dijkstra(1);
        if(dst[n] == inf){
            cout << -1 << "\n";
            return;
        }
        cout << max((ll)0, dst[n] - p);
    }
    else if(g == 2){
        vector<pair<ll, ll>> calc(n + 1, make_pair(0, inf));
        vector<ll> maxv(n + 1, 0);
        maxv[1] =  cost[1];
        calc[1] = make_pair(p, 0);
        for(int i = 1; i < n; i++){
            if(calc[i].first >= graph[i][0].second){
                calc[i + 1] = make_pair(calc[i].first - graph[i][0].second, calc[i].second);
                maxv[i + 1] = max(maxv[i], cost[i + 1]);
            }
            else{
                ll need = graph[i][0].second - calc[i].first;
                ll add = need / maxv[i] + (need % maxv[i] > 0);
                calc[i + 1] = make_pair(add * maxv[i] - need, calc[i].second + add);
                maxv[i + 1] = max(maxv[i], cost[i + 1]);
            }
        }
        if(calc[n].second == inf)
            cout << -1;
        else
            cout << calc[n].second;
        return;
    }
    else if (n <= 10){
        vector<ll> order;
        for(int i = 1; i <= n; i++)
            order.push_back(i);
        ll ans = inf;
        do{
            if(order[0] != 1)
                continue;
            bool good = true;
            vector<ll> temp = order;
            while(temp.back() != n)
                temp.pop_back();
            for(int i = 0; i < temp.size() - 1; i++)
                    if(edges[temp[i]][temp[i + 1]] == inf)
                        good = false;
            if(!good)
                continue;
            vector<pair<ll, ll>> calc(n + 1, make_pair(0, inf));
            vector<ll> maxv(n + 1, 0);
            maxv[1] =  cost[1];
            calc[1] = make_pair(p, 0);
            for(int i = 0; i < temp.size() - 1; i++){
                if(calc[temp[i]].first >= edges[temp[i]][temp[i + 1]]){
                    calc[temp[i + 1]] = make_pair(calc[temp[i]].first - edges[temp[i]][temp[i + 1]], calc[temp[i]].second);
                    maxv[temp[i + 1]] = max(maxv[temp[i]], cost[temp[i + 1]]);
                }
                else{
                    ll need = edges[temp[i]][temp[i + 1]] - calc[temp[i]].first;
                    ll add = need / maxv[temp[i]] + (need % maxv[temp[i]] > 0);
                    calc[temp[i + 1]] = make_pair(add * maxv[temp[i]] - need, calc[temp[i]].second + add);
                    maxv[temp[i + 1]] = max(maxv[temp[i]], cost[temp[i + 1]]);
                }
            }
            /*cout << "PATH: ";
            for(ll num : temp)
                cout << num << " ";
            cout << "\n";
            cout << calc[n].second << "\n";*/
            ans = min(ans, calc[n].second);
        }while(next_permutation(order.begin(), order.end()));
        if(shortest_path[1][n] == inf)
            ans = -1;
        cout << ans;
        return;
    }
    else
        cout << 0;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}