#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("Ofast") // O3 maybe
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

#define time() (double)(clock()) / (double)(CLOCKS_PER_SEC)

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int n, m, p, g;
vector<int> w;

const int N = 1e3 + 10;

vector<pair<int, int>> G[N];

int dist[N][N];

const int infll = 1e18;

void read () {
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dist[i][j] = infll;
        }
    }
    w.resize(n);
    cin >> w;
    for (int i = 0; i < m; i++) {
        int u, v, weight;
        cin >> u >> v >> weight;
        u--;v--;
        dist[u][v] = min(dist[u][v], weight);
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (dist[i][j] != infll) {
                G[i].push_back({j, dist[i][j]});
            }
        }
    }
}


void solve_zero() {
    vector<int> dist(n, infll);
    set<pair<int, int>> st;
    st.insert({0, 0});
    dist[0] = 0;
    while (!st.empty()) {
        auto it = *st.begin();
        st.erase(st.begin());
        int u = it.second;
        for (auto v : G[u]) {
            if (dist[v.first] > dist[u] + v.second) {
                st.erase({dist[v.first], v.first});
                dist[v.first] = dist[u] + v.second;
                st.insert({dist[v.first], v.first});
            }
        }
    }
    if (dist[n - 1] == infll) {
        cout << "-1\n";
        return;
    }
    cout << max(0ll, dist[n - 1] - p) << '\n';
}

int ans = infll;

bool used[N][N];

vector<int> s;

void rec (int where, int ost, int current, int mx, vector<int> &cnt) {
    if (time() > 0.9) {
        return;
    }
    if (where == n - 1) {
        ans = min(ans, current);
        return;
    }
    if (used[where][mx]) return;
    used[where][mx] = true;
    for (auto v : G[where]) {
        int c = lower_bound(all(s), w[v.first]) - s.begin();
        int next_mx = max(mx, c);
        if (used[v.first][mx]) continue;
        int was = ost;
        int can = 0;
        if (v.second > ost) {
            can = (v.second - ost + s[mx] - 1) / s[mx];
            ost += can * s[mx];
        }
        ost -= v.second;
        rec(v.first, ost, current + can, next_mx, cnt);
        ost = was;
    }
    used[where][mx] = false;
}

void solve_strange () {
    vector<int> used(n, false);
    s = w;
    sort(all(s));
    vector<int> t;
    vector<int> weights;
    rec(0, p, 0, lower_bound(all(s), w[0]) - s.begin(), used);
    cout << (ans == infll ? -1 : ans) << '\n';
}

void solve_greedy() {
    int mx = 0;
    int ans = 0;
    for (int i = 0; i < n - 1; i++) {
        mx = max(mx, w[i]);
        int need = G[i][0].second;
        if (p < need) {
            int can = (need - p + mx - 1) / mx;
            p += can * mx;
            ans += can;
        }
        p -= need;
    }
    cout << ans << '\n';
}

void solve() {
    read();
    if (g == 1) {
        solve_zero();
        return;
    }
    if (g == 2) {
        solve_greedy();
        return;
    }
    if (g == 3 || g == 0) {
        solve_strange();
        return;
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}
/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */