﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e17);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<vector<pair<ll, ll>>> g;
vector<ll> money;
ll n, m, p, type;


void solve0(istream& cinn, ostream& cout) {
	vector<ll> dp(n, INF);
	dp[0] = 0;
	set<pair<ll, ll>> s;
	s.emplace(dp[0], 0);

	while (!s.empty()) {
		auto [tt, v] = *s.begin();
		s.erase(s.begin());

		for (auto& [u, w] : g[v]) {
			if (dp[u] > dp[v] + w) {
				s.erase({ dp[u], u });
				dp[u] = dp[v] + w;
				s.emplace(dp[u], u);
			}
		}
	}

	if (dp[n - 1] == INF)
		cout << "-1\n";
	else
		cout << max(0ll, dp[n - 1] - p) << '\n';
}


void solve1(istream& cin, ostream& cout) {
	ll cnt = 0;
	ll x = money[0];
	for (ll i = 0; i + 1 < n; ++i) {
		x = max(x, money[i]);
		if (p < g[0][0].second) {
			ll buf = (g[0][0].second - p + x - 1) / x;
			p += buf * x;
			cnt += buf;
		}
		p -= g[0][0].second;
	}

	cout << cnt << '\n';
}



void solve(istream& cin, ostream& cout) {
	cin >> n >> m >> p >> type;
	money.resize(n);
	g.resize(n);
	for (auto& t : money)
		cin >> t;
	for (ll i = 0; i < m; ++i) {
		ll a, b, w;
		cin >> a >> b >> w;
		--a, --b;
		g[a].emplace_back(b, w);
	}

	if (type == 1)
		solve0(cin, cout);
	else if (type == 2)
		solve1(cin, cout);
}