#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <string>
#include <vector>
#include <climits>

#define sz(a) int((int)a.size())

//#define int long long

using namespace std;

struct Edge {
    int to, cost;
};

vector<vector<Edge>> G;
vector<int> w;
vector<int> d;
vector<bool> was;

void dfs(int v, int p) {
    was[v] = true;
//    cout << v << endl;
    for (Edge edge : G[v]) {
        if (!was[edge.to]) {
            int need = max(0, edge.cost - p);
            int length = ceil(1.0 * need / w[v]);
            //p += w[v] * length;
            d[edge.to] = d[v] + length;
            dfs(edge.to, p + (w[v] * length) - edge.cost);
        }
    }
}

void solve_for_tree(int n, int m, int p, int g) {
    G.resize(n);
    d.resize(n);
    was.resize(n, false);
    w.resize(n);
//    cout << "OK0" << endl;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
//    cout << "m = " << m << endl;
    for (int i = 0; i < m; ++i) {
        int a, b, cost;
        cin >> a >> b >> cost;
        a--;
        b--;
        G[a].push_back({b, cost});
//        cout << "i = " << i << endl;
    }
//    cout << "OK1" << endl;
    dfs(0, p);
    if (!was[n - 1]) {
        cout << -1;
    } else {
        cout << d[n - 1];
    }
//    for (auto el : d) {
//        cout << el << ' ';
//    }
}

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    if (m == n - 1) {
        solve_for_tree(n, m, p, g);
    }
}

int32_t main() {
//    freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}