#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include <bits/stdc++.h>

constexpr int64_t inf = 1e18;

struct Cum {
    int64_t cnt;
    int64_t mn;

    bool operator<(const Cum& other) const {
        return std::pair{cnt, -mn} < std::pair{other.cnt, -other.mn};
    }
};

void solve() {
    int n, m, p, g;
    std::cin >> n >> m >> p >> g;
    std::vector<int> w(n);
    for (int& i : w) {
        std::cin >> i;
    }
    std::vector<std::array<int, 3>> edg(m);
    for (auto& [u, v, w] : edg) {
        std::cin >> u >> v >> w;
        u--;
        v--;
    }

    std::vector<std::vector<int64_t>> dist(n, std::vector<int64_t>(n, inf));
    for (auto& [u, v, w] : edg) {
        dist[u][v] = std::min<int64_t>(dist[u][v], w);
    }

    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            const int64_t val = dist[i][k];
#pragma GCC ivdep
            for (int j = 0; j < n; j++) {
                // dist[i][j] = std::min(dist[i][j], dist[i][k] + dist[k][j]);
                dist[i][j] = std::min(dist[i][j], val + dist[k][j]);
            }
        }
    }

    if (dist[0][n - 1] == inf) {
        std::cout << "-1\n";
        return;
    }
    std::vector<int> ord(n);
    std::iota(ord.begin(), ord.end(), 0);
    std::sort(ord.begin() + 1, ord.end() - 1, [&](int a, int b) { return w[a] < w[b]; });

    std::vector<Cum> dp(n);
    for (int i = 0; i < n; i++) {
        dp[i] = {inf, -inf};
    }
    dp[0] = {0, p};

    for (int i = 0; i < n - 1; i++) {
        int a = ord[i];
        Cum cm = dp[a];
        for (int j = i + 1; j < n; j++) {
            int b = ord[j];
            int64_t len = dist[a][b];
            if (len < inf) {
                Cum cm2{cm.cnt, cm.mn - len};
                if (cm2.mn < 0) {
                    int64_t d = (-cm2.mn - 1) / w[a] + 1;
                    cm2.cnt += d;
                    cm2.mn += d * w[a];
                    assert(cm2.mn >= 0);
                }

                dp[b] = std::min(dp[b], cm2);
            }
        }
    }

    std::cout << dp[n - 1].cnt << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t = 1;
#ifdef LOCAL
    std::cin >> t;
#endif
    while (t--) {
        solve();
    }

    return 0;
}
