#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

#define int ll
const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res = res * a;
			}
			a = a * a;
			n /= 2;
		}
		return res;
	}

	mint rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}

	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}

	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}

	mint& operator/=(const mint& b) {
		(*this) *= b.rev();
		return *this;
	}

	mint operator+(const mint& b) const {
		return mint(*this) += b;
	}
	mint operator-(const mint& b) const {
		return mint(*this) -= b;
	}
	mint operator*(const mint& b) const {
		return mint(*this) *= b;
	}
	mint operator/(const mint& b) const {
		return mint(*this) /= b;
	}
};

const int maxn = 1000;
const int maxm = 140 * 100 + 1;
const int inf = 1e14;
int n, m, p, gr;
int g[maxn][maxn];
vector<pair<int, int>> t[maxn];
int dp[110][maxm + 10];
int w[maxn];
int used[maxn];

void dfs(int v) {
	used[v] = 1;
	for (auto& [u, s] : t[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
}

void solve1() {
	for (int k = 0; k < n; k++) {
		for (int v = 0; v < n; v++) {
			for (int u = 0; u < n; u++) {
				if (g[v][k] != inf && g[k][u] != inf) {
					g[v][u] = min(g[v][u], g[v][k] + g[k][u]);
				}
			}
		}
	}
	cout << max(0ll, g[0][n - 1] - p) << '\n';
}

void solve4() {
	for (int i = 0; i < n; i++) {
		for (int j = 0; j <= maxm; j++) {
			dp[i][j] = inf;
		}
	}
	dp[0][p] = 0;
	set<pair<int, pair<int, int>>> q;
	q.insert({ 0, {0, p} });
	while (!q.empty()) {
		int dist = (*q.begin()).first;
		int v = (*q.begin()).second.first;
		if (v == n - 1) {
			cout << dist << '\n';
			break;
		}
		int cost = (*q.begin()).second.second;
		q.erase(q.begin());
		if (dist != dp[v][cost]) continue;
		if (dp[v][min(maxm, cost + w[v])] > dp[v][cost] + 1) {
			dp[v][min(maxm, cost + w[v])] = dp[v][cost] + 1;
			q.insert({ dp[v][cost] + 1, {v, min(maxm, cost + w[v])} });
		}
		for (auto& [u, s] : t[v]) {
			if (s > cost) continue;
			if (dp[u][cost - s] > dp[v][cost]) {
				dp[u][cost - s] = dp[v][cost];
				q.insert({ dp[v][cost], {u, cost - s} });
			}
		}
	}
}

void solve() {
	cin >> n >> m >> p >> gr;
	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			g[i][j] = inf;
		}
	}
	for (int i = 0; i < m; i++) {
		int v, u, s;
		cin >> v >> u >> s;
		g[v - 1][u - 1] = min(s, g[v - 1][u - 1]);
		t[v - 1].push_back({ u - 1, s });
	}
	dfs(0);
	if (!used[n - 1]) {
		cout << "-1\n";
		return;
	}
	if (gr == 1) {
		solve1();
	}
	/*if (gr == 2) {
		solve2();
	}*/
	if (gr == 4 || gr == 0) {
		solve4();
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}