#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = 1e18;

vector<vector<pair<int, int>>> gr;
vector<vector<int>> d;

void dijkstra(int s) {
    priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>> q;
    q.emplace(0, s);
    d[s][s] = 0;
    while (!q.empty()) {
        auto [newd, v] = q.top();
        q.pop();
        if (newd < d[s][v])
            continue;
        for (auto [to, w] : gr[v]) {
            if (d[s][to] > newd + w) {
                d[s][to] = newd + w;
                q.emplace(newd + w, to);
            }
        }
    }
}

inline void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    gr = vector<vector<pair<int, int>>>(n);
    d = vector<vector<int>>(n, vector<int>(n, INF));
    vector<int> w(n);
    for (auto& i : w)
        cin >> i;
    vector<int> o;
    for (int i = 0; i < n; ++i) {
        if (w[i] >= w[0])
            o.push_back(i);
    }
    sort(o.begin(), o.end(), [&](int f, int s) {
        return w[f] < w[s];
    });
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        gr[a - 1].emplace_back(b - 1, s);
    }
    for (int i = 0; i < n; ++i)
        dijkstra(i);
    vector<pair<int, int>> dp(n, {INF, INF});
    dp[0] = {0, p};
    for (auto i : o) {
        pair<int, int> old = dp[i];
        for (int j = 0; j < n; ++j) {
            if (i == j || d[i][j] == INF)
                continue;
            dp[i].first += max(0, ((d[i][j] - dp[i].second) + w[i] - 1) / w[i]);
            dp[i].second += max(0, ((d[i][j] - dp[i].second) + w[i] - 1) / w[i]) * w[i] - d[i][j];
            if (dp[i].first < dp[j].first || dp[i].first == dp[j].first && dp[i].second > dp[j].second)
                dp[j] = dp[i];
            dp[i] = old;
        }
    }
    if (dp.back().first == INF)
        cout << -1 << '\n';
    else
        cout << dp.back().first << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
#ifdef LOCAL
    cin >> tests;
#endif
    for (int i = 1; i <= tests; ++i)
        solve();
}