#include <bits/stdc++.h>

#define ll long long
#define ull H
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

struct S{
	int v, cnt, dist;
};

struct cmp{
	bool operator()(const S& a, const S& b){
		return a.dist > b.dist;
	}
};

int main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
//	cin >> T;
	while (T--){
		int n, m, p, G;
		cin >> n >> m >> p >> G;
		vector<int> w(n + 1);
		for (int i = 1; i <= n; i++){
			cin >> w[i];
		}
		vector<vector<pair<int, int>>> g(n + 1);
		for (int i = 0; i < m; i++){
			int u, v, s;
			cin >> u >> v >> s;
			g[u].push_back({v, s});
		}
		if (G == 1){
			vector<ll> dist(n + 1, 1e18);
			priority_queue<pair<ll, int>> q;
			q.push({0, 1});
			dist[1] = 0;
			while (!q.empty()){
				pair<ll, int> t = q.top();
				q.pop();
				if (-t.first > dist[t.second]){
					continue;
				}
				int v = t.second;
				for (auto& [u, s] : g[v]){
					if (dist[u] > dist[v] + s){
						dist[u] = dist[v] + s;
						q.push({-dist[u], u});
					}
				}
			}
			if (dist[n] == 1e18){
				cout << -1 << "\n";
			} else {
				cout << max(0ll, dist[n] - p) << "\n";
			}
			continue;
		}
		if (G == 2){
			ll cur = p;
			ll mx = w[1];
			ll res = 0;
			for (int i = 2; i <= n; i++){
				ll s = g[i - 1][0].second;
				ll k = (max(0ll, (s - p)) + mx - 1) / mx;
				res += k;
				p += k * mx;
				p -= s;
				mx = max(mx, (ll)w[i]);
			}
			cout << res << "\n";
			continue;
		}
		if (G == 4){
			assert(n <= 100);
			int MAXSUM = 100 * n;
			vector<vector<int>> dist(n + 1, vector<int>(MAXSUM + 1, 1e9));
			if (p > MAXSUM){
				cout << 0 << "\n";
				continue;
			}
			dist[1][p] = 0;
			priority_queue<S, vector<S>, cmp> q;
			q.push({1, p, 0});
			while (!q.empty()){
				S t = q.top();
				q.pop();
				if (t.dist > dist[t.v][t.cnt]){
					continue;
				}
				int v = t.v;
				for (auto& [u, s] : g[v]){
					for (int j = (max(0, s - t.cnt) + w[v] - 1) / w[v], cntb = 0;
						 cntb <= 0; j++, cntb++){
						assert(t.cnt + j * 1ll * w[v] >= s);
						ll nwsum = t.cnt - s + j * 1ll * w[v];
						if (nwsum >= MAXSUM){
							cntb++;
						}
						nwsum = min(nwsum, (ll)MAXSUM);
						if (dist[u][nwsum] > dist[v][t.cnt] + j){
							dist[u][nwsum] = dist[v][t.cnt] + j;
							q.push({u, nwsum, dist[u][nwsum]});
						}
					}
				}
				if (t.cnt != MAXSUM){
					int nwsum = min(MAXSUM, t.cnt + w[v]);
					if (dist[v][nwsum] > dist[v][t.cnt] + 1){
						dist[v][nwsum] = dist[v][t.cnt] + 1;
						q.push({v, nwsum, dist[v][nwsum]});
					}
				}
			}
			int res = *min_element(all(dist[n]));
			if (res == 1e9){
				res = -1;
			}
			cout << res << "\n";
			continue;
		}
		if (G == 3 || G == 0){
			vector<vector<int>> mat(n + 1, vector<int>(n + 1, -1));
			for (int v = 1; v <= n; v++){
				for (auto& [u, s] : g[v]){
					mat[v][u] = s;
				}
			}
			for (int v = 1; v <= n; v++){
				for (auto& [u, s] : g[v]){
					mat[v][u] = min(mat[v][u], s);
				}
			}
			ll res = 1e18;
			for (int mask = 1; mask < (1 << n); mask++){
				vector<int> t;
				for (int i = 0; i < n; i++){
					if (mask & (1 << i)){
						t.push_back(1 + i);
					}
				}
				vector<int> order(t.size());
				for (int i = 0; i < t.size(); i++){
					order[i] = i;
				}
				do {
					vector<int> v(t.size());
					for (int i = 0; i < t.size(); i++){
						v[i] = t[order[i]];
					}
					bool good = 1;
					good &= (v[0] == 1);
					good &= (v[t.size() - 1] == n);
					for (int i = 0; i + 1 < t.size(); i++){
						good &= (mat[v[i]][v[i + 1]] != -1);
					}
					if (!good){
						continue;
					}
					ll cur = p;
					ll mx = w[v[0]];
					ll curres = 0;
					for (int i = 1; i < t.size(); i++){
						ll s = mat[v[i - 1]][v[i]];
						ll k = (max(0ll, (s - cur)) + mx - 1) / mx;
						curres += k;
						cur += k * mx;
						cur -= s;
						mx = max(mx, (ll)w[v[i]]);
					}
					res = min(res, curres);
				} while (next_permutation(all(order)));
			}
			if (res == 1e18){
				res = -1;
			}
			cout << res << "\n";
			continue;
		}
	}
	return 0;
}
