#include<bits/stdc++.h>

using namespace std;

struct edge
{
    long long ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

struct Point
{
    long long ch,br;
    Point(){};
    Point(long long chi, long long bri)
    {
        ch = chi;
        br = bri;
    }
};

const int maxn = 805;
int n,m,p,g;
int w[maxn];
int c[maxn];
long long sumc[maxn];
long long dp[maxn][maxn],sum[maxn][maxn];
unsigned long long d[maxn],inf = -1;
vector<edge>v[maxn];

void read()
{
    cin >> n >> m >> p >> g;
    for(int i=1;i<=n;i++) cin >> w[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        if(x+1==y) c[y] = z;
        v[x].push_back({y,z});
    }
}

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg] = 0;
    q.push({beg,0});
    edge e,nb;
    int sz;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                if(e.dist+nb.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
}

void solve1()
{
    dijkstra(1);
    if(d[n]==inf) cout << -1 << endl;
    else
    {
        if(p>=d[n]) cout << 0 << endl;
        else
        {
            long long res = p;
            res -= d[n];
            cout << (-res) << endl;
        }
    }
}

long long rec(int l, int r)
{
    if(dp[l][r]!=-1) return dp[l][r];
    if(l==r)
    {
        dp[l][r] = 0;
        return 0;
    }
    long long path,pom;
    if(l!=1)
    {
        if(dp[1][l]==-1)
        rec(1,l);
    }
    path = sumc[r] - sumc[l] - sum[1][l];
    if(path<0)
    {
        sum[l][r] += (-path);
        path = 0;
    }
    pom = path/w[l];
    if(path%w[l]) pom++;
    dp[l][r] = pom;
    sum[l][r] += pom*w[l]-path;
    for(int i=l+1;i<r;i++)
    {
        dp[l][r] = min(dp[l][r],rec(l,i) + rec(i,r));
    }
    return dp[l][r];
}

void solve2()
{
    for(int i=2;i<=n;i++)
    {
        if(p==0) break;
        if(p>=c[i])
        {
            p -= c[i];
            c[i] = 0;
        }
        else
        {
            c[i] -= p;
            p = 0;
        }
        sumc[i] = sumc[i-1] + c[i];
    }
    memset(dp,-1,sizeof(dp));
    cout << rec(1,n) << endl;
}

void solve()
{
    if(g==1) solve1();
    if(g==2) solve2();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
	return 0;
}

