#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

const int N = 5e5 + 7, MOD = 1e9 + 7;

#define int long long

pair<int, int> d[1000][1000];

struct Edge {
	int v, w;
};

int w[N], n, p, m, g;

vector<Edge> edges[N];

int divd(int a, int b) {
	if (a % b == 0) {
		return a / b;
	}
	return a / b + 1;
}

void Dijkstra(){
	for (int i = 1; i <= n; i++) {
		for(int j = 1; j <= n; j++)
			d[i][j] = {1e15, 0};
	}
	d[1][1] = { 0,-p };
	set < pair< pair<int, int>, pair<int, int> > > s;
	s.clear();
	for (int i = 1; i <= n; i++) {
		for (int j = 1; j <= n; j++) {
			s.insert({ d[i][j], {i,j} });
		}
	}
	while (!s.empty()) {
		auto cur = *s.begin();
		s.erase(cur);
		for (auto e : edges[cur.second.first]) {
			int mn_needed = e.w;
			int mn_have = cur.first.second * -1;
			int extradays = divd(mn_needed - mn_have, w[cur.second.second]);
			mn_have += extradays * w[cur.second.second];
			int new_city = e.v;
			int newmax = e.v;
			if (w[newmax] <= w[cur.second.second]) {
				newmax = cur.second.second;
			}
			pair<int, int > newpair = d[cur.second.first][cur.second.second];
			newpair.first += extradays;
			newpair.second = (mn_have - mn_needed) * -1;
			if (d[new_city][newmax] > newpair) {
				s.erase({ d[new_city][newmax], {new_city, newmax} });
				d[new_city][newmax] = newpair;
				s.insert({ d[new_city][newmax], {new_city, newmax} });
			}
		}
	}
}





signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n >> m >>p >>  g;
	for (int i = 1; i <= n; i++) {
		cin >> w[i];
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		edges[u].push_back({ v,w });
	}
	Dijkstra();
	long long per = 1e15;
	for (int mx_city = 1; mx_city <= n; mx_city++) {
		per = min(per, d[n][mx_city].first);
	}
	if (per == 1e15) {
		cout << -1;
		return 0;
	}
	cout << per;
}