#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef vector<vpi> vvpi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;
typedef set<int> si;
typedef multiset<int> msi;
typedef set<pi> spi;
typedef multiset<pi> mspi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef vector<bool> vb;

template<typename T> bool minravno(T& a, const T& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> bool maxravno(T& a, const T& b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename T> void print(const T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}
template<typename T> void sort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void rsort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
	reverse(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void reverse(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	reverse(a.begin() + i, a.begin() + (j + 1));
}

mt19937 rnd(228);
const int INF = 1e18;
int n, m, p, g;

void solve1() {
	vi w(n + 1);
	input(w, 1);
	vti e;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		e.push_back({ u, v, w });
	}
	shuffle(all(e), rnd);
	vi d(n + 1, INF);
	d[1] = 0;
	bool flag = true;
	while (flag) {
		flag = false;
		for (auto [u, v, w] : e) {
			if (minravno(d[v], d[u] + w))
				flag = true;
		}
	}
	if (d[n] == INF)
		cout << "-1";
	else
		cout << max(0ll, d[n] - p);
}

void solve2() {
	vi w(n + 1);
	input(w, 1);
	vi e(n);
	for (int i = 1; i <= m; ++i) {
		int u, v;
		cin >> u >> v >> e[i];
	}
	int ans = 0;
	int mx = w[1];
	for (int i = 1; i < n; ++i) {
		maxravno(mx, w[i]);
		if (e[i] > p) {
			ans += (e[i] - p + mx - 1) / mx;
			p += (e[i] - p + mx - 1) / mx * mx;
		}
		p -= e[i];
	}
	cout << ans;
}

void solve3() {

}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m >> p >> g;
	if (g == 1)
		solve1();
	else if (g == 2)
		solve2();
	else
		solve3();


	return 0;
}