#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef vector<ll> vll;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const ll inf = 1e12 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

ll dijkstra(const vvpll &g) {
    int n = g.size();

    vll d(n, inf);
    d[0] = 0;

    vb used(n, false);

    set<pll> q;
    q.insert({0, 0});

    while (q.size() != 0) {
        int v = q.begin()->ss;
        q.erase(q.begin());

        used[v] = true;

        for (pll e : g[v]) {
            ll to = e.ff;
            ll w = e.ss;

            if (!used[to] && d[to] > d[v] + w) {
                auto it = q.find({d[to], to});

                if (it != q.end()) {
                    q.erase(it);
                }

                d[to] = d[v] + w;
                q.insert({d[to], to});
            }
        }
    }

    return d[n-1];
}


void dfs(const vvpll &g, const vll &w, int v, ll p, ll d, ll &ans) {
    int n = g.size();


    if (v == n - 1) {
        ans = d;
        return;
    }

    for (pll e : g[v]) {
        int to = e.ff;
        int c = e.ss;

        ll d_plus = (c - p + w[v] - 1) / w[v];
        ll p_new = d_plus * w[v] + p - c;

        dfs(g, w, to, p_new, d + d_plus, ans);
    }
}


void solve() {
    int n, m, p, T;
    cin >> n >> m >> p >> T;

    vll w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }

    vvpll g(n);
    for (int i = 0; i < m; i++) {
        int v, u, s;
        cin >> v >> u >> s;
        v--;
        u--;

        g[v].push_back({u, s});
    }

    if (T == 1) {
        ll ans = dijkstra(g);

        if (ans == inf) {
            ans = -1;
        }

        cout << ans << '\n';
    } else if (T == 2) {
        ll ans = -1;
        dfs(g, w, 0, p, 0, ans);

        cout << ans << '\n';
    } else {
        cout << -1 << '\n';
    }
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}

