//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,tune=native")

#include <queue>
#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

const ll inf = 1e16;

#define int long long

signed main() {
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n, m, gr;
    ll p;
    cin >> n >> m >> p >> gr;
    if (gr == 1) {
        vector<ll> w(n);
        for (int i = 0; i < n; ++i) {
            cin >> w[i];
            assert(w[i] == 1);
        }
        vector<vector<pair<int, ll>>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b, s;
            cin >> a >> b >> s;
            --a;
            --b;
            g[a].push_back({b, s});
        }
        priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> q;
        vector<ll> d(n, inf);
        d[0] = 0;
        q.push({0, 0});
        while (!q.empty()) {
            auto [ww, v] = q.top();
            q.pop();
            if (d[v] != ww) {
                continue;
            }
            for (auto [u, s]: g[v]) {
                if (d[u] > d[v] + s) {
                    d[u] = d[v] + s;
                    q.push({d[u], u});
                }
            }
        }
//        for (int i = 0; i < n; ++i) {
//            cout << d[i] << ' ';
//        }
//        cout << endl;
        if (d[n - 1] > 1e12) {
            cout << -1 << endl;
            return 0;
        }
        cout << max((ll) 0, d[n - 1] - p) << endl;
        return 0;
    }
    if (gr == 2) {
        vector<ll> w(n);
        for (int i = 0; i < n; ++i) {
            cin >> w[i];
        }
        vector<ll> s(m);
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin >> a >> b >> s[i];
        }
        vector<ll> st;
        ll mx = 1;
        int cnt = 0;
        for (int i = 0; i < n - 1; ++i) {
            if (mx < w[i]) {
                mx = w[i];
            }
            ll need = max((ll) 0, s[i] - p);
            int x = (need + mx - 1) / mx;
            cnt += x;
            p = p + x * mx - s[i];
        }
        cout << cnt << endl;
        return 0;
    }
    if (gr == 3 || gr == 0) {
        vector<ll> w(n);
        for (int i = 0; i < n; ++i) {
            cin >> w[i];
        }
        vector<vector<int>> d(n, vector<int>(n, inf));
        for (int i = 0; i < m; ++i) {
            int a, b, s;
            cin >> a >> b >> s;
            --a;
            --b;
            d[a][b] = min(d[a][b], s);
        }
        vector<int> order(n - 1);
        iota(order.begin(), order.end(), 1);
        int mn = inf;
        int p0 = p;
        do {
            p = p0;
            ll mx = 1;
            int cnt = 0;
            int now = 0;
            for (int i = 0; i < n - 1; ++i) {
                if (mx < w[now]) {
                    mx = w[now];
                }
                int s = d[now][order[i]];
                ll need = max((ll) 0, s - p);
                int x = (need + mx - 1) / mx;
                cnt += x;
                p = p + x * mx - s;
                now = order[i];
                if (now == n - 1) {
                    break;
                }
            }
            mn = min(mn, cnt);
        } while (next_permutation(order.begin(), order.end()));
        if (mn > 1e12) {
            cout << -1 << endl;
            return 0;
        }
        cout << mn << endl;
    }

#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}