#define _CRT_SECURE_NO_WARNINGS
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#include <cmath>
#include <deque>
#include <set>
#include <map>
using namespace std;

using ll = long long;

const ll LLINF = 2e18;

ll n, m, p, group;
vector<ll> w;
vector<vector<pair<ll, ll>>> graph;

ll dijsktra1() {
	vector<ll> dst(n, LLINF);
	set<pair<ll, ll>> pq;
	dst[0] = 0;
	pq.insert({ 0, 0 });
	while (!pq.empty()) {
		auto [s, u] = *pq.begin();
		pq.erase(pq.begin());
		for (auto [v, ds] : graph[u]) {
			if (s + ds < dst[v]) {
				pq.erase({ dst[v], v });
				dst[v] = s + ds;
				pq.insert({ dst[v], v });
			}
		}
	}
	return dst[n - 1] == LLINF ? -1 : dst[n - 1];
}

void solve1() {
	ll c = dijsktra1();
	if (c == -1)
		cout << "-1\n";
	else
		cout << max(0ll, c - p) << "\n";
}

struct Edge {
	ll u, v, s;
};

vector<bool> vis;
vector<Edge> path;
ll dfs2(int u, int t) {
	vis[u] = true;
	if (u == t) {
		return 0;
	}
	for (auto [v, s] : graph[u]) {
		if (vis[v])
			continue;
		ll r = dfs2(v, t);
		if (r != -1) {
			path.push_back({ u, v, s });
			return r + s;
		}
	}
	return -1;
}

void solve2() {
	vis.assign(n, false);
	path.clear();
	dfs2(0, n - 1);
	if (!vis[n - 1]) {
		cout << "-1\n";
		return;
	}
	reverse(path.begin(), path.end());
	ll left = p;
	ll maxw = w[0];
	ll res = 0;
	for (int i = 0; i < path.size(); ++i) {
		if (left < path[i].s) {
			ll k = (path[i].s - left + maxw - 1) / maxw;
			res += k;
			left += maxw * k;
		}
		left -= path[i].s;
		maxw = max(maxw, w[path[i].v]);
	}
	cout << res << "\n";
}

vector<bool> cur;
vector<vector<Edge>> paths;
vector<Edge> curPath;

void bfs3(int u, int t) {
	cur[u] = true;
	if (u == t) {
		paths.push_back(curPath);
		cur[u] = false;
		return;
	}
	for (auto [v, s] : graph[u]) {
		if (cur[v]) {
			continue;
		}
		curPath.push_back({ u, v, s });
		bfs3(v, t);
		curPath.pop_back();
	}
	cur[u] = false;
}


void solve3() {
	vis.assign(n, false);
	path.clear();
	dfs2(0, n - 1);
	if (!vis[n - 1]) {
		cout << "-1\n";
		return;
	}

	vector<vector<ll>> matrix(n, vector<ll>(n, -1));
	for (int u = 0; u < n; ++u) {
		for (auto [v, s] : graph[u]) {
			if (matrix[u][v] == -1 || s < matrix[u][v])
				matrix[u][v] = s;
		}
	}

	graph.assign(n, vector<pair<ll, ll>>());

	for (int u = 0; u < n; ++u) {
		for (int v = 0; v < n; ++v) {
			if (matrix[u][v] == LLINF)
				continue;
			graph[u].push_back({ v, matrix[u][v] });
		}
	}

	cur.assign(n, false);
	paths.clear();
	curPath.clear();
	bfs3(0, n - 1);
	ll totalRes = LLINF;
	for (auto& cp : paths) {
		ll left = p;
		ll maxw = w[0];
		ll res = 0;
		for (int i = 0; i < cp.size(); ++i) {
			if (left < cp[i].s) {
				ll k = (cp[i].s - left + maxw - 1) / maxw;
				res += k;
				left += maxw * k;
			}
			left -= cp[i].s;
			maxw = max(maxw, w[cp[i].v]);
		}
		totalRes = min(totalRes, res);
	}
	if (paths.empty())
		cout << "-1\n";
	else
		cout << totalRes << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	//int t;
	//cin >> t;
	//while (t--) {
	//	cin >> n >> m >> p >> group;
	//	w.resize(n);
	//	for (int i = 0; i < n; ++i) {
	//		cin >> w[i];
	//	}
	//	graph.assign(n, vector<pair<ll, ll>>());
	//	for (int i = 0; i < m; ++i) {
	//		ll u, v, s;
	//		cin >> u >> v >> s;
	//		u--, v--;
	//		graph[u].push_back({ v, s });
	//	}
	//	if (n <= 10)
	//		solve3();
	//	else if (group == 1)
	//		solve1();
	//	else
	//		solve2();
	//}

	cin >> n >> m >> p >> group;
	w.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	graph.assign(n, vector<pair<ll, ll>>());
	for (int i = 0; i < m; ++i) {
		ll u, v, s;
		cin >> u >> v >> s;
		u--, v--;
		graph[u].push_back({ v, s });
	}
	if (group == 1)
		solve1();
	else if (group == 2)
		solve2();
	else
		solve3();

	//int t;
	//cin >> t;
	//while (t--) {
	//	solve();
	//}
}