#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

vector<vector<pair<int, ll>>> g;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<ll> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];

    g.resize(n);
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        g[u].emplace_back(v, s);
    }

    if (group == 1) {
        priority_queue<pair<ll, int>, vector<pair<ll, int>>, greater<pair<ll, int>>> pq;
        vector<ll> dist(n, 1e18);
        dist[0] = 0;
        pq.push({0, 0});
        while (!pq.empty()) {
            auto [d, v] = pq.top();
            pq.pop();
            if (dist[v] != d) continue;

            for (auto [u, s] : g[v]) {
                if (dist[v] + s < dist[u]) {
                    dist[u] = dist[v] + s;
                    pq.push({dist[u], u});
                }
            }
        }

        if (dist[n - 1] == 1e18) {
            cout << -1;
        } else {
            cout << max(0LL, dist[n - 1] - p);
        }
    } else if (group == 2) {
        ll ans = 0;
        ll mx = w[0];
        for (int i = 0; i < n - 1; i++) {
            ll cur = g[i][0].second;
            if (p < cur) {
                int need = cur - p;
                int cnt = (need - 1) / mx + 1;
                ans += cnt;
                p += mx * cnt;
            }
            p -= cur;
            mx = max(mx, w[i + 1]);
        }
        cout << ans;
    } else if (group == 0 || group == 3) {
        vector<vector<ll>> mg(n, vector<ll>(n, 1e18));
        for (int v = 0; v < n; v++) {
            for (auto [u, s] : g[v]) {
                mg[v][u] = min(mg[v][u], s);
            }
        }


        vector<vector<pair<ll, ll>>> dp(n, vector<pair<ll, ll>>(n, {1e18, -1}));
        dp[0][0] = {0, p};
        for (int _ = 0; _ < 10000; _++) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    if (dp[i][j].first == 1e18) continue;

                    for (int k = 0; k < n; k++) {
                        ll e = mg[i][k];
                        if (e == 1e18) continue;

                        auto [ans, have] = dp[i][j];
                        if (have < e) {
                            int need = e - have;
                            int cnt = (need - 1) / w[j] + 1;
                            ans += cnt;
                            have += w[j] * cnt;
                        }
                        have -= e;

                        int mx = j;
                        if (w[k] > w[j]) {
                            mx = k;
                        }

                        if (ans < dp[k][mx].first || ans == dp[k][mx].first && have > dp[k][mx].second) {
                            dp[k][mx] = {ans, have};
                        }
                    }
                }
            }
        }

        ll ans = 1e18;
        for (int i = 0; i < n; i++) ans = min(ans, dp[n - 1][i].first);
        if (ans == 1e18) {
            cout << -1 << '\n';
        } else {
            cout << ans << '\n';
        }
    }

    return 0;
}