#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1000000007;

const int maxn = 800;

int dist[maxn][maxn];

void solve() {
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dist[i][j] = INF64;
        }
    }
    for (int i = 0; i < n; i++) {
        dist[i][i] = 0;
    }
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        if (c < dist[a][b]) {
            g[a].emplace_back(b, c);
            dist[a][b] = c;
        }
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    vector<pair<int, int>> dp(n, {INF64, -INF64});
    vector<pair<int, int>> s;
    for (int i = 0; i < n; i++) {
        s.emplace_back(w[i], i);
    }
    sort(all(s));
    dp[0] = {0, p};
    for (int i = 0; i < n; i++) {
        int x = s[i].Y;
        for (int j = 0; j < i; j++) {
            int y = s[j].Y;
            if (dist[y][x] != INF64) {
                pair<int, int> now;
                if (dp[y].Y >= dist[y][x]) {
                    now = {dp[y].X, dp[y].Y - dist[y][x]};
                } else {
                    int need = dist[y][x] - dp[y].Y;
                    if (need % w[y] == 0) {
                        now = {dp[y].X + need / w[y], 0};
                    } else {
                        now = {dp[y].X + need / w[y] + 1, w[y] - need % w[y]};
                    }
                }
                if (dp[x].X > now.X || (dp[x].X == now.X && dp[x].Y < now.Y)) {
                    dp[x] = now;
                }
            }
        }
    }
    int ans = INF64;
    for (int i = 0; i < n - 1; i++) {
        if (dist[i][n - 1] != INF64) {
            ans = min(ans, dp[i].X + (max(0LL, dist[i][n - 1] - dp[i].Y) + w[i] - 1) / w[i]);
        }
    }
    if (ans == INF64) {
        cout << -1 << '\n';
    } else {
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}