#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <set>
#include <random>
#include <time.h>

using namespace std;
mt19937 rnd(time(0));

typedef long long ll;
typedef vector<ll> vll;
typedef vector<vector<pair<int, ll>>> graph;

const ll INF = 8e18;


vector<int> used;
vector<ll> w;
vector<vector<pair<int, ll>>> g;
set<pair<ll, int>> curc;

ll ans = INF;
void dfs(int v, ll p, ll res) {
	if (v == g.size() - 1) {
		ans = min(ans, res);
		return;
	}
	used[v] = 1;
	curc.insert({ -w[v], v });
	for (auto [u, len] : g[v]) {
		if (used[u] != 1) {
			ll np = p, nres = res;
			if (p < len) {
				ll c = -curc.begin()->first;
				ll need = len - p;
				ll resplus = (need + c - 1) / c;
				np += resplus * c;
				nres += resplus;
			}
			np -= len;
			dfs(u, np, nres);
		}
	}
	curc.erase({ -w[v], v });
	used[v] = 2;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	ll n, m, p, f;
	cin >> n >> m >> p >> f;
	w.resize(n);
	g.resize(n);
	vector<vector<ll>> gm(n, vector<ll>(n, INF));
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	for (int i = 0; i < m; ++i) {
		ll u, v, c;
		cin >> u >> v >> c;
		--u; --v;
		gm[u][v] = min(gm[u][v], c);
	}
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (gm[i][j] != INF)
				g[i].push_back({ j, gm[i][j] });
		}
	}
	if (f == 2) {
		dfs(0, p, 0);
		if (ans == INF)
			cout << -1 << "\n";
		else
			cout << ans << "\n";
	} else {
		vector<ll> d(n, INF);
		set<pair<ll, int>> s;
		d[0] = 0;
		s.insert({ d[0], 0 });
		while (!s.empty()) {
			int v = s.begin()->second;
			s.erase(s.begin());
			for (auto [u, len] : g[v]) {
				if (d[v] + len < d[u]) {
					s.erase({ d[u], u });
					d[u] = d[v] + len;
					s.insert({ d[u], u });
				}
			}
		}
		if (d[n - 1] == INF)
			cout << -1 << "\n";
		else
			cout << max(0ll, d[n - 1] - p) << "\n";
	}
}