#include <iostream>
#include <vector>
#include <bitset>
#include <algorithm>
//#include <iomanip>
//#include <map>
//#include <random>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/rope>

using namespace std;
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
//mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll))
        end_char = ' ';
    if (typeid(T) == typeid(ld))
        end_char = '\t';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */
struct Edge {
    int v;
    ll w;
    Edge(int _v, ll _w): v(_v), w(_w) {}
};

const ll INF = 2e18;

void group1(int n, int m, int p) {
    vector<ll> w(n);
    cin >> w;
    vector<vector<Edge>> g(n);
    for (int i = 0; i < m; ++i) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        --a; --b;
        g[a].emplace_back(b, c);
    }
    vector<ll> d(n, INF);
    vector<bool> used(n, false);
    d[0] = 0;
    for (int i = 0; i < n; ++i) {
        ll mn = INF;
        int v = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && mini(mn, d[j]))
                v = j;
        }
        if (v == -1)
            break;
        used[v] = true;
        for (Edge e :g[v]) {
            mini(d[e.v], d[v] + e.w);
        }
    }
    if (d[n - 1] == INF)
        cout << -1;
    else
        cout << max(0ll, d[n - 1] - p);
    exit(0);
}

void group2(int n, int m, int p) {
    vector<ll> w(n);
    cin >> w;
    ll res = 0;
    ll money = p;
    ll mx = 0;
    for (int i = 0; i < n - 1; ++i) {
        int a, b;
        ll c;
        cin >> a >> b >> c;
        maxi(mx, w[i]);
        if (c <= money) {
            money -= c;
            continue;
        }
        ll need = c - money;
        ll con = (need + mx - 1) / mx;
        res += con;
        money += con * mx;
        money -= c;
    }
    cout << res;
    exit(0);
}

uint get_bit(uint mask, int i) {
    return (mask & (1 << i)) >> i;
}

ll g_ans = -1;

bitset<12> used;

void dfs(int v, const vector<vector<Edge>>& g, ll money,
       ll mx, ll res, const vector<ll>& w) {
    if (g_ans != -1 && res >= g_ans) {
        return;
    }
    if (v + 1 == g.size()) {
        g_ans = res;
        return;
    }
    maxi(mx, w[v]);
    used[v] = true;
    for (Edge e :g[v]) {
        if (used[e.v])
            continue;
        ll con = 0;
        if (e.w > money) {
            con = ((ll) e.w - money + mx - 1) / mx;
        }
        dfs(e.v, g, money + con * mx - e.w, mx, res + con, w);
    }
    used[v] = false;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef DUDE
    freopen("input.txt", "r", stdin);
#endif
    int n, m, group;
    ll p;
    cin >> n >> m >> p >> group;
    if (group == 1) {
        group1(n, m, p);
    }
    else if (group == 2) {
       group2(n, m, p);
    }
    else {
        vector<ll> w(n);
        cin >> w;
        vector<vector<Edge>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            ll c;
            cin >> a >> b >> c;
            --a; --b;
            g[a].emplace_back(b, c);
        }
        dfs(0, g, p, 0, 0, w);
        cout << g_ans;
    }
    return 0;
}
