#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define endl '\n'
#define len(a) ll(a.size())

// author: @cot-in

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

const ll linf = 1e18;

ll dijkstra(ll n, vector<vector<pair<ll, ll>>> &g) {
    vector<ll> dist(n, linf);
    set<pair<ll, ll>> q;
    dist[0] = 0;
    q.insert({0, 0});
    while (!q.empty()) {
        ll v = q.begin()->second;
        q.erase(q.begin());
        for (auto [u, cost]: g[v]) {
            if (dist[u] > dist[v] + cost) {
                q.erase({dist[u], u});
                dist[u] = dist[v] + cost;
                q.insert({dist[u], u});
            }
        }
    }
//    for (auto el: dist) {
//        cout << el << ' ';
//    }
//    cout << endl;
    if (dist[n - 1] == linf) {
        cout << -1;
        exit(0);
    }
    return dist[n - 1];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), fin();
    ll n, m, p, q;
    cin >> n >> m >> p >> q;
    vector<ll> w(n);
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < n; i++)
        cin >> w[i];
    while (m--) {
        ll v, u, cost;
        cin >> v >> u >> cost;
        v--;
        u--;
        g[v].push_back({u, cost});
    }
    cout << max(0ll, dijkstra(n, g) - p);
    return 0;
}