#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

int n, m, p;
vector<int> w;
vector<vector<pair<int, ll>>> g;

void solve1() {
    vector<ll> d(n, 1e18);
    vector<int> used(n);
    d[0] = 0;
    while (true) {
        int mn = -1;
        for (int i = 0; i < n; i++) {
            if (!used[i] && (mn == -1 || d[i] < d[mn])) mn = i;
        }
        if (mn == -1) break;

        used[mn] = 1;
        for (auto [to, c] : g[mn]) {
            d[to] = min(d[to], d[mn] + c);
        }
    }

    if (d[n - 1] == 1e18) cout << -1;
    else cout << d[n - 1] - p;
}


int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int G;
    cin >> n >> m >> p >> G;
    w.resize(n);
    for (int& x : w) cin >> x;
    g.resize(n);

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a - 1].emplace_back(b - 1, c);
    }

    if (G == 1) solve1();

}