#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

int n, m, p;
vector<int> w;
vector<vector<pair<int, ll>>> g;

void solve1() {
    vector<ll> d(n, 1e18);
    d[0] = 0;
    while (true) {
        bool is = false;
        for (int i = 0; i < n; i++) {
            for (auto [to, c] : g[i]) {
                if (d[to] > d[i] + c) {
                    d[to] = d[i] + c;
                    is = true;
                }
            }
        }
        if (!is) break;
    }

    if (d[n - 1] == 1e18) cout << -1;
    else cout << max(0LL, d[n - 1] - p);
}

void solve4() {
    const ll MX = 300000;
    vector<vector<ll>> dp(n, vector<ll>(MX + 1, 1e18));
    dp[0][p] = 0;
    while (true) {
        bool is = false;
        for (int v = 0; v < n; v++) {
            for (ll x = 0; x <= MX; x++) {
                for (auto [to, c] : g[v]) {
                    ll need = max(0LL, c - x) / w[v] + (bool)(max(0LL, c - x) % w[v]);
                    for (ll j = need; x + j * w[v] - c <= MX; j++) {
                        if (x + j * w[v] - c <= MX && dp[to][x + j * w[v] - c] > dp[v][x] + j) {
                            dp[to][x + j * w[v] - c] = dp[v][x] + j;
                            is = true;
                        }
                    }
                }
            }
        }
        if (!is) break;
    }

    ll mn = 1e18;
    for (int i = 0; i <= MX; i++) {
        mn = min(mn, dp[n - 1][i]);
    }

//    for (int i = 0; i < n; i++) {
//        for (int x = 0; x <= 30; x++) {
//            if (dp[i][x] != 1e9) cout << i << " " << x << ": " << dp[i][x] << "\n";
//        }
//        cout << "\n";
//    }

    if (mn == 1e18) cout << -1;
    else cout << mn;
}

void solve2() {
    vector<vector<int>> layers;
    vector<int> used(n);
    queue<pair<int, int>> q;
    q.emplace(0, 0);
    used[0] = 1;
    while (!q.empty()) {
        auto [v, l] = q.front();
        q.pop();
        while (layers.size() <= l) layers.emplace_back();
        layers[l].push_back(v);

        for (auto [to, v] : g[v]) {
            if (!used[to]) {
                q.emplace(to, l + 1);
                used[to] = 1;
            }
        }
    }

    vector<pair<ll, ll>> dp(n);
}

void solve3() {
    vector<pair<ll, ll>> dp(n, {1e18, 0});
    dp[0] = {0, p};
    while (true) {
        bool is = false;
        for (int v = 0; v < n; v++) {
            for (auto [to, c] : g[v]) {
                ll need = max(0LL, c - dp[v].second) / w[v] + (bool)(max(0LL, c - dp[v].second) % w[v]);
                if (dp[to].first - dp[to].second / w[to] > dp[v].first + need - (dp[v].second + need * w[v] - c) / w[to]) {
                    dp[to].first = dp[v].first + need;
                    dp[to].second = dp[v].second + need * w[v] - c;
                }
//                if (dp[to].first > dp[v].first + need ||
//                    (dp[to].first == dp[v].first + need && dp[to].second < dp[v].second + need * w[v] - c)) {
//                    dp[to].first = dp[v].first + need;
//                    dp[to].second = dp[v].second + need * w[v] - c;
//                }
            }
        }
        if (!is) break;
    }

    for (int i = 0; i < n; i++) {
        cout << dp[i].first << " " << dp[i].second << "\n";
    }

    if (dp[n - 1].first == 1e18) cout << -1;
    else cout << dp[n - 1].first;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    int G;
    cin >> n >> m >> p >> G;
    w.resize(n);
    for (int& x : w) cin >> x;
    g.resize(n);

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a - 1].emplace_back(b - 1, c);
    }

    if (G == 1) solve1();
    else solve4();

}