#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;

ll n;
ll ans = -1;

void gen(vector<int>&used, ll u, ll mx, ll p, ll res, vector<vector<ll>>&gr, vector<ll>& w) {
	if (u == n-1) {
		if (ans == -1) {
			ans = res;
		}
		else {
			ans = min(ans, res);
		}
	}
	else {
		for (ll v = 0; v < n; ++v) {
			if (!used[v] && gr[u][v] != -1) {
				used[v] = 1;
				ll cnt = 0;
				if (p < gr[u][v]) {
					cnt = (gr[u][v] - p - 1 + mx) / mx;
				}ll o = p - gr[u][v];
				o += cnt * mx;
				gen(used, v, max(mx, w[v]), o, res + cnt, gr, w);
				used[v] = 0;
			}
		}
	}
}

void dfs(int u, vector<bool>& used, vector<vector<pair<ll, ll>>>& gr) {
	used[u] = 1;
	for (auto v : gr[u]) {
		if (!used[v.first]) {
			dfs(v.first, used, gr);
		}
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll m, p, g;
	cin >> n >> m >> p >> g;
	vector<ll> w(n);
	for (ll i = 0; i < n; ++i) {
		cin >> w[i];
	}
	vector<vector<pair<ll, ll>>> gr(n);
	for (ll i = 0; i < m; ++i) {
		ll a, b;
		ll s;
		cin >> a >> b >> s;
		--a;
		--b;
		gr[a].push_back({ b, s });
	}
	if (g == 1) {
		vector<ll> dst(n, -1);
		dst[0] = 0;
		set<pair<ll, ll>> st = { {0, 0} };
		vector<bool> used(n);
		while (!st.empty()) {
			ll u = (*st.begin()).second;
			st.erase(st.begin());
			used[u] = 1;
			for (auto v : gr[u]) {
				if (dst[v.first] == -1 || dst[v.first] > dst[u] + v.second) {
					if (dst[v.first] != -1) {
						st.erase({ dst[v.first], v.first });
					}
					dst[v.first] = dst[u] + v.second;
					st.insert({ dst[v.first], v.first });
				}
			}
		}
		if (dst[n - 1] == -1) {
			cout << -1;
		}
		else {
			cout << max(0ll, dst[n - 1] - p);
		}
	}
	else if (g == 2) {
		ll mx = w[0];
		ll res = 0;
		for (ll i = 1; i < n; ++i) {
			ll k = gr[i - 1][0].second;
			if (k > p) {
				res += (k - p + mx - 1) / mx;
				p += (k - p + mx - 1) / mx * mx;
			}
			p -= k;
			mx = max(w[i], mx);
		}
		cout << res;
	}
	else {
		vector<int> used(n);
		used[0] = 1;
		vector<vector<ll>> gr1(n, vector<ll>(n, -1));
		for (ll i = 0; i < n; ++i) {
			for (auto j : gr[i]) {
				if (gr1[i][j.first] == -1) {
					gr1[i][j.first] = j.second;
				}
				else {
					gr1[i][j.first] = min(j.second, gr1[i][j.first]);
				}
			}
		}
		gen(used, 0, w[0], p, 0, gr1, w);
		vector<bool> used1(n);
		dfs(0, used1, gr);
		if (used1[n - 1] && ans == -1) {
			int d = 0;
			cout << 5 / d;
		} 
		cout << ans;
	}
	return 0;
}