#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

const long long INF = 1e15;

int n, m, p, gr;
long long w[100000];

vector<vector<pair<long long, int>>> g(100000);
long long g2[801][801];

void solve1(){

    vector<int> d(n, INF);
    set<pair<long long, int>> q;
    d[0] = 0;
    for(int i = 0; i < n; i ++){
        q.insert({d[i], i});
    }

    while(!q.empty()){
        pair<long long, int> v = *q.begin();
        q.erase(q.begin());

        for(auto j : g[v.second]){
            int u = j.first;
            long long to = j.second;
            if(d[u] > v.first + to){
                q.erase({d[u], u});
                d[u] = v.first + to;
                q.insert({d[u], u});
            }
        }
    }

    if(d[n - 1] == INF){
        cout << -1 << "\n";
        return;
    }
    cout<< d[n - 1] << "\n";

}

void solve2(){

    int ans = 0;
    for(int i = 0; i < n; i ++){
        long long sum = g2[i][i + 1];
        int j = i + 1;
        while(j < n && w[j] <= w[i]){
            j ++;
            sum += g2[j - 1][j];
        }

        int kol = sum / w[i];
        if(sum % w[i] != 0)
            kol += 1;

        i = j - 1;
        ans += kol;
    }

    cout<< ans << "\n";

}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> p >> gr;
    for(int i = 0; i < n; i ++)
        cin >> w[i];

    for(int i = 0; i < m; i ++){
        int a, b, s;
        cin >> a >> b >> s;

        g[a - 1].push_back({b - 1, s});

        g2[a - 1][b - 1] = s;
    }

    if(gr == 1)
        solve1();
    if(gr == 2)
        solve2();

  return 0;
}
