#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<ll> arr;
vector<vector<pair<ll, ll>>> graph;

const ll INF = 1e16;

void solve() {
    ll n, m, p, g;
    cin >> n >> m >> p >> g;

    arr.resize(n + 1);
    graph.resize(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    while (m--) {
        ll a, b, s;
        cin >> a >> b >> s;
        graph[a].push_back({b, s});
    }

    if (g == 1) {
        set<pair<ll, ll>> s;
        vector<ll> dist(n + 1, INF);
        dist[1] = 0;
        s.insert({0, 1});
        while (!s.empty()) {
            auto now = *s.begin();
            s.erase(s.begin());
            if (dist[now.second] != now.first) {
                continue;
            }

            for (auto x: graph[now.second]) {
                if (dist[x.first] > dist[now.second] + x.second) {
                    dist[x.first] = dist[now.second] + x.second;
                    s.insert({dist[x.first], x.first});
                }
            }
        }

        if (dist[n] == INF) {
            cout << -1 << "\n";
        } else {
            cout << max(0ll, dist[n] - p);
        }
    }  else if (g == 2) {
        ll now_money = p;
        ll ans = 0;
        ll can_do = 0;
        for (ll i = 1; i < n; ++i) {
            can_do = max(can_do, arr[i]);
            ll price = graph[i][0].second;

            if (price > now_money) {
                price -= now_money;
                now_money = 0;

                ll create_count = (price + can_do - 1) / can_do;
                now_money += can_do * create_count - price;
                ans += create_count;
            } else {
                now_money -= price;
            }
        }

        cout << ans << "\n";
    }

//    else if (g == 0 || g == 3) {
//        vector<ll> path;
//        path.push_back(-1);
//        ll ans = LLONG_MAX;
//
//        for (ll i = 2; i <= n; ++i) {
//            path.push_back(i);
//        }
//        do {
//            vector<ll> realpath = path;
//            realpath.insert(realpath.begin(), 1);
//            ll all_cost = 0;
//            ll now_money = p;
//            ll now_ans = 0;
//
//            if (all_cost)
//            bool ok = true;
//            for (ll i = 0; i < path.size(); ++i) {
//                ll j = i + 1;
//                if (j < path.size() && path[j] == -1) {
//                    ++j;
//                }
//
//                if (j < path.size()) {
//                    ll from = path[i];
//                    ll to = path[j];
//
//                    ll min_money = LLONG_MAX;
//                    for (auto x : graph[from]) {
//                        if (x.first == to) {
//                            min_money = min(min_money, x.second);
//                        }
//                    }
//
//                    if (min_money == LLONG_MAX) {
//                        ok = false;
//                        break;
//                    }
//
//                    all_cost += min_money;
//                }
//            }
//
//            if (!ok) {
//                continue;
//            }
//
//            for (ll i = 0; i < path.size(); ++i) {
//                ll j = i + 1;
//                if (j < path.size() && path[j] == -1) {
//                    ++j;
//                }
//
//                if (j < path.size()) {
//                    ll from = path[i];
//                    ll to = path[j];
//
//                    ll min_money = LLONG_MAX;
//                    for (auto x : graph[from]) {
//                        if (x.first == to) {
//                            min_money = min(min_money, x.second);
//                        }
//                    }
//
//                    if (path[i + 1] == -1 && all_cost >= now_) {
//                        now_ans += all
//                    }
//                }
//
//            }
//        } while (next_permutation(path.begin(), path.end()));
//    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}