#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

vector<ll> arr;
vector<vector<pair<ll, ll>>> graph;

const ll INF = 1e16;

void solve() {
    ll n, m, p, g;
    cin >> n >> m >> p >> g;

    arr.resize(n + 1);
    graph.resize(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    while (m--) {
        ll a, b, s;
        cin >> a >> b >> s;
        graph[a].push_back({b, s});
    }

    if (g == 1) {
        set<pair<ll, ll>> s;
        vector<ll> dist(n + 1, INF);
        dist[1] = 0;
        s.insert({0, 1});
        while (!s.empty()) {
            auto now = *s.begin();
            s.erase(s.begin());
            if (dist[now.second] != now.first) {
                continue;
            }

            for (auto x: graph[now.second]) {
                if (dist[x.first] > dist[now.second] + x.second) {
                    dist[x.first] = dist[now.second] + x.second;
                    s.insert({dist[x.first], x.first});
                }
            }
        }

        if (dist[n] == INF) {
            cout << -1 << "\n";
        } else {
            cout << max(0ll, dist[n] - p);
        }
    } else if (g == 2) {
        ll now_money = p;
        ll ans = 0;
        ll can_do = 0;
        for (ll i = 1; i < n; ++i) {
            can_do = max(can_do, arr[i]);
            ll price = graph[i][0].second;

            if (price > now_money) {
                price -= now_money;
                now_money = 0;

                ll create_count = (price + can_do - 1) / can_do;
                now_money += can_do * create_count - price;
                ans += create_count;
            } else {
                now_money -= price;
            }
        }

        cout << ans << "\n";
    } else if (g == 0 || g == 3) {
        vector<ll> path1;
        ll ans = LLONG_MAX;

        vector<vector<ll>> distance(n + 1, vector<ll>(n + 1));
        for (ll i = 1; i <= n; ++i) {
            set<pair<ll, ll>> s;
            vector<ll> dist(n + 1, INF);
            dist[i] = 0;
            s.insert({0, i});
            while (!s.empty()) {
                auto now = *s.begin();
                s.erase(s.begin());
                if (dist[now.second] != now.first) {
                    continue;
                }

                for (auto x: graph[now.second]) {
                    if (dist[x.first] > dist[now.second] + x.second) {
                        dist[x.first] = dist[now.second] + x.second;
                        s.insert({dist[x.first], x.first});
                    }
                }
            }

            distance[i] = dist;
        }

        path1.push_back(-1);
        for (ll i = 2; i < n; ++i) {
            path1.push_back(i);
        }
        do {
            vector<ll> path;
            path.push_back(1);
            for (auto x: path1) {
                if (x == -1) {
                    break;
                }
                path.push_back(x);
            }
            path.push_back(n);

            vector<ll> prices;
            bool ok = true;
            for (ll i = 0; i < path.size(); ++i) {
                ll j = i + 1;
                if (j < path.size()) {
                    ll from = path[i];
                    ll to = path[j];

                    ll min_money = distance[from][to];
                    if (min_money == INF) {
                        ok = false;
                        break;
                    }

                    prices.push_back(min_money);
                }
            }

            if (!ok) {
                continue;
            }

            ll now_money = p;
            ll now = 0;
            ll can_do = 0;
            for (ll i = 0; i < prices.size(); ++i) {
                can_do = max(can_do, arr[path[i]]);
                ll price = prices[i];

                if (price > now_money) {
                    price -= now_money;
                    now_money = 0;

                    ll create_count = (price + can_do - 1) / can_do;
                    now_money += can_do * create_count - price;
                    now += create_count;
                } else {
                    now_money -= price;
                }
            }

            ans = min(ans, now);
        } while (next_permutation(path1.begin(), path1.end()));

        if (ans == LLONG_MAX) {
            cout << -1 << "\n";
        } else {
            cout << ans << "\n";
        }
    } else if (g == 4) {
        map<pair<ll, ll>, ll> dist;
        dist[{1, p}] = 0;
        set<pair<ll, pair<ll, ll>>> s;
        s.insert({0, {1, p}});
        while (!s.empty()) {
            auto now = *s.begin();
            s.erase(s.begin());
            if (dist[now.second] != now.first) {
                continue;
            }

            for (auto x: graph[now.second.first]) {
                for (ll do_pr = 0; do_pr <= 100; ++do_pr) {
                    ll newactions = dist[now.second] + do_pr;
                    ll new_money = do_pr * arr[now.second.first] + now.second.second;

                    if (new_money > 10000 && now.second.second > 10000) {
                        continue;
                    }
                    if (new_money >= x.second) {
                        new_money -= x.second;
                        if (dist.find({x.first, new_money}) == dist.end() || dist[{x.first, new_money}] > newactions) {
                            dist[{x.first, new_money}] = newactions;
                            s.insert({dist[{x.first, new_money}], {x.first, new_money}});
                        }
                    }
                }
            }
        }

        ll ans = INF;
        for (auto [x, y]: dist) {
            if (x.first == n) {
                ans = min(ans, y);
            }
        }
        if (ans == INF) {
            cout << -1 << "\n";
        } else {
            cout << max(0ll, ans);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}