#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const ll LL_INF = 2e18 + 10;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

struct Edge {
    ll u, v, s;
    Edge() : u(0), v(0), s(0) {}
    Edge(int _u, int _v, int _s) : u(_u), v(_v), s(_s) {}
};

int main() {
    ll sum;
    int n, m, test_ind;
    cin >> n >> m >> sum >> test_ind;
    vector<ll> w(n);
    cin >> w;
    vector<vector<Edge>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--;
        v--;
        g[u].push_back(Edge(u, v, s));
    }
    if (test_ind == 1) {
        vector<ll> d(n, LL_INF);
        d[0] = 0;
        set<pair<ll, int>> s;
        s.insert(pair<ll, int>(0, 0));
        while (!s.empty()) {
            int u = s.begin()->second;
            s.erase(s.begin());
            for (auto e : g[u]) {
                if (d[u] + e.s < d[e.v]) {
                    s.erase(pair<ll, int>(d[e.v], e.v));
                    d[e.v] = d[u] + e.s;
                    s.insert(pair<ll, int>(d[e.v], e.v));
                }
            }
        }
        if (d[n - 1] == LL_INF) {
            cout << -1;
        } else {
            cout << max(d[n - 1] - sum, 0LL);
        }
    } else if (test_ind == 2) {
        ll maxim = 0;
        ll ans = 0;
        for (int i = 0; i < n - 1; i++) {
            maxim = max(maxim, w[i]);
            if (sum < g[i][0].s) {
                ll delta = (g[i][0].s - sum + maxim - 1) / maxim;
                sum += delta * maxim;
                ans += delta;
            }
            sum -= g[i][0].s;
        }
        cout << ans;
    }

}
