#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(1e18) + 13;
template<typename T> inline bool smin(T&a,T b) {
  if (b < a) { a = b; return true; }
  return false;
}
template<typename T> inline bool smax(T&a,T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T1, typename T2> istream & operator >> (istream & in, pair<T1, T2> & pr) {
  in >> pr.first >> pr.second;
  return in;
}
template<typename T> istream & operator >> (istream & in, vector<T> & vec) {
  for (int & x : vec) in >> x;
  return in;
}
template<typename T1, typename T2> ostream & operator << (ostream & out, pair<T1, T2> & pr) {
  out << pr.first << " " << pr.second;
  return out;
}
template<typename T> ostream & operator << (ostream & out, vector<T> & vec) {
  if (vec.empty()) return out;
  out << vec[0];
  for (size_t i = 1; i < vec.size(); ++i)
    out << " " << vec[i];
  return out;
}
mt19937 rng(1810u);
uniform_int_distribution<> uid(0, INF-1);

constexpr int N = 800 + 3;
vector<pair<int, int>> g[N];
ll dist[N];
const int N_lite = 10;
pair<ll, ll> dp[N_lite][1 << N_lite];

void Solve() {

  int n, m, gr;
  ll p;
  cin >> n >> m >> p >> gr;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) cin >> a[i];
  for (int i = 0; i < m; ++i) {
    int u, v, w;
    cin >> u >> v >> w;
    --u, --v;
    g[u].emplace_back(v, w);
  }

  if (gr == 1) {
    set<pair<ll, int>> st;
    fill(dist, dist + N, LLINF);
    dist[0] = 0;
    st.insert({dist[0], 0});
    while (!st.empty()) {
      int v = st.begin()->second;
      st.erase(st.begin());
      for (auto [u, w]: g[v]) {
        if (dist[u] > dist[v] + w) {
          st.erase({dist[u], u});
          dist[u] = dist[v] + w;
          st.insert({dist[u], u});
        }
      }
    }
    if (dist[n - 1] == LLINF) cout << -1 << endl;
    else cout << max(0ll, dist[n - 1] - p) << endl;

    return;
  } else if (gr == 2) {
    ll cnt = 0;
    int mx = a[0];
    for (int i = 0; i < n-1; ++i) {
      smax(mx, a[i]);
      assert(g[i].size() == 1 && g[i][0].first == i + 1);
      ll t = (max(0ll, g[i][0].second - p) + mx - 1) / mx;
      cnt += t;
      p += t * mx - g[i][0].second;
    }
    cout << cnt << endl;
    return;
  }

  for (int i = 0; i < N_lite; ++i)
    fill(dp[i], dp[i] + (1 << N_lite), make_pair(LLINF, 0ll));
  dp[0][1] = { 0, p };
  ll ans = LLINF;
  for (int mask = 1, mxm = (1 << n); mask < mxm; ++mask) {
    int mx = -INF;
    for (int i = 0; i < n; ++i)
      if (mask >> i & 1) {
        smax(mx, a[i]);
      }
    for (int v = 0; v < n; ++v) {
      for (auto [u, w] : g[v]) {
        if (mask >> u & 1) continue;
        ll t = (max(0ll, w - dp[v][mask].second) + mx - 1) / mx;
        ll tot = dp[v][mask].first + t, pt = dp[v][mask].second + t * mx - w;
        if (dp[u][mask | (1 << u)].first > tot ||
            (dp[u][mask | (1 << u)].first == tot && dp[u][mask | (1 << u)].second > pt))
          dp[u][mask | (1 << u)] = { tot, pt };
      }
    }
    if ((mask & 1) && (mask >> (n - 1) & 1)) {
      smin(ans, dp[n-1][mask].first);
    }
  }
  if (ans == LLINF) {
    cout << -1 << endl;
  } else {
    cout << ans << endl;
  }

}


int32_t main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  Solve();

  return 0;
}
