#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=805;
const int INF=1e9+5;

struct Edge
{
    int v,w;
    Edge() {}
    Edge(int _v,int _w)
    {
        v=_v;
        w=_w;
    }
};
bool operator< (Edge a,Edge b)
{
    return a.w>b.w;
}

int n,m,p,g;
int a[MAXN];
vector<Edge> adj[MAXN];
int d[MAXN];
priority_queue<Edge> pq;
bool used[MAXN];

void dijkstra(int v)
{
    for(int i=1;i<=n;i++) d[i]=INF;
    d[v]=0;
    pq.push(Edge(v,0));
    while(!pq.empty())
    {
        v=pq.top().v;
        pq.pop();
        if(used[v]) continue;
        used[v]=1;
        for(int i=0;i<adj[v].size();i++)
        {
            if(!used[adj[v][i].v] && d[v]+adj[v][i].w<d[adj[v][i].v])
            {
                d[adj[v][i].v]=d[v]+adj[v][i].w;
                pq.push(Edge(adj[v][i].v, d[adj[v][i].v]));
            }
        }
    }
}

bool cmp(Edge a,Edge b)
{
    if(a.v==b.v) return a.w<b.w;
    return a.v<b.v;
}

int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);

cin>>n>>m>>p>>g;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
for(int i=0;i<m;i++)
{
    int u,v,w;
    cin>>u>>v>>w;
    adj[u].push_back(Edge(v,w));
}

if(g==1)
{
   /* for(int i=1;i<=n;i++)
    {
        cout<<i<<": ";
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].v<<";"<<adj[i][j].w<<" | ";
        cout<<endl;
    }*/
    for(int i=1;i<=n;i++)
    {
        sort(adj[i].begin(),adj[i].end(),cmp);
        for(int j=1;j<adj[i].size();j++)
        {
            if(adj[i][j].v==adj[i][j-1].v)
            {
                adj[i].erase(adj[i].begin()+j);
                j--;
            }
        }
    }
   /* for(int i=1;i<=n;i++)
    {
        cout<<i<<": ";
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].v<<";"<<adj[i][j].w<<" | ";
        cout<<endl;
    }*/
    dijkstra(1);
    cout<<max(0, d[n]-p)<<endl;
    return 0;
}

if(g==2)
{
    int last=a[1];
    int currM=p;
    int currS=0;
    int ans=0;
    for(int i=2;i<=n;i++)
    {
        currS+=adj[i-1][0].w;
        if(a[i]>last || i==n)
        {
            int tmp;
            if(currS>currM)
            {
                tmp=(currS-currM+last-1)/last;
                ans+=tmp;
                currM=currM+tmp*last-currS;
                currS=0;
            }
            else
            {
                currM-=currS;
                currS=0;
            }
            last=a[i];
        }
    }
    cout<<ans<<endl;
    return 0;
}

return 0;
}
/*
7 12 0 1
1 1 1 1 1 1 1
1 2 5
1 3 4
1 4 2
2 5 2
3 6 4
4 5 4
5 6 3
5 7 8
1 7 16
6 7 5
4 7 10
5 7 6


1 - 2 - 5  -  7
  \     |
  \ 3 - 6
   \
    4
*/
