#include<bits/stdc++.h>
#define endl '\n'
#define ll long long
using namespace std;

const int MAXN=805;
const ll INF=1e18+5;

struct Edge
{
    ll v,w;
    Edge() {}
    Edge(int _v,int _w)
    {
        v=_v;
        w=_w;
    }
};
bool operator< (Edge a,Edge b)
{
    return a.w>b.w;
}

ll n,m,p,g;
ll a[MAXN];
vector<Edge> adj[MAXN];
ll d[MAXN];
priority_queue<Edge> pq;
bool used[MAXN];
vector<int> path;
int vis[MAXN];
ll mx[MAXN];
ll ans=INF;

void dijkstra(int v)
{
    for(int i=1;i<=n;i++) d[i]=INF;
    d[v]=0;
    pq.push(Edge(v,0));
    while(!pq.empty())
    {
        v=pq.top().v;
        pq.pop();
        if(used[v]) continue;
        used[v]=1;
        for(int i=0;i<adj[v].size();i++)
        {
            if(!used[adj[v][i].v] && d[v]+adj[v][i].w<d[adj[v][i].v])
            {
                d[adj[v][i].v]=d[v]+adj[v][i].w;
                pq.push(Edge(adj[v][i].v, d[adj[v][i].v]));
            }
        }
    }
}

void dfs(int v,ll maxi)
{
    path.push_back(v);
    if(v==n)
    {
        int last=a[1];
        ll currM=p;
        ll currS=0;
        ll Ans=0;
        for(int i=1;i<n;i++)
        {
            for(int j=0;j<adj[path[i-1]].size();j++)
            {
                if(adj[path[i-1]][j].v==path[i]) {currS+=adj[path[i-1]][j].w; break;}
            }
            if(a[path[i]]>last || path[i]==n)
            {
                if(currS>currM)
                {
                    ll tmp=(currS-currM+last-1)/last;
                    Ans+=tmp;
                    currM=currM+tmp*last-currS;
                    currS=0;
                }
                else
                {
                    currM-=currS;
                    currS=0;
                }
                last=a[path[i]];
            }
        }
        ans=min(ans,Ans);
        path.pop_back();
        return;
    }
    vis[v]++;
    ll last=mx[v];
    mx[v]=maxi;
    for(int i=0;i<adj[v].size();i++)
    {
        if(vis[v]>1)
        {
            if(!vis[adj[v][i].v]) dfs(adj[v][i].v, max(maxi, a[adj[v][i].v]));
        }
        else
        {
            if(!vis[adj[v][i].v]) dfs(adj[v][i].v, max(maxi, a[adj[v][i].v]));
            else if(maxi>mx[adj[v][i].v]) dfs(adj[v][i].v, max(maxi, a[adj[v][i].v]));
        }
    }
    mx[v]=last;
    vis[v]--;
    path.pop_back();
}

bool cmp(Edge a,Edge b)
{
    if(a.v==b.v) return a.w<b.w;
    return a.v<b.v;
}

int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);

cin>>n>>m>>p>>g;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
for(int i=0;i<m;i++)
{
    ll u,v,w;
    cin>>u>>v>>w;
    adj[u].push_back(Edge(v,w));
}

if(g==1)
{
   /* for(int i=1;i<=n;i++)
    {
        cout<<i<<": ";
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].v<<";"<<adj[i][j].w<<" | ";
        cout<<endl;
    }*/
   /* for(int i=1;i<=n;i++)
    {
        sort(adj[i].begin(),adj[i].end(),cmp);
        for(int j=1;j<adj[i].size();j++)
        {
            if(adj[i][j].v==adj[i][j-1].v)
            {
                adj[i].erase(adj[i].begin()+j);
                j--;
            }
        }
    }*/
   /* for(int i=1;i<=n;i++)
    {
        cout<<i<<": ";
        for(int j=0;j<adj[i].size();j++) cout<<adj[i][j].v<<";"<<adj[i][j].w<<" | ";
        cout<<endl;
    }*/
    dijkstra(1);
    if(d[n]==INF) cout<<-1<<endl;
    else cout<<max(0LL, d[n]-p)<<endl;
    return 0;
}

if(g==2)
{
    int last=a[1];
    ll currM=p;
    ll currS=0;
    ll ans=0;
    for(int i=2;i<=n;i++)
    {
        currS+=adj[i-1][0].w;
        if(a[i]>last || i==n)
        {
            if(currS>currM)
            {
                ll tmp=(currS-currM+last-1)/last;
                ans+=tmp;
                currM=currM+tmp*last-currS;
                currS=0;
            }
            else
            {
                currM-=currS;
                currS=0;
            }
            last=a[i];
        }
    }
    cout<<ans<<endl;
    return 0;
}

if(g==0 || g==3)
{
    for(int i=1;i<=n;i++)
    {
        sort(adj[i].begin(),adj[i].end(),cmp);
        /*for(int j=1;j<adj[i].size();j++)
        {
            if(adj[i][j].v==adj[i][j-1].v)
            {
                adj[i].erase(adj[i].begin()+j);
                j--;
            }
        }*/
    }
    dfs(1,0LL);
    if(ans==INF) cout<<-1<<endl;
    else cout<<ans<<endl;
    return 0;
}

return 0;
}
/*
7 12 0 1
1 1 1 1 1 1 1
1 2 5
1 3 4
1 4 2
2 5 2
3 6 4
4 5 4
5 6 3
5 7 8
1 7 16
6 7 5
4 7 10
5 7 6

5 11 0 1
1 1 1 1 1
1 1 2
4 4 1
1 2 2
2 3 4
3 4 3
4 2 3
2 5 16
3 5 11
4 5 6
1 5 20
5 5 1


1 - 2 - 5  -  7
  \     |
  \ 3 - 6
   \
    4
*/
