#include <iostream>
#include <utility>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 800;

int n, m, p, q;
int ww[MAXN + 5];
long long dist[MAXN + 5];
vector< pair<int, int> > G[MAXN + 5];

void Dijkstra()
{
    for (int i = 1; i <= n; ++ i)
    {
        dist[i] = 1e18 + 1;
    }

    dist[1] = 0;
    priority_queue< pair<int, int> > pq;
    pq.push({0, 1});
    while (!pq.empty())
    {
        int u = pq.top().second, d = -pq.top().first;
        pq.pop();
        if (d > dist[u]) continue;
        for (auto [v, w] : G[u])
        {
            if (dist[u] + w < dist[v])
            {
                dist[v] = dist[u] + w;
                pq.push({-dist[v], v});
            }
        }
    }
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> p >> q;

    if (q == 1)
    {
        for (int i = 1; i <= n; ++ i)
        {
            cin >> ww[i];
        }
        for (int j = 1; j <= m; ++ j)
        {
            int u, v, w;
            cin >> u >> v >> w;
            G[u].push_back({v, w});
        }

        Dijkstra();

        if (dist[n] == 1e18 + 1) cout << -1 << endl;
        else cout << dist[n] - p << endl;
    }

    return 0;
}
