#include<bits/stdc++.h>
using namespace std;

long long const MAXN=1000001;
long long n, m, p, g, w[MAXN], inf = 1e18+7, used[MAXN], d[MAXN];

struct edge
{
    long long ver, dist;
    bool operator<(const edge &ed)const
    {
        return dist > ed.dist;
    }
};

vector<edge> v[MAXN];

void dijkstra(long long s)
{
    for(long long i=0;i<=n;i++)
    {
        d[i] = inf;
    }
    d[s] = 0;
    priority_queue<edge> q;
    q.push({s,0});
    while(!q.empty())
    {
        edge u = q.top();
        q.pop();
        if(u.dist <= d[u.ver])
        {
            if(!used[u.ver])
            {
                used[u.ver] = 1;
                long long sz = v[u.ver].size();
                for(long long i=0;i<sz;i++)
                {
                    edge nb = v[u.ver][i];
                    if(nb.dist + u.dist < d[nb.ver])
                    {
                        nb.dist += u.dist;
                        d[nb.ver] = nb.dist;
                        q.push(nb);
                    }
                }
            }
        }
    }
}

void read()
{
    long long x, y, ds;
    cin>>n>>m>>p>>g;
    for(long long i=1;i<=n;i++)
    {
        cin>>w[i];
    }
    for(long long i=1;i<=m;i++)
    {
        cin>>x>>y>>ds;
        v[x].push_back({y,ds});
        d[i+1] = ds;
    }
    if(g == 1)
    {
        dijkstra(1);
        if(d[n] == inf) cout<<-1<<endl;
        else cout<<max((long long)0, d[n] - p)<<endl;
    }
    else
    {
        long long cnt = 0, u = w[1];
        long long r = p;
        for(long long i=2;i<=n;i++)
        {
            if(r < d[i])
            {
                if((d[i]-r)%u == 0)
                {
                    cnt += (d[i]-r)/u;
                    r += (d[i]-r);
                }
                else
                {
                    cnt += ((d[i]-r)/u+1);
                    r += ((d[i]-r)/u+1)*u;
                }
            }
            r -= d[i];
            u = max(u, w[i]);
        }
        cout<<cnt<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}

/*

4 3 4 2
1 20 15 7
1 2 5
2 3 60
3 4 20
*/
