#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"
#include "cmath"
#include "iomanip"

using namespace std;

typedef long long ll;
typedef long double ld;


void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    ll n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<ll> w;
    w.resize(n);
    for (ll &i: w)
        cin >> i;
    vector<vector<pair<ll, ll>>> g(n);
    vector<vector<ll>> dist(n, vector<ll>(n, 1e18));
    for (int i = 0; i < n; i++)
        dist[i][i] = 0;
    for (ll i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        g[a].push_back({b, w});
        dist[a][b] = min(dist[a][b], w);
    }
    for (ll q = 0; q < n; q++) {
        for (ll i = 0; i < n; i++) {
            for (ll j = 0; j < n; j++) {
                dist[i][j] = min(dist[i][j], dist[i][q] + dist[q][j]);
            }
        }
    }
    vector<pair<ll, ll>> ans(n, {1e18, 1e18});
    ans[0] = {0, p};
    set<pair<ll, ll>> s;
    vector<bool> is(n);
    is[0] = 1;
    s.insert({0, 0});
    while (!s.empty()) {
        auto[x, i] = *s.begin();
        auto[d, p1] = x;
        is[i] = 1;
        s.erase(s.begin());
        for (int j = 0; j < n; j++) {
            if (is[j])
                continue;
            s.erase({ans[j].first, j});
            if (dist[i][j] >= p)
                ans[j] = min(ans[j], {d + (dist[i][j] - p1 + w[i] - 1) / w[i],
                                      p1 + ((dist[i][j] - p1 + w[i] - 1) / w[i]) * w[i] - dist[i][j]});
            else
                ans[j] = min(ans[j], {d, p1 - dist[i][j]});
            s.insert({ans[j].first, j});
        }
    }
    if (ans[n - 1].first == 1e18)
        cout << -1;
    else
        cout << ans[n - 1].first;

}