#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>
#include <iomanip>

using namespace __gnu_pbds;
using namespace std;

//#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

typedef long long ll;

const int N = 805;
const ll inf = 1e18;

ll d[N][N];


void solve() {
  for (int i = 0; i < N; ++i) {
    for (int j = 0; j < N; ++j) {
      d[i][j] = inf;
    }
  }

  int n, m, p, g;
  cin >> n >> m >> p >> g;
  for (int i = 0; i < n; i++) {
    d[i][i] = 0;
  }

  vector<int> a(n);
  for (auto &x : a) {
    cin >> x;
  }

  for (int w = 0; w < m; w++) {
    int u, v;
    ll c;
    cin >> u >> v >> c;
    --u, --v;
    d[u][v] = min(d[u][v], c);
  }

  for (int k = 0; k < n; k++) {
    for (int i = 0; i < n; i++) {
      for (int j = 0; j < n; j++) {
        d[i][j] = min(d[i][j], d[i][k] + d[k][j]);
      }
    }
  }

  if (d[0][n - 1] == inf) {
    cout << -1 << '\n';
    return;
  }

  vector<pair<ll, ll>> dp(n, pair(-inf, inf));
  dp[0] = {p, 0};
  for (int phase = 0; phase < n; phase++) {
    bool any_change = false;
    for (int i = 0; i < n; i++) {
      for (int prev = 0; prev < n; prev++) {
        if (d[prev][i] != inf) {
          ll need_money = max(0ll, d[prev][i] - dp[prev].first);
          ll po = (need_money + a[prev] - 1) / a[prev];
          ll new_cnt = po + dp[prev].second;
          ll new_money = dp[prev].first + po * a[prev] - d[prev][i];
          if (new_cnt < dp[i].second || (new_cnt == dp[i].second && new_money > dp[i].first)) {
            dp[i] = {new_money, new_cnt};
            any_change = true;
          }
        }
      }
    }
    if (!any_change) {
      break;
    }
  }

  cout << dp[n - 1].second << '\n';
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}