use std::io::{self, prelude::*};

fn solve<R: BufRead, W: Write>(scan: &mut Scanner<R>, w: &mut W) -> io::Result<()> {
    let n = scan.token();
    let albs = (0..n)
        .map(|_| {
            (0..scan.token())
                .map(|_| scan.token())
                .collect::<Vec<i32>>()
        })
        .collect::<Vec<_>>();

    let mut albs = albs
        .into_iter()
        .map(|alb| {
            alb.into_iter().fold(vec![], |mut acc, x| {
                if acc.is_empty() || acc.last() < Some(&x) {
                    acc.push(x);
                }
                acc
            })
        })
        .collect::<Vec<_>>();
    albs.sort_unstable_by_key(|a| a.last().cloned());

    let ks: Vec<_> = albs.iter().map(|v| v.len()).collect();
    let mut dp: Vec<_> = ks.iter().map(|&k| vec![0; k + 1]).collect();
    let mut mxdp = vec![0; n];
    dp[0]
        .iter_mut()
        .enumerate()
        .for_each(|(i, x)| *x = ks[0] - i);
    mxdp[0] = ks[0];
    for i in 1..n {
        dp[i][ks[i]] = mxdp[i - 1];
        dp[i][0] = ks[i];
        for start in 0..ks[i] {
            let bound = albs[..i].partition_point(|x| x.last() < albs[i].get(start));
            for j in 0..bound {
                dp[i][start] = dp[i][start].max(mxdp[j] + ks[i] - start);
            }
        }
        mxdp[i] = *dp[i].iter().max().unwrap();
    }

    writeln!(w, "{}", mxdp.iter().max().unwrap())
}

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());
    solve(&mut scan, &mut w)
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
