#define _GLIBCXX_DEBUG

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cassert>
#include <functional>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>

using namespace std;

int main(){
    std::uniform_int_distribution<uint64_t> ri_dist(0, -1);
    std::default_random_engine r_eng(std::chrono::steady_clock::now().time_since_epoch().count());

    int n;
    cin >> n;
    vector<vector<int>> music(n);
    for (int i = 0; i < n; i++){
        int k;
        cin >> k;
        music[i].resize(k);
        for (int j = 0; j < k; j++){
            cin >> music[i][j];
        }
    }

    uint64_t best_res = 0;

    function<void(vector<int>&)> perebor = [&](vector<int>& ord){
        if (ord.size() == n){
            uint64_t best_from_now = 0;
            uint64_t E = 0;
            for (int alb : ord){
                for (int track : music[alb]){
                    if (best_from_now < track){
                        best_from_now = track;
                        E++;
                    }
                }
            }
            best_res = max(best_res, E);
        } else {
            for (int i = 0; i < n; i++){
                bool found = false;
                for (int el : ord){
                    if (el == i){
                        found = true;
                        break;
                    }
                }
                if (!found){
                    ord.push_back(i);
                    perebor(ord);
                    ord.pop_back();
                }
            }
        }
    };
    vector<int> ps;
    perebor(ps);
    printf("%lu\n", best_res);
}
