#include <bits/stdc++.h>
#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const int mod = 1e9 + 7;
const ld eps = 1e-6;

struct album {
    vector<int> a;
    int mx;
    vector<int> ans;
};

bool cmp(album &a, album &b) {
    return a.mx < b.mx;
}

struct segtree{
    vector<ll> t, mod;
    int sz_t;
    void build(int n) {
        t.resize(4 * n);
        mod.resize(4 * n);
        sz_t = n;
    }
    void push(int v, int tl, int tr) {
        t[v] = max(t[v], mod[v]);
        if (tr - tl != 1) {
            mod[v * 2] = max(mod[v * 2], mod[v]);
            mod[v * 2 + 1] = max(mod[v * 2 + 1], mod[v]);
        }
        mod[v] = 0;
    }
    void upd(int v, int tl, int tr, int l, int r, int x) {
        push(v, tl, tr);
        if (l <= tl && tr <= r) {
            mod[v] = max(mod[v], x);
            push(v, tl, tr);
            return;
        }
        if (max(l, tl) >= min(r, tr)) {
            return;
        }
        upd(v * 2, tl, (tl + tr) / 2, l, r, x);
        upd(v * 2 + 1, (tl + tr) / 2, tr, l, r, x);
        t[v] = max(t[v * 2], t[v * 2 + 1]);
    }
    void upd(int l, int r, int x) {
        upd(1, 0, sz_t, l, r + 1, x);
    }
    int get_max(int v, int tl, int tr, int pos) {
        push(v, tl, tr);
        if (tr - tl == 1) {
            return t[v];
        }
        if (pos < (tl + tr) / 2) {
            return get_max(v * 2, tl, (tl + tr) / 2, pos);
        } else {
            return get_max(v * 2 + 1, (tl + tr) / 2, tr, pos);
        }
    }
    int get_max(int pos) {
        return get_max(1, 0, sz_t, pos);
    }
};

signed main() {
    int n;
    cin >> n;
    vector<album> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].a.resize(k);
        a[i].ans.resize(k + 1);
        a[i].mx = -1;
        for (int j = 0; j < k; j++) {
            cin >> a[i].a[j];
            a[i].mx = max(a[i].mx, a[i].a[j]);
        }
    }
    sort(a.begin(), a.end(), cmp);
    segtree t;
    t.build(200001);
    for (int i = n - 1; i >= 0; i--) {
        int k = a[i].a.size();
        vector<int> st;
        vector<int> upper(n);
        for (int j = k - 1; j >= 0; j--) {
            while (!st.empty() && a[i].a[st.back()] < a[i].a[j]) {
                st.pop_back();
            }
            if (st.empty()) {
                upper[j] = k;
            } else {
                upper[j] = st.back();
            }
            st.push_back(j);
        }
        a[i].ans[k] = 0;
        for (int j = k - 1; j >= 0; j--) {
            a[i].ans[j] = 1 + a[i].ans[upper[j]];
        }
        int l = 0;
        for (int j = 0; j < k; j++) {
            if (l >= a[i].a[j]) {
                continue;
            }
            t.upd(l, a[i].a[j] - 1, a[i].ans[j] + t.get_max(a[i].mx));
            l = a[i].a[j];
        }
    }
    cout << t.get_max(0);
    return 0;
}