#include <bits/stdc++.h>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

template<typename T>
std::ostream &operator<<(std::ostream &out, std::vector<T> &a) {
    for (auto &el: a)
        out << el << ' ';
    return out;
}

template<typename T>
std::istream &operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &el: a)
        in >> el;
    return in;
}

template<typename T1, typename T2>
std::istream &operator>>(std::istream &in, std::pair<T1, T2> &a) {
    in >> a.first >> a.second;
    return in;
}

typedef long long ll;
typedef long double ld;
using namespace std;

struct cut {
    int l, r, w;
};

const int INF = 1e9 + 7;

void solve() {
    int n; cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        a[i].resize(k);
        for (auto &el : a[i])
            cin >> el;
    }

    vector<vector<int>> b(n);
    for (int i = 0; i < n; ++i) {
        int mx = -INF;
        for (int j = 0; j < len(a[i]); ++j) {
            if (a[i][j] > mx) {
                mx = a[i][j];
                b[i].push_back(a[i][j]);
            }
        }
    }

    vector<cut> cuts;
    auto add_cut = [&] (int l, int r, int w) {
        cuts.push_back({l, r, w});
    };

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < len(b[i]); ++j) {
            int l = b[i][j];
            int r = b[i].back();
            int w = (len(b[i]) - j);
            add_cut(l, r, w);
        }
    }

    sort(all(cuts), [&] (const cut& c1, const cut& c2) {
        if (c1.r == c2.r) {
            return c1.l < c2.l;
        }
        return c1.r < c2.r;
    });

    vector<int> dp(len(cuts), 0);
    vector<int> pref(len(cuts), 0);
    for (int i = 0; i < len(cuts); ++i) {
        dp[i] = cuts[i].w;
        pref[i] = (i ? max(pref[i - 1], dp[i]) : dp[i]);
        int l = -1, r = len(cuts);
        while (r - l > 1) {
            int m = (r + l) >> 1;
            if (cuts[m].r >= cuts[i].l) {
                r = m;
            } else {
                l = m;
            }
        }

        if (l == -1)
            continue;
        dp[i] = max(dp[i], cuts[i].w + pref[l]);
        pref[i] = max(pref[i - 1], dp[i]);
    }

    cout << *max_element(all(dp));
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}