#include <bits/stdc++.h>
using namespace std;
const int maxa = 2e5;

struct Fenwick {
    int n;
    vector<int> fen;
    Fenwick() {}
    Fenwick(int _n) {
        n = _n;
        fen.resize(n + 1);
    }
    void maxEq(int i, int x) {
        while (i <= n) {
            fen[i] = max(fen[i], x);
            i += (i & -i);
        }
    }
    int getPref(int i) {
        int res = 0;
        while (i > 0) {
            res = max(res, fen[i]);
            i -= (i & -i);
        }
        return res;
    }
    ~Fenwick() {}
};

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        int k;
        cin >> k;
        int mx = -1;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (x > mx) {
                a[i].emplace_back(x);
                mx = x;
            }
        }
    }
    sort(p.begin(), p.end(), [&](const int& A, const int& B) {
         return a[A].back() < a[B].back();
    });
    Fenwick ans(maxa);
    for (const int& i : p) {
        int cur = a[i].size();
        for (int j = 0; j < (int)a[i].size(); ++j) {
            cur = max(cur, ans.getPref(a[i][j] - 1) + (int)a[i].size() - j);
        }
        ans.maxEq(a[i].back(), cur);
    }
    cout << ans.getPref(maxa) << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
