#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const ld eps = 1e-9;

struct segment_tree {
	vector<int> promise;
	vector<int> sum;
	int sz = 1;
	void dub(int n) {
		while (sz < n) sz *= 2;
	}
	segment_tree(vector<int>& arr) {
		dub(arr.size());
		sum.resize(2 * sz);
		promise.resize(2 * sz);
		build(1, 0, sz, arr);
	}
	void build(int id, int l, int r, vector<int>& arr) {
		if (r - l == 1 && l < arr.size()) {
			sum[id] = arr[l];
			return;
		}
		if (r - l == 1) {
			sum[id] = INF;
			return;
		}
		int m = (r + l) / 2;
		build(2 * id, l, m, arr);
		build(2 * id, m, r, arr);
		sum[id] = min(sum[2 * id], sum[2 * id + 1]);
	}
	void push(int id, int l, int r) {
		sum[id] += promise[id];
		if (r - l > 1) {
			promise[2 * id] += promise[id];
			promise[2 * id] += promise[id];
		}
		promise[id] = 0;
	}
	void upd(int id, int l, int r, int l_q, int r_q, int val) {
		push(id, l, r);
		if (l_q <= l && r <= r_q) {
			promise[id] += val;
			push(id, l, r);
			return;
		}
		if (l_q >= r || l >= r_q) return;
		
	}
};


vector<vector<int>> help;


int count(int l, int r) {
	return help[l].size() + help[r].size() - (upper_bound(help[r].begin(), help[r].end(), help[l].back()) - help[r].begin());
}
bool f(int l, int r) {
	if (count(l, r) > count(r, l)) return true;
	return false;
}

signed main() {
	int n; cin >> n;
	vector<vector<int>> mas(n);
	for (int x = 0; x < n; x++) {
		int k; cin >> k;
		for (int i = 0; i < k; i++) {
			int a; cin >> a;
			mas[x].push_back(a);
		}
	}
	help.resize(n);
	for (int x = 0; x < n; x++) {
		int maxi = -1;
		for (auto it : mas[x]) {
			if (maxi < it) help[x].push_back(it);
			maxi = max(maxi, it);
		}
	}
	vector<int> arr(n);
	for (int x = 0; x < n; x++) arr[x] = x;
	sort(arr.begin(), arr.end(), f);
	int ans = 0;
	for (int x = 1; x < n; x++) {
		ans += help[arr[x]].size() - (upper_bound(help[arr[x]].begin(), help[arr[x]].end(), help[arr[x - 1]].back()) - help[arr[x]].begin());
	}
	ans += help[arr[0]].size();
	cout << ans;
}
 