#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

using pii = pair <int, int>;

template <typename T>
void mxr(T& a, const T& b) {
    a = max(a, b);
}

template <typename T>
void mnr(T& a, const T& b) {
    a = min(a, b);
}

class Fenwick {
private:
    vector <int> d;
    int n;

public:
    explicit Fenwick(int n) : d(n), n(n) { }

    void upd(int i, int x) {
        for (; i < n; i |= (i + 1)) {
            mxr(d[i], x);
        }
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            mxr(res, d[i]);
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector <vector <int> > v(n);
    vector <vector <int> > v1;
    vector <pii> pt;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int mr = 0;
        while (k--) {
            int a;
            cin >> a;
            mxr(mr, a);
            v[i].push_back(a);
        }
        pt.emplace_back(mr, i);
    }
    sort(all(pt));
    v1.reserve(pt.size());
    for (auto [mr, id] : pt) {
        v1.emplace_back(v[id]);
    }
    v = v1;
    Fenwick fenwick(2e5 + 1);
    for (int i = 0; i < n; ++i) {
        int m = sz(v[i]);
        vector <int> cr(m, m);
        vector <int> st;
        for (int j = 0; j < m; ++j) {
            while (!st.empty() && v[i][j] > v[i][st.back()]) {
                cr[st.back()] = j;
                st.pop_back();
            }
            st.push_back(j);
        }
        vector <int> dp(m + 1);
        int mx = *max_element(all(v[i]));
        vector <int> pmax = v[i];
        for (int j = 1; j < m; ++j) {
            mxr(pmax[j], pmax[j - 1]);
        }
        for (int j = m - 1; j >= 0; --j) {
            dp[j] = dp[cr[j]] + 1;
            if (v[i][j] == pmax[j]) {
                fenwick.upd(mx, fenwick.get(v[i][j] - 1) + dp[j]);
            }
        }
    }
    cout << fenwick.get(2e5);
}