#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
typedef long double ld;
using namespace std;

int get1(const vector<int> &A, int last) {
    int  i = -1;
    int n = (int)A.size();
    for (int j = 0; j < n; j++) {
        if (A[j] > last) {
            i = j;
            break;
        }
    }
    if (i == -1) {
        return 0;
    }
    int cnt = 0;
    int mx = (i == 0 ? 0 : *max_element(A.begin(), A.begin() + i));
    for (; i < n; i++) {
        if (A[i] > mx) {
            cnt++;
            mx = A[i];
        }
    }
    return cnt;
}

int get(const vector<int> &A) {
    int cnt = 0;
    int mx = 0;
    for (const int &i : A) {
        if (i > mx) {
            cnt++;
            mx = i;
        }
    }
    return cnt;
}

vector<int> operator+(const vector<int> &A, const vector<int> &B) {
    vector<int> C;
    C.reserve(A.size() + B.size());
    for (const auto &i : A) {
        C.push_back(i);
    }
    for (const auto &i : B) {
        C.push_back(i);
    }
    return C;
}

struct segtree {
    static const int size = 256 * 1024;
    int tree[size * 2 - 1]{};
    void set(int i, int v) {
        int x = size + i - 1;
        tree[x] = max(tree[x], v);
        while (x) {
            x = (x - 1) / 2;
            tree[x] = max(tree[x * 2 + 1], tree[x * 2 + 2]);
        }
    }
    int get(int l, int r, int x = 0, int lx = 0, int rx = size) {
        if (l <= lx && rx <= r) {
            return tree[x];
        }
        if (l >= rx || lx >= r) {
            return 0;
        }
        return max(get(l, r, x * 2 + 1, lx, (lx + rx) / 2),
                   get(l, r, x * 2 + 2, (lx + rx) / 2, rx), rx);
    }
};


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> A(n);
    vector<int> mx(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        A[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> A[i][j];
        }
        mx[i] = *max_element(A[i].begin(), A[i].end());
    }
    vector<int> B(n);
    iota(B.begin(), B.end(), 0);
    sort(B.begin(), B.end(), [&mx](int i, int j) {
        return mx[i] < mx[j];
    });

    segtree st;

    for (int i : B) {
        auto &C = A[i];
        vector<int> Q;
        int m = (int)C.size();
        vector<int> dp(m);
        int val = 0;
        for (int j = m - 1; j >= 0; j--) {
            dp[j] = 1;
            while (!Q.empty() && C[Q.back()] <= C[j]) {
                Q.pop_back();
            }
            if (!Q.empty()) {
                dp[j] = dp[Q.back()] + 1;
            }
            Q.push_back(j);
            val = max(val, dp[j] + st.get(0, C[j]));
        }
        st.set(mx[i], val);
    }
    cout << st.get(0, st.size);
    return 0;
}
