#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int N = 2e5+1;

void solve();

signed main() {
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

vi contain[N];
int used[N];

struct Album{
    int mx, q, ind;

    bool operator<(const Album &oth) const{
        if (mx != oth.mx) return mx > oth.mx;
        return q < oth.q;
    }
};

void solve_stupid(int n, vvi a){
    vi perm(n);
    iota(all(perm), 0);
    int ans = 0;
    do {
        vi st;
        for (auto i: perm) {
            
            for (int j = 0; j < a[i].size(); j++) {
                int x = a[i][j];
                if (st.empty() || st.back() < x) st.push_back(x);
            }
        }
        print(perm);
        print(st);
        ans = max(ans, (int)st.size());
        
    } while (next_permutation(all(perm)));

    cout << ans;
}

void solve() {
    int n;
    cin >> n;
    vvi a(n);
    vi cnt(n);
    priority_queue<Album> pq;

    for (int i = 0; i < n; i++){
        int k;
        cin >> k;
        for (int j = 0; j < k; j++){
            int x;
            cin >> x;
            if (a[i].empty() || a[i].back() < x) a[i].push_back(x), contain[x].push_back(i), cnt[i]++;
        }
        //reverse(all(a[i]));
        pq.push({a[i][0], cnt[i], i});
    }

    if (n <= 7) {
        solve_stupid(n, a);
        return;
    }

    int ans = 0;
    vi used_albums(n);
    int el = 0;
    while (!pq.empty()){
        auto buf = pq.top();
        pq.pop();
        int u = buf.ind;
        int qu = buf.q;
        int mxu = buf.mx;
        if (qu > cnt[u]) continue;
        if (used_albums[u]) continue;
        used_albums[u] = 1;
        debnl(u);
        print(a[u]);
        ans += qu;

        while (el <= mxu){
            for (auto i: contain[el]) if (!used_albums[i]) pq.push({a[i][0], --cnt[i], i}), a[i].pop_back();
            el++;
        }

    }

    cout << ans;
}













