#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;

#define int long long

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd(12);

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int N = 2e5+1;

void solve();

signed main() {
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}

vvi contain(N);
vi used(N);

struct Album{
    int mx, q, ind;

    bool operator<(const Album &oth) const{
        return mx < oth.mx;
    }
};

vvi gen() {
    int n = rnd() % 7 + 1;
    vvi a(n);
    for (int i = 0; i < n; i++) {
        int k = rnd() % 10 + 1;
        for (int j = 0; j < k; j++) {
            a[i].push_back(rnd() % 10 + 1);
        }
    }
    return a;
}

int solve_stupid(int n, vvi a){
    vi perm(n);
    iota(all(perm), 0);
    int ans = 0, ev = 0;
    do {
        vi st;
        for (auto i: perm) {
            
            for (int j = 0; j < a[i].size(); j++) {
                int x = a[i][j];
                if (st.empty() || st.back() < x) st.push_back(x);
            }
        }
        //print(perm);
        //print(st);
        ans = max(ans, (int)st.size());
        ev++;
        
    } while (next_permutation(all(perm)));
    //debnl(ev);

    return ans;
}

vvi read_data() {
    int n;
    cin >> n;
    vvi a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            a[i].push_back(x);
        }
    }
    return a;
}

void solve() {
    
    vvi raw = read_data();
    int n = raw.size();

    contain = vvi(N);
    used = vi(N);

    vvi a(n);
    vi cnt(n);
    multiset<Album> pq;

    vector<Album> segs;

    for (int i = 0; i < n; i++){
        int k = raw[i].size();
        for (int j = 0; j < k; j++){
            int x = raw[i][j];
            
            
            if (a[i].empty() || a[i].back() < x) a[i].push_back(x), contain[x].push_back(i);
        }
        reverse(all(a[i]));
        segs.push_back({ a[i][0], cnt[i], i });
        
    }

    sort(all(segs));
    //print2d(a);
    vi dp(N);
    int cur = 1;
    
    for (Album seg : segs) {
        int i = seg.ind;
        debnl(i);
        int mx = seg.mx;
        while (cur <= mx) {
            dp[cur] = max(dp[cur], dp[cur - 1]);
            cur++;
            deb(dp[cur]);
        }
        int q = 1;
        for (auto el : a[i]) {
            deb(el);  debnl(dp[el]);
            dp[mx] = max(dp[mx], dp[el - 1] + q);
            deb(el);  debnl(dp[el]);
            q++;
        }

    }

    cout << *max_element(all(dp));
    
}













