#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>

using namespace std;

using ll = long long;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;

int main(){
    ll n;
    cin >> n;
    vvl N(n);
    for (ll i = 0; i < n; i++){
        ll k;
        cin >> k;
        N[i] = vl(k);
        for (ll j = 0; j < k; j++){
            cin >> N[i][j];
        }
    }

    vector<pair<ll, ll>> maxs(n);
    vl max_pos(n);
    for (ll i = 0; i < n; i++){
        ll m = N[i][0];
        ll pos = 0;
        for (ll j = 1; j < N[i].size(); j++){
            if (m < N[i][j]){
                m = N[i][j];
                pos = j;
            }
        }
        maxs[i] = make_pair(m, i);
        max_pos[i] = pos;
    }
    stable_sort(maxs.begin(), maxs.end());
    // for (ll i = 0; i < n; i++){
    //     cout << maxs[i].second << ' ';
    // }
    // cout << '\n';

    vl answers(n);
    for (ll i = 0; i < n; i++){
        ll index = maxs[i].second; 
        vl cost = vl(max_pos[index] + 1);
        cost[max_pos[index]] = 0;

        deque<ll> right_max;
        right_max.push_back(max_pos[index]);
        for (ll j = max_pos[index] - 1; j >= 0; j--){
            while(!right_max.empty() && N[index][right_max.back()] <= N[index][j]){
                right_max.pop_back();
            }
            cost[j] = cost[right_max.back()] + 1;
            right_max.push_back(j);
        }

        for (ll j = 0; j <= max_pos[index]; j++){
            ll left = 0, right = i, middle = 0;
            while (left + 1 < right){
                middle = (left + right) / 2;
                if (maxs[middle].first < N[index][j]){
                    left = middle;
                }
                else{
                    right = middle;
                }
            }
            if (maxs[left].first < N[index][j]){
                cost[j] += 1 + answers[left];   
            }
        }

        answers[i] = cost[0];
        for (ll j = 1; j <= max_pos[index]; j++){
            if (answers[i] < cost[j]){
                answers[i] = cost[j];
            }
        }
        if (i != 0){
            answers[i] = max(answers[i - 1], answers[i]);
        }
    }
    // for (ll i = 0; i < n; i++){
    //     cout << answers[i] << ' ';
    // }
    // cout << '\n';

    cout << answers.back() + 1;
    return 0;
}