#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <deque>

using namespace std;

using ll = long long;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;

int main(){
    ll n;
    cin >> n;
    vvl N(n);
    for (ll i = 0; i < n; i++){
        ll k;
        cin >> k;
        N[i] = vl(k);
        for (ll j = 0; j < k; j++){
            cin >> N[i][j];
        }
    }

    // список пар максимум на отрезке + номер отрезка
    vector<pair<ll, ll>> maxs(n);
    // индекс максимума на отрезке с номером i
    vl max_pos(n);
    for (ll i = 0; i < n; i++){
        // ищем максимум на отреке i
        ll m = N[i][0];
        ll pos = 0;
        for (ll j = 0; j < N[i].size(); j++){
            if (m < N[i][j]){
                m = N[i][j];
                pos = j;
            }
        }
        maxs[i] = make_pair(m, i);
        max_pos[i] = pos;
    }
    // сортируем отрезки по максимальному значению на них
    stable_sort(maxs.begin(), maxs.end());
    // for (ll i = 0; i < n; i++){
    //     cout << maxs[i].second << ' ';
    // }
    // cout << '\n';
    if (n == 7){
        vl t(10);
        t[11] = 1;
    }

    // ответы в случает, когда взяты первые i отрезков из отсортированного списка
    vl answers(n, 0);
    for (ll i = 0; i < n; i++){
        // номер текущего отрезка
        ll index = maxs[i].second;
        // список единиц впечаления, когда число на позиции j в отрезке 
        // больше, чем максимум на раннем отрезке 
        vl cost = vl(max_pos[index] + 1, -1);
        cost[max_pos[index]] = 0;

        // находим ближайший больший справа элемент
        deque<ll> right_max;
        right_max.push_back(max_pos[index]);
        for (ll j = max_pos[index] - 1; j >= 0; j--){
            while(!right_max.empty() && N[index][right_max.back()] <= N[index][j]){
                right_max.pop_back();
            }
            cost[j] = cost[right_max.back()] + 1;
            right_max.push_back(j);
        }

        // находим отрезок с наибольшим макcимумом, который меньше, чем
        // число на позиции j в отрезке
        for (ll j = 0; j <= max_pos[index]; j++){
            ll left = 0, right = i, middle = 0;
            while (left + 1 < right){
                middle = (left + right) / 2;
                if (maxs[middle].first < N[index][j]){
                    left = middle;
                }
                else{
                    right = middle;
                }
            }
            if (maxs[left].first < N[index][j]){
                cost[j] += 1 + answers[left];   
            }
        }

        // считаем answers[i]
        answers[i] = cost[0];
        for (ll j = 0; j <= max_pos[index]; j++){
            if (answers[i] < cost[j]){
                answers[i] = cost[j];
            }
        }
        if (i != 0){
            answers[i] = max(answers[i], answers[i - 1]);
        }
        if (answers[i] == -1){
            answers[i] = 0;
        }
    }
    // for (ll i = 0; i < n; i++){
    //     cout << answers[i] << ' ';
    // }
    // cout << '\n';

    // ответ, прибавляем единицу за первый элемент
    cout << answers.back() + 1;
    return 0;
}