#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> &a);
template<typename T>
ostream& operator << (ostream &out, set<T> &a);
template<typename T>
ostream& operator << (ostream &out, vector<T> &a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> &a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(2281337711);
struct Fenwick {
    vector<int> tree;
    int n;
    Fenwick(int _n) : n(_n), tree(_n) {}
    void update(int pos, int val) {
        for (; pos < n; pos |= (pos + 1)) chmax(tree[pos], val);
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) chmax(ans, tree[r]);
        return ans;
    }
};
void solve_case() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> mx(n);
    map<int, vector<int>> layers;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (a[i].empty() || a[i].back() < x) {
                a[i].push_back(x);
                chmax(mx[i], x);
            }
        }
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    sort(ord.begin(), ord.end(), [&](int left, int right){
        return mx[left] < mx[right];
    });
    Fenwick f(mx[ord[n - 1]] + 1);
    for (int i = 0; i < n; i++) {
        int cur = 0;
        for (int j = 0; j < a[ord[i]].size(); j++) {
            chmax(cur, f.get(a[ord[i]][j] - 1) + a[ord[i]].size() - j);
        }
        f.update(mx[ord[i]], cur);
    }
    cout << f.get(f.n - 1) << "\n";
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}