#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct SegTree {
	int n;
	vector<int> vec;

	struct node {
		int x;
		node(): x(0) {};
		node(int x): x(x) {};
		node(node a, node b) {
			x = max(a.x, b.x);
		};

		void upd(int nx) {
			if (nx > x) x = nx;
		}
	};

	vector<node> st;

	SegTree(int n, vector<int> vec): n(n), vec(vec) {
		st.resize(n * 4);
	}

	// void build(int v, int l, int r) {
	// 	if (r - l == 1) {
	// 		st[v] = node(vec[l]);
	// 		return;
	// 	}
	// 	int m = (l + r) / 2;
	// 	build(v * 2 + 1, l, m);
	// 	build(v * 2 + 2, m, r);
	// 	st[v] = node(st[v * 2 + 1], st[v * 2 + 2]);
	// }

	int ask(int v, int l, int r, int ql, int qr) {
		if (qr <= l || r <= ql) return 0;
		if (ql <= l && r <= qr) return st[v].x;
		int m = (l + r) / 2;
		return max(ask(v * 2 + 1, l, m, ql, qr), ask(v * 2 + 2, m, r, ql, qr));
	}

	void upd(int v, int l, int r, int qi, int x) {
		if (qi < l || r <= qi) return;
		if (r - l == 1) {
			st[v].upd(x);
			return;
		}
		int m = (l + r) / 2;
		upd(v * 2 + 1, l, m, qi, x);
		upd(v * 2 + 2, m, r, qi, x);
		st[v] = node(st[v * 2 + 1], st[v * 2 + 2]);
	}
};

const int maxa = 2e5 + 5;

int optz(vector<int> &vec) {
	int mx = -1e9;
	vector<int> newv;
	for (int x: vec) {
		if (x > mx) newv.push_back(x);
		mx = max(mx, x);
	}
	vec = newv;
	return mx;
}

int main() {
	#ifndef LOCAL
	ios::sync_with_stdio(0);
	cin.tie(0);
	#endif
	int n;
	cin >> n;
	vector<vector<int>> vec(n);
	for (vector<int> &v: vec) {
		int k;
		cin >> k;
		v.resize(k);
		for (int &x: v) cin >> x;
	}
	vector<pair<int, int>> order;
	for (int i = 0; i < n; ++i) {
		int mx = optz(vec[i]);
		order.push_back({mx, i});
	}
	sort(order.begin(), order.end());
	// for (int i = 0; i < n; ++i) {
	// 	for (int x: vec[order[i].second]) cout << x << ' '; cout << endl;
	// }
	vector<int> null(maxa, 0);
	SegTree st(maxa, null);
	//st.build(0, 0, maxa);
	// cout << "COCK" << endl;
	for (int i = n - 1; i >= 0; --i) {
		int ord = order[i].second;
		for (int j = vec[ord].size() - 1; j >= 0; --j) {
			int x = vec[ord][j];
			int ansn = st.ask(0, 0, maxa, order[i].first + 1, maxa);
			if (j != vec[ord].size() - 1) {
				ansn = max(ansn, st.ask(0, 0, maxa, vec[ord][j + 1], vec[ord][j + 1] + 1));
			}
			st.upd(0, 0, maxa, x, ansn + 1);
			// cout << x << ' ' << ansn << endl;
		}
	}
	cout << st.ask(0, 0, maxa, 0, maxa) << endl;
}