#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAXA = 200228;

struct SegmentTree {
    int tree_size;
    vector <int> tree;

    SegmentTree (int n) {
        tree_size = 1;
        while (tree_size < n)
            tree_size <<= 1;

        tree.resize(2 * tree_size);
    }

    void update(int v, int tl, int tr, int pos, int x) {
        if (tr -tl == 1) {
            tree[v] = max(tree[v], x);
            return;
        }

        int mid = (tl + tr) / 2;
        if (pos < mid) update(2 * v, tl, mid, pos, x);
        else update(2 *v + 1, mid, tr, pos, x);

        tree[v] = max(tree[2 * v], tree[2 * v + 1]);

    }

    void update(int pos, int x) {
        update(1, 0, tree_size, pos, x);
    }

    int query(int v, int tl, int tr, int l, int r) {
        if (tl >= r || tr <= l)
            return 0;

        if (tl >=l  && tr <= r)
            return tree[v];

        int mid = (tl + tr) / 2;
        int left = query(2 * v, tl, mid, l, r);
        int right = query(2 * v + 1, mid, tr, l, r);
        return max(left, right);
    }

    int query(int l, int r) {
        return query(1, 0 ,tree_size, l, r);
    }
};

void solve() {
    int n;
    cin >> n;

    vector <int> k(n);
    vector <vector <int>> a(n);
    for (int i =0 ; i < n; i++) {
        cin >> k[i];

        int x;
        for (int j = 0; j < k[i]; j++) {
            cin >> x;

            if (a[i].empty() || x > a[i].back())
                a[i].push_back(x);
        }

    }

    vector <int> order(n);
    iota(order.begin(), order.end(), 0);

    sort(order.begin(), order.end(), [&] (int i, int j) {
        return a[i].back() < a[j].back();
    });

    SegmentTree tree(MAXA);

    for (int i: order) {
        int sz = a[i].size();
        for (int j = sz - 1; j >= 0; j--) {
            int x = tree.query(0, a[i][j]) + sz - j;
            tree.update(a[i].back(), x);
        }
    }

    cout << tree.tree[1] << '\n';

    /*

    vector <int> order(n);
    iota(order.begin(), order.end(), 0);

    int answer = 0;
    do {
        int maxx = 0;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (int x: a[order[i]]) {
                if (x > maxx) {
                    ans++;
                    maxx = x;
                }
            }
        }

        answer= max(answer, ans);
    } while (next_permutation(order.begin(), order.end()));

    cout << answer << '\n';*/
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
