#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

const int C = 2e5 + 5;

int t[4 * C];

void set_val(int v, int tl, int tr, int pos, int val) {
    if (tl == tr) {
        t[v] = max(t[v], val);
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm)
        set_val(v * 2 + 1, tl, tm, pos, val);
    else
        set_val(v * 2 + 2, tm + 1, tr, pos, val);
    t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
}

int get(int v, int tl, int tr, int l, int r) {
    if (tl > r || tr < l) return 0;
    if (l <= tl && tr <= r) return t[v];
    int tm = (tl + tr) >> 1;
    return max(get(v * 2 + 1, tl, tm, l, r), get(v * 2 + 2, tm + 1, tr, l, r));
}

bool cmp(vector<int>& a, vector<int>& b) {
    return a.back() < b.back();
}

void solve() {
    int n, k, val;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        cin >> k;
        for (int j = 0; j < k; j++) {
            cin >> val;
            if (a[i].empty() || a[i].back() < val)
                a[i].push_back(val);
        }
    }
    sort(All(a), cmp);
    int ans = 0;
    for (int i = 0; i < n; i++) {
        int last = a[i].back(), s = sz(a[i]);
        for (int j = 0; j < s; j++) {
            int cur = get(0, 0, C - 1, 0, a[i][j] - 1);
            cur += s - j;
            ans = max(ans, cur);
            set_val(0, 0, C - 1, last, cur);
        }
    }
    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    solve();
}