#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
typedef long long ll;

struct SegTree {
private:
    int n;
    vector<int> t;
    void upd(int p, int l, int r, int i, int x) {
        if (l > i || r <= i) return;
        if (l + 1 == r) {
            t[p] = max(t[p], x);
            return;
        }
        int mid = (l + r) / 2;
        upd(2 * p + 1, l, mid, i, x);
        upd(2 * p + 2, mid, r, i, x);
        t[p] = max(t[2 * p + 1], t[2 * p + 2]);
    }

    int get(int p, int l, int r, int a, int b) {
        if (l >= b || r <= a) return 0;
        if (a <= l && r <= b) return t[p];
        int mid = (l + r) / 2;
        return max(get(2 * p + 1, l, mid, a, b), get(2 * p + 2, mid, r, a, b));
    }
public:
    SegTree() = default;
    SegTree(int _n) {
        n = _n;
        t.assign(4 * n, 0);
    }
    void update(int ind, int val) {
        upd(0, 0, n, ind, val);
    }
    int get_max(int l, int r) {
        return get(0, 0, n, l, r);
    }
};

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

int clever(int n, vector<vector<int>>& q) {
    vector<pair<int, int>> srt;
    vector<vector<int>> w(n);
    SegTree dp(200001);
    for (int i = 0; i < n; ++i) {
        int mx = -1;
        for (auto u: q[i]) {
            if (u > mx) {
                w[i].push_back(u);
                mx = u;
            }
        }
        srt.emplace_back(w[i].back(), i);
    }
    sort(all(srt));
    for (auto [x, ind]: srt) {
        int res = 0;
        for (int i = w[ind].size() - 1; i >= 0; --i) {
            res = max(res, dp.get_max(0, w[ind][i]) + (int)w[ind].size() - i);
        }
        dp.update(x, res);
    }
    return dp.get_max(0, 200001);
}

int stupid(int n, vector<vector<int>>& q) {
    vector<int> perm(n);
    iota(all(perm), 0);
    int ans = 0;
    for (int _ = 0; _ < 9000; ++_) {
        int mx = -1, cnt = 0;
        for (int i: perm) {
            for (auto u: q[i]) {
                if (u > mx) {
                    cnt++;
                    mx = u;
                }
            }
        }
        ans = max(ans, cnt);
        next_permutation(all(perm));
    }
    return ans;
}

mt19937 rnd(0);

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<vector<int>> q(n);
    for (int i = 0; i < n; ++i) {
        int sz; cin >> sz;
        for (int j = 0; j < sz; ++j) {
            int x; cin >> x;
            q[i].push_back(x);
        }
    }
    cout << clever(n, q);
}