#include "bits/stdc++.h"

using namespace std;
using ll = long long;
using ld = long double;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

constexpr int INF = 1e9;

struct segtree {
	int size;
	struct node {
		int mx;
		node(int x = 0) : mx(x) {}
	};
	vector<node> t;
	segtree(int n) {
		size = 1;
		while (size < n)
			size *= 2;
		t.assign(2 * size, 0);
	}

	int get_max(int l, int r, int x, int lx, int rx) {
		if (rx <= l || lx >= r) {
			return 0;
		}
		if (l <= lx && rx <= r) {
			return t[x].mx;
		}

		int mx = (lx + rx) / 2;
		int a = get_max(l, r, 2 * x, lx, mx);
		int b = get_max(l, r, 2 * x + 1, mx, rx);
		return max(a, b);
	}
	int get_max(int l, int r) {
		return get_max(l, r, 1, 0, size);
	}

	void set(int pos, int value, int x, int lx, int rx) {
		if (rx - lx == 1) {
			t[x].mx = value;
			return;
		}

		int mx = (lx + rx) / 2;
		if (pos < mx)
			set(pos, value, 2 * x, lx, mx);
		else
			set(pos, value, 2 * x + 1, mx, rx);
		t[x] = max(t[2 * x].mx, t[2 * x + 1].mx);
	}
	void set(int pos, int value) {
		set(pos, value, 1, 0, size);
	}
};

struct segtree_mn {
	int size;
	struct node {
		int mn, idx;
		node(int x = 2 * INF, int idx = -1) : mn(x), idx(x) {}
	};
	vector<node> t;
	segtree_mn(int n) {
		size = 1;
		while (size < n)
			size *= 2;
		t.resize(2 * size);
	}

	pair<int, int> get_min(int l, int r, int x, int lx, int rx) {
		if (rx <= l || lx >= r) {
			return { 2 * INF, -1 };
		}
		if (l <= lx && rx <= r) {
			return { t[x].mn, t[x].idx };
		}

		int mx = (lx + rx) / 2;
		pair<int, int> a = get_min(l, r, 2 * x, lx, mx);
		pair<int, int> b = get_min(l, r, 2 * x + 1, mx, rx);
		return min(a, b);
	}
	pair<int, int> get_min(int l, int r) {
		return get_min(l, r, 1, 0, size);
	}

	void set(int pos, int value, int x, int lx, int rx) {
		if (rx - lx == 1) {
			t[x] = { value, pos };
			return;
		}

		int mx = (lx + rx) / 2;
		if (pos < mx)
			set(pos, value, 2 * x, lx, mx);
		else
			set(pos, value, 2 * x + 1, mx, rx);
		if (t[2 * x].mn <= t[2 * x + 1].mn) {
			t[x] = t[2 * x];
		}
		else {
			t[x] = t[2 * x + 1];
		}
	}
	void set(int pos, int value) {
		set(pos, value, 1, 0, size);
	}
};

void solve_case() {
	int n; cin >> n;
	vector<vector<int>> V(n);
	for (auto& v : V) {
		int k; cin >> k;
		v.resize(k);
		for (auto& x : v)
			cin >> x;
	}

#ifdef LOCAL
	int MAX_A = 12;
#else
	int MAX_A = 2e5 + 100;
#endif

	segtree_mn st_mn(MAX_A + 2);
	for (int i = 0; i <= MAX_A; i++)
		st_mn.set(i, INF);

	vector<int> past(MAX_A, -1);
	vector<int> dp(MAX_A);

	vector<vector<pair<int, int>>> g(MAX_A);
	for (int k = 0; k < n; k++) {
		auto& a = V[k];
		vector<int> mx(sz(a));
		mx[0] = a[0];
		for (int i = 1; i < sz(a); i++)
			mx[i] = max(mx[i - 1], a[i]);

		vector<int> len(sz(a), 0);
		for (int i = sz(a) - 1; i >= 0; i--) {
			int num = st_mn.get_min(a[i] + 1, MAX_A + 1).second;

			int res = 0;
			if (num != -1 && num <= MAX_A) {
				res = len[num];
			}

			len[i] = res + 1;
			past[a[i]] = i;
			st_mn.set(a[i], i);
		}

		for (int i = 0; i < sz(a); i++) {
			st_mn.set(a[i], INF);
			past[a[i]] = -1;
		}

		int MX = *max_element(all(a));
		for (int i = 0; i < sz(a); i++) {
			if (!i || mx[i] != mx[i - 1]) {
				g[mx[i]].emplace_back(MX + 1, len[i]);
			}
		}
	}

	segtree st(MAX_A);
	for (int i = 0; i < MAX_A; i++) {
		int have = st.get_max(0, i + 1);
		for (auto& [v, w] : g[i]) {
			int next = have + w;

			int had = st.get_max(v, v + 1);
			if (next > had) {
				st.set(v, next);
			}
		}
	}

	cout << st.get_max(0, MAX_A) << "\n";
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
