#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

struct segtree {
    int n;
    vector<int> t;
    segtree(int N) {
        n = N;
        t.resize(4 * n);
    }

    void upd(int tl, int tr, int x, int v, int l, int r) {
        if (tl >= r || l >= tr)
            return;
        if (l >= tl && r <= tr) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        upd(tl, tr, x, 2 * v, l, m);
        upd(tl, tr, x, 2 * v + 1, m, r);
    }

    int get(int i, int v, int l, int r) {
        if (l == r - 1)
            return t[v];
        int m = (l + r) / 2;
        if (i < m)
            return get(i, 2 * v, l, m) + t[v];
        else
            return get(i, 2 * v + 1, m, r) + t[v];
    }
};


vector<int> get_xc(vector<int> &v) {
    auto xc = v;
    sort(xc.begin(), xc.end());
    xc.resize(unique(xc.begin(), xc.end()) - xc.begin());
    return xc;
}

vector<int> get_res(vector<int> v) {
    int cur = 0;
    auto xc = get_xc(v);
    for (auto &x : v)
        x = (int)(lower_bound(xc.begin(), xc.end(), x) - xc.begin());
    int sz = (int)xc.size();
    segtree st(sz);
    for (auto &x : v) {
        if (x > cur) {
            cur = x;
            st.upd(0, cur, 1, 1, 0, sz);
        }
    }

    vector<int> res(sz);
    for (int i = 0; i < sz; ++i) {
        res[i] = st.get(i, 1, 0, sz);
    }
    return res;
}

signed main() {
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    for (auto &x: v) {
        int k;
        cin >> k;
        x.resize(k);
        for (auto &y: x)
            cin >> y;
    }


    vector<vector<int>> result(n), xc(n);
    for (int i = 0; i < n; ++i) {
        result[i] = get_res(v[i]);
        xc[i] = get_xc(v[i]);
    }
    vector<int> all;
    for (auto &x : v)
        for (auto &y : x)
            all.push_back(y);
    all = get_xc(all);
    vector<vector<int>> dp(n, vector<int>((int)all.size(), 0));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for ()
        }
    }
}