#include <bits/stdc++.h>

using namespace std;
const int maxn = 50;
struct segtree {
    vector<int> t;
    segtree() {
        t.resize(4 * maxn);
    }

    void upd(int tl, int tr, int x, int v, int l, int r) {
        if (tl >= r || l >= tr)
            return;
        if (l >= tl && r <= tr) {
            t[v] += x;
            return;
        }
        int m = (l + r) / 2;
        upd(tl, tr, x, 2 * v, l, m);
        upd(tl, tr, x, 2 * v + 1, m, r);
    }

    int get(int i, int v, int l, int r) {
        if (l == r - 1)
            return t[v];
        int m = (l + r) / 2;
        if (i < m)
            return get(i, 2 * v, l, m) + t[v];
        else
            return get(i, 2 * v + 1, m, r) + t[v];
    }
};


vector<int> get_xc(vector<int> &v) {
    auto xc = v;
    sort(xc.begin(), xc.end());
    xc.resize(unique(xc.begin(), xc.end()) - xc.begin());
    return xc;
}

vector<int> get_res(vector<int> v) {
    int cur = 0;
    segtree st;
    for (auto &x : v) {
        if (x > cur) {
            cur = x;
            st.upd(0, cur, 1, 1, 0, maxn);
        }
    }

    vector<int> res(maxn);
    for (int i = 0; i < maxn; ++i) {
        res[i] = st.get(i, 1, 0, maxn);
    }
    return res;
}



signed main() {
    int n; cin >> n;
    vector<vector<int>> v(n);
    for (auto &x : v) {
        int k; cin >> k;
        x.resize(k);
        for (auto &y : x)
            cin >> y;
    }

    int K = 0;
    for (auto &x : v) {
        for (auto &y : x)
            K = max(K, y);
    }
    vector<int> mx(n);
    for (int i = 0; i < n; ++i) {
        for (auto &x : v[i])
            mx[i] = max(mx[i], x);
    }

    vector<vector<int>> result(n);
    for (int i = 0; i < n; ++i)
        result[i] = get_res(v[i]);

    vector<int> dp(K + 1);
    for (int i = 0; i <= K; ++i) {
        for (int j = 0; j < n; ++j) {
            if (mx[j] == i) {
                for (int k = 0; k < i; ++k) {
                    dp[i] = max(dp[i], dp[k] + result[j][k]);
                }
            }
        }
    }

    int res = 0;
    for (auto &x : dp)
        res = max(res, x);
    cout << res << '\n';
}