#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>

#define int long long

using namespace std;

vector <vector <int> > kek;

bool comp(vector <int> &a, vector <int> &b)
{
    if (a.back()<b.back()) return 1;
    return 0;
}

vector <int> segtree;

void update(int v, int l, int r, int i, int x)
{
    if (l>i or r<=i) return;
    if (l==r-1)
    {
        segtree[v]=x;
    }
    else
    {
        update(2*v+1,l,(r+l)/2,i,x);
        update(2*v+2,(r+l)/2,r,i,x);
        segtree[v]=max(segtree[2*v+1],segtree[2*v+2]);
    }
}

int get(int v, int l, int r, int lx, int rx)
{
    if (lx>=r or l>=rx) return 0;
    if (lx<=l and r<=rx) return segtree[v];
    else
    {
        return max(get(2*v+1,l,(r+l)/2,lx,rx),get(2*v+2,(r+l)/2,r,lx,rx));
    }
}

void solve()
{
    int n;
    cin>>n;
    vector <vector <int> > albums(n);
    for (int i=0; i<n; i++)
    {
        int k;
        cin>>k;
        int m=0;
        for (int j=0; j<k; j++)
        {
            int o;
            cin>>o;
            if (o>m)
            {
                albums[i].push_back(o);
                m=o;
            }
        }
    }
    sort(albums.begin(),albums.end(),comp);
    int o=200001;
    segtree.resize(4*o,0);

    //храним do[k[i]] - макс значение, если мы закончили в k[i], пересчет за длину на лог
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<albums[i].size(); j++)
        {
            update(0,0,o,albums[i].back(),max(get(0,0,o,0,albums[i][j])+(int)albums[i].size()-j,get(0,0,o,albums[i].back(),albums[i].back()+1)));
        }
    }
    cout<<get(0,0,o,0,o)<<"\n";
}

signed main() {
    int t=1;
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    //cin>>t;
    while (t--)
    {
        solve();
    }
}
