#include <iostream>
#include <utility>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

struct LCA{
    int n, k;
    vector<int> depths, parents;
    vector<vector<int>> dp;

    void dfs(int v, int par, vector<vector<int>>& g, vector<bool>& used){
        used[v] = true;
        parents[v] = par;
        for(auto to : g[v]){
            if(!used[to])
                dfs(to, v, g, used);
        }
        if(par != -1)
            depths[v] = depths[par] + 1;

    }

    int get_log2(int n){
        ll num = 1;
        k = 0;
        while (num < n) {
            num *= 2;
            k++;
        }
        return k;
    }

    void LA(){
        for(int i = 0; i < n; i++)
            dp[0][i] = parents[i];
        for(int i = 1; i <= k; i++){
            for(int j = 0; j < n; j++){
                dp[k][i] = dp[k - 1][dp[k - 1][i]];
            }
        }
    }

    void build(vector<vector<int>>& g){
        n = g.size();
        vector<bool> used(n);
        depths.assign(n, 0);
        parents.assign(n, 0);
        dfs(0,-1,g,used);

        int k = get_log2(n);
        dp.assign(k + 1, vector<int>(n));
        LA();
    }

    int up(int v, int level){
        for(int i = k; i >= 0; i--){
            if(depths[v] - (1ll << i) >= level){
                v = dp[i][v];
            }
        }
        return v;
    }

    int lca(int v, int u){
        if(depths[v] < depths[u])
            u = up(u, depths[v]);
        if (depths[u] < depths[v])
            v = up(v, depths[u]);


    }


};

struct segtree{
    vector<ll> tree;
    int size;

    int init(int n){
        size = 1;
        while(size < n)
            size *= 2;
        tree.assign(2 * size - 1, 0);
    }
};

void solve(){

}

int main() {
    //freopen("input", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector <int>> alb(n);
    for(int i = 0; i < n; i++){
        int k;
        cin >> k;
        int mx = 0;
        for(int j = 0; j < k; j++){
            int val;
            cin >> val;
            mx = max(val, mx);
            if(alb[i].empty())
                alb[i].push_back(mx);
            else if(mx > alb[i].back())
                alb[i].push_back(mx);
        }
    }

    for(int i = 0; i < n; i++)
        reverse(alb[i].begin(), alb[i].end());

    sort(alb.begin(), alb.end());

    for(int i = 0; i < n; i++)
        reverse(alb[i].begin(), alb[i].end());

    vector<int> dp(2e5 + 10);
    for(int i = 0;  i< n; i++)
        dp[alb[i].back()] = max(dp[alb[i].back()], (int)alb[i].size());

    vector<int> dp_max(dp.size());
    int ind = 0;
    for(int i = 1; i <= alb.back().back(); i++){
        if(dp[i] > 0){
            while (ind < n && alb[ind].back() == i) {
                for (int j = 0; j < alb[ind].size(); j++) {
                   // cout << dp_max[alb[ind][j] - 1] << ' ';
                    dp[i] = max(dp[i], dp_max[alb[ind][j] - 1] + (int) alb[ind].size() - j);
                }
                ind++;
            }
        }
        dp_max[i] = max(dp_max[i - 1], dp[i]);
    }

    cout<<dp_max[alb.back().back()];



    return 0;
}
