#include <iostream>
#include <vector>
#include <numeric>
#include <set>
#include <algorithm>

using namespace std;
using ll = long long;

const ll INF18 = 1e18;
/*
ll solveFact(const vector<vector<ll>> &albums) {
    ll n = ll(albums.size());
    vector<ll> order(n);
    iota(order.begin(), order.end(), 0);
    ll res = 0;
    do {
        ll tmp = 0;
        ll mx = 0;
        for (const auto &id: order) {
            for (auto &item: albums[id]) {
                if (mx < item) {
                    ++tmp;
                    mx = item;
                }
            }
        }

        res = max(res, tmp);
    } while (next_permutation(order.begin(), order.end()));
    return res;
}

ll solveA2(const vector<vector<ll>> &albums) {
    ll n = ll(albums.size());
    if (n == 1) {
        bool wasOne = false;
        for (const auto &item: albums[0]) {
            if (item == 2 && wasOne) {
                return 2;
            } else if (item == 1) {
                wasOne = true;
            }
        }

        return 1;
    } else {
        bool wasOne = false;
        bool wasTwo = false;
        for (const auto &lst: albums) {
            for (const auto &item: lst) {
                if (item == 1) {
                    wasOne = true;
                } else {
                    wasTwo = true;
                }
            }
        }
        return wasOne + wasTwo;
    }
}

void resolve() {
    ll n;
    cin >> n;
    vector<vector<ll>> albums(n);
    ll maxA = 0;
    ll maxK = 0;
    for (ll i = 0; i < n; ++i) {
        ll sz;
        cin >> sz;
        maxK = max(maxK, sz);
        for (ll j = 0; j < sz; ++j) {
            ll x;
            cin >> x;
            if (!j || albums[i].back() < j) {
                albums[i].push_back(x);
            }
        }
        maxA = max(maxA, albums[i].back());
    }

    ll res;
    if (maxA <= 2) {
        res = solveA2(albums);
    } else {
        res = solveFact(albums);
    }
    cout << res << '\n';
}
*/

ll dp[200001];
vector<vector<ll>> als[200001];

void resolve1() {
    ll n;
    cin >> n;
    for (ll i = 0; i < n; ++i) {
        ll sz;
        cin >> sz;
        vector<ll> cur;
        for (ll j = 0; j < sz; ++j) {
            ll x;
            cin >> x;
            if (!j || cur.back() < x) {
                cur.push_back(x);
            }
        }

        als[cur.back()].push_back(cur);
    }

    for (auto &al: als) {
        for (const auto &lst: al) {
            for (ll prev = 0; prev < lst.back(); ++prev) {
                dp[lst.back()] = max(dp[lst.back()],
                                     dp[prev] + ll(lst.end() - upper_bound(lst.begin(), lst.end(), prev)));
            }
        }
    }

    ll res = 0;
    for (ll item: dp) {
        res = max(res, item);
    }

    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve1();
    return 0;
}
