#include <bits/stdc++.h>
#define all(a) a.begin(),a.end()
#define rall(a) a.rbegin(),a.rend()
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;
using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template<typename T> using oset = tree<T,null_type,less<T>,rb_tree_tag,tree_order_statistics_node_update>;

const int MAXN = 2e5 + 5;
vector<int> A[MAXN];

struct segtree
{
    int sz;
    vector<int> tree;
    segtree(int n)
    {
        sz = 1;
        while (sz < n) sz<<=1;
        tree.resize(sz * 2);
    }
    void upd(int i, int x) {
        i+=sz-1;
        tree[i] = x;
        while (i) {
            i = (i-1)>>1;
            tree[i] = max(tree[i*2+1], tree[i*2+2]);
        }
    }
    int get_max(int l, int r) {
        l+=sz-1; r+=sz-1;
        int ans = 0;
        while (l<=r) {
            if (!(l&1)) ans = max(ans, tree[l]);
            if (r&1) ans = max(ans, tree[r]);
            l>>=1;
            r=(r>>1)-1;
        }
        return ans;
    }
};

struct segtree1
{
    int sz;
    vector<pair<int,int>> tree;
    vector<int> op;
    segtree1(int n) {
        sz = 1;
        while (sz < n) sz<<=1;
        tree.resize(sz*2);
        op.resize(sz*2, -1);
    }
    void push(int lx, int rx, int v) {
        if (rx-lx==1 || op[v] == -1) return;
        op[v*2+1] = op[v*2+2] = op[v];
        tree[v*2+1] = tree[v*2+2] = {op[v], 0};
        op[v] = -1;
    }
    void upd(int lx, int rx, int v, int l, int r, int x, int i) {
        push(lx,rx,v);
        if (lx>=r || rx<=l) return;
        if (lx>=l && rx<=r) {
            if (x > tree[v].first) tree[v] = {x, i};
            if (x == 0) {
                tree[v] = {x, 0};
                op[v] = 0;
            }
            return;
        }
        int mid = (lx+rx)>>1;
        upd(lx,mid,v*2+1,l,r,x,i);
        upd(mid,rx,v*2+2,l,r,x,i);
        tree[v] = max(tree[v*2+1], tree[v*2+2]);
    }
    void upd(int l, int r, int x, int i) {upd(0,sz,0,l,r,x, i);}
    pair<int,int> get_max(int lx, int rx, int v, int l, int r) {
        push(lx,rx,v);
        if (lx>=r || rx<=l) return {0,0};
        if (lx>=l && rx<=r) {
            return tree[v];
        }
        int mid = (lx+rx)>>1;
        return max(get_max(lx,mid,v*2+1,l,r), get_max(mid,rx,v*2+2,l,r));
    }
    pair<int,int> get_max(int l, int r) {return get_max(0,sz,0,l,r);}
};

int dps[MAXN], dpe[MAXN];

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i=0,b;i<n;i++) {
        cin >> b;
        A[i].resize(b);
        for (auto &x:A[i]) cin >> x;
    }
    segtree sts(MAXN), ste(MAXN);
    segtree1 st(MAXN);
    cout << "\n";
    for (auto &v : A) {
        if (v.empty()) continue;
        int m = (int)v.size();
        vector<pair<int,int>> B(m);
        for (int i=0;i<m;i++) B[i] = {v[i], i};
        vector<pair<int,int>> upds(m), upde(m);
        // L to R
        {
            st.upd(0,MAXN,0,0);
            vector<int> temp(m, 1), start(m);
            for (int i=0;i<m;i++) {
                start[i] = i;
                auto pr = st.get_max(0, B[i].first - 1);
                if (pr.first + 1 > temp[i]) {
                    temp[i] = pr.first + 1;
                    start[i] = start[pr.second];
                }
                st.upd(B[i].first, B[i].first+1, temp[i], i);
            }
            for (int i=0;i<m;i++) {
                //    cout << temp[i] << " " << start[i] << ", ";
                int mx = sts.get_max(B[i].first+1,MAXN-1);
                upds[i] = {start[i], mx + temp[i]};
            }
            //cout << "\n";
            //for (auto &[a,b] : B) cout << a << " " << b + 1<< " | ";
           // cout << "\n\n";
        }
        // R to L
        {
            st.upd(0,MAXN,0,0);
            vector<int> temp(m, 1), start(m);
            for (int i=m-1;i>=0;i--) {
                start[i] = i;
                auto pr = st.get_max(B[i].first + 1, MAXN - 1);
                if (pr.first + 1 > temp[i]) {
                    temp[i] = pr.first + 1;
                    start[i] = start[pr.second];
                }
                st.upd(B[i].first, B[i].first+1, temp[i], i);
            }
            for (int i=0;i<m;i++) {
                int mx = ste.get_max(0, B[i].first - 1);
                upde[i] = {start[i], mx + temp[i]};
            }
        }
        for (int i=0;i<m;i++) sts.upd(upds[i].first, upds[i].second);
        for (int i=0;i<m;i++) ste.upd(upde[i].first, upde[i].second);
    }
    int ans = max(sts.get_max(0,MAXN-1), ste.get_max(0,MAXN-1));
    cout << ans;
}

/*

4
5
4 9 4 6 8
1
7
2
8 6
1
1

4
2
3 4
2
1 8
2
2 8
2
7 9

*/
