#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 200000 + 10;

int n;
int perm[MAXN];
std::vector <int> songs[MAXN];

inline int bigger(int idx, int num)
{
    int l = -1, r = songs[idx].size(), mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (songs[idx][mid] <= num) l = mid;
        else r = mid;
    }

    return songs[idx].size() - r;
}

void solve()
{
    std::iota(perm + 1, perm + 1 + n, 1);
    std::sort(perm + 1, perm + 1 + n, [&](const int &a, const int &b)
    {
        return songs[a].back() < songs[b].back();
    });

    int ans = 0;
    int last = 0;
    for (int i = 1 ; i <= n ; ++i)
    {
        for (const int &j : songs[perm[i]])
        {
            if (j > last)
            {
                ans++;
                last = j;
            }
        }
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        int k, curr;
        std::cin >> k;
        for (int j = 1 ; j <= k ; ++j)
        {
            std::cin >> curr;
            if (songs[i].empty() || curr > songs[i].back())
            {
                songs[i].push_back(curr);
            }
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}