#include <algorithm>
#include <iostream>
#include <iomanip>
#include <numeric>
#include <vector>
#include <stack>
#include <set>

typedef long long llong;
const int MAXN = 200000 + 10;

int n;
int perm[MAXN];
std::vector <int> songs[MAXN];
std::vector <std::pair <int,int>> nums;

struct BIT
{
    int tree[MAXN];
    void update(int pos, int value)
    {
        pos = n + 1 - pos;
        for (int idx = pos ; idx <= n ; idx += idx & (-idx))
        {
            tree[idx] = std::max(tree[idx], value);
        }
    }

    int query(int pos)
    {
        int ans = 0;
        pos = n + 1 - pos;
        for (int idx = pos ; idx >= 1 ; idx -= idx & (-idx))
        {
            ans = std::max(ans, tree[idx]);
        }

        return ans;
    }
};

BIT fenwick;
int dp[MAXN];
bool vis[MAXN];
int inPerm[MAXN];
void solve()
{
    int ans = 0;
    std::iota(perm + 1, perm + 1 + n, 1);
    do
    {
        int curr = 0;
        int last = 0;
        for (int i = 1 ; i <= n ; ++i)
        {
            for (const int &j : songs[perm[i]])
            {
                if (j > last)
                {
                    curr++;
                    last = j;
                }
            }
        }

        ans = std::max(ans, curr);
    } while (std::next_permutation(perm + 1, perm + 1 + n));
    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        int k, curr;
        std::cin >> k;
        for (int j = 1 ; j <= k ; ++j)
        {
            std::cin >> curr;
            if (songs[i].empty() || curr > songs[i].back())
            {
                songs[i].push_back(curr);
                nums.push_back({curr, i});
            }
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}