#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int INF = 0x3f3f3f3f;
const int MAX_AI = 2e5 + 100;

vector<int> filter_ai(const vector<int>& ai) {
    vector<int> b;
    b.push_back(ai[0]);
    for (int aij : ai) {
        if (aij > b.back()) {
            b.push_back(aij);
        }
    }
    return b;
}

struct seg_tree {
    struct node {
        int l, r;
        int value;
    };

    vector<node> tree;

    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = {l, r, 0};
            return;
        }

        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = {l, r, 0};
    }

    seg_tree(int n) {
        tree.resize(4 * n);
        build(0, 0, n);
    }

    void upd(int v, int k, int c) {
        if (tree[v].r - tree[v].l == 1) {
            tree[v].value = max(tree[v].value, c);
            return;
        }

        int m = (tree[v].l + tree[v].r) / 2;
        if (k < m) {
            upd(2 * v + 1, k, c);
        } else {
            upd(2 * v + 2, k, c);
        }
        tree[v].value = max(tree[2 * v + 1].value, tree[2 * v + 2].value);
    }

    int get(int v, int l, int r) {
        if (tree[v].r <= l || r <= tree[v].l) {
            return -INF;
        }
        if (l <= tree[v].l && tree[v].r <= r) {
            return tree[v].value;
        }
        return max(get(2 * v + 1, l, r), get(2 * v + 2, l, r));
    }
};

void solve() {
    int n, ki;
    cin >> n;

    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> ki;
        a[i].resize(ki);
        for (int j = 0; j < ki; ++j) {
            cin >> a[i][j];
        }
        a[i] = filter_ai(a[i]);
    }

    sort(a.begin(), a.end(), [](const auto& x, const auto& y) {
        return x.back() < y.back();
    });

    seg_tree dp(MAX_AI);
    for (int i = 0; i < n; ++i) {
        int k = (int) a[i].size();
        dp.upd(0, a[i].back(), k);
        for (int j = 0; j < k; ++j) {
            dp.upd(0, a[i].back(), dp.get(0, 0, a[i][j]) + k - j);
        }
    }

    cout << dp.get(0, 0, MAX_AI) << "\n";
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}