#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 2e5 + 300, mod = 1e9 + 7;
struct seg_tree{
    ll size;
    vector<ll> tree;
    void init(ll x){
        size = 1;
        while(size < x)
            size *= 2;
        tree.assign(size * 2 - 1, 0);
    }
    void set(ll lx, ll rx, ll x, ll i, ll v){
        if(rx - lx == 1){
            tree[x] = v;
            return;
        }
        ll m = (lx + rx) / 2;
        if(i < m)
            set(lx, m, x * 2 + 1, i, v);
        else
            set(m, rx, x * 2 + 2, i, v);
        tree[x] = max(tree[x * 2 + 1], tree[x * 2 + 2]);
    }
    void set(ll i, ll v){
        set(0, size, 0, i, v);
    }
    ll get_max(ll lx, ll rx, ll x, ll l, ll r){
        if(lx >= r || rx <= l)
            return 0;
        if(lx >= l && rx <= r)
            return tree[x];
        ll m = (lx + rx) / 2;
        ll a = get_max(lx, m, x * 2 + 1, l, r);
        ll b = get_max(m, rx, x * 2 + 2, l, r);
        return max(a, b);
    }
    ll get_max(ll l, ll r){
        return get_max(0, size, 0, l, r);
    }
};
void solve(){
    ll n;
    cin >> n;
    vector<vector<ll>> nums(n);
    vector<ll> max_val(n + 1);
    for(int i = 0; i < n; i++){
        ll k;
        cin >> k;
        for(int j = 0; j < k; j++){
            ll x;
            cin >> x;
            nums[i].push_back(x);
            max_val[i] = max(max_val[i], x);
        }
    }
    vector<ll> order;
    for(int i = 0; i < n; i++)
        order.push_back(i);
    vector<vector<ll>> path(n);
    for(int i = 0; i < n; i++){
        path[i].push_back(nums[i][0]);
        for(int j = 1; j < nums[i].size(); j++)
            if(path[i].back() < nums[i][j])
                path[i].push_back(nums[i][j]);
    }
    seg_tree st;
    st.init(limit);
    sort(order.begin(), order.end(), [&](ll a, ll b){
        return max_val[a] < max_val[b];
    });
    vector<ll> vals(limit);
    for(int pos = 0; pos < n; pos++){
       ll len = 0, i = order[pos];
       for(int j = path[i].size() - 1; j >= 0; j--){
           len++;
           ll val = len + st.get_max(0, path[i][j]);
           vals[path[i].back()] = max(vals[path[i].back()], val);
           st.set(path[i].back(), vals[path[i].back()]);
          // cout << path[i][j] << " " << vals[path[i].back()] << "\n";
       }
    }
    cout << *max_element(vals.begin(), vals.end());
}
int main(){
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}
