﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e17);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<vector<pair<ll, ll>>> b;
vector<vector<ll>> a, dp;
vector<ll> mx;
ll n;


ll fn(const vector<ll>& pr) {
	ll x = 0;
	ll res = 0;

	for (auto& i : pr) {
		/*
		ll buf = lower_bound(b[i].begin(), b[i].end(), make_pair(x + 1, -1ll)) - b[i].begin();
		res += dp[i][buf];
		x = max(x, mx[i]);
		*/
		for (ll j = 0; j < a[i].size(); ++j) {
			if (x < a[i][j]) {
				x = a[i][j];
				++res;
			}
		}
	}

	return res;
}


void solve(istream& cin, ostream& cout) {
	cin >> n;
	a.resize(n);
	b.resize(n);
	dp.resize(n);
	mx.resize(n);


	for (auto& t : a) {
		ll k;
		cin >> k;
		t.resize(k);
		for (auto& u : t)
			cin >> u;
	}

	vector<ll> stack, r;
	for (ll i = 0; i < n; ++i) {
		stack.clear();
		r.clear();
		r.resize(a[i].size(), a[i].size());


		for (ll j = 0; j < a[i].size(); ++j) {
			while (!stack.empty() && a[i][stack.back()] < a[i][j]) {
				r[stack.back()] = j;
				stack.pop_back();
			}
			stack.push_back(j);
		}


		dp[i].resize(a[i].size() + 1, 0);
		for (ll j = a[i].size() - 1; j >= 0; --j) {
			dp[i][j] = 1 + dp[i][r[j]];
			mx[i] = max(mx[i], a[i][j]);
		}


		b[i].resize(a[i].size());
		for (ll j = 0; j < a[i].size(); ++j)
			b[i][j] = { a[i][j], j };
		sort(b[i].begin(), b[i].end());
	}


	vector<ll> pr(n);
	for (ll i = 0; i < n; ++i)
		pr[i] = i;

	ll res = 0;
	do {
		res = max(res, fn(pr));
	} while (next_permutation(pr.begin(), pr.end()));


	cout << res << '\n';
}