﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = int;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e9);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<vector<pair<ll, ll>>> b;
vector<vector<ll>> a, dp;
vector<ll> mx;
ll n;


ll fnDebug(const vector<ll>& pr) {
	ll x = 0;
	ll res = 0;

	for (auto& i : pr) {
		/*
		ll buf = lower_bound(b[i].begin(), b[i].end(), make_pair(x + 1, -1ll)) - b[i].begin();
		res += dp[i][buf];
		x = max(x, mx[i]);
		*/
		for (ll j = 0; j < a[i].size(); ++j) {
			if (x < a[i][j]) {
				x = a[i][j];
				++res;
			}
		}
	}

	return res;
}


ll fn(const vector<ll>& pr) {
	ll x = 0;
	ll res = 0;

	for (auto& i : pr) {
		ll buf = lower_bound(b[i].begin(), b[i].end(), make_pair(x + 1, -1)) - b[i].begin();
		res += dp[i][b[i][buf].second];
		x = max(x, mx[i]);
	}

	return res;
}


void solve(istream& cin, ostream& cout) {
	a.clear();
	b.clear();
	dp.clear();
	mx.clear();

	// n = 5;
	cin >> n;
	a.resize(n);
	b.resize(n);
	dp.resize(n);
	mx.resize(n);


	ll mmx = 0;


	for (auto& t : a) {
		ll k = 5;
		cin >> k;
		t.resize(k);
		for (auto& u : t) {
			// u = rnd() % 10 + 1;
			cin >> u;
			mmx = max(mmx, u);
		}
	}


	if (mmx == 1) {
		cout << "1\n";
		return;
	}

	vector<ll> stack, r;
	for (ll i = 0; i < n; ++i) {
		stack.clear();
		r.clear();
		r.resize(a[i].size(), a[i].size());


		for (ll j = 0; j < a[i].size(); ++j) {
			while (!stack.empty() && a[i][stack.back()] < a[i][j]) {
				r[stack.back()] = j;
				stack.pop_back();
			}
			stack.push_back(j);
		}


		dp[i].resize(a[i].size() + 1, 0);
		for (ll j = a[i].size() - 1; j >= 0; --j) {
			dp[i][j] = 1 + dp[i][r[j]];
			mx[i] = max(mx[i], a[i][j]);
		}


		b[i].emplace_back(a[i][0], 0);
		for (ll j = 1; j < a[i].size(); ++j) {
			if (a[i][j] > b[i].back().first)
				b[i].emplace_back(a[i][j], j);
		}
		b[i].emplace_back(INF, a[i].size());
	}


	if (mmx == 2) {
		bool is_one = false;
		bool is_two = false;
		for (auto& t : b) {
			for (ll i = 0; i < t.size(); ++i) {
				if (t[i].first == 1)
					is_one = true;
				if (t[i].first == 2)
					is_two = true;
			}
		}
		if (is_one && is_two)
			cout << "2\n";
		else
			cout << "1\n";
		return;
	}


	vector<ll> pr(n);
	for (ll i = 0; i < n; ++i)
		pr[i] = i;
	sort(pr.begin(), pr.end(), [&](ll x, ll y) {return mx[x] < mx[y]; });


	ll res = 0;
	map<ll, ll> mp;
	mp[0] = 0;
	for (auto& i : pr) {
		ll cnt = 0;
		for (auto t = mp.begin(); t != mp.end() && cnt < 30; ++t, ++cnt) {
			auto& [x, sum] = *t;
			if (x >= mx[i])
				break;
			ll buf = lower_bound(b[i].begin(), b[i].end(), make_pair(x + 1, -1)) - b[i].begin();
			mp[max(x, mx[i])] = max(mp[max(x, mx[i])], sum + dp[i][b[i][buf].second]);
			res = max(res, sum + dp[i][b[i][buf].second]);
		}
		cnt = 0;
		for (auto t = --mp.lower_bound(mx[i]); t != mp.begin() && cnt < 20; --t, ++cnt) {
			auto& [x, sum] = *t;
			if (x >= mx[i])
				break;
			ll buf = lower_bound(b[i].begin(), b[i].end(), make_pair(x + 1, -1)) - b[i].begin();
			mp[max(x, mx[i])] = max(mp[max(x, mx[i])], sum + dp[i][b[i][buf].second]);
			res = max(res, sum + dp[i][b[i][buf].second]);
		}
	}


	cout << res << '\n';
}