#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5 + 1, mod = 1e9 + 7, INF = 1e18;

struct node {
    ll l, r, mx;
};

vector<node> tree(4 * N);

void build(ll v, ll l, ll r){
    if(r - l == 1){
        tree[v] = {l, r, 0};
    } else {
        ll m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = {l, r, 0};
    }
}

void update(ll v, ll pos, ll x){
    if(tree[v].r - tree[v].l == 1){
        tree[v].mx = max(tree[v].mx, x);
    } else {
        ll m = (tree[v].l + tree[v].r) / 2;
        if(pos < m){
            update(2 * v + 1, pos, x);
        } else {
            update(2 * v + 2, pos, x);
        }
        tree[v].mx = max(tree[2 * v + 1].mx, tree[2 * v + 2].mx);
    }
}

ll get(ll v, ll l, ll r){
    if(l <= tree[v].l && r >= tree[v].r){
        return tree[v].mx;
    }
    if(l >= tree[v].r || tree[v].l >= r){
        return 0;
    }
    return max(get(2 * v + 1, l, r), get(2 * v + 2, l, r));
}

bool cmp(const pair<ll, vector<ll>>& a, const pair<ll, vector<ll>>& b){
    return a.first < b.first;
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, vector<ll>>> a(n);
    for(ll i = 0; i < n; i++){
        ll cnt, mx = 0;
        cin >> cnt;
        for(ll j = 0; j < cnt; j++){
            ll k;
            cin >> k;
            mx = max(mx, k);
            a[i].second.push_back(k);
        }
        a[i].first = mx;
    }
    sort(a.begin(), a.end(), cmp);
    vector<vector<ll>> pos(n);
    for(ll i = 0; i < n; i++){
        ll mx = 0;
        for(ll j = 0; j < (ll)a[i].second.size(); j++){
            if(mx < a[i].second[j]){
                mx = a[i].second[j];
                pos[i].push_back(j);
            }
        }
    }
    build(0, 0, N);
    vector<ll> dp(N);
    for(ll i = 0; i < n; i++){
        for(ll j = 0; j < pos[i].size(); j++){
            ll ps = pos[i][j];
            ll mx = get(0, 0, a[i].second[ps]);
            update(0, a[i].first, mx + (ll)pos[i].size() - j);
        }
    }
    ll ans = get(0, 0, N);
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
