#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <numeric>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;

template<typename T> bool minravno(T& a, const T& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> bool maxravno(T& a, const T& b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename T> void print(const T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}
template<typename T> void sort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void rsort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
	reverse(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void reverse(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	reverse(a.begin() + i, a.begin() + (j + 1));
}
const int MAXN = 2e5 + 10;

vi a[MAXN];
int dp1[MAXN], dp2[MAXN];

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n;
	cin >> n;
	for (int i = 1; i <= n; ++i) {
		int mx = 0;
		int k;
		cin >> k;
		while (k--) {
			int x;
			cin >> x;
			if (maxravno(mx, x))
				a[i].push_back(x);
		}
	}
	a[0].push_back(0);
	vi b(n);
	iota(all(b), 1);
	sort(all(b), [&](int i, int j) {
		return a[i].back() < a[j].back();
		});
	for (auto i : b) {
		for (int j = 0; j < a[i].size(); ++j) {
			for (int k = a[i][j] - 1; k >= 0; --k)
				maxravno(dp1[a[i].back()], dp1[k] + (int)a[i].size() - j);
		}
	}
	reverse(b);
	for (auto i : b) {
		for (int j = 0; j < a[i].size(); ++j) {
			for (int k = a[i].back() + 1; k < MAXN; ++k)
				maxravno(dp2[a[i][j]], dp2[k] + (int)a[i].size() - j);
		}
	}

	int ans = 0;
	for (int k = 1; k < MAXN; ++k)
		maxravno(ans, dp1[k - 1] + dp2[k]);
	cout << ans;
	return 0;
}