#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

void solve()
{
	long long n;
	vector<vector<long long>> v;
	cin >> n;
	v.resize(n);
	for (long long i = 0; i < n; i++)
	{
		long long k;
		cin >> k;
		for (long long j = 0; j < k; j++)
		{
			long long x;
			cin >> x;
			if (!v[i].size() || v[i].back() < x)
			{
				v[i].push_back(x);
			}
		}
	}
	sort(v.begin(), v.end(),
		[](vector<long long>& x, vector<long long>& y)
		{
			return x.back() < y.back();
		}
	);
	
	vector<long long> dp(n + 1);
	for (long long i = 1; i < n + 1; i++)
	{
		dp[i] = v[i - 1].size();
		for (long long j = v[i - 1].size() - 1; j > -1; j--)
		{
			long long left = -1, right = i;
			while (right - left > 1)
			{
				long long mid = (left + right) / 2;
				if (v[mid].back() < v[i - 1][j])
				{
					left = mid;
				}
				else
				{
					right = mid;
				}
			}
			dp[i] = max(dp[i], dp[left + 1] + ((long long)v[i - 1].size() - j));
		}
		dp[i] = max(dp[i], dp[i - 1]);
	}
	cout << dp[n] << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*























*/
