#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <random>
#include <unordered_map>

using namespace std;
typedef long long ll;

ll bin_pow(ll a, ll n) {
	if (n == 0)
		return 1;
	if (n & 1)
		return a * bin_pow(a, n - 1);
	ll b = bin_pow(a, n / 2);
	return b * b;
}

vector<vector<int>>arr;

bool comp(int a, int b) {
	return arr[a].back() < arr[b].back();
}

vector<int>tree;
int sz = 2e5 + 1;
void upd(int i, int x, int l = 0, int r = sz, int v = 0) {
	if (i < l || r <= i)
		return;
	if (l + 1 == r) {
		tree[v] = max(tree[v], x);
		return;
	}
	int m = (l + r) / 2;
	upd(i, x, l, m, 2 * v + 1);
	upd(i, x, m, r, 2 * v + 2);
	tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
}
int get(int ql, int qr, int l = 0, int r = sz, int v = 0) {
	if (ql <= l && r <= qr) {
		return tree[v];
	}
	if (qr <= l || r <= ql)
		return 0;
	int m = (l + r) / 2;
	return max(get(ql, qr, l, m, 2 * v + 1), get(ql, qr, m, r, 2 * v + 2));
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	vector<int>p(n);
	arr.resize(n);
	for (int i = 0; i < n; i++) {
		p[i] = i;
		int k; cin >> k;
		for (int j = 0; j < k; j++) {
			int x; cin >> x;
			if (!arr[i].empty() && arr[i].back() >= x)
				continue;
			arr[i].push_back(x);
		}
	}
	tree.resize(4 * sz);
	sort(p.begin(), p.end(), comp);
	for (auto i : p) {
		int res = 0;
		for (int j = 0; j < arr[i].size(); j++) {
			res = max(res, int(arr[i].size()) - j + get(0, arr[i][j]));
		}
		upd(arr[i].back(), res);
	}
	cout << get(0, sz);
	return 0;
}