#ifndef DEBUG
#pragma GCC optimize("-Ofast")
#pragma GCC target("avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#ifdef DEBUG
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ---


void solve() {
  ll n;
  cin >> n;
  vvi a(n);
  for (int i = 0; i < n; ++i) {
    ll k;
    cin >> k;
    vi b(k);
    cin >> b;
    ll last = 0;
    for (auto e : b) {
      if (e > last) a[i].emplace_back(e);
      last = max(last, e);
    }
  }

  sort(a.begin(), a.end(), [&](const vi &a, const vi &b) {
    return a.back() < b.back();
  });

  vi dp(n);
  ll ans = 0;
  for (int i = 0; i < n; ++i) {
    dp[i] = a[i].size();
//    for (int j = 0; j < i; ++j) {
//      dp[i] = max(dp[i], dp[j] +
//          (lower_bound(a[i].rbegin(), a[i].rend(), a[j].back(), greater<>()) - a[i].rbegin()));
//    }
    for (ll ei = 0; ei < a[i].size(); ++ei) {
      auto e = a[i][ei];
      ll j = (a.rend() - upper_bound(a.rbegin(),
                                     a.rend(),
                                     e, [&](ll e, const vi &a) -> bool {
            return e > a.back();
          })) - 1;
      if (j == -1) continue;
      dp[i] = max(dp[i], dp[j] + (ll) (a[i].size() - ei));
    }
    ans = max(ans, dp[i]);
  }

  cout << ans << endl;
}