#include <bits/stdc++.h>

using namespace std;

struct segmentTree {
    struct node {
        int mx, idx;
    };

    int size = 1;
    vector<pair<int, int>> t;

    void init(int n) {
        while (size < n) {
            size <<= 1;
        }
        t.resize(2 * size - 1);
    }

    void set(int i, int v) {
        t[i + size - 1] = {v, i};
        i += size - 1;
        while (i > 0) {
            i = (i - 1) / 2;
            t[i] = max(t[2 * i + 1], t[2 * i + 2]);
        }
    }

    pair<int, int> get(int l, int r) {
        l += size - 1;
        r += size - 2;
        pair<int, int> mx = {0, 0};
        while (l <= r) {
            if (!(l & 1)) {
                mx = max(mx, t[l]);
            }
            l >>= 1;
            if (r & 1) {
                mx = max(mx, t[r]);
            }
            r >>= 1;
            r--;
        }
        return mx;
    }
};

const int N = 200'000;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }

    vector<vector<int>> q(n);

    for (int i = 0; i < n; i++) {
        int m = (int) a[i].size();
        int mx = 0;
        for (int j = 0; j < m; j++) {
            if (a[i][j] > mx) {
                mx = a[i][j];
                q[i].push_back(a[i][j]);
            }
        }
    }

    vector<vector<int>> f(N + 1);
    for (int i = 0; i < n; i++) {
        f[q[i].back()].push_back(i);
    }

    vector<int> dp(N + 1);
    for (int i = 1; i < N + 1; i++) {
        dp[i] = dp[i - 1];
        for (auto it : f[i]) {
            int x = (int) q[it].size();
            for (int j = 0; j < x; j++) {
                dp[i] = max(dp[i], dp[q[it][j] - 1] + x - j);
            }
        }
    }
    cout << dp[N] << "\n";
}