#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

const int MAXN = (1 << 18);

int st[2 * MAXN];
void upd(int v, int val) {
	v = v + MAXN;
	st[v] = val;
	while (v > 1) {
		v /= 2;
		st[v] = max(st[2 * v], st[2 * v + 1]);
	}
}

int get_max(int l, int r) {
	int vl = l + MAXN;
	int vr = r + MAXN;
	int res = 0;
	while (vl <= vr) {
		if (vl & 1) {
			res = max(res, st[vl]);
			vl++;
		}
		if ((vr & 1) == 0) {
			res = max(res, st[vr]);
			vr--;
		}
		vl /= 2;
		vr /= 2;
	}
	return res;
}

void solve() {
	int n;
	cin >> n;
	vector <vector <int>> a(n);
	vector <pair <int, int>> tosort;
	int k;
	for (int i = 0; i < n; i++) {
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; j++)
			cin >> a[i][j];
		int ma = -1e9;
		for (auto e : a[i])
			ma = max(ma, e);
		tosort.push_back({ ma, i });
	}
	sort(tosort.begin(), tosort.end());
	vector <vector <int>> b(n);
	for (int i = 0; i < n; i++) {
		int id = tosort[i].second;
		b[i].push_back(a[id][0]);
		for (int j = 1; j < a[id].size(); j++)
			if (a[id][j] > b[i].back())
				b[i].push_back(a[id][j]);
	}
	vector <int> dp(n, 0);
	dp[0] = (int)b[0].size();
	upd(0, dp[0]);
	for (int i = 1; i < n; i++) {
		int sz = (int)b[i].size();
		dp[i] = sz;
		for (int cnt = 1; cnt <= sz; cnt++) {
			int st = 0;
			if (b[0].back() >= b[i][sz - cnt])
				st = -1;
			int l = 0, r = i;
			while (l < r) {
				int mid = (l + r + 1) / 2;
				if (b[mid].back() < b[i][sz - cnt])
					l = mid;
				else
					r = mid - 1;
			}
			int f = l;
			if (st != -1)
				dp[i] = max(dp[i], get_max(st, f) + cnt);
		}
		upd(i, dp[i]);
	}
	int ans = get_max(0, n - 1);
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}