#include <iostream>
#include <vector>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

int INF = 2e9;

bool cmp(vector<int> o1, vector<int> o2) {
    return o1.back() < o2.back();
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<vector<int>> albums(n);
    range(i, n) {
        int k, t;
        cin >> k >> t;
        albums[i] = {t};
        loop(k - 1) {
            cin >> t;
            if (t > albums[i].back()) {
                albums[i].push_back(t);
            }
        }
    }
    sort(albums.begin(), albums.end(), cmp);
    vector<pair<int, int>> dp(n + 1, {INF, 0});
    dp[0] = {0, 0};
    range(i0, n) {
        vector<int> album = albums[i0];
        int i = i0 + 1;
        range(j, i) {
            auto [val, ans0] = dp[j];
            if (val < album[0]) {
                if (dp[i].second < album.size() + ans0) {
                    dp[i] = {album.back(), album.size() + ans0};
                }
            } else {
                int L = 0,
                    R = album.size();
                while (L + 1 != R) {
                    int c = (L + R) / 2;
                    if (val < album[c]) {
                        R = c;
                    } else {
                        L = c;
                    }
                }
                if (dp[i].second < album.size() - R + ans0) {
                    dp[i] = {album.back(), album.size() - R + ans0};
                }
            }
        }
    }
    cout << dp.back().second << endline;
}
