#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

const int INF = 2e9;

int n;
vector<vector<int>> albums;

bool cmp(vector<int> o1, vector<int> o2) {
    if (o1.back() == o2.back()) {
        if (o1.size() >= 2 && o2.size() >= 2) {
            return o1[o1.size() - 2] > o2[o2.size() - 2];
        }
        return o2.size() >= 2;
    }
    return o1.back() < o2.back();
}

void solve1() {
    vector<pair<int, int>> dp(n + 1, {INF, 0});
    dp[0] = {0, 0};
    range(i0, n) {
        vector<int> album = albums[i0];
        int i = i0 + 1;
        range(j, i) {
            auto [val, ans0] = dp[j];
            if (val < album[0]) {
                if (dp[i].second < album.size() + ans0) {
                    dp[i] = {album.back(), album.size() + ans0};
                }
            } else {
                int L = 0,
                        R = album.size();
                while (L + 1 != R) {
                    int c = (L + R) / 2;
                    if (val < album[c]) {
                        R = c;
                    } else {
                        L = c;
                    }
                }
                if (dp[i].second < album.size() - R + ans0) {
                    dp[i] = {album.back(), album.size() - R + ans0};
                }
            }
        }
    }
    cout << dp.back().second << endline;
}

void solve2() {
    vector<bool> found(3, false);
    for (auto v: albums) {
        for (int value: v) {
            found[value] = true;
        }
    }
    cout << found[1] + found[2] << endline;
}

void solve3() {
    int ans = 0;
    int last = 0;
    for (auto album: albums) {
        for (int value : album) {
            ans += value > last;
            last = value;
        }
    }
    cout << ans << endline;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    cin >> n;
    albums.resize(n);
    int max_len = 0;
    range(i, n) {
        int k, t;
        cin >> k >> t;
        albums[i] = {t};
        loop(k - 1) {
            cin >> t;
            if (t > albums[i].back()) {
                albums[i].push_back(t);
            }
        }
        max_len = max(max_len, (int) albums[i].size());
    }
    sort(albums.begin(), albums.end(), cmp);
    if (max_len <= 2) {
        solve3();
    } else if (n > 1000) {
        solve2();
    } else {
        solve1();
    }
}
