#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

const int N = 1005;

void solve() {
  int n;
  cin >> n;
  vector<vector<int>> a(n);
  for (int i = 0; i < n; i++) {
    int k;
    cin >> k;
    int prv = -1;
    for (int j = 0; j < k; j++) {
      int x;
      cin >> x;
      if (x > prv) {
        a[i].push_back(x);
        prv = x;
      }
    }
  }

  vector<int> dp(N);
  for (int i = 0; i < N; i++) {
    for (int j = 0; j < n; j++) {
      int id = upper_bound(all(a[j]), i) - a[j].begin();
      int cnt = sz(a[j]) - id;
      if (cnt > 0) {
        dp[a[j].back()]= max(dp[a[j].back()], dp[i] + cnt);
      }
    }
  }

  cout << *max_element(all(dp));
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}