#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

const int N = 2e5 + 5;

void solve() {
  int n;
  cin >> n;
  vector<vector<int>> a(n);
  for (int i = 0; i < n; i++) {
    int k;
    cin >> k;
    int prv = -1;
    for (int j = 0; j < k; j++) {
      int x;
      cin >> x;
      if (x > prv) {
        a[i].push_back(x);
        prv = x;
      }
    }
  }

  sort(all(a), [&] (const vector<int>& ar1, const vector<int>& ar2) {
    return ar1.back() < ar2.back();
  });

  vector<int> dp(N), pref(N);
  int calc_to = 1;
  for (int i = 0; i < n; i++) {
    int val = a[i].back();
    dp[val] = sz(a[i]);
    for (int j = sz(a[i]) - 1; j >= 0; j--) {
      dp[val] = max(dp[val], pref[a[i][j] - 1] + sz(a[i]) - j);
    }
    while (calc_to < val) {
      pref[calc_to] = max(dp[calc_to], pref[calc_to - 1]);
      calc_to++;
    }
    pref[val] = max(dp[val], pref[val - 1]);
  }

  cout << *max_element(all(dp));
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}