use std::io::{self, prelude::*};

fn main() -> io::Result<()> {
    let mut scan = Scanner::new(io::BufReader::new(io::stdin().lock()));
    let mut w = io::BufWriter::new(io::stdout().lock());

    let n = scan.token();
    let mut a: Vec<(i32, i32)> = (0..n).map(|_| (scan.token(), scan.token())).collect();
    a.sort();

    let mut suf = vec![0; n + 1];
    for i in (0..n).rev() {
        suf[i] = suf[i + 1].max(a[i].1);
    }

    let mut ans = a[..n - 1].iter().map(|x| (a[n - 1].0 - x.1).abs()).min().unwrap();
    for i in 0..(n - 1) {
        ans = ans.min((a[i].0 - suf[i + 1]).abs());
    }

    writeln!(w, "{ans}")
}

struct Scanner<R> {
    reader: R,
    buf: Vec<u8>,
    buf_iter: std::str::SplitAsciiWhitespace<'static>,
}

impl<R: BufRead> Scanner<R> {
    fn new(reader: R) -> Self {
        Self {
            reader,
            buf: vec![],
            buf_iter: "".split_ascii_whitespace(),
        }
    }

    fn token<T: std::str::FromStr>(&mut self) -> T {
        loop {
            if let Some(token) = self.buf_iter.next() {
                return token.parse().ok().expect("Failed parse");
            }
            self.buf.clear();
            self.reader
                .read_until(b'\n', &mut self.buf)
                .expect("Failed read");
            self.buf_iter = unsafe {
                let slice = std::str::from_utf8_unchecked(&self.buf);
                std::mem::transmute(slice.split_ascii_whitespace())
            };
        }
    }
}
