#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

#define int long long

int n;

bool cmp(pair<int, int> a, pair<int, int> b) {
    if (a.first == b.first) {
        return a.second > b.second;
    }
    return a.first < b.first;
}

vector<pair<int, int>> v;

void input() {
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].first >> v[i].second;
    }
}

int solve_slow() {
    set<int> all_fs;
    map<int, int> cnt_f;
    int mx_f = 0;
    for (auto i : v) {
        all_fs.insert(i.first);
        cnt_f[i.first] += 1;
        mx_f = max(mx_f, i.first);
    }
    int ans = 1e9;
    for (auto mx : all_fs) {
        vector<bool> taken(n);
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            if (v[i].first <= mx) {
                taken[i] = true;
                ++cnt;
            }
        }
        if (cnt != n) {
            int mx2 = 0;
            for (int i = 0; i < n; ++i) {
                if (!taken[i]) {
                    mx2 = max(mx2, v[i].second);
                }
            }
            ans = min(ans, abs(mx2 - mx));
        } else {
            assert(mx == mx_f);
            if (cnt_f[mx_f] > 1) {
                for (int i = 0; i < n; ++i) {
                    ans = min(ans, abs(mx - v[i].second));
                }
            } else {
                for (int i = 0; i < n; ++i) {
                    if (v[i].first == mx) continue;
                    ans = min(ans, abs(mx - v[i].second));
                }
            }
        }
    }
    return ans;
}

int solve_fast() {
    sort(v.begin(), v.end(), cmp);
    vector<int> suf(n);
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = v[i].second;
        if (i != n - 1) {
            suf[i] = max(suf[i], suf[i + 1]);
        }
    }
    int ans = 1e9;
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(v[i].first - suf[i + 1]));
    }
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(v[n - 1].first - v[i].second));
    }
    return ans;
}

void solve() {
    input();
    cout << solve_slow();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    while (cin >> n) {
        solve();
        cout << "\n";
    }
}