#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 2e9 + 7;
const ld eps = 1e-9;

struct segment_tree {
	vector<ll> promise;
	vector<ll> sum;
	ll sz = 1;
	void dub(ll n) {
		while (sz < n) sz *= 2;
	}
	segment_tree(vector<ll>& arr) {
		dub(arr.size());
		sum.resize(2 * sz);
		promise.resize(2 * sz);
		build(1, 0, sz, arr);
	}
	void build(ll id, ll l, ll r, vector<ll>& arr) {
		if (r - l == 1 && l < arr.size()) {
			sum[id] = arr[l];
			return;
		}
		if (r - l == 1) {
			sum[id] = INF;
			return;
		}
		ll m = (r + l) / 2;
		build(2 * id, l, m, arr);
		build(2 * id, m, r, arr);
		sum[id] = min(sum[2 * id], sum[2 * id + 1]);
	}
	void push(ll id, ll l, ll r) {
		sum[id] += promise[id];
		if (r - l > 1) {
			promise[2 * id] += promise[id];
			promise[2 * id] += promise[id];
		}
		promise[id] = 0;
	}
	void upd(ll id, ll l, ll r, ll l_q, ll r_q, ll val) {
		push(id, l, r);
		if (l_q <= l && r <= r_q) {
			promise[id] += val;
			push(id, l, r);
			return;
		}
		if (l_q >= r || l >= r_q) return;
		
	}
};


vector<vector<ll>> help;


ll count(ll l, ll r) {
	return help[l].size() + help[r].size() - (upper_bound(help[r].begin(), help[r].end(), help[l].back()) - help[r].begin());
}
bool f(ll l, ll r) {
	if (count(l, r) > count(r, l)) return true;
	return false;
}

signed main() {
	ll n; cin >> n;
	vector<pair<ll, ll>> mas(n);
	multiset<ll> ml;
	multiset<ll> options;
	for (auto& it : mas) cin >> it.first >> it.second;
	for (ll x = 0; x < n; x++) {
		ml.insert(mas[x].second);
	}
	options.insert(INF);
	options.insert(-INF);
	ll mini = INF;
	sort(mas.begin(), mas.end());
	for (ll x = 0; x < n - 1; x++) {
		ml.erase(ml.find(mas[x].second));
		int the_end = *(--ml.end());
		mini = min(mini, abs(the_end - mas[x].first));
		auto ind = options.upper_bound(mas[x].first);
		if (*ind > the_end) {
			mini = min(mini, abs(*ind - mas[x].first));
		}
		ind--;
		if (*ind > the_end) {
			mini = min(mini, abs(*ind - mas[x].first));
		}
		options.insert(mas[x].second);
	}
	auto ind = options.upper_bound(mas.back().first);
	mini = min(mini, abs(*ind - mas.back().first));
	ind--;
	mini = min(mini, abs(*ind - mas.back().first));
	cout << mini;
}
 