#include <iostream>
#include <vector>

using namespace std;

struct tree{
    vector<pair<long long, long long>> tr;
    vector<long long> v;

    void build(long long id, long long l, long long r) {
        if (r - l == 1) {
            tr[id] = {v[l], l};
            return;
        }
        long long mid = (l + r) / 2;
        build(id * 2 + 1, l, mid);
        build(id * 2 + 2, mid, r);
        tr[id] = max(tr[id * 2 + 1], tr[id * 2 + 2]);
    }

    tree(vector<long long> v) {
        this->v = v;
        tr.resize(v.size() * 4);
        build(0, 0, v.size());
    }

    void change(long long id, long long l, long long r, long long i, long long x) {
        if (r - l == 1) {
            tr[id] = {x, l};
            return;
        }
        long long mid = (l + r) / 2;
        if (i < mid) {
            change(id * 2 + 1, l, mid, i, x);
        } else {
            change(id * 2 + 2, mid, r, i, x);
        }
        tr[id] = max(tr[id * 2 + 1], tr[id * 2 + 2]);
    }

    pair<long long, long long> ask(long long id, long long l, long long r, long long ql, long long qr) {
        if (ql <= l && r <= qr) {
            return tr[id];
        }
        if (r <= ql || qr <= l) {
            return {0, -1};
        }
        long long mid = (l + r) / 2;
        return max(ask(id * 2 + 1, l, mid, ql, qr), ask(id * 2 + 2, mid, r, ql, qr));
    }
};

int main()
{
    long long n;
    cin >> n;
    vector<long long> a(n);
    vector<long long> b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }
    tree a1(a);
    tree b1(b);
    long long mn = 1e9;
    for (int i = 0; i < n; i++) {
        long long w1 = a1.tr[0].first, w2 = b1.tr[0].first;
        if (w1 > w2) {
            long long id = a1.tr[0].second;
            long long t = max(b1.ask(0, 0, n, 0, id).first, b1.ask(0, 0, n, id + 1, n).first);
            //cout << w1 << " " << w2 << " " << id << " " << t <<" A" << endl;
            mn = min(mn, w1 - t);
            a1.change(0, 0, n, id, 0);
        } else {
            long long id = b1.tr[0].second;
            long long t = max(a1.ask(0, 0, n, 0, id).first, a1.ask(0, 0, n, id + 1, n).first);
            mn = min(mn, w2 - t);
            //cout << w1 << " " << w2 << " " << id << " " << t << " B" << endl;
            b1.change(0, 0, n, id, 0);
        }
    }
    cout << mn;
    return 0;
}
