#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto &u : v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (auto &u : v) {
        os << u << ' ';
    }
    return os;
}


struct segtree {
    int n;
    vector<int> tree;

    segtree(int _n) {
        n = _n;
        tree.resize(2 * n);
    }

    void set(int i, int v) {
        i += n;
        tree[i] = v;
        i /= 2;
        while (i > 0) {
            tree[i] = max(tree[2 * i], tree[2 * i + 1]);
            i /= 2;
        }
    }

    int get(int l, int r) {
        l += n;
        r += n;
        int ans = INT64_MAX;
        while (l <= r) {
            if (l % 2 == 0) {
                ans = max(ans, tree[l]);
                l += 1;
            }
            if (r % 2 == 1) {
                ans = max(ans, tree[r]);
                r -= 1;
            }
            l /= 2;
            r /= 2;
        }
        return ans;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> ab(n);
    for (int i = 0; i < n; ++i) {
        cin >> ab[i].first >> ab[i].second;
    }
    sort(ab.begin(), ab.end());
    vector<int> suff(n + 1);
    suff[n - 1] = ab[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        suff[i] = max(suff[i + 1], ab[i].second);
    }

    set<int> st;
    int ans = INT64_MAX;
    for (int i = 0; i < n; ++i) {
        if (i == n - 1) {
            int val1 = INT64_MAX;
            int val2 = INT64_MAX;
            if (st.lower_bound(ab[i].first) != st.end()) {
                val1 = *st.lower_bound(ab[i].first);
            }
            if (st.lower_bound(ab[i].first) != st.begin()) {
                val2 = *--st.lower_bound(ab[i].first);
            }

            if (abs(val2 - ab[i].first) < ans) {
                ans = abs(val2 - ab[i].first);
            }
            if (abs(val1 - ab[i].first) < ans) {
                ans = abs(val1 - ab[i].first);
            }
            continue;
        }
        int cur = suff[i + 1];
        int val1 = INT64_MAX;
        int val2 = INT64_MAX;
        if (st.lower_bound(ab[i].first) != st.end()) {
            val1 = *st.lower_bound(ab[i].first);
            val1 = max(val1, cur);
        }
        if (st.lower_bound(ab[i].first) != st.begin()) {
            val2 = *--st.lower_bound(ab[i].first);
            val2 = max(val2, cur);
        }
        if (abs(cur - ab[i].first) < ans) {
            ans = abs(cur - ab[i].first);
        }
        if (abs(val2 - ab[i].first) < ans) {
            ans = abs(val2 - ab[i].first);
        }
        if (abs(val1 - ab[i].first) < ans) {
            ans = abs(val1 - ab[i].first);
        }
        st.insert(ab[i].second);
    }

    cout << ans << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day2/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}