#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>
#include<set>
#include<tuple>


#pragma GCC optimize("unroll-loops")
using namespace std;
typedef long long ll;


vector<int> tree;
const int INF = 2000000000;


void build_tree(int k, int l, int r, vector<int>& m)
{
    if (r - l == 1)
    {
        tree[k] = m[l];
        return;
    }
    build_tree(2 * k, l, (l + r) / 2, m);
    build_tree(2 * k + 1, (l + r) / 2, r, m);
    tree[k] = max(tree[2 * k], tree[2 * k + 1]);
    return;
}


int get_mx(int k, int l, int r, int lf, int rf)
{
    if (l >= rf || r <= lf)
    {
        return -INF;
    }
    if (lf <= l && rf >= r)
    {
        return tree[k];
    }
    return max(get_mx(2 * k, l, (l + r) / 2, lf, rf), get_mx(2 * k + 1, (l + r) / 2, r, lf, rf));
}



int main()
{
    int n;
    cin >> n;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; i++)
    {
        cin >> p[i].first >> p[i].second;
    }
    sort(p.begin(), p.end());
    vector<int> a(n);
    for (int i = 0; i < n; i++)
    {
        a[i] = p[i].second;
    }
    tree.resize(4 * n);
    build_tree(1, 0, n, a);
    int ans = INF;
    set<int> s;
    for (int i = 0; i < n ; i++)
    {
        int mx = get_mx(1, 0, n, i + 1, n);
        int ansnow = INF;
        int mx1 = INF;
        int mn1 = -INF;
        auto it = s.lower_bound(p[i].first);
        if (it != s.end() && *it <= p[i].first)
        {
            mn1 = max(mn1, *it);
        }
        if (it != s.begin())
        {
            --it;
            mn1 = max(mn1, *it);
        }
        auto it2 = s.upper_bound(p[i].first);
        if (it2 != s.end())
        {
            mx1 = min(mx1, *it2);
        }
        if (mn1 >= mx && mn1 != INF)
        {
            ansnow = min({ansnow, abs(p[i].first - mn1), abs(mx1 - p[i].first), abs(mx - p[i].first)});
        }
        else if (mx < mx1)
        {
            ansnow = min({ansnow, abs(mx - p[i].first), abs(mx1 - p[i].first)});
        }
        else
        {
            ansnow = min(ansnow, abs(mx - p[i].first));
        }
        ans = min(ansnow, ans);
        s.insert(p[i].second);
    }
    cout << ans;
    return 0;
}