#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n;
    vector<pair<in<int>, in<int>>> cost;

    optional<int> solve_one() {
        set<pair<int, int>> a_kek, b_kek;
        int lb = 0;
        for (int i = 0; i < n; ++i) {
            auto [a, b] = cost[i];
            a_kek.emplace(a, i);
            b_kek.emplace(b, i);
            lb = max(lb, (int) min(a, b));
        }

        optional<int> res;
        for (auto cur = a_kek.lower_bound({lb, -1}); cur != a_kek.end(); ++cur) {
            auto b_cur = b_kek.upper_bound({cur->first, -1});
            if (b_cur == b_kek.begin()) {
                continue;
            }
            --b_cur;
            while (b_cur != b_kek.begin() && b_cur->second == cur->second) {
                --b_cur;
            }
            if (b_cur->second == cur->second) {
                continue;
            }

            int cur_res = cur->first - b_cur->first;
            if (!res || cur_res < *res) {
                //cerr << cur->first << ":" << cur->second << " " << b_cur->first << ":" << b_cur->second << endl;
                res = cur_res;
            }
        }
        return res;
    }

    solve() : cost(n) {
        auto res = solve_one();
        transform(cost.begin(), cost.end(), cost.begin(), [](auto pr) { return pair{pr.second, pr.first}; });
        auto res1 = solve_one();
        if (!res || (res1 && *res1 < *res)) {
            res = *res1;
        }
        cout << *res << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}
