#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <chrono>
#include <unordered_set>

using namespace std;
using pii = pair<int, int>;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int search(vector<pii>& a, int x, int canNot, int l, int r) {
    int predl = -1, predr = -1;
    while (r - l > 1 ) {
        predl = l;
        predr = r;
        int m1 = (2 * l + r) / 3;
        int m2 = (l + 2 * r) / 3;
        int res1 = abs(x - a[m1].first);
        int res2 = abs(x - a[m2].first);
        if (res1 <= res2) {
            r = m2;
        } else {
            l = m1;
        }
        if (predl == l && predr == r) break;
    }
    if (a[l].second == canNot) {
        if (l > 0) {
            l--;
        } else {
            l++;
        }
    }
    if (a[r].second == canNot) {
        if (r < a.size() - 2) {
            r++;
        } else {
            r--;
        }
    }
    if (abs(x - a[l].first) <= abs(x - a[r].first)) {
        return l;
    } else {
        return r;
    }
}


int main() {
    int n, x, y;
    cin >> n;
    vector<int> a;
    vector<int> b;
    vector<pii> c, d;
    int ch = 1;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        if (x != y) ch = 0;
        a.emplace_back(x);
        b.emplace_back(y);
        c.emplace_back(x, i);
        d.emplace_back(y, i);
    }
    if (ch && rnd() % 2) {
        int ans = 1e9;
        int cur = 0;
        for (int i = 0; i < n; ++i) {
            x = c[i].first;
            if (i != 0) {
                cur = max(cur, b[c[i - 1].second]);
            }
            int ind = search(d, x, c[i].second, i + 1, n);
            ans = min(ans, abs(x - max(cur, d[ind].first)));
        }
        cout << ans << endl;

    } else {
        vector<int> possible;
        for (int i = 0; i < n; ++i) {
            possible.push_back(i);
        }
        sort(c.rbegin(), c.rend());
        sort(d.rbegin(), d.rend());
        unordered_set<int> cannot;
        int ans = 1e9;
        int cur = 0;
        for (int i = 0; i < n ;++i) {
            x = c[i].first;
            if (i > 0) {
                cur = max(cur, b[c[i - 1].second]);
            }
            cannot.insert(c[i].second);
            int best = -1;
            for (int j = 0; j < n; ++j) {
                if (cannot.find(j) == cannot.end()) {
                    if (best == -1 || abs(x - b[j]) < abs(x - b[best])) {
                        best = j;
                    }
                }
            }
            ans = min(ans, abs(x - max(b[best], cur)));
        }
        cout << ans << endl;
    }
    return 0;
}