#include <iostream>
#include <iomanip>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <bitset>
#include <algorithm>
#include <ext/pb_ds/assoc_container.hpp>
#include <random>
#include <chrono>
#include <cassert>
#include <climits>

using namespace std;

using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template <typename T>
istream& operator>>(istream &in, vector <T> &arr) {
    for (T &i: arr) in >> i;
    return in;
}

template <typename T>
ostream& operator<<(ostream &out, const vector <T> &arr) {
    for (const T &i: arr) out << i << ' ';
    return out;
}

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define mp make_pair

//#define int int64_t
//#define multitest
#define ull uint64_t
#define x first
#define y second

#pragma GCC target("fma")
#pragma GCC optimize("O3")
//#pragma GCC optimize("trapv")

void solve() {
    int n;
    cin >> n;
    vector <pair <int, int>> a(n);
    for (auto &[f, s]: a) cin >> f >> s;
    sort(all(a));
    vector <int> suf_max(n);
    int mx = a[n - 1].x;
    for (int i = n - 2; i >= 0; --i) {
        suf_max[i] = mx;
        mx = max(mx, a[i].x);
    }
    int ans = INT_MAX;
    multiset <int> st1;
    multiset <int> st2;
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(a[i].x - suf_max[i]));
        if (ans == 0) {
            cout << ans << '\n';
            return;
        }
        if (a[i].x > suf_max[i]) {
            auto it = st2.lower_bound(a[i].x);
            if (it != st2.end()) {
                ans = min(ans, abs(a[i].x - *it));
            }
        }
        st1.insert(a[i].x);
        st2.insert(a[i].y);
    }
    for (auto &[f, s]: a) swap(f,s);
    st1 = multiset <int>();
    st2 = multiset <int>();
    mx = a[n - 1].x;
    for (int i = n - 2; i >= 0; --i) {
        suf_max[i] = mx;
        mx = max(mx, a[i].x);
    }
    for (int i = 0; i < n - 1; ++i) {
        ans = min(ans, abs(a[i].x - suf_max[i]));
        if (ans == 0) {
            cout << ans << '\n';
            return;
        }
        if (a[i].x > suf_max[i]) {
            auto it = st2.lower_bound(a[i].x);
            if (it != st2.end()) {
                ans = min(ans, abs(a[i].x - *it));
            }
        }
        st1.insert(a[i].x);
        st2.insert(a[i].y);
    }
    cout << ans << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("in.txt", "rt", stdin);
    freopen("out.txt", "wt", stdout);
    auto start = clock();
#endif
    int t;
#ifdef multitest
    cin >> t;
#else
    t = 1;
#endif
    while (t --> 0) solve();
#ifdef LOCAL
    auto end = clock();
    cerr << "time: " << end - start << endl;
#endif
    return 0;
}