//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cmath>
#include <math.h>
#include <algorithm>

using namespace std;

mt19937 rnd(12);

const int N = 2e5 + 11, inf = 1e9 + 111, mod = 1e9 + 7;

int n;

bool cmp(pair<int, int>& a, pair<int, int>& b) {
    if (a.second == b.second)
        return a.first > b.first;
    return a.second < b.second;
}

struct Fenwick_tree
{
    vector<int> tree;

    Fenwick_tree() {}
    Fenwick_tree(int n) {
        tree.resize(n, 0);
    }

    void upd(int i, int x) {
        while (i < tree.size()) {
            tree[i] += x;
            i |= (i + 1);
        }
    }

    int _get(int i) {
        int sum = 0;
        while (i >= 0) {
            sum += tree[i];
            i &= (i + 1);
            i--;
        }
        return sum;
    }

    int get(int l, int r) {
        int sum = _get(r);
        if (l > 0) {
            sum -= _get(l - 1);
        }
        return sum;
    }
};

int itog = inf;
unordered_map<int, int> mp;

void did(vector<pair<int, int>>& give) {
    vector<int> a(n), b(n);
    Fenwick_tree tree(n * 2 + 1);
    int cnt = 0;
    for (int i = 0; i < n; i++) {
        a[i] = give[i].first;
        b[i] = give[i].second;
        tree.upd(mp[a[i]], 1);
    }
    sort(a.begin(), a.end());
    sort(b.begin(), b.end());
    unordered_map<int, pair<int, int>> near(n);
    int now = 0;
    for (int i = 0; i < n; i++) {
        while (now < n && a[now] <= b[i]) {
            now++;
        }
        now--;
        if (now == -1) {
            near[b[i]] = { -1, -1 };
        }
        else if (now == 0) {
            near[b[i]] = { a[now], -1 };
        }
        else {
            near[b[i]] = { a[now], a[now - 1] };
        }
        now++;
    }
    sort(give.begin(), give.end(), cmp);
    now = 0;
    for (int i = 0; i < n; i++) {
        while (now < n && give[i].second == give[now].second) {
            tree.upd(mp[give[now].first], -1);
            now++;
        }
        if (tree.get(mp[give[i].second] + 1, 2 * n) != 0) continue;
        if (near[give[i].second].first == -1) continue;
        if (near[give[i].second].first == give[i].first) {
            if (near[give[i].second].second == -1) continue;
            itog = min(itog, give[i].second - near[give[i].second].second);
        }
        else {
            itog = min(itog, give[i].second - near[give[i].second].first);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    cin >> n;
    vector<pair<int, int>> give(n);
    vector<int> b(n);
    vector<int> a(n);
    vector<int> all(n * 2);
    for (int i = 0; i < n; i++) {
        cin >> give[i].first >> give[i].second;
        all[i * 2] = give[i].first;
        all[i * 2 + 1] = give[i].second;
    }
    sort(all.begin(), all.end());
    int now = 0;
    for (int elem : all) {
        if (mp.find(elem) == mp.end()) {
            mp[elem] = now;
            now++;
        }
    }
    did(give);
    for (int i = 0; i < n; i++) {
        swap(give[i].first, give[i].second);
    }
    did(give);
    cout << itog;
}
