#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>


using namespace std;

typedef long long ll;

int addm(int a, int b, int m) {
	return (a + b) % m;
}

int subm(int a, int b, int m) {
	return ((a - b) % m + m) % m;
}

int mulm(int a, int b, int m) {
	return (ll)a * b % m;
}

int bin_pow(int a, int n, int m) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, m);
		return mulm(b, b, m);
	}
	else {
		return mulm(a, bin_pow(a, n - 1, m), m);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector<ll> gcdex(ll a, ll b) {
	if (b == 0) {
		return { a, 0, a };
	}
	else {
		vector<ll> aaa = gcdex(b, a % b);
		return { aaa[1], aaa[0] - (a / b) * aaa[1], aaa[2] };
	}
}

int solve1(int n, vector<pair<int, int>> arr) {
	sort(arr.begin(), arr.end());
	vector<int> mx_suff(n + 1);
	mx_suff[n] = -1e9;
	for (int i = n - 1; i >= 0; i--) {
		mx_suff[i] = max(mx_suff[i + 1], arr[i].second);
	}
	int ans = 1e9;
	set<int> ss;
	for (int i = 0; i < n; i++) {
		int mx1 = arr[i].first;
		int mx2 = mx_suff[i + 1];
		ans = min(abs(mx1 - mx2), ans);
		if (mx2 < mx1) {
			auto it = ss.upper_bound(mx1);
			if (it != ss.begin()) {
				it--;
				mx2 = max(*it, mx2);
				ans = min(abs(mx1 - mx2), ans);
			}
		}
		ss.insert(arr[i].second);
	}
	return ans;
}

int solve2(int n, vector<pair<int, int>> arr) {
	int ans = 1e9;
	for (int mask = 0; mask < (1 << n); mask++) {
		if (mask != 0 && mask + 1 != ((1 << n))) {
			int mx1 = 0, mx2 = 0;
			for (int i = 0; i < n; i++) {
				if ((1 << i) & mask) {
					mx1 = max(arr[i].first, mx1);
				}
				else {
					mx2 = max(arr[i].second, mx2);
				}
			}
			ans = min(abs(mx1 - mx2), ans);
		}
	}
	return ans;
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int n;
	cin >> n;
	vector<pair<int, int>> arr(n);
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> arr[i].second;
	}
	// cout << solve1(n, arr);
	cout << solve2(n, arr);
	exit(0);
}