#include <bits/stdc++.h>

using namespace std;

struct Point {
    int x, y;

    Point(int x, int y) {
        this->x = x;
        this->y = y;
    }

    friend int operator%(Point a, Point b) {
        return a.x * b.y - a.y * b.x;
    }

    friend int operator*(Point a, Point b) {
        return a.x * b.x + a.y * b.y;
    }

    friend Point operator+(Point a, Point b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend Point operator-(Point a, Point b) {
        return {a.x - b.x, a.y - b.y};
    }

    long long len_sq(Point a) {
        return a.x * a.x + a.y * a.y;
    }

    double len(Point a) {
        return sqrt(len_sq(a));
    }

    long long dist_sq(Point a, Point b) {
        return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
    }

    double dist(Point a, Point b) {
        return sqrt(dist_sq(a, b));
    }

    bool check_collinear(Point a, Point b) {
        if (abs(double(a.x) / double(b.x) - double(a.y) / double(b.y)) < 1e-8) {
            return true;
        }
        return false;
    }

};

bool comp_points(Point a, Point b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

void obol(vector<Point> arr) {
    int min_x = -1e9;
    Point min(1e9, 1e9);
    queue<Point> q;
    sort(arr.begin(), arr.end(), comp_points);
    q.push(arr[0]);
    q.push(arr[1]);
    int i = 2;
}

vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

void solve() {
    int n;
    cin >> n;
    vector <int> a(n);
    vector <int> b(n);
    for (int i = 0; i < n; i++){
        cin >> a[i];
        cin >> b[i];
    }
    int max_m = (1 << n) - 1;
    vector<bool> flag(n, false);
    int ans = 1e9;
    for (int mask = 0; mask <= max_m; mask++){
        int max1 = -1e9;
        int max2 = -1e9;
        for (int k = 0; k < n; k++){
            if (((mask) | (1 << k)) == mask){
                flag[k] = true;
            }
        }
        for (int i = 0; i < n; i++){
            if (flag[i]){
                max1 = max(max1, a[i]);
            }
            else{
                max2 = max(max2, b[i]);
            }
        }
        if (abs(max1 - max2) < ans){
            ans = abs(max1 - max2);
        }
    }
    cout << ans;
}

int main() {
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
