#include<bits/stdc++.h>
#define fr first
#define sc second
#define pb push_back
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int MAXN = 1e6 + 5;
const int INF = 1e9;

struct Node{
	int mx = -INF, mn = INF;
	Node() {
		mx = -INF;
		mn = INF;
	}
	Node(int val){
		mx = mn = val;
	}
	Node(Node a, Node b){
		mx = max(a.mx, b.mx);
		mn = min(a.mn, b.mn);
	}
} segmtree[4 * MAXN];

void upd(int node, int l, int r, int x, int v){
	if(l == r){
		segmtree[node] = Node(v);
	}
	else{
		int m = (l + r) / 2;
		if(l <= x && x <= m) upd(2 * node + 0, l + 0, m, x, v);
		else				 upd(2 * node + 1, m + 1, r, x, v);
		segmtree[node] = Node(segmtree[2 * node], segmtree[2 * node + 1]);
	}
}

Node qry(int node, int l, int r, int ql, int qr){
	if(qr < l || r < ql) return Node();
	if(ql <= l && r <= qr){
		return segmtree[node];
	}
	else{
		int m = (l + r) / 2;
		return Node(qry(2 * node, l, m, ql, qr), qry(2 * node + 1, m + 1, r, ql, qr));
	}
}

int N, NN;
Node qry(int l, int r){
	if(r < l) return -1;
	else return qry(1, 1, N, l, r);
}

void build(int node = 1, int l = 1, int r = N){
	if(l == r){
		segmtree[node] = Node();
	}
	else{
		int m = (l + r) / 2;
		build(2 * node + 0, l + 0, m);
		build(2 * node + 1, m + 1, r);
		segmtree[node] = Node();
	}
}

int main(){
	int ans = INF;
	cin >> NN;
	vector<pair<int, int>> A(NN);
	vector<int> comp;
	for(auto &[x, y] : A){
		cin >> x >> y;
		comp.pb(x);
		comp.pb(y);
	}
	sort(all(comp));
	comp.resize(distance(comp.begin(), unique(all(comp))));
	N = comp.size();
	for(int _i = 0; _i < 2; _i ++){
		build();
		sort(all(A));
		vector<int> lesser, greater;
		for(auto [x, y] : A){
			int comp_x = lower_bound(all(comp), x) - comp.begin() + 1;
			int comp_y = lower_bound(all(comp), y) - comp.begin() + 1;
			
			int a = qry(1, comp_x).mx;
			if(abs(a) == INF) lesser.pb(-1); else lesser.pb(a);
			
			a = qry(comp_x, N).mn;
			if(abs(a) == INF) greater.pb(-1); else greater.pb(a);
			
			upd(1, 1, N, comp_y, y);
		}
		if(lesser[NN - 1] != -1) ans = min(ans, A[NN - 1].fr - lesser[NN - 1]);
		if(greater[NN - 1] != -1) ans = min(ans, greater[NN - 1] - A[NN - 1].fr);
		int mx = 0;
		for(int i = NN - 2; i >= 0; i --){
			mx = max(mx, A[i + 1].sc);
			ans = min({ans, abs(A[i].fr - mx), abs(A[i].fr - max(mx, lesser[i])), abs(A[i].fr - max(mx, greater[i]))});
		}
		
		for(auto &[x, y] : A){
			swap(x, y);
		}
		/// cout << ans << endl;
	}
	cout << ans << endl;
}
/**

*/