import sys
input = sys.stdin.readline


def cmp(a, b):
    if a[-1] != b[-1]:
        return a[-1] < b[-1]
    l, r = -1, len(a)
    while r - l > 1:
        m = (r + l) // 2
        if a[m] > b[-1]:
            r = m
        else:
            l = m
    ans = len(a) - r + len(b)
    l, r = -1, len(b)
    while r - l > 1:
        m = (r + l) // 2
        if b[m] > a[-1]:
            r = m
        else:
            l = m
    ass = len(b) - r + len(a)
    return ans < ass


def merge(a):
    if len(a) == 1:
        return a
    m = len(a) // 2
    x = a[:m]
    y = a[m:]
    x = merge(x)
    y = merge(y)
    i, j = 0, 0
    while i < len(x) and j < len(y):
        if cmp(x[i], y[j]):
            a[i + j] = x[i]
            i += 1
        else:
            a[i + j] = y[j]
            j += 1
    while i < len(x):
        a[i + j] = x[i]
        i += 1
    while j < len(y):
        a[i + j] = y[j]
        j += 1
    return a


def solve2(a):
    a = merge(a)
    x = -1
    ans = 0
    for i in range(len(a)):
        for j in a[i]:
            if j > x:
                ans += 1
                x = j
    print(ans)


def solve():
    n = int(input())
    dp = [[(0, 0), 0, 0] for i in range(n)]
    x, y = map(int, input().split())
    dp[0][0] = x
    dp[0][1] = y
    for i in range(n - 1):
        x, y = map(int, input().split())
        dp[i + 1][0] = max(dp[i][0], x)
        dp[i + 1][1] = max(dp[i][1], y)
        dp[i + 1][2] = (dp[i][0], y)
        if abs(dp[i][1] - x) < abs(dp[i][0] - y):
            dp[i + 1][2] = (x, dp[i][1])
        if i == 0:
            continue
        if y > dp[i][2][1] and abs(dp[i][2][0] - y) < abs(dp[i + 1][2][0] - dp[i + 1][2][1]):
            dp[i + 1][2] = (dp[i][2][0], y)
        if x > dp[i][2][0] and abs(dp[i][2][1] - x) < abs(dp[i + 1][2][0] - dp[i + 1][2][1]):
            dp[i + 1][2] = (x, dp[i][2][1])
    print(abs(dp[n - 1][2][0] - dp[n - 1][2][1]))


solve()
