#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <set>

typedef long long llong;
const int MAXN = 500000 + 10;
const int INF  = 1e9;

struct Present
{
    int a, b;
    inline friend bool operator < (const Present &x, const Present &y)
    {
        return x.a < y.a || (x.a == y.a && x.b > y.b);
    }
};

int n;
int ans;
int maxB[MAXN];
Present p[MAXN];
std::set <int> setB;

void solve()
{
    std::sort(p + 1, p + 1 + n);
    for (int i = n ; i >= 1 ; --i)
    {
        maxB[i] = std::max(maxB[i + 1], p[i].b);
    }
    ans = 2e9;
    setB.insert(-1e9 - 1);
    setB.insert(-2e9 + 1);
    for (int i = 1 ; i <= n ; ++i)
    {
        int minDiffB;
        auto nextIT = setB.lower_bound(p[i].a);
        auto prevIT = std::prev(nextIT);
        if (p[i].a - (*prevIT) < p[i].a - (*nextIT))
        {
            minDiffB = *prevIT;
        } else
        {
            minDiffB = *nextIT;
        }

        ans = std::min(ans, abs(p[i].a - std::max(minDiffB, maxB[i + 1])));
        setB.insert(p[i].b);
    }

    std::cout << ans << '\n';
}

void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> p[i].a >> p[i].b;
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}