#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>

#pragma warning(disable: 4996)

typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define pii pair<int, int>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

vec<pll> asd;
struct edge {
    int mx;
};

vec<edge> tree;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v].mx = asd[l].second;
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tree[v].mx = max(tree[v * 2 + 1].mx, tree[v * 2 + 2].mx);
}

ll get(int v, int l, int r, int ql, int qr) {
    if (r <= ql || qr <= l) {
        return -LINF;
    }
    if (ql <= l && r <= qr) {
        return tree[v].mx;
    }
    int m = (l + r) / 2;
    return max(get(v * 2 + 1, l, m, ql, qr), get(v * 2 + 2, m, r, ql, qr));
}

void solve() {
    int n; cin >> n;
    vec<pll> qwe(n);
    asd = vec<pll>(n);
    for (int i = 0; i < n; i++) {
        cin >> qwe[i].first >> qwe[i].second;
        asd[i] = qwe[i];
    }
    tree = vec<edge>(4 * n);
    build(0, 0, n);
    sort(asd.begin(), asd.end());
    set<vec<ll>> now;
    ll ans = LINF;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                now.insert({ abs(qwe[i].first - qwe[j].second), i, j });
            }
        }
    }
    for (auto elem : now) {
        int i = elem[1];
        int j = elem[2];

        ll mx;
        if (asd[n - 1].first <= qwe[i].first) {
            cout << elem[0] << "\n";
            exit(0);
        }

        int l = 0, r = n - 1;
        while (l + 1 < r) {
            int  m = (l + r) / 2;
            if (asd[m].first > qwe[i].first) {
                r = m;
            }
            else {
                l = m;
            }
        }
        int q = ((asd[l].first > qwe[i].first) ? l : r);
        mx = get(0, 0, n, q, n);

        if (mx > qwe[j].second) {
            continue;
        }
        cout << elem[0] << "\n";
        exit(0);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}