﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(2e9);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


void solve(istream& cin, ostream& cout) {
	ll n;
	cin >> n;
	vector<pair<ll, ll>> v(n);
	for (auto& [x, y] : v)
		cin >> x >> y;
	vector<ll> a(n), b(n);
	for (ll i = 0; i < n; ++i)
		a[i] = b[i] = i;
	sort(a.begin(), a.end(), [&](ll x, ll y) {return v[x].first < v[y].first; });
	sort(b.begin(), b.end(), [&](ll x, ll y) {return v[x].second < v[y].second; });


	ll res = INF;
	ll x = -INF;
	ll y = -INF;
	multiset<ll> s;
	for (ll i = 0; i < n; ++i)
		s.insert(v[i].second);
	for (ll i = n - 1; i >= 0; --i) {
		ll x = v[a[i]].first;
		res = min(res, abs(x - y));
		s.erase(s.find(v[a[i]].second));


		auto buf = s.lower_bound(x);
		if (buf != s.end())
			res = min(res, abs(x - max(y, *buf)));
		if (buf != s.begin())
			res = min(res, abs(x - max(y, *(--buf))));


		y = max(y, v[a[i]].second);
	}


	x = -INF;
	y = -INF;
	s.clear();
	for (ll i = 0; i < n; ++i)
		s.insert(v[i].first);
	for (ll i = n - 1; i >= 0; --i) {
		ll x = v[b[i]].second;
		res = min(res, abs(x - y));
		s.erase(s.find(v[b[i]].first));


		auto buf = s.lower_bound(x);
		if (buf != s.end())
			res = min(res, abs(x - max(y, *buf)));
		if (buf != s.begin())
			res = min(res, abs(x - max(y, *(--buf))));


		y = max(y, v[b[i]].first);
	}

	cout << res << '\n';
}