#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <string>
#include <vector>
#include <climits>

#define sz(a) int((int)a.size())

//#define int long long

using namespace std;

struct Section {
    int a, b;
};

struct MX {
    int mx1 = -1, mx2 = -2;
};

vector<Section> v;
vector<MX> suf_max_b;

bool can(int at_mx_a, int at_mx_b) {
    if (at_mx_a == v.size() - 1) {
        return true;
    }
    int mx_a = v[at_mx_a].a;
    int mx_b = v[at_mx_b].b;
    if (at_mx_b <= at_mx_a) {
        return suf_max_b[at_mx_a + 1].mx1 <= mx_b;
    }
    if (mx_b != suf_max_b[at_mx_a + 1].mx1) {
        return false;
    }
    return true;
}

bool comp(Section x, Section y) {
    if (x.a != y.a) {
        return x.a < y.a;
    }
    return x.b < y.b;
}

void smart_solve(int n) {
//    int n;
//    cin >> n;
    v.resize(n);
    suf_max_b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i].a >> v[i].b;
    }
    sort(v.begin(), v.end(), comp);
    int mx1 = -1, mx2 = -2;
    for (int i = n - 1; i >= 0; --i) {
        if (v[i].b > mx1) {
            mx2 = mx1;
            mx1 = v[i].b;
        } else {
            if (v[i].b > mx2) {
                mx2 = v[i].b;
            }
        }
        suf_max_b[i] = {mx1, mx2};
    }
    int ans = 2e9;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if (can(i, j)) {
                ans = min(ans, abs(v[i].a - v[j].b));
            }
            if (ans == 0) {
                cout << 0;
                return;
            }
        }
    }
    cout << ans;
}

void smarter_solve(int n) {
    int mx1 = -1, mx2 = -2;
    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        if (a > mx1) {
            mx2 = mx1;
            mx1 = a;
        } else {
            if (a > mx2) {
                mx2 = a;
            }
        }
    }
    cout << mx1 - mx2;
}

void solve() {
    int n;
    cin >> n;
    if (n <= 5000) {
        smart_solve(n);
    } else {
        smarter_solve(n);
    }
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}