#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

#define int ll
const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res = res * a;
			}
			a = a * a;
			n /= 2;
		}
		return res;
	}

	mint rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}

	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}

	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}

	mint& operator/=(const mint& b) {
		(*this) *= b.rev();
		return *this;
	}
	
	mint operator+(const mint& b) const {
		return mint(*this) += b;
	}
	mint operator-(const mint& b) const {
		return mint(*this) -= b;
	}
	mint operator*(const mint& b) const {
		return mint(*this) *= b;
	}
	mint operator/(const mint& b) const {
		return mint(*this) /= b;
	}
};

void solve() {
	int n;
	cin >> n;
	vector<int> a(n), b(n);
	vector<pair<int, int>> c(n);
	multiset<int> q;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		c[i] = { b[i], i };
		q.insert(a[i]);
	}
	int ans = (int)(2e12);
	sort(c.begin(), c.end());
	for (int i = 0; i < n; i++) {
		int cur = c[i].second;
		q.erase(q.lower_bound(a[cur]));
		if (q.size()) {
			ans = min(ans, abs(c[i].first - (*q.rbegin())));
		}
	}
	cout << ans << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}
