#pragma 'GCC-optimize'
#pragma 'unroll-loops'
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <stack>

#define all(x) x.begin(),x.end()
#define f first
#define s second

using namespace std;

const int maxn = 5e5;
vector <int> bb;
int t[4 * maxn];

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v] = bb[l];
        return;
    }
    int m = (l + r) >> 1;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return -1e9;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) >> 1;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

vector <int> mbs(int n, vector <int> &a) {
    vector <int> b(n, n);
    stack <int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] < a[i]) {
            b[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    return b;
}

int solve(int n, vector <pair <int, int> > a) {
    sort(a.begin(), a.end());
    vector <int> A;
    vector <pair <int, int> > B;
    map <pair <int, int>, int> M;
    for (auto x: a) {
        A.push_back(x.f);
        B.emplace_back(x.s, x.f);
        M[{x.s, x.f}]++;
        bb.push_back(x.s);
    }
    sort(all(B));
    build(0, 0, n);
    // for (int i = 0; i < 10; ++i) cout << t[i] << " "; cout << '\n';
    vector <int> _a = mbs(n, A);
    set <int> Q;
    int ans = 1e9;
    for (int i = 0; i < n; ++i) {
        if (a.back().f > a[i].f) {
            int mx = get(0, 0, n, _a[i], n);
            ans = min(ans, abs(a[i].f - mx));
            auto it = Q.upper_bound(mx);
            auto ff = lower_bound(it, Q.end(), a[i].f);
            if (ff != Q.end()) ans = min(ans, abs(a[i].f - *ff));
            if (ff != Q.begin()) {
                ff--;
                if (*ff > mx) ans = min(ans, abs(a[i].f - *ff));
            }
        }
        else {
            int l = 0, r = n;
            while (r - l > 1) {
                int m = (l + r) >> 1;
                if (B[m].f >= a[i].f) r = m;
                else l = m;
            }
            for (int j = l - 1; j <= r + 1; ++j) {
                if (B[j] != make_pair(a[i].s, a[i].f) || (B[j] == make_pair(a[i].s, a[i].f) && M[B[j]] > 1)) {
                    ans = min(ans, abs(a[i].f - B[j].f));
                }
            }
        }
        Q.insert(a[i].s);
        //cout << i << " " << ans << '\n';
    }
    return ans;
}

int fake(int n, vector <pair <int, int> > &a) {
    sort(a.begin(), a.end());
    return a[n - 1].f - a[n - 2].f;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        int n; cin >> n;
        vector <pair <int, int> > a(n);
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].f >> a[i].s;
            if (a[i].f == a[i].s) {
                cnt++;
            }
        }
        if (cnt == n) cout << fake(n, a);
        else cout << solve(n, a);
    }
    return 0;
}