#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

#define ll long long


void build(int idx, int tl, int tr, vector<pair<ll, ll>>& v, vector<int>& t) {
	if (tl == tr) {
		t[idx] = v[tl].second;
	}
	else {
		int tm = (tl + tr) / 2;

		build(2 * idx + 1, tl, tm, v, t);
		build(2 * idx + 2, tm + 1, tr, v, t);

		t[idx] = max(t[2 * idx + 1], t[2 * idx + 2]);
	}
}

int gets(int idx, int tl, int tr, int l, int r, vector<int>& t) {
	if (tl == l && tr == r) {
		return t[idx];
	}
	else if (l > r) {
		return -1;
	}
	else {
		int tm = (tl + tr) / 2;

		return max(gets(2 * idx + 1, tl, tm, l, min(r, tm), t), 
			gets(2 * idx + 2, tm + 1, tr, max(tm + 1, l), r, t));
	}
}


int main() {
	int n;
	cin >> n;

	vector<pair<ll, ll>> v(n);
	for (int i = 0; i < n; i++) {
		ll a, b;
		cin >> a >> b;

		v[i].first = a;
		v[i].second = b;
	}

	sort(v.begin(), v.end());

	vector<int> t(4 * n);

	build(0, 0, n - 1, v, t);

	ll ans = 1e18;

	set<ll> s1;
	set<ll> s2;

	for (int i = 0; i < n; i++) {
		s1.insert(v[i].second);
		s2.insert(-v[i].second);

		if (i == n - 1 || v[i].first != v[i + 1].first) {
			ll m1 = v[i].first;

			ll m2 = -1;
			if (i < n - 1) {
				m2 = gets(0, 0, n - 1, i + 1, n - 1, t);

				if (abs(m2 - m1) < ans) {
					ans = abs(m2 - m1);
				}
			}

			

			auto it1 = lower_bound(s1.begin(), s1.end(), m1);

			if (it1 != s1.end()) {
				ll m1v = *it1;

				if (m1v > m2 && abs(m1v - m1) < ans) {
					ans = abs(m1v - m1);
				}
			}

			auto it2 = lower_bound(s2.begin(), s2.end(), -m1);

			if (it2 != s2.end()) {
				ll m1d = -(*it2);

				if (m1d > m2 && abs(m1d - m1) < ans) {
					ans = abs(m1d - m1);
				}
			}
		}
	}

	cout << ans;
}