#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcp(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

struct b {
    int i, j, cost;
};

bool cmp(b f, b s) {
    if (f.cost == s.cost){
        return f.i < s.i;
    }
    return f.cost < s.cost;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<b> a;
    vector<vector<int>> al(n, vector<int>(2));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < 2; ++j) {
            int c;
            cin >> c;
            a.push_back({i, j, c});
            al[i][j] = c;
        }
    }
    sort(a.begin(), a.end(), cmp);
    vector<int> cnt(n);
    vector<multiset<int>> f(2);
    int num = 0;
    int ans = 2e9 + 1;
    for (auto i: a) {
        if (cnt[i.i] == 0) {
            cnt[i.i]++;
            f[i.j].insert(i.cost);
            ++num;
        } else {
            f[1 - i.j].erase(f[1 - i.j].find(al[i.i][1 - i.j]));
            f[i.j].insert(i.cost);
        }
        if (num == n && f[0].size() && f[1].size()) {
            ans = min(ans, abs(*f[0].rbegin() - *f[1].rbegin()));
        }
    }
    cout << ans << "\n";
}