#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 5e5 + 10;

struct tree {
    vector <vector <int> > x;
    int sz;
    void build(vector <int> a) {
        sz = 1;
        while (sz < a.size())
            sz *= 2;
        x.resize(sz * 2);
        for (int i = 0; i < a.size(); i++)
            x[i + sz].push_back(a[i]);
        for (int i = sz - 1; i > 0; i--) {
            merge(x[i * 2].begin(), x[i * 2].end(), 
                x[i * 2 + 1].begin(), x[i * 2 + 1].end(), back_inserter(x[i]));
        }
    }
    pair <int, int> get(int v, int l, int r, int ql, int qr, int k, int k2) {
        if (l >= qr || r <= ql)
            return { -1e9, -1e9 };
        if (ql <= l && r <= qr) {
            int ind1 = lower_bound(x[v].begin(), x[v].end(), max(k, k2)) - x[v].begin();
            int ind2 = upper_bound(x[v].begin(), x[v].end(), k) - x[v].begin() - 1;
            int a = -1e9, b = -1e9;


            if (ind1 < x[v].size())
                a = x[v][ind1];
            if (ind2 >= 0)
                b = x[v][ind2];
            
            if (b < k2)
                b = -1e9;
            return { a, b };
        }
        int m = (l + r) / 2;
        auto q1 = get(v * 2, l, m, ql, qr, k, k2);
        auto q2 = get(v * 2 + 1, m, r, ql, qr, k, k2);
        return { min(q1.first, q2.first), max(q1.second, q2.second) };
    }
    pair <int, int> get(int l, int r, int k1, int k2) {
        return get(1, 0, sz, l, r, k1, k2);
    }
} d;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n;
    cin >> n;
    vector <pair <int, int>> a(n);
    vector <int> x;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin(), a.end());
    for (auto& r : a)
        x.push_back(r.second);
    vector <int> mp(n);
    for (int i = n - 1; i >= 0; i--) {
        mp[i] = x[i];
        if (i < n - 1)
            mp[i] = max(mp[i], mp[i + 1]);
    }
    d.build(x);
    int ans = 1e9;
    for (int i = 0; i < n; i++) {
        int ind = upper_bound(a.begin(), a.end(), make_pair(a[i].first, (int)1e9)) - a.begin();
        int mx = -1e9;
        if (ind < n)
            mx = mp[ind];
        ans = min(ans, abs(a[i].first - mx));
        for (int j = 0; j < ind; j++) {
            if (j != i && a[j].second >= mx)
                ans = min(ans, abs(a[i].first - a[j].second));
        }
    }
    cout << ans;
}