#pragma GCC optimize("OFast")

#include <bits/stdc++.h>

using namespace std;

#define ff first
#define ss second
#define pb push_back
//#define int long long
#define dl long double

const int inf = 2e9;

const int maxn = 1e6+100;

map<int, int> mp;
int rev[maxn];
int cnt = 0;

struct Segtree {
    int n;
    vector<int> a;
    vector<int> t;

    int op(int _a, int _b) {
        return max(_a, _b);
    }

    Segtree() {};

    Segtree(int _n) {
        n = _n;
        a.assign(n, 0);
        t.resize(4 * n);
        build(1, 0, n);
    }

    Segtree(vector<int> _a) {
        n = (int) _a.size();
        a = _a;
        t.resize(4 * n);
        build(1, 0, n);
    }

    void build(int v, int l, int r) {
        if (l + 1 == r) {
            t[v] = a[l];
            return;
        }
        int m = (l + r) / 2;
        build(v * 2, l, m);
        build(v * 2 + 1, m, r);
        t[v] = op(t[v * 2], t[v * 2 + 1]);
    }

    void update(int v, int l, int r, int pos, int val) {
        if (l + 1 == r) {
            t[v] += val;
            return;
        }
        int m = (l + r) / 2;
        if (pos < m) update(v * 2, l, m, pos, val);
        else update(v * 2 + 1, m, r, pos, val);
        t[v] = op(t[v * 2], t[v * 2 + 1]);
    }

    int get(int v, int l, int r, int lq, int rq) {
        if (r <= lq || rq <= l) return -inf;
        if (lq <= l && r <= rq) return t[v];
        int m = (l + r) / 2;
        return op(get(v * 2, l, m, lq, rq), get(v * 2 + 1, m, r, lq, rq));
    }

    int get(int l, int r) {
        return get(1, 0, n, l, r);
    }

    void upd(int pos, int val) {
        update(1, 0, n, pos, val);
    }
};

struct Magic {
    Segtree t;

    Magic() {
        t = Segtree(maxn);
    };

    void push(int x) {
        t.upd(mp[x], 1);
    }

    void remove(int x) {
        t.upd(mp[x], -1);
    }

    int getmore(int x) {
        x = mp[x];
        if (t.get(x, maxn) == 0) return inf;
        int l=x, r=maxn, m;
        while (r - l > 1) {
            m = (l + r) / 2;
            if (t.get(l, m) == 0) l = m;
            else r = m;
        }
        return rev[l];
    }

    int getmini(int x) {
        x = mp[x];
        if (t.get(0, x) == 0) return -inf;
        int l=0, r=x, m;
        while (r - l > 1) {
            m = (l + r) / 2;
            if (t.get(m, r) == 0) r = m;
            else l = m;
        }
        return rev[l];
    }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].ff >> a[i].ss;
    vector<int> b;
    for (auto i: a) {
        b.pb(i.ff);
        b.pb(i.ss);
    }
    sort(b.begin(), b.end());
    for (auto i: b) {
        if (mp.find(i) == mp.end()) {
            mp[i] = cnt;
            rev[cnt++] = i;
        }
    }
    sort(a.begin(), a.end());
    multiset<int> st;
    for (int i = 0; i < n; i++) st.insert(a[i].ss);
    int r;
    Magic t;
    int ans = inf;
    for (int l = 0; l < n; l++) {
        r = l;
        t.push(a[l].ss);
        st.erase(st.find(a[l].ss));
        while (r + 1 < n && a[r + 1].ff == a[l].ff) {
            r++;
            t.push(a[r].ss);
            st.erase(st.find(a[r].ss));
        }
        for (int i = l; i <= r; i++) {
            t.remove(a[i].ss);
            if (!st.empty() && ((*st.rbegin()) >= a[i].ff)) ans = min(ans, *st.rbegin() - a[i].ff);
            else {
                ans = min(ans, t.getmore(a[i].ff) - a[i].ff);
                ans = min(ans, a[i].ff - t.getmini(a[i].ff));
                if (!st.empty()) ans = min(ans, -*st.rbegin() + a[i].ff);
            }
            t.push(a[i].ss);
        }
        l = r;
    }
    cout << ans;
}

signed main() {
#ifndef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
//    freopen("input", "r", stdin);
//    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}