#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma,sse,sse2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#if defined(DEBUG)
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

#ifndef DEBUG
//#define endl '\n'
#endif

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ----------

void solve() {
  ll n;
  cin >> n;
  vii a(n);
  cin >> a;
  auto c = a;

  ll ans = 1e18;

  {
    sort(a.begin(), a.end());
    for (int i = n - 2; i >= 0; --i) {
      a[i].second = max(a[i].second, a[i + 1].second);
    }
    a.emplace_back(1e18, 0);

    ll l;
    {
      ll L = 0, R = n;
      while (R - L > 1) {
        ll M = (L + R) / 2;
        (a[M].first <= a[M + 1].second ? L : R) = M;
      }
      l = L;
    }

    ans = min(ans, a[l + 1].second - a[l].first);

    vi d(n);
    for (int i = 0; i < n; ++i) {
      d[i] = c[i].second;
    }
    sort(d.begin(), d.end());

    for (int i = l + 1; i < n; ++i) {
      auto it = lower_bound(d.begin(), d.end(), a[i].first);
      if (it == d.end()) continue;
      ans = min(ans, *it - a[i].first);
    }
  }

  {
    for (auto &e : c) {
      e = {e.second, e.first};
    }
    a = c;
  }

  {
    sort(a.begin(), a.end());
    for (int i = n - 2; i >= 0; --i) {
      a[i].second = max(a[i].second, a[i + 1].second);
    }
    a.emplace_back(1e18, 0);

    ll l;
    {
      ll L = 0, R = n;
      while (R - L > 1) {
        ll M = (L + R) / 2;
        (a[M].first <= a[M + 1].second ? L : R) = M;
      }
      l = L;
    }

    ans = min(ans, a[l + 1].second - a[l].first);

    vi d(n);
    for (int i = 0; i < n; ++i) {
      d[i] = c[i].second;
    }
    sort(d.begin(), d.end());

    for (int i = l + 1; i < n; ++i) {
      auto it = lower_bound(d.begin(), d.end(), a[i].first);
      if (it == d.end()) continue;
      ans = min(ans, *it - a[i].first);
    }
  }

  cout << ans << endl;
}