#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <cmath>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
// #define endl '\n'
#define len(a) int(a.size())

// author: @cot-in

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

mt19937 rnd(101328);

int cnt = 2e9;

void gen(int n, vector<int> &cur, vector<int> &a, vector<int> &b) {
    if (len(cur) == n) {
        int mxa = -1, mxb = -1;
        for (int i = 0; i < n; i++) {
            if (cur[i] == 1) {
                mxa = max(mxa, a[i]);
            } else {
                mxb = max(mxb, b[i]);
            }
        }
        if (mxa > -1 && mxb > -1)
            cnt = min(cnt, abs(mxa - mxb));
        return;
    }
    for (int i = 1; i <= 2; i++) {
        cur.push_back(i);
        gen(n, cur, a, b);
        cur.pop_back();
    }
}

int stupid_solve(int n, vector<int> &a, vector<int> &b) {
    cnt = 2e9;
    vector<int> cur;
    gen(n, cur, a, b);
    return cnt;
}

int clever_solve(int n, vector<int> &a, vector<int> &b) {
    int ccnt = 2e9;
    vector<pair<int, int>> aa(n);
    vector<int> bn(n);
    for (int i = 0; i < n; i++)
        aa[i] = {a[i], i};
    sort(all(aa));
    for (int i = 0; i < n; i++)
        bn[i] = b[aa[i].second];
    for (int i = 0; i < n; i++)
        a[i] = aa[i].first;
    for (int i = 0; i < n; i++)
        b[i] = bn[i];
    vector<int> suff(n, b[n - 1]);
    for (int i = n - 2; i >= 0; i--)
        suff[i] = max(suff[i + 1], b[i]);
    multiset<int> cur;
    map<int, int> cnts;
    int mxcur = 0;
//    for (auto el: a) {
//        cout << el << ' ';
//    }
//    cout << endl;
//    for (auto el: b) {
//        cout << el << ' ';
//    }
//    cout << endl;
//    for (auto el: suff) {
//        cout << el << ' ';
//    }
//    cout << endl;
    for (int i = 0; i < n; i++) {
        cur.insert(b[i]);
        cnts[b[i]]++;
        int r = i + 1;
//        int l = i, r = n;
//        while (r - l > 1) {
//            int mid = (l + r) / 2;
//            if (a[mid] > a[i]) {
//                r = mid;
//            } else {
//                l = mid;
//            }
//        }
//        cout << i << ' ' << r << ' ' << endl;
        int mxb = -1;
        if (r != n) {
            mxb = suff[r];
            ccnt = min(ccnt, abs(a[i] - mxb));
        }
//        cout << a[i] << ' ' << mxb << endl;
        cur.insert(a[i]);
        cur.erase(cur.find(b[i]));
        cnts[b[i]]--;
        auto it = cur.find(a[i]);
        if (mxb <= a[i] && cnts[a[i]] > 0) {
//            cout << i << ' ' << a[i] << endl;
            ccnt = 0;
        }
//        for (auto el: cur) {
//            cout << el << ' ';
//        }
//        cout << endl;
        if (it != cur.begin()) {
            // cout << "debug 1: " << i << ' ' << *(--it) << endl;
            ccnt = min(ccnt, abs(a[i] - max(mxb, *(--it))));
            ++it;
        }
        if (*it != *cur.rbegin()) {
            // cout << "debug 2: " << i << ' ' << *(cur.lower_bound(a[i])) << endl;
            ccnt = min(ccnt, abs(max(*(cur.upper_bound(a[i])), mxb) - a[i]));
        }
//        cout << "counted" << endl;
        cur.erase(cur.find(a[i]));
        cur.insert(b[i]);
        cnts[b[i]]++;
        mxcur = max(mxcur, b[i]);
//        cout << "completed: " << i << ' ' << ccnt << ' ' << mxb << endl;
//        int mxb = -1;
//        for (int j = 0; j < n; j++) {
//            if (a[j] > a[i])
//                mxb = max(mxb, b[j]);
//        }
//        if (mxb != -1) {
//            ccnt = min(ccnt, abs(a[i] - mxb));
//        }
//        for (int j = 0; j < n; j++) {
//            if (i != j && a[j] <= a[i])
//                ccnt = min(ccnt, abs(a[i] - max(mxb, b[j])));
//        }
    }
    return ccnt;
}

vector<int> gen_test(int curn) {
    vector<int> vc(curn);
    for (int i = 0; i < curn; i++)
        vc[i] = rnd() % 20;
    return vc;
}

void make_stress() {
    int right = 0, wrong = 0;
    for (int t = 0; t < 1000; t++) {
        cout << "Test " << t + 1 << ": ";
        int curn = rnd() % 10 + 2;
        vector<int> a = gen_test(curn);
        vector<int> b = gen_test(curn);
        int clvr = clever_solve(curn, a, b);
        int stpd = stupid_solve(curn, a, b);
        if (clvr == stpd) {
            cout << "OK" << endl;
            right++;
        } else {
            cout << "WA" << endl;
            cout << curn << endl;
            for (auto el: a)
                cout << el << ' ';
            cout << endl;
            for (auto el: b)
                cout << el << ' ';
            cout << endl;
            cout << "Right answer: " << stpd << endl;
            cout << "Your answer: " << clvr << endl;
            wrong++;
        }
    }
    cout << "============" << endl;
    cout << "Right answers: " << right << endl;
    cout << "Wrong answers: " << wrong << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
//    make_stress();
//    return 0;
    fin();
    int n;
    cin >> n;
    if (n > 5000) {
        vector<int> vc(n);
        for (int i = 0; i < n; i++)
            cin >> vc[i] >> vc[i];
        sort(all(vc));
        cout << vc[n - 1] - vc[n - 2];
        return 0;
    }
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    cout << clever_solve(n, a, b);
    return 0;
}