#include <bits/stdc++.h>

#define int long long
#define double long double
using namespace std;
const int mod = 1e9 + 7;

struct segtree {
    int size;
    vector<vector<int>> tree;

    vector<int> combine(vector<int> &a, vector<int> &b) {
        vector<int> ans;
        int idx = 0;
        int jdx = 0;
        while (idx < a.size() && jdx < b.size()) {
            if (a[idx] <= b[jdx]) {
                ans.push_back(a[idx]);
                idx++;
            } else {
                ans.push_back(b[jdx]);
                jdx++;
            }
        }
        for (int i = idx; i < a.size(); ++i) {
            ans.push_back(a[i]);
        }
        for (int i = jdx; i < b.size(); ++i) {
            ans.push_back(b[i]);
        }
        return ans;
    }

    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            if (l < a.size()) {
                tree[v] = {a[l]};
            } else {
                tree[v] = {};
            }
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void init(int n, vector<int> &a) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.resize(2 * size - 1);
        build(0, 0, size, a);
    }

    int ans(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql | qr <= l)return LLONG_MAX;
        if (ql <= l && r <= qr) {
            int x1 = LLONG_MAX;
            int y1 = LLONG_MAX;
            if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].end()) {
                x1 = *lower_bound(tree[v].begin(), tree[v].end(), val);
            }
            if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].begin()) {
                y1 = tree[v][lower_bound(tree[v].begin(), tree[v].end(), val) - tree[v].begin()];
            }
            if (x1 == LLONG_MAX && y1 == LLONG_MAX)return LLONG_MAX;
            else return min(abs(x1 - val), abs(y1 - val));
        }
        int mid = (l + r) / 2;
        int s1 = ans(2 * v + 1, l, mid, ql, qr, val);
        int s2 = ans(2 * v + 2, mid, r, ql, qr, val);
        return min(s1, s2);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    segtree st;
    st.init(n, b);
    int ans = LLONG_MAX;
    for (int i = 0; i < n; ++i) {
        int x = a[i];
        ans = min(ans, min(st.ans(0, 0, st.size, 0, i, x), st.ans(0, 0, st.size, i + 1, n, x)));
    }
    cout << ans;
}