#include <bits/stdc++.h>

using namespace std;

struct segtree {
    int size;
    vector<vector<int>> tree;

    vector<int> combine(vector<int> &a, vector<int> &b) {
        vector<int> ans;
        int idx = 0;
        int jdx = 0;
        while (idx < a.size() && jdx < b.size()) {
            if (a[idx] <= b[jdx]) {
                ans.push_back(a[idx]);
                idx++;
            } else {
                ans.push_back(b[jdx]);
                jdx++;
            }
        }
        for (int i = idx; i < a.size(); ++i) {
            ans.push_back(a[i]);
        }
        for (int i = jdx; i < b.size(); ++i) {
            ans.push_back(b[i]);
        }
        return ans;
    }

    void build(int v, int l, int r, vector<pair<int, int>> &a) {
        if (r - l == 1) {
            if (l < a.size()) {
                tree[v] = {a[l].second};
            } else {
                tree[v] = {};
            }
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void init(int n, vector<pair<int, int>> &a) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.resize(2 * size - 1);
        build(0, 0, size, a);
    }

    int ans(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql | qr <= l)return INT_MAX;
        if (ql <= l && r <= qr) {
            int x1 = INT_MAX;
            int y1 = INT_MAX;
            if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].end()) {
                x1 = *lower_bound(tree[v].begin(), tree[v].end(), val);
            }
            if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].begin()) {
                y1 = *(--lower_bound(tree[v].begin(), tree[v].end(), val));
            }
            if (x1 == INT_MAX && y1 == INT_MAX)return INT_MAX;
            else if (x1 == INT_MAX)return abs(y1 - val);
            else if (y1 == INT_MAX)return abs(x1 - val);
            else return min(abs(x1 - val), abs(y1 - val));
        }
        int mid = (l + r) / 2;
        int s1 = ans(2 * v + 1, l, mid, ql, qr, val);
        int s2 = ans(2 * v + 2, mid, r, ql, qr, val);
        return min(s1, s2);
    }

    int ans1(int v, int l, int r, int ql, int qr, int val) {
        if (r <= ql | qr <= l)return INT_MAX;
        if (ql <= l && r <= qr) {
            int x1 = INT_MAX;
            if (lower_bound(tree[v].begin(), tree[v].end(), val) != tree[v].end()) {
                x1 = *lower_bound(tree[v].begin(), tree[v].end(), val);
            }
            return x1;
        }
        int mid = (l + r) / 2;
        int s1 = ans1(2 * v + 1, l, mid, ql, qr, val);
        int s2 = ans1(2 * v + 2, mid, r, ql, qr, val);
        return min(s1, s2);
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<pair<int, int>> c(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        c[i] = {a[i], b[i]};
    }
    sort(c.begin(), c.end());
    segtree st;
    st.init(n, c);
    vector<int> sufmx(n + 1, 0);
    sufmx[n - 1] = c[n - 1].second;
    for (int i = n - 2; i >= 0; --i) {
        sufmx[i] = max(sufmx[i + 1], c[i].second);
    }
    int ans = INT_MAX;
    for (int i = 0; i < n; ++i) {
        int x = c[i].first;
        int mx = sufmx[i + 1];
        if (i == n - 1) {
            ans = min(ans, st.ans(0, 0, st.size, 0, i, x));
        } else if (i == 0) {
            ans = min(ans, abs(x - mx));
        } else {
            if (mx >= x) {
                ans = min(ans, mx - x);
                continue;
            }
            if (mx < x) {
                ans = min(ans, min(x - mx, st.ans1(0, 0, st.size, 0, i, x)));
            }
        }
    }
    cout << ans;
}