#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename K, typename V, typename Cmp = less<K>>
using ordered_map =
    __gnu_pbds::tree<K, V, Cmp, __gnu_pbds::rb_tree_tag,
                     __gnu_pbds::tree_order_statistics_node_update>;

template <typename T, typename Cmp = less<T>>
using ordered_set = ordered_map<T, __gnu_pbds::null_type, Cmp>;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
  return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
  return os << p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
  for (T& e : v) is >> e;
  return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
  for (const T& e : v) os << e << " ";
  return os;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}
template <typename T>
void chmin(T& a, const T& b) {
  if (a > b) a = b;
}

void solve();

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

void solve() {
  i32 n;
  cin >> n;
  vector<pair<i64, i64>> a(n);
  cin >> a;
  sort(ALL(a));
  multiset<i64> optional_b, forced_b;
  for (int i = 1; i < n; ++i) {
    forced_b.insert(a[i].second);
  }
  i64 ans = abs(*forced_b.rbegin() - a[0].first);
  for (int i = 1; i < n - 1; ++i) {
    optional_b.insert(a[i - 1].first);
    forced_b.erase(forced_b.find(a[i].second));
    i64 closest_b = *forced_b.rbegin();
    auto it = optional_b.lower_bound(a[i].first);
    if (it == optional_b.begin() ||
        (it != optional_b.end() &&
         abs(a[i].first - *it) < abs(a[i].first - *prev(it)))) {
      chmax(closest_b, *it);
    } else {
      chmax(closest_b, *prev(it));
    }
    chmin(ans, abs(closest_b - a[i].first));
  }
  auto it = optional_b.lower_bound(a.back().first);
  if (it == optional_b.begin() ||
      (it != optional_b.end() &&
       abs(a.back().first - *it) < abs(a.back().first - *prev(it)))) {
    chmin(ans, abs(*it - a.back().first));
  } else {
    chmin(ans, abs(*it - a.back().first));
  }
  cout << ans << "\n";
}
