#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

struct Tree {
    vector<ll> tree;
    ll sz = 1;

    Tree(ll n) {
        while (sz < n) {
            sz *= 2;
        }

        tree.resize(n * 4);
    }

    void add(ll i, ll x) {
        i += sz;
        tree[i] += x;
        i /= 2;
        while (i != 0) {
            tree[i] = tree[i * 2] + tree[i * 2 + 1];
            i /= 2;
        }
    }

    ll get_bigger(ll i, ll v, ll tl, ll tr) {
        if (tl == tr) {
            if (tree[v] > 0) {
                return tl;
            } else {
                return -1;
            }
        }

        ll tm = (tl + tr) / 2;
        if (i >= tm) {
            return get_bigger(i, v * 2 + 1, tm + 1, tr);
        } else {
            ll res = get_bigger(i, v * 2, tl, tm);
            if (res != -1) {
                return res;
            }
            return get_bigger(i, v * 2 + 1, tm + 1, tr);
        }
    }

    ll get_lower(ll i, ll v, ll tl, ll tr) {
        if (tl == tr) {
            if (tree[v] > 0) {
                return tl;
            } else {
                return -1;
            }
        }

        ll tm = (tl + tr) / 2;
        if (i >= tm) {
            ll res = get_lower(i, v * 2, tl, tm);
            if (res != -1) {
                return res;
            }
            return get_lower(i, v * 2 + 1, tm + 1, tr);
        } else {
            return get_lower(i, v * 2, tl, tm);
        }
    }
};

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> arr(n);
    vector<ll> c;
    for (auto &x : arr) {
        cin >> x.first >> x.second;
        c.push_back(x.first);
        c.push_back(x.second);
    }
    sort(c.begin(), c.end());
    c.erase(unique(c.begin(), c.end()), c.end());

    for (auto &x : arr) {
        x.first = lower_bound(c.begin(), c.end(), x.first) - c.begin();
        x.second = lower_bound(c.begin(), c.end(), x.second) - c.begin();
    }

    Tree t = Tree(2 * n + 5);

    sort(arr.begin(), arr.end());
    vector<ll> pref_max(n + 1);
    for (ll i = n - 1; i >= 0; --i) {
        pref_max[i] = max(pref_max[i + 1], c[arr[i].second]);
    }
    ll j = 0;
    ll ans = LLONG_MAX;
    for (ll i = 0; i < n; ++i) {
        while (j < n && arr[i].first >= arr[j].first) {
            t.add(arr[j].second, 1);
            ++j;
        }

        t.add(arr[i].second, -1);

        ll mx = 0;
        if (j < n) {
            mx = pref_max[j];
        }

        ll right_value = t.get_bigger(arr[i].first, 1, 0, t.sz - 1);
        if (right_value != -1) {
            right_value = c[right_value];
            ans = min(ans, abs(c[arr[i].first] - max(mx, right_value)));
        }

        ll left_value = t.get_lower(arr[i].first, 1, 0, t.sz - 1);
        if (left_value != -1) {
            left_value = c[left_value];
            ans = min(ans, abs(c[arr[i].first] - max(mx, left_value)));
        }
        ans = min(ans, abs(c[arr[i].first] - mx));

        t.add(arr[i].second, 1);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}