#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

struct Tree {
    vector<int> tree;
    int sz = 1;

    Tree(int n) {
        while (sz < n) {
            sz *= 2;
        }

        tree.resize(n * 4);
    }

    void add(int i, int x) {
        i += sz;
        tree[i] += x;
        i /= 2;
        while (i != 0) {
            tree[i] = tree[i * 2] + tree[i * 2 + 1];
            i /= 2;
        }
    }

    int get_sum(int l, int r, int v, int tl, int tr) {
        if (l == tl && r == tr) {
            return tree[v];
        }

        int tm = (tl + tr) / 2;
        int res = 0;
        if (l <= tm) {
            res += get_sum(l, min(tm, r), v * 2, tl, tm);
        }
        if (r >= tm + 1) {
            res += get_sum(max(l, tm + 1), r, v * 2 + 1, tm + 1, tr);
        }


        return res;
    }

    int get_bigger(int i, int v, int tl, int tr) {
        if (tl == tr) {
            if (tree[v] > 0) {
                return tl;
            } else {
                return -1;
            }
        }

        int tm = (tl + tr) / 2;
        if (i >= tm) {
            return get_bigger(i, v * 2 + 1, tm + 1, tr);
        } else {
            if (get_sum(i, tm, 1, 0, sz - 1) > 0) {
                return get_bigger(i, v * 2, tl, tm);
            }
            return get_bigger(i, v * 2 + 1, tm + 1, tr);
        }
    }

    int get_lower(int i, int v, int tl, int tr) {
        if (tl == tr) {
            if (tree[v] > 0) {
                return tl;
            } else {
                return -1;
            }
        }

        int tm = (tl + tr) / 2;
        if (i <= tm) {
            if (get_sum(i, tm, 1, 0, sz - 1) > 0) {
                return get_lower(i, v * 2, tl, tm);
            }
            return get_lower(i, v * 2 + 1, tm + 1, tr);
        } else {
            return get_lower(i, v * 2, tl, tm);
        }
    }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    vector<int> c;
    for (auto &x : arr) {
        cin >> x.first >> x.second;
        c.push_back(x.first);
        c.push_back(x.second);
    }
    sort(c.begin(), c.end());
    c.erase(unique(c.begin(), c.end()), c.end());

    for (auto &x : arr) {
        x.first = lower_bound(c.begin(), c.end(), x.first) - c.begin();
        x.second = lower_bound(c.begin(), c.end(), x.second) - c.begin();
    }

//    Tree t = Tree(2 * n + 5);

    sort(arr.begin(), arr.end());
    vector<int> pref_max(n + 1);
    for (int i = n - 1; i >= 0; --i) {
        pref_max[i] = max(pref_max[i + 1], c[arr[i].second]);
    }
    int j = 0;
    int ans = INT_MAX;
    multiset<int> s;
    for (int i = 0; i < n; ++i) {
        while (j < n && arr[i].first >= arr[j].first) {
            s.insert(arr[j].second);
            ++j;
        }

        s.erase(s.find(arr[i].second));

        int mx = 0;
        if (j < n) {
            mx = pref_max[j];
        }

        auto it = s.lower_bound(arr[i].first);
        if (it != s.end()) {
            int right_value = c[*it];
            ans = min(ans, abs(c[arr[i].first] - max(mx, right_value)));
        }

        if (it != s.begin()) {
            --it;
            int left_value = c[*it];
            ans = min(ans, abs(c[arr[i].first] - max(mx, left_value)));
        }
        if (j < n) {
            ans = min(ans, abs(c[arr[i].first] - mx));
        }

        s.insert(arr[i].second);
    }
    cout << ans << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}