#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <tuple>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif


template<typename T>
istream &operator>>(istream &in, pair<T, T> &p) {
    in >> p.first >> p.second;
    return in;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &value: v) {
        in >> value;
    }
    return in;
}

const int INF = 2e9;
const int BLOCK = 707;

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> ab(n);
    cin >> ab;
    sort(ab.begin(), ab.end());
    vector<int> a(n), b(n), b2(n);
    bool g4 = true;
    range(i, n) {
        tie(a[i], b[i]) = ab[i];
        b2[i] = b[i];
        g4 = g4 && (a[i] == b[i]);
    }
    if (g4) {
        cout << a.back() - a[a.size() - 2] << endline;
        return 0;
    }
    for (auto l = b2.begin(); l < b2.end(); l += BLOCK) {
        sort(l, min(b2.end(), l + BLOCK));
    }
    int rmaxb = -1;
    int best = INF;
    vector<int> uk((n + BLOCK - 1) / BLOCK);
    range(i, uk.size()) {
        uk[i] = (i + 1) * BLOCK - 1;
    }
    for (int i = n - 1; i >= 0; i--) {
        best = min(best, abs(rmaxb - a[i]));
        range(j, i / BLOCK) {
            int L = j * BLOCK;
            while (uk[j] >= L && b2[uk[j]] > a[i]) {
                uk[j]--;
            }
            best = min(best, abs(a[i] - max(rmaxb, b2[uk[j]])));
            best = min(best, abs(a[i] - max(rmaxb, b2[uk[j] + 1])));
        }
        for (int j = i / BLOCK * BLOCK; j < i; j++) {
            best = min(best, abs(a[i] - max(rmaxb, b[j])));
        }
        rmaxb = max(rmaxb, b[i]);
    }
    cout << best << endline;
}