#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr bool DEBUG = false;

ll arith(ll lx, ll rx) { // [lx, rx)
    return (rx - 1) * rx / 2 - (lx - 1) * lx / 2;
}

map<ll, ll> asked;

vector<ll> coins, debug_coins;

int Q = 0;

ll ask(ll r) {
    if (asked.count(r)) {
        return asked[r];
    } else if (r <= 0) {
        return asked[r] = 0;
    }

    ll x;
    Q += 1;

    if (!DEBUG) {
        cout << "? " << r << endl;
        cin >> x;

        if (x == -1) {
            exit(0);
        }
    } else {
        x = arith(1, r + 1);

        for (ll c : debug_coins) {
            if (c <= r) {
                x -= c;
            }
        }
    }

    return asked[r] = x;
}

ll ask(ll lx, ll rx) { // [lx, rx)
    return ask(rx - 1) - ask(lx - 1);
}

ll fake(ll lx, ll rx) {
    return arith(lx, rx) - ask(lx, rx);
}

bool good(ll lx, ll rx) {
    return fake(lx, rx) != 0;
}

int check_simple(ll lx, ll rx, ll sum, int k = -1) {
    k = max(k, -1);

    if (sum == arith(lx, rx)) {
        return 0;
    } else if (lx + 1 == rx) {
        coins.push_back(lx);
        return 1;
    } else if (k == 1) {
        coins.push_back(arith(lx, rx) - sum);
        return 1;
    } else if (k == rx - lx || sum == 0) {
        while (lx < rx) {
            coins.push_back(lx++);
        }
        return rx - lx;
    } else if (k + 1 == rx - lx) {
        while (lx < rx) {
            if (lx != sum) {
                coins.push_back(lx);
            }

            lx += 1;
        }
        return rx - lx - 1;
    }

    return -1;
}

int solve(ll lx, ll rx, ll sum, int k = -1) {
    k = max(k, -1);

    if (k == 0) {
        return 0;
    }

    int ret = check_simple(lx, rx, sum, k);

    if (ret != -1) {
        return ret;
    }

    ll mid = (lx + rx) >> 1;

    if (k == 2) {
        ll f = arith(lx, rx) - sum;
        ll m = f / 2;

        ll first = fake(lx, m + 1);
        ll second = f - first;

        coins.push_back(first);
        coins.push_back(second);

        return 2;
    } else {
        ll sumL = ask(lx, mid);
        ll sumR = sum - sumL;

        int kl = -1, kr = -1;

        if ((kl = check_simple(lx, mid, sumL)) != -1) {
            return kl + solve(mid, rx, sumR, k - kl);
        } else if ((kr = check_simple(mid, rx, sumR)) != -1) {
            return kr + solve(lx, mid, sumL, k - kr);
        }

        if (k == 3) {
            if (fake(mid, rx) >= rx) { // => right half contains 2
                solve(lx, mid, sumL, 1);
                solve(mid, rx, sumR, 2);
            } else {
                solve(lx, mid, sumL, 2);
                solve(mid, rx, sumR, 1);
            }

            return k;
        } else if (k == 4) {
            if (fake(mid, rx) < rx) {
               solve(lx, mid, sumL, 3);
               solve(mid, rx, sumR, 1);
            } else {
                ll f = fake(lx, mid);

                ll m = f / 2;

                if (fake(lx, m + 1) == 0) {
                    solve(lx, mid, sumL, 1);
                    solve(mid, rx, sumR, 3);
                } else {
                    solve(lx, mid, sumL, 2);
                    solve(mid, rx, sumR, 2);
                }
            }

            return k;
        } else {
            int res = solve(lx, mid, sumL, -1);
            return res + solve(mid, rx, sumR, k - res);
        }
    }
}

void solve() {
    coins.clear(), debug_coins.clear(), asked.clear();
    Q = 0;

    int n, k;
    cin >> n >> k;

    if (DEBUG) {
        debug_coins.resize(k);

        for (auto& x : debug_coins) {
            cin >> x;
        }
    }

    ll sum = ask(1, n + 1);

    solve(1, n + 1, sum, k);

    sort(coins.begin(), coins.end());
    coins.resize(unique(coins.begin(), coins.end()) - coins.begin());

    assert(coins.size() == k);

    cout << "! ";

    for (int x : coins) {
        cout << x << " ";
    }

    cout << endl;

    if (DEBUG) {
        cout << "You asked " << Q << " questions" << endl;
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}
