#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

class SegmentTree {
private:
    vector<int> d;
    int n;

    void upd(int i) {
        d[i] = (d[2 * i] + d[2 * i + 1]);
    }

public:
    SegmentTree(const vector<int> &v) {
        n = 1;
        while (n < sz(v)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(v); ++i) {
            d[i + n] = v[i];
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res += d[l++];
            }
            if (r & 1) {
                res += d[--r];
            }
        }
        return res;
    }

    void upd(int i, int x) {
        d[i += n] = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};

using pii = pair<int, int>;

template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
}

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
};

long long query;

gp_hash_table <int, long long> Q{};

void ask(int a) {
    if (Q.find(a) != Q.end()) {
        query = Q[a];
        return;
    }
    cout << "? " << a << endl;
    cin >> query;
    Q[a] = query;
    if (query == -1) {
        exit(0);
    }
}

long long sum(int i) {
    return 1ll * i * (i + 1) / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    Q.clear();
    int l = 1;
    long long sumBad = 0;
    vector <int> ans;
    long long G = sum(n);
    ask(n);
    G = G - query;
    for (int i = 0; i < k; ++i) {
        int l1 = l, r1 = ((int) G) - sumBad;
        while (l1 != r1) {
            int mid = (l1 + r1) / 2;
            ask(mid);
            if (query == sum(mid) - sumBad) {
                l1 = mid + 1;
            } else {
                r1 = mid;
            }
        }
        ans.push_back(l1);
        l = ++l1;
        sumBad += l - 1;
    }
    cout << "! ";
    for (auto i : ans) {
        cout << i << " ";
    }
    cout << endl;
    int b;
    cin >> b;
    if (b == -1) {
        exit(0);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
//    freopen("inputik.txt", "r", stdin);
//    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
