#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
#define int long long
using namespace std;

vector<int> Q;

#ifdef LOCAL
int n, k;
vector<int> P;
#endif

int query(int p) {
#ifndef LOCAL
    cout << "? " << p << endl;
    int res;
    cin >> res;
#else
    int res = (1 + p) * p / 2;
    for (int i : P) {
        if (i <= p)
        res -= i;
    }
#endif
    for (int i : Q) {
        if (i <= p) {
            res += i;
        }
    }
    return res;
}

void solve() {
#ifndef LOCAL
    int n, k;
    cin >> n >> k;
#endif
    while (k--) {
        int l = 0;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (query(m) != (1 + m) * m / 2) {
                r = m;
            } else {
                l = m;
            }
        }
        Q.push_back(r);
    }
    cout << "! ";
    for (int i : Q) {
        cout << i << " ";
    }
#ifdef LOCAL
    if (P != Q) {
        debug(Q);
        debug(P);
    }
#endif
    cout << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
#ifdef LOCAL
        random_device rd;
        mt19937 rnd(rd());
        n = rnd() % 10 + 1;
        P.resize(0);
        for (int i = 0; i <= rnd() % (min(n, 100ll)) + 1; i++) {
            P.push_back(rnd() % n + 1);
        }
        sort(P.begin(), P.end());
        P.erase(unique(P.begin(), P.end()), P.end());
        k = (int)P.size();
#endif
        Q.resize(0);
        solve();
    }
    return 0;
}
