#undef LOCAL
#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
#define int long long
using namespace std;

vector<int> Q;

map<int, int> cached;
int query(int p) {
    int res;
    if (cached.contains(p)) {
        res = cached[p];
    } else {
        cout << "? " << p << endl;
        cin >> res;
        if (res == -1) {
            exit(0);
        }
        cached[p] = res;
    }
    for (int i : Q) {
        if (i <= p) {
            res += i;
        }
    }
    return res;
}

void answer() {
    cout << "!";
    for (auto &i : Q) {
        cout << " " << i;
    }
    cout << endl;
    int res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 3) {
        {
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (query(m) != (1 + m) * m / 2) {
                    r = m;
                } else {
                    l = m;
                }
            }
            Q.push_back(r);
        }
        int sum = (1 + n) * n / 2 - query(n);
        int m = sum / 2;
        int x = (1 + m) * m / 2 - query(m);
        int y = sum - x;
        Q.push_back(x);
        Q.push_back(y);
    } else {
        while (k--) {
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (query(m) != (1 + m) * m / 2) {
                    r = m;
                } else {
                    l = m;
                }
            }
            Q.push_back(r);
        }
    }
    answer();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        cached.clear();
        Q.resize(0);
        solve();
    }
    return 0;
}