#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;

//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx2,bmi,bmi2,lzcnt,popcnt")

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'
#define int long long

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { cout << #a << endl; for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { cout << #a << endl; for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

void solve();

signed main() {
	int T = 1;
	cin >> T;
	while (T--) {
		solve();
	}
}

int cnt = 0;
vi answer;

ll get_sum(int x) {
	ll s = 0;
	for (int i = 0; i < answer.size() && answer[i] <= x; i++) {
		s += answer[i];
	}
	return s;
}

unordered_map<ll, ll> mem;

#ifdef DEBUG

vi missing;

void gen_missing(int n, int k) {
	set<int> raw;
	while (raw.size() < k) raw.insert(rnd() % n + 1);
	missing.clear();
	for (auto x : raw) missing.push_back(x);
	print(missing);
}

ll ask(ll p) {
	if (mem.count(p)) return mem[p];
	ll a = p * (p + 1) / 2;
	for (int i = 0; i < missing.size() && missing[i] <= p; i++) a -= missing[i];
	mem[p] = a;
	if (a == -1) exit(0);
	return a;
}

bool check() {
	if (answer.size() != missing.size()) return false;
	int q = answer.size();
	for (int i = 0; i < q; i++) {
		if (answer[i] != missing[i]) return false;
	}
	return true;
}

#else

void gen_missing(int n, int k) {

}

ll ask(int p) {

	if (mem.count(p)) return mem[p];
	cnt++;
	if (cnt > 3500) throw 1;
	cout << "? " << p << endl;
	ll a;
	cin >> a;
	mem[p] = a;
	if (a == -1) exit(0);
	return a;
}

bool check() {
	return true;
}

#endif // DEBUG






void solve() {
	ll n, q;
	cnt = 0;
	cin >> n >> q;
	//n = 1e6;
	//q = 15;
	gen_missing(n, q);
	answer = vi();
	mem = unordered_map<int, ll>();
	for (int i = 0; i < q - 1; i++) {
		int left = 0;
		int right = n;
		while (right - left > 1) {
			ll mid = (right + left) / 2;
			ll req = mid * (mid + 1) / 2 - get_sum(mid);
			if (ask(mid) == req) left = mid;
			else right = mid;
			//deb(left); debnl(right);
		}
		answer.push_back(right);
		//print(answer);
	}

	ll res = ask(n);
	answer.push_back((n * (n + 1) / 2 - accumulate(all(answer), 0LL)) - res);

	cout << "! ";
	for (auto x : answer) cout << x << ' ';
	cout << endl;
	int correct;
	cin >> correct;
	if (correct < 0) exit(0);
}
