#include <bits/stdc++.h>
#include <stdexcept>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, k;

    unordered_map<long long, long long> answered;

    long long false_sum(long long r) {
        if (r == 0 || answered.find(r) != answered.end()) {
            return answered[r];
        }
        cout << "? " << r << "\n";
        long long a;
        cin >> a;
        if (a == -1) {
            throw runtime_error("Exceeded query count");
        }
        answered[r] = r * (r + 1) / 2 - a;
        return answered[r];
    }

    vector<long long> res;

    solve() {
        if (k > 3) {
            stupid_solve();
        } else {
            smart_solve(0, n, k);
        }
    }

    bool check_add(long long x) {
        if (false_sum(x) - false_sum(x - 1) == x) {
            res.push_back(x);
            return true;
        }
        return false;
    }

    void smart_solve(int l, int r, int kk) {
        long long all_sm = false_sum(r) - false_sum(l);
        if (kk == 1) {
            res = {all_sm};
        } else {
            long long mean_sm = false_sum(all_sm / k) - false_sum(l);
            if (kk == 2) {
                assert(check_add(mean_sm));
                assert(check_add(all_sm - mean_sm));
            } else {
                if (mean_sm <= r && check_add(mean_sm)) {
                    smart_solve(all_sm / k, r, kk - 1);
                } else {
                    assert(check_add(all_sm - mean_sm));
                    smart_solve(l, all_sm / k, kk - 1);
                }
            }
        }
    }

    void stupid_solve() {
        long long prev_sum = 0;
        for (int i = 2; i <= n + 1; i += 2) {
            long long cur_sum = false_sum(min(i, (int)n));
            if (cur_sum == prev_sum) {
                continue;
            }
            if (cur_sum - prev_sum <= i) {
                res.push_back(cur_sum - prev_sum);
            } else {
                assert(cur_sum - prev_sum == i + (i - 1));
                res.push_back(i - 1);
                res.push_back(i);
            }
            prev_sum = cur_sum;
        }
    }

    void output() {
        cout << "! ";
        for (long long x : res) {
            cout << x << " ";
        }
        cout << "\n";
        int a;
        cin >> a;
        if (a == -1) {
       //     throw std::runtime_error("Oopsie, guessed wrong...");
       exit(0);
        }
    }

    ~solve() {
        output();
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
