#include <iostream>
#include <algorithm>
#include <set>
#include <vector>
#include <map>

using namespace std;

vector<long long> answer;
map<long long, long long> mem;

long long n, k;

long long get_summ(long long l, long long r) {
    return (r - l) * (r + l + 1) / 2;
}

long long ask(long long p) {
    long long ret;
    if (mem.find(p) == mem.end()) {
        cout << "? " << p << endl;
        cin >> ret;
        mem[p] = ret;
        if (ret == -1)
            exit(0);
    }
    return mem[p];
}

void rec(long long left_summ, long long curr_summ, long long l, long long r) {
    if (curr_summ == 0) {
        for (long long i = l; i < r; ++i) {
            answer.push_back(i);
        }
        return;
    }
    if (curr_summ < get_summ(l, r)) {
        if (answer.size() == k - 1) {
            answer.push_back(get_summ(l, r) - curr_summ - 1);
            return;
        }
        long long m = (l + r) / 2;
        long long ask1 = ask(m) - left_summ;
        long long ask2 = curr_summ - ask1;
        rec(left_summ, ask1, l, m), rec(left_summ + ask1, ask2, m, r);
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    long t;
    cin >> t;
    for (long h = 0; h < t; ++h) {
        mem[0] = 0;
        cin >> n >> k;
        rec(0, ask(n), 0, n);
        cout << "! ";
        for (long i = 0; i < k; ++i) {
            cout << answer[i] + 1 << " ";
        }
        cout << endl;
        cin >> k;
        if (k < 0)
            exit(0);
        answer.clear();
        mem.clear();
    }
    return 0;
}
