#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std; using namespace __gnu_pbds;
typedef long long ll; typedef long double ld;
typedef tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int INF = 1e9; ll ways = 1; ll MOD = 1e9 + 7;
struct line{
    int k, b;
    line() = default;
    line(int k, int b) : k(k), b(b) {};
    int get(int x){
        return k * x + b;
    }
};
int cross(line a, line b){
    if(a.k < b.k) swap(a, b);
    int x = (b.b - a.b) / (a.k - b.k);
    if(a.b > b.b) x--;
    return x;
}
vector<int>dots; vector<line>lines;
void add(line news){
    while(!lines.empty() && lines.back().get(dots.back()) > news.get(dots.back())){
        dots.pop_back(); lines.pop_back();
    }
    if(lines.empty()){
        dots.push_back(-INF);
    }else{
        dots.push_back(cross(news, lines.back()));
    }
    lines.push_back(news);
}
int get(int x){
    auto val = lower_bound(dots.begin(), dots.end(), x) - dots.begin() - 1;
    return lines[val].get(x);
}
struct Node{
    Node *left = nullptr, *right = nullptr;
    ll val = 0;
    Node() = default;
    Node(Node *l, Node *r, int val) : left(l), right(r), val(val) {};
};
void create(Node *t, int l, int r){
    if(t->left == nullptr){
        t->left = new Node();
    }if(t->right == nullptr){
        t->right = new Node();
    }
}
void update(Node* t, int l, int r, int ind, ll x){
    if(r <= ind || ind < l) return;
    if(l + 1 == r){
        t->val += x; return;
    }
    create(t, l, r);
    update(t->left, l, (l + r) / 2, ind, x); update(t->right, (l + r) / 2, r, ind, x);
    t->val = t->left->val + t->right->val;
}
ll get(Node *t, int l, int r, int tl, int tr){
    if(t->val == 0) return 0;
    if(tl >= r || tr <= l) return 0;
    if(l >= tl && r <= tr) return t->val;
    create(t, l, r);
    return (get(t->left, l, (l + r) / 2, tl, tr) + get(t->right, (l + r) / 2, r, tl, tr));
}
void solve(){
    int n, k; cin >> n >> k; vector<int>index; Node* root = new Node();
    if(n <= 1000){
        ll last = 0;
        for(int i = 0; i < n; i += 2){
            cout << "? " << i + 1 << endl;
            ll answer; cin >> answer;
            if(answer == last + i + 1){
                index.push_back(i + 2);
            }else if(answer == last + i + 2) index.push_back(i + 1);
            else{
                index.push_back(i + 1); index.push_back(i + 2);
            }
            last = answer;
        }
        cout << "! ";
        for(auto val: index){
            cout << val + 1 << " ";
        }
        cout << endl;
        int a; cin >> a;
        if(a == -1) exit(0);
        return;
    }
    for(int i = 0; i < k; i++){
        ll left = 0; ll right = n;
        while(left + 1 < right){
            ll mid = (left + right) / 2;
            cout << "? " << mid << endl;
            ll answer; cin >> answer;
            if(answer < (mid + 1) * mid / 2 - get(root, 0, n, 0, mid)){
                right = mid;
            }else left = mid;
        }
        update(root, 0, n, left, left + 1); index.push_back(left);
    }
    cout << "! ";
    for(auto val: index){
        cout << val + 1 << " ";
    }
    cout << endl;
    int a; cin >> a;
    if(a == -1) exit(0);
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int t; cin >> t;
    while(t--){
        solve();
    }
}
