#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <map>
#include <set>
#include <math.h>
#include <climits>
#include <deque>

using namespace std;

#define ll long long
#define lll __int128
#define ld long double
#define lld __float128
#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

struct interactor {
    ll ans(vector<ll> what) {
        cout << '!' << " ";
        for (int i = 0; i < what.size(); ++i) cout << what[i] << " ";
        cout << endl;
        ll res;
        cin >> res;
        return res;
    }

    ll ask(ll what) {
        cout << "?" << " " << what << endl;
        ll ans;
        cin >> ans;
        if (ans == -1) exit(0);
        return ans;
    }
};

ll formulo(ll index) {
    return ((index + 1) * index) / 2;
}

void solve() {
    int n, m;
    cin >> n >> m;
    ll curleft = 0, badSum = 0;
    interactor ask;
    vector<ll> answers;
    set<pair<ll, ll>> queries; // index with result
    queries.insert({0, 0});
    for (int i = 0; i < m; ++i) {
        ll l = curleft, r = n + 1;
        bool find = 0;
        while (r - l > 1) {
            auto lb = queries.lower_bound({ l + 1, -1 });
            if (lb != queries.end() && (*lb).first != r) {
                auto pa = *lb;
                ll needed = formulo(pa.first) - badSum;
                ll result = pa.second;
                (needed == result ? l : r) = pa.first;
            }
            else {
                int mid = (r + l) / 2;
                ll needed = formulo(mid) - badSum;
                ll result = ask.ask(mid);
                (needed == result ? l : r) = mid;
                queries.insert({ mid, result });
            }
            if (l * 2 >= r) {
                auto lb1 = queries.lower_bound({ l, -1 });
                auto lb2 = queries.lower_bound({ r, -1 });
                if (lb1 != queries.end() && (*lb1).first == l && lb2 != queries.end() && (*lb2).first == r) {
                    ll needed = formulo(r) - badSum;
                    ll result = (*lb2).second;
                    if (needed - result <= r) {
                        ll newy = needed - result;
                        if (newy <= 2 * r) {
                            answers.push_back(newy);
                            badSum += newy;
                            curleft = newy;
                            find = 1;
                            queries.insert({ newy, formulo(newy) - badSum });
                            break;
                        }
                    }
                }
            }
        }
        if (!find) {
            answers.push_back(r);
            badSum += r;
            curleft = l;
        }
    }
    ask.ans(answers);
}

int main() {
    fast;
    srand((int)time(nullptr));
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}