#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

map<ll, ll> memorized;

ll ask(ll p) {
    if (memorized.contains(p)) {
        return memorized[p];
    }

    cout << "? " << p << endl;
    ll res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }

    memorized[p] = res;
    return res;
}

void resolve() {
    memorized.clear();
    ll n, k;
    cin >> n >> k;
    if (n == -1 || k == -1) {
        exit(0);
    }

    ll allSum = ask(n);
    vector<ll> res;
    ll got = 0;
    for (ll i = 0; i < k - 1; ++i) {
        ll l = 0;
        ll r = n + 1;
        if (!res.empty()) {
            l = res.back();
        }

        while (r - l > 1) {
            ll m = (l + r) >> 1;
            ll real = ask(m);
            ll notLeft = (m * (m + 1) / 2) - got;
            ll diff = notLeft - real;
            if (diff > 0 && diff < l * 2) {
                r = diff;
                break;
            }

            if (real == notLeft) {
                l = m;
            } else {
                r = m;
            }
        }

        res.push_back(r);
        got += r;
    }

    res.push_back(n * (n + 1) / 2 - allSum - got);
    cout << "! ";
    for (ll i = 0; i < ll(res.size()); ++i) {
        cout << res[i];
        if (i < n - 1) {
            cout << ' ';
        }
    }
    cout << endl;

    ll verdict;
    cin >> verdict;
    if (verdict == -1) {
        exit(0);
    }
}

int32_t main() {
    ll testN;
    cin >> testN;
    while (testN--) {
        resolve();
    }
    return 0;
}
