#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
//random_device rd;
//mt19937 gen(rd);
const int SZ = 1e5 + 1, inf = 2e9;
const long long INF = 2e18;

struct Pt {
    ld x, y;
    Pt(ld x = 0, ld y = 0) : x(x), y(y) {}
};

Pt operator+(Pt a, Pt b) {
    return Pt(a.x + b.x, a.y + b.y);
}
Pt operator-(Pt a, Pt b) {
    return Pt(a.x - b.x, a.y - b.y);
}
ld operator*(Pt a, Pt b) {
    return a.x * b.x + a.y * b.y;
}
ld operator%(Pt a, Pt b) {
    return a.x * b.y - a.y * b.x;
}
ld get_ungle(Pt a, Pt b) {
    return atan2(a % b, a * b);
}

struct segment_tree {
    struct Node {
        ///
        Node() {}
    };
    int sz;
    vector<Node> tree;

    segment_tree(int n) {
        int k = 1;
        while (k < n)
            k <<= 1;
        sz = k;
        tree.assign(sz * 2 - 1, Node());
        build(0, 0, sz);
    }

    void push(int v, int l, int r) {
        return;
    }

    void upd(int v, int l, int r) {
        return;
    }

    void build(int vert, int left, int right) {
        if (right - left) {
            return;
        }
        int midle = (left + right) / 2;
        build(vert * 2 + 1, left, midle);
        build(vert * 2 + 2, midle, right);
        upd(vert, left, right);
    }

    void on_segment(int vert, int left, int right, int qleft, int qright) {
        if (qleft <= left && right <= qright) {
            //in
            return;
        }
        if (right <= qleft || qright <= left) {
            //not in
            return;
        }
        push(vert, left, right);
        int midle = (left + right) / 2;
        on_segment(vert * 2 + 1, left, midle, qleft, qright);
        on_segment(vert * 2 + 2, midle, right, qleft, qright);
        upd(vert, left, right);
    }
};

struct n_segment_tree {
    struct Node {
        ///
        int l, r;
        Node(int l = -1, int r = -1) : l(l), r(r) {}
    };
    int sz;
    vector<Node> tree;

    n_segment_tree(int n) {
        int k = 1;
        while (k < n)
            k <<= 1;
        sz = k;
        tree.assign(1, Node());
        //build(0, 0, sz);
    }

    void push(int v, int l, int r) {
        if (tree[v].l == -1) {
            tree[v].l = tree.size();
            tree.push_back(Node());
        }
        if (tree[v].r == -1) {
            tree[v].r = tree.size();
            tree.push_back(Node());
        }
        return;
    }

    void upd(int v, int l, int r) {
        return;
    }

    void on_segment(int vert, int left, int right, int qleft, int qright) {
        if (qleft <= left && right <= qright) {
            //in
            return;
        }
        if (right <= qleft || qright <= left) {
            //not in
            return;
        }
        push(vert, left, right);
        int midle = (left + right) / 2;
        on_segment(tree[vert].l, left, midle, qleft, qright);
        on_segment(tree[vert].r, midle, right, qleft, qright);
        upd(vert, left, right);
    }
};

vector<ll> ans;

void get_ans(ll l, ll r, ll sum_left = 0, ll sum = 0) { // (l, r]
    if (l == r)
        return;
    ll sum_true = r * (r + 1) / 2 - l * (l + 1) / 2;
    if (sum == sum_true)
        return;
    else if (r - l == 1) {
        ans.push_back(r);
        return;
    }
    ll mid = (l + r) / 2;
    ll x, x_true = mid * (mid + 1) / 2 - l * (l + 1) / 2;
    cout << "? " << mid << endl;
    cin >> x;
    x -= sum_left;
    if (x != x_true) {
        get_ans(l, mid, sum_left, x);
    }
    ll right_true = r * (r + 1) / 2 - mid * (mid + 1) / 2;
    if (sum - x != right_true) {
        if (right_true - (sum - x) <= r) {
            // right_true - (sum - x) - ans;
            ans.push_back(right_true - (sum - x));
            return;
        }
        get_ans(mid, r, sum_left + x, sum - x);
    }
    return;
    
}

int main()
{
#ifdef _DEBUG
    //freopen("input.txt", "r", stdin);
#endif
    //ios_base::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);
    int t;
    cin >> t;
    for (int q = 0; q < t; q++) {
        ans.clear();
        ll n, k, x;
        cin >> n >> k;
        cout << "? " << n << endl;
        cin >> x;
        get_ans(0, n, 0, x);
        cout << "!";
        for (auto x : ans)
            cout << ' ' << x;
        cout << endl;
        cin >> x;
        if (x == -1)
            return 0;
    }
}