//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <unordered_map>

using namespace std;

//#define LOCAL

vector<int> v;
#define ll long long
#ifdef LOCAL
vector<int> not_real = {2, 4, 7, 10};
int r_n = (int) 1e7;
#endif

ll count(ll k) {
    return (k * (k + 1)) / 2;
}

vector<pair<int, ll>> save;
unordered_map<int, int> mem;

ll ask(int k) {
    ll res;
    if (mem.find(k) != mem.end()) {
        res = mem[k];
        for (int el : v) {
            if (el <= k) {
                res += (ll) el;
            }
        }
        return res;
    }
    cout << '?' << ' ' << k << endl;
#ifdef LOCAL
    res = 0;
    for (int i = 1; i <= k; i++) {
        res += i;
    }
    for (int el : not_real) {
        if (el <= k) {
            res -= el;
        }
    }
#else
    cin >> res;
#endif
    if (res < 0) {
        exit(0);
    }
    for (int el : v) {
        if (el <= k) {
            res += (ll) el;
        }
    }
    save.push_back({k, res});
    return res;
}

void ans() {
    cout << '!' << ' ';
    for (int el : v) {
        cout << el << ' ';
    }
    cout << endl;
    int res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
}

int main() {
    int t;
#ifdef LOCAL
    t = 1;
#else
    cin >> t;
#endif

    for (int q = 0; q < t; q++) {
        int n, k;
#ifdef LOCAL
        n = r_n;
        k = not_real.size();
#else
        cin >> n >> k;
#endif
        v.resize(0);
        save.resize(0);

        if (k == 3) {
            int l = 0, r = n;
            if (v.size() > 0) {
                for (auto el : save) {
                    if (el.second - count(el.first) == v[v.size() - 1]) {
                        l = max(l, el.first);
                    }
                }
            }
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (ask(m) != count(m)) {
                    r = m;
                } else {
                    l = m;
                }
            }

            v.push_back(r);


            ll sum = ask(n);
            ll dif = count(n) - sum;

            ll sum2 = ask(dif / 2);
            ll sec = count(dif / 2) - sum2;
            v.push_back(sec);
            v.push_back(dif - sec);
            ans();
            continue;
        }

        if (k == 4) {
            int l = 0, r = n;
            if (v.size() > 0) {
                for (auto el : save) {
                    if (el.second - count(el.first) == v[v.size() - 1]) {
                        l = max(l, el.first);
                    }
                }
            }
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (ask(m) != count(m)) {
                    r = m;
                } else {
                    l = m;
                }
            }

            v.push_back(r);


            ll sum = ask(n);
            ll dif = count(n) - sum;

            ll sum2 = ask(dif / 3);
            ll sec = count(dif / 3) - sum2;
            ll sum23 = ask(sec / 2);
            if (sum23 == count(sec / 2)) {
                v.push_back(sec);
                dif -= sec;
                ll sum3 = ask(dif / 2);
                ll th = count(dif / 2) - sum3;
                v.push_back(th);
                v.push_back(dif - th);
            } else {
                v.push_back(dif - sec);
                dif -= (dif - sec);

                ll sum3 = ask(dif / 2);
                ll th = count(dif / 2) - sum3;
                v.push_back(th);
                v.push_back(dif - th);
            }
            ans();
            continue;
        }


        for (int i = 0; i < k; i++) {
            int l = 0, r = n;
            if (v.size() > 0) {
                for (auto el : save) {
                    if (el.second - count(el.first) == v[v.size() - 1]) {
                        l = max(l, el.first);
                    }
                }
            }
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (ask(m) != count(m)) {
                    r = m;
                } else {
                    l = m;
                }
            }

            v.push_back(r);
        }
        ans();
    }

}
