﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e9 + 10);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<ll> res, pref;
ll n, k;

void addFake(const ll val) {
	res.push_back(val);
	pref.push_back(val);
	if (pref.size() > 1)
		pref.back() += pref[pref.size() - 2];
}


ll getSum(const ll p) {
	return p * (p + 1ll) / 2ll;
}


ll okSum(const ll p) {
	ll s = getSum(p);
	auto buf = upper_bound(res.begin(), res.end(), p);
	if (buf != res.begin()) {
		--buf;
		s -= pref[buf - res.begin()];
	}
	return s;
}


bool isFake(const ll p) {
	ll sum;
	cout << "? " << p << endl;
	cin >> sum;
	return okSum(p) != sum;
}


void solve(istream& cin, ostream& cout) {
	res.clear();
	pref.clear();
	cin >> n >> k;

	ll L = 0, R = n, M;
	for (ll i = 0; i < k; ++i) {
		if (!res.empty()) {
			L = res.back();
			R = n;
		}

		while (R - L > 1) {
			M = (R + L) / 2;
			if (isFake(M))
				R = M;
			else
				L = M;
		}
		addFake(R);
	}

	cout << "! ";
	for (auto& t : res)
		cout << t << ' ';
	cout << endl;

	ll ok;
	cin >> ok;
	if (ok != 1)
		exit(0);
}