﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e9 + 10);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


map<ll, ll> zp;
vector<ll> res, pref;
ll n, k;
ll L, R;
bool break_run = false;


void addFake(const ll val) {
	res.push_back(val);
	if (res.size() <= 1 || res.back() > res[res.size() - 2]) {
		pref.push_back(val);
		if (pref.size() > 1)
			pref.back() += pref[pref.size() - 2];
	} else {
		sort(res.begin(), res.end());
		pref.push_back(0);
		pref[0] = res[0];
		for (ll i = 1; i < res.size(); ++i)
			pref[i] = pref[i - 1] + res[i];
	}
}


ll getSum(const ll p) {
	return p * (p + 1ll) / 2ll;
}


ll okSum(const ll p) {
	ll s = getSum(p);
	auto buf = upper_bound(res.begin(), res.end(), p);
	if (buf != res.begin()) {
		--buf;
		s -= pref[buf - res.begin()];
	}
	return s;
}


void findSuperFake(const ll p2) {
	if (okSum(p2) == zp[p2])
		return;

	auto iter = zp.lower_bound(p2);
	if (iter != zp.begin()) {
		--iter;
		ll p1 = iter->first;
		if (zp[p1] == zp[p2]) {
			for (ll i = p1; i <= p2; ++i) {
				if (zp[p1] != okSum(i))
					addFake(i);
				zp[i] = zp[p1];
			}
			break_run = true;
		}
	}


	auto d = okSum(p2) - zp[p2];

	if (d != 0 && d < 2 * L + 3) {
		addFake(d);
		break_run = true;
	}
}


bool isFake(const ll p) {
	auto iter = zp.lower_bound(p);


	if (iter != zp.end()) {
		if (iter->first == p) {
			findSuperFake(p);
			return okSum(p) != iter->second;
		}


		if (okSum(iter->first) == iter->second)
			return false;
	}


	if (iter != zp.begin()) {
		--iter;
		if (okSum(iter->first) != iter->second)
			return true;
	}

	ll sum;
	cout << "? " << p << endl;
	cin >> sum;
	if (sum == -1)
		exit(-1);
	zp[p] = sum;
	findSuperFake(p);
	return okSum(p) != sum;
}


void solve(istream& cin, ostream& cout) {
	res.clear();
	pref.clear();
	zp.clear();
	cin >> n >> k;
	zp[0] = 0;


	while (res.size() < k) {
		break_run = false;
		L = 0;
		R = n;

		for (auto& [p, sum] : zp) {
			if (isFake(p))
				R = min(R, p);
			else
				L = max(L, p);
		}

		while (R - L > 1 && !break_run) {
			ll M = (R + L) / 2;
			if (isFake(M))
				R = M;
			else
				L = M;
		}
		if (break_run)
			continue;
		addFake(R);
	}

	cout << "! ";
	for (auto& t : res)
		cout << t << ' ';
	cout << endl;

	ll ok;
	cin >> ok;
	if (ok != 1)
		exit(-1);
}