#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
//#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return abs(uid(rng)) % n;
}

int R = 1;
struct segment_tree {
    vector<ll> t, d;

    explicit segment_tree(int n = 1 << 19) {
        R = 1;
        while (R < n)
            R *= 2;
        t.resize(R * 2 + 10, 0);
        d.resize(R * 2 + 10, 0);
    }

    void calc(int node) {
        if (node < R)
            t[node] = t[node * 2] + t[node * 2 + 1];
    }

    void push(int node, int nl, int nr) {
        t[node] += d[node] * (nr - nl + 1);
        if (node < R) {
            d[node * 2] += d[node];
            d[node * 2 + 1] += d[node];
        }
        d[node] = 0;
    }

    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (ql <= nl && nr <= qr) {
            t[node] += val * (nr - nl + 1);
            d[node] += val;
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }

    ll ans(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (ql <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return ans(ql, qr, node * 2, nl, nm) +
               ans(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

struct Point {
    ld x{}, y{};
    Point() = default;
    Point(ld x, ld y) : x(x), y(y) {}
    ld operator*(Point& other) const {
        return x * other.x + y * other.y;
    }
    ld operator%(Point& other) const {
        return x * other.y - y * other.x;
    }
    Point operator-(Point& other) const {
        return {x - other.x, y - other.y};
    }
    Point operator+(Point& other) const {
        return {x + other.x, y + other.y};
    }
    ld len2() const {
        return x * x + y * y;
    }
};
#define Vector Point
#define Polygon vector <Point>

bool is_prime(ll x) {
    for (ll i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}
ll get_mod() {
    ll i = ll(1e9 + 7) + rnd(1e9);
    while (!is_prime(i))
        i++;
    return i;
}
const ll MOD1 = 1e9 + 1000 - 7, MOD2 = get_mod();
const ll P = 73;
const int HASH_SIZE = 1;
pair <ll, ll> Ps[HASH_SIZE];
void init_hash() {
    Ps[0] = {1, 1};
    for (int i = 1; i < HASH_SIZE; i++)
        Ps[i] = {Ps[i - 1].F * P % MOD1, Ps[i - 1].S * P % MOD2};
}
struct str_hash {
    vector <pair <ll, ll>> H;
    explicit str_hash(string& s) {
        if (Ps[0].F != 1)
            init_hash();
        H.resize(s.size() + 1);
        for (int i = 1; i <= s.size(); i++)
            H[i] = {(H[i - 1].F + (s[i - 1] - 'a' + 1) * Ps[i].F) % MOD1,
                    (H[i - 1].S + (s[i - 1] - 'a' + 1) * Ps[i].S) % MOD2};
    }
    pair <ll, ll> get(int l, int r) {
        l++, r++;
        return {(H[r].F - H[l - 1].F + MOD1) % MOD1 * Ps[HASH_SIZE - l].F % MOD1,
                (H[r].S - H[l - 1].S + MOD2) % MOD2 * Ps[HASH_SIZE - l].S % MOD2};
    }
};

ll f(ll x) {
    cout << "? " << x << endl;
    ll res;
    cin >> res;
    return res;
}

ll cnt = 0;
bool check(ll x) {
    ll t = (x + 1) * x / 2 - cnt;
    return t == f(x);
}

void solve() {
    ll n, k;
    cin >> n >> k;
    ll last = 0;
    vector <ll> ans;
    for (int _ = 0; _ < k; _++) {
        ll l = last + 1, r = n + 1;
        while (l + 1 < r) {
            ll m = (l + r) / 2;
            if (check(m))
                l = m;
            else
                r = m;
        }
        ans.push_back(l);
        last = l;
        cnt += l;
    }
    cout << "! ";
    for (auto& i : ans)
        cout << i << ' ';
    cout << endl;
}

int main() {
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    //ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
