#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

#ifdef LOCAL
int N = 1000000000, K = 4;
vector<int> secret = {123, 1343, 87236, 124876};
ll ask(int p) {
    cout << "? " << p << endl;
    ll res = (ll)p * (p + 1) / 2;
    for (auto x : secret) {
        if (x <= p) res -= x;
    }
    cout << res << endl;
    return res;
}

void answer(vector<int> &v) {
    cout << "!";
    for (auto el : v) {
        cout << ' ' << el;
    }
    cout << endl;
    sort(v.begin(), v.end());
    int res;
    if (secret == v) {
        res = 1;
    } else {
        res = -1;
    }
    cout << res << endl << '\n';
    if (res == -1) assert(false);
}
#else
ll ask(int p) {
    cout << "? " << p << endl;
    ll secret;
    cin >> secret;
    if (secret == -1) assert(false);
    return secret;
}

void answer(vector<int> &v) {
    cout << "!";
    for (auto el : v) {
        cout << ' ' << el;
    }
    cout << endl;
    int secret;
    cin >> secret;
    if (secret == -1) assert(false);
}
#endif

ll diff(int p) {
    return ((ll)p * (p + 1) / 2) - ask(p);
}

void solve() {
#ifdef LOCAL
    int n = N, k = K;
#else
    int n, k;
    cin >> n >> k;
#endif
    vector<int> ans;
    int left = n;
    ll d = diff(n);
    set<pair<ll, int>> answers = {{0, 0}, {d, n}};
    for (int i = 0; i < k; ++i) {
        int l = (--answers.lower_bound({d, 0}))->second;
        int r = answers.lower_bound({d, 0})->second;
        ll d_l = 0;
        while (r - l > 1) {
            int m = (l + r) / 2;
            ll d_m = diff(m);
            answers.emplace(d_m, m);
            if (d_m == d) {
                r = m;
            } else {
                l = m;
                d_l = d_m;
            }
        }
        left = l;
        d = d_l;
        ans.push_back(r);
    }
    answer(ans);
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}