#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

const int N = 5e5 + 7, MOD = 1e9 + 7, C = 10;

#define int long long

vector<int> answers;

vector<pair<int, long long> > queries;

int n, k;

long long find(int p) {
	for (int i = 0; i < queries.size(); i++) {
		if (queries[i].first == p) {
			return queries[i].second;
		}
	}
	return -1;
}

long long query(long long p) {
	long long f = find(p);
	if (f != -1) {
		return f;
	}
	cout << "? " << p << "\n";
	cout.flush();
	long long q;
	cin >> q;
	for (auto u : answers) {
		if (u <= p) {
			q += u;
		}
	}
	queries.push_back({ p,  (p * (p + 1)) / 2 - q });
	return (p * (p + 1)) / 2 - q;
}

void add(int p) {
	for (auto& u : queries) {
		if (u.first >= p) {
			u.second -= p;
		}
	}
}

int GetMax() {
	int mx = 0;
	for (auto u : queries) {
		if (u.second == 0) {
			mx = max(mx, u.first);
		}
	}
	return mx;
}

int GetMin() {
	int mn = n;
	for (auto u : queries) {
		if (u.second != 0) {
			mn = min(mn, u.first);
		}
	}
	return mn;
}

void solve() {
	queries.clear();
	answers.clear();
	cin >> n >> k;
	if (k == 3) {
		int L = GetMax(), R = GetMin();
		while (R - L > 1) {
			int mid = (L + R) / 2;
			if (query(mid) == 0) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		int fst = R;
		answers.push_back(R);
		add(R);
		int SUM = query(n);
		int k1 = R + 1;
		int k2 = SUM - k1;
		if (!(k1 > R && k2 > R && k2 <= n)) {
			k1 = n;
			k2 = SUM - n;
		}
		int snd = query((k1 + k2) / 2);
		int trd = SUM - snd;
		if (snd == 0 || trd == 0) {
			int t = 0;
			cout << 1 / t;
		}
		cout << "! " << fst << " " << snd << " " << trd << "\n";
		cout.flush();
		int a;
		cin >> a;
		if (a == -1) {
			exit(0);
		}
		return;
	}
	if (n > 1000) {
		int bl = n / C;
		for (int i = 0; i < C - 1; i++) {
			query(bl * (i + 1));
		}
	}
	for (int i = 0; i < k; i++) {
		int L = GetMax(), R = GetMin();
		while (R - L > 1) {
			int mid = (L + R) / 2;
			if (query(mid) == 0) {
				L = mid;
			}
			else {
				R = mid;
			}
		}
		answers.push_back(R);
		add(R);
	}
	cout << "! ";
	for (auto u : answers) {
		cout << u << " ";
	}
	cout << "\n";
	cout.flush();
	int a;
	cin >> a;
	if (a == -1) {
		exit(0);
	}
}


signed main()
{
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
#else
	//std::ios::sync_with_stdio(false);
	//cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}