#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

struct fenwick
{
	long long n;
	unordered_map<long long, long long> t;

	fenwick(long long in)
	{
		n = in;
	}

	void upd(long long k, long long val)
	{
		k++;
		for (; k <= n; k += k & -k)
		{
			t[k] += val;
		}
	}

	long long get(long long k)
	{
		k++;
		long long sum = 0;
		for (; k > 0; k -= k & -k)
		{
			sum += t[k];
		}
		return sum;
	}
};

long long sumlr(long long l, long long r)
{
	return (l + r) * (r - l + 1) / 2;
}

map<long long, long long> memqr;

long long ask(long long k)
{
	long long res = 0;
	cout << "? " << k << endl;
	cin >> res;
	return res;
}

void answer(vector<long long>& ans)
{
	cout << "! ";
	for (auto& i : ans)
	{
		cout << i << " ";
	}
	cout << endl;
}

void solve()
{
	long long n, k;
	cin >> n >> k;

	long long prev = 0;
	vector<long long> ans;
	for (long long i = 1; i < n + 1; i++)
	{
		long long res = ask(i);
		if (prev == res)
		{
			ans.push_back(i);
		}
		prev = res;
	}
	answer(ans);
}

void reset()
{
	memqr.clear();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
		reset();
	}

	return 0;
}

/*























*/
