#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <algorithm>
#include <deque>
#include <queue>

using namespace std;

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcp(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

#define int long long

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        vector<int> ans = {0};
        set<pair<int, int>> quests;
        quests.insert({n, 1e18});
        quests.insert({0, 0});
        int s = 0;
        if (k >= 2) {
            if (k > 2) {
                for (int cnt = 0; cnt < k - 2; ++cnt) {
                    auto c = quests.lower_bound({ans.back() + 1, 0});
                    int pr = ans.back();
                    while (c->second == c->first * (c->first + 1) / 2 - s) {
                        pr = c->first;
                        ++c;
                    }
                    int kkk = (c->first + 1) * c->first / 2 - s - c->second;
                    if (kkk > ans.back() && (pr + 1) * 2 > kkk) {
                        s += kkk;
                        ans.push_back(kkk);
                        continue;
                    }
                    int r = c->first;
                    --c;
                    int l = c->first;
                    int answ = -1;
                    while (r - l > 1) {
                        int m = (l + r) / 2;
                        cout << "? " << m << endl;
                        int res;
                        cin >> res;
                        quests.insert({m, res});
                        int kk = m * (m + 1) / 2 - s - res;
                        if (kk > ans.back() && (l + 1) * 2 > kk) {
                            answ = kk;
                            break;
                        }
                        if (m * (m + 1) / 2 - s == res) {
                            l = m;
                        } else {
                            r = m;
                        }
                    }
                    if (answ >= 0) {
                        ans.push_back(answ);
                    } else {
                        answ = r;
                        ans.push_back(r);
                    }
                    s += answ;
                }
            }
            cout << "? " << n << endl;
            int summ;
            cin >> summ;
            int ss = n * (n + 1) / 2 - summ - s;
            int ind = ss / 2;
            cout << "? " << ind << endl;
            int res;
            cin >> res;
            ans.push_back((ind + 1) * ind / 2 - s - res);
            s += ans.back();
            ans.push_back(n * (n + 1) / 2 - s - summ);
        } else {
            for (int cnt = 0; cnt < k; ++cnt) {
                auto c = quests.lower_bound({ans.back() + 1, 0});
                int pr = ans.back();
                while (c->second == c->first * (c->first + 1) / 2 - s) {
                    pr = c->first;
                    ++c;
                }
                int kkk = (c->first + 1) * c->first / 2 - s - c->second;
                if (kkk > ans.back() && (pr + 1) * 2 > kkk) {
                    s += kkk;
                    ans.push_back(kkk);
                    continue;
                }
                int r = c->first;
                --c;
                int l = c->first;
                int answ = -1;
                while (r - l > 1) {
                    int m = (l + r) / 2;
                    cout << "? " << m << endl;
                    int res;
                    cin >> res;
                    quests.insert({m, res});
                    int kk = m * (m + 1) / 2 - s - res;
                    if (kk > ans.back() && (l + 1) * 2 > kk) {
                        answ = kk;
                        break;
                    }
                    if (m * (m + 1) / 2 - s == res) {
                        l = m;
                    } else {
                        r = m;
                    }
                }
                if (answ >= 0) {
                    ans.push_back(answ);
                } else {
                    answ = r;
                    ans.push_back(r);
                }
                s += answ;
            }
        }
        cout << "! ";
        for (int i = 1; i <= k; ++i) {
            cout << ans[i] << " ";
        }
        cout << endl;
        int res;
        cin >> res;
        if (res != 1) {
            exit(1);
        }
    }
}