#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

void solve();

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--){
        solve();
    }
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}

vector<int> found;


map<int, ll> asked;

ll ask(int k){
    ll x;
    if (asked.find(k) == asked.end()){
        cout << "? " << k << endl;
        cin >> x;
        asked[k] = x;
    }
    x = asked[k];
    for (auto el : found){
        if (el <= k){
            x += el;
        }
    }
    return x;
}

ll get(ll x){
    return (x + 1) * x / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < k; ++i) {
        int l = 0;
        int r = 1e9;
        while (r - l > 1){
            int m = (l + r) / 2;
            if (ask(m) == get(m)){
                r = m;
            } else{
                l = m;
            }
        }
        found.push_back(r);
    }
    cout << "! ";
    for (int i = 0; i < k; ++i) {
        cout << found[i] << ' ';
    }
    cout << endl;
    int a;
    cin >> a;
    assert(a == 1);
}