#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
//ifstream input("input");
//#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

int ask(int p) {
	cout << "?" << " " << p << endl;
	int ans;
	cin >> ans;
	if (ans == -1) {
		exit(0);
	}
	return p * (p + 1) / 2 - ans;
}

void say(const vector<int> &is) {
	cout << "!" << " ";
	for (const int &i : is) {
		cout << i << " ";
	}
	cout << endl;
	int ans;
	cin >> ans;
	if (ans == -1) {
		exit(0);
	}
}

vector<int> operator+(const vector<int> &a, const vector<int> &b) {
	vector<int> c(a.begin(), a.end());
	copy(b.begin(), b.end(), back_inserter(c));
	return c;
}

vector<int> gen(int l, int r, int k, int pref) {
	int s = ask(r) - pref;
	if (k == 1) {
		return {s};
	}
	assert(1 <= s / k && s / k < r);
	int s1 = ask(s / k) - pref;
	assert(0 < s1 && s1 < s);
	if (k == 2) {
		return gen(l, s / k, 1, pref) + gen(s / k + 1, r, 1, pref + s1);
	}
	if (k == 3) {
		if (s1 == l || (s1 <= r && ask(s1 - 1) - pref == 0)) {
			return gen(l, s / k, 1, pref) + gen(s / k + 1, r, 2, pref + s1);
		} else {
			return gen(l, s / k, 2, pref) + gen(s / k + 1, r, 1, pref + s1);
		}
	}
	assert(0);
}

void solve() {
	int n, k;
	cin >> n >> k;
	if (k <= 3) {
		say(gen(1, n, k, 0));
		return;
	}
	vector<pair<int, int>> p;
	p.emplace_back(0, 0);
	for (int i = 0; i < k; ++i) {
		int l = p.back().first;
		int r = n + 1;
		int rans = -1;
		while (l + 1 < r) {
			int mid = (l + r) / 2;
			int mans = ask(mid);
			if (mans == p.back().second) {
				l = mid;
			} else {
				r = mid;
				rans = mans;
			}
		}
		p.emplace_back(r, rans);
	}
	vector<int> ans;
	for (int i = 0; i < k; ++i) {
		ans.push_back(p[i + 1].first);
	}
	say(ans);
}

int32_t main() {
	int T = 1;
	cin >> T;
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
