#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma,sse,sse2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#if defined(DEBUG)
//  freopen("../in.txt", "r", stdin);
//  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  ll t;
  cin >> t;
  while (t--)
    solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

#ifndef DEBUG
//#define endl '\n'
#endif

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ----------

class solver {
 public:
  solver() = default;

  ll ask(ll i) {
    if (i == 0) return 0;
    cout << "? " << i << endl;
    ll r;
    cin >> r;
    return r;
  }

  ll weight(ll i) {
    return i * (i + 1) / 2 - badsum;
  }

  void solve() {
    cin >> n >> k;
    ll left = 0;
    for (int i = 0; i < k; ++i) {
      ll L = left, R = n;
      while (R - L > 1) {
        ll M = (L + R) / 2;
        ll a = ask(M);
        if (a == -1) {
          return;
        }
        (a == weight(M) ? L : R) = M;
      }
      left = R;
      fakes.emplace_back(R);
      badsum += R;
    }

    cout << "! " << fakes << endl;
  }

  ll n, k;
  vi fakes;
  ll badsum = 0;
};

void solve() {
  auto s = solver();
  s.solve();
}