#ifndef DEBUG
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,fma,sse,sse2")
//#pragma GCC optimize("unroll-loops")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#if defined(DEBUG)
//  freopen("../in.txt", "r", stdin);
//  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  ll t;
  cin >> t;
  while (t--)
    solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

#ifndef DEBUG
//#define endl '\n'
#endif

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ----------

class solver {
 public:
  solver() = default;

  ll ask(ll i) {
    if (i == 0) return 0;
    cout << "? " << i << endl;
    ll r;
    cin >> r;
    if (r == -1) abort();
    return r;
  }

  void answer(const vi &a) {
    cout << "! " << a << endl;
    ll r;
    cin >> r;
    if (r == -1) exit(0);
  }

  ll weight(ll i) {
    return i * (i + 1) / 2;
  }

  void solve_range_k(ll l, ll r, ll prefbad, ll badsum, ll k) {
    ll m = badsum / k;
    assert(l < m && m <= r);

    if (k == 1) {
      fakes.emplace_back(badsum);
      return;
    }

    ll bad = weight(m) - ask(m) - prefbad;
    if (k == 2) {
      solve_range_k(l, m, prefbad, bad, 1);
      solve_range_k(m, r, prefbad + bad, badsum - bad, 1);
      return;
    }

    assert(0 < bad && bad < prefbad);

    ll kl = solve_range_k_range(l, m + 1, prefbad, bad, 1, k - 1);
    solve_range_k(m + 1, r, prefbad + bad, badsum - bad, k - kl);
  }

  ll solve_range_k_range(ll l, ll r, ll prefbad, ll badsum, ll kl, ll kr) {
    ll ret = 0;
    ll L = l, R = r;
    ll bad = 0;

    while (bad != badsum) {
      while (R - L > 1) {
        ll M = (L + R) / 2;
        (ask(M) - prefbad - bad == 0 ? L : R) = M;
      }

      fakes.emplace_back(R);
      ret += 1;
      bad += R;
      L = R;
      R = r;
    }

    return ret;
  }

  void solve() {
    cin >> n >> K;
    solve_range_k(0, n, 0, weight(n) - ask(n), K);

    answer(fakes);
  }

  ll n, K;
  vi fakes;
};

void solve() {
  auto s = solver();
  s.solve();
}