#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

ll sum(ll n) {
    return n * (n + 1) / 2;
}

ll segsum(ll a, ll b) {
    return sum(b) - sum(a);
}

vi ans;
unordered_map<int, ll> sums;

ll ask_sum(int n) {
    if (sums.find(n) == sums.end()) {
        cout << "? " << n << endl;
        ll s;
        cin >> s;
        if (s == -1)
            exit(0);
        sums[n] = s;
    }
    return sums[n];
}

void solve3(int l, int r);

void solve(int n, int k, int p = 0) {
    if (k == 1)
        ans.push_back(segsum(p, n) - ask_sum(n) + ask_sum(p));
    else if (k == 2) {
        ll x = segsum(p, n) - ask_sum(n) + ask_sum(p), y = segsum(p, x / 2) - ask_sum(x / 2) + ask_sum(p);
        ans.push_back(y);
        ans.push_back(x - y);
    }
    else if (k == 3)
        solve3(p + 1, n);
    else if (k * 30 > n / 2) {
        for (int i = p + 2; i <= n; i += 2) {
            ll x = ask_sum(i) - ask_sum(i - 2);
            if (x == i)
                ans.emplace_back(i - 1);
            else if (x == i - 1)
                ans.emplace_back(i);
            else if (x == 0) {
                ans.emplace_back(i - 1);
                ans.emplace_back(i);
            }
        }
        if ((n - p) % 2 == 1) {
            ll x = ask_sum(n) - ask_sum(n - 1);
            if (x == 0)
                ans.emplace_back(n);
        }
    }
    else {
        int l = p, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (ask_sum(m) < ask_sum(p) + segsum(p, m))
                r = m;
            else
                l = m;
        }
        ans.push_back(r);
        solve(n, k - 1, r);
    }
}

void solve3(int l, int r) {
    int m = (l + r) / 2;
    ll x1 = ask_sum(m) - ask_sum(l - 1), x2 = ask_sum(r) - ask_sum(m),
       y1 = segsum(l - 1, m), y2 = segsum(m, r);
    if (y1 - x1 == 0)
        solve3(m + 1, r);
    else if (y2 - x2 == 0)
        solve3(l, m);
    else if (y2 - x2 <= r) {
        solve(m, 2, l - 1);
        solve(r, 1, m);
    }
    else {
        solve(m, 1, l - 1);
        solve(r, 2, m);
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        sums[0] = 0;
        solve(n, k);
        cout << "! ";
        for (int x: ans)
            cout << x << ' ';
        cout << endl;
        int ch;
        cin >> ch;
        if (ch == -1)
            exit(0);
        ans.clear();
        sums.clear();
    }
}
