#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>
#include <iomanip>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

void solve() {
  int n, k;
  cin >> n >> k;

  auto query = [&] (int p) {
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return x;
  };

  int cnt = 0;
  vector<int> pos;
  int prv = 0;
  for (int i = 2; i <= n; i += 2) {
    int sum = query(i);
    if (prv + 2 * i - 1 != sum) {
      if (prv == sum) {
        pos.push_back(i - 1);
        pos.push_back(i);
      } else if (prv + i - 1 == sum) {
        pos.push_back(i);
      } else {
        pos.push_back(i - 1);
      }
    }
    prv = sum;
  }
  if (sz(pos) != k) {
    pos.push_back(n);
  }

  cout << "! ";
  for (auto &x : pos) cout << x << ' ';
  cout << endl;

  int kok;
  cin >> kok;
}

int32_t main() {
//#ifdef LOCAL
//  freopen("input.txt", "r", stdin);
//#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}