#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>
#include <iomanip>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

int get_sum(int l, int r) {
  return l * (r - l + 1) + (r - l + 1) * (r - l) / 2;
}

void solve() {
  int n, k;
  cin >> n >> k;

#ifdef LOCAL
  vector<int> a(n + 1);
  iota(all(a), 0);
  for (int i = 0; i < k; i++) {
    int x;
    cin >> x;
    a[x] = 0;
  }
  vector<int> pref(n + 1);
  for (int i = 1; i <= n; i++) {
    pref[i] = pref[i - 1] + a[i];
  }
#endif

  map<int, int> mp;
  auto query = [&] (int p) {
#ifdef LOCAL
    return pref[p];
#endif
    if (mp.find(p) != mp.end()) {
      return mp[p];
    }
    cout << "? " << p << endl;
    int x;
    cin >> x;
    mp[p] = x;
    return x;
  };

  auto calc_proeb = [&] (int r) {
    if (r == 0) {
      return 0ll;
    }
    return get_sum(1, r) - query(r);
  };

  vector<int> pos;
  if (k == 3) {
    int global_proeb = calc_proeb(n);
    debug(global_proeb);
    int l = 1, r = n, p = -1;
    while (l <= r) {
      int m = (l + r) / 2;
      int proeb = calc_proeb(m);
      if (proeb == 0) {
        l = m + 1;
      } else if (proeb == global_proeb) {
        r = m - 1;
      } else {
        p = m;
        break;
      }
    }
    int proeb = calc_proeb(p);
    debug(p, global_proeb, proeb);
    if (calc_proeb(proeb - 1) == 0) { // 1 left, 2 right
      pos.push_back(proeb);
      l = p + 1;
      while (l < r) {
        int m = (l + r) / 2;
        if (calc_proeb(m) != proeb) {
          r = m;
        } else {
          l = m + 1;
        }
      }
      pos.push_back(l);
      pos.push_back(global_proeb - l - proeb);
    } else { // 2 left, 1 right
      pos.push_back(global_proeb - proeb);
      r = p - 1;
      while (l < r) {
        int m = (l + r) / 2;
        if (calc_proeb(m) != 0) {
          r = m;
        } else {
          l = m + 1;
        }
      }
      pos.push_back(l);
      pos.push_back(proeb - l);
    }
  } else if (n <= 1000) {
    int prv = 0;
    for (int i = 2; i <= n; i += 2) {
      int sum = query(i);
      if (prv + 2 * i - 1 != sum) {
        if (prv == sum) {
          pos.push_back(i - 1);
          pos.push_back(i);
        } else if (prv + i - 1 == sum) {
          pos.push_back(i);
        } else {
          pos.push_back(i - 1);
        }
      }
      prv = sum;
    }
    if (sz(pos) != k) {
      pos.push_back(n);
    }
  } else {
    int cur_sum = 0;
    int lst = 0;
    for (int w = 0; w < k; w++) {
      int l = lst + 1, r = n;
      while (l < r) {
        int m = (l + r) / 2;
        int x = query(m);
        if (cur_sum + get_sum(lst + 1, m) != x) {
          r = m;
        } else {
          l = m + 1;
        }
      }
      pos.push_back(l);
      cur_sum = query(l);
      lst = l;
    }
  }

  cout << "! ";
  for (auto &x : pos) cout << x << ' ';
  cout << endl;

  int kok;
  cin >> kok;
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}