#pragma GCC optimize("O3, unroll-loops")
#pragma GCC target("avx,avx2,sse,bmi")

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int T = 750'000 + 3, S = 1e6 + 4;
constexpr int B = 1300;

namespace Trie {
    int go[26][S], top = 2;
    bool term[S];

    void add(string &s) {
        int v = 1;

        for (char cc : s) {
            int c = cc - 'a';

            if (!go[c][v]) {
                go[c][v] = top++;
            }

            v = go[c][v];
        }

        term[v] = true;
    }
}

namespace fn {
    ll fn[T];

    void add(int x) {
        for (++x; x < T; x += x & -x) {
            ++fn[x];
        }
    }

    ll sum(int x) {
        ll ans = 0;

        for (++x; x > 0; x -= x & -x) {
            ans += fn[x];
        }

        return ans;
    }

    ll sum(int l, int r) {
        return sum(r - 1) - sum(l - 1);
    }
}

constexpr int P = 341, MOD = 1000696969;

int powers[T], prefHash[T];

int getHash(string& s) {
    int ans = 0;

    for (char c : s) {
        ans = (1LL * ans * P + (c - 'a')) % MOD;
    }

    return ans;
}

void calcPrefHash(string& t) {
    for (int i = 1; i <= t.size(); ++i) {
        int c = t[i - 1] - 'a';

        prefHash[i] = (1LL * prefHash[i - 1] * P + c) % MOD;
    }
}

inline int rangeHash(int l, int r) {
    int res = (prefHash[r] - 1LL * prefHash[l] * powers[r - l]) % MOD;
    return res < 0 ? res + MOD : res;
}

vector<pair<int, int>> queries[T];
int cntt[S];

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    powers[0] = 1;

    for (int i = 1; i <= t.size(); ++i) powers[i] = 1LL * powers[i - 1] * P % MOD;

    vector<pair<int, int>> heavy;


    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;

        if (s.size() < B) {
            reverse(s.begin(), s.end());

            Trie::add(s);
        } else {
            heavy.emplace_back(s.size(), getHash(s));
        }
    }

    sort(heavy.begin(), heavy.end());

    calcPrefHash(t);

    vector<ll> ans(m);

    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;

        queries[r - 1].emplace_back(l - 1, i);
    }

    for (int i = 0; i < t.size(); ++i) {
        int v = 1, len = 0;

        while (v != 0) {
            if (Trie::term[v]) {
                fn::add(i - len + 1);
            }

            if (i < len) {
                break;
            }

            v = Trie::go[t[i - len] - 'a'][v];
            len += 1;
        }

        int last = 0;

        for (auto [x, y] : heavy) {
            if (x > i + 1) {
                break;
            }

            if (x == last) {
                continue;
            }

            if (rangeHash(i - x + 1, i + 1) == y) {
                fn::add(i - x + 1);
                last = x;
            }
        }

        for (auto [l, j] : queries[i]) {
            ans[j] = fn::sum(i) - fn::sum(l - 1);
        }
    }

    for (auto x : ans) {
        cout << x << ' ';
    }

    cout << '\n';

    return 0;
}