#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll P = 53, M = 1000000007;

inline ll hash_char(char c) {
    return c - 'a' + 1;
}

void hash_str(const string &s, vector<ll> &h) {
    ll n = ll(s.size());
    for (ll i = 0; i < n; i++) h[i + 1] = (h[i] * P % M + hash_char(s[i])) % M;
}

ll hash_str(const string &s) {
    vector<ll> h(s.size() + 1);
    hash_str(s, h);
    return h.back();
}

const ll N = 500000;

ll F[N + 1];

ll hash_substr(const vector<ll> &h, ll l, ll r) {
    return (M + h[r] - h[l] * F[r - l] % M) % M;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    F[0] = 1;
    for (ll i = 1; i <= N; i++) F[i] = F[i - 1] * P % M;
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<ll> h(t.size() + 1);
    hash_str(t, h);
    vector<string> a(n);
    for (auto &s: a) cin >> s;
    unordered_set<ll> d;
    for (auto &s: a) d.insert(hash_str(s));
    while (m--) {
        ll l0, r0;
        cin >> l0 >> r0;
        l0--;
        ll ans = 0;
        for (ll l = l0; l < r0; l++) {
            for (ll r = l + 1; r <= r0; r++) {
                ll x = hash_substr(h, l, r);
                if (d.find(x) != d.end()) ans++;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';
}