#include <bits/stdc++.h>

#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define rz resize

using namespace std;

mt19937 rnd(time(0));

struct Hash{
    int p, mod;

    Hash (int P, int MOD)
    {
        p = P;
        mod = MOD;
    }

    int add(int a, int b)
    {
        if(a + b >= mod)
            return a + b - mod;
        return a + b;
    }

    int sub(int a, int b)
    {
        if(a - b < 0)
            return a - b + mod;
        return a - b;
    }

    int mul(int a, int b)
    {
        return ((long long)a * b) % mod;
    }

    vec<int> h, dg;

    void calc_hash(string &s)
    {
        h.clear();
        dg.clear();
        int n = sz(s);
        h.rz(n);
        dg.rz(n);
        h[0] = s[0];
        dg[0] = 1;

        for(int i = 1; i < n; i++)
        {
            dg[i] = mul(dg[i - 1], p);
            h[i] = add(mul(h[i - 1], p), s[i]);
        }
    }

    int get(int l, int r)
    {
        if(l)
            return sub(h[r], mul(h[l - 1], dg[r - l + 1]));
        return h[r];
    }
};

void solve()
{
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vec<string> a (n);
    for(auto &i : a)
        cin >> i;
    set<int> hashes;
    Hash H (37, 1e9 + 123);

    FOR(i, n)
    {
        H.calc_hash(a[i]);
        hashes.insert(H.get(0, sz(a[i]) - 1));
    }
    H.calc_hash(s);
    vec<vec<int>> ans (sz(s), vec<int> (sz(s)));
    for(int l = 0; l < sz(s); l++)
    {
        int cur = 0;
        for(int r = l; r < sz(s); r++)
        {
            int h = H.get(l, r);
            if(hashes.find(h) != hashes.end())
            {
                cur++;
            }
            ans[l][r] = cur;
        }
    }

    FOR(i, m)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int res = 0;

        for(int curl = l; curl <= r; curl++)
        {
            if(l)
                res += ans[curl][r] - ans[curl][l - 1];
            else
                res += ans[curl][r];
        }

        cout << res << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}


