#include <bits/stdc++.h>

#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define rz resize

using namespace std;

mt19937 rnd(time(0));

struct Hash{
    int p, mod;

    Hash (int P, int MOD)
    {
        p = P;
        mod = MOD;
    }

    int add(int a, int b)
    {
        if(a + b >= mod)
            return a + b - mod;
        return a + b;
    }

    int sub(int a, int b)
    {
        if(a - b < 0)
            return a - b + mod;
        return a - b;
    }

    int mul(int a, int b)
    {
        return ((long long)a * b) % mod;
    }

    vec<int> h, dg;

    void calc_hash(string &s)
    {
        h.clear();
        dg.clear();
        int n = sz(s);
        h.rz(n);
        dg.rz(n);
        h[0] = s[0];
        dg[0] = 1;

        for(int i = 1; i < n; i++)
        {
            dg[i] = mul(dg[i - 1], p);
            h[i] = add(mul(h[i - 1], p), s[i]);
        }
    }

    int get(int l, int r)
    {
        if(l)
            return sub(h[r], mul(h[l - 1], dg[r - l + 1]));
        return h[r];
    }
};

void solve()
{
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vec<string> a (n);
    for(auto &i : a)
        cin >> i;
    set<pii> hashes;
    Hash H1 (37, 1e9 + 123);
    Hash H2 (59, 1e9 + 7);

    FOR(i, n)
    {
        H1.calc_hash(a[i]);
        H2.calc_hash(a[i]);
        hashes.insert({H1.get(0, sz(a[i]) - 1), H2.get(0, sz(a[i]) - 1)});
    }
    H1.calc_hash(s);
    H2.calc_hash(s);
    int N = sz(s);
    vec<vec<int>> pref (N + 1, vec<int> (N + 1));
    vec<vec<int>> ok (N + 1, vec<int> (N + 1));


    for(int l = 0; l < N; l++)
    {
        for(int r = l; r < N; r++)
        {
            int h1 = H1.get(l, r);
            int h2 = H2.get(l, r);
            if(hashes.find({h1, h2}) != hashes.end())
            {
                ok[l + 1][r + 1] = 1;
            }
        }
    }

    for(int i = 1; i <= N; i++)
    {
        for(int j = 1; j <= N; j++)
        {
            pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + ok[i][j];
        }
    }

    auto get = [&](int l1, int r1, int l2, int r2)
    {
        int p1 = pref[l1 - 1][r1 - 1];
        int p2 = pref[l2][r1 - 1];
        int p3 = pref[l1 - 1][r2];
        int p4 = pref[l2][r2];
        return p4 - p2 - p3 + p1;
    };

    FOR(i, m)
    {
        int l, r;
        cin >> l >> r;
        int res = get(l, l, r, r);
        cout << res << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}


