#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
mt19937 rnd(time(NULL));
const int inf = 1e18, MAXN = 2e6+10, mod = 998244353, mod1 = (int)1e9+7, mod2 = 1e9+1011, K = 330;
const long double eps = 1e-9;

struct Node {
    int pr, suf, lst, IsTerm, cnt;
    vector<int> nx;

    Node() {
        pr = suf = lst = -1;
        IsTerm = cnt = 0;
        nx.resize(26, -1);
    }
};
vector<Node> p(MAXN);
int sz = 1;

void add_string(string &s) {
    int v = 0;
    for (auto c : s) {
        if (p[v].nx[c-'a'] == -1) {
            p[sz].pr = v;
            p[sz].lst = c-'a';
            p[v].nx[c-'a'] = sz++;
        }
        v = p[v].nx[c-'a'];
    }
    p[v].IsTerm = 1;
}

struct req {
    int l, r, ind;

    req() = default;

    req(int a, int b, int c) : l(a), r(b), ind(c) {}
};

bool cmp(req &a, req &b) {
    if (a.l == b.l) return a.r < b.r;
    return a.l < b.l;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m; cin >> n >> m;
    string t; cin >> t;
    for (int i = 0; i<n; ++i) {
        string s; cin >> s;
        add_string(s);
    }
    deque<int> d;
    p[0].suf = 0;
    for (int i = 0; i<26; ++i) {
        if (p[0].nx[i] == -1) p[0].nx[i] = 0;
        else {
            p[p[0].nx[i]].suf = 0;
            d.emplace_back(p[0].nx[i]);
        }
    }
    while (!d.empty()) {
        auto u = d.front();
        d.pop_front();
        p[u].cnt = p[p[u].suf].cnt + p[u].IsTerm;
        for (int i = 0; i<26; ++i) {
            if (p[u].nx[i] == -1) {
                p[u].nx[i] = p[p[u].suf].nx[i];
            } else {
                p[p[u].nx[i]].suf = p[p[u].suf].nx[i];
                d.emplace_back(p[u].nx[i]);
            }
        }
    }
    vector<req> reqs(m);
    vector<int> res(m);
    for (int i = 0; i<m; ++i) {
        int l, r; cin >> l >> r; l--; r--;
        reqs[i] = {l, r, i};
    }
    sort(all(reqs), cmp);
    int lst = -1, v = 0, cur = 0;
    if (n > 100) assert(0);
    for (auto [l, r, ind] : reqs) {
        if (l != lst) {
            v = 0; cur = l-1;
        }
        while (cur < r) {
            cur++;
            v = p[v].nx[t[cur]-'a'];
            res[ind] += p[v].cnt;
        }
    }
    for (int i = 0; i<m; ++i) cout << res[i] << " ";
    cout << '\n';
    return 0;
}
