#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

using namespace std;


int MOD1 = 1e9 + 7;
int MOD2 = 998244353;

int add1(int a, int b)
{
    return (a + b) % MOD1;
}

int mul1(int a, int b)
{
    return (a * 1ll * b) % MOD1;
}

int sub1(int a, int b)
{
    return (a - b + MOD1) % MOD1;
}

int add2(int a, int b)
{
    return (a + b) % MOD2;
}

int mul2(int a, int b)
{
    return (a * 1ll * b) % MOD2;
}

int p1 = 29;
int p2 = 31;

const int MAXN = 5e6;

int pw1[MAXN];
int pw2[MAXN];

int h1[MAXN];
int h2[MAXN];

void hashing(string& s)
{
    int hs1 = 0;
    int hs2 = 0;
    for (int i = 0; i < s.size(); i++)
    {
        char c = s[i];
        hs1 = mul1(hs1, p1);
        hs2 = mul2(hs2, p2);

        hs1 = add1(hs1, c - 'a' + 1);
        hs2 = add2(hs2, c - 'a' + 1);

        h1[i] = hs1;
        h2[i] = hs2;
    }
}

pair<int, int> get_hash(string& s)
{
    int hs1 = 0;
    int hs2 = 0;
    for (int i = 0; i < s.size(); i++)
    {
        char c = s[i];
        hs1 = mul1(hs1, p1);
        hs2 = mul2(hs2, p2);

        hs1 = add1(hs1, c - 'a' + 1);
        hs2 = add2(hs2, c - 'a' + 1);
    }
    return {hs1, hs2};
}
//
//pair<int, int> get_sub

int get_sub_hash(int l, int r)
{
    if (l == 0)
        return h1[r];
    return sub1(h1[r], mul1(h1[l - 1], pw1[r - l + 1]));
}

vector<string> strs;

vector<int> lens;

vector<vector<int> > pos;
vector<vector<int> > pos_ind;
vector<vector<int> > ind;
vector<long long> ans;

struct ev
{
    int x, type, ind;
    ev() {}
    ev(int x, int type, int ind): x(x), type(type), ind(ind) {}
    bool operator<(const ev& o)
    {
        if (x != o.x)
            return x < o.x;
        return type < o.type;
    }
};

vector<vector<ev> > evs;

int get_id(int x)
{
    return lower_bound(lens.begin(), lens.end(), x) - lens.begin();
}

int main()
{
    pw1[0] = 1;
    pw2[0] = 1;
    for (int i = 1; i < MAXN; i++)
    {
        pw1[i] = mul1(pw1[i - 1], p1);
        pw2[i] = mul2(pw2[i - 1], p2);
    }
    int n, q;
    cin >> n >> q;
    ans.resize(q);
    string t;
    cin >> t;
    hashing(t);
    strs.resize(n);
    for (int i = 0; i < n; i++)
    {
        cin >> strs[i];
        lens.push_back(strs[i].size());
    }
    sort(lens.begin(), lens.end());
    lens.erase(unique(lens.begin(), lens.end()), lens.end());
    pos.resize(lens.size());
    pos_ind.resize(lens.size());
    evs.resize(lens.size());
    ind.resize(lens.size());
    for (int i = 0; i < n; i++)
    {
        pos[get_id(strs[i].size())].push_back(i);
    }
    for (int _ = 0; _ < lens.size(); _++)
    {
        int i = lens[_];
        if (i > t.size()) break;
        set<int> st;
        for (int j = 0; j < pos[_].size(); j++)
        {
            st.insert(get_hash(strs[pos[_][j]]).first);
        }
        for (int j = 0; j < (int)t.size() - i + 1; j++)
        {
            int cur = get_sub_hash(j, j + i - 1);
            if (st.count(cur))
            {
                pos_ind[_].push_back(j);
                evs[_].push_back({j, 1, -1});
            }
        }
    }
//    for (int _ = 0; _ < lens.size(); _++)
//    {
//        int i = lens[_];
//        cout << i << ": ";
//        for (auto& x : pos_ind[_]) cout << x << ' ';
//        cout << endl;
//    }
    vector<int> last(q);
    for (int j = 0; j < q; j++)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        long long ans = 0;
        for (int _ = 0; _ < lens.size(); _++)
        {
            int i = lens[_];
            if (i > r - l + 1) break;
            evs[_].push_back({l, 0, j});
            evs[_].push_back({r - i + 1, 2, j});
            //int cnt = upper_bound(pos_ind[_].begin(), pos_ind[_].end(), r - i + 1) - lower_bound(pos_ind[_].begin(), pos_ind[_].end(), l);
            //ans += max(0, cnt);
        }
       // cout << ans << '\n';
    }
    for (int _ = 0; _ < lens.size(); _++)
    {
        if (lens[_] > t.size()) break;
        sort(evs[_].begin(), evs[_].end());
        fill(last.begin(), last.end(), 0);
        int cnt = 0;
        for (auto&[x, type, ind] : evs[_])
        {
            if (type == 1)
            {
                cnt++;
            }
            else
            {
                if (type == 0)
                {
                    last[ind] = cnt;
                }
                else
                {
                    ans[ind] += cnt - last[ind];
                }
            }
        }
    }
    for (int i = 0; i < q; i++)
    {
        cout << ans[i] << '\n';
    }
    return 0;
}
