#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define pii pair<int,int>
#define F first
#define S second
typedef long double ld;
//#define int int64_t

typedef tree <pii, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> oset;

mt19937 gen(chrono::system_clock().now().time_since_epoch().count());

const int N = 5e5+100, M = 5e5+100, Ts = 250000+100, S = 1e6+100, K = 10000, inf = 1e9+100;

int64_t ans[M];
string t;
string s[N];
unordered_map <int, int> vec[Ts];
int n, m;
vector <pii> q[Ts];

struct Trie {
    int b[S][26];
    int num[S];
    int n = 1;

    Trie() {}

    void add (string& s) {
        int v = 1;
        for (int i=0;i<s.size();++i) {
            if (b[v][s[i]-'a'] == 0) {
                n++;
                b[v][s[i]-'a'] = n;
            }
            v = b[v][s[i]-'a'];
        }
        num[v]++;
    }
};
int p[Ts+S];

void KMP (string& s) {
    int k = s.size();
    s = s + "#" + t;
//    cout << s << '\n';
    int n = s.size();
    p[0] = 0;
    for (int i=1;i<n;++i) {
        int j = p[i-1];
        while (j > 0 && s[j] != s[i]) {
            j = p[j-1];
        }
        if (s[j] == s[i]) {
            j++;
        }
        p[i] = j;
    }
//    for (int i=0;i<n;++i) {
//        cout << p[i] << ' ';
//    }
//    cout << '\n';
    for (int i=k;i<n;++i) {
        if (p[i] == k) {
            vec[i-k-1-k+1][i-k-1] += 1;
        }
    }
    s = "";
}

int64_t f[Ts];

void add (int p, int x){
    while (p < Ts) {
        f[p] += x;
        p |= (p+1);
    }
}

int64_t get (int p) {
    int64_t ans = 0;
    while (p >= 0) {
        ans += f[p];
        p = ((p+1)&p)-1;
    }
    return ans;
}

Trie T;

int32_t main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> n >> m;
    cin >> t;
    int sum = 0;
    for (int i=0;i<n;++i) {
        cin >> s[i];
        sum += s[i].size();
    }
    for (int i=0;i<n;++i) {
        if (s[i].size() > sqrt(sum)) {
            KMP(s[i]);
        }
        else {
            T.add(s[i]);
            s[i] = "";
        }
    }
    for (int i=0;i<t.size();++i) {
        int v = 1;
        for (int j=i;j<t.size();++j) {
            v = T.b[v][t[j]-'a'];
            if (v == 0) break;
            if (T.num[v] > 0) vec[i][j] += T.num[v];
        }
    }
//    for (int i=0;i<t.size();++i) {
//        for (auto j:vec[i]) {
//            cout << i << ' ' << j.F << ' ' << j.S << '\n';
//        }
//    }
    for (int i=0;i<m;++i) {
        int l, r;
        cin >> l >> r;
        l--;r--;
        q[l].push_back({r, i});
    }
    for (int i=int64_t(t.size())-1;i>=0;--i) {
        for (auto j:vec[i]) {
            add(j.F, j.S);
        }
        for (auto j:q[i]) {
            ans[j.S] = get(j.F);
        }
    }
    for (int i=0;i<m;++i) {
        cout << ans[i] << ' ';
    }
    return 0;
}
