#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

const int MAXT = 1e4, SZ_CNT = 1500;

int n;

struct node {
    node *to[26];
    int c;
    bool terminal;
    node *par = NULL;
    bool counted;
    int cnt;
    node *suf = NULL;
    node *go[26];
};

using pnode = node*;

pnode root[SZ_CNT];

void add(string s, int k) {
    if (!root[k]) {
        root[k] = new node();
    }
    pnode cur = root[k];
    for (auto c : s) {
        int x = c - 'a';
        if (cur->to[x]) {
            cur = cur->to[x];
        } else {
            cur->to[x] = new node();
            cur->to[x]->par = cur;
            cur = cur->to[x];
            cur->c = x;
        }
    }
    cur->terminal = true;
}

pnode go(pnode p, int c);

pnode suf(pnode p) {
    if (p->suf) {
        return p->suf;
    }
    if (!p->par) {
        p->suf = p;
        return p->suf;
    }
    if (!(p->par->par)) {
        p->suf = p->par;
        return p->suf;
    }
    p->suf = go(suf(p->par), p->c);
    return p->suf;
}

pnode go(pnode p, int c) {
    if (p->go[c]) {
        return p->go[c];
    }
    if (p->to[c]) {
        p->go[c] = p->to[c];
        return p->go[c];
    }
    if (!p->par) {
        p->go[c] = p;
        return p->go[c];
    }
    p->go[c] = go(suf(p), c);
    return p->go[c];
}

pnode state[SZ_CNT];

int count_term(pnode p) {
    if (p->counted) {
        return p->cnt;
    }
    p->counted = true;
    if (p->terminal) p->cnt = 1;
    p->cnt += count_term(suf(p));
    return p->cnt;
}

long long cnt[MAXT][SZ_CNT];

void solve() {
    cin >> n;
    int m;
    cin >> m;
    string t;
    cin >> t;
    vector<int> sizes;
    vector<string> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> v[i];
        sizes.push_back(v[i].size());
    }
    sort(sizes.begin(), sizes.end());
    sizes.resize(unique(sizes.begin(), sizes.end()) - sizes.begin());
    int sz_cnt = sizes.size();
    unordered_map<int, int> to;
    for (int i = 0; i < sz_cnt; ++i) {
        to[sizes[i]] = i;
    }
    for (int i = 0; i < n; ++i) {
        add(v[i], to[v[i].size()]);
    }
    for (int i = 0; i < sz_cnt; ++i) {
        state[i] = root[i];
    }
    int tn = t.size();
    for (int i = 0; i < tn; ++i) {
        int x = t[i] - 'a';
        for (int sz = 0; sz < sz_cnt; ++sz) {
            state[sz] = go(state[sz], x);
            cnt[i][sz] = count_term(state[sz]);
            if (i != 0) {
                cnt[i][sz] += cnt[i - 1][sz];
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;
        long long ans = 0;
        for (int j = 0; j < sz_cnt; ++j) {
            int sz = sizes[j];
            int rs = r;
            int ls = l + sz - 1;
            if (ls > rs) {
                break;
            }
            long long r_val = cnt[rs][j];
            long long l_val;
            if (ls != 0) {
                l_val = cnt[ls - 1][j];
            } else {
                l_val = 0;
            }
            ans += r_val - l_val;
        }
        cout << ans << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    solve();
}