#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 2e9 + 7;
const ld eps = 1e-9;

const vector<ll> mods = { (ll)1e9 + 7, (ll)1e9 + 9, 1791791791 };
const ll sz = 2;
const vector<ll> p = { 57, 179, 239 };

struct hash1 {
	vector<vector<ll>> has;
	vector<vector<ll>> pows;
	hash1(string& s) {
		ll n = s.size();
		pows.resize(n + 1, vector<ll>(sz, 1));
		has.resize(n + 1, vector<ll>(sz));
		for (ll x = 0; x < n; x++) {
			for (ll i = 0; i < sz; i++) {
				has[x + 1][i] = (has[x][i] * p[i] + (s[x] - 'a' + 1)) % mods[i];
				pows[x + 1][i] = pows[x][i] * p[i] % mods[i];
			}
		}
	}
	vector<ll> fast(string& s) {
		vector<ll> ans(sz);
		for (ll x = 0; x < s.size(); x++) {
			for (ll i = 0; i < sz; i++) {
				ans[i] = (ans[i] * p[i] + (s[x] - 'a' + 1)) % mods[i];
			}
		}
		return ans;
	}
	vector<ll> get(ll l, ll r) {
		vector<ll> ans(sz);
		for (ll x = 0; x < sz; x++) {
			ans[x] = ((has[r][x] - has[l][x] * pows[r - l][x]) % mods[x] + mods[x]) % mods[x];
		}
		return ans;
	}
};

signed main() {
	ll n, m; cin >> n >> m;
	vector<ll> sizes(n);
	vector<ll> right;
	vector<ll> left;
	string t; cin >> t;
	hash1 h(t);
	for (ll x = 0; x < n; x++) {
		string s; cin >> s;
		sizes[x] = s.size();
		vector<ll> fast = h.fast(s);
		for (ll i = 0; i + (ll)s.size() <= t.size(); i++) {
			ll l = i;
			ll r = i + s.size();
			if (h.get(l, r) == fast) {
				left.push_back(l);
				right.push_back(r);
			}
		}
	}
	sort(left.begin(), left.end());
	sort(right.begin(), right.end());
	for (ll x = 0; x < m; x++) {
		ll l, r; cin >> l >> r;
		l--;
		int cnt1 = lower_bound(left.begin(), left.end(), l) - left.begin();
		int cnt2 = upper_bound(right.begin(), right.end(), r) - right.begin();
		cout << max(0, cnt2 - cnt1) << endl;
	}
}