#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 2e9 + 7;
const ld eps = 1e-9;

const vector<ll> mods = { (ll)1e9 + 7, (ll)1e9 + 9, 1791791791 };
const ll sz = 2;
const vector<ll> p = { 57, 179, 239 };

struct seg {
	vector<vector<ll>> ml;
	ll sz = 1;
	void dub(ll n) {
		while (sz < n) sz *= 2;
	}
	seg(vector<ll>& a) {
		dub(a.size());
		ml.resize(2 * sz);
		build(1, 0, sz, a);
	}
	void build(ll id, ll l, ll r, vector<ll>& a) {
		if (r - l == 1 && l < a.size()) {
			ml[id].push_back(a[l]);
			return;
		}
		if (r - l == 1) {
			ml[id].push_back(INF);
			return;
		}
		ll m = (r + l) / 2;
		build(2 * id, l, m, a);
		build(2 * id + 1, m, r, a);
		for (auto& it : ml[2 * id]) {
			ml[id].push_back(it);
		}
		for (auto& it : ml[2 * id + 1]) {
			ml[id].push_back(it);
		}
		sort(ml[id].begin(), ml[id].end());
	}
	ll get(ll id, ll l, ll r, ll l_q, ll r_q, ll val) {
		if (l_q <= l && r <= r_q) {
			return upper_bound(ml[id].begin(), ml[id].end(), val) - ml[id].begin();
		}
		if (l_q >= r || r_q <= l) return 0;
		ll m = (r + l) / 2;
		ll s1 = get(2 * id, l, m, l_q, r_q, val);
		ll s2 = get(2 * id + 1, m, r, l_q, r_q, val);
		return s1 + s2;
	}
};

struct hash1 {
	vector<vector<ll>> has;
	vector<vector<ll>> pows;
	hash1(string& s) {
		ll n = s.size();
		pows.resize(n + 1, vector<ll>(sz, 1));
		has.resize(n + 1, vector<ll>(sz));
		for (ll x = 0; x < n; x++) {
			for (ll i = 0; i < sz; i++) {
				has[x + 1][i] = (has[x][i] * p[i] + (s[x] - 'a' + 1)) % mods[i];
				pows[x + 1][i] = pows[x][i] * p[i] % mods[i];
			}
		}
	}
	vector<ll> fast(string& s) {
		vector<ll> ans(sz);
		for (ll x = 0; x < s.size(); x++) {
			for (ll i = 0; i < sz; i++) {
				ans[i] = (ans[i] * p[i] + (s[x] - 'a' + 1)) % mods[i];
			}
		}
		return ans;
	}
	vector<ll> get(ll l, ll r) {
		vector<ll> ans(sz);
		for (ll x = 0; x < sz; x++) {
			ans[x] = ((has[r][x] - has[l][x] * pows[r - l][x]) % mods[x] + mods[x]) % mods[x];
		}
		return ans;
	}
};

signed main() {
	ll n, m; cin >> n >> m;
	vector<ll> sizes(n);
	vector<pair<ll, ll>> lr;
	vector<ll> left;
	vector<ll> right;
	string t; cin >> t;
	hash1 h(t);
	for (ll x = 0; x < n; x++) {
		string s; cin >> s;
		sizes[x] = s.size();
		vector<ll> fast = h.fast(s);
		for (ll i = 0; i + (ll)s.size() <= t.size(); i++) {
			ll l = i;
			ll r = i + s.size();
			if (h.get(l, r) == fast) {
				lr.push_back({ l, r });
			}
		}
	}
	sort(lr.begin(), lr.end());
	for (ll x = 0; x < lr.size(); x++) {
		left.push_back(lr[x].first);
		right.push_back(lr[x].second);
	}
	seg st(right);
	for (ll x = 0; x < m; x++) {
		ll l, r; cin >> l >> r;
		l--;
		int id = lower_bound(left.begin(), left.end(), l) - left.begin();
		cout << st.get(1, 0, st.sz, id, st.sz, r) << endl;
	}
}