#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;
#define ll long long
const int MAXN = 1e6 + 10;

struct node {
    int nxt[26];
    int suf = -1;
    int pr = -1;
    int pr_sym = -1;
    int len = 0;
    int term = 0;
    int cnt = 0;
    int ssuf = 0;

    node() {
        for (int i = 0; i < 26; ++i) nxt[i] = -1;
    }
};

node all[MAXN];
int cur = 0;

inline int add_node() {
    return cur++;
}

inline void add_string(const string& s) {
    int root = 0;
    for (char c : s) {
        int sym = c - 'a';
        if (all[root].nxt[sym] == -1) {
            int v = add_node();
            all[root].nxt[sym] = v;
            all[v].pr = root;
            all[v].pr_sym = sym;
            all[v].len = all[root].len + 1;
        }
        root = all[root].nxt[sym];
    }
    all[root].term = 1;
}

void build() {
    queue <int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        if (v == 0) {}
        else if (all[v].pr == 0) {
            all[v].suf = 0;
            all[v].cnt = all[all[v].suf].cnt + all[v].term;
        }
        else {
            all[v].suf = all[all[all[v].pr].suf].nxt[all[v].pr_sym];
            all[v].cnt = all[all[v].suf].cnt + all[v].term;
            if (all[all[v].suf].term) all[v].ssuf = all[v].suf;
            else all[v].ssuf = all[all[v].suf].ssuf;
        }
        for (int i = 0; i < 26; ++i) {
            if (all[v].nxt[i] != -1) {
                q.push(all[v].nxt[i]);
                continue;
            }
            if (v == 0) all[v].nxt[i] = 0;
            else all[v].nxt[i] = all[all[v].suf].nxt[i];
        }
    }
}

inline void stupid_solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <string> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    while (m--) {
        int l, r;
        cin >> l >> r; --l; --r;
        int ans = 0;
        for (int i = l; i <= r; ++i) {
            for (int j = 0; j < n; ++j) {
                if (i + (int)a[j].size() - 1 <= r && s.substr(i, a[j].size()) == a[j]) ans++;
            }
        }
        cout << ans << " ";
    }
}

struct Fenwick {
    int n;
    vector <int> f;

    Fenwick(int n) : n(n) {
        f.resize(n + 1);
    }

    inline void add(int i, int x) {
        for (++i; i <= n; i += (i & (-i))) f[i] += x;
    }

    inline int get_pref(int i) {
        int ans = 0;
        for (++i; i > 0; i -= (i & (-i))) ans += f[i];
        return ans;
    }

    inline int get_seg(int l, int r) {
        return get_pref(r) - get_pref(l - 1);
    }
};

struct SQRT {
    int n;
    const int K = 1500;
    vector <int> val;
    vector <int> sum;

    SQRT(int n) : n(n) {
        val.resize(n);
        sum.resize((n + K - 1) / K);
    }

    inline void add(int i, int x) {
        val[i] += x;
        sum[i / K] += x;
    }

    inline int get_seg(int l, int r) {
        int ans = 0;
        while (l <= r && l % K != 0) {
            ans += val[l++];
        }
        while (l <= r && r % K != K - 1) {
            ans += val[r--];
        }
        while (l <= r) {
            ans += sum[l / K];
            l += K;
        }
        return ans;
    }
};

inline void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    add_node();
    string tmp;
    vector <int> all_l;
    for (int i = 0; i < n; ++i) {
        cin >> tmp;
        all_l.push_back((int)tmp.size());
        add_string(tmp);
    }
    sort(all_l.begin(), all_l.end());
    all_l.resize(unique(all_l.begin(), all_l.end()) - all_l.begin());
    build();
    vector <int> ans(m);
    int ln = (int)t.size();
    vector <vector <pair <int, int>>> all_q(ln);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r; --l; --r;
        all_q[l].emplace_back(r, i);
    }
    vector <int> now(ln);
    int root = 0;
    SQRT f(ln);
    vector <pair <int, int>> xd(cur);
    for (int i = 0; i < cur; ++i) {
        xd[i].first = all[i].ssuf;
        xd[i].second = all[i].len;
    }
    for (int i = 0; i < ln; ++i) {
        root = all[root].nxt[t[i] - 'a'];
        now[i] = root;
        if (!all[root].term) now[i] = xd[root].first;
        f.add(i, all[now[i]].cnt);
    }
    for (int l = 0; l < ln; ++l) {
        if (l) {
            for (int flex : all_l) {
                if (l + flex - 2 < ln && xd[now[l + flex - 2]].second == flex) {
                    now[l + flex - 2] = xd[now[l + flex - 2]].first;
                    f.add(l + flex - 2, -1);
                }
            }
        }
        for (auto [r, ind] : all_q[l]) {
            ans[ind] = f.get_seg(l, r);
        }
    }
    for (int i : ans) cout << i << " ";
}

void test_gen(int n, int m, int ln) {
    mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());
    cout << n << " " << m << "\n";
    string t;
    for (int i = 0; i < ln; ++i) t.push_back('a' + rnd() % 3);
    cout << t << "\n";
    vector <string> a;
    while (a.size() < n) {
        string cha;
        int cha_len = rnd() % 5 + 1;
        while (cha_len--) cha.push_back('a' + rnd() % 3);
        if (find(a.begin(), a.end(), cha) != a.end()) continue;
        a.push_back(cha);
    }
    for (auto i : a) cout << i << "\n";
    while (m--) {
        int l = rnd() % ln + 1;
        int r = rnd() % ln + 1;
        if (l > r) swap(l, r);
        cout << l << " " << r << "\n";
    }
}

signed main(int argc, char** argv) {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int t = 1;
        //cin >> t;
        while (t--) solve();
    } else if (1) {
        stupid_solve();
    } else {
        int n = (int)atoi(argv[1]);
        int m = (int)atoi(argv[2]);
        int ln = (int)atoi(argv[3]);
        test_gen(n, m, ln);
    }
    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

 */