#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <map>
#include <set>

using namespace std;

struct tree{
    vector<pair<int, int>> tr;
    vector<pair<int, int>> aaa;

    tree(int n) {
        tr.resize(n * 4);
        aaa.resize(n);
    }

    void change(int id, int l, int r, int i, int t) {
        if (r - l == 1) {
            if (t == 0) {
                tr[id].first++;
            } else {
                tr[id].second++;
            }
            aaa[l] = tr[id];
            return;
        }
        int mid = (l + r) / 2;
        if (i < mid) {
            change(id * 2 + 1, l, mid, i, t);
        } else {
            change(id * 2 + 2, mid, r, i, t);
        }
        tr[id] = {tr[id * 2 + 1].first + tr[id * 2 + 2].first, tr[id * 2 + 1].second + tr[id * 2 + 2].second};
    }

    int ask(int id, int l, int r, int ql, int qr, int t) {
        if (l >= r) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            if (t == 0) {
                return tr[id].first;
            } else {
                return tr[id].second;
            }
        }
        if (r <= ql || qr <= l) {
            return 0;
        }
        int mid = (l + r) / 2;
        return ask(id * 2 + 1, l, mid, ql, qr, t) + ask(id * 2 + 2, mid, r, ql, qr, t);
    }
};
struct shash{
    int R = 27, mod = 1e9 + 7;
    vector<long long> st;
    vector<long long> h;
    shash(string s) {
        st.resize(s.size() + 1);
        h.resize(s.size() + 1);
        st[0] = 1;
        h[0] = 0;
        for (int i = 0; i < s.size(); i++) {
            st[i + 1] = st[i] * R % mod;
            h[i + 1] = (h[i] * R + s[i] - 'a' + 1) % mod;
        }
    }
    int get(int l, int r) {
        return (h[r] + mod - h[l] * st[r - l] % mod) % mod;
    }
};

int main()
{
    cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    shash st(t);
    vector<pair<long long, int>> v(n);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        shash tmp(s);
        v[i] = {tmp.get(0, s.size()), s.size()};
    }
    tree tr(t.size());
    long long all = 0;
    for (auto [h, sz] : v) {
        for (int j = 0; j < t.size(); j++) {
            if (j + sz <= t.size() && st.get(j, j + sz) == h) {
                tr.change(0, 0, t.size(), j, 0);
                tr.change(0, 0, t.size(), j + sz - 1, 1);
                all++;
            }
        }
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        cout << all - tr.ask(0, 0, t.size(), 0, l, 0) - tr.ask(0, 0, t.size(), r, t.size(), 1) << " ";
    }

    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
*/
