#include <iostream>
#include <vector>
#include <algorithm>
#include<set>

using namespace std;

#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int MOD = 1e9 + 7;
const int maxn = 1e6 + 1;
const int p = 239;

int mult(int x, int y) {
    long long ans = x;
    ans *= y;
    if(ans >= MOD) ans %= MOD;
    return (int)ans;
}

int sum(int x, int y) {
    int ans = x + y;
    if(ans >= MOD) ans -= MOD;
    return ans;
}

int sub(int x, itn y) {
    int ans = x - y;
    if(ans < 0) ans += MOD;
    return ans;
}

int get_hash(int l, int r, vector<int> &h, vector<int> &pows) {
    ++r;
    return sub(h[r], mult(h[l], pows[r - l]));
}

void solve() {
    int k, m;
    cin >> k >> m;
    string s;
    cin >> s;
    itn n = (int)s.size();
    vector<itn> h(n + 1, 1);
    vector<int> pows(n + 1, 1);
    for(int i = 0; i < n; ++i) {
        h[i + 1] = sum(mult(h[i], p), s[i]);
        pows[i + 1] = mult(pows[i], p);
    }
    vector<itn> lens;
    set<int> hashs;
    for(int i = 0; i < k; ++i) {
        string t;
        cin >> t;
        if((int)t.size() > (int)s.size()) continue;
        lens.pb((int)t.size());
        int h1 = 1;
        for(int j = 0; j < (int)t.size(); ++j) h1 = sum(mult(h1, p), t[j]);
        hashs.insert(sub(h1, pows[(int)t.size()]));
    }
    sort(all(lens));
    if((int)lens.size() == 0) {
        for(int i = 0; i < m; ++i) {
            int l, r;
            cin >> l >> r;
            cout << 0 << ' ';
        }
        return;
    }
    vector<itn> lens1 = {lens[0]};
    for(int i = 1; i < (int)lens.size(); ++i) {
        if(lens[i] != lens[i - 1]) lens1.pb(lens[i]);
    }
    lens = lens1;
    vector<int> szh(maxn);
    for(int i = 0; i < (int)lens.size(); ++i) szh[lens[i]] = i;
    vector<vector<int>> pref_cnt((int)lens.size());
    for(auto to : lens) {
        pref_cnt[szh[to]].resize(n, 0);
        for(int i = to - 1; i < n; ++i) {
            if(i >= 1) pref_cnt[szh[to]][i] = pref_cnt[szh[to]][i - 1];
            int cur = get_hash(i - to + 1, i, h, pows);
            if(hashs.find(cur) != hashs.end()) pref_cnt[szh[to]][i]++;
        }
    }
    for(Int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int ans = 0;
        for(auto to : lens) {
            if(pref_cnt[szh[to]][r] == 0) continue;
            if(r - l + 1 < to) continue;
            ans += pref_cnt[szh[to]][r] - ((l + to - 2 >= 0) ? pref_cnt[szh[to]][l + to - 2] : 0);
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int tmr = 1;
    //cin >> tmr;
    while(tmr--) {
        solve();
    }
}