//#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC comment("/linker:64000000")
//#pragma GCC targer("fma")
#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

struct Fenwick {
    vector<int> tree;
    int n;

    void upd(int i) {
        for (; i < n; i |= i + 1) {
            tree[i]++;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i &= i + 1, i--) {
            res += tree[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }

    void init(int n) {
        this->n = n;
        tree.assign(n, 0);
    }
};

const int INF = 1e9 + 9;
const int OSN = 257;

int add(int a, int b) {
    int c = (a + b - INF);
    while (c < 0) {
        c += INF;
    }
    return c;
}

int mul(ll a, ll b) {
    int c = (a * b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

struct hashes {
    vector<int> hpref;
    vector<int> osn;

    void init(string &t) {
        int n = t.size();
        hpref.assign(n + 1, 0);
        osn.assign(n + 1, 1);

        for (int i = 1; i <= n; i++) {
            osn[i] = mul(OSN, osn[i - 1]);
            hpref[i] = add(mul(hpref[i - 1], OSN), t[i - 1] - 'a');
        }
    }

    int get_hash(int l, int r) {
        return add(hpref[r + 1], -mul(hpref[l], osn[r - l + 1]));
    }
};

int calc(string &t) {
    int hpref = 0;

    for (auto &it : t) {
        hpref = mul(hpref, OSN);
        hpref = add(hpref, it - 'a');
    }
    return hpref;
}

const int K = 600;
const int DIFF = -1e9;

struct query {
    int x, y;
    int id;
};

inline void solve() {
    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    hashes my;
    my.init(t);
    hashes good;

    vector<pii> need_to_calc;
    unordered_map<int, unordered_set<int>> other;

    for (int i = 0; i < n; i++) {
        string tg;
        cin >> tg;

        int hsh = calc(tg);
        if (tg.size() >= K) {
            need_to_calc.push_back({hsh, tg.size()});
        } else {
            other[tg.size()].insert(hsh);
        }
    }

    n = t.size();
    vector<int> asks[n];

    for (pii &it : need_to_calc) {
        int len = it.Y;
        int hsh = it.X;

        for (int i = 0; i + len <= n; i++) {
            int r = i + len - 1;

            if (my.get_hash(i, r) == hsh) {
                asks[i].push_back(r);
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= K && i + j <= n; j++) {
            int r = i + j - 1;
            int hah = my.get_hash(i, r);

            if (other[j].count(hah)) {
//                cout << i << ' ' << r << endl;
                asks[i].push_back(r);
            }
        }
    }
    vector<query> my_ask[n];

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        --a; --b;

        if (a != 0) {
            my_ask[a - 1].push_back({a, b, -i});
        }

        my_ask[b].push_back({a, b, i});
    }

    Fenwick tree;
    tree.init(n);
    vector<int> ans(m, 0);

    for (int i = 0; i < n; i++) {
        for (int &it : asks[i]) {
            tree.upd(it);
        }

        for (query &it : my_ask[i]) {
            int val = tree.get(it.x, it.y);

            if (it.id < 0) {
                val *= -1;
                it.id *= -1;
            }

            ans[it.id] += val;
        }
    }

    cout << ans << endl;
}


signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

//
#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
