#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T>
using ordered_set = tree<T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

class SegmentTree {
private:
    vector<int> d;
    int n;

    void upd(int i) {
        d[i] = (d[2 * i] + d[2 * i + 1]);
    }

public:
    SegmentTree(const vector<int> &v) {
        n = 1;
        while (n < sz(v)) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < sz(v); ++i) {
            d[i + n] = v[i];
        }
        for (int i = n - 1; i; --i) {
            upd(i);
        }
    }

    int get(int l, int r) {
        int res = 0;
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                res += d[l++];
            }
            if (r & 1) {
                res += d[--r];
            }
        }
        return res;
    }

    void upd(int i, int x) {
        d[i += n] = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};

using pii = pair<int, int>;

template<typename T1, typename T2>
void mxr(T1 &a, const T2 &b) {
    if (a < b) {
        a = b;
    }
}

template<typename T1, typename T2>
void mnr(T1 &a, const T2 &b) {
    if (a > b) {
        a = b;
    }
};

const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        a -= MOD;
    }
    return a;
}

int mul(int a, int b) {
    return 1ll * a * b % MOD;
}

int sub(int a, int b) {
    if (a > b) {
        return a - b;
    }
    return a + MOD - b;
}

const int X = 101;

int ch(char c) {
    return c - 'a' + 1;
}

const int POW_MAX_N = 5e6 + 1;
int xpow[POW_MAX_N];

const int MAXM = 500'001;
const int MAXLEN = 1'000'001;

gp_hash_table<int,int> hashes[MAXLEN];
vector <int> lsbyr[MAXM];
int sh[MAXM];

const int K = 500;
int block[MAXM / K + 1];
int val[MAXM];

int qget(int l, int r) {
    if (r - l + 1 <= 2 * K) {
        int res = 0;
        for (; l <= r; ++l) {
            res += val[l];
        }
        return res;
    }
    int ln = l + (K - l % K) % K;
    int res = 0;
    while (l != ln) {
        res += val[l++];
    }
    int rp = (r % K == K - 1 ? r : r - (r % K) - 1);
    while (r != rp) {
        res += val[r--];
    }
    int i = l / K, j = r / K;
    for (; i <= j; ++i) {
        res += block[i];
    }
    return res;
}

int geth(int l, int r) {
    int ll = (l ? sh[l - 1] : 0);
    return sub(sh[r], mul(ll, xpow[r - l + 1]));
}

int fdata[MAXM];

int m;

inline void upd(int i, int x) {
    for (; i < m; i |= i + 1) {
        fdata[i] += x;
    }
}

inline int get(int i) {
    int res = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) {
        res += fdata[i];
    }
    return res;
}

inline int get(int l, int r) {
    return get(r) - get(l - 1);
}

signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    xpow[0] = 1;
    for (int i = 1; i < POW_MAX_N; ++i) {
        xpow[i] = mul(xpow[i - 1], X);
    }
    int n, q;
    cin >> n >> q;
    string t;
    cin >> t;
    vector <string> v(n);
    vector <int> lens;
    for (auto &i : v) {
        cin >> i;
        lens.push_back(sz(i));
    }
    sort(all(lens));
    lens.resize(unique(all(lens)) - lens.begin());
    for (int i = 0; i < n; ++i) {
        int h = 0;
        for (auto j : v[i]) {
            h = mul(h, X);
            h = add(h, ch(j));
        }
        hashes[sz(v[i])][h] = 1;
    }
    m = sz(t);
    for (int i = 0; i < m; ++i) {
        if (i) {
            sh[i] = mul(sh[i - 1], X);
        }
        sh[i] = add(sh[i], ch(t[i]));
    }
    for (int i = 0; i < m; ++i) {
        for (auto j : lens) {
            if (j + i > m) {
                break;
            }
            int h = geth(i, i + j - 1);
            if (hashes[j][h]) {
                lsbyr[i + j - 1].push_back(i);
            }
        }
    }
    vector <vector <pii> > qs(m);
    vector <int> qans(q);
    for (int iter = 0; iter < q; ++iter) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        qs[r].emplace_back(l, iter);
    }
    for (int i = 0; i < m; ++i) {
        for (auto l : lsbyr[i]) {
            upd(m - l - 1, 1);
        }
        for (auto [l, it] : qs[i]) {
            qans[it] = get(m - l - 1);
        }
    }
    for (auto i : qans) {
        cout << i << " ";
    }
}
