#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 100, MOD = 1e9 + (1000 - 7), MAXN = 3e5, p_ = 239179, k = 100;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

vector<ll> ht(MAXN);
vector<ll> p(MAXN);

ll geth(string &s) {
    ll h = 0;
    for (ll i = 0; i < s.size(); ++i) {
        h = (h * p_ + (s[i] - 'a' + 1)) % MOD;
    }
    return h;
}

ll getht(ll l, ll r) {
    return ((ht[r] - ht[l - 1] * p[r - l + 1]) % MOD + MOD) % MOD;
}

void solve() {
    p[0] = 1;
    for (ll i = 1; i < MAXN; ++i) {
        p[i] = (p[i - 1] * p_) % MOD;
    }
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (ll i = 0; i < n; ++i) cin >> s[i];
    for (ll i = 1; i <= t.size(); ++i) {
        ht[i] = (ht[i - 1] * p_ + (t[i - 1] - 'a' + 1)) % MOD;
    }
    unordered_map<ll, bool> mp;
    map<ll, vector<ll>> mpdlin;
    for (ll i = 0; i < n; ++i) {
        if (s[i].size() < k) {
            mp[geth(s[i])] = true;
        } else {
            ll h = geth(s[i]);
            for (ll j = 1; j + s[i].size() - 1 <= t.size(); ++j) {
                if (h == getht(j, j + s[i].size() - 1)) mpdlin[s[i].size()].push_back(j);
            }
        }
    }
    for (auto &e : mpdlin) {
        sort(e.second.begin(), e.second.end());
    }
    while (m--) {
        ll l, r;
        cin >> l >> r;
        ll ans = 0;
        for (ll len = 1; len < k; ++len) {
            for (ll i = l; i + len - 1 <= r; ++i) {
                if (mp.find(getht(i, i + len - 1)) != mp.end()) ans++;
            }
        }
        for (auto e : mpdlin) {
            if (e.first == 1) {
                for (auto pos : e.second) cout << pos << ' ';
                cout << '\n';
            }
            ans += upper_bound(e.second.begin(), e.second.end(), r - e.first + 1) - lower_bound(e.second.begin(), e.second.end(), l);
        }
        cout << ans << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}