//#pragma GCC optimize("Ofast,unroll-loops")
//#pragma GCC target("avx,avx2,sse,sse2,sse3,tune-native")

#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int b = 29, mod = 998244353;

struct segtree {
	int n;
	vector<int> t;

	segtree(int _n) {
		n = _n;
		t.resize(2 * n);
	}

	void upd(int i) {
		for (t[i += n + 1]++; i > 1; i >>= 1)
			t[i >> 1] = t[i] + t[i ^ 1];
	}

	int get(int l, int r) {
		int res = 0;
		for (l += n + 1, r += n + 1; l < r; l >>= 1, r >>= 1) {
			if (l & 1) res += t[l++];
			if (r & 1) res += t[--r];
		}
		return res;
	}
};

void solve() {
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector<string> s(n);
	vector<int> hash;
	for (auto &x: s) {
		cin >> x;
		int cur = 0;
		for (char c: x)
			cur = (cur * b + c - 'a' + 1) % mod;
		hash.push_back(cur);
	}
	int sz = t.size();
	t = "$" + t;
	vector<int> h(sz + 1), pw(sz + 1);
	pw[0] = 1;
	for (int i = 1; i <= sz; i++)
		h[i] = (h[i - 1] * b + t[i] - 'a' + 1) % mod, pw[i] = pw[i - 1] * b % mod;
	auto get = [&](int l, int r) {
		return (h[r] + mod - h[l - 1] * pw[r - l + 1] % mod) % mod;
	};
	vector qq(sz + 1, vector<pair<int, int>>());
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		qq[l].push_back({r, i});
	}
	segtree st(sz + 1);
	vector<int> res(m);
	for (int i = sz; i; i--) {
		for (int j = 0; j < n; j++) {
			int to = i + s[j].size() - 1;
			if (to > sz) continue;
			if (get(i, to) == hash[j]) st.upd(to);
		}
		for (auto[r, id]: qq[i])
			res[id] = st.get(i, r + 1);
	}
	for (int i: res)
		cout << i << " ";
	cout << '\n';
}

int32_t main() {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);
	cout << fixed << setprecision(20);

	solve();
}
