#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

constexpr int maxk = 26;

struct Node {
    Node *go[maxk];
    Node *suflink;
    Node *pr;
    vector<int> vals;
    int ch;

    Node(int _ch = -1) {
        ch = _ch;
        for (int i = 0; i < maxk; ++i) {
            go[i] = nullptr;
        }
        if (ch == -1) {
            suflink = this;
        } else {
            suflink = nullptr;
        }
        pr = this;
    }
};

Node *root = new Node();

Node *root_global = root;

Node* get_go(Node *root, int ch);

Node* get_suflink(Node *root) {
    if (root->suflink) {
        return root->suflink;
    }
    root->suflink = get_go(get_suflink(root->pr), root->ch);
    if (root->suflink == root) {
        root->suflink = root_global;
    } else {
        get_suflink(root->suflink);
        for (auto vl : root->suflink->vals) {
            root->vals.push_back(vl);
        }
    }
    return root->suflink;
}

Node* get_go(Node *root, int ch) {
    if (root->go[ch]) {
        return root->go[ch];
    }
    if (root->ch == -1) {
        root->go[ch] = root;
        return root->go[ch];
    }
    return root->go[ch] = get_go(get_suflink(root), ch);
}

void add_string(string s) {
    Node *nw = root;
    for (auto ch : s) {
        if (nw->go[ch - 'a']) {
            nw = nw->go[ch - 'a'];
        } else {
            nw->go[ch - 'a'] = new Node(ch - 'a');
            nw->go[ch - 'a']->pr = nw;
            nw = nw->go[ch - 'a'];
        }
    }
    nw->vals.push_back(s.size());
}

constexpr int mod1 = 1e9 + 7, mod2 = 1e9 + 9, base = 29;

constexpr int maxn = 1e6 + 5, sq = 1000;

int f[maxn];

void add(int pos) {
    for (int i = pos; i < maxn; i += i & -i) {
        f[i]++;
    }
}

int get(int pos) {
    int ans = 0;
    for (int i = pos; i > 0; i -= i & -i) {
        ans += f[i];
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n), s_nw;
    vector<pair<int, int>> vl(n), vl_nw;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        for (auto ch : s[i]) {
            vl[i].first = (vl[i].first * 1LL * base + ch - 'a' + 1) % mod1;
            vl[i].second = (vl[i].second * 1LL * base + ch - 'a' + 1) % mod2;
        }
        if (s[i].size() <= sq) {
            reverse(s[i].begin(), s[i].end());
            add_string(s[i]);
        } else {
            s_nw.push_back(s[i]);
            vl_nw.push_back(vl[i]);
        }
    }
    s = s_nw;
    vl = vl_nw;
    n = vl.size();
    vector<pair<int, int>> pw((int)t.size() + 1);
    pw[0] = {1, 1};
    for (int i = 1; i <= (int)t.size(); ++i) {
        pw[i].first = pw[i - 1].first * 1LL * base % mod1;
        pw[i].second = pw[i - 1].second * 1LL * base % mod2;
    }
    vector<pair<int, int>> pr((int)t.size() + 1);
    for (int i = 0; i < (int)t.size(); ++i) {
        pr[i + 1].first = (pr[i].first * 1LL * base + t[i] - 'a' + 1) % mod1;
        pr[i + 1].second = (pr[i].second * 1LL * base + t[i] - 'a' + 1) % mod2;
    }
    vector<int> l(m), r(m);
    vector<vector<int>> qs(t.size());
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
        qs[l[i]].push_back(i);
    }
    vector<int> ans(m);
    Node *nw = root;
    for (int i = (int)t.size() - 1; i >= 0; --i) {
        nw = get_go(nw, t[i] - 'a');
        get_suflink(nw);
        for (auto len : nw->vals) {
            add(i + len);
        }
        for (int j = 0; j < n; ++j) {
            if (i + (int)s[j].size() <= (int)t.size()) {
                pair<int, int> hash_nw;
                hash_nw.first = pr[i + (int)s[j].size()].first - pr[i].first * 1LL * pw[(int)s[j].size()].first % mod1;
                if (hash_nw.first < 0) {
                    hash_nw.first += mod1;
                }
                hash_nw.second = pr[i + (int)s[j].size()].second - pr[i].second * 1LL * pw[(int)s[j].size()].second % mod2;
                if (hash_nw.second < 0) {
                    hash_nw.second += mod2;
                }
                if (hash_nw == vl[j]) {
                    add(i + (int)s[j].size());
                }
            }
        }
        for (auto ind : qs[i]) {
            ans[ind] = get(r[ind]);
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
