#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (ll)1e9
#define db double
#define bint __int128_t

const ll mod = 1e9 + 7;

ll mul(ll a, ll b) {
    return (bint)(a * b % mod);
}

ll sub(ll a, ll b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}

ll add(ll a, ll b) {
    return (a + b) % mod;
}

const ll p = 37;
const int sz = 5e4 + 1;
ll pw[sz];

ll gethash(int l, int r, vector<ll> hsh) {
    ll oct = mul((l == 0 ? 0 : hsh[l - 1]), pw[r - l + 1]);
    return sub(hsh[r], oct);
}

vector<vector<ll>> t;

void build(int v, int l, int r, vector<ll>& a, int id) {
    if (r - l == 1) {
        t[id][v] = a[l];
        return;
    }
    int mid = (r + l) >> 1;
    build(2 * v + 1, l, mid, a, id);
    build(2 * v + 2, mid, r, a, id);
    t[id][v] = t[id][2 * v + 1] + t[id][2 * v + 2];
}

ll ask(int v, int l, int r, int lb, int rb, int id) {
    if (r <= lb || rb <= l) {
        return 0;
    }
    if (lb <= l && r <= rb) {
        return t[id][v];
    }
    int mid = (r + l) >> 1;
    return ask(2 * v + 1, l, mid, lb, rb, id) + ask(2 * v + 2, mid, r, lb, rb, id);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<ll> tz;
    {
        string ts; cin >> ts;
        tz.resize((int)ts.size());
        tz[0] = (ts[0] - 'a' + 1);
        for (int i = 1; i < (int)tz.size(); i++) {
            tz[i] = add(mul(tz[i - 1], p), (ts[i] - 'a' + 1));
        }
    }
    t = vector<vector<ll>>(4 * n, vector<ll>(4 * (int)tz.size()));
    vector<ll> stz(n);
    vector<ll> st(n);
    {
        for (int i = 0; i < n; i++) {
            string ts; cin >> ts;
            st[i] = (ts[0] - 'a' + 1);
            stz[i] = ts.size();
            for (int j = 1; j < (int)stz[i]; j++) {
                st[i] = add(mul(st[i], p), (ts[j] - 'a' + 1));
            }
        }
    }
    vector<vector<ll>> good(n, vector<ll>(tz.size()));
    for (int i = 0; i < (int)tz.size(); i++) {
        for (int j = 0; j < n; j++) {    
            if (i + stz[j] - 1 >= (int)tz.size()) continue;
            if (st[j] == gethash(i, (int)stz[j] + i - 1, tz)) good[j][i]++;
        }
    }
    for (int i = 0; i < n; i++) {
        build(0, 0, (int)tz.size(), good[i], i);
    }
    for (int q = 0; q < m; q++) {
        int l, r;
        cin >> l >> r;
        --l;
        ll ans = 0;
        for (int i = 0; i < n; i++) {
            ans += ask(0, 0, (int)tz.size(), l, r - (r % stz[i]), i);
        }
        cout << ans << " ";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    // cout << fixed << setprecision(20);

    pw[0] = 1;
    for (int i = 1; i < sz; i++) {
        pw[i] = mul(pw[i - 1], p);
    }
    ll t = 1;
    // cin >> t;
    while (t--) solve();
    return 0;
}