#include <iostream>
#include <vector>
#include <queue>
using namespace std;
const int MAXN=1e6+10;
const long long osn[2]={29,31};
const long long mod[2]={1000000007,1000000009};
struct node {
    int ch[26];
    int fail, ok, w, len;
};
struct hesh {
    long long h[2];
};
hesh wh[MAXN], pref[MAXN], power[MAXN];
node trie[MAXN];
vector <pair <int,int> > sub[MAXN];
vector <int> sub1[MAXN];
string str, word[MAXN];
int m, cnt;
void add(int ind) {
    int cur=0;
    for (int i=0;i<word[ind].size();i++) {
        int let=word[ind][i]-'a';
        if (trie[cur].ch[let]==0) {
            cnt++;
            trie[cur].ch[let]=cnt;
            trie[cnt].len=trie[cur].len+1;
        }
        cur=trie[cur].ch[let];
        wh[ind].h[0]=(wh[ind].h[0]*osn[0]+let)%mod[0];
        wh[ind].h[1]=(wh[ind].h[1]*osn[1]+let)%mod[1];
    }
    trie[cur].w++;
}
void bfs() {
    queue <int> q;
    q.push(0);
    while (!q.empty()) {
        int x=q.front();
        q.pop();
        for (int i=0;i<26;i++) {
            int child=trie[x].ch[i];
            if (child==0) continue;
            int up=x;
            bool fl=false;
            while (up!=0) {
                if (trie[trie[up].fail].ch[i]!=0) {
                    trie[child].fail=trie[trie[up].fail].ch[i];
                    fl=true;
                    break;
                }
                up=trie[up].fail;
            }
            if (!fl) trie[child].fail=0;
            if (trie[trie[child].fail].w) trie[child].ok=trie[child].fail;
            else trie[child].ok=trie[trie[child].fail].ok;
            q.push(child);
        }
    }
}
void find_substr() {
    int cur=0;
    for (int i=0;i<str.size();i++) {
        int let=str[i]-'a';
        while (cur!=0 && trie[cur].ch[let]==0) cur=trie[cur].fail;
        if (cur==0 && trie[cur].ch[let]==0) cur=0;
        else cur=trie[cur].ch[let];
        int kopie=cur;
        while (cur!=0 && trie[cur].w) {
            sub[i].push_back({trie[cur].len,trie[cur].w});
            cur=trie[cur].ok;
        }
        cur=kopie;
    }
}
hesh geth(int l, int r) {
    hesh ans;
    if (l==0) ans.h[0]=pref[r].h[0];
    else ans.h[0]=(pref[r].h[0]-(pref[l-1].h[0]*power[r-l+1].h[0])%mod[0]+mod[0])%mod[0];
    if (l==0) ans.h[1]=pref[r].h[1];
    else ans.h[1]=(pref[r].h[1]-(pref[l-1].h[1]*power[r-l+1].h[1])%mod[1]+mod[1])%mod[1];
    return ans;
}
void find_substr1() {
    power[0].h[0]=power[0].h[1]=1;
    for (int i=1;i<=str.size();i++) {
        power[i].h[0]=power[i-1].h[0]*osn[0]%mod[0];
        power[i].h[1]=power[i-1].h[1]*osn[1]%mod[1];
    }
    for (int i=0;i<str.size();i++) {
        long long let=str[i]-'a';
        if (i>0) pref[i].h[0]=pref[i-1].h[0]*osn[0];
        pref[i].h[0]+=let;
        if (i>0) pref[i].h[1]=pref[i-1].h[1]*osn[1];
        pref[i].h[1]+=let;
        pref[i].h[0]%=mod[0]; pref[i].h[1]%=mod[1];
    }
    for (int i=0;i<str.size();i++) {
        for (int j=0;j<m;j++) {
            int n=word[j].size();
            hesh cur=geth(i-n+1,i);
            if (cur.h[0]==wh[j].h[0] && cur.h[1]==wh[j].h[1]) sub1[i].push_back(word[j].size());
        }
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int q;
    cin >> m >> q >> str;
    for (int i=0;i<m;i++) {
        cin >> word[i];
        if (word[i].size()<=str.size()) add(i);
    }
    //bfs();
    //find_substr();
    find_substr1();
    /*for (int i=0;i<str.size();i++) {
        if (sub1[i].empty()) continue;
        cout << i << ' ' << sub1[i].size() << ":\n";
        for (auto j:sub1[i]) cout << j.first << ' ' << j.second << endl;
    }*/
    int l, r, ans;
    for (int i=0;i<q;i++) {
        cin >> l >> r;
        l--; r--;
        ans=0;
        for (int i=l;i<=r;i++) {
            for (auto j:sub1[i]) {
                if (i-j+1>=l) ans++;
            }
        }
        cout << ans;
        if (i<q-1) cout << ' ';
    }
    cout << endl;
    return 0;
}