#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
using namespace std;

constexpr int ord(const char &x) {
    return static_cast<int>(x - 'a');
}

namespace aho {
    struct node {
        int nx[26]{};
        int suff = -1;
        int p = -1;
        int chr = -1;
        int len = 0;
        bool cnt = false;
        node() {
            memset(nx, -1, sizeof nx);
        }
    };

    vector<node> tree = { node() };
    int sz = 1;

    int new_node() {
        tree.emplace_back();
        return sz++;
    }

    void add_string(string &s) {
        int u = 0;
        for (const char &x : s) {
            if (tree[u].nx[ord(x)] == -1) {
                int v = new_node();
                tree[u].nx[ord(x)] = v;
                tree[v].p = u;
                tree[v].chr = ord(x);
                tree[v].len = tree[u].len + 1;
            }
            u = tree[u].nx[ord(x)];
        }
        tree[u].cnt = true;
    }

    void build() {
        for (int &v : tree[0].nx) {
            if (v == -1) {
                v = 0;
            }
        }
        for (int u = 1; u < sz; u++) {
            int v = tree[tree[u].p].suff;
            if (v == -1) {
                tree[u].suff = 0;
                for (int &i : tree[u].nx) {
                    if (i == -1) {
                        i = 0;
                    }
                }
            } else {
                tree[u].suff = tree[v].nx[tree[u].chr];
                for (int i = 0; i < 26; i++) {
                    if (tree[u].nx[i] == -1) {
                        tree[u].nx[i] = tree[tree[u].suff].nx[i];
                    }
                }
            }
        }
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        aho::add_string(s);
    }
    aho::build();

    vector<int> state(t.size());
    for (int u = 0, i = 0; i < (int)t.size(); i++) {
        int x = ord(t[i]);
        u = aho::tree[u].nx[x];
        state[i] = u;
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for (int j = l; j <= r; j++) {
            int u = state[j - 1];
            while (u != -1) {
                {
                    using namespace aho;
                    if (tree[u].len <= j - l + 1) {
                        ans += tree[u].cnt;
                    }
                    u = tree[u].suff;
                }
            }
        }
        cout << ans << " ";
    }
    return 0;
}
