#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
const ll P = 239;
//const ll MOD = 998244353;

using namespace std;

void solve() {
    int n, m; cin >> n >> m;
    string s; cin >> s;
    vector<string> str(n);
    for (int i = 0; i < n; ++i) {
        cin >> str[i];
    }
    vector<ll> pw(s.size() + 1, 1), hsh(s.size() + 1, 0);
    for (int i = 0; i < (int)s.size(); ++i) {
        pw[i + 1] = pw[i] * P % MOD;
        hsh[i + 1] = (hsh[i] * P + s[i]) % MOD;
    }
    vector<vector<int>> ps(s.size());
    for (int i = 0; i < n; ++i) {
        ll h = 0;
        for (char ch : str[i]) {
            h = (h * P + ch) % MOD;
        }
        for (int st = 0; st <= (int)(s.size()) - (int)(str[i].size()); ++st) {
            ll hnw = (hsh[st + (int)str[i].size()] - hsh[st] * pw[(int)str[i].size()] + MOD * MOD) % MOD;
            if (hnw == h) {
                ps[st].push_back(st + (int)str[i].size());
            }
        }
    }
    for (int i = 0; i < (int)s.size(); ++i) {
        sort(all(ps[i]));
    }
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r; --l; --r;
        int ans = 0;
        for (int j = l; j <= r; ++j) {
            if (ps[j].size()) {
                int pos = lower_bound(all(ps[j]), r + 2) - ps[j].begin();
                ans += pos;
            }
        }
        cout << ans << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}