#include <bits/stdc++.h>
#define int long long
#define pii pair < int, int >
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

const int maxn = 50000 + 1, mam = 20000 + 1, inf = 1e12 + 100, alp = 37, mod = 1e9 + 7;

struct hsh
{
    int mod;
    int a[maxn], p[maxn];

    int mood(int x)
    {
        x %= mod;
        if (x < 0)
            x += mod;
        return x;
    }

    void build(string s)
    {
        int n = s.size();
        p[0] = 1;
        for (int i = 0; i < n; ++i) 
        {
            a[i + 1] = mood(a[i] * alp + s[i] - 'a' + 1);
            p[i + 1] = mood(p[i] * alp);
        }
    }   

    int get(int l, int r)
    {
        return mood(a[r] - mood(a[l] * p[r - l]));
    }

};

vector < int > g[maxn];
vector < int > tr[4 * maxn];

void build(int v, int l, int r)
{
    if (r - l == 1)
    {
        tr[v] = g[l];
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    // cout << "OK" << endl;
    merge(all(tr[2 * v + 1]), all(tr[2 * v + 2]), std::back_inserter(tr[v]));

    // cout << "TREE : " << v << ' ' << l << ' ' << r << endl;
    // for (auto i : tr[v])
    //     cout << i << ' ';
    // cout << endl;
}

int query(int v, int l, int r, int lx, int rx)
{
    if (lx <= l && r <= rx)
    {
        return upper_bound(all(tr[v]), rx) - tr[v].begin();
    }
    if (l >= rx || lx >= r)
        return 0;
    int m = (r + l) / 2;
    return query(2 * v + 1, l, m, lx, rx) + query(2 * v + 2, m, r, lx, rx);
}

void solve()
{
    int n, m;
    cin >> n >> m;
    hsh p, q;
    p.mod = 1e9 + 7;
    q.mod = 1e9 + 9;
    string t;
    cin >> t;
    p.build(t);
    q.build(t);
    int k = t.size();
    for (int i = 0; i < n; ++i)
    {
        string s;
        cin >> s;
        int len = s.size();
        int hs1 = 0, hs2 = 0;
        int m1 = 1e9 + 7, m2 = 1e9 + 9;
        for (auto j : s)
        {
            hs1 = (hs1 * alp + j - 'a' + 1) % m1;
            hs2 = (hs2 * alp + j - 'a' + 1) % m2;
        }
        for (int i = 0; i + len <= k; ++i)
        {
            if (p.get(i, i + len) == hs1 && q.get(i, i + len) == hs2)
                g[i].pb(i + len);
        }
    }
    for (int i = 0; i < k; ++i)
    {
        sort(all(g[i]));
        // cout << i << ": ";
        // for (auto j : g[i])
        //     cout << j << ' ';
        // cout << endl;
    }
    // cout << endl;
    build(0, 0, k);
    // cout << endl;
    while (m--)
    {
        int l, r;
        cin >> l >> r;
        --l;
        // cout << l << ' ' << r << ' ';
        cout << query(0, 0, k, l, r) << ' ';
    }
}

signed main()
{
    cin.tie(0);
    cout.tie(0);
    ios::sync_with_stdio(false);
    int t = 1;
    // cin >> t;
    while (t--)
    {
        solve();
        cout << endl;
    }
    return 0;
}