#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define LL __int128
#define F first
#define S second
mt19937 rnd(100);

struct Node {
    Node *L, *R;
    ll y, v, c;
};

ll size(Node *r) {
    return r == nullptr ? 0 : r->c;
}

void update(Node *r) {
    r->c = size(r->L) + 1 + size(r->R);
}

pair<Node *, Node *> split(Node *r, ll k) {
    if (r == nullptr)
        return {nullptr, nullptr};
    else if (size(r->L) >= k) {
        auto p = split(r->L, k);
        r->L = p.S;
        update(r);
        return {p.F, r};
    } else {
        auto p = split(r->R, k - size(r->L) - 1);
        r->R = p.F;
        update(r);
        return {r, p.S};
    }
}

Node *merge(Node *r1, Node *r2) {
    if (r1 == nullptr)
        return r2;
    else if (r2 == nullptr)
        return r1;
    else if (r1->y <= r2->y) {
        r1->R = merge(r1->R, r2);
        update(r1);
        return r1;
    } else {
        r2->L = merge(r1, r2->L);
        update(r2);
        return r2;
    }
}

struct mst {
    vector<vector<ll>> arr;
    ll size;

    mst(vector<ll> &inp) {
        ll k = 1;
        while (k < inp.size())
            k *= 2;
        size = k * 2;
        arr.resize(size);
        for (int i = 0; i < inp.size(); ++i)
            arr[i + k] = {inp[i]};
        while (--k)
            merge(k);
    }

    void merge(ll x) {
        ll s1 = arr[x * 2].size();
        ll s2 = arr[x * 2 + 1].size();
        ll p1 = 0, p2 = 0;
        arr[x].resize(s1 + s2);

        while (p1 + p2 < s1 + s2)
            if (p2 == s2 || p1 != s1 && arr[x * 2][p1] < arr[x * 2 + 1][p2])
                arr[x][p1 + p2] = arr[x * 2][p1], p1++;
            else
                arr[x][p1 + p2] = arr[x * 2 + 1][p2], p2++;
    }

    ll l1, r1, l2, r2, ans;

    ll ask(ll _l1, ll _r1, ll _l2, ll _r2) {
        l1 = _l1, r1 = _r1, l2 = _l2, r2 = _r2, ans = 0;
        ask(0, size / 2, 1);
        return ans;
    }

    void ask(ll L, ll R, ll now) {
        if (L >= l1 && R <= r1) {
            ll l = -1, r = arr[now].size(), mid;
            while (r - l > 1) {
                mid = (r + l) / 2;
                if (arr[now][mid] < l2)
                    l = mid;
                else
                    r = mid;
            }
            ll le = -1, ri = arr[now].size();
            while (ri - le > 1) {
                mid = (ri + le) / 2;
                if (arr[now][mid] >= r2)
                    ri = mid;
                else
                    le = mid;
            }
            ans += le - l;
        } else if (L >= r1 || R <= l1)
            return;
        else
            ask(L, (R + L) / 2, now * 2), ask((R + L) / 2, R, now * 2 + 1);
    }
};

ll prs = 37;
ll mod = 10000007;

ll mo(ll a) {
    if (a >= 0)
        return a % mod;
    else
        return (mod - ((-a) % mod)) % mod;
}


int main() {
    cin.tie(0), ios_base::sync_with_stdio(0);

    ll m, q, n;
    string s;
    cin >> m >> q >> s;
    n = s.size();
    vector<ll> pref(n + 1), po(n + 1);
    pref[0] = 0;
    po[0] = 1;
    for (int i = 0; i < n; ++i) {
        po[i + 1] = mo(po[i] * prs);
        pref[i + 1] = mo(pref[i] + mo((s[i] - 'a' + 1) * po[i]));
    }

    vector<ll> h(m);
    for (int i = 0; i < m; ++i) {
        cin >> s;
        if (s.size() > n)
            continue;
        ll h1 = 0;
        for (int j = 0; j < s.size(); ++j)
            h1 += mo((s[j] - 'a' + 1) * po[j]);
        h[i] = mo(h1 * po[n]);
    }

    ll l, r;
    for (int i = 0; i < q; ++i) {
        cin >> l >> r;
        l--;
        unordered_map<ll, ll> help;
        for (int j = l; j < r; ++j)
            for (int k = j + 1; k <= r; ++k) {
                ll h1 = mo(mo(pref[k] - pref[j]) * po[n - j]);
                if (!help.count(h1))
                    help[h1] = 1;
                else
                    help[h1]++;
            }

        ll ans = 0;
        for (int j = 0; j < m; ++j)
            if (help.count(h[j]))
                ans += help[h[j]];
        cout << ans << '\n';
    }

    return 0;
}
/*


3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

4 4
abcdca
ab
ca
bcd
openolympiad
1 5
2 2
2 6
1 6

 */
/*
Для нужных подстрок сщитаем все возможные хеши и их количество
 */