#include <bits/stdc++.h>
#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int p = 71;
int mod = 1e9 + 9;

int add(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}
int sub(int a, int b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}
int mul(int a, int b) {
    return 1ll * a * b % mod;
}

struct hashing {
    vector<int> pw;
    vector<int> hsh;

    void build(string s) {
        int n = s.size();
        pw.assign(n + 1, 1);
        hsh.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            hsh[i + 1] = add(mul(hsh[i], p), s[i] - 'a' + 1);
            pw[i + 1] = mul(pw[i], p);
        }
    }

    int get(int l, int r) {
        return sub(hsh[r + 1], mul(hsh[l], pw[r - l + 1]));
    }
};

int ghsh(string s) {
    int res = 0;
    for (auto i : s) {
        res = add(mul(res, p), i - 'a' + 1);
    }
    return res;
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    hashing h;
    h.build(t);
    vector<int> len;
    vector<unordered_set<int>> st(1e6 + 1);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        len.push_back(s.size());
        st[s.size()].insert(ghsh(s));
    }
    sort(all(len));
    len.resize(unique(all(len)) - len.begin());
    vector<vector<int>> cnt(len.size());
    for (int j = 0; j < len.size(); ++j) {
        int c = len[j];
        if (c > t.size()) break;
        cnt[j].assign(t.size() - c + 2, 0);
        for (int i = 0; i < t.size() - c + 1; ++i) {
            cnt[j][i + 1] = cnt[j][i] + st[c].count(h.get(i, i + c - 1));
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l;
        ll ans = 0;
        for (int j = 0; j < len.size(); ++j) {
            int c = len[j];
            if (c > r - l) break;
            ans += cnt[j][r - c + 1] - cnt[j][l];
        }
        cout << ans << '\n';
    }
}

void solve() {
}