#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int p = 71;
int mod = 1e9 + 9;

int add(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}
int sub(int a, int b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}
int mul(int a, int b) {
    return 1ll * a * b % mod;
}

struct hashing {
    vector<int> pw;
    vector<int> hsh;

    void build(string s) {
        int n = s.size();
        pw.assign(n + 1, 1);
        hsh.assign(n + 1, 0);
        for (int i = 0; i < n; ++i) {
            hsh[i + 1] = add(mul(hsh[i], p), s[i] - 'a' + 1);
            pw[i + 1] = mul(pw[i], p);
        }
    }

    int get(int l, int r) {
        return sub(hsh[r + 1], mul(hsh[l], pw[r - l + 1]));
    }
};

int ghsh(string s) {
    int res = 0;
    for (auto i : s) {
        res = add(mul(res, p), i - 'a' + 1);
    }
    return res;
}
cc_hash_table<int, int> st[(int)1e6 + 1];
vector<int> cnt[(int)1e6 + 1];

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    if (n <= 100) {
        string t;
        cin >> t;
        hashing h;
        h.build(t);
        vector<int> len;
        for (int i = 0; i < n; ++i) {
            string s;
            cin >> s;
            len.push_back(s.size());
            st[s.size()][ghsh(s)]++;
        }
        sort(all(len));
        len.resize(unique(all(len)) - len.begin());
        for (int j = 0; j < len.size(); ++j) {
            int c = len[j];
            if (c > t.size()) break;
            cnt[j].assign(t.size() - c + 2, 0);
            for (int i = 0; i < t.size() - c + 1; ++i) {
                cnt[j][i + 1] = cnt[j][i] + st[c]);
            }
        }
        while (m--) {
            int l, r;
            cin >> l >> r;
            --l;
            ll ans = 0;
            for (int j = 0; j < len.size(); ++j) {
                int c = len[j];
                if (c > r - l) break;
                ans += cnt[j][r - c + 1] - cnt[j][l];
            }
            cout << ans << '\n';
        }
    } else {
        string t;
        cin >> t;
        hashing h;
        h.build(t);
        vector<vector<int>> cnt(t.size(), vector<int>(t.size()));
        for (int i = 0; i < n; ++i) {
            string s;
            cin >> s;
            int g = ghsh(s);
            for (int i = 0; i + s.size() - 1 < t.size(); ++i) {
                cnt[i][i + s.size() - 1] += h.get(i, i + s.size() - 1) == g;
            }
        }
        for (int d = 1; d < t.size(); ++d) {
            for (int l = 0, r = d; r < t.size(); ++l, ++r) {
                cnt[l][r] += cnt[l + 1][r] + cnt[l][r - 1] - cnt[l + 1][r - 1];
            }
        }
        while (m--) {
            int l, r;
            cin >> l >> r;
            --l, --r;
            cout << cnt[l][r] << '\n';
        }
    }
}

void solve() {
}