#include <bits/stdc++.h>

using namespace std;
#define all(x) x.begin(), x.end()

int p = 71;
int mod = 1e9 + 9;

int add(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}

int sub(int a, int b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}

int mul(int a, int b) {
    return 1ll * a * b % mod;
}

string t, s;

const int N = 1e5 + 100;

int pw[N], hsh[N];

void build() {
    pw[0] = 1;
    for (int i = 0; i < t.size(); ++i) {
        hsh[i + 1] = add(mul(hsh[i], p), t[i] - 'a' + 1);
        pw[i + 1] = mul(pw[i], p);
    }
}

int get(int l, int r) {
    return sub(hsh[r + 1], mul(hsh[l], pw[r - l + 1]));
}

int ghsh(string s) {
    int res = 0;
    for (auto i : s) {
        res = add(mul(res, p), i - 'a' + 1);
    }
    return res;
}

unordered_set<int> st[N];
int pref[500][N], pref1[500][N];

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    cin >> t;
    build();
    vector<int> len;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        if (s.size() > t.size()) continue;
        len.push_back(s.size());
        st[s.size()].insert(ghsh(s));
    }
    sort(all(len));
    len.resize(unique(all(len)) - len.begin());
    for (int j = 0; j < len.size(); ++j) {
        int c = len[j];
        for (int i = 0; i < t.size() - c + 1; ++i) {
            int cur = st[c].count(get(i, i + c - 1));
            pref[j + 1][i + 1] = pref[j][i + 1] + cur;
            pref1[j + 1][i + c] = pref[j][i + 1] + cur;
        }
    }
    for (int i = 0; i <= len.size(); ++i) {
        for (int j = 1; j <= t.size(); ++j) pref[i][j] += pref[i][j - 1];
    }
    for (int i = 0; i <= len.size(); ++i) {
        for (int j = 1; j <= t.size(); ++j) pref1[i][j] += pref1[i][j - 1];
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l;
        int k = upper_bound(all(len), r - l) - len.begin();
        cout << pref1[k][r] - pref[k][l] << '\n';
    }
}
