#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
using namespace std;
typedef long long ll;
const ll MOD = 1e9 + 7, MOD2 = 1e9 + 9, BASE = 31;

ll get_hash(const string &s) {
    ll cur_hash = 0;
    for (int j = 0; j < s.size(); ++j) {
        cur_hash = (cur_hash * BASE % MOD + (s[j] - 'a' + 1)) % MOD;
    }
    return cur_hash;
}
ll get_hash2(const string &s) {
    ll cur_hash = 0;
    for (int j = 0; j < s.size(); ++j) {
        cur_hash = (cur_hash * BASE % MOD2 + (s[j] - 'a' + 1)) % MOD2;
    }
    return cur_hash;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    set<pair<ll, ll>> hashes;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        hashes.insert({get_hash(s), get_hash2(s)});
    }
    vector<vector<ll>> cnt(t.size(), vector<ll>(t.size(), 0));
    for (int i = 0; i < t.size(); ++i) {
        ll cur_hash = 0;
        ll cur_hash2 = 0;
        for (int j = i; j < t.size(); ++j) {
            cur_hash = (cur_hash * BASE % MOD + (t[j] - 'a' + 1)) % MOD;
            cur_hash2 = (cur_hash2 * BASE % MOD2 + (t[j] - 'a' + 1)) % MOD2;
            if (hashes.find({cur_hash, cur_hash2}) != hashes.end()) {
                cnt[i][j]++;
            }
        }
    }
    vector<vector<ll>> pref(t.size() + 2, vector<ll>(t.size() + 2, 0));
    for (int i = t.size(); i >= 1; --i) {
        for (int j = 1; j <= t.size(); ++j) {
            pref[i][j] = pref[i + 1][j] + pref[i][j - 1] - pref[i + 1][j - 1] + cnt[i - 1][j - 1];
        }
    }
    for (int _ = 0; _ < m; ++_) {
        int l, r;
        cin >> l >> r;
        ll ans = pref[l][r];
        cout << ans << " ";
    }

    return 0;
}