#include <iostream>
#include <iomanip>

#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

struct Node
{
	map<char, Node*> dict;
	bool terminal = false;
	Node* syfflink = 0;
	Node* p = 0;
	char ch = ' ';
	int deep = 0;
};

void insert(Node* tree, string& s)
{
	Node* node = tree;
	for (int i = 0; i < s.size(); ++i)
	{
		if (node->dict.find(s[i]) == node->dict.end())
		{
			Node* tmp = new Node;
			tmp->ch = s[i];
			tmp->p = node;
			tmp->deep = i;
			node->dict[s[i]] = tmp;
		}

		node = node->dict[s[i]];
	}

	node->terminal = true;
}

void build(vector<string>& words, Node*& tree)
{
	tree = new Node;
	for (int i = 0; i < words.size(); ++i)
		insert(tree, words[i]);


	Node* damy = new Node;
	for (char i = 'a'; i <= 'z'; ++i)
		damy->dict[i] = tree;
	tree->syfflink = damy;

	queue<Node*> q;
	for (auto i : tree->dict)
		q.push(i.second);

	while (!q.empty())
	{
		Node* v = q.front();
		q.pop();

		Node* sp = v->p->syfflink;
		while (sp->dict.find(v->ch) == sp->dict.end())
			sp = sp->syfflink;

		v->syfflink = sp->dict[v->ch];

		for (auto i : v->dict)
			q.push(i.second);
	}
}

void clear(Node* node)
{
	for (auto i : node->dict)
		clear(i.second);

	delete node;
}

int main()
{
	int n, m;
	cin >> n >> m;

	string t;
	cin >> t;
	vector<string> words(n);
	for (auto& i : words)
		cin >> i;

	Node* tree = new Node;
	build(words, tree);

	while (m--)
	{
		int l, r;
		cin >> l >> r;
		l--, r--;
		Node* node = tree;
		vector<pair<int, int>> vxogd;
		for (int i = l; i <= r; ++i)
		{
			while (node->dict.find(t[i]) == node->dict.end())
				node = node->syfflink;
			node = node->dict[t[i]];

			Node* copy_node = node;
			while (copy_node != tree)
			{
				if (copy_node->terminal)
					vxogd.push_back({ i - copy_node->deep, i });
				copy_node = copy_node->syfflink;
			}
		}
		cout << vxogd.size() << " ";
	}

	delete tree->syfflink;
	clear(tree);
}