#ifdef WIN64
    #define _GLIBCXX_DEBUG
#endif // WIN64
#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple
#define isz(x) (int) x.size()
#define xx first
#define yy second

#ifdef WIN64
    #define check(x) cerr << (#x) << " = " << x << "\n"
    template<class T> void print(T* ar, int sz) {
        for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
        cerr << "\n";
    }
#else
    #define check(x) 17
    template<class T> void print(T* ar, int sz) {}
#endif // WIN64

const int N = (int) 5e5 + 1;
const int INF = (int) 1e9 + 117;
const int MOD = (int) 1e9 + 7;
const long long INFll = (long long) 2e18 + 117;
const double EPS = 1e-8;
const int BASE = 31;

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

#define int long long

using Pt = pair<int, int>;
using ll = long long;

inline int sum(int a, int b) {
    return (a + b >= MOD ? a + b - MOD : a + b);
}

inline int mul(int a, int b) {
    return ((ll)a * b) % MOD;
}

inline int subtr(int a, int b) {
    return ((a - b) % MOD + MOD) %  MOD;
}

struct Hash {
    vector<int> pref, pw;

    Hash() {}

    Hash(const string& s) {
        int n = isz(s);
        pref.assign(n, 0);
        pw.assign(n + 1, 0);
        pw[0] = 1;
        pref[0] = s[0] - 'a' + 1;
        for (int i = 1; i < n; ++i) {
            pref[i] = sum(mul(pref[i - 1], BASE), s[i] - 'a' + 1);
            pw[i] = mul(pw[i - 1], BASE);
        }
    }

    int get(int l, int r) {
        if (!l) return pref[r];
        return subtr(pref[r], mul(pref[l - 1], pw[r - l + 1]));
    }
};

inline int get_hash(const string& s) {
    int n = isz(s);
    int pref = s[0] - 'a' + 1;
    for (int i = 1; i < n; ++i) pref = sum(mul(pref, BASE), s[i] - 'a' + 1);
    return pref;
}

string s[N], t;
int n, m, hs[N];
Hash ht;

signed main() {
#ifdef WIN64
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WIN64
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int tst = 1;
    //cin >> t;
    while (tst--) {
        assert(cin >> n >> m >> t);
        ht = Hash(t);
        for (int i = 0; i < n; ++i) {
                assert(cin >> s[i]);
                check(s[i]);
                hs[i] = get_hash(s[i]);
        }
        for (int _ = 0; _ < m; ++_) {
            int l, r;
            assert(cin >> l >> r);
            --l; --r;
            int res = 0;
            for (int i = 0; i < n; ++i) {
                for (int j = l; j + isz(s[i]) - 1 <= r; ++j) {
                    if (ht.get(j, j + isz(s[i]) - 1) == hs[i]) {
                        res++;
                    }
                }
            }
            cout << res << " ";
        }
    }
    return 0;
}
