#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef std::pair<int, int> pii;

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::milliseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define ff first
#define sc second
#define str string
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

template<typename T, typename T1> istream& operator>>(istream& in, pair<T, T1> &a) { in >> a.ff >> a.sc; return in; }
template<typename T, typename T1> ostream& operator<<(ostream& out, pair<T, T1> a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream& in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T> a) { for (auto el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937 gen(mt_seed); int randint(int l, int r) { uniform_int_distribution<> random(l, r); return random(gen); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const {return x ^ RANDOM; }};

vector<pii> kek;

void f(str &s1, str &s2) {
    str s = s1 + '#' + s2;
    vector<int> z(sz(s));
    int l = 0, r = 0;
    for (int i = 1; i < sz(s); ++i) {
        if (i <= r)
            z[i] = min(r - i + 1, z[i - l]);
        while (i + z[i] < sz(s) && s[i + z[i]] == s[z[i]])
            ++z[i];
        if (i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    for (int i = sz(s1) + 1; i < sz(s); ++i)
        if (z[i] == sz(s1))
            kek.pb({i - sz(s1) - 1, i - 2});
}

struct seg_tree {
    int n;
    vector<vector<int>> t;
    seg_tree(int m, vector<pii> &a) {
        n = m;
        t.resize(4 * n);
        build(0, 0, n, a);
    }

    void build(int id, int l, int r, vector<pii> &a) {
        if (l + 1 == r) {
            t[id] = {a[l].sc};
            return;
        }
        build(id * 2 + 1, l, (l + r) >> 1, a);
        build(id * 2 + 2, (l + r) >> 1, r, a);
        merge(all(t[id * 2 + 1]), all(t[id * 2 + 2]), back_inserter(t[id]));
    }

    int getLow(int id, int l, int r, int lx, int rx, int x) {
        if (r <= lx || rx <= l) return 0;
        if (lx <= l && r <= rx)
            return upper_bound(all(t[id]), x) - t[id].begin();

        return getLow(id * 2 + 1, l, (l + r) >> 1, lx, rx, x) + getLow(id * 2 + 2, (l + r) >> 1, r, lx, rx, x);
    }
    int getLow(int l, int r, int x) {
        return getLow(0, 0, n, l, r, x);
    }
};

int main() {
    fast
    file_in

    int n, m;
    cin >> n >> m;
    str t;
    cin >> t;
    vector<str> s(n);
    cin >> s;

    for (int i = 0; i < n; ++i)
        f(s[i], t);

    sort(all(kek));

    if (sz(kek) == 0) {
        while (m--)
            cout << "0 ";
    } else {
        seg_tree tree(sz(kek), kek);

        vector<int> first_num_of(sz(t), 1e9);
        for (int i = 0; i < sz(kek); ++i)
            first_num_of[kek[i].ff] = min(first_num_of[kek[i].ff], i);
        first_num_of[sz(t) - 2] = min(first_num_of[sz(t) - 2], sz(kek));
        for (int i = sz(t) - 2; i >= 0; --i)
            first_num_of[i] = min(first_num_of[i], first_num_of[i + 1]);

        while (m--) {
            int l, r;
            cin >> l >> r;
            --r;
            --l;
            cout << (first_num_of[l] >= sz(kek) ? 0 : tree.getLow(first_num_of[l], sz(kek), r)) << " ";
        }
    }
    return 0;
}