#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

//#define int long long
#define ll long long

const int INF = 1e9 + 7;

using namespace std;
//using namespace __gnu_pbds;
//using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

struct Hash {
    vector<vector<ll>> pref, pw;
    vector<ll> mod, base;
    int n;

    Hash(string &s, vector<ll> &_mod, vector<ll> &_base) {
        mod = _mod;
        base = _base;
        n = (ll) s.size();
        pref.resize(n + 1, vector<ll>(2, 0));
        pw.resize(n + 1, vector<ll>(2, 1));
        for (int i = 1; i <= n; i++) {
            for (int j = 0; j < 2; j++) {
                pref[i][j] = (((ll)pref[i - 1][j] * (ll)base[j]) % mod[j] + s[i - 1] - 'a') % mod[j];
                pw[i][j] = ((ll)pw[i - 1][j] * (ll)base[j]) % mod[j];
            }
        }
    }

    vector<ll> get(int l, int r) {
        vector<ll> res(2, 0);
        for (int i = 0; i < 2; i++) {
            res[i] = ((ll)pref[r][i] + (ll)mod[i] - ((ll)pref[l][i] * (ll)pw[r - l][i]) % mod[i]) % mod[i];
        }
        return res;
    }
};

bool comp(Hash &a, Hash &b) {
    return a.n < b.n;
}

vector<int> operator+(vector<int> &a, vector<int> &b) {
    vector<int> res(a.size() + b.size());
    merge(a.begin(), a.end(), b.begin(), b.end(), res.begin());
    return res;
}

struct MergeSortTree {
    vector<vector<int>> tree;
    vector<vector<int>> a;

    void build(int l, int r, int ind) {
        if (l == r - 1) {
            tree[ind] = a[l];
            return;
        }
        int mid = (l  +r) / 2;
        build(l, mid, ind * 2 + 1);
        build(mid, r, ind * 2 +2);
        tree[ind] = tree[ind * 2 + 1] + tree[ind * 2 + 2];
    }

    MergeSortTree(vector<vector<int>> &_a) {
        a = _a;
        tree.resize(4 * _a.size());
        build(0, (int) a.size(), 0);
    }

    int func(vector<int> &vec, int x) {
        int l = -1, r = (int) vec.size();
        while(r - l > 1) {
            int mid = (l + r) / 2;
            if (vec[mid] > x) r = mid;
            else l = mid;
        }
        return r;
    }

    int get(int l, int r, int ql, int qr, int x, int ind) {
        if (l >= qr || r <= ql) return 0;
        if (l >= ql && r <= qr) return func(tree[ind], x);
        int mid = (l + r) / 2;
        return get(l, mid, ql, qr, x, ind * 2 + 1) + get(mid, r, ql, qr, x, ind * 2 + 2);
    }
};

void sf() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    sf();
    vector<ll> mods = {1000000007, 998244353};
    vector<ll> base = {37, 41};
    int m, q;
    cin >> m >> q;
    string s;
    cin >> s;
    int n = (int) s.size();
    vector<string> vec(m);
    for (auto &i : vec) cin >> i;
    vector<Hash> hashes;
    for (int i = 0; i < m; i++) {
        hashes.emplace_back(Hash(vec[i], mods, base));
    }
    sort(hashes.begin(), hashes.end(), comp);
    Hash ABOBA(s, mods, base);
    vector<vector<int>> right(n);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (i + hashes[j].n > n) break;
            vector<ll> v1 = hashes[j].pref.back();
            vector<ll> v2 = ABOBA.get(i, i + hashes[j].n);
            if (v1 == v2) {
                right[i].push_back(i + hashes[j].n);
            }
        }
    }
    MergeSortTree MST(right);
    while (q--) {
        int L, R;
        cin >> L >> R;
        L--;
        cout << MST.get(0, n, L, R, R, 0) << ' ';
    }
}
