#include <iostream>
#include "array"
#include "climits"
#include "cmath"
#include "algorithm"
#include "vector"
#include "string"
#include "map"
using namespace std;
#define all(x) x.begin(), x.end()
struct vect {
    vector<int> a;
    vector<int> a500;
    int sm = 0;
    void init(int n) {
        a.assign(n, {});
        a500.assign(n/500+1, {});
    }
    void add(int x) {
        sm++;
        a[x]++;
        a500[x/500]++;
    }
    int get(int l, int r) {
        if (l >= r)
            return 0;
        int l1 = min((l + 499) / 500 * 500, r);
        int res = 0;
        while (l != l1) {
            res += a[l];
            l++;
        }
        if (l == r)
            return res;
        while (l + 500 <= r) {
            res += a500[l/500];
            l += 500;
        }
        while (l != r) {
            res += a[l];
            l++;
        }
        return res;
    }
};
int mod = 1e9 + 7;
int p = 179;

int pls(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
int sub(int a, int b) {
    if (a - b < mod) return a - b + mod;
    return a - b;
}
int mult(long long a, long long b) {
    return a * b % mod;
}
int pw(int a, int b) {
    int res = 1;
    while (b) {
        if (b % 2)
            res = mult(res, a);
        a = mult(a, a);
        b /= 2;
    }
    return res;
}
int inv(int x) {
    return pw(x, mod - 2);
}
int hsh(string s) {
    int res = 0;
    int pp = 1;
    for (int i = s.size() - 1; i >= 0; --i) {
        res = pls(res, mult(s[i], pp));
        pp *= p;
    }
    return res;
}
void addvals(string &s, vect &amogus, vect &invamogus, vector<string> vals) {
    vector<int> vls(vals.size());
    for (int i = 0; i < vals.size(); ++i) {
        vls[i] = hsh(vals[i]);
        //cout << vals[i] << ' ' << vls[i] << '\n';
    }
    //cout << '\n';
    sort(all(vls));
    int ln = vals[0].size();
    int bgp = 1;
    for (int i = 0; i < ln; ++i) {
        bgp = mult(bgp, p);
    }
    int res1 = hsh(s.substr(0, ln));
    if (binary_search(all(vls), res1)) {
        //cout << 0 << '\n';
        amogus.add(0);
        invamogus.add(0+ln-1);
    }
    //cout << res1 << '\n';
    for (int i = 1; i + ln - 1 < s.size(); ++i) {
        res1 = pls(sub(mult(res1, p), mult(s[i-1], bgp)), s[i+ln-1]);
        //cout << res1 << '\n';
        if (binary_search(all(vls), hsh(s.substr(i, ln)))) {
            //cout << i << '\n';
            amogus.add(i);
            invamogus.add(i+ln-1);
        }
    }
}

void addvalsdebug(string &s, vect &amogus, vect &invamogus, vector<string> vals) {
    sort(all(vals));
    vector<int> vls(vals.size());
    for (int i = 0; i < vals.size(); ++i) {
        vls[i] = hsh(vals[i]);
        //cout << vals[i] << '\n';
    }
    //cout << '\n';
    sort(all(vls));
    int ln = vals[0].size();
    int bgp = 1;
    for (int i = 0; i < ln; ++i) {
        bgp = mult(bgp, p);
    }
    int res1 = hsh(s.substr(0, ln));
    if (binary_search(all(vals), s.substr(0, ln))) {
        //cout << 0 << '\n';
        amogus.add(0);
        invamogus.add(0+ln-1);
    }
    for (int i = 1; i + ln - 1 < s.size(); ++i) {
        res1 = pls(sub(mult(res1, p), mult(s[i-1], bgp)), s[i+ln-1]);
        if (binary_search(all(vals), s.substr(i, ln))) {
            //cout << i << '\n';
            amogus.add(i);
            invamogus.add(i+ln-1);
        }
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vect amogus, invamogus;
    amogus.init(s.size());
    invamogus.init(s.size());
    vector<pair<int, string>> sts(n);
    for (int i = 0; i < n; ++i) {
        cin >> sts[i].second;
        sts[i].first = sts[i].second.size();
    }
    sort(all(sts));
    vector<array<int, 3>> zpr(m);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        zpr[i] = {r - l, l, i};
    }
    sort(all(zpr));
    int ind1 = 0;
    vector<int> res(m);
    for (int ind2 = 0; ind2 < m; ++ind2) {
        while (ind1 != n and sts[ind1].first <= zpr[ind2][0]) {
            vector<string> segs;
            int ln = sts[ind1].first;
            while (ind1 != n and sts[ind1].first == ln) {
                segs.push_back(sts[ind1].second);
                ind1++;
            }
            addvals(s, amogus, invamogus, segs);
        }
        int l = zpr[ind2][1], r = zpr[ind2][0] + zpr[ind2][1];
        res[zpr[ind2][2]] = amogus.sm - amogus.get(0, l) - invamogus.get(r, s.size());
    }
    for (int i = 0; i < m; ++i) {
        cout << res[i] << ' ';
    }
    cout << '\n';
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    while (t--) solve();
    return 0;
}
/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5


4 4
abcdca
ab
ca
bcd
openolympiad
1 5
2 2
2 6
1 6
 */