#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;
typedef __int128 bint;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

bint p = 1337, mod = 1e18;

bint mul(bint a, bint b) {
    return (a * b) % mod;
}

ll add(ll a, ll b) {
    a += b;
    if (a >= mod)
        a -= mod;
    else if (a < 0)
        a += mod;
    return a;
}

const int MAXN = 1e5;
bint power[MAXN];

bool cmp(string& a, string& b) {
    return sz(a) < sz(b);
}

void solve() {
    int n, m, l, r;
    cin >> n >> m;
    string t;
    cin >> t;
    int ts = sz(t);
    vector<string> s(n);
    for (int i = 0; i < n; i++)
        cin >> s[i];
    if (n <= 5e3 && ts <= 5e3) {
        vector<bint> th(ts + 1), sh(n + 1);
        for (int i = 0; i < ts; i++) {
            th[i + 1] = add(mul(th[i], p), t[i]);
        }
        for (int i = 0; i < n; i++) {
            bint h = 0;
            for (int c : s[i]) {
                h = mul(h, p);
                h = add(h, c);
            }
            sh[i] = h;
        }
        auto get = [&th](int l, int r) {
            return add(th[r + 1], -mul(th[l], power[r - l + 1]));
        };

        vector<vector<int>> cnt(ts, vector<int>(ts)), pref(ts, vector<int>(ts+1)), dp(ts, vector<int>(ts));

        for (int r = 0; r < ts; r++) {
            for (int i = 0; i < n; i++) {
                int len = sz(s[i]);
                int l = r - len + 1;
                if (l >= 0 && get(l, r) == sh[i]) {
                    cnt[l][r]++;
                }
            }
        }
        for (int l = 0; l < ts; l++) {
            for (int i = l; i < ts; i++) {
                pref[l][i] = (i == 0 ? 0 : pref[l][i - 1]) + cnt[l][i];
            }
        }
        for (int len = 1; len <= ts; len++) {
            for (int l = 0, r = len - 1; r < ts; l++, r++) {
                dp[l][r] = (l+1 < ts ? dp[l + 1][r] : 0) + pref[l][r];
            }
        }
        while (m--) {
            cin >> l >> r;
            l--, r--;
            cout << dp[l][r] << '\n';
        }
    }
    else {
        map<int, vector<int>> bsz;
        for (int i = 0; i < n; i++) {
            bsz[sz(s[i])].push_back(i);
        }
        vector<vector<int>> pref;
        vector<int> lens;
        for (auto pr : bsz) {
            vector<int> ind = pr.Y;
            int len = pr.X;
            vector<bint> cur_h;
            for (int j : ind) {
                bint h = 0;
                for (char c : s[j]) {
                    h = mul(h, p);
                    h = add(h, c);
                }
                cur_h.push_back(h);
            }
            sort(All(cur_h));
            vector<int> cur(ts + 1);
            cur[0] = 0;

            bint h = 0;
            for (int i = 0; i < ts; i++) {
                h = mul(h, p);
                h = add(h, t[i]);
                if (i - len >= 0)
                    h = add(h, -mul(power[len], t[i - len]));
                cur[i + 1] = cur[i];
                int j = lower_bound(All(cur_h), h) - cur_h.begin();
                if (j >= 0 && j < sz(cur_h) && cur_h[j] == h)
                    cur[i + 1]++;
            }
            pref.emplace_back();
            swap(pref.back(), cur);
        }
        int sq = sz(pref);
        while (m--) {
            cin >> l >> r;
            l--, r--;
            ll ans = 0;
            for (int i = 0; i < sq; i++) {
                int len = lens[i];
                if (len > r - l + 1) break;
                int tr = r, tl = l + len - 1;
                ans += pref[i][tr + 1] - pref[i][tl];
            }
            cout << ans << '\n';
        }
    }
}

void precalc() {
    power[0] = 1;
    for (int i = 1; i < MAXN; i++)
        power[i] = mul(power[i - 1], p);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    precalc();
    solve();
}