#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

const int A = 26, K = 450;
int len = 1;
struct Node{
    int nxt[A], suf, par;
    char chr, used;
    int val[K];
};

const int T = 250010, S = 100010, null = T + S, N = null + 1;
Node a[N];
int sz = 0;

int newNode(){
    a[sz].suf = null;
    a[sz].par = null;
    for (auto &x : a[sz].nxt) x = null;
    return sz++;
}

int rt = newNode();

int add_to_bore(string s){
    int v = rt;
    for (auto c : s){
        c -= 'a';
        if (a[v].nxt[c] == null) a[v].nxt[c] = newNode(), a[a[v].nxt[c]].chr = c, a[a[v].nxt[c]].par = v;
        v = a[v].nxt[c];
    }
    return v;
}

int dist[N];
void transform_to_aho(){
    for (int i = 0; i < sz; i++) dist[i] = inf;
    dist[rt] = 0;
    vector <int> d = {rt};
    for (int i = 0; i < d.size(); i++){
        int v = d[i];
        for (auto u : a[v].nxt){
            if (u == null) continue;
            if (dist[u] == inf) {
                dist[u] = dist[v] + 1;
                d.push_back(u);
            }
        }
        if (dist[v] == 0){
            a[v].suf = null;
            for (int &x : a[v].nxt) if (x == null) x = rt;
        }
        else{
            if (dist[v] == 1) a[v].suf = rt;
            else a[v].suf = a[a[a[v].par].suf].nxt[a[v].chr];
            for (int j = 0; j < 26; j++) if (a[v].nxt[j] == null) a[v].nxt[j] = a[a[v].suf].nxt[j];
        }
    }
}

#pragma GCC optimize("avx2")
void mergearrays(int *a1, const int *a2){
    for (int i = 0; i < len; i++) a1[i] += a2[i];
}

void rec(int v){
    if (v == null || a[v].used) return;
    a[v].used = 1;
    rec(a[v].suf);
    for (int i = 0; i < len; i++) {
        mergearrays(a[v].val, a[a[v].suf].val);
    }
}

string s[S];
int c[S], got[T];

void solve(){
    int n, m;
    string t;
    cin >> n >> m >> t;
    for (int i = 0; i < n; i++) cin >> s[i], c[i] = s[i].size();
    sort(c, c + n);
    for (int i = 0; i < n; i++) if (c[i] != c[len - 1]) c[len++] = c[i];
    for (int i = 0; i < n; i++) {
        int v = add_to_bore(s[i]);
        a[v].val[lower_bound(c, c + len, s[i].size()) - c]++;
    }
    int v = add_to_bore(t);
    transform_to_aho();
    for (; v != null; v = a[v].par) rec(v);
    got[0] = rt;
    int v0 = rt, ind = 0;
    for (auto ch : t){
        ind++;
        int v1 = a[v0].nxt[ch - 'a'];
        got[ind] = v1;
        for (int i = 0; i < len; i++) a[v1].val[i] += a[v0].val[i];
        v0 = v1;
    }
    while (m--){
        int l, r;
        cin >> l >> r;
        l--;
        ll ans = 0;
        for (int i = 0; i < len; i++){
            int siz = c[i];
            if (l + siz > r) break;
            ans += a[got[r]].val[i] - a[got[l + siz - 1]].val[i];
        }
        cout << ans << " ";
    }
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}
