#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 1E6, sq = 317;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator+ (const Mod_int& m) const
	{
		return ans + m.ans;
	}
	Mod_int operator+= (const Mod_int& m)
	{
		return *this = *this + m;
	}
	Mod_int operator- (const Mod_int& m) const
	{
		return int32_t(ans) - int32_t(m.ans) + int32_t(MOD);
	}
	Mod_int operator-= (const Mod_int& m)
	{
		return *this = *this - m;
	}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step(uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
	bool operator== (const Mod_int& m) const
	{
		return ans == m.ans;
	}
};

Mod_int hash_pr[5 * MAXN + 1], step[MAXN + 1];

Mod_int get_hash(int l, int sz)
{
	return hash_pr[l + sz] - hash_pr[l] * step[sz];
}

unordered_set <uint64_t> mp;
vector <int> pref[MAXN + 1];

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	step[0] = 1;
	for (int i = 0; i < MAXN; i++)
	{
		step[i + 1] = step[i] * 269;
	}

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	for (int i = 0; i < s.size(); i++)
	{
		hash_pr[i + 1] = hash_pr[i] * 269 + s[i];
	}

	vector <int> sz;
	for (int i = 0; i < n; i++)
	{
		Mod_int h = 0;
		string p;
		cin >> p;
		for (int i = 0; i < p.size(); i++)
		{
			h *= 269;
			h += p[i];
		}
		mp.insert(h.ans);
		sz.push_back(p.size());
	}
	sort(ALL(sz));
	sz.resize(unique(ALL(sz)) - sz.begin());

	for (int i = 0; i < sz.size(); i++)
	{
		pref[sz[i]].resize(s.size() + 1);
		for (int j = 0; j < int(s.size()) - sz[i] + 1; j++)
		{
			pref[sz[i]][j + 1] = pref[sz[i]][j];
			Mod_int h = get_hash(j, sz[i]);
			if (mp.count(h.ans))
			{
				pref[sz[i]][j + 1]++;
			}
		}
	}

	for (int z = 0; z < m; z++)
	{
		int l, r;
		cin >> l >> r;
		--l;
		--r;
		int64_t ans = 0;
		for (int i = 0; i < sz.size(); i++)
		{
			if (r - sz[i] + 2 >= l)
			{
				ans += pref[sz[i]][r - sz[i] + 2] - pref[sz[i]][l];
			}
		}
		cout << ans << ' ';
	}
}