#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pp;

const ll mod = 1e9 + 7, base = 31;
const ll maxn = 1e5;
ll powr[maxn];


void powr_precount() {
    powr[0] = 1;
    for (ll i = 1; i < maxn; i++) {
        powr[i] = powr[i - 1] * base % mod;
    }
}

ll get_code(char x) {
    return x - 'a' + 1;
}

ll count_hash(string &s) {
    ll ans = 0;
    for (ll j = 0; j < s.size(); j++) {
        ans += get_code(s[j]) * powr[j] % mod;
        ans %= mod;
    }
    return ans * powr[maxn - 1] % mod;
}

signed main() {
    powr_precount();
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    set<ll>choice;
    for (int i = 0; i < n; i++){
        cin >> s[i];
        choice.insert(count_hash(s[i]));
    }
    int T = t.size();
    vector<ll>t_hashes(T);
    t_hashes[0] = get_code(t[0]);
    for (int i = 1; i < T; i++){
        t_hashes[i] = t_hashes[i - 1];
        t_hashes[i] += get_code(t[i]) * powr[i] % mod;
        t_hashes[i] %= mod;
    }
    while (m--){
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        ll ans = 0;
        for (int a = l; a <= r; a++){
            for (int b = a; b <= r; b++){
                ll curr_hs = (t_hashes[b] - (a > 0 ? t_hashes[a - 1] : 0)) * powr[maxn - 1 - a] % mod;
                if (choice.find(curr_hs) != choice.end()){
                    ans++;
                }
            }
        }
        cout << ans << ' ';
    }
}