#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const ll MOD = 10000000000000061;

/// actual code starts here

constexpr int N = 5e6 + 5;


struct node {
    array<int, 26> to;
    int suf, super_suf;
    int term;

    node() {
        for (int j = 0; j < 26; j++)
            to[j] = -1;
        suf = 0, super_suf = 0;
        term = 0;
    }
};

vector<node> tr;
int en_len[N];

void add(string &s) {
    int v = 0;
    for (auto i: s) {
        int sym = i - 'a';
        if (tr[v].to[sym] == -1) {
            tr[v].to[sym] = tr.size();
            tr.pb(node());
        }
        v = tr[v].to[sym];
    }
    en_len[v] = s.size();
    tr[v].term = 1;
}

void build() {
    queue<int> q;
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        for (int j = 0; j < 26; j++) {
            if (tr[v].to[j] == -1) {
                if (v == 0) {
                    tr[v].to[j] = 0;
                    tr[v].suf = 0;
                } else {
                    tr[v].to[j] = tr[tr[v].suf].to[j];
                }
            } else {
                if (v == 0) {
                    tr[tr[v].to[j]].suf = 0;
                } else {
                    tr[tr[v].to[j]].suf = tr[tr[v].suf].to[j];
                }
                if (tr[tr[tr[v].to[j]].suf].term) {
                    tr[tr[v].to[j]].super_suf = tr[tr[v].to[j]].suf;
                } else {
                    tr[tr[v].to[j]].super_suf = tr[tr[tr[v].to[j]].suf].super_suf;
                }
                q.push({tr[v].to[j]});
            }
        }
    }
}

constexpr int K = 2048, K2 = 2047;
int p[N], botva[N];

string t;
vector<pair<int, int>> ask[N];

int get(int l, int r) {
    int res = 0;
    while (l <= r) {
        if ((l & K2) == 0) {
            res += botva[l >> 11];
            l += K;
        }
        else {
            res += p[l++];
        }
    }
    return res;
}

void solve() {
    tr.pb(node());
    int n, m;
    cin >> n >> m >> t;
    vector<int> lens;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        add(s);
    }
    build();
    vector<ll> res(m);
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        ask[r].pb({l, i});
    }
    int v = 0;
    for (int i = 0; i < (int) t.size(); i++) {
        v = tr[v].to[t[i] - 'a'];
        int v2 = v;
        while (v2 != 0) {
            if (tr[v2].term) {
                int l = i - en_len[v2] + 1;
                botva[l >> 11]++;
                p[l]++;
            }
            v2 = tr[v2].super_suf;
        }
        for (auto [l, id]: ask[i]) {
            res[id] = get(l, i);
        }
    }
    for (int i = 0; i < m; i++)
        cout << res[i] << ' ';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}