#include <bits/stdc++.h>

#pragma optimize("inline, avx2, Ofast");
using namespace std;

struct Point {
    int x, y;

    Point(int x, int y) {
        this->x = x;
        this->y = y;
    }

    friend int operator%(Point a, Point b) {
        return a.x * b.y - a.y * b.x;
    }

    friend int operator*(Point a, Point b) {
        return a.x * b.x + a.y * b.y;
    }

    friend Point operator+(Point a, Point b) {
        return {a.x + b.x, a.y + b.y};
    }

    friend Point operator-(Point a, Point b) {
        return {a.x - b.x, a.y - b.y};
    }

    long long len_sq(Point a) {
        return a.x * a.x + a.y * a.y;
    }

    double len(Point a) {
        return sqrt(len_sq(a));
    }

    long long dist_sq(Point a, Point b) {
        return (a.x - b.x) * (a.x - b.x) + (a.y - b.y) * (a.y - b.y);
    }

    double dist(Point a, Point b) {
        return sqrt(dist_sq(a, b));
    }

    bool check_collinear(Point a, Point b) {
        if (abs(double(a.x) / double(b.x) - double(a.y) / double(b.y)) < 1e-8) {
            return true;
        }
        return false;
    }

};

bool comp_points(Point a, Point b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
}

void obol(vector<Point> arr) {
    int min_x = -1e9;
    Point min(1e9, 1e9);
    queue<Point> q;
    sort(arr.begin(), arr.end(), comp_points);
    q.push(arr[0]);
    q.push(arr[1]);
    int i = 2;
}

vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

long long mod = 1e9 + 7;

long long mod_pr(long long a, long long b) {
    return ((a % mod) * (b % mod)) % mod;
}

long long sum_mod(long long a, long long b) {
    return ((a % mod) + (b % mod)) % mod;
}

long long minus_mod(long long a, long long b) {
    return (((a % mod) - (b % mod)) % mod + mod) % mod;
}

void solve() {
    int n, m;
    cin >> n >> m;
    int k = 29;
    string t;
    cin >> t;
    vector<long long> hash(t.size() + 1, 0);
    vector<long long> p(t.size() + 1, 1);
    for (int i = 0; i < t.size(); i++) {
        hash[i + 1] = sum_mod(mod_pr(hash[i], k), (long long) (t[i] - 'a'));
        p[i + 1] = mod_pr(p[i], k);
    }
    vector<long long> hashes(n);
    vector<vector<int>> poses_l(n);
    vector<string> strings(n);
    for (int i = 0; i < n; i++) {
        string x;
        cin >> x;
        strings[i] = x;
        long long hash_temp = 0;
        for (int j = 0; j < x.size(); j++) {
            hash_temp = sum_mod(mod_pr(hash_temp, k), (long long) (x[j] - 'a'));
        }
        hashes[i] = hash_temp;
        for (int j = 1; j <= (int) t.size() - (int) x.size() + 1; j++) {
            long long hash_pod = hash[j + x.size() - 1] - hash[j - 1] * p[x.size()];
            if (hash_pod == hash_temp) {
                poses_l[i].push_back(j);
            }
        }
    }
    /*for (int i = 0; i < n; i++){
        for (auto u : poses_l[i]){
            cout << u << " ";
        }
        cout << endl;
    }*/
    for (int i = 0; i < m; i++) {
        int ql, qr;
        cin >> ql >> qr;
        int counter = 0;
        for (int j = 0; j < n; j++) {
            auto first = lower_bound(poses_l[j].begin(), poses_l[j].end(), ql);
            auto second = lower_bound(poses_l[j].begin(), poses_l[j].end(), qr - strings[j].size() + 1);
            if (first == poses_l[j].end()) {
                continue;
            }
            if (second != poses_l[j].end()) {
                if (*second != qr - strings[j].size() + 1) {
                    second = prev(second);
                }
            } else {
                second = prev(second);
            }
            if (*second < *first) {
                continue;
            }
            counter += int(second - first) + 1;
        }
        cout << counter << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    t = 1;
    solve();
    return 0;
}
