#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

const int MOD1 = 1e9 + 7;
const int MOD2 = 998244353;
const int P1 = 832, P2 = 203;
#ifdef LOCAL
constexpr int N = 100;
#else
constexpr int N = 5e5 + 10;
#endif

int pw1[N], pw2[N], ipw1[N], ipw2[N];

inline int binpow1(int a, int n) {
	int res = 1;
	while (n) {
		if (n & 1)
			res = ((ll)res * a) % MOD1;
		a = ((ll)a * a) % MOD1;
		n >>= 1;
	}
	return res;
}
inline int binpow2(int a, int n) {
	int res = 1;
	while (n) {
		if (n & 1)
			res = ((ll)res * a) % MOD2;
		a = ((ll)a * a) % MOD2;
		n >>= 1;
	}
	return res;
}

struct segtree {
	int size;
	vector<vector<int>> t;
	segtree(vector<vector<int>>& numbers) {
		size = 1;
		while (size < sz(numbers))
			size *= 2;
		t.resize(2 * size);
		build(numbers, 1, 0, size);
	}

	void build(vector<vector<int>>& a, int x, int lx, int rx) {
		if (rx - lx == 1) {
			if (lx < sz(a))
				t[x] = a[lx];
			sort(all(t[x]));
			return;
		}

		int mx = (lx + rx) / 2;
		build(a, 2 * x, lx, mx);
		build(a, 2 * x + 1, mx, rx);
		merge(all(t[2 * x]), all(t[2 * x + 1]), back_inserter(t[x]));
	}

	int get(int l, int r, int max_val, int x, int lx, int rx) {
		if (l >= rx || r <= lx) {
			return 0;
		}
		if (l <= lx && rx <= r) {
			int cnt = upper_bound(all(t[x]), max_val) - t[x].begin();
			return cnt;
		}

		int mx = (lx + rx) / 2;
		return get(l, r, max_val, 2 * x, lx, mx) +
			get(l, r, max_val, 2 * x + 1, mx, rx);
	}
	int get(int l, int r, int max_val) {
		return get(l, r, max_val, 1, 0, size);
	}
};

void solve_case() {
	pw1[0] = pw2[0] = 1;
	for (int i = 1; i < N; i++) {
		pw1[i] = ((ll)pw1[i - 1] * P1) % MOD1;
		pw2[i] = ((ll)pw2[i - 1] * P2) % MOD2;
	}

	ipw1[N - 1] = binpow1(pw1[N - 1], MOD1 - 2);
	ipw2[N - 1] = binpow2(pw2[N - 1], MOD2 - 2);

	for (int i = N - 2; i > 0; i--) {
		ipw1[i] = ((ll)P1 * (ll)ipw1[i + 1]) % MOD1;
		ipw2[i] = ((ll)P2 * (ll)ipw2[i + 1]) % MOD2;
	}
	ipw1[0] = ipw2[0] = 1;
	
	int n, m; cin >> n >> m;
	string s; cin >> s;
	vector<vector<pair<int, int>>> strings(sz(s) + 1);

	for (int i = 0; i < n; i++) {
		string t; cin >> t;
		if (sz(t) > sz(s)) continue;
		pair<int, int> h = { 0, 0 };
		for (int j = 0; j < sz(t); j++) {
			h.first = (h.first + ((ll)pw1[j] * t[j])) % MOD1;
			h.second = (h.second + ((ll)pw2[j] * t[j])) % MOD2;
		}

		strings[sz(t)].push_back(h);
	}

	vector<int> h1(sz(s) + 1, 0), h2(sz(s) + 1, 0);
	for (int i = 0; i < sz(s); i++) {
		h1[i + 1] = (h1[i] + ((ll)pw1[i] * s[i])) % MOD1;
		h2[i + 1] = (h2[i] + ((ll)pw2[i] * s[i])) % MOD2;
	}

	vector<vector<int>> numbers(sz(s));
	for (int len = 1; len <= sz(s); len++) {
		auto& hashes = strings[len];
		if (hashes.empty())
			continue;

		map<pair<int, int>, int> have;
		for (auto x : hashes)
			have[x] = 1;

		for (int i = 0; i + len <= sz(s); i++) {
			int r = i + len - 1;
			pair<int, int> h = { 
				((((h1[r + 1] - h1[i]) % MOD1 + MOD1) % MOD1) * (ll)ipw1[i]) % MOD1,
				((((h2[r + 1] - h2[i]) % MOD2 + MOD2) % MOD2) * (ll)ipw2[i]) % MOD2
			};

			if (have[h]) {
				numbers[i].push_back(r);
			}
		}
	}

	segtree st(numbers);
	for (int i = 0; i < m; i++) {
		int l, r; cin >> l >> r;
		l--; r--;

		int res = st.get(l, r + 1, r);
		cout << res << " ";
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	//cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
