#pragma GCC target ("sse4")
#pragma GCC target ("avx2")
#pragma GCC optimization ("O3")
#pragma GCC optimization ("unroll-loops")
#include<bits/stdc++.h>
#define pb push_back
#define lsb(x) x&(-x)
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

struct Aho_Corasick{
	struct Node{
		int children[26] = {0};
		vector<int> v;
		int fail = 0, par = 0, ok = 0, dep = 0;
		char alpha;
		bool eow = false;
		Node() {}
	};
	vector<Node> trie;
	Aho_Corasick(){
		trie.pb(Node());
	}
	void insert(string &t){
		int curr = 0;
		for(auto x : t){
			if(!trie[curr].children[x - 'a']){
				trie[curr].children[x - 'a'] = trie.size();
				trie.pb(Node());
				trie.back().par = curr;
				trie.back().alpha = x;
				trie.back().dep = trie[curr].dep + 1;
			}
			curr = trie[curr].children[x - 'a'];
		}
		trie[curr].eow = true;
	}
	void build(){
		queue<int> q;
		for(int z = 0; z < 26; z ++){
			if(trie[0].children[z]){
				q.push(trie[0].children[z]);
			}
		}
		while(!q.empty()){
			int u = q.front(), p = trie[u].par; q.pop();
			for(int z = 0; z < 26; z ++) if(trie[u].children[z]){
				q.push(trie[u].children[z]);
			}
			int ptr = p, cont = trie[u].alpha - 'a';
			while(ptr && !trie[trie[ptr].fail].children[cont]){
				ptr = trie[ptr].fail;
			}
			if(trie[trie[ptr].fail].children[cont] != u){
				trie[u].fail = trie[trie[ptr].fail].children[cont];
			}
			else trie[u].fail = 0;
			if(trie[trie[u].fail].eow) trie[u].ok = trie[u].fail;
			else trie[u].ok = trie[trie[u].fail].ok;
		}
	}
	int node = 0;
	int run(char x){
		while(node && !trie[node].children[x - 'a']){
			node = trie[node].fail;
		}
		if(trie[node].children[x - 'a']){
			node = trie[node].children[x - 'a'];
		}
		vector<int> ret;
		if(trie[node].v.empty()){
			if(trie[node].eow){
				trie[node].v.pb(trie[node].dep);
			}
			int temp = node;
			while(temp){
				temp = trie[temp].ok;
				if(trie[temp].eow){
					trie[node].v.pb(trie[temp].dep);
				}
			}
		}
		return node;
	}
} patterns;

const int MAXN = 750006;

int N, M, A[MAXN], BIT[MAXN], ans[MAXN];
vector<pair<int, int>> queries[MAXN];
string T;

void upd(int x, int v){
	for(++ x; x < MAXN; x += lsb(x)){
		BIT[x] += v;
	}
}

int qry(int x){
	int ret = 0;
	for(++ x; x > 0; x -= lsb(x)){
		ret += BIT[x];
	}
	return ret;
}

int qry(int l, int r){
	return qry(r) - qry(l - 1);
}

int main(){
	ios_base::sync_with_stdio(NULL);
	cin.tie();
	cout.tie();
	cin >> N >> M >> T;
	for(int i = 0; i < N; i ++){
		string t; cin >> t;
		patterns.insert(t);
	}
	patterns.build();
	for(int i = 0; i < M; i ++){
		int l, r; cin >> l >> r;
		queries[r].pb({l, i});
	}
	for(int r = 1; r <= T.size(); r ++){
		char x = T[r - 1];
		for(auto len : patterns.trie[patterns.run(x)].v){
			int l = r - len + 1;
			upd(l, 1);
		}
		for(auto [l, i] : queries[r]){
			ans[i] = qry(l, r);
		}
	}
	for(int i = 0; i < M; i ++){
		cout << ans[i] << " ";
	}
	cout << endl;
}
/**
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
*/