#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

struct edge {
    int to, w;
};
vector<vector<edge>> gr;

vector<vector<ll>> dists;
const vector<int> def(26, -1);

struct koras {
    int car = 0;
    struct node {
        vector<int> go = def;
        int suf = -1;
        bool term = false;
    };
    vector<node> had;

    koras(int x) {
        had.push_back({def, 0});
    }

    void add(string a) {
        int cur = 0;
        for (auto el: a) {
            if (had[cur].go[el - 'a'] == -1) {
                had[cur].go[el - 'a'] = had.size();
                had.push_back({def, -1});
            }
            cur = had[cur].go[el - 'a'];
        }
        had[cur].term = true;
    }

    void build() {
        queue<ll> ww;
        ww.push(0);
        while (!ww.empty()) {
            int v = ww.front();
            ww.pop();
            if (v == 0) {
                for (int i = 0; i < 26; i++) {
                    if (had[v].go[i] == -1) {
                        had[v].go[i] = 0;
                    } else {
                        had[had[v].go[i]].suf = 0;
                        ww.push(had[v].go[i]);
                    }
                }
            } else {
                for (int i = 0; i < 26; i++) {
                    if (had[v].go[i] == -1) {
                        had[v].go[i] = had[had[v].suf].go[i];
                    } else {
                        had[had[v].go[i]].suf = had[had[v].suf].go[i];
                        ww.push(had[v].go[i]);
                    }
                }
            }
        }
    }

    ll move(char x){
        car = had[car].go[x - 'a'];
        int aba = car;
        ll ans = 0;
        while (had[aba].suf != aba){
            ans += had[aba].term;
            aba = had[aba].suf;
        }
        return ans;
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    koras mach(0);
    string t;
    cin >> t;
    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        mach.add(s);
    }
    mach.build();
    for (int d = 0; d < m; d++){
        mach.car = 0;
        int l,r;
        cin >> l >> r;
        l--;
        ll ans= 0;
        for (int i = l; i < r; i++){
            ans += mach.move(t[i]);
        }
        cout << ans << " ";
    }

}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
