#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;

struct Query{
    int l, r, i;
};

string t;
vector<Query> q;
vector<string> s;
vector<int> f[2];

void inc(int pos, int who){
    for(; pos < sz(t); pos |= pos + 1)
        f[who][pos] ++;
}

int sum(int pos, int who){
    int ans = 0;
    for(; pos >= 0; pos = (pos & (pos + 1)) - 1)
        ans += f[who][pos];
    return ans;
}


main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    s.resize(n);
    q.resize(m);
    cin >> t;
    f[0].resize(sz(t));
    f[1].resize(sz(t));
    for(int i = 0; i < n; i ++)
        cin >> s[i];
    for(int i = 0; i < m; i ++){
        cin >> q[i].l >> q[i].r;
        q[i].l --; q[i].r --;
        q[i].i = i;
    }

//    cout << "Here\n";


    for(int j = 0; j < n; j ++){
        string now = s[j] + "." + t;
        vector<int> p(sz(now));
        for(int i = 1; i < sz(now); i ++){
            int prev = p[i - 1];
            while(prev > 0 && now[prev] != now[i])
                prev = p[prev - 1];
            if (now[i] == now[prev])
                p[i] = prev + 1;
        }

        for(int i = sz(s[j]) + 1; i < sz(now); i ++)
            if (p[i] == sz(s[j])){
                int pos = i - sz(s[j]) - 1;
//                cout << j << ' ' << pos - sz(s[j]) + 1 << ' ' << pos << '\n';
                inc(pos - sz(s[j]) + 1, 0);
                inc(pos, 1);
            }
    }

//    cout << "Here";

    for(int i = 0; i < m; i ++){
        int l = q[i].l, r = q[i].r;
        int ans = sum(r, 1) - (l > 0 ? sum(l - 1, 0) : 0);
        cout << ans << ' ';
    }

}

/*

*/
