#include <iostream>
#include <vector>
#include <set>
#include <cstring>

using namespace std;
using ll = long long;

const ll MAX_N = 5e6 + 100;

string src;
vector<ll> ins[MAX_N];
vector<pair<ll, ll>> ls[MAX_N];
ll tree[MAX_N];

void calcIns(const string &target) {
    if (target.length() > src.length()) {
        return;
    }

    string all = target + '#' + src;
    ll n = ll(src.length());
    ll m = ll(target.length());
    ll NM = n + m + 1;
    vector<ll> pref(NM);
    for (ll i = 1; i < NM; ++i) {
        ll p = i;
        while (p && all[pref[p - 1]] != all[i]) {
            p = pref[p - 1];
        }

        if (p) {
            pref[i] = pref[p - 1] + 1;
        }

        if (pref[i] == m) {
            ll finish = i - m - 1;
            ll start = finish - m + 1;
            ins[start].push_back(finish);
        }
    }
}

void inc(ll r) {
    while (r < MAX_N) {
        ++tree[r];
        r |= r + 1;
    }
}

ll getSum(ll r) {
    ll res = 0;
    while (r >= 0) {
        res += tree[r];
        r = (r & (r + 1)) - 1;
    }
    return res;
}

void resolve() {
    ll n, q;
    cin >> n >> q;
    cin >> src;
    for (ll i = 0; i < n; ++i) {
        string target;
        cin >> target;
        calcIns(target);
    }

    for (ll tst = 0; tst < q; ++tst) {
        ll l, r;
        cin >> l >> r;
        --l;
        --r;
        ls[l].emplace_back(r, tst);
    }

    vector<ll> res(q);
    for (ll i = ll(src.length()) - 1; i >= 0; --i) {
        for (const auto &R: ins[i]) {
            inc(R);
        }

        for (const auto &item: ls[i]) {
            res[item.second] += getSum(item.first);
        }
    }

    for (const auto &item: res) {
        cout << item << ' ';
    }
    cout << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    memset(tree, 0, sizeof(tree));
    resolve();
    return 0;
}
