#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) (a.size())

#define line cout<<'\n'

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 2e5 + 100;

vector <int> f(vector <int> a, vector<int> b) {
    vector <int> res;
    int l = 0, r = 0;

    while (l < sz(a) && r < sz(b)) {
        if (a[l] < b[r]) res.emplace_back(a[l++]);
        else res.emplace_back(b[r++]);
    }
    while (l < sz(a)) res.emplace_back(a[l++]);
    while (r < sz(b)) res.emplace_back(b[r++]);
    return res;
}

struct HASH {
    vector <int> h1, h2, pw1, pw2;
    int cpow1, cpow2, mod1, mod2;
    HASH (string &s, int &B1, int &M1, int &B2, int &M2) {
        cpow1 = B1;
        cpow2 = B2;
        mod1 = M1;
        mod2 = M2;

        int n = sz(s);
        h1.assign(n + 1, 0);
        h2.assign(n + 1, 0);
        pw1.assign(n + 1, 1);
        pw2.assign(n + 1, 1);

        for (int i = 1; i <= n; i++) {
            pw1[i] = pw1[i - 1] * cpow1 % mod1;
            pw2[i] = pw2[i - 1] * cpow2 % mod2;
        }

        for (int i = 1; i <= n; i++) {
            h1[i] = (h1[i - 1] * cpow1 + s[i - 1] - 'A') % mod1;
            h2[i] = (h2[i - 1] * cpow2 + s[i - 1] - 'A') % mod2;
        }
    }

    pair<int, int> get(int l, int r) {
        int H1 = ((h1[r] - h1[l - 1] * pw1[r - l + 1]) % mod1 + mod1) % mod1;
        int H2 = ((h2[r] - h2[l - 1] * pw2[r - l + 1]) % mod2 + mod2) % mod2;
        return {H1, H2};
    }
};

void solve() {
    int n, q;
    cin >> n >> q;
    set<pair<int, int>> st;
    string s;
    cin >> s;

    int MOD1 = 1e9 + 7, MOD2 = 1e9 + 123, B1 = 137, B2 = 31;
    HASH hs(s, B1, MOD1, B2, MOD2);

    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        HASH y(t, B1, MOD1, B2, MOD2);
        st.insert(y.get(1, sz(t)));
    }

    vector <vector <int>> pref(sz(s) + 1);
    for (int i = 0; i < sz(s); i++) {
        for (int j = 0; j <= i; j++) {
            auto H = hs.get(j + 1, i + 1);
            if (st.find(H) != st.end()) {
                pref[i + 1].push_back(j + 1);
            }
        }
    }
    for (int i = 2; i <= sz(s); i++) {
        pref[i] = f(pref[i - 1], pref[i]);
    }

    while (q--) {
        int l, r, res;
        cin >> l >> r;
        res = sz(pref[r]) - (lower_bound(all(pref[r]), l) - pref[r].begin());
        cout << res << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}