#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

//#define int long long

void solve() {
	int n, m; cin >> n >> m;
	string s; cin >> s;

	int64 p0 = 257;
	const int64 MOD = 1e9 + 7;
	vector <int64> pw(s.size() + 1, 1);
	for (int i = 1; i < pw.size(); ++i) {
		pw[i] = pw[i - 1] * p0 % MOD;
	}

	vector <int64> hs(s.size() + 1, 0);
	for (int i = 1; i < hs.size(); ++i) {
		hs[i] = (hs[i - 1] * p0 + s[i - 1]) % MOD;
	}

	auto getHs = [&](int l, int r) {
		return (hs[r] - hs[l] * pw[r - l] % MOD + MOD) % MOD;
	};


	unordered_set <int64> st;
	vector <int> ln(n);
	for (int i = 0; i < n; ++i) {
		string t; cin >> t;
		ln[i] = t.size();
		int64 chs = 0;
		for (int i = 0; i < t.size(); ++i) {
			chs = (chs * p0 + t[i]) % MOD;
		}
		st.insert(chs);
	}

	vector <int> big = ln;
	sort(all(big));
	big.resize(unique(all(big)) - big.begin());

	vector <vector <int>> iln(big.size(), vector <int>(s.size() + 1));
	for (int i = 0; i < big.size(); ++i) {
		for (int j = 0; j + big[i] <= s.size(); ++j) {
			iln[i][j + 1] = st.count(getHs(j, j + big[i]));
		}
	}
	for (auto& vec : iln) {
		for (int i = 1; i < vec.size(); ++i) {
			vec[i] += vec[i - 1];
		}
	}

	while (m--) {
		int l, r; cin >> l >> r;
		--l;
		int ans = 0;
		for (int i = 0; i < big.size(); ++i) {
			if (r - big[i] + 1 <= l) break;
			ans += iln[i][r - big[i] + 1] - iln[i][l];
		}

		cout << ans << '\n';
	}
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}