#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

//#define int long long

void solve() {
	int n, m; cin >> n >> m;
	string s; cin >> s;

	int64 p0 = 257;
	const int64 MOD = 1e9 + 7;
	int64* pw = new int64[s.size() + 1]; pw[0] = 1;
	for (int i = 1; i < s.size() + 1; ++i) {
		pw[i] = pw[i - 1] * p0 % MOD;
	}

	int64* hs = new int64[s.size() + 1]; hs[0] = 0;
	for (int i = 1; i < s.size() + 1; ++i) {
		hs[i] = (hs[i - 1] * p0 + s[i - 1]) % MOD;
	}

	auto getHs = [&](int l, int r) {
		int64 a = hs[r], b = hs[l] * pw[r - l] % MOD;
		if (a >= b) return a - b;
		return a - b + MOD;
	};


	vector <bool> st(MOD, false);// memset(st, 0, sizeof(st));
	vector <int> ln(n);
	vector <int64> shs(n);
	for (int i = 0; i < n; ++i) {
		string t; cin >> t;
		ln[i] = t.size();
		int64 chs = 0;
		for (int i = 0; i < t.size(); ++i) {
			chs = (chs * p0 + t[i]) % MOD;
		}
		shs[i] = chs;
	}
	vector <int> ln0 = ln;
	sort(all(ln));
	ln.resize(unique(all(ln)) - ln.begin());
	vector <vector <int64>> lhs(ln.size());
	for (int i = 0; i < n; ++i) {
		int p = lower_bound(all(ln), ln0[i]) - ln.begin();
		lhs[p].push_back(shs[i]);
	}

	vector <tuple <int, int, int>> qs;
	vector <int> aans(m, 0);
	for (int i = 0; i < m; ++i) {
		int l, r; cin >> l >> r;
		--l;
		qs.push_back({ l, r, i });
	}

	int* iln = new int[s.size() + 1];
	for (int i = 0; i < ln.size(); ++i) {
		for (auto h : lhs[i]) {
			st[h] = true;
		}

		memset(iln, 0, 4 * (s.size() + 1));
		for (int j = 0; j + ln[i] <= s.size(); ++j) {
			iln[j + 1] = st[getHs(j, j + ln[i])];
		}
		for (int j = 1; j < s.size() + 1; ++j) {
			iln[j] += iln[j - 1];
		}

		for (auto& [l, r, ind] : qs) {
			if (r - l >= ln[i]) {
				aans[ind] += iln[r - ln[i] + 1] - iln[l];
			}
		}

		for (auto h : lhs[i]) {
			st[h] = false;
		}
	}

	for (auto x : aans) {
		cout << x << ' ';
	}
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}