#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll MOD = 1791791791, K = 31;
const int MAXL = 5e5 + 1;

vector<ll> pws;

ll get_hash(int l, int r, vector<ll> &hsh) {
    if (l > r) return 0;
    return (hsh[r + 1] - (hsh[l] * pws[r - l + 1]) % MOD + MOD) % MOD;
}

int sumr(int x1, int y1, int x2, int y2, vector<vector<int>> &pref) {
    return pref[x2 + 1][y2 + 1] - pref[x2 + 1][y1] - pref[x1][y2 + 1] + pref[x1][y1];
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int n, m; cin >> n >> m;
    string t; cin >> t;
    int l = t.size();
    vector<ll> ht(l + 1, 0);
    for (int i = 1; i <= l; ++i) {
        ht[i] = ((ht[i - 1] * K) % MOD + (t[i - 1] - 'a' + 1)) % MOD;
    }
    pws.resize(MAXL, 1);
    for (int i = 1; i <= MAXL; ++i) {
        pws[i] = (pws[i - 1] * K) % MOD;
    }
    vector<vector<int>> good(l, vector<int>(l, 0));
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        ll h = 0;
        for (auto c: s) {
            h = ((h * K) % MOD + (c - 'a' + 1)) % MOD;
        }
        for (int j = 0; j + s.size() <= l; ++j) {
            ll h1 = get_hash(j, j + s.size() - 1, ht);
            if (h1 == h) {
                good[j][j + s.size() - 1] = 1;
            }
        }
    }
    vector<vector<int>> pref(l + 1, vector<int>(l + 1, 0));
    for (int i = 1; i <= l; ++i) {
        for (int j = 1; j <= l; ++j) {
            pref[i][j] = pref[i][j - 1] + pref[i - 1][j] - pref[i - 1][j - 1];
            pref[i][j] += good[i - 1][j - 1];
        }
    }
    while (m--) {
        int lf, rg; cin >> lf >> rg;
        lf--; rg--;
        cout << sumr(lf, lf, rg, rg, pref) << ' ';
    }
}