#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }

const int p = 1e6 + 9;
const int mod = 1e9 + 7;
const int N = 1e5 + 10;
inline int add (int a, int b) { a += b; if (a >= mod) a -= mod; return a; }
inline int mul (int a, int b) { return (a * 1ll * b) % mod; }
inline int sub (int a, int b) { a -= b; if (a < 0) a += mod; return a; }
inline int binpow (int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        b >>= 1; a = mul(a, a);
    }
    return res;
}

int pw[N], inv[N];

inline void solve () {
    int n, q; cin >> n >> q;

    string s; cin >> s;
    vector <int> h (sz(s));
    for (int i = 0; i < sz(s); ++i) {
        h[i] = mul(s[i] - 'a' + 1, pw[i]);
        if (i) h[i] = add(h[i], h[i - 1]);
    }

    auto get = [&] (int l, int r) {
        int res = sub(h[r], (l ? h[l - 1] : 0));
        res = mul(res, inv[l]);
        return res;
    };

    vector <int> hs (n), le (n);
    for (int i = 0; i < n; ++i) {
        string t; cin >> t;
        int hh = 0;
        for (int j = 0; j < sz(t); ++j) {
            hh = add(hh, mul(t[j] - 'a' + 1, pw[j]));
        }
        hs[i] = hh; le[i] = sz(t);
    }

    while (q--) {
        int l, r; cin >> l >> r; --l; --r;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = l; j + le[i] - 1 <= r; ++j) {
                if (hs[i] == get(j, j + le[i] - 1)) ++ans;
            }
        }
        cout << ans << " ";
    }
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL

    pw[0] = inv[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = mul(pw[i - 1], p);
        inv[i] = binpow(pw[i], mod - 2);
    }

    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
