#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define fast ios::sync_with_stdio(false);cin.tie(0);

struct SegT {
    vector<int> tree;

    void init(int n) {
        tree.resize(4 * n);
    }

    void upd(int i, int l, int r, int qi, int x) {
        if (!(l <= qi && qi < r)) {
            return;
        }
        if (l + 1 == r) {
            tree[i] += x;
            return;
        }
        int m = (r + l) / 2;
        upd(2 * i + 1, l, m, qi, x);
        upd(2 * i + 2, m, r, qi, x);
        tree[i] = tree[2 * i + 1] + tree[2 * i + 2];
    }

    int get(int i, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr) {
            return 0;
        }
        if (ql <= l && r <= qr) {
            return tree[i];
        }
        int m = (r + l) / 2;
        return get(2 * i + 1, l, m, ql, qr) + get(2 * i + 2, m, r, ql, qr);
    }

};

struct Hash {
    string s;

    vector<ll> h, powers;

    int MOD, p;


    int add(int a, int b) {
        if (a + b >= MOD) {
            return a + b - MOD;
        }
        return a + b;
    }

    int mult(int a, int b) {
        return (1ll * a * b) % MOD;
    }

    int diff(int a, int b) {
        if (a - b >= 0)
            return a-b;
        return a-b + MOD;
    }

    Hash (string _s, int _MOD, int _p) {
        MOD = _MOD;
        p = _p;
        s = _s;
        int n = s.size();
        h.resize(n);
        powers.resize(n);
        build();
    }

    void build() {
        int n = s.size();
        h[0] = s[0];
        powers[0] = 1;
        for (int i = 1; i < n; i++) {
            powers[i] = (powers[i - 1] * p) % MOD;
            h[i] = add(mult(h[i - 1], p), s[i]);
        }

    }

    int get(int l, int r) {
        if (l == 0)
            return h[r];
        return diff(h[r], mult(h[l-1], powers[r - l + 1]));
    }
};



ll hs(pair<ll, ll> ax) {
    return (ax.first << 30) + ax.second;
}

signed main() {
    fast;
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    map<pair<int, int>, int> bx;
    vector<int> lens;
    Hash hr(s, 1e9 + 7, 251);
    Hash hr1(s, 1e9 + 9, 251);
    vector<pair<int, int>> otr;
    map<ll, int> mp;
    //mp.reserve(1e6);
    for (int i = 0; i < n; i++) {
        string t;
        cin >> t;
        lens.push_back(t.size());
        auto d = Hash(t, 1e9 + 7, 251).h.back();
        auto d1 = Hash(t, 1e9 + 9, 251).h.back();
        mp[hs({d, d1})]++;
    }
    sort(lens.begin(), lens.end());
    lens.erase(unique(lens.begin(), lens.end()), lens.end());
     n = s.size();
    vector<vector<pair<int, int>>> events(n + 1);
    for (int sz : lens) {
        for (int j = 0; j + sz - 1 < s.size(); j++) {
            if (mp.find(hs({hr.get(j, j + sz - 1), hr1.get(j, j + sz - 1)})) != mp.end()) {
                events[j + sz - 1].emplace_back(j, 1);
            }
        }
    }
    vector<vector<pair<int, int>>> req(n);
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;r--;
        req[r].push_back({l, i});
    }

    SegT tr;
    tr.init(n);
    vector<int> ans(m);
    for (int i = 0; i < n; i++) {
        for (auto [idx, t] : events[i]) {
            tr.upd(0, 0, n, idx, t);
        }
        for (auto [l ,idx] : req[i]) {
            ans[idx] = tr.get(0, 0, n, l, n);
        }
    }
    for (auto i : ans) cout << i << ' ';
}