#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 5000 + 10;
const llong INF = 1e18;

int n, q, l;
int f[MAXN];
int lenn[MAXN];
int cnt[MAXN][MAXN];
void match(char t[], char s[], int len)
{
    std::fill(f, f + len, 0);
    for (int i = 1 ; i < len ; ++i)
    {
        int last = i - 1;
        while (last >= 0 && s[f[last]] != s[i])
        {
            last = f[last] - 1;
        }
        
        if (last == -1) f[i] = 0;
        else f[i] = f[last] + 1;
    }
    
    int where = 0;
    for (int i = 0 ; i < l ; ++i)
    {
        int last = where;
        while (last >= 1 && s[last] != t[i])
        {
            last = f[last - 1];
        }
        
        if (last >= 0) where = last + (s[last] == t[i]);
        else where = 0;
        
        if (where == len)
        {
            cnt[i - len + 1][i]++;
            where = f[where - 1];
        }
    }
}

int prefix[MAXN][MAXN];
char s[MAXN][MAXN];
char t[MAXN];

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        match(t, s[i], lenn[i]);
    }

    for (int i = 1 ; i <= l ; ++i)
    {
        for (int j = 1 ; j <= l ; ++j)
        {
            prefix[i][j] = cnt[i - 1][j - 1] + prefix[i - 1][j] + prefix[i][j - 1] - prefix[i - 1][j - 1];
        }
    }

    int l, r;
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> l >> r; l--;
        std::cout << prefix[r][r] - prefix[l][r] - prefix[r][l] + prefix[l][l] << ' ';
    }

    std::cout << '\n';
}

void input()
{
    std::cin >> n >> q;
    std::cin >> t; l = strlen(t);
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> s[i];
        lenn[i] = strlen(s[i]);
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}