#include <algorithm>
#include <iostream>
#include <numeric>
#include <cstring>
#include <vector>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 5000 + 10;
const int MAXS = 1000000 + 10;
const llong INF = 1e18;

int n, q, l;
int f[MAXS];
int cnt[MAXN][MAXN];
void match(const std::string &t, const std::string &s)
{
    std::fill(f, f + s.size(), 0);
    for (int i = 1 ; i < s.size() ; ++i)
    {
        int last = i - 1;
        while (last >= 0 && s[f[last]] != s[i])
        {
            last = f[last] - 1;
        }
        
        if (last == -1) f[i] = 0;
        else f[i] = f[last] + 1;
    }
    
    int where = 0;
    for (int i = 0 ; i < t.size() ; ++i)
    {
        int last = where;
        while (last >= 1 && s[last] != t[i])
        {
            last = f[last - 1];
        }
        
        if (last >= 0) where = last + (s[last] == t[i]);
        else where = 0;
        
        if (where == s.size())
        {
            cnt[i - s.size() + 1][i]++;
            where = f[where - 1];
        }
    }
}

std::vector <int> v[MAXN];
void match2(const std::string &t, const std::string &s, int idx)
{
    std::fill(f, f + s.size(), 0);
    for (int i = 1 ; i < s.size() ; ++i)
    {
        int last = i - 1;
        while (last >= 0 && s[f[last]] != s[i])
        {
            last = f[last] - 1;
        }
        
        if (last == -1) f[i] = 0;
        else f[i] = f[last] + 1;
    }
    
    int where = 0;
    for (int i = 0 ; i < t.size() ; ++i)
    {
        int last = where;
        while (last >= 1 && s[last] != t[i])
        {
            last = f[last - 1];
        }
        
        if (last >= 0) where = last + (s[last] == t[i]);
        else where = 0;
        
        if (where == s.size())
        {
            v[idx].push_back(i + 2 - (int)s.size());
            where = f[where - 1];
        }
    }
}

int prefix[MAXN][MAXN];
std::string s[MAXN];
std::string t;

void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        match(t, s[i]);
    }

    for (int i = 1 ; i <= t.size() ; ++i)
    {
        for (int j = 1 ; j <= t.size() ; ++j)
        {
            prefix[i][j] = cnt[i - 1][j - 1] + prefix[i - 1][j] + prefix[i][j - 1] - prefix[i - 1][j - 1];
        }
    }

    int l, r;
    for (int i = 1 ; i <= q ; ++i)
    {
        std::cin >> l >> r; l--;
        std::cout << prefix[r][r] - prefix[l][r] - prefix[r][l] + prefix[l][l] << ' ';
    }

    std::cout << '\n';
}

int binary(int idx, int to)
{
    int l = -1, r = v[idx].size(), mid;
    while (l < r - 1)
    {
        mid = (l + r) / 2;
        if (v[idx][mid] <= to) l = mid;
        else r = mid;
    }

    return r;
}

void solve2()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        match2(t, s[i], i);
    }

    int l, r;
    for (int i = 1 ; i <= q ; ++i)
    {
        int ans = 0;
        std::cin >> l >> r; l--;
        for (int j = 1 ; j <= n ; ++j)
        {
            ans += binary(j, r + 1 - s[j].size()) - binary(j, l);
        }

        std::cout << ans << ' ';
    }

    std::cout << '\n';
}


void input()
{
    std::cin >> n >> q;
    std::cin >> t;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> s[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    if (n <= 100 && t.size() <= 50000) solve2();
    else solve();

    return 0;
}