#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int srt = 800;

const int MOD = 1e9 + 9; //233

vector <vector <int>> small;

int fast_pow(int a, int p) {
    if (p == 0) {
        return 1;
    }
    int res;
    if (p % 2 == 0) {
        res = fast_pow(a, p / 2);
        res *= res;
    } else {
        res = fast_pow(a, p - 1);
        res *= a;
    }
    res %= MOD;
    return res;
}


int pow26[5000050];

int get_hash(string s) {
    int hash = 0;
    for (int i = 0 ; i < s.size(); i++) {
        hash += (s[i] - 'a') * pow26[i];
        hash %= MOD;
    }
    return hash;
}

vector <int> sz;
vector <vector <int>> big_pos;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int rev_26 = fast_pow(26, MOD - 2);
    pow26[0] = 1;
    for (int i = 1; i < 5000050; i++) {
        pow26[i] = pow26[i - 1] * 26;
        pow26[i] %= MOD;
    }
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    string s;
    vector <string> task;
    cin >> n >> m;
    cin >> s;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    vector <vector <int>> pos;
    pos.resize(srt + 1);
    vector <unordered_map<int, vector<int>>> hash_small;
    hash_small.resize(srt + 1);

    for (int i = 0 ; i < s.size(); i++) {
        int h = 0;
        int p = i;
        int ssz = 0;
        while (ssz < srt && p < s.size()) {
            h += (s[p] - 'a') * pow26[ssz];
            h %= MOD;
            ssz++;
            p++;
            hash_small[ssz][h].push_back(i);
        }
    }
    /*
    for (int i = 0; i <= srt; i++) { // swap for
        int pp = 0;
        int hash = 0;
        for (int j = i; j < s.size(); j++) {
            hash += (s[j] - 'a') * pow26[pp];
            hash %= MOD;
            hash_small[pp][hash].push_back(i);
            pp++;
            if (pp == (srt + 1)) {
                break;
            }
        }
    }
    */
    for (int i = 0; i < n; i++) {
        if (task[i].size() <= srt) {
            int h = get_hash(task[i]);
            for (int j: hash_small[task[i].size()][h]) {
                pos[task[i].size()].push_back(j);
            }
        }
    }
    for (int i = 0 ; i <= srt; i++) {
        sort(pos[i].begin(), pos[i].end());
    }
    for (int i = 0; i < n; i++) {
        if (task[i].size() > srt) {
            sz.push_back(task[i].size());
            big_pos.push_back({});
            int h = 0;
            if (s.size() < task[i].size()) {
                break;
            }
            int h_task = get_hash(task[i]);
            for (int j = 0 ; j < task[i].size(); j++) {
                h += (s[j] - 'a') * pow26[j];
                h %= MOD;
            }
            if (h == h_task) {
                big_pos.back().push_back(0);
            }
            int l = 0;
            while ((l + task[i].size()) < s.size()) {
                h -= (s[l] - 'a');
                h *= rev_26;
                h += (s[l + task[i].size()] - 'a') * pow26[task[i].size() - 1];
                h %= MOD;
                l++;
                if (h == h_task) {
                    big_pos.back().push_back(l);
                }
            }
        }
    }
    int l, r;
    for (int i = 0 ; i < m; i++) {
        cin >> l >> r;
        l--;
        int ans = 0;
        for (int p = 0 ; p < sz.size(); p++) {
            if (l <= (r - (sz[p] - 1))) {
                ans -= lower_bound(big_pos[p].begin(), big_pos[p].end(), l) - big_pos[p].begin();
                ans += lower_bound(big_pos[p].begin(), big_pos[p].end(), (r - (sz[p] - 1))) - big_pos[p].begin();
            }
        }
        for (int p = 1; p <= srt; p++) {
            if (l > r) {
                break;
            }
            ans -= lower_bound(pos[p].begin(), pos[p].end(), l) - pos[p].begin();
            ans += lower_bound(pos[p].begin(), pos[p].end(), r) - pos[p].begin();
            r--;
        }
        cout << ans << " ";
    }
}