#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<vector<int>> all;

struct merge_sort_tree {
private:
    struct node {
        int l, r;
        vector<int> values;
    };

    vector<node> tree;

    void build(int v, int l, int r) {
        if (r - l == 1) {
            tree[v] = {l, r, all[l]};
            sort(tree[v].values.begin(), tree[v].values.end());
            return;
        }

        int m = (l + r) / 2;
        build(2 * v + 1, l, m);
        build(2 * v + 2, m, r);
        tree[v] = {l, r};
        merge(tree[2 * v + 1].values.begin(), tree[2 * v + 1].values.end(),
              tree[2 * v + 2].values.begin(), tree[2 * v + 2].values.end(),
              back_inserter(tree[v].values));
    }

public:
    merge_sort_tree() {
        int n = (int) all.size();
        tree.resize(4 * n);
        build(0, 0, n);
    }

    ll get(int v, int l, int r, int b) {
        if (tree[v].r <= l || r <= tree[v].l) {
            return 0;
        }
        if (l <= tree[v].l && tree[v].r <= r) {
            return (int) (
                    upper_bound(tree[v].values.begin(), tree[v].values.end(), b) -
                    tree[v].values.begin()
            );
        }
        return get(2 * v + 1, l, r, b) + get(2 * v + 2, l, r, b);
    }
};

string x;

void find_pos(const string &t, const string &si) {
    if (si.size() > t.size()) return;
    x = si + "#" + t;
    int n = (int) si.size(), m = (int) t.size(), w = n + m + 1;

    vector<int> p(w);
    for (int i = 1; i < w; ++i) {
        int j = p[i - 1];
        while (j > 0 && x[i] != x[j]) {
            j = p[j - 1];
        }
        if (x[i] == x[j]) {
            p[i] = j + 1;
        }
        if (p[i] == n) {
            all[i - 2 * n].push_back(i - n);
        }
    }
    
    x.clear();
}

void solve() {
    int n, m;
    string t;
    cin >> n >> m >> t;

    all.resize(t.size());
    for (int i = 0; i < n; ++i) {
        string si;
        cin >> si;
        find_pos(t, si);
    }

    merge_sort_tree mst;

    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;

        ll ans = mst.get(0, l, r, r);
        cout << ans << " ";
    }
    cout << "\n";
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
