#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) << ": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b) {
    return ((ll)a * b) % mod;
}

int add(int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}
struct cnm {
    vector<int> par, rang;
    void init(int n) {
        for (int i = 0; i < n; i++) {
            rang.pb(0);
            par.pb(i);
        }
    }
    int get(int a) {
        while (par[a] != a) {
            return get(par[a]);
        }
        par[a] = a;
        return par[a];
    }   
    void make_union(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b) return;
        if (rang[a] < rang[b]) swap(a, b);
        rang[a]++;
        par[b] = a;
    }
};
const int MAXN = 2e5 + 10;
const int MAX_LOG = 20;
const int base = 31;
vector<vector<int> > gr;
int up[MAXN][MAX_LOG];
vector<int> path, gets, in, out;
int fl = 0, timer = 0;
int is_pred(int a, int b) {
    if (in[a] <= in[b] && out[a] >= out[b]) return 1;
    return 0;
}
void make_in_out(int u, int p) {
    in[u] = timer;
    timer++;
    for (auto to : gr[u]) {
        if (to == p) continue;
        up[to][0] = u;
        make_in_out(to, u);
    }
    out[u] = timer;
    timer++;
}
void make_lca(int u, int p) {
    for (int i = 1; i < MAX_LOG; i++) {
        int c = up[u][i - 1];
        int next = up[c][i - 1];
        up[u][i] = next;
    }
    for (auto to : gr[u]) {
        if (to == p) continue;
        make_lca(to, u);
    }
}
int get_lca(int a, int b) {
    if (is_pred(a, b)) return a;
    if (is_pred(b, a)) return b;
    for (int i = 19; i >= 0; i--) {
        int c = up[a][i];
        if (!is_pred(c, b)) {
            a = c;
        }
    }
    return up[a][0];
}
int get_hash(vector<int> a) {
    int ans = 0;
    for (int i = 0; i < a.size(); i++) {
        ans = mul(ans, base);
        ans = add(ans, a[i]);
    }
    return ans;
}
struct hashes {
    vector<int> pref;
    vector<int> power;
    void init(vector<int> a) {
        int n = a.size();
        pref = vector<int>(n + 1);
        power = vector<int>(n + 1);
        power[0] = 1;
        for (int i = 0; i < a.size(); i++) {
            pref[i + 1] = (pref[i] * base) % mod;
            pref[i + 1] = add(pref[i + 1], a[i]);
            power[i + 1] = mul(power[i], base);
        }
    }
    int get_hash(int l, int r) {
        int right = pref[r], left = pref[l];
        left = mul(left, power[r - l]);
        return (right - left + mod) % mod;
    }
};
void solve() {
    int n, m;
    cin >> n >> m;
    string t; cin >> t;
    hashes hash_st;
    vector<int> st;
    for (int i = 0; i < t.size(); i++) st.pb(t[i] - 96);
    hash_st.init(st);
    set<int> all_hashes;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        vector<int> a;
        for (int j = 0; j < s.size(); j++) {
            //cout << s[j] - 97 << endl;
            a.pb(s[j] - 96);
        }
        all_hashes.insert(get_hash(a));
    }
    int t_sz = t.size();
    vector<vector<int> > pos(t_sz);
    for (int i = 0; i < t_sz; i++) {
        for (int j = i; j < t_sz; j++) {
            int cur = hash_st.get_hash(i, j + 1);
            if (all_hashes.count(cur)) {
                pos[i].pb(j);
            }
        }
    }
    /*
    for (auto c : pos) {
        for (auto x : c) {
            cout << x << " ";
        }
        cout << endl;
    }
    */
    vector<int> all_ans;
    for (int it = 0; it < m; it++) {
        int l, r, ans = 0;
        cin >> l >> r;
        l--; r--;
        for (int j = l; j <= r; j++) {
            auto c = upper_bound(pos[j].begin(), pos[j].end(), r) - pos[j].begin();
            ans += c;
        } 
        all_ans.pb(ans);
    }
    for (auto c : all_ans) cout << c << " ";

}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}