#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return abs(uid(rng)) % n;
}

int R = 1;
struct segment_tree {
    vector<ll> t, d;

    explicit segment_tree(int n = 1 << 19) {
        R = 1;
        while (R < n)
            R *= 2;
        t.resize(R * 2 + 10, 0);
        d.resize(R * 2 + 10, 0);
    }

    void calc(int node) {
        if (node < R)
            t[node] = t[node * 2] + t[node * 2 + 1];
    }

    void push(int node, int nl, int nr) {
        t[node] += d[node] * (nr - nl + 1);
        if (node < R) {
            d[node * 2] += d[node];
            d[node * 2 + 1] += d[node];
        }
        d[node] = 0;
    }

    void modify(int ql, int qr, ll val, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return;
        if (ql <= nl && nr <= qr) {
            t[node] += val * (nr - nl + 1);
            d[node] += val;
            return;
        }
        int nm = (nl + nr) / 2;
        modify(ql, qr, val, node * 2, nl, nm);
        modify(ql, qr, val, node * 2 + 1, nm + 1, nr);
        calc(node);
    }

    ll ans(int ql, int qr, int node = 1, int nl = 0, int nr = R - 1) {
        push(node, nl, nr);
        if (qr < nl || nr < ql)
            return 0;
        if (ql <= nl && nr <= qr)
            return t[node];
        int nm = (nl + nr) / 2;
        return ans(ql, qr, node * 2, nl, nm) +
               ans(ql, qr, node * 2 + 1, nm + 1, nr);
    }
};

struct Point {
    ld x{}, y{};
    Point() = default;
    Point(ld x, ld y) : x(x), y(y) {}
    ld operator*(Point& other) const {
        return x * other.x + y * other.y;
    }
    ld operator%(Point& other) const {
        return x * other.y - y * other.x;
    }
    Point operator-(Point& other) const {
        return {x - other.x, y - other.y};
    }
    Point operator+(Point& other) const {
        return {x + other.x, y + other.y};
    }
    ld len2() const {
        return x * x + y * y;
    }
};
#define Vector Point
#define Polygon vector <Point>

bool is_prime(ll x) {
    for (ll i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}
ll get_mod() {
    ll i = ll(1e9 + 7) + rnd(1e9);
    while (!is_prime(i))
        i++;
    return i;
}
const ll MOD1 = 1e9 + 1000 - 7, MOD2 = get_mod();
const ll P = 73;
const int HASH_SIZE = 500010;
pair <ll, ll> Ps[HASH_SIZE];
void init_hash() {
    Ps[0] = {1, 1};
    for (int i = 1; i < HASH_SIZE; i++)
        Ps[i] = {Ps[i - 1].F * P % MOD1, Ps[i - 1].S * P % MOD2};
}
struct str_hash {
    vector <pair <ll, ll>> H;
    explicit str_hash(string& s) {
        H.resize(s.size() + 1);
        for (int i = 1; i <= s.size(); i++)
            H[i] = {(H[i - 1].F + (s[i - 1] - 'a' + 1) * Ps[i].F) % MOD1,
                    (H[i - 1].S + (s[i - 1] - 'a' + 1) * Ps[i].S) % MOD2};
    }
    pair <ll, ll> get(int l, int r) {
        l++, r++;
        return {(H[r].F - H[l - 1].F + MOD1) % MOD1 * Ps[HASH_SIZE - l].F % MOD1,
                (H[r].S - H[l - 1].S + MOD2) % MOD2 * Ps[HASH_SIZE - l].S % MOD2};
    }
};

const int B = 300;
int used[500010];
set <pair <ll, ll>> hs[500010];
vector <int> ind1[500010], ind2[500010];
vector <pair <pair <int, int>, int>> z[500010];
ll res[500010];

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    init_hash();
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        used[s.size()] = 1;
        pair <ll, ll> h = {0, 0};
        for (int j = 0; j < s.size(); j++)
            h = {(h.F + (s[j] - 'a' + 1) * Ps[j + 1].F) % MOD1,
                 (h.S + (s[j] - 'a' + 1) * Ps[j + 1].S) % MOD2};
        h = {h.F * Ps[HASH_SIZE - 1].F % MOD1,
             h.S * Ps[HASH_SIZE - 1].S % MOD2};
        hs[s.size()].insert(h);
    }
    str_hash th(t);
    for (int i = 0; i < 500010; i++)
        if (used[i])
            for (int j = 0; j + i - 1 < t.size(); j++)
                if (hs[i].find(th.get(j, j + i - 1)) != hs[i].end()) {
                    ind1[j + i - 1].push_back(i);
                    ind2[j].push_back(i);
                }
    for (int i = 0; i < t.size(); i++) {
        sort(ind1[i].begin(), ind1[i].end());
        sort(ind2[i].begin(), ind2[i].end());
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        z[r / B].push_back({{l, r}, i});
    }
    for (int i = 0; i < 500010; i++) {
        sort(z[i].begin(), z[i].end());
        int nl = 0, nr = 0;
        ll ans = upper_bound(ind2[0].begin(), ind2[0].end(), 1) - ind2[0].begin();
        for (auto& el : z[i]) {
            int ql = el.F.F, qr = el.F.S, ind = el.S;
            while (nr < qr) {
                nr++;
                ans += upper_bound(ind1[nr].begin(), ind1[nr].end(), nr - nl + 1) - ind1[nr].begin();
            }
            while (nr > qr) {
                ans -= upper_bound(ind1[nr].begin(), ind1[nr].end(), nr - nl + 1) - ind1[nr].begin();
                nr--;
            }
            while (nl < ql) {
                ans -= upper_bound(ind2[nl].begin(), ind2[nl].end(), nr - nl + 1) - ind2[nl].begin();
                nl++;
            }
            res[ind] = ans;
        }
    }
    for (int i = 0; i < m; i++)
        cout << res[i] << ' ';
    cout << endl;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
