#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return abs(uid(rng)) % n;
}

bool is_prime(ll x) {
    for (ll i = 2; i * i <= x; i++)
        if (x % i == 0)
            return false;
    return true;
}
ll get_mod() {
    ll i = ll(1e9 + 7) + rnd(1e9);
    while (!is_prime(i))
        i++;
    return i;
}
const ll MOD = get_mod();
const ll P = 73;
const int HASH_SIZE = 500010;
ll Ps[HASH_SIZE];
struct str_hash {
    vector <ll> H;
    explicit str_hash(string& s) {
        H.resize(s.size() + 1);
        for (int i = 1; i <= s.size(); i++)
            H[i] = (H[i - 1] + (s[i - 1] - 'a' + 1) * Ps[i]) % MOD;
    }
    ll get(int l, int r) {
        l++, r++;
        return (H[r] - H[l - 1] + MOD) % MOD * Ps[HASH_SIZE - l] % MOD;
    }
};

const int B = 900;
int used[500010];
unordered_set <ll> hs[500010];
vector <int> ind1[500010], ind2[500010];
vector <pair <pair <int, int>, int>> z[500010];
ll res[500010];

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Ps[0] = 1;
    for (int i = 1; i < HASH_SIZE; i++)
        Ps[i] = Ps[i - 1] * P % MOD;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        used[s.size()] = 1;
        ll h = 0;
        for (int j = 0; j < s.size(); j++)
            h = (h + (s[j] - 'a' + 1) * Ps[j + 1]) % MOD;
        h = h * Ps[HASH_SIZE - 1] % MOD;
        hs[s.size()].insert(h);
    }
    str_hash th(t);
    for (int i = 0; i < 500010; i++)
        if (used[i])
            for (int j = 0; j + i - 1 < t.size(); j++)
                if (hs[i].find(th.get(j, j + i - 1)) != hs[i].end()) {
                    ind1[j + i - 1].push_back(i);
                    ind2[j].push_back(i);
                }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        z[r / B].push_back({{l, r}, i});
    }
    for (int i = 0; i < 500010; i++) {
        if (z[i].empty())
            continue;
        sort(z[i].begin(), z[i].end());
        int nl = z[i][0].F.F, nr = z[i][0].F.F;
        ll ans = upper_bound(ind2[z[i][0].F.F].begin(), ind2[z[i][0].F.F].end(), 1) - ind2[z[i][0].F.F].begin();
        for (auto& el : z[i]) {
            int ql = el.F.F, qr = el.F.S, ind = el.S;
            while (nr < qr) {
                nr++;
                ans += upper_bound(ind1[nr].begin(), ind1[nr].end(), nr - nl + 1) - ind1[nr].begin();
            }
            while (nr > qr) {
                ans -= upper_bound(ind1[nr].begin(), ind1[nr].end(), nr - nl + 1) - ind1[nr].begin();
                nr--;
            }
            while (nl < ql) {
                ans -= upper_bound(ind2[nl].begin(), ind2[nl].end(), nr - nl + 1) - ind2[nl].begin();
                nl++;
            }
            res[ind] = ans;
        }
    }
    for (int i = 0; i < m; i++)
        cout << res[i] << ' ';
    cout << endl;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
