#include <bits/stdc++.h>
typedef long long ll;

using namespace std;

const ll MOD = 1791791791, P = 239, SIZE = 1e5 + 7;

ll hash_t[SIZE], pows[SIZE];

ll get_lr(int l, int r) {
    return (hash_t[r] - hash_t[l] * pows[r - l] % MOD + MOD) % MOD;
}

struct req {
    int type, x, ind, y;

    bool operator<(req a) {
        if (x == a.x) return type < a.type;
        return x < a.x;
    }
};

vector<int> t_f(SIZE);

int getr(int r) {
    int res = 0;
    for (; r > 0; r -= r & -r) res += t_f[r];
    return res;
}

void add(int ind, int val) {
    for (; ind < SIZE; ind += ind & -ind) t_f[ind] += val;
}

int getlr(int l, int r) {
    return getr(r - 1) - getr(l);
}

unordered_map<ll, vector<int>> flex;

signed main() {
    flex.reserve(1000000);
    pows[0] = 1;
    for (int i = 1; i < SIZE; ++i) {
        pows[i] = pows[i - 1] * P % MOD;
    }
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> all(n);
    vector<ll> all_h(n);
    vector<vector<int>> inds(1000000);
    for (int i = 0; i < n; ++i) cin >> all[i], inds[all[i].size()].push_back(i);
    for (int i = 0; i < n; ++i) {
        for (char j : all[i]) {
            all_h[i] = (all_h[i] * P % MOD + j - 'a' + 7) % MOD;
        }
    }

    for (int i = 0; i < t.size(); ++i) {
        hash_t[i + 1] = (hash_t[i] * P % MOD + t[i] - 'a' + 7) % MOD;
    }
    vector<req> ufo;
    for (int k = 0; k < 1000000; ++k) {
        if (inds[k].empty()) continue;
        flex.clear();
        for (int i = 0; i + k <= t.size(); ++i) {
            flex[get_lr(i, i + k)].push_back(i);
        }
        for (auto i : inds[k]) {
            for (int x : flex[all_h[i]]) ufo.push_back({0, x, -1, x + k});
        }
    }
    vector<int> ans(m);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r, l--;
        ufo.push_back({-1, l, i, r});
        ufo.push_back({1, r - 1, i, r});
    }
    sort(ufo.begin(), ufo.end());
    for (auto x : ufo) {
        if (x.type == 0) {
            add(x.y, 1);
        }
        if (x.type == -1) {
            ans[x.ind] = -getr(x.y);
        }
        if (x.type == 1) {
            ans[x.ind] += getr(x.y);
        }
    }
    for (int i : ans) cout << i << " ";
    cout << endl;
}