#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

vc <int> prefix (string s) {
    int n = sz(s);
    vc <int> p(n);
    for (int i = 1; i < n; ++i) {
        int j = p[i - 1];
        while (j > 0 && s[i] != s[j])
            j = p[j - 1];
        if (s[i] == s[j])
            ++j;
        p[i] = j;
    }
    return p;
}

struct fw {
    vc <int> t; int n;
    fw (int n): n(n) {
        t.resize(n + 1);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] += x;
    }
    int get (int i) {
        int rt = 0;
        for (++i; i > 0; i -= i & -i)
            rt += t[i];
        return rt;
    }
    int get (int l, int r) {
        return get(r) - get(l - 1);
    }
};

void solve () {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vc <vc <int>> sum(sz(t));
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        string z = s + '#' + t;
        vc <int> pr = prefix(z);
        for (int j = sz(s) + 1; j < sz(z); ++j) {
            if (pr[j] == sz(s))
                sum[j - sz(s) - 1].pb(sz(s));
        }
    }
    vc <vc <pii>> quer(sz(t));
    vc <int> ans(m);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r; --l; --r;
        quer[r].pb({l, i});
    }
    fw st(sz(t));
    for (int j = 0; j < sz(t); ++j) {
        for (int k : sum[j])
            st.upd(j - k + 1, 1);
        for (auto [l, i] : quer[j]) {
            ans[i] = st.get(l, j);
        }
    }
    for (int i = 0; i < m; ++i)
        cout << ans[i] << ' ';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}
