#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define int long long
#define pb push_back

const int N = 5e6 + 1;
const int mod = 1e9 + 7;
const int inf = 1e9;
const int K = 26;

struct node {
    map <int, int> next;
    int suf = -1, p = -1;
    int len = 0, cnt = 0;
    node () {}
};

node t[N]; int sz = 1;
int create () {
    return sz++;
}

int add (int a, int x) {
    int b = create();
    t[b].suf = 0;
    t[b].len = t[a].len + 1;
    t[b].p = a;
    for (; a != -1; a = t[a].suf) {
        if (t[a].next.find(x) == t[a].next.end()) {
            t[a].next[x] = b;
        } else {
            int c = t[a].next[x];
            if (t[c].p == a) {
                t[b].suf = c;
                break;
            }
            int d = create();
            t[d] = t[c];
            t[d].cnt = 0;
            t[c].suf = t[b].suf = d;
            t[d].p = a;
            t[d].len = t[a].len + 1;
            for (; a != -1 && t[a].next[x] == c; a = t[a].suf) {
                t[a].next[x] = d;
            }
            break;
        }
    }
    return t[t[b].p].next[x];
}

using ll = long long;

struct fw {
    vc <ll> t; int n;
    fw () {}
    fw (int n): n(n) {
        t.resize(n + 1);
    }
    void upd (int i, int x) {
        for (++i; i <= n; i += i & -i)
            t[i] += x;
    }
    ll get (int i) {
        ll rt = 0;
        for (++i; i > 0; i -= i & -i)
            rt += t[i];
        return rt;
    }
    int get (int l, int r) {
        return get(r) - get(l - 1);
    }
};
fw st;

int near[N], cur;
void dfs (int a) {
    if (a == -1)
        return;
    near[a] = t[a].suf;
    while (near[a] != -1 && t[near[a]].cnt == 0)
        near[a] = t[near[a]].suf;
    dfs(near[a]);
    st.upd(cur - t[a].len + 1, t[a].cnt);
}

void solve () {
    int n, q, m;
    cin >> n >> q;
    string s; cin >> s; m = sz(s);
    for (int i = 0; i < n; ++i) {
        string r;
        cin >> r;
        int lst = 0;
        for (char c : r)
            lst = add(lst, c - 'a');
        t[lst].cnt++;
    }
    vc <vc <pii>> quer(m);
    vc <ll> ans(q);
    for (int i = 0; i < q; ++i) {
        int l, r;
        cin >> l >> r; --l; --r;
        quer[r].pb({l, i});
    }
    st = fw(m);
    int lst = 0;
    for (int j = 0; j < m; ++j) {
        lst = add(lst, s[j] - 'a');
        cur = j;
        dfs(lst);
        for (auto [l, i] : quer[j]) {
            ans[i] = st.get(l, j);
        }
    }
    for (int i = 0; i < q; ++i)
        cout << ans[i] << ' ';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}

/*
3 4
abcdca
ab
ca
bcd
1 5
2 2
2 6
1 6
 */