#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

const int B = 444;

const int P = 179, MOD = 1e9 + 7;

int hsh(string & s) {
    ll res = 0;
    for (auto c : s) {
        res = (res * P + c) % MOD;
    }
    return int(res);
}

vector<ll> hs, pw;

int get_hash(int i, int j) {
    return int((hs[j] - hs[i] * pw[j - i] % MOD + MOD) % MOD);
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> l(m), r(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
    }
    vector<ll> ans(m, 0);

    hs.assign(sz(t) * 2 + 1, 0);
    pw.assign(sz(t) * 2 + 1, 1);
    for (int i = 0; i < sz(t) * 2; ++i) {
        pw[i + 1] = pw[i] * P % MOD;
        hs[i + 1] = (hs[i] * P + t[i % sz(t)]) % MOD;
    }

    vector<pair<int, int>> hashes(n);
    for (int i = 0; i < n; ++i) {
        hashes[i] = {sz(s[i]), hsh(s[i])};
    }
    sort(hashes.begin(), hashes.end());

    int idx = 0;
    while (idx < n) {
        int len = hashes[idx].first;
        if (len > sz(t)) break;
        unordered_set<int> cur_hashes;
        while (idx < n && hashes[idx].first == len) {
            cur_hashes.insert(hashes[idx].second);
            idx++;
        }
        vector<int> matches(sz(t) + 1, 0);
        for (int i = 0; i < sz(t); ++i) {
            if (cur_hashes.contains(get_hash(i, i + len))) {
                matches[i + 1] = matches[i] + 1;
            } else {
                matches[i + 1] = matches[i];
            }
        }
        for (int i = 0; i < m; ++i) {
            if (l[i] < r[i] - len + 1) {
                ans[i] += matches[r[i] - len + 1] - matches[l[i]];
            }
        }
    }

    for (auto el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}