#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

const int B = 444;

const uint64_t P = 179;

uint64_t hsh(string & s) {
    uint64_t res = 0;
    for (auto c : s) {
        res = res * P + (uint64_t)c;
    }
    return res;
}

vector<uint64_t> hs, pw;

uint64_t get_hash(int i, int j) {
    return hs[j] - hs[i] * pw[j - i];
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> l(m), r(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
    }
    vector<ll> ans(m, 0);

    hs.assign(sz(t) * 2 + 1, 0);
    pw.assign(sz(t) * 2 + 1, 1);
    for (int i = 0; i < sz(t) * 2; ++i) {
        pw[i + 1] = pw[i] * P;
        hs[i + 1] = hs[i] * P + (uint64_t)t[i % sz(t)];
    }

    vector<pair<int, uint64_t>> hashes(n);
    for (int i = 0; i < n; ++i) {
        hashes[i] = {sz(s[i]), hsh(s[i])};
    }
    sort(hashes.begin(), hashes.end());

    int idx = 0;
    while (idx < n) {
        int len = hashes[idx].first;
        if (len > sz(t)) break;
        unordered_set<uint64_t> cur_hashes;
        while (idx < n && hashes[idx].first == len) {
            cur_hashes.insert(hashes[idx].second);
            idx++;
        }
        vector<int> matches(sz(t) - len + 2, 0);
        for (int i = 0; i < sz(t) - len + 1; ++i) {
            if (cur_hashes.contains(get_hash(i, i + len))) {
                matches[i + 1] = matches[i] + 1;
            } else {
                matches[i + 1] = matches[i];
            }
        }
        for (int i = 0; i < m; ++i) {
            if (l[i] < r[i] - len + 1) {
                ans[i] += matches[r[i] - len + 1] - matches[l[i]];
            }
        }
    }

    for (auto el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}