#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

const int B = 444;

const ll P = 179, MOD1 = 1e9 + 7, MOD2 = 1e9 + 9;

pair<ll, ll> hsh(string & s) {
    ll res1 = 0, res2 = 0;
    for (auto c : s) {
        res1 = (res1 * P + c) % MOD1;
        res2 = (res2 * P + c) % MOD2;
    }
    return {res1, res2};
}

vector<ll> hs1, hs2, pw1, pw2;

pair<ll, ll> get_hash(int i, int j) {
    return {(hs1[j] - hs1[i] * pw1[j - i] % MOD1 + MOD1) % MOD1,
            (hs2[j] - hs2[i] * pw2[j - i] % MOD2 + MOD2) % MOD2};
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> l(m), r(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
    }
    vector<ll> ans(m, 0);

    hs1.assign(sz(t) * 2 + 1, 0);
    hs2.assign(sz(t) * 2 + 1, 0);
    pw1.assign(sz(t) * 2 + 1, 1);
    pw2.assign(sz(t) * 2 + 1, 1);
    for (int i = 0; i < sz(t) * 2; ++i) {
        pw1[i + 1] = pw1[i] * P % MOD1;
        pw2[i + 1] = pw2[i] * P % MOD2;
        hs1[i + 1] = (hs1[i] * P + t[i % sz(t)]) % MOD1;
        hs2[i + 1] = (hs2[i] * P + t[i % sz(t)]) % MOD2;
    }

    vector<pair<int, pair<ll, ll>>> hashes(n);
    for (int i = 0; i < n; ++i) {
        hashes[i] = {sz(s[i]), hsh(s[i])};
    }
    sort(hashes.begin(), hashes.end());

    int idx = 0;
    while (idx < n) {
        int len = hashes[idx].first;
        if (len > sz(t)) break;
        set<pair<ll, ll>> cur_hashes;
        while (idx < n && hashes[idx].first == len) {
            cur_hashes.insert(hashes[idx].second);
            idx++;
        }
        vector<int> matches(sz(t) - len + 2, 0);
        for (int i = 0; i < sz(t) - len + 1; ++i) {
            if (cur_hashes.contains(get_hash(i, i + len))) {
                matches[i + 1] = matches[i] + 1;
            } else {
                matches[i + 1] = matches[i];
            }
        }
        for (int i = 0; i < m; ++i) {
            if (l[i] < r[i] - len + 1) {
                ans[i] += matches[r[i] - len + 1] - matches[l[i]];
            }
        }
    }

    for (auto el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}