#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

const int B = 444;

const ll P = 179, MOD1 = 1e9 + 7, MOD2 = 1e9 + 9;

ll hsh(string & s) {
    ll res1 = 0, res2 = 0;
    for (auto c : s) {
        res1 = (res1 * P + c) % MOD1;
        res2 = (res2 * P + c) % MOD2;
    }
    return res1 * MOD2 + res2;
}

const int T = 750000, N = 500000;

ll hs1[2 * T + 1], hs2[2 * T + 1], pw1[2 * T + 1], pw2[2 * T + 1];

ll get_hash(int i, int j) {
    return (hs1[j] - hs1[i] * pw1[j - i] % MOD1 + MOD1) % MOD1 * MOD2 + (hs2[j] - hs2[i] * pw2[j - i] % MOD2 + MOD2) % MOD2;
}

pair<int, ll> hashes[N];

int matches[T + 1];

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    vector<int> l(m), r(m);
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
    }
    vector<ll> ans(m, 0);

    hs1[0] = hs2[0] = 0;
    pw1[0] = pw2[0] = 1;
    for (int i = 0; i < sz(t) * 2; ++i) {
        pw1[i + 1] = pw1[i] * P % MOD1;
        pw2[i + 1] = pw2[i] * P % MOD2;
        hs1[i + 1] = (hs1[i] * P + t[i % sz(t)]) % MOD1;
        hs2[i + 1] = (hs2[i] * P + t[i % sz(t)]) % MOD2;
    }

    for (int i = 0; i < n; ++i) {
        hashes[i] = {sz(s[i]), hsh(s[i])};
    }
    sort(hashes, hashes + n);

    int idx = 0;
    while (idx < n) {
        int len = hashes[idx].first;
        if (len > sz(t)) break;
        vector<ll> cur_hashes;
        while (idx < n && hashes[idx].first == len) {
            cur_hashes.push_back(hashes[idx].second);
            idx++;
        }
        matches[0] = 0;
        if (sz(cur_hashes) < 10) {
            for (int i = 0; i < sz(t) - len + 1; ++i) {
                if (find(cur_hashes.begin(), cur_hashes.end(), get_hash(i, i + len)) != cur_hashes.end()) {
                    matches[i + 1] = matches[i] + 1;
                } else {
                    matches[i + 1] = matches[i];
                }
            }
        } else {
            unordered_set<ll> cur_hashes_set(cur_hashes.begin(), cur_hashes.end());
            for (int i = 0; i < sz(t) - len + 1; ++i) {
                if (cur_hashes_set.contains(get_hash(i, i + len))) {
                    matches[i + 1] = matches[i] + 1;
                } else {
                    matches[i + 1] = matches[i];
                }
            }
        }

        for (int i = 0; i < m; ++i) {
            if (l[i] < r[i] - len + 1) {
                ans[i] += matches[r[i] - len + 1] - matches[l[i]];
            }
        }
    }

    for (auto el : ans) {
        cout << el << ' ';
    }
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}