#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res = res * a;
			}
			a = a * a;
			n /= 2;
		}
		return res;
	}

	mint rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}

	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}

	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}

	mint& operator/=(const mint& b) {
		(*this) *= b.rev();
		return *this;
	}

	mint operator+(const mint& b) const {
		return mint(*this) += b;
	}
	mint operator-(const mint& b) const {
		return mint(*this) -= b;
	}
	mint operator*(const mint& b) const {
		return mint(*this) *= b;
	}
	mint operator/(const mint& b) const {
		return mint(*this) /= b;
	}
};

vector<int> prefix(string s) {
	int n = s.size();
	vector<int> pr(n);
	for (int i = 1; i < n; i++) {
		int j = pr[i - 1];
		while (j > 0 && s[j] != s[i])
			j = pr[j - 1];
		if (s[j] == s[i]) j++;
		pr[i] = j;
	}
	return pr;
}

int ans[500010];
struct BIT {
	vector<int> t;
	BIT(int n) {
		t.resize(n + 1);
	}
	void add(int v) {
		for (; v < t.size(); v += v & -v)
			t[v]++;
	}
	int get(int v) {
		int res = 0;
		for (; v > 0; v -= v & -v) {
			res += t[v];
		}
		return res;
	}
};
struct query {
	int l, x, k, id;
};
bool operator<(query& a, query& b) {
	return a.l < b.l;
}
void solve() {
	int n, m;
	string s;
	cin >> n >> m >> s;
	vector<string> t(n);
	for (int i = 0; i < n; i++) {
		cin >> t[i];
	}
	vector<pair<int, int>> keka(m);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		keka[i] = { l, r };
	}
	for (int i = 0; i < n; i++) {
		vector<vector<query>> q(s.size());
		for (int j = 0; j < m; j++) {
			int l = keka[j].first, r = keka[j].second;
			if (l > 0) q[l - 1].push_back({l - 1, r, -1, j});
			q[r].push_back({ r, r, 1, j });
		}
		auto pr = prefix(t[i] + "#" + s);
		vector<int> res(s.size(), -1);
		for (int j = t[i].size() + 1; j < pr.size(); j++) {
			if (pr[j] == t[i].size()) {
				res[j - 2 * t[i].size()] = j - t[i].size() - 1;
			}
		}
		BIT t(s.size() + 1);
		for (int k = 0; k < s.size(); k++) {
			if (res[k] != -1) {
				t.add(res[k] + 1);
			}
			for (auto qu : q[k]) {
				ans[qu.id] += qu.k * t.get(qu.x + 1);
			}
		}
	}
	for (int i = 0; i < m; i++) {
		cout << ans[i] << " ";
	}
	cout << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}