#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

const int P = 179;
const int MOD = 228228227;

int mul(int a, int b) {
    return 1LL * a * b % MOD;
}

int add(int a, int b) {
    return (a + b) % MOD;
}

int sub(int a, int b) {
    return ((a - b) % MOD + MOD) % MOD;
}

int binpow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int b = binpow(a, n / 2);
        return mul(b, b);
    } else {
        return mul(a, binpow(a, n - 1));
    }
}

int divide(int a, int b) {
    if (b == 0) {
        return 0;
    }
    return mul(a, binpow(b, MOD - 2));
}

const int N = 50'001;
int pw[N];

void solve() {
    int n, q;
    string t;
    cin >> n >> q >> t;
    vector<int> h(sz(t) + 1);
    for (int i = 1; i <= sz(t); ++i) {
        h[i] = add(mul(h[i - 1], P), t[i - 1] - 'a' + 1);
    }

    auto get = [&h](int l, int r) {
        return sub(h[r], mul(h[l - 1], pw[r - l + 1]));
    };

    set<int> st;

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int now = 0;
        for (auto c : s) {
            now = add(mul(now, P), c - 'a' + 1);
        }
        st.emplace(now);
    }

    vector<vector<int>> precalc(sz(t) + 1, vector<int> (sz(t) + 1, 0));
    for (int l = 1; l <= sz(t); ++l) {
        int ans = 0;
        int now = 0;
        for (int r = l; r <= sz(t); ++r) {
            now = add(mul(now, P), t[r - 1] - 'a' + 1);
            ans += (st.find(now) != st.end());
            precalc[l][r] = ans;
        }
    }

    for (int w = 0; w < q; ++w) {
        int l, r;
        cin >> l >> r;
        cout << precalc[l][r] << ' ';
//        int ans = 0;
//        for (int i = l; i <= r; ++i) {
//            int now = 0;
//            for (int j = i; j <= r; ++j) {
//                now = add(mul(now, P), t[j - 1] - 'a' + 1);
//                ans += cnt[now];
//            }
//        }
//        cout << ans << ' ';
    }

}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    pw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = mul(pw[i - 1], P);
    }
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
