#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#pragma optimize("Ofast");
#pragma target("avx, avx2, bmi, bmi2");

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

const int k = 1;
int mod[k] = {(int)1e9 + 7};

struct ModInt {
    int x[k];
    explicit ModInt(int y) {
        for (int i = 0; i < k; i++) x[i] = y;
    }
    ModInt() {
        for (int i = 0; i < k; i++) x[i] = 0;
    }
    ModInt operator+(ModInt b) {
        ModInt c(0);
        for (int i = 0; i < k; i++) {
            c.x[i] = x[i] + b.x[i];
            if (c.x[i] >= mod[i]) c.x[i] -= mod[i];
        }
        return c;
    }
    ModInt operator-(ModInt b) {
        ModInt c(0);
        for (int i = 0; i < k; i++) {
            c.x[i] = x[i] - b.x[i];
            if (c.x[i] < 0) c.x[i] += mod[i];
        }
        return c;
    }
    ModInt operator*(ModInt b) {
        ModInt c(0);
        for (int i = 0; i < k; i++) {
            c.x[i] = (x[i] * b.x[i]) % mod[i];
        }
        return c;
    }
    bool operator==(ModInt b) {
        bool fl = true;
        for (int i = 0; i < k; i++)
            fl &= x[i] == b.x[i];
        return fl;
    }
};

const int N = 6e6 + 3;
ModInt powers[N];
ModInt p(239);

struct Hashes {
    vector<ModInt> hashes;
    Hashes(string& s) {
        int n = s.size();
        hashes.resize(n + 1);
        hashes[0] = ModInt(0);
        for (int i = 1; i <= n; i++)
            hashes[i] = hashes[i - 1] * p + ModInt(s[i - 1] - 'a' + 1);
    }
    ModInt get_hash(int l, int r) {
        return hashes[r] - hashes[l] * powers[r - l];
    }
};


void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector<string> bebra(n);
    vector<ModInt> hashes;
    for (auto &i : bebra) {
        cin >> i;
        hashes.emplace_back(Hashes(i).get_hash(0, i.size()));
    }

    Hashes hs(s);

    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        int cnt = 0;
        for (int i = 0; i < n; i++) {
            for (int st = l; st <= r - (int)bebra[i].size(); st++) {
                if (hs.get_hash(st, st + bebra[i].size()) == hashes[i]) {
                    cnt++;
                }
            }
        }
        cout << cnt << ' ';
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    powers[0] = ModInt(1);
    for (int i = 1; i < N; i++)
        powers[i] = powers[i - 1] * p;
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}