#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<vector<int>> go;
vector<int> suff;
vector<vector<int>> term;

void add_trie(int v, string &s, int id, int pos) {
    if (pos == s.size()) {
        term[v].push_back(id);
        return;
    }
    int c = s[pos] - 'a';
    if (go[v][c] == -1) {
        go[v][c] = go.size();
        go.push_back(vector<int>(26, -1));
        suff.push_back(0);
        term.push_back({});
    }
    add_trie(go[v][c], s, id, pos + 1);
}

queue<int> q;

void build_vert(int v) {
    if (v == 0) {
        suff[v] = v;
        for (auto &el: go[v]) {
            if (el == -1)
                el = v;
            else
                q.push(el);
            suff[el] = v;
        }
        return;
    }
    for (int c = 0; c < 26; ++c) {
        if (go[v][c] == -1)
            go[v][c] = go[suff[v]][c];
        else {
            q.push(go[v][c]);
            suff[go[v][c]] = go[suff[v]][c];
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m;
    cin >> n >> m;
    string text;
    cin >> text;
    go.push_back(vector<int>(26, -1));
    suff.push_back(0);
    term.push_back({});
    vector<int> sizes(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        sizes[i] = s.size();
        add_trie(0, s, i, 0);
    }
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        build_vert(v);
    }
    vector<pair<int, int>> occ;
    int curv = 0;
    for (int i = 0; i < text.size(); ++i) {
        curv = go[curv][text[i] - 'a'];
        vector<int> ans;
        int v = curv;
        while (suff[v] != v) {
            for (auto id: term[v])
                ans.push_back(id);
            v = suff[v];
        }
        for (auto el: ans)
            occ.push_back({i - sizes[el] + 1, i});
    }
    for (int tn = 0; tn < m; ++tn) {
        int li, ri;
        cin >> li >> ri;
        int ans = 0;
        for (auto [a, b]: occ)
            ans += (a >= li && b <= ri);
        cout << ans << ' ';
    }
}