#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,fast-math,unroll-loops,inline")

#include <bits/stdc++.h>

using namespace std;

array<vector<int>, 26> go;
vector<int> suff, supersuff;
vector<vector<int>> term;

void add_trie(int v, string &s, int id, int pos) {
    if (pos == s.size()) {
        term[v].push_back(id);
        return;
    }
    int c = s[pos] - 'a';
    if (go[c][v] == -1) {
        go[c][v] = go[0].size();
        for (int i = 0; i < 26; ++i)
            go[i].push_back(-1);
        suff.push_back(0);
        supersuff.push_back(0);
        term.push_back({});
    }
    add_trie(go[c][v], s, id, pos + 1);
}

queue<int> q;

void build_vert(int v) {
    if (v == 0) {
        suff[v] = v;
        for (int c = 0; c < 26; ++c) {
            if (go[c][v] == -1)
                go[c][v] = v;
            else
                q.push(go[c][v]);
            supersuff[go[c][v]] = suff[go[c][v]] = v;
        }
        return;
    }
    for (int c = 0; c < 26; ++c) {
        if (go[c][v] == -1)
            go[c][v] = go[suff[v]][c];
        else {
            q.push(go[c][v]);
            suff[go[c][v]] = go[c][suff[v]];
            if (term[suff[go[c][v]]].size())
                supersuff[go[c][v]] = suff[go[c][v]];
            else
                supersuff[go[c][v]] = supersuff[suff[go[c][v]]];
        }
    }
}

vector<pair<int, int>> pts;

int build_corasick(int n) {
    string text;
    cin >> text;
    for (int i = 0; i < 26; ++i)
        go[i].reserve(2e5);
    suff.reserve(2e5);
    supersuff.reserve(2e5);
    term.reserve(2e5);
    for (int i = 0; i < 26; ++i)
        go[i].push_back(-1);
    suff.push_back(0);
    supersuff.push_back(0);
    term.push_back({});
    vector<int> sizes(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        sizes[i] = s.size();
        add_trie(0, s, i, 0);
    }
    q.push(0);
    while (!q.empty()) {
        int v = q.front();
        q.pop();
        build_vert(v);
    }
    vector<pair<int, int>> occ;
    int curv = 0;
    for (int i = 0; i < text.size(); ++i) {
        curv = go[curv][text[i] - 'a'];
        vector<int> ans;
        int v = curv;
        while (suff[v] != v) {
            for (auto id: term[v])
                ans.push_back(id);
            v = supersuff[v];
        }
        for (auto el: ans)
            pts.push_back({i - sizes[el] + 1, i});
    }
    return text.size();
}

template<typename Node>
struct SegTree {
    int n;
    int h = 0;
    vector<Node> t;

    SegTree(const vector<Node> &in) {
        n = in.size();
        while ((1 << h) < n)
            ++h;
        t.resize((1 << (h + 1)), Node::zero_el());
        for (int i = 0; i < n; ++i)
            t[(1 << h) + i] = in[i];
        for (int i = (1 << h) - 1; i > 0; --i)
            t[i] = Node::merge(t[2 * i], t[2 * i + 1]);
    }

    void upd(int v, int vl, int vr, int i, Node &val) {
        if (vl + 1 == vr) {
            t[v] = val;
            return;
        }
        int vm = (vl + vr) / 2;
        if (i < vm)
            upd(2 * v, vl, vm, i, val);
        else
            upd(2 * v + 1, vm, vr, i, val);
        t[v] = Node::merge(t[2 * v], t[2 * v + 1]);
    }

    void upd(int i, Node val) {
        upd(1, 0, (1 << h), i, val);
    }

    Node get(int v, int vl, int vr, int l, int r) {
        if (vl >= r || vr <= l)
            return Node::zero_el();
        if (l <= vl && vr <= r)
            return t[v];
        int vm = (vl + vr) / 2;
        return Node::merge(get(2 * v, vl, vm, l, r), get(2 * v + 1, vm, vr, l, r));
    }

    Node get(int l, int r) {
        return get(1, 0, (1 << h), l, r);
    }

    Node get(int i) {
        return t[(1 << h) + i];
    }
};

struct Node {
    int val;

    static Node merge(Node a, Node b) {
        return {a.val + b.val};
    }

    static Node zero_el() {
        return {0};
    }
};

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m;
    cin >> n >> m;
    n = build_corasick(n);
    vector<vector<tuple<int, int, int>>> opev(n), clev(n);
    vector<vector<int>> ptev(n);
    for (auto [x, y]: pts)
        ptev[x].push_back(y);
    for (int tn = 0; tn < m; ++tn) {
        int li, ri;
        cin >> li >> ri;
        --li, --ri;
        opev[li].push_back({li, ri, tn});
        clev[ri].push_back({li, ri, tn});
    }
    vector<int> ans(m);
    vector<Node> in(n);
    SegTree<Node> st(in);
    for (int i = 0; i < n; ++i) {
        for (auto [li, ri, id]: opev[i])
            ans[id] -= st.get(li, ri + 1).val;
        for (auto y: ptev[i]) {
            Node tmp = st.get(y);
            st.upd(y, {tmp.val + 1});
        }
        for (auto [li, ri, id]: clev[i])
            ans[id] += st.get(li, ri + 1).val;
    }
    for (auto el: ans)
        cout << el << ' ';
}