#include <bits/stdc++.h>

#define ll long long
#define ull H
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#pragma GCC optimize("O3")
#pragma GCC target("avx2", "popcnt")

using namespace std;

const int K = 2;
const int MOD[K] = {(int)1e9 + 7, (int)1e9 + 9};
#ifdef ON_PC
	const int MAXN = 100;
#else
	const int MAXN = 2e6 + 10;
#endif


struct H{
	int h[K];

	H(){
		for (int i = 0; i < K; i++){
			h[i] = 0;
		}
	}

	H(vector<int> a){
		for (int i = 0; i < a.size(); i++){
			h[i] = a[i];
		}
	}
};

H operator+(const H& a, const H& b){
	H c;
	for (int i = 0; i < K; i++){
		c.h[i] = (a.h[i] + b.h[i]) % MOD[i];
	}
	return c;
}

H operator-(const H& a, const H& b){
	H c;
	for (int i = 0; i < K; i++){
		c.h[i] = (a.h[i] - b.h[i] + MOD[i]) % MOD[i];
	}
	return c;
}

H operator*(const H& a, const H& b){
	H c;
	for (int i = 0; i < K; i++){
		c.h[i] = (a.h[i] * 1ll * b.h[i]) % MOD[i];
	}
	return c;
}

H operator*(const H& a, int x){
	H c;
	for (int i = 0; i < K; i++){
		c.h[i] = (a.h[i] * 1ll * x) % MOD[i];
	}
	return c;
}

bool operator==(const H& a, const H& b){
	for (int i = 0; i < K; i++){
		if (a.h[i] != b.h[i]){
			return 0;
		}
	}
	return 1;
}

bool operator<(const H& a, const H& b){
	for (int i = 0; i < K; i++){
		if (a.h[i] != b.h[i]){
			return a.h[i] < b.h[i];
		}
	}
	return 0;
}

ull pref[MAXN];
ull pw[MAXN + 100];

ull h(int i, int j){
	return (pref[j] - pref[i - 1]) * pw[MAXN - i + 1];
}

int main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	pw[0] = H({1, 1});
	for (int i = 1; i < MAXN + 100; i++){
		pw[i] = pw[i - 1] * H({57, 113});
	}
	int T = 1;
//	cin >> T;
	while (T--){
		int n, m;
		string t;
		cin >> n >> m >> t;
		vector<string> a(n);
		for (int i = 0; i < n; i++){
			cin >> a[i];
		}
		a.push_back(t);
		vector<int> start(n + 1);
		string s = " ";
		for (int i = 0; i <= n; i++){
			s += a[i];
		}
		start[0] = 1;
		for (int i = 1; i <= n; i++){
			start[i] = start[i - 1] + a[i - 1].size();
		}
		for (int i = 1; i < s.size(); i++){
			pref[i] = pref[i - 1] + pw[i - 1] * (s[i] - 'a' + 1);
		}
//		vector<vector<int>> pos(n);
//		for (int i = 0; i < n; i++){
//			for (int j = start[n]; j + a[i].size() - 1 <= start[n] + a[n].size() - 1; j++){
//				if (h(start[i], start[i] + a[i].size() - 1) ==
//					h(j, j + a[i].size() - 1)){
//					pos[i].push_back(j - start[n]);
//				}
//			}
//		}
		vector<int> uniq;
		for (int i = 0; i < n; i++){
			uniq.push_back(a[i].size());
		}
		sort(all(uniq));
		uniq.erase(unique(all(uniq)), uniq.end());
		vector<set<H>> good(MAXN);
		for (int i = 0; i < n; i++){
			good[a[i].size()].insert(h(start[i], start[i] + a[i].size() - 1));
		}
		vector<vector<int>> pref(uniq.size(), vector<int>(t.size()));
//		for (int i = 0; i < n; i++){
//			for (auto& x : pos[i]){
//				cout << x << " ";
//			}
//			cout << "\n";
//		}
//		for (int i = 0; i < n; i++){
//			int t = lower_bound(all(uniq), a[i].size()) - uniq.begin();
//			for (auto& x : pos[i]){
//				pref[t][x]++;
//			}
//		}
		for (int i = 0; i < uniq.size(); i++){
			for (int j = 0; j + uniq[i] - 1 < t.size(); j++){
				ull curh = h(start[n] + j, start[n] + j + uniq[i] - 1);
				if (good[uniq[i]].find(curh) != good[uniq[i]].end()){
					pref[i][j]++;
				}
			}
		}
		for (int i = 0; i < uniq.size(); i++){
			for (int j = 1; j < t.size(); j++){
				pref[i][j] += pref[i][j - 1];
			}
		}
//		for (int i = 0; i < n; i++){
//			for (auto& x : pos[i]){
//				cout << x << " ";
//			}
//			cout << "\n";
//		}
		for (int id = 0; id < m; id++){
			int l, r;
			cin >> l >> r;
			ll res = 0;
			l--;
			r--;
//			cout << "id: " << id << "\n";
			for (int i = 0; i < uniq.size() && uniq[i] <= r - l + 1; i++){
//				int tl = lower_bound(all(pos[i]), l) - pos[i].begin();
//				int tr = upper_bound(all(pos[i]), r - a[i].size() + 1) - pos[i].begin();
//				cout << tl << " " << tr << "\n";
				res += pref[i][r - uniq[i] + 1];
				if (l){
					res -= pref[i][l - 1];
				}
			}
			cout << res << " ";
		}
	}
	return 0;
}
