#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);
#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

const int maxn = 5e5;
const int maxlen = 5e6;


int fenwick_tree[maxlen + 1];
struct Fenw {
    int get(int x) {
        int res = 0;
        for (; x > 0; x -= x & -x)
            res += fenwick_tree[x];
        return res;
    }

    void add(int x, int val) {
        for (; x <= maxlen; x += x & -x) {
            fenwick_tree[x] += val;
        }
    }
    int get(int l, int r) {
        return get(r - 1) - get(l - 1);
    }
};

const int P = 228;
const int Q = 1e9 + 7;

const int SEP = 320;

int p[maxlen + 1];

set<int> light;
vector<pair<int, int>> heavy;

void precalc() {
    p[0] = 1;
    for (int i = 1; i <= maxlen; ++i)
        p[i] = (p[i - 1] * P) % Q;
}

int get_h(string & s) {
    int h = 0;
    for (char c : s)
        h = (h * P + c) % Q;
    return h;
}

vector<pair<int, int>> req[maxlen + 1];

int prefhash[maxlen + 1];

int ans[maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int len = s.size();
    for (int i = 1; i <= len; ++i)
        prefhash[i] = (prefhash[i - 1] * P + s[i - 1]) % Q;

    for (int i = 0; i < n; ++i) {
        string d;
        cin >> d;
        int h = get_h(d);
        if (d.size() > SEP) {
            heavy.push_back({h, d.size()});
        } else {
            light.insert(h);
        }
    }

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        req[y].push_back({x, i});
    }

    Fenw fenw;

    
    for (int i = 1; i <= len; ++i) {
        for (int j = i; i - j + 1 <= SEP and j >= 1; --j) {
            int le = i - j + 1;
            int d = ((prefhash[i] - prefhash[j - 1] * p[le]) % Q + Q) % Q;
            if (light.count(d))
                fenw.add(j, 1);
        }
        for (auto [h, l] : heavy) {
            if (l > i)
                continue;
            int d = ((prefhash[i] - prefhash[i - l] * p[l]) % Q + Q) % Q;
            if (d == h)
                fenw.add(i - l + 1, 1);
        }

        for (auto [l, pos] : req[i]) {
            ans[pos] = fenw.get(l, i + 1);
        }
    }

    for (int i = 0; i < m; ++i)
        cout << ans[i] << " ";
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    precalc();
    solve();

    return 0;
}