#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);
#define endl '\n'
#define double ld


#pragma GCC optimize("Ofast")
#pragma GCC optimization("unroll-loops")

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}


const int maxn = 5e5;
const int maxlen = 5e5;

ll fenwick_tree[maxlen + 1];
struct Fenw {
    ll get(int x) {
        ll res = 0;
        for (; x > 0; x -= x & -x)
            res += fenwick_tree[x];
        return res;
    }

    void add(int x, int val) {
        for (; x <= maxlen; x += x & -x) {
            fenwick_tree[x] += val;
        }
    }
    ll get(int l, int r) {
        return get(r - 1) - get(l - 1);
    }
};


const int P = 228;
const ll Q1 = 1e9 + 7;
const ll Q2 = 1e9 + 9;

struct Hash {
    ll a = 0, b = 0;

    Hash operator-(Hash other) const {
        return {((a - other.a) % Q1 + Q1) % Q1, ((b - other.b) % Q2 + Q2) % Q2};
    }

    Hash operator+(Hash other) const {
        return {(a + other.a) % Q1, (b + other.b) % Q2};
    }

    Hash operator+(ll x) const {
        return {(a + x) % Q1, (b + x) % Q2};
    }

    Hash operator*(int p) const {
        return {a * p % Q1, b * p % Q2};
    }

    Hash operator*(Hash p) const {
        return {a * p.a % Q1, b * p.b % Q2};
    }

    bool operator==(Hash other) const {
        return a == other.a and b == other.b;
    }

    bool operator<(Hash other) const {
        if (a != other.a)
            return a < other.a;
        return b < other.b;
    }
};

const int SEP = 100;

Hash p[maxlen + 1];

struct HS {
    int operator()(Hash const& h) const {
        return h.a * Q2 + h.b;
    }
};

unordered_set<Hash, HS> light;
vector<pair<Hash, int>> heavy;

void precalc() {
    p[0] = {1, 1};
    for (int i = 1; i <= maxlen; ++i)
        p[i] = p[i - 1] * P;
}

Hash get_h(string & s) {
    Hash h;
    for (char c : s)
        h = h * P + Hash{c, c};
    return h;
}

vector<pair<int, int>> req[maxlen + 1];

Hash prefhash[maxlen + 1];

ll ans[maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int len = s.size();
    for (int i = 1; i <= len; ++i)
        prefhash[i] = prefhash[i - 1] * P + Hash{s[i - 1], s[i - 1]};

    for (int i = 0; i < n; ++i) {
        string d;
        cin >> d;
        Hash h = get_h(d);
        if (d.size() > SEP) {
            heavy.push_back({h, d.size()});
        } else {
            light.insert(h);
        }
    }

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        req[y].push_back({x, i});
    }

    Fenw fenw;

    for (int i = 1; i <= len; ++i) {
        for (int j = i; i - j + 1 <= SEP and j >= 1; --j) {
            int le = i - j + 1;
            Hash d = prefhash[i] - prefhash[j - 1] * p[le];
            if (light.count(d)) fenw.add(j, 1);
        }
        for (auto [h, l] : heavy) {
            if (l > i) continue;
            Hash d = prefhash[i] - prefhash[i - l] * p[l];
            if (d == h) fenw.add(i - l + 1, 1);
        }

        for (auto [l, pos] : req[i]) {
            ans[pos] = fenw.get(l, i + 1);
        }
    }

    for (int i = 0; i < m; ++i)
        cout << ans[i] << " ";
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    precalc();
    solve();

    return 0;
}