#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
ll p1 = 277, mod1 = 2286661337, p2 = 279, mod2 = 1e9 + 7;
ll powers1[5000000], powers2[5000000];
ll geth1(string& s) {
	ll h = 0;
	for (int i = 0; i < s.size(); i++) {
		h = (h * p1 + (s[i] - 'a' + 1)) % mod1;
	}
	return h;
}
ll geth2(string& s) {
	ll h = 0;
	for (int i = 0; i < s.size(); i++) {
		h = (h * p2 + (s[i] - 'a' + 1)) % mod2;
	}
	return h;
}
struct Hash1 {
	vector <ll> h;
	Hash1(string& s) {
		h.resize(s.size() + 1);
		for (int i = 0; i < s.size(); i++) {
			h[i + 1] = (h[i] * p1 + (s[i] - 'a' + 1)) % mod1;
		}
	}
	ll get(ll l, ll r) {
		return (h[r] - (h[l] * powers1[r - l]) % mod1 + mod1) % mod1;
	}
};
struct Hash2 {
	vector <ll> h;
	Hash2(string& s) {
		h.resize(s.size() + 1);
		for (int i = 0; i < s.size(); i++) {
			h[i + 1] = (h[i] * p2 + (s[i] - 'a' + 1)) % mod2;
		}
	}
	ll get(ll l, ll r) {
		return (h[r] - (h[l] * powers2[r - l]) % mod2 + mod2) % mod2;
	}
};
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	powers1[0] = 1, powers2[0] = 1;
	for (int i = 1; i <= 5e6; i++) powers1[i] = powers1[i - 1] * p1 % mod1, powers2[i] = powers2[i - 1] * p2 % mod2;
	set <ll> hs1, hs2;
	int n, m; cin >> n >> m;
	string t; cin >> t;
	Hash1 x1(t); Hash2 x2(t);
	if (n <= 100) {
		vector <pair <int, int>> gs;
		for (int i = 0; i < n; i++) {
			string s; cin >> s;
			if (s.size() > t.size()) continue;
			ll h1 = geth1(s), h2 = geth2(s);
			for (int l = 0; l <= t.size() - s.size(); l++) {
				if (x1.get(l, l + s.size()) == h1 && x2.get(l, l + s.size()) == h2) {
					gs.push_back({ l, l + s.size() - 1 });
				}
			}
		}
		sort(gs.begin(), gs.end());
		gs.erase(unique(gs.begin(), gs.end()), gs.end());
		vector <ll> st(t.size() + 1, 0), e(t.size() + 1, 0);
		int ind = 0;
		for (int i = 0; i < t.size(); i++) {
			int cnt = 0;
			while (ind < gs.size() && gs[ind].first == i) ind++, cnt++;
			st[i + 1] = st[i] + cnt;
		}
		for (int i = 0; i < gs.size(); i++) swap(gs[i].first, gs[i].second);
		sort(gs.begin(), gs.end());
		ind = 0;
		for (int i = 0; i < t.size(); i++) {
			int cnt = 0;
			while (ind < gs.size() && gs[ind].first == i) ind++, cnt++;
			e[i + 1] = e[i] + cnt;
		}
		while (m--) {
			int l, r; cin >> l >> r;
			cout << max(0ll, e[r] - st[l - 1]) << "\n";
		}
		return 0;
	}
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		hs1.insert(geth1(s));
		hs2.insert(geth2(s));
	}
	vector <vector <int>> kol(t.size(), vector <int>(t.size(), 0));
	for (int l = 0; l < t.size(); l++) {
		for (int r = l; r < t.size(); r++) {
			ll h1 = x1.get(l, r + 1), h2 = x2.get(l, r + 1);
			if (hs1.find(h1) != hs1.end() && hs2.find(h2) != hs2.end()) kol[l][r]++;
		}
	}
	for (int len = 1; len <= t.size(); len++) {
		for (int l = 0; l <= t.size() - len; l++) {
			int r = l + len - 1;
			if (l + 1 <= r) kol[l][r] += kol[l + 1][r];
			if (r - 1 >= l) kol[l][r] += kol[l][r - 1];
			if (l + 1 <= r - 1) kol[l][r] -= kol[l + 1][r - 1];
		}
	}
	while (m--) {
		int l, r; cin >> l >> r; l--, r--;
		cout << kol[l][r] << "\n";
	}
	return 0;
}