#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

#define ll long long

void build(int idx, int tl, int tr, vector<int>& dt, vector<vector<int>> &sp) {
	if (tl == tr) {
		for (int i = 0; i < sp[tl].size(); i++) {
			int len = sp[tl][i];

			if (len == 1) {
				dt[idx]++;
			}
		}
	}
	else {
		int tm = (tl + tr) / 2;

		build(2 * idx + 1, tl, tm, dt, sp);
		build(2 * idx + 2, tm + 1, tr, dt, sp);

		dt[idx] = dt[2 * idx + 1] + dt[2 * idx + 2];

		for (int i = tl; i <= tm; i++) {
			for (int j = 0; j < sp[i].size(); j++) {
				int len = sp[i][j];

				int en = i + len - 1;
				if (en <= tr && en > tm) {
					dt[idx]++;
				}
			}
		}
	}
}

int gets(int idx, int tl, int tr, int l, int r, vector<int>& dt, vector<vector<int>>& sp) {
	if (tl == l && tr == r) {
		return dt[idx];
	}
	else if (l > r) {
		return 0;
	}
	else {
		int tm = (tl + tr) / 2;

		int ret = gets(2 * idx + 1, tl, tm, l, min(r, tm), dt, sp);
		ret += gets(2 * idx + 2, tm + 1, tr, max(tm + 1, l), r, dt, sp);

		for (int i = l; i <= min(r, tm); i++) {
			for (int j = 0; j < sp[i].size(); j++) {
				int len = sp[i][j];

				int en = i + len - 1;
				if (en <= r && en > min(r, tm)) {
					ret++;
				}
			}
		}

		return ret;
	}
}


int main() {
	int n, m;
	cin >> n >> m;
	
	string t;
	cin >> t;

	vector<ll> p(t.size());

	p[0] = 1;

	ll e = 1e9 + 7;
	for (int i = 1; i < p.size(); i++) {
		p[i] = p[i - 1] * 31;
		p[i] %= e;
	}

	vector<ll> hash(t.size() + 1);

	hash[0] = 0;

	for (int i = 1; i < hash.size(); i++) {
		hash[i] = hash[i - 1];
		hash[i] += (p[i - 1] * (t[i - 1] - 'a')) % e;
		hash[i] %= e;
	}

	vector<string> v;
	for (int i = 0; i < n; i++) {
		string x;
		cin >> x;

		if (x.size() <= t.size()) {
			v.push_back(x);
		}
	}

	n = v.size();

	vector<ll> hashv(n, 0);

	for (int i = 0; i < n; i++) {
		for (int j = 0; j < v[i].size(); j++) {
			hashv[i] += (p[j] * (v[i][j] - 'a')) % e;
			hashv[i] %= e;
		}
	}

	vector<vector<int>> sp(t.size());

	// ХЕШИ!!!!!!! разность
	for (int i = 0; i < t.size(); i++) {
		for (int j = 0; j < n; j++) {
			if (i + v[j].size() <= t.size()) {

				int len = v[j].size();

				ll h1 = (hash[i + len] - hash[i] + e) % e;

				ll h2 = (hashv[j] * p[i]) % e;

				if (h1 == h2) {
					sp[i].push_back(len);
				}
			}
		}
	}

	vector<int> dt(4 * t.size());
	build(0, 0, t.size() - 1, dt, sp);

	

	vector<pair<int, int>> rq(m);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		rq[i] = { l, r };
	}

	for (int i = 0; i < m; i++) {
		cout << gets(0, 0, t.size() - 1, rq[i].first, rq[i].second, dt, sp) << " ";
	}
}