#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

const int N = 1e5 + 7, MOD2 = 1e9 + 7, MOD = 1000003, C = 10, p1 = 29, p2 = 31;

vector<int> hash2[MOD];

int n, k;

long long pows1[N* 10], pows2[N * 10];

int pref[N][1500], t, q;

string s;

int binpow(long long a, int step, int md) {
	if (step == 0) {
		return 1;
	}
	long long h = binpow(a, step / 2, md);
	h = (h * h) % md;
	if (step % 2) {
		h = (h * a) % md;
		return h;
	}
	return h;
}

struct window {
	long long h1, h2;
	int len;
	void build() {
		len = 0;
		h1 = 0;
		h2 = 0;
	}
	void add(char a) {
		int c = a - 'a' + 1;
		h1 += (pows1[len] * c) % MOD;
		h2 += (pows2[len] * c) % MOD2;
		len++;
		h1 %= MOD;
		h2 %= MOD2;
	}
	void del(char a) {
		int c = a - 'a' + 1;
		h1 -= c;
		h2 -= c;
		h1 *= binpow(p1, MOD - 2, MOD);
		h2 *= binpow(p2, MOD2 - 2, MOD2);
		h1 %= MOD;
		h2 %= MOD2;
		len--;
	}
};

window a;

vector<int> lengths;

int GetSum(int l, int r, int I) {
	if (l == 0) {
		return pref[r][I];
	}
	return pref[r][I] - pref[l - 1][I];
}

void solve() {
	cin >> t >> q;
	cin >> s;
	n = s.size();
	for (int i = 0; i < t; i++) {
		string s1;
		cin >> s1;
		lengths.push_back(s1.size());
		a.build();
		for (auto u : s1) {
			a.add(u);
		}
		hash2[a.h1].push_back(a.h2);
	}
	sort(lengths.begin(), lengths.end());
	lengths.resize(unique(lengths.begin(), lengths.end()) - lengths.begin());
	int I = 0;
	for (auto l : lengths) {
		if (l > n) {
			break;
		}
		a.build();
		for (int i = 0; i < l; i++) {
			a.add(s[i]);
		}
		for (int i = 0; i < n + 1 - l; i++) {
			if (find(hash2[a.h1].begin(), hash2[a.h1].end(), a.h2) != hash2[a.h1].end()) {
				pref[i][I] ++;
				//cout << i << "!\n";
			}
			a.del(s[i]);
			if (i + l < n)
				a.add(s[i + l]);
		}
		for (int i = 1; i < n; i++) {
			pref[i][I] += pref[i - 1][I];
		}
		I++;
	}

	for (int i = 0; i < q; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		long long answ = 0;
		int I = 0;
		for (auto len : lengths) {
			if (len > r - l + 1) {
				break;
			}
			answ += GetSum(l, r - len + 1, I);
			I++;
		}
		cout << answ << " ";
	}
}


signed main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	pows1[0] = 1;
	pows2[0] = 1;
	for (int i = 1; i < N * 10; i++) {
		pows1[i] = (pows1[i - 1] * p1) % MOD;
		pows2[i] = (pows2[i - 1] * p2) % MOD2;
	}
	int t;
	t = 1;
	while (t--) {
		solve();
	}
}