#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <numeric>
#include <random>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef vector<vpi> vvpi;
typedef tuple<int, int, int> ti;
typedef vector<ti> vti;
typedef set<int> si;
typedef multiset<int> msi;
typedef set<pi> spi;
typedef multiset<pi> mspi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef vector<bool> vb;
typedef vector<string> vs;

template<typename T> bool minravno(T& a, const T& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> bool maxravno(T& a, const T& b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename T> void print(const T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}
template<typename T> void sort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void rsort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
	reverse(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void reverse(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	reverse(a.begin() + i, a.begin() + (j + 1));
}

mt19937 rnd(228);
const int MAXN = 1e5;
int n, m;

vi n_func(string s) {
	int m = (s.size());
	int l = 0, r = 0;
	vi n(m);
	for (int i = 1; i < m; ++i) {
		if (i <= r)
			n[i] = min(r - i + 1, n[i - l]);
		while (n[i] + i < m && s[i + n[i]] == s[n[i]])
			n[i]++;
		if (i + n[i] - 1 > r) {
			r = i + n[i] - 1;
			l = i;
		}
	}
	return n;
}

vi t[4 * MAXN];

void build(vvi& a, int v, int tl, int tr) {
	if (tr - tl > 1) {
		int m = (tr + tl) / 2;
		build(a, v * 2, tl, m);
		build(a, v * 2 + 1, m, tr);
	}
	for (int i = tl; i < tr; ++i) {
		for (auto j : a[i])
			t[v].push_back(j);
	}
	sort(t[v]);
	//t[v].erase(unique(all(t[v])), t[v].end());
}

int get(int v, int tl, int tr, int l, int r, int x) {
	if (r <= tl || tr <= l)
		return 0;
	if (l <= tl && r >= tr)
		return upper_bound(all(t[v]), x) - t[v].begin();
	int m = (tr + tl) / 2;
	return get(v * 2, tl, m, l, r, x) + get(v * 2 + 1, m, tr, l, r, x);
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	cin >> n >> m;
	string t;
	cin >> t;
	vs s(n);
	input(s);
	vvi b(t.size());
	for (int i = 0; i < n; ++i) {
		vi nf = n_func(s[i] + "#" + t);
		for (int j = s[i].size() + 1; j < nf.size(); ++j) {
			if (nf[j] == s[i].size())
				b[j - s[i].size() - 1].push_back(j - 2);
		}
	}
	for (int i = 0; i < t.size(); ++i) {
		sort(b[i]);
		b[i].erase(unique(all(b[i])), b[i].end());
	}
	build(b, 1, 0, t.size());
	while (m--) {
		int l, r;
		cin >> l >> r;
		cout << get(1, 0, t.size(), l - 1, r, r - 1) << ' ';
	}

	return 0;
}