#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

#pragma GCC optimize("Ofast,no-stack-protector")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("unroll-loops")

const int INF = 1e8, MOD = 1e9 + 7;

vector<int> suff_arr(string& s)
{
	s.push_back('#');

	int n = s.size();
	vector<int> eq(n), sa(n);
	int cls = 0;
	map<int, vector<int>> mp;
	for (int i = 0; i < n; i++)
	{
		mp[s[i] - 'a'].push_back(i);
	}

	int idx = 0;
	for (auto& i : mp)
	{
		for (auto& j : i.second)
		{
			eq[j] = cls;
			sa[idx] = j;
			idx++;
		}
		cls++;
	}

	int d = 1;
	while (cls < n)
	{
		int ncls = 0;
		vector<int> neq(n);
		vector<vector<int>> srt(cls);
		for (int i = 0; i < n; i++)
		{
			int prev = (sa[i] - d + n) % n;
			srt[eq[prev]].push_back(prev);
		}

		idx = 0;
		for (int i = 0; i < cls; i++)
		{
			for (int j = 0; j < srt[i].size(); j++)
			{
				if (j == 0 || eq[(srt[i][j - 1] + d) % n] != eq[(srt[i][j] + d) % n])
				{
					ncls++;
				}

				neq[srt[i][j]] = ncls - 1;
				sa[idx] = srt[i][j];
				idx++;
			}
		}
		swap(eq, neq);
		cls = ncls;
		d *= 2;
	}
	sa.erase(sa.begin());
	s.pop_back();
	return sa;
}

vector<int> lcp_arr(vector<int>& sa, string& s)
{
	int n = s.size();
	vector<int> pos(n);
	for (int i = 0; i < n; i++)
	{
		pos[sa[i]] = i;
	}

	int k = 0;
	vector<int> lcp(n);
	for (int i = 0; i < n; i++)
	{
		if (k > 0)
		{
			k--;
		}
		if (pos[i] == n - 1)
		{
			lcp[n - 1] = 0;
			k = 0;
			continue;
		}

		int j = sa[pos[i] + 1];
		while (max(i + k, j + k) < n && s[i + k] == s[j + k])
		{
			k++;
		}
		lcp[pos[i]] = k;
	}
	return lcp;
}

void debug_sa(string& s, vector<int>& sa)
{
	cout << "!!!!!!!!!!!!!!!!!!\n";
	for (int i = 0; i < sa.size(); i++)
	{
		for (int j = sa[i]; j < s.size(); j++)
		{
			cout << s[j];
		}
		cout << "\n";
	}
	cout << "!!!!!!!!!!!!!!!!!!\n";
}

struct fenwick
{
	int n;
	vector<int> t;

	fenwick(int in)
	{
		n = in;
		t.resize(n + 1);
	}

	void upd(int k, int val)
	{
		k++;
		for (; k <= n; k += k & -k)
		{
			t[k] += val;
		}
	}

	int get(int k)
	{
		k++;
		int sum = 0;
		for (; k > 0; k -= k & -k)
		{
			sum += t[k];
		}
		return sum;
	}
};

const int N = 5000005;
//const int N = 100;
vector<pair<int, int>> qr[N];

void solve()
{
	int n, m;
	string t;
	vector<string> s;
	vector<int> sidx;
	cin >> n >> m >> t;
	s.resize(n);
	sidx.resize(n);
	for (int i = 0; i < n; i++)
	{
		cin >> s[i];
	}
	for (int i = 1; i < n; i++)
	{
		sidx[i] = sidx[i - 1] + s[i - 1].size();
	}

	string st;
	for (int i = 0; i < n; i++)
	{
		st += s[i];
	}
	st += t;
	vector<int> sa = suff_arr(st);
	vector<int> pos(st.size());
	for (int i = 0; i < sa.size(); i++)
	{
		pos[sa[i]] = i;
	}
	vector<int> lcp = lcp_arr(sa, st);

	//debug_sa(st, sa);

	// calc_lower
	vector<int> ask(sa.size(), -1);
	for (int i = 0; i < n; i++)
	{
		ask[pos[sidx[i]]] = s[i].size();
	}

	vector<int> stck;
	vector<int> lwl(sa.size(), -1);
	for (int i = 0; i < lcp.size(); i++)
	{
		if (ask[i] != -1)
		{
			if (!stck.size() || lcp[stck[0]] >= ask[i])
			{
				lwl[i] = -1;
			}
			else
			{
				int left = 0, right = stck.size();
				while (right - left > 1)
				{
					int mid = (left + right) / 2;
					if (lcp[stck[mid]] < ask[i])
					{
						left = mid;
					}
					else
					{
						right = mid;
					}
				}
				lwl[i] = stck[left];
			}
		}

		while (stck.size() && lcp[stck.back()] >= lcp[i])
		{
			stck.pop_back();
		}
		stck.push_back(i);
	}
	stck = {};
	vector<int> lwr(sa.size(), sa.size());
	for (int i = sa.size() - 1; i > -1; i--)
	{
		while (stck.size() && lcp[stck.back()] >= lcp[i])
		{
			stck.pop_back();
		}
		stck.push_back(i);

		if (ask[i] != -1)
		{
			if (!stck.size() || lcp[stck[0]] >= ask[i])
			{
				lwr[i] = sa.size();
			}
			else
			{
				int left = 0, right = stck.size();
				while (right - left > 1)
				{
					int mid = (left + right) / 2;
					if (lcp[stck[mid]] < ask[i])
					{
						left = mid;
					}
					else
					{
						right = mid;
					}
				}
				lwr[i] = stck[left];
			}
		}
	}

	vector<vector<int>> psum(sa.size() + 1);
	for (int i = 0; i < sa.size(); i++)
	{
		if (ask[i] == -1)
		{
			continue;
		}

		int left = lwl[i] + 1, right = lwr[i];
		psum[left].push_back(ask[i]);
		psum[right + 1].push_back(-ask[i]);
	}

	vector<vector<int>> mnlen(t.size());
	multiset<int> stlen;
	for (int i = 0; i < sa.size(); i++)
	{
		for (auto& j : psum[i])
		{
			if (j > 0)
			{
				stlen.insert(j);
			}
			else
			{
				stlen.erase(stlen.find(-j));
			}
		}
		if (stlen.size() && st.size() - sa[i] <= t.size())
		{
			for (auto& j : stlen)
			{
				int idx = t.size() - (st.size() - sa[i]);
				if (idx + j - 1 >= t.size())
				{
					break;
				}
				mnlen[idx].push_back(idx + j - 1);
			}
		}
	}

	for (int i = 0; i < m; i++)
	{
		int l, r;
		cin >> l >> r;
		l--;
		if (l > 0)
		{
			qr[l - 1].push_back({ -r, i });
		}
		qr[r - 1].push_back({ r, i });
	}

	fenwick ft(t.size() + 5);
	vector<int> ans(m);
	for (int i = 0; i < t.size(); i++)
	{
		for (auto& j : mnlen[i])
		{
			ft.upd(j, 1);
		}
		for (auto& [rr, idx] : qr[i])
		{
			if (rr < 0)
			{
				rr = abs(rr);
				rr--;
				ans[idx] -= ft.get(rr);
			}
			else
			{
				rr--;
				ans[idx] += ft.get(rr);
			}
		}
	}
	for (int i = 0; i < m; i++)
	{
		cout << ans[i] << " ";
	}
	cout << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	//cin >> tst;
	while (tst--)
	{
		solve();
	}

	return 0;
}

/*























*/