#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <algorithm>
#include <deque>
#include <queue>

using namespace std;

#define int long long

mt19937 rn;
vector<__int128> fen;

void add(__int128 i, __int128 x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

__int128 get(__int128 r) {
    __int128 res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    __int128 a, b, c;
};

struct po__int128 {
    __int128 x, y;

    po__int128 operator-(po__int128 a) {
        return po__int128{x - a.x, y - a.y};
    }

    __int128 operator*(po__int128 a) {
        return x * a.y - y - a.x;
    }

    __int128 operator%(po__int128 a) {
        return x * a.x + y * a.y;
    }

    po__int128 operator-(__int128 d) {
        return po__int128{x - d, y - d};
    }

    po__int128 operator+(__int128 d) {
        return po__int128{x + d, y + d};
    }
};

__int128 lcp(vector<__int128> a, vector<__int128> b) {
    vector<vector<__int128>> dp(a.size() + 1, vector<__int128>(b.size() + 1));
    __int128 n = a.size();
    __int128 m = b.size();
    for (__int128 i = 0; i < n; ++i) {
        for (__int128 j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

__int128 qq = 1791791;
int qq1 = 179;

__int128 get_hash(string s) {
    __int128 h = 0;
    for (auto i: s) {
        h = h * qq + i - 'a' + 1;
    }
    return h;
}

int mod = 1791791791;

int get_hash1(string s) {
    int h = 0;
    for (auto i: s) {
        h = h * qq1 + i - 'a' + 1;
        h %= mod;
    }
    return h;
}

int mm(int a){
    return (a % mod + mod) % mod;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    long long n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    set<__int128> c;
    vector<__int128> hashs(n);
    vector<int> hashs1(n);
    vector<__int128> ln(n);
    for (__int128 i = 0; i < n; ++i) {
        string s;
        cin >> s;
        __int128 h = get_hash(s);
        c.insert(h);
        hashs[i] = h;
        hashs1[i] = get_hash1(s);
        ln[i] = s.size();
    }
    if (n > 100) {
        vector<vector<long long>> dp(t.size(), vector<long long>(t.size()));
        for (__int128 i = 0; i < t.size(); ++i) {
            __int128 h = 0;
            for (__int128 j = i; j < t.size(); ++j) {
                h = h * qq + t[j] - 'a' + 1;
                dp[i][j] = c.count(h);
            }
        }
        vector<vector<long long>> ans(t.size(), vector<long long>(t.size()));
        for (__int128 i = 0; i < t.size(); ++i) {
            ans[i][i] = dp[i][i];
        }
        for (__int128 ln = 1; ln < t.size(); ++ln) {
            for (__int128 i = 0; i < t.size() - ln; ++i) {
                ans[i][i + ln] = ans[i + 1][i + ln] + ans[i][i + ln - 1] + dp[i][i + ln];
                if (ln > 1) {
                    ans[i][i + ln] -= ans[i + 1][i + ln - 1];
                }
            }
        }
        for (__int128 i = 0; i < m; ++i) {
            long long l, r;
            cin >> l >> r;
            --l;
            --r;
            cout << ans[l][r] << " ";
        }
    } else {
        vector<__int128> hash(t.size() + 1);
        vector<__int128> step(t.size() + 1, 1);
        for (__int128 i = 0; i < t.size(); ++i) {
            hash[i + 1] = hash[i] * qq + t[i] - 'a' + 1;
            step[i + 1] = step[i] * qq;
        }
        vector<int> hash1(t.size() + 1);
        vector<int> step1(t.size() + 1, 1);
        for (int i = 0; i < t.size(); ++i) {
            hash1[i + 1] = hash1[i] * qq1 + t[i] - 'a' + 1;
            hash1[i + 1] %= mod;
            step1[i + 1] = step1[i] * qq1;
            step1[i + 1] %= mod;
        }
        vector<vector<int>> sum(n, vector<int>(t.size() + 1));
        for (__int128 i = 0; i < n; ++i) {
            for (__int128 j = ln[i]; j <= t.size(); ++j) {
                if (hashs[i] == hash[j] - hash[j - ln[i]] * step[ln[i]] &&
                    hashs1[i] == mm(hash1[j] - hash1[j - ln[i]] * step1[ln[i]])) {
                    sum[i][j - ln[i]]++;
                }
            }
            for (int j = 1; j < t.size() + 1; ++j) {
                sum[i][j] += sum[i][j - 1];
            }
        }
        for (__int128 i = 0; i < m; ++i) {
            long long l, r;
            cin >> l >> r;
            --l;
            __int128 ans = 0;
            for (__int128 j = 0; j < n; ++j) {
                if (r - l >= ln[j]) {
                    ans += sum[j][r - ln[j]];
                    if (l > 0) {
                        ans -= sum[j][l - 1];
                    }
                }
            }
            cout << (long long) ans << " ";
        }
    }
}