#define _CRT_SECURE_NO_WARNINGS
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#include <cmath>
#include <deque>
#include <set>
#include <map>
using namespace std;

using ll = long long;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll BASE = 31;
const ll MOD1 = 1e9 + 7;
const ll MOD2 = 1e9 + 1000 - 7;

string s;

vector<pair<ll, ll>> p, h;

void precalc() {
	p.resize(s.size() + 1);
	h.resize(s.size() + 1);
	p[0] = { 1, 1 };
	h[0] = { 0, 0 };
	for (int i = 1; i <= s.size(); ++i) {
		p[i] = { (p[i - 1].first * BASE) % MOD1, (p[i - 1].second * BASE) % MOD2 };
		h[i] = { (h[i - 1].first * BASE + (s[i - 1] - 'a' + 1)) % MOD1, (h[i - 1].second * BASE + (s[i - 1] - 'a' + 1)) % MOD2 };
	}
}

pair<ll, ll> getHash(int l, int r) {
	return { ((h[r].first - h[l].first * p[r - l].first) % MOD1 + MOD1) % MOD1, ((h[r].second - h[l].second * p[r - l].second) % MOD2 + MOD2) % MOD2 };
}

pair<ll, ll> getHash(const string& s) {
	pair<ll, ll> res = { 0, 0 };
	for (int i = 0; i < s.size(); ++i) {
		res = { (res.first * BASE + (s[i] - 'a' + 1)) % MOD1, (res.second * BASE + (s[i] - 'a' + 1)) % MOD2 };
	}
	return res;
}

void solve() {
	int n, m;
	cin >> n >> m;
	cin >> s;
	precalc();
	set<pair<ll, ll>> st;
	for (int i = 0; i < n; ++i) {
		string t;
		cin >> t;
		st.insert(getHash(t));
	}
	vector<vector<ll>> pref(s.size() + 1, vector<ll>(s.size() + 1, 0));
	for (int i = 1; i <= s.size(); ++i) {
		for (int j = 1; j <= s.size(); ++j) {
			int v = (j >= i ? st.count(getHash(i - 1, j)) : 0);
			pref[i][j] = pref[i - 1][j] + pref[i][j - 1] - pref[i - 1][j - 1] + v;
		}
	}

	for (int i = 0; i < m; ++i) {
		int ql, qr;
		cin >> ql >> qr;
		ql--;
		cout << pref[qr][qr] - pref[ql][qr] - pref[qr][ql] + pref[ql][ql] << " ";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	solve();
	//int t;
	//cin >> t;
	//while (t--) {
	//	solve();
	//}
}