#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod[2] = {int(1e9) + 9, int(1e9) + 321};
const ll P[2] = {239, 119};

const int MAXS = 1e5 + 10;
vector<int> hashs[MAXS];
vector<int> inds[MAXS];
int pw[2][MAXS];

const int MAXN = 1e5 + 10;
int h[2][MAXN] = {};

void buildHashs(string& s) {
    int n = s.size();
    for (int i = 0; i < n; i++) {
        h[0][i + 1] = (h[0][i] * P[0] + (s[i] - 'a' + 1)) % mod[0];
        h[1][i + 1] = (h[1][i] * P[1] + (s[i] - 'a' + 1)) % mod[1];
    }
}

ll getHash(string& s) {
    int n = s.size();
    vector<ll> h = {0, 0};
    for (int i = 0; i < n; i++) {
        h[0] = (h[0] * P[0] + (s[i] - 'a' + 1)) % mod[0];
        h[1] = (h[1] * P[1] + (s[i] - 'a' + 1)) % mod[1];
    }

    ll res = h[0] * mod[1] + h[1];
    return res;
}

ll getHash(int l, int r) {
    ll h0 = (h[0][r] - 1LL * h[0][l] * pw[0][r - l]) % mod[0];
    ll h1 = (h[1][r] - 1LL * h[1][l] * pw[1][r - l]) % mod[1];
    if (h0 < 0) h0 += mod[0];
    if (h1 < 0) h1 += mod[1];
    ll res = h0 * mod[1] + h1;
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pw[0][0] = pw[1][0] = 1;
    for (int i = 1; i < MAXS; i++) {
        pw[0][i] = (pw[0][i - 1] * P[0]) % mod[0];
        pw[1][i] = (pw[1][i - 1] * P[1]) % mod[1];
    }

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int t_len = t.length();
    buildHashs(t);

    vector<int> l;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int len = s.length();
        l.push_back(len);
        hashs[len].push_back(getHash(s));
    }

    sort(all(l));
    l.resize(unique(all(l)) - l.begin());
    for (auto len : l) {
        sort(all(hashs[len]));
        for (int i = 0; i < t_len; i++) {
            if (i + len - 1 < t_len) {
                ll cur = getHash(i, i + len);
                auto it = lower_bound(all(hashs[len]), cur);
                if (it != hashs[len].end() && *it == cur) {
                    inds[len].push_back(i + 1);
                }
            }
        }
    }

    for (int i = 0; i < m; i++) {
        int lq, rq;
        cin >> lq >> rq;
        ll ans = 0;
        for (auto len : l) {
            if (lq + len - 1 > rq) {
                break;
            }
            ans += upper_bound(all(inds[len]), rq - len + 1) - lower_bound(all(inds[len]), lq);
        }
        cout << ans << ' ';
    }

    return 0;
}