#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 321;
const ll P = 239;

const int MAXS = 1e6 + 10;
const int MAXN = 1e6 + 10;
cc_hash_table<int, int> hashs[MAXS];
vector<int> pref[MAXS];
int pw[MAXS];
int h[MAXN] = {};

void buildHashs(string& s) {
    int n = s.size();
    for (int i = 0; i < n; i++)  h[i + 1] = (h[i] * P + (s[i] - 'a' + 1)) % mod;
}

int getHash(string& s) {
    int n = s.size();
    ll h = 0;
    for (int i = 0; i < n; i++) h = (h * P + (s[i] - 'a' + 1)) % mod;
    return h;
}

int getHash(int l, int r) {
    ll res = (h[r] - 1LL * h[l] * pw[r - l]) % mod;
    if (res < 0) res += mod;
    return res;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int t_len = t.length();
    buildHashs(t);

    pw[0] = 1;
    for (int i = 1; i <= t_len; i++) pw[i] = (pw[i - 1] * P) % mod;

    vector<int> l;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        int len = s.length();
        l.push_back(len);
        hashs[len][getHash(s)] = 1;
    }

    sort(all(l));
    l.resize(unique(all(l)) - l.begin());
    for (auto len : l) {
        pref[len].resize(t_len + 1);
        for (int i = 0; i < t_len; i++) {
            pref[len][i + 1] = pref[len][i];
            if (i + len - 1 < t_len) {
                int cur = getHash(i, i + len);
                if (hashs[len].find(cur) != hashs[len].end()) {
                    pref[len][i + 1]++;
                }
            }
        }
    }

    for (int i = 0; i < m; i++) {
        int lq, rq;
        cin >> lq >> rq;
        ll ans = 0;
        for (auto len : l) {
            if (lq + len - 1 > rq) {
                break;
            }
            ans += pref[len][rq - len + 1] - pref[len][lq - 1];
        }
        cout << ans << ' ';
    }

    return 0;
}