#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <unordered_set>

#define   unsigned long long -> long long;
using namespace std;

long long mod = 1e9 + 7;
long long p = 57;

vector < long long > ch;
vector < long long > deg;

long long get_hash(const string& a) {
    long long h = 0;
    for (auto i : a) {
        h = ((h * p) % mod + (i - 'a' + 1)) % mod;
        h %= mod;
    }
    return h;
}

void zapolni(const string& s) {
    long long h = 0;
    for (long long i = 0; i < s.size(); i++) {
        h = ((h * p) % mod + (s[i] - 'a' + 1)) % mod;
        h %= mod;
        ch[i] = h;
    }
}

void stepen() {
    long long t = 0;
    for (long long i = 0; i < deg.size(); i++) {
        t = (t * p) % mod;
        if (i == 0)t = 1;
        deg[i] = t;
    }
}

long long get(long long l, long long r) {
    l--;
    if (l < 0) {
        return ch[r];
    }
    return (ch[r] - ch[l] * deg[r - l] % mod);
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    unordered_set < long long > q;
    for (long long i = 0; i < n; i++) {
        string a;
        cin >> a;

        q.insert(get_hash(a));
    }
    
    ch.resize(s.size());
    zapolni(s);

    deg.resize(s.size());
    stepen();
    
    vector < long long > answer(m);
    for (long long i = 0; i < m; i++) {
        long long l, r;
        cin >> l >> r;
        l--; r--;

        long long kol = 0;
        for (long long j = l; j <= r; j++) {
            for (long long len = 0; j + len <= r; len++) {
                if (q.find(get(j, j + len)) != q.end()) {
                    //cout << j << " " << j + len << '\n';
                    kol++;
                }
            }
        }

        answer[i] = kol;
    }

    for (auto i : answer) {
        cout << i << " ";
    }
}