#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second
#define endl '\n'
#define double long double

int mod1 = 1e9 + 7;
int mod2 = 1e9 + 9;

struct Hash{
    int h1, h2;
    Hash(): h1(1), h2(1){}
    Hash(int H1, int H2): h1(H1), h2(H2){}

    Hash operator*(int a) {
        Hash c;
        c.h1 = (a * h1) % mod1;
        c.h2 = (a * h2) % mod2;
        return c;
    }
    Hash operator+(int a) {
        Hash c;
        c.h1 = (a + h1) % mod1;
        c.h2 = (a + h2) % mod2;
        return c;
    }
};

Hash operator+(Hash a, Hash b) {
    Hash c;
    c.h1 = (a.h1 + b.h1) % mod1;
    c.h2 = (a.h2 + b.h2) % mod2;
    return c;
}
Hash operator-(Hash a, Hash b) {
    Hash c;
    c.h1 = (a.h1 - b.h1 + mod1) % mod1;
    c.h2 = (a.h2 - b.h2 + mod2) % mod2;
    return c;
}
Hash operator*(Hash a, Hash b) {
    Hash c;
    c.h1 = (a.h1 * b.h1) % mod1;
    c.h2 = (a.h2 * b.h2) % mod2;
    return c;
}
bool operator == (Hash a, Hash b) {
    return b.h1 == a.h1 and b.h2 == a.h2;
}

Hash get_hash(int l, int r, vector<Hash> &h, vector<Hash> &p) {
    Hash c = h[r] - (h[l - 1] * p[r - l + 1]);
    return c;
}


signed main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout << setprecision(17);

    Hash pw = {239, 53};

    vector<Hash> p(100005, {1, 1});

    for (int i = 1; i < 100000; i++) {
        p[i] = p[i - 1] * pw;
    }

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    t = "#" + t;

    vector<Hash> hash_t(t.size(), {0, 0});

    int len = t.size();
    for (int i = 1; i < len; i++) {
        hash_t[i] = hash_t[i - 1] * pw + (int)(t[i] - 'a' + 1);
    }

    vector<Hash> hash(n);
    vector<int> ll(n);

    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;

        ll[i] = s.size();

        Hash h = {0, 0};

        for (int j = 0; j < s.size(); j++) {
            h = h * pw + (int)(s[j] - 'a' + 1);
        }

        hash[i] = h;
    }

    vector<vector<int>> pos(n);

    for (int i = 1; i < len; i++) {
        for (int j = 0; j < n; j++) {
            if (i + ll[j] > len) continue;
            Hash hhru = get_hash(i, i + ll[j] - 1, hash_t, p);
            if (hhru == hash[j]) {
                pos[j].push_back(i);
            }
        }
    }

    while (m--) {
        int l, r;
        cin >> l >> r;

        int cnt = 0;

        for (int i = 0; i < n; i++) {
            auto it2 = upper_bound(pos[i].begin(), pos[i].end(), r - ll[i] + 1) - pos[i].begin();
            auto it1 = lower_bound(pos[i].begin(), pos[i].end(), l) - pos[i].begin();

            cnt += max(0LL, it2 - it1);
        }

        cout << cnt << " ";
    }

    return 0;
}

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5
 */

/*
 4 4
abcdca
ab
ca
bcd
opedrftghyj
1 5
2 2
2 6
1 6
 */