#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

constexpr ll mod1 = 1e9 + 7, mod2 = 2286661337, p1 = 237, p2 = 371;
vector<ll>pp1, pp2;

pair<ll, ll> get_hashes(string& s) {
	ll h1 = 0, h2 = 0;
	for (int i = 0; i < s.size(); i++) {
		h1 = (h1 * p1 % mod1 + s[i] - 'a' + 1) % mod1;
		h2 = (h2 * p2 % mod2 + s[i] - 'a' + 1) % mod2;
	}
	return { h1, h2 };
}

vector<ll>h1, h2;
ll get_hash1(int l, int r) {
	return (h1[r + 1] - h1[l] * pp1[r - l + 1] % mod1 + mod1) % mod1;
}
ll get_hash2(int l, int r) {
	return (h2[r + 1] - h2[l] * pp2[r - l + 1] % mod2 + mod2) % mod2;
}

vector<int>tree;
void upd(int i, int l, int r, int v) {
	if (i < l || r <= i)
		return;
	if (l + 1 == r) {
		tree[v]++;
		return;
	}
	int m = (l + r) / 2;
	upd(i, l, m, 2 * v + 1);
	upd(i, m, r, 2 * v + 2);
	tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}
int get(int ql, int qr, int l, int r, int v) {
	if (ql <= l && r <= qr)
		return tree[v];
	if (qr <= l || r <= ql)
		return 0;
	int m = (l + r) / 2;
	return get(ql, qr, l, m, 2 * v + 1) + get(ql, qr, m, r, 2 * v + 2);
}

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	pp1.resize(1e6 + 1, 1);
	pp2.resize(1e6 + 1, 1);
	for (int i = 1; i < pp1.size(); i++) {
		pp1[i] = pp1[i - 1] * p1 % mod1;
		pp2[i] = pp2[i - 1] * p2 % mod2;
	}
	int n, m;
	cin >> n >> m;
	string t; cin >> t;
	h1.resize(t.size() + 1);
	h2.resize(t.size() + 1);
	for (int i = 1; i <= t.size(); i++) {
		h1[i] = (h1[i - 1] * p1 % mod1 + t[i - 1] - 'a' + 1) % mod1;
		h2[i] = (h2[i - 1] * p2 % mod2 + t[i - 1] - 'a' + 1) % mod2;
	}
	vector<pair<ll, ll>>hashes(n);
	vector<int>lens(n);
	for (int i = 0; i < n; i++) {
		string s; cin >> s;
		hashes[i] = get_hashes(s);
		lens[i] = s.size();
	}
	vector<vector<int>>rights(t.size());
	for (int j = 0; j < n; j++) {
		for (int i = lens[j] - 1; i < t.size(); i++) {
			int l = i - lens[j] + 1;
			if (get_hash1(l, i) == hashes[j].first && get_hash2(l, i) == hashes[j].second)
				rights[l].push_back(i);
		}
	}
	vector<vector<pair<int, int>>>reqs(t.size());
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--, r--;
		reqs[l].push_back({ r, i });
	}
	vector<int>ans(m);
	tree.resize(4 * t.size());
	for (int i = int(t.size() - 1); i >= 0; i--) {
		for (int r : rights[i])
			upd(r, 0, t.size(), 0);
		for (auto q : reqs[i]) {
			ans[q.second] = get(i, q.first + 1, 0, t.size(), 0);
		}
	}
	for (auto i : ans)
		cout << i << ' ';
	return 0;
}