#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#define ll long long
#define ld long double

// login: open-2023-382
// passw: 6tgd8wpk

using namespace std;

const ll inf = 1e18;

class Point {
public:
	ld x, y;
	Point() = default;
	Point(ld x, ld y) {
		this->x = x;
		this->y = y;
	}
};

class Vector {
public:
	ld x, y;
	Vector() = default;
	Vector(ld x, ld y) {
		this->x = x;
		this->y = y;
	}
	Vector(Point a, Point b) {
		this->x = b.x - a.x;
		this->y = b.y - a.y;
	}
};

// (x - xa) / (xb - xa) = (y - ya) / (yb - ya)
// x(yb - ya) - xa(yb - ya) = y(xb - xa) - ya(xb - xa)
// x(yb - ya) - y(xb - xa) - xa(yb - ya) + ya(xb - xa) = 0

class Line {
public:
	ld a, b, c;
	Line() = default;
	Line(ld a, ld b, ld c) {
		this->a = a;
		this->b = b;
		this->c = c;
	}
	Line(Vector v, Point a) {
		this->a = v.x;
		this->b = v.y;
		this->c = -this->a * a.x - this->b * a.y;
	}
	Line(Point a, Point b) {
		this->a = b.y - a.y;
		this->b = -(b.x - a.x);
		this->c = a.y * (b.x - a.x) - a.x * (b.y - a.y);
	}
};

ld scalSol(Vector a, Vector b) {
	return a.x * b.x + a.y * b.y;
}

ld vectSol(Vector a, Vector b) {
	return a.x * b.y - a.y * b.x;
}

ll n, m;
string t;
vector<string> s;
vector<ll> l, r, ans;

const ll MOD = 1e9 + 9, p = 4242;

void read() {
	cin >> n >> m;
	cin >> t;
	l = r = vector<ll>(m);
	s = vector<string>(n);
	for (ll i = 0; i < n; i++) {
		cin >> s[i];
	}
	for (ll i = 0; i < m; i++) {
		cin >> l[i] >> r[i];
	}
}

set<ll> sizes;
set<ll> H[1000001];
vector<ll> hashT;
ll step[5000001];

ll getT(ll l, ll r) {
	l--;
	return (hashT[r] - (hashT[l] * step[r - l] % MOD) + 2 * MOD) % MOD;
}

void build() {
	step[0] = 1;
	for (ll i = 1; i <= 5000000; i++) {
		step[i] = (step[i - 1] * p) % MOD;
	}

	for (ll i = 0; i < n; i++) {
		if ((ll)s[i].size() > (ll)t.size()) continue;
		ll h = 0;
		for (ll j = 0; j < (ll)s[i].size(); j++) {
			h = (h * p) % MOD;
			h += s[i][j];
		}
		H[(ll)s[i].size()].insert(h);
		sizes.insert((ll)s[i].size());
	}
	hashT = vector<ll>((ll)t.size() + 1);
	hashT[0] = 0;
	for (ll i = 1; i <= (ll)t.size(); i++) {
		hashT[i] = (hashT[i - 1] * p + t[i - 1]) % MOD;
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);

	read();
	build();
	ans = vector<ll>(m);
	for (auto& cur : sizes) {
		vector<ll> cnt((ll)t.size() + 1, 0);
		for (ll i = cur; i <= (ll)t.size(); i++) {
			ll suf = getT(i - cur + 1, i);
			if (H[cur].find(suf) != H[cur].end()) {
				cnt[i] = 1;
			}
		}
		vector<ll> pref((ll)t.size() + 1);
		for (ll i = 1; i <= (ll)t.size(); i++) {
			pref[i] = pref[i - 1] + cnt[i];
		}
		for (ll i = 0; i < m; i++) {
			ll curR = r[i];
			ll curL = l[i] + cur - 1;
			if (curR < curL) {
				continue;
			}
			ans[i] += pref[curR] - pref[curL - 1];
		}
	}
	for (ll i = 0; i < m; i++) {
		cout << ans[i] << ' ';
	}

	return 0;
}