#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

const ll MOD1 = 1e9+321, P1 = 29;
const ll MOD2 = 1e9+123, P2 = 31;
vector<ll> pows1, pows2;
int MX;

struct fenwick {

    fenwick(int n) : n(n) {
        v.resize(n);
    }

    void add(int r, int x) {
        for (; r < n; r = r | (r + 1)) {
            v[r] += x;
        }
    }

    int get(int r) {
        int s = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            s += v[r];
        }
        return s;
    }

    int n;
    vector<ll> v;

};

struct qr {

    qr() {}
    qr(int l, int r, int i) : l(l), r(r), i(i) {}

    int l, r, i;

};

int n, m;
string t;
vector<string> v;
vector<qr> qrs;

void solve() {

    cin >> n >> m;
    cin >> t;
    v.resize(n);
    for (auto& x : v) cin >> x;
    qrs.resize(m);
    for (int i = 0; i < m; i++) {
        cin >> qrs[i].l >> qrs[i].r;
        qrs[i].l--, qrs[i].r--;
        qrs[i].i = i;
    }

    MX = t.size();
    for (auto& x : v) MX = max(MX, (int)x.size());

    pows1.resize(MX + 1);
    pows1[0] = 1;
    for (int i = 1; i <= MX; i++) {
        pows1[i] = (pows1[i - 1] * P1) % MOD1;
    }
    pows2.resize(MX + 1);
    pows2[0] = 1;
    for (int i = 1; i <= MX; i++) {
        pows2[i] = (pows2[i - 1] * P2) % MOD2;
    }

    sort(all(v), [](const string& a, const string& b) {
        return a.size() < b.size();
    });

    unordered_set<ll> s;

    vector<vector<int>> pos(t.size());
//    for (int i = 0; i < pos.size(); i++) pos[i].reserve(500);
    for (int i = 0; i < n; i++) {
        if (i == 0 || v[i - 1].size() != v[i].size()) s.clear();
        ll h1 = 0, h2 = 0;
        for (int j = 0; j < v[i].size(); j++) {
            h1 = (h1 + (ll)(v[i][j] - 'a' + 1) * pows1[j]) % MOD1;
            h2 = (h2 + (ll)(v[i][j] - 'a' + 1) * pows2[j]) % MOD2;
        }
        s.insert(((ll)(h1 * pows1[MX - v[i].size() + 1] % MOD1) << 32) + h2 * pows2[MX - v[i].size() + 1] % MOD2);

        if (i == n - 1 || v[i].size() != v[i + 1].size()) {
            vector<int> pref1(t.size()), pref2(t.size());
            for (int j = 0; j < t.size(); j++) {
                pref1[j] = ((ll)(t[j] - 'a' + 1) * pows1[j] + (ll)(j == 0 ? 0 : pref1[j - 1])) % MOD1;
                pref2[j] = ((ll)(t[j] - 'a' + 1) * pows2[j] + (ll)(j == 0 ? 0 : pref2[j - 1])) % MOD2;
                if (j + 1 >= v[i].size()) {
                    int h1 = (ll)(MOD1 + (ll)pref1[j] - (ll)(j + 1 == v[i].size() ? 0 : pref1[j - v[i].size()])) * pows1[MX - j] % MOD1;
                    int h2 = (ll)(MOD2 + (ll)pref2[j] - (ll)(j + 1 == v[i].size() ? 0 : pref2[j - v[i].size()])) * pows2[MX - j] % MOD2;
                    if (s.find(((ll)(h1) << 32) + h2) != s.end()) pos[j].push_back(j - v[i].size() + 1);
                }
            }
        }
    }

//    for (int i = 0; i < t.size(); i++) {
//        cout << i << ": ";
//        for (int j = 0; j < pos[i].size(); j++) {
//            cout << pos[i][j].first << " " << pos[i][j].second << ", ";
//        }
//        cout << "\n";
//    }

    sort(all(qrs), [](qr a, qr b) {
        return a.r < b.r;
    });

    fenwick f(t.size());
    vector<ll> ans(m);

    int ptr = 0;
    for (int i = 0; i < t.size(); i++) {
        for (int j = 0; j < pos[i].size(); j++) {
            f.add(pos[i][j], 1);
        }
        while (ptr < m && qrs[ptr].r == i) {
            ans[qrs[ptr].i] = f.get(t.size() - 1) - f.get(qrs[ptr].l - 1);
            ptr++;
        }
    }

    cout << ans;

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    cout << setprecision(10) << fixed;
    solve();

}