#include <iostream>
#include <bits/stdc++.h>
#define ll long long

using namespace std;

const ll mod = 1e9 + 7, k = 179;

vector<int> hashes, st;

void calc(string &t){
    int hash = 0;
    for (auto c : t){
        int sym = (c - 'a' + 1);
        hash = (ll)(hash * 1ll * k + (ll)sym) % mod;
        hashes.push_back(hash);
    }
}

int get(int l, int r){
    if (l == 0) return hashes[r];
    return (((ll)hashes[r] - (ll)(hashes[l - 1] * 1ll * st[r - l + 1]) % mod) % mod + mod) % mod;
}

const int maxn = 5e3, sq = 1000;
set<int> h[sq];
int finds[sq][maxn], dif[sq];


signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    int main_size = (int) t.size();

    st.assign(main_size + 1, 0);
    st[0] = 1;
    for (int i = 1; i <= main_size; i ++){
        st[i] = (st[i - 1] * 1ll * k) % mod;
    }

    calc(t);

    if (n <= 5e3 && main_size <= 5e3){
        vector<pair<int, int>> words;

        string s;

        for (int i = 0; i < n; i++) {
            int hash = 0;
            cin >> s;
            for (auto c: s) {
                int pos = (c - 'a' + 1);
                hash = (hash * 1ll * k + (ll)pos) % mod;
            }
            words.push_back({(int)s.size(), hash});
        }
        sort(words.begin(), words.end());

        int pr = -1;
        int cnt = -1;
        for (int i = 0; i < n; i ++){
            if (pr != words[i].first){
                cnt ++;
                dif[cnt] = words[i].first;
            }
            h[cnt].insert(words[i].second);
            pr = words[i].first;
        }
        int SQRT = cnt + 1;

        for (int j = 0; j < SQRT; j ++){
            int l = dif[j];
            for (int i = 0; i <= main_size - l; i ++){
                if (h[j].find(get(i, i + l - 1)) != h[j].end()){
                    finds[j][i] = 1;
                }
            }
        }
        for (int i = 0; i < SQRT; i++) {
            for (int j = 0; j < main_size; j++) {
                finds[i][j] += (j == 0 ? 0 : finds[i][j - 1]);
            }
        }

        for (int i = 0; i < m; i++) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            int ans = 0;
            for (int j = 0; j < SQRT; j++) {
                int rik = r - dif[j] + 1;
                if (l > rik) continue;
                ans += finds[j][rik] - (l == 0 ? 0 : finds[j][l - 1]);
            }
            cout << ans << " ";
        }
        return 0;
    }

    vector<vector<int>> find(n, vector<int>(main_size, 0));
    vector<int> len(n);
    string s;

    for (int i = 0; i < n; i++) {
        int hash = 0;
        cin >> s;
        for (auto c: s) {
            int pos = (c - 'a' + 1);
            hash = (hash * k + pos) % mod;
        }
        len[i] = (int) s.size();


        for (int j = 0; j <= main_size - len[i]; j++) {
            if (get(j, j + len[i] - 1) == hash) {
                find[i][j] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < main_size; j++) {
            find[i][j] += (j == 0 ? 0 : find[i][j - 1]);
        }
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            int rik = r - len[j] + 1;
            if (l > rik) continue;
            ans += find[j][rik] - (l == 0 ? 0 : find[j][l - 1]);
        }
        cout << ans << " ";
    }
}

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

 */