#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename K, typename V, typename Cmp = less<K>>
using ordered_map =
    __gnu_pbds::tree<K, V, Cmp, __gnu_pbds::rb_tree_tag,
                     __gnu_pbds::tree_order_statistics_node_update>;

template <typename T, typename Cmp = less<T>>
using ordered_set = ordered_map<T, __gnu_pbds::null_type, Cmp>;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
  return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
  return os << p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
  for (T& e : v) is >> e;
  return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
  for (const T& e : v) os << e << " ";
  return os;
}
template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}
template <typename T>
void chmin(T& a, const T& b) {
  if (a > b) a = b;
}

void solve();

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

struct aho_node {
  char c = -1;
  array<i32, 26> next = {0};
  i32 p = 0, suff = 0, suff_end = 0, i = -1;
  bool end = false;
};

pair<vector<aho_node>, vector<i32>> make_corasick(const vector<string>& words) {
  vector<aho_node> corasick;
  vector<i32> ind(size(words));
  corasick.push_back({});
  // construct trie
  for (int i = 0; i < ssize(words); ++i) {
    const string& s = words[i];
    i32 cur = 0;
    for (char c : s) {
      if (corasick[cur].next[c - 'a'] == 0) {
        corasick[cur].next[c - 'a'] = (i32)ssize(corasick);
        corasick.push_back({.c = (char)(c - 'a'), .p = cur});
      }
      cur = corasick[cur].next[c - 'a'];
    }
    corasick[cur].end = true;
    corasick[cur].i = i;
    ind[i] = cur;
  }
  // suff links
  queue<i32> q;
  for (int i = 0; i < 26; ++i) {
    i32 u;
    if (u = corasick[0].next[i]; u == 0) continue;
    for (int j = 0; j < 26; ++j) {
      i32 v;
      if (v = corasick[u].next[j]; v == 0) continue;
      q.push(v);
    }
  }
  while (!q.empty()) {
    i32 u = q.front();
    q.pop();
    const char c = corasick[u].c;
    i32 p = corasick[u].p;
    while (p != 0 && corasick[corasick[p].suff].next[c] == 0) {
      p = corasick[p].suff;
    }
    corasick[u].suff = corasick[corasick[p].suff].next[c];
    corasick[u].suff_end = corasick[corasick[u].suff].suff_end;
    if (corasick[corasick[u].suff].end)
      corasick[u].suff_end = corasick[u].suff;
    for (int i = 0; i < 26; ++i) {
      i32 v;
      if (v = corasick[u].next[i]; v == 0) continue;
      q.push(v);
    }
  }
  return {corasick, ind};
}


void solve() {
  i32 n, m;
  string text;
  cin >> n >> m >> text;
  vector<string> words(n);
  cin >> words;

  vector<i32> len;
  for (const string& s : words) len.push_back((i32)ssize(s));
  sort(ALL(len));
  len.erase(unique(ALL(len)), len.end());
  vector<i32> len_i(n);
  for (int i = 0; i < n; ++i) {
    len_i[i] = lower_bound(ALL(len), (i32)ssize(words[i])) - len.begin();
  }
  vector<vector<i64>> start_cnt(size(len), vector<i64>(size(text)));

  auto [corasick, ind] = make_corasick(words);
  vector<set<i32>> ends(n);
  i32 cur = 0;
  for (int i = 0; i < ssize(text); ++i) {
    char c = text[i] - 'a';
    while (cur != 0 && corasick[cur].next[c] == 0) {
      cur = corasick[cur].suff;
    }
    cur = corasick[cur].next[c];
    if (corasick[cur].end) {
      ends[corasick[cur].i].insert(i);
    } else {
      i32 u = corasick[cur].suff_end;
      if (u != 0) ends[u].insert(i);
    }
  }
  map<i32, i32> r_ind;
  for (int i = 0; i < n; ++i) {
    r_ind[ind[i]] = i;
  }
  vector<vector<i32>> g(n);
  vector<i32> parentless;
  for (int i = 0; i < n; ++i) {
    i32 u = corasick[ind[i]].suff_end;
    if (u != 0)
      g[r_ind[u]].push_back(i);
    else
      parentless.push_back(i);
  }
  auto dfs = [&](i32 u, auto&& dfs) -> set<i32> {
    vector<set<i32>> st;
    st.push_back(ends[u]);
    for (i32 v : g[u]) {
      st.push_back(dfs(v, dfs));
    }
    sort(ALL(st), [](const auto& a, const auto& b) { return size(a) > size(b); });
    while (size(st) > 1) {
      for (i32 e : st.back())
        st[0].insert(e);
      st.pop_back();
    }
    for (i32 e : st[0]) {
      start_cnt[len_i[u]][e - ssize(words[u]) + 1]++;
    }
    return st[0];
  };
  for (i32 u : parentless) dfs(u, dfs);

  vector<vector<i64> > start_acc = start_cnt;
  for (int i = 0; i < ssize(start_cnt); ++i) {
    for (int j = 1; j < ssize(text); ++j) {
      start_acc[i][j] += start_acc[i][j - 1];
    }
  }

  for (int i = 0; i < m; ++i) {
    i32 l, r;
    cin >> l >> r;
    --l, --r;
    i64 ans = 0;
    for (int j = 0; j < ssize(len); ++j) {
      if (r - len[j] + 1 < l) continue;
      ans += start_acc[j][r - len[j] + 1] - (l != 0 ? start_acc[j][l - 1] : 0);
    }
    cout << ans << "\n";
  }
}
