#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>
#include <cassert>
#include <unordered_map>

using namespace std;

struct query {
	int l, r, id;
	query(int l0, int r0, int i) {
		l = l0;
		r = r0;
		id = i;
	}
};

const int MAXC = 1e6 + 7;
vector <string> s[MAXC];

const int base[2] = { 29, 179 };
const int mod[2] = { 1000000007, 1791791791 };
unordered_map <int, bool> good_hash[2];

struct modder {
	int b[MAXC];
	int myid;

	modder(int ind) {
		myid = ind;
	}

	void calc_b() {
		b[0] = 1;
		for (int i = 1; i < MAXC; i++)
			b[i] = (1ll * b[i - 1] * base[myid]) % mod[myid];
	}

	inline int myhash(string& s) {
		int res = 0;
		for (auto e : s)
			res = (res * 1ll * base[myid] + (e - 'a' + 1)) % mod[myid];
		return res;
	}

	vector <int> pref;
	inline void calc_pref(string& s) {
		int n = (int)s.size();
		pref.resize(n);
		pref[0] = (s[0] - 'a' + 1);
		for (int i = 1; i < n; i++)
			pref[i] = (1ll * pref[i - 1] * base[myid] + (s[i] - 'a' + 1)) % mod[myid];
	}

	inline int get_hash(int l, int r) {
		if (l == 0)
			return pref[r];
		int h = (pref[r] - pref[l - 1] * 1ll * b[r - l + 1]) % mod[myid];
		if (h < 0)
			h += mod[myid];
		return h;
	}
};

modder m1(0);
modder m2(1);


void solve() {
	m1.calc_b();
	m2.calc_b();

	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	int sz = (int)t.size();
	m1.calc_pref(t);
	m2.calc_pref(t);
	string temp;
	for (int i = 0; i < n; i++) {
		cin >> temp;
		s[(int)temp.size()].push_back(temp);
	}
	vector <query> q;
	vector <long long> ans(m, 0);
	for (int i = 0; i < m; i++) {
		int l, r;
		cin >> l >> r;
		l--; r--;
		q.push_back(query(l, r, i));
	}

	for (int i = 0; i < 2; i++)
		good_hash[i].reserve(n);
	for (int len = 1; len < MAXC; len++) {
		if (s[len].empty())
			continue;
		for (auto e : s[len]) {
			good_hash[0][m1.myhash(e)] = true;
			good_hash[1][m2.myhash(e)] = true;
		}
		vector <int> sum(sz + 1, 0);
		for (int l = 0; l + len - 1 < sz; l++) {
			int r = l + len - 1;
			if (good_hash[0][m1.get_hash(l, r)] &&
				good_hash[1][m2.get_hash(l, r)])
				sum[l + 1]++;
		}
		for (int i = 1; i <= sz; i++)
			sum[i] += sum[i - 1];
		for (auto e : q) {
			if (e.r - e.l + 1 < len)
				continue;
			int l = e.l;
			int r = e.r - len + 1;
			ans[e.id] += (sum[r + 1] - sum[l]);
		}
	}
	for (auto e : ans)
		cout << e << " ";
	cout << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}