#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx2,bmi2,lzcnt,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MOD1 = 1e9 + 21;
const int MOD2 = 1e9 + 7;
const int N = 1e5 + 5;
int powers[N][2], ipowers[N][2], pref[N][2];

int inverse(int x, const int MOD) {
    int ans = 1;
    for (int p = MOD - 2; p > 0; p /= 2, x = 1ll * x * x % MOD) {
        if (p % 2) {
            ans = 1ll * ans * x % MOD;
        }
    }
    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    uniform_int_distribution<int> dist(100, 1e9);
    mt19937 rng(chrono::steady_clock().now().time_since_epoch().count());
    int base = dist(rng);
    powers[0][0] = powers[0][1] = 1;
    for (int i = 0; i + 1 < N; i++) {
        powers[i + 1][0] = 1ll * powers[i][0] * base % MOD1;
        powers[i + 1][1] = 1ll * powers[i][1] * base % MOD2;
    }
    ipowers[N - 1][0] = inverse(powers[N - 1][0], MOD1);
    ipowers[N - 1][1] = inverse(powers[N - 1][1], MOD2);
    for (int i = N - 2; i >= 0; i--) {
        ipowers[i][0] = 1ll * ipowers[i + 1][0] * base % MOD1;
        ipowers[i][1] = 1ll * ipowers[i + 1][1] * base % MOD2;
    }
    int sz = (int)t.size();
    for (int i = 0; i < sz; i++) {
        pref[i + 1][0] = (pref[i][0] + 1ll * powers[i][0] * int(t[i] - 'a' + 1)) % MOD1;
        pref[i + 1][1] = (pref[i][1] + 1ll * powers[i][1] * int(t[i] - 'a' + 1)) % MOD2;
    }
    map<pair<int, int>, int> cnt;
    vector<pair<int, int>> h(n);
    vector<int> len(n);
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        len[i] = (int)s.size();
        int hash[2] = {0, 0};
        for (int j = 0; j < (int)s.size(); j++) {
            hash[0] = (hash[0] + 1ll * powers[j][0] * int(s[j] - 'a' + 1)) % MOD1;
            hash[1] = (hash[1] + 1ll * powers[j][1] * int(s[j] - 'a' + 1)) % MOD2;
        }
        h[i] = {hash[0], hash[1]};
    }
    map<pair<int, int>, int> occ;
    vector<int> start(sz + 1), end(sz + 1);
    vector<vector<int>> pos(sz);
    for (int a = sz; a >= 0; a--) {
        for (int j = 0; j < n; j++) {
            int hash[2];
            hash[0] = (1ll * h[j].first * powers[a][0] + pref[a][0]) % MOD1;
            hash[1] = (1ll * h[j].second * powers[a][1] + pref[a][1]) % MOD2;
            if (occ.count({hash[0], hash[1]})) {
                pos[a].push_back(a + len[j]);
            }
        }
        occ[{pref[a][0], pref[a][1]}] = a;
    }
    for (auto &v : pos) {
        sort(v.begin(), v.end());
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        long long ans = 0;
        for (int j = l; j < r; j++) {
            ans += lower_bound(pos[j].begin(), pos[j].end(), r + 1) - pos[j].begin();
        }
        cout << ans << " \n"[i + 1 == m];
    }
}