#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <cassert>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = unsigned long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const ll LL_INF = 2e18 + 10;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

struct Hash {
    string s;
    int n;
    ll base;
    vector<ll> p;
    vector<ll> hash;
    Hash() : n(0), base(0) {}
    Hash(string& _s, ll _base) : s(_s), base(_base) {
        n = s.size();
        p.resize(n);
        hash.resize(n);
        p[0] = 1;
        hash[0] = s[0] - 'a';
        for (int i = 1; i < n; i++) {
            p[i] = p[i - 1] * base;
            hash[i] = hash[i - 1] * base + s[i] - 'a';
        }
    }
    ll get(int l, int r) {
        if (l == 0) {
            return hash[r];
        }
        return hash[r] - hash[l - 1] * p[r - l + 1];
    }
};

int main() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash hash(t, 31);
    vector<string> s(n);
    vector<Hash> h(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
        h[i] = Hash(s[i], 31);
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        ll cnt = 0;
        for (int i = l; i <= r; i++) {
            for (int j = i; j <= r; j++) {
                for (auto& hi : h) {
                    if (hash.get(i, j) == hi.hash[hi.n - 1]) {
                        cnt++;
                        break;
                    }
                }
            }
        }
        cout << cnt << ' ';
    }
}
