#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <queue>
#include <iomanip>
#include <cstring>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

const int N = 1e5, buben = 200;

ll itoll(int a, int b) {
	return (ll)a << 32 + (ll)b;
}

int hash_arr[N], k = 31, mod = 1e9 + 7, powed[N];
map<ll, int> cond;
int timer = 0;
vector<pii> pos[N];

void get_hash(string s) {
	hash_arr[0] = s[0] - 'a' + 1;
	for (int i = 0; i < sz(s); i++) 
		hash_arr[i] = (1ll * hash_arr[i - 1] * k + (s[i] - 'a' + 1)) % mod;
}

int get_substr(int l, int r) {
	if (l == 0)
		return hash_arr[r];
	return ((ll)hash_arr[r] - (1ll * hash_arr[l - 1] * powed[r - l + 1]) % (ll)mod + (ll)mod) % mod;
}

int pref[2 * N];

void pref_f(const string& s) {
	pref[0] = 0;
	int n = sz(s), k = 0;
	for (int i = 1; i < n; i++) {
		while (k != 0 && s[k] != s[i])
			k = pref[k - 1];
		if (s[k] == s[i])
			k++;
		pref[i] = k;
	}
}

vector<pii> all_pos;
bool marks[N];

void solve() {
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector<string> s(n);
	get_hash(t);
	for (int i = 1; i <= min(buben, sz(t)); i++) {
		for (int j = 0; j <= sz(t) - i; j++) {
			int chash = get_substr(j, j + i - 1);
			ll params = itoll(i, chash);
			auto it = cond.find(params);
			if (it == cond.end()) {
				cond[params] = timer;
				pos[timer].push_back({ j, j + i - 1 });
				timer++;
			}
			else 
				pos[it->second].push_back({ j, j + i - 1 });
		}
	}
	for (int i = 0; i < n; i++) {
		cin >> s[i];
		if (sz(s[i]) > buben) {
			string newt = s[i] + '#' + t;
			pref_f(newt);
			for (int j = sz(s[i]) + 1; j < sz(newt); j++) {
				if (pref[j] == sz(s[i]))
					all_pos.push_back({ j - 2 * sz(s[i]), j - sz(s[i]) - 1});
			}
		}
		else {
			get_hash(s[i]);
			ll params = itoll(sz(s[i]), hash_arr[sz(s[i]) - 1]);
			auto it = cond.find(params);
			if (it != cond.end()) {
				marks[it->second] = true;
			}
		}
	}
	for (int i = 0; i < timer; i++) {
		if (marks[i]) {
			for (pii u : pos[i])
				all_pos.push_back(u);
		}
	}
	int l, r;
	for (int i = 0; i < m; i++) {
		cin >> l >> r;
		l--;
		r--;
		int ans = 0;
		for (pii& u : all_pos) {
			if (u.first >= l && u.second <= r) 
				ans++;
		}
		cout << ans << " ";
	}
}

signed main() {
	//freopen("input.txt", "r", stdin);
	//freopen("output1.txt", "w", stdout);	
	powed[0] = 1;
	for (int i = 1; i < N; i++) 
		powed[i] = (1ll * powed[i - 1] * k) % mod;	
	solve();
}