#include <iostream>
#include <vector>
#include <set>
#include <string>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

int MOD = 1791791791;
long long p = 151;

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (T &value: v) {
        in >> value;
    }
    return in;
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<int> ps(t.length() + 1);
    ps[0] = 1;
    for (int i = 1; i <= t.length(); i++) {
        ps[i] = (ps[i - 1] * p) % MOD;
    }
    vector<string> strs(n);
    cin >> strs;
    vector<int> hash_t(t.length() + 1);
    hash_t[0] = 0;
    range(i, t.length()) {
        hash_t[i + 1] = ((hash_t[i] * p) + t[i]) % MOD;
    }
    vector<int> hash_strs(n, 0);
    range(i, n) {
        range(j, strs[i].length()) {
            hash_strs[i] = ((hash_strs[i] * p) + strs[i][j]) % MOD;
        }
    }
    loop(m) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        long long ans = 0;
        range(i, n) {
            for (int a = l, b = l + strs[i].size(); b <= r + 1; a++, b++) {
                if (hash_t[b] == (hash_strs[i] + hash_t[a] * (long long) ps[strs[i].size()]) % MOD) {
                    ans++;
                }
            }
        }
        cout << ans << " ";
    }
    cout << endline;
}