#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 5e6 + 1, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

struct mint {
    int x;

    mint(int x_ = 0) {
        x = x_;
    }

    mint operator+(const mint &oth) const {
        return x + oth.x >= MOD ? x + oth.x - MOD : x + oth.x;
    }

    mint operator-(const mint &oth) const {
        return x - oth.x < 0 ? x - oth.x + MOD : x - oth.x;
    }

    mint operator*(const mint &oth) const {
        return (1LL * x * oth.x) % MOD;
    }

    bool operator==(const mint &oth) const {
        return x == oth.x;
    }
};

mint pw[MAXN];

const mint P = 31;

void init() {
    pw[0] = 1;
    for (int i = 1; i < MAXN; ++i) {
        pw[i] = pw[i - 1] * P;
    }
}

mint get_hash(const string &s) {
    mint hsh = 0;
    for (auto &el : s) {
        hsh = (hsh + (el - 'a' + 1)) * P;
    }
    return hsh;
}

struct Hash {
    vector<mint> hs;

    Hash(const string &s) {
        hs.resize(s.size() + 1, 0);
        for (int i = 0; i < s.size(); ++i) {
            hs[i + 1] = (hs[i] + (s[i] - 'a' + 1)) * P;
        }
    }

    mint get(int l, int r) {
        return hs[r] - hs[l - 1] * pw[r - l + 1];
    }
};

void solve() {
    init();
    vector<int> lens;
    vector<pair<string, mint>> a;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        a.emplace_back(s, get_hash(s));
        lens.push_back(s.size());
    }
    unordered_map<int, int> cnt;
    for (auto &[x, y] : a) {
        ++cnt[y.x];
    }
    sort(all(lens)), lens.resize(unique(all(lens)) - lens.begin());
    Hash hs(t);
    while (m--) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for (int i = l; i + lens[0] - 1 <= r; ++i) {
            for (int j = 0; j < lens.size() && lens[j] - 1 + i <= r; ++j) {
                ans += cnt[hs.get(i, i + lens[j] - 1).x];
            }
        }
        cout << ans << ' ';
    }
}
