#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 5e6 + 1, MOD = 1e9 + 9, MOD1 = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

struct mint {
    int x, y;

    mint(int x_ = 0, int y_ = 0) {
        x = x_, y = y_;
    }

    mint operator+(const mint &oth) const {
        return {x + oth.x >= MOD ? x + oth.x - MOD : x + oth.x,
                y + oth.y >= MOD1 ? y + oth.y - MOD1 : y + oth.y};
    }

    mint operator-(const mint &oth) const {
        return {x - oth.x < 0 ? x - oth.x + MOD : x - oth.x,
                y - oth.y < 0 ? y - oth.y + MOD1 : y - oth.y};
    }

    mint operator*(const mint &oth) const {
        return {(1LL * x * oth.x) % MOD, (1LL * y * oth.y) % MOD1};
    }
};

mint pw[MAXN];

const mint P = {31, 37};

void init() {
    pw[0] = {1, 1};
    for (int i = 1; i < MAXN; ++i) {
        pw[i] = pw[i - 1] * P;
    }
}

mint get_hash(const string &s) {
    mint hsh;
    for (auto &el: s) {
        mint nw = {el - 'a' + 1, el - 'a' + 1};
        hsh = (hsh + nw) * P;
    }
    return hsh;
}

struct Hash {
    vector<mint> hs;

    Hash(const string &s) {
        hs.resize(s.size() + 1);
        for (int i = 0; i < s.size(); ++i) {
            mint nw = {s[i] - 'a' + 1, s[i] - 'a' + 1};
            hs[i + 1] = (hs[i] + nw) * P;
        }
    }

    mint get(int l, int r) {
        return hs[r] - hs[l - 1] * pw[r - l + 1];
    }
};

const int K = 707;

struct Node {
    int l, r, ind;

    bool operator<(const Node &oth) const {
        if (l / K == oth.l / K) return r < oth.r;
        return l / K < oth.l / K;
    }
};

const int MX = 1e7;

int l[MX], r[MX], sm[MX];

int nw = 1;

const int R = 1 << 19;

struct Tree {
    int root;

    Tree() {
        root = nw++;
    }

    void update(int ind, int add, int node, int nl = 1, int nr = R) {
        if (nl == nr) {
            sm[node] += add;
            return;
        }
        int nm = (nr + nl) / 2;
        if (nl <= ind && ind <= nm) {
            if (!l[node]) {
                l[node] = nw++;
            }
            update(ind, add, l[node], nl, nm);
        } else {
            if (!r[node]) {
                r[node] = nw++;
            }
            update(ind, add, r[node], nm + 1, nr);
        }
        sm[node] = 0;
        if (l[node]) sm[node] += sm[l[node]];
        if (r[node]) sm[node] += sm[r[node]];
    }

    int get(int ql, int qr, int node, int nl = 1, int nr = R) {
        if (ql <= nl && nr <= qr) {
            return sm[node];
        }
        if (qr < nl || nr < ql) {
            return 0;
        }
        int nm = (nr + nl) / 2;
        if (!l[node]) {
            l[node] = nw++;
        }
        if (!r[node]) {
            r[node] = nw++;
        }
        return get(ql, qr, l[node], nl, nm) + get(ql, qr, r[node], nm + 1, nr);
    }
};

struct Fenwick {
    vector<Tree> t;

    Fenwick() {
        t.resize(5e5 + 1);
    }

    void upd(int i, int ind, int x) {
        for (; i < t.size(); i += i & -i) t[i].update(ind, x, t[i].root);
    }

    int get(int len, int less) {
        int ans = 0;
        for (; len > 0; len -= len & -len) {
            ans += t[len].get(1, less, t[len].root);
        }
        return ans;
    }

    int get(int lef, int rig, int less) {
        return get(rig, less) - get(lef - 1, less);
    }
};

void solve() {
    init();
    vector<int> lens;
    vector<pair<string, mint>> a;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        a.emplace_back(s, get_hash(s));
        lens.push_back(s.size());
    }
    gp_hash_table<ll, int> cnt;
    for (auto &[x, y]: a) {
        ++cnt[1LL * y.x ^ (1LL * y.y << 31L)];
    }
    sort(all(lens)), lens.resize(unique(all(lens)) - lens.begin());
    Hash hs(t);
    Fenwick fenw;
    for (int i = 1; i <= t.size(); ++i) {
        int sm = 0;
        for (int j = 0; j < lens.size() && i + lens[j] - 1 <= t.size(); ++j) {

            sm += cnt[1LL * hs.get(i, i + lens[j] - 1).x ^ (1LL * hs.get(i, i + lens[j] - 1).y << 31LL)];
            fenw.upd(i, i + lens[j] - 1, sm);
        }
    }
    while (m--) {
        int lef, rig;
        cin >> lef >> rig;
        cout << fenw.get(lef, rig, rig) << ' ';
    }
}