#include<bits/stdc++.h>
#define MAXN 100007
#define MAXS 5000007
using namespace std;

struct node{
    int ch[26];
    int w;
    int fail;
    int ok;
};

int n,m,curr,num,child,sz,l,r,ans;
int z[MAXS],to[MAXN];
string word[MAXN],text;

node trie[1000007];
queue<int> q;

bool cmp(string s,string t){
    for(int i=0;i<min(s.size(),t.size());i++){
        if(s[s.size()-1-i]<t[t.size()-1-i])return true;
        if(s[s.size()-1-i]>t[t.size()-1-i])return false;
    }
    if(s.size()<t.size())return true;
    return false;
}

bool suffix(string s,string t){
    for(int i=0;i<min(s.size(),t.size());i++){
        if(s[s.size()-1-i]!=t[t.size()-1-i])return false;
    }
    return true;
}

void add(string s,int id){
    curr=0;
    for(int i=0;i<s.size();i++){
        if(trie[curr].ch[s[i]-'a']==0){
            num++; trie[curr].ch[s[i]-'a']=num;
        }
        curr=trie[curr].ch[s[i]-'a'];
    }
    trie[curr].w=id;
}

void bfs(int x){
    for(int i=0;i<26;i++){
        child=trie[x].ch[i];
        if(child==0)continue;

        q.push(child);

        curr=trie[x].fail;
        while(curr!=0 and trie[curr].ch[i]==0){
            curr=trie[curr].fail;
        }

        if(trie[curr].ch[i]!=0 and trie[curr].ch[i]!=child){
            trie[child].fail=trie[curr].ch[i];
        }

        if(trie[trie[child].fail].w!=0){
            trie[child].ok=trie[child].fail;
        }else{
            trie[child].ok=trie[trie[child].fail].ok;
        }
    }
}

void aho_corasick(){
    q.push(0);
    while(!q.empty()){
        bfs(q.front());
        q.pop();
    }
}

void match(){
    curr=0;
    for(int i=0;i<text.size();i++){
        while(curr!=0 and trie[curr].ch[text[i]-'a']==0){
            curr=trie[curr].fail;
        }
        if(trie[curr].ch[text[i]-'a']!=0){
            curr=trie[curr].ch[text[i]-'a'];
        }

        if(trie[curr].w!=0){
            z[i+1]=trie[curr].w;
        }else{
            z[i+1]=trie[curr].ok;
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>text;

    for(int i=1;i<=n;i++){
        cin>>word[i];
    }
    sort(word+1,word+n+1,cmp);
    
    for(int i=1;i<=n;i++){
        add(word[i],i);
        if(i>1 and suffix(word[i-1],word[i])){
            to[i]=i-1;
        }
    }

    aho_corasick();
    match();

    for(int i=1;i<=m;i++){
        cin>>l>>r;
        ans=0;
        for(int f=l;f<=r;f++){
            curr=z[f];
            while(curr!=0){
                if(f-int(word[curr].size())+1>=l)ans++;
                curr=to[curr];
            }
        }
        cout<<ans<<" ";
    }
    cout<<"\n";

    return 0;
}