#include<bits/stdc++.h>
#define MAXN 500007
#define MAXS 5000007
using namespace std;

struct node{
    int ch[26];
    int w;
    int fail;
    int ok;
};

struct event{
    int id;
    int type;
    int pos;
};

int n,m,curr,num,child,sz,l,r,temp;
long long ans[MAXS];
vector<int> z[MAXS];
string word[MAXN],text;
vector<event> v[MAXS];

node trie[1000007];
queue<int> q;

int fenwick[MAXS],cnt;

void update(int x){
    while(x<=sz){
        fenwick[x]++;
        x+=(x & (-x));
    }
}

int getsum(int x){
    int res=0;
    while(x>=1){
        res+=fenwick[x];
        x-=(x & (-x));
    }
    return res;
}

void add(string s,int id){
    curr=0;
    for(int i=0;i<s.size();i++){
        if(trie[curr].ch[s[i]-'a']==0){
            num++; trie[curr].ch[s[i]-'a']=num;
        }
        curr=trie[curr].ch[s[i]-'a'];
    }
    trie[curr].w=id;
}

void bfs(int x){
    for(int i=0;i<26;i++){
        child=trie[x].ch[i];
        if(child==0)continue;

        q.push(child);

        curr=trie[x].fail;
        while(curr!=0 and trie[curr].ch[i]==0){
            curr=trie[curr].fail;
        }

        if(trie[curr].ch[i]!=0 and trie[curr].ch[i]!=child){
            trie[child].fail=trie[curr].ch[i];
        }

        if(trie[trie[child].fail].w!=0){
            trie[child].ok=trie[child].fail;
        }else{
            trie[child].ok=trie[trie[child].fail].ok;
        }
    }
}

void aho_corasick(){
    q.push(0);
    while(!q.empty()){
        bfs(q.front());
        q.pop();
    }
}

void match(){
    curr=0;
    for(int i=0;i<text.size();i++){
        while(curr!=0 and trie[curr].ch[text[i]-'a']==0){
            curr=trie[curr].fail;
        }
        if(trie[curr].ch[text[i]-'a']!=0){
            curr=trie[curr].ch[text[i]-'a'];
        }
        
        temp=curr;
        if(trie[temp].w==0)temp=trie[temp].ok;
        while(temp!=0){
            z[i+1].push_back(i+1-int(word[trie[temp].w].size())+1);
            temp=trie[temp].ok;
        }
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>text;
    sz=int(text.size());

    for(int i=1;i<=n;i++){
        cin>>word[i];
    }
    
    for(int i=1;i<=n;i++){
        add(word[i],i);
    }
    if(sz>250000)return 0;

    aho_corasick();
    match();

    for(int i=1;i<=m;i++){
        cin>>l>>r;
        v[l-1].push_back({i,0,l-1});
        v[r].push_back({i,1,l-1});
    }

    for(int i=1;i<=int(text.size());i++){
        for(int f=0;f<z[i].size();f++){ 
            update(z[i][f]); cnt++;
        }
        for(int f=0;f<v[i].size();f++){
            if(v[i][f].type==0){
                ans[v[i][f].id]=cnt-getsum(v[i][f].pos);
            }else{
                ans[v[i][f].id]=cnt-getsum(v[i][f].pos)-ans[v[i][f].id];
            }
        }
    }

    for(int i=1;i<=m;i++){
        cout<<ans[i]<<" ";
    }
    cout<<"\n";

    return 0;
}