/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 5e6 + 10, maxlen = 5e6 + 10, maxs = 5e6 + 10;


int n, m;
string t, s[maxn];
vector < int > occ[maxlen];
int len;

const int alphabet = 26;
struct node
{
    int go[alphabet];
    int fail_link, closest, is_word;

    node()
    {
        memset(go, -1, sizeof(go));
        fail_link = 0;
        closest = -1;
        is_word = 0;
    }
};

node tree[(int)(1e6)];
int next_free;
void add_word(int root, string &word, int pos, int idx)
{
    ///cout << root << " " << word << " " << pos << endl;
    if (pos == word.size())
    {
        tree[root].is_word = idx;
        return;
    }

    int &next_state = tree[root].go[word[pos] - 'a'];
    if (next_state == -1)
        next_state = ++ next_free;
    add_word(next_state, word, pos + 1, idx);
}

void build_automata()
{
    for (int i = 1; i <= n; i ++)
        add_word(0, s[i], 0, i);

    queue < int > q;
    q.push(0);
    while(!q.empty())
    {
        int state = q.front();
        q.pop();
        for (int i = 0; i < alphabet; i ++)
        {
            int fail_link = tree[state].fail_link;
            int &next_state = tree[state].go[i];
            if (tree[state].go[i] == -1)
            {
                if (state == 0)
                {
                    next_state = state;
                }
                else
                {
                    next_state = tree[fail_link].go[i];
                }
                continue;
            }

            if (state == 0)
            {
                tree[next_state].fail_link = 0;
            }
            else
            {
                //cout << "state " << state << " " << next_state << " " << fail_link << " " << endl;
                tree[next_state].fail_link = tree[fail_link].go[i];
            }

            int back_state = tree[next_state].fail_link;
            if (tree[back_state].is_word != 0)
                tree[next_state].closest = back_state;
            else
                tree[next_state].closest = tree[back_state].closest;

            q.push(next_state);

        }
    }

    /**for (int i = 0; i <= next_free; i ++)
    {
        cout << i << " : " << tree[i].go[0] << endl;
    }*/
}

void get_occurences()
{
    int state = 0;
    for (int i = 1; i <= len; i ++)
    {
        state = tree[state].go[t[i] - 'a'];
        int back_state = state;
        while(back_state != -1)
        {
            if (tree[back_state].is_word != 0)
            {
                ///cout << i << " : " << tree[back_state].is_word << endl;
                int word_len = s[tree[back_state].is_word].size();
                occ[i - word_len + 1].push_back(i);
            }

            back_state = tree[back_state].closest;
        }
    }
}

ll fen[maxlen];
void update(int v, ll val)
{
    for (int i = v; i <= len; i += (i & -i))
        fen[i] += val;
}

ll sum(int v)
{
    ll cur = 0;
    for (int i = v; i > 0; i -= (i & -i))
        cur += fen[i];
    return cur;
}

vector < int > upd[maxlen];

vector < pair < int, int > > ask[maxlen];
ll ans[maxn];
void solve()
{
    cin >> n >> m >> t;
    for (int i = 1; i <= n; i ++)
    {
        cin >> s[i];
    }

    len = t.size();
    t = "#" + t;

    build_automata();
    get_occurences();
    /**for (int i = 1; i <= len; i ++)
    {
        for (int j = 1; j <= n; j ++)
        {
            if (i + s[j].size() - 1 > len)
                continue;
            bool same = true;
            for (int p = 0; p < s[j].size(); p ++)
            {
                if (s[j][p] != t[i + p])
                {
                    same = false;
                }
            }
            if (same)
            {
                ///cout << i << " : " << i + s[j].size() - 1 << " " << j << endl;
                occ[i].push_back(i + s[j].size() - 1);
            }
        }
    }*/
    for (int i = 1; i <= len; i ++)
        for (int x : occ[i])
            upd[x].push_back(i);

    for (int i = 1; i <= m; i ++)
    {
        int l, r;
        cin >> l >> r;
        ask[r].push_back({l, i});
    }

    ll cnt = 0;
    for (int i = 1; i <= len; i ++)
    {
        for (int x : upd[i])
        {
            //cout << i << " : " << x << endl;
            cnt ++;
            update(x, 1);
        }
        //cout << query_range(1, 1, n, 4, 5) << endl;
        for (pair < int, int > cur : ask[i])
        {
            //cout << "ask " << cur.first << " " << cur.second << endl;
            ans[cur.second] = cnt - sum(cur.first - 1);
        }
    }

    for (int i = 1; i <= m; i ++)
        cout << ans[i] << " ";
    cout << endl;
    /**for (int i = 1; i <= m; i ++)
    {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for (int j = l; j <= r; j ++)
        {
            for (int x : occ[j])
                if (x <= r)
                    ans ++;
        }
        cout << ans << " ";
    }
    cout << endl;*/
}

int main()
{
    speed();
    solve();
    return 0;
}
