#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 500000;
const int BASE = 31;
const int MOD = 1000000007;

int sz[MAXN + 5];
string s[MAXN + 5];
int hshs[MAXN + 5];
int pw[10 * MAXN + 5];
int hsht[10 * MAXN + 5];
vector<int> wh[MAXN + 5];
int ans3[5005][5005];
priority_queue<int> pq[MAXN + 5];

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    for (int i = 1; i <= n; ++ i)
    {
        cin >> s[i];
    }

    int st = t.size();

    pw[0] = 1;
    for (int i = 1; i <= st; ++ i)
    {
        pw[i] = (1ll * pw[i - 1] * BASE) % MOD;
    }

    for (int i = 1; i <= n; ++ i)
    {
        sz[i] = s[i].size();
        for (int j = 0; j < sz[i]; ++ j)
        {
            hshs[i] = (1ll * hshs[i] * BASE + (s[i][j] - 'a')) % MOD;
        }
    }

    hsht[0] = 0;
    for (int i = 1; i <= st; ++ i)
    {
        hsht[i] = (1ll * hsht[i - 1] * BASE + (t[i - 1] - 'a')) % MOD;
    }

    for (int i = 1; i <= n; ++ i)
    {
        wh[i].resize(st + 1);
        wh[i][0] = 0;
        for (int j = 1; j <= st - sz[i] + 1; ++ j)
        {
            wh[i][j] = wh[i][j - 1];
            int hsh0 = (hsht[j + sz[i] - 1] - 1ll * hsht[j - 1] * pw[sz[i]]) % MOD;
            if (hsh0 < 0) hsh0 += MOD;
            if (hsh0 == hshs[i]) wh[i][j]++;
        }
    }

    if (n <= 5000 and st <= 5000)
    {
        vector<int> qa, qb;
        qa.resize(m + 1);
        qb.resize(m + 1);
        for (int i = 1; i <= m; ++ i)
        {
            cin >> qa[i] >> qb[i];
            pq[qa[i]].push(-qb[i]);
        }

        for (int i = 1; i <= st; ++ i)
        {
            int prv = 0;
            while (!pq[i].empty())
            {
                int curr = -pq[i].top();
                pq[i].pop();
                if (curr == prv) continue;
                prv = curr;
                for (int j = 1; j <= n; ++ j)
                {
                    int x = curr - sz[j] + 1;
                    if (i <= x) ans3[i][curr] += wh[j][x] - wh[j][i - 1];
                }
            }
        }

        for (int i = 1; i <= m; ++ i)
        {
            cout << ans3[qa[i]][qb[i]] << " ";
        }
        cout << endl;
        return 0;
    }

    for (int i = 1; i <= m; ++ i)
    {
        int a, b;
        cin >> a >> b;

        int cnt = 0;
        for (int j = 1; j <= n; ++ j)
        {
            int c = b - sz[j] + 1;
            if (c < a) continue;
            cnt += wh[j][c] - wh[j][a - 1];
        }
        cout << cnt << " ";
    }
    cout << endl;

    return 0;
}
