#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

struct H {
    vector<ll> h, base;
    ll MOD = 1e9 + 7, p = 10;
    ll n;

    H() = default;

    H(string &s) {
        n = s.size();
        base.resize(n + 1, 1);
        for (ll i = 1; i <= n; i++)
            base[i] = (base[i - 1] * p) % MOD;
        h.resize(n + 1);
        for (ll i = 1; i <= n; i++) {
            h[i] = (h[i - 1] * p + s[i - 1] - 'a') % MOD;
        }
    }

    ll get(ll l, ll r) {
        return ((h[r + 1] - h[l] * base[r - l + 1]) % MOD + MOD) % MOD;
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    for (auto &i: v)
        cin >> i;
    H h(t);
    vector<H> v1(n);
    for (ll i = 0; i < n; i++)
        v1[i] = H(v[i]);
    map<ll, vector<ll>> ans;
    for (auto i: v1) {
        ans[i.n].resize(t.size());
        for (ll j = 0; j + i.n <= t.size(); j++) {
            if (h.get(j, j + i.n - 1) == i.get(0, i.n - 1))
                ans[i.n][j]++;
        }
    }
    vector<ll> len;
    for (auto &[a, b]: ans) {
        len.push_back(a);
        for (ll i = 1; i < b.size(); i++)
            b[i] += b[i - 1];
    }
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;
        ll c = 0;
        for (auto i: len) {
            if (i > (r - l + 1))
                break;
            if (l > 0)c += ans[i][r - i + 1] - ans[i][l - 1];
            else c += ans[i][r - i + 1];
        }
        cout << c << '\n';
    }

}