#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

struct H {
    vector<ll> h, base, h1, base1;
    ll MOD = 1e9 + 117, p = 10, MOD1 = 1;
    ll n;

    H() = default;

    H(string &s) {
        n = s.size();
        base.resize(n + 1, 1);
        for (ll i = 1; i <= n; i++)
            base[i] = (base[i - 1] * p) % MOD;
        h.resize(n + 1);
        for (ll i = 1; i <= n; i++) {
            h[i] = (h[i - 1] * p + s[i - 1] - 'a') % MOD;
        }

        base1.resize(n + 1, 1);
        for (ll i = 1; i <= n; i++)
            base1[i] = (base1[i - 1] * p) % MOD1;
        h1.resize(n + 1);
        for (ll i = 1; i <= n; i++) {
            h1[i] = (h1[i - 1] * p + s[i - 1] - 'a') % MOD1;
        }
    }

    pair<ll, ll> get(ll l, ll r) {
        return {((h[r + 1] - h[l] * base[r - l + 1]) % MOD + MOD) % MOD,
                ((h1[r + 1] - h1[l] * base1[r - l + 1]) % MOD1 + MOD1) % MOD1};
    }
};

void solve() {
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    vector<ll> len;
    for (auto &i: v) {
        cin >> i;
        len.push_back(i.size());
    }
    std::sort(len.begin(), len.end());
    len.resize(unique(len.begin(), len.end()) - len.begin());
    H h(t);
    vector<H> v1(n);
    map<ll, vector<pair<ll, ll>>> m1;
    for (ll i = 0; i < n; i++) {
        v1[i] = H(v[i]);
        m1[v[i].size()].push_back(v1[i].get(0, v1[i].n - 1));
    }
    for (auto &[a, b]: m1) {
        sort(b.begin(), b.end());
    }
    map<ll, vector<ll>> ans;
    for (int i = 0; i < t.size(); i++) {
        for (int l: len) {
            if (l + i > t.size())
                break;
            ans[l].resize(t.size());
            ans[l][i] += upper_bound(m1[l].begin(), m1[l].end(), h.get(i, i + l - 1))
                         - lower_bound(m1[l].begin(), m1[l].end(), h.get(i, i + l - 1));
        }
    }
    for (auto &[a, b]: ans) {
        for (ll i = 1; i < b.size(); i++)
            b[i] += b[i - 1];
    }
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--;
        r--;
        ll c = 0;
        for (auto i: len) {
            if (i > (r - l + 1))
                break;
            if (l > 0)c += ans[i][r - i + 1] - ans[i][l - 1];
            else c += ans[i][r - i + 1];
        }
        cout << c << '\n';
    }

}