#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2e5 + 1, M = 2e5 + 1;

int n, m, bit, a, b;

int Weight[M];

inline int w(int i) {
    return Weight[i] >> bit & 1;
}

vector<pair<int, int>> adj[N], rev[N];

vector<int> ord;

int used[N];

void dfs_ord(int v) {
    used[v] = true;

    for (auto [to, i] : adj[v]) {
        if (!used[to]) {
            dfs_ord(to);
        }
    }

    ord.push_back(v);
}

bool yay = true;

int cnt_b[N], dp_b[N];

int stupid_dp() {
    for (int x : ord) {
        cnt_b[x] = dp_b[x] = 0;

        if (x == b) {
            cnt_b[x] = 1;
            continue;
        }

        for (auto [to, i] : adj[x]) {
            cnt_b[x] ^= cnt_b[to];
            dp_b[x] ^= dp_b[to];

            if (cnt_b[to]) {
                dp_b[x] ^= w(i);
            }
        }
    }

    return dp_b[a];
}

int depth[N], cyc[2][N], xr[N];

int solve_bit() {
    memset(used, 0, sizeof(used[0]) * n);

    auto dfs = [&](auto self, int v) -> void {
        used[v] = 1;
        cyc[0][v] = cyc[1][v] = 0;

        for (auto [to, i] : adj[v]) {
            if (!used[to]) {
                depth[to] = depth[v] + 1;
                xr[to] = xr[v] ^ w(i);
                self(self, to);
                cyc[0][v] = max(cyc[0][v], cyc[0][to] - 1);
                cyc[1][v] = max(cyc[1][v], cyc[1][to] - 1);
            } else if (used[to] == 1) {
                int kek = xr[v] ^ xr[to] ^ w(i);
                cyc[kek][v] = max(cyc[kek][v], depth[v] - depth[to] + 1);
            }
        }

        used[v] = 2;
    };

    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            depth[i] = 0;
            xr[i] = 0;
            dfs(dfs, i);
        }
    }

    auto bfs = [&](int source) -> vector<array<int, 2>> {
        queue<pair<int, int>> q;
        q.emplace(source, 0);

        vector<array<int, 2>> dist(n, {-1, -1});
        dist[source][0] = 0;

        while (!q.empty()) {
            auto [v, t] = q.front();
            q.pop();

            auto &vec = (source == a ? adj[v] : rev[v]);

            for (auto [to, i] : vec) {
                int d = dist[v][t] + 1;
                int tt = t ^ w(i);

                if (dist[to][tt] == -1) {
                    dist[to][tt] = d;
                    q.emplace(to, tt);
                }
            }
        }

        return dist;
     };

    auto dista = bfs(a);
    auto distb = bfs(b);

    for (int i = 0; i < n && yay; ++i) {
        bool wow[2]{};

        for (int x : {0, 1}) {
            for (int y : {0, 1}) {
                if (dista[i][x] != -1 && distb[i][y] != -1) {
                    wow[x ^ y] = true;
                }
            }
        }

        for (int t = 0; t < 2; ++t) {
            if (cyc[t][i]) {
//                cout << t << " " << i << endl;

                if (wow[t ^ 1]) {
                    yay = false;
                    break;
                }
            }
        }
    }

    return stupid_dp();
}

void solve() {
    yay = true;
    cin >> n >> m;

    for (int i = 0; i < n; ++i) {
        adj[i].clear(), rev[i].clear();
    }

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v >> Weight[i];
        u -= 1, v -= 1;

        adj[u].emplace_back(v, i);
        rev[v].emplace_back(u, i);
    }

    cin >> a >> b;
    a -= 1, b -= 1;

    memset(used, 0, sizeof(used[0]) * n);

    ord.clear();
    dfs_ord(a);
//    reverse(ord.begin(), ord.end());

    if (find(ord.begin(), ord.end(), b) == ord.end()) {
        cout << "0\n";
        return;
    }

    int A = __lg(*max_element(Weight, Weight + m));

    int ans = 0;

    for (bit = 0; bit <= A && yay; ++bit) {
        if (solve_bit()) {
            ans += 1 << bit;
        }
    }

    if (!yay) {
        cout << "-1\n";
        return;
    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}
