#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void output(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = 2e5+10, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011;
const long double eps = 1e-9;
vector<vector<pair<int, int>>> g, g_rev, g1;
vector<int> ts, usd1, usdst, usdf;

void dfs1(int u) {
    usd1[u] = 1;
    for (auto [v, wt] : g1[u]) {
        if (!usd1[v]) dfs1(v);
    }
    ts.emplace_back(u);
}

void dfsst(int u) {
    usdst[u] = 1;
    for (auto [v, wt] : g[u]) {
        if (!usdst[v]) dfsst(v);
    }
}

void dfsf(int u) {
    usdf[u] = 1;
    for (auto [v, wt] : g_rev[u]) {
        if (!usdf[v]) dfsf(v);
    }
}

void solve() {
    g.clear();
    g_rev.clear();
    g1.clear();
    usd1.clear();
    usdst.clear();
    usdf.clear();
    ts.clear();
    int n, m; cin >> n >> m;
    g.resize(n);
    g_rev.resize(n);
    g1.resize(n);
    usd1.resize(n);
    usdst.resize(n);
    usdf.resize(n);
    bool fl1 = true;
    for (int i = 0; i<m; ++i) {
        int u, v, wt; cin >> u >> v >> wt;
        if (v <= u) fl1 = false;
        g[u-1].emplace_back(v-1, wt);
        g_rev[v-1].emplace_back(u-1, wt);
    }
    int a, b; cin >> a >> b; a--; b--;
    if (fl1) {
        if (a == b) {
            cout << "0\n";
            return;
        }
        dfsst(a); dfsf(b);
        if (!usdst[b]) {
            cout << "-1\n";
            return;
        }
        for (int u = 0; u<n; ++u) {
            if (!usdst[u] || !usdf[u]) continue;
            for (auto [v, wt] : g[u]) {
                if (usdst[v] && usdf[v]) g1[v].emplace_back(u, wt);
            }
        }
        for (int i = 0; i<n; ++i) {
            if (!usdst[i] || !usdf[i]) continue;
            if (!usd1[i]) dfs1(i);
        }
        vector<int> dp(n);
        for (auto u : ts) {
            dp[u] = 0;
            if (u == a) continue;
            for (auto [v, wt] : g1[u]) {
                dp[u] ^= (dp[v]^wt);
            }
        }
        cout << dp[b] << '\n';
        return;
    }
    cout << "-1\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
