#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>
#include <numeric>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

v<ll> used;

void circle(v<v<pll>>& gr, ll i, ll b, ll& first, ll& second, bool& is) {
	if (i == b) {
		is = false;
	}

	used[i] = 1;
	for (auto j : gr[i]) {
		if (is) {
			first ^= j.second;
		}
		else {
			second ^= j.second;
		}
		if (!used[j.first]) {
			circle(gr, j.first, b, first, second, is);
		}
	}
}

void top(v<v<pll>>& gr, ll i, v<ll>& sort, v<ll>& ans) {
	ans[i] = 0;
	used[i] = 1;
	for (auto j : gr[i]) {
		if (!used[j.first]) {
			top(gr, j.first, sort, ans);
		}
	}
	sort.push_back(i);
}

v<ll> path(v<v<pll>>& gr, ll a) {
	used.assign(gr.size(), 0);
	v<ll> sort;
	v<ll> ans(gr.size(), -1);
	top(gr, a, sort, ans);
	ans[a] = 1;
	std::reverse(all(sort));
	for (auto i : sort) {
		for (auto j : gr[i]) {
			ans[j.first] += ans[i];
			if (ans[j.first] >= 2) {
				ans[j.first] -= 2;
			}
		}
	}
	return ans;
}

void solve() {
	ll n, m;
	std::cin >> n >> m;
	v<v<pll>> gr(n), rev(n);
	bool check0 = true;
	ll ans = 0;
	for (int i = 0; i < m; ++i) {
		ll a, b, c;
		std::cin >> a >> b >> c;
		--a, --b;
		if (i < m - 1) {
			if (!(a == i && b == i + 1)) {
				check0 = false;
			}
		}
		else {
			if (!(a == n - 1 && b == 0)) {
				check0 = false;
			}
		}
		gr[a].push_back({ b, c });
		rev[b].push_back({ a, c });
	}
	ll a, b;
	std::cin >> a >> b;
	--a, --b;
	if (check0) {
		used.assign(n, 0);
		ll first = 0, second = 0;
		bool is = true;
		circle(gr, a, b, first, second, is);
		if (first == 0 && second == 0) {
			std::cout << 0 << '\n';
		}
		else {
			std::cout << -1 << '\n';
		}
	}
	else {
		v<ll> prev = path(gr, a);
		v<ll> next = path(rev, b);
		for (int i = 0; i < n; ++i) {
			for (auto j : gr[i]) {
				if (prev[i] == 1 && next[j.first] == 1) {
					ans ^= j.second;
				}
			}
		}
		std::cout << ans << '\n';
	}
}

int main() {	
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	std::cin >> t;
	while (t--) {
		solve();
	}
}