#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

int dfs(int v, int end, vector<vector<pair<int, int>>>& gr) {
	if (v == end) return 0;
	for (auto& it : gr[v]) {
		return it.second ^ dfs(it.first, end, gr);
	}
}

void solve() {
	int n, m; cin >> n >> m;
	ll ans = 0;
	vector<vector<pair<int, int>>> gr(n);
	int ways = 0;
	bool fl = true;
	for (int x = 0; x < m; x++) {
		int st, fin, w; cin >> st >> fin >> w;
		ways ^= w;
		fl &= (st < fin);
		gr[st - 1].push_back({ fin - 1, w });
		//gr[fin - 1].push_back({ st - 1, w });
	}
	int a, b; cin >> a >> b; a--; b--;
	if (fl) {
		deque<int> deq;
		vector<int> ways(n);
		vector<int> used(n, 0);
		deq.push_back(a);
		while (!deq.empty()) {
			int v = deq.front();
			deq.pop_front();
			if (used[v]) continue;
			used[v] = 1;
			for (auto& it : gr[v]) {
				int u = it.first;
				int w = it.second;
				ways[u] ^= (ways[v] ^ w);
				deq.push_back(u);
			}
		}
		if (used[b] == 0) cout << -1;
		else cout << ways[b];
		cout << endl;
		return;
	}
	int one = dfs(a, b, gr);
	int two = dfs(b, a, gr);
	if ((one ^ ways) != 0 || (two ^ ways) != 0 || one != 0 || two != 0) cout << -1;
	else cout << 0;
	cout << endl;
}

signed main() {
	int t; cin >> t;
	for (int x = 0; x < t; x++) {
		solve();
	}
}