#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

void create_topsort(int u, vector<vector<pair<int, int>>>& g, vector<char>& used, vector<int>& top_sort) {
    used[u] = 1;
    for (auto& [v, w]: g[u]) {
        if (used[v])
            continue;
        create_topsort(v, g, used, top_sort);
    }
    top_sort.push_back(u);
}

void mark_comp(int u, int now_comp, vector<vector<pair<int, int>>>& g, vector<int>& comp) {
    comp[u] = now_comp;
    for (auto& [v, w]: g[u]) {
        if (comp[v] != -1)
            continue;
        mark_comp(v, now_comp, g, comp);
    }
}

bool check(int u, bool now, int prefxor, int& b, vector<vector<pair<int, int>>>& g, vector<char>& is_bad,
           vector<int>& sum_inside, vector<vector<char>>& used, vector<vector<char>>& dp) {
    bool default_now_val = now;
    if (is_bad[u] == 1 && (sum_inside[u] > 0 || prefxor != 0))
        now = false;
    used[now][u] = true;
    if (u == b && !now) {
        dp[default_now_val][u] = now;
        return now;
    }
    bool ans = true;
    for (auto& [v, w]: g[u]) {
        if (used[now][v] == 0)
            check(v, now, prefxor^w, b, g, is_bad, sum_inside, used, dp);
        ans &= dp[now][v];
    }
    dp[default_now_val][u] = ans;
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        g[u].emplace_back(v, w);
    }
    vector<char> used(n);
    vector<int> topsort, comp(n, -1);
    for (int i = 0; i < n; ++i) {
        if (used[i])
            continue;
        create_topsort(i, g, used, topsort);
    }
    int now_comp = 0;
    for (int i = 0; i < n; ++i) {
        if (comp[topsort[i]] != -1)
            continue;
        mark_comp(topsort[i], now_comp++, g, comp);
    }
    vector<vector<pair<int, int>>> new_g(now_comp);
    vector<char> is_bad(now_comp);
    vector<int> sum_inside(now_comp);
    for (int i = 0; i < n; ++i) {
        //sz[comp[i]]++;
        for (auto& [v, w]: g[i]) {
            if (comp[i] == comp[v]) {
                is_bad[comp[i]] = 1;
                sum_inside[comp[i]] += w;
                continue;
            }
            new_g[comp[i]].emplace_back(comp[v], w);
        }
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    vector<vector<char>> used2(2, vector<char>(now_comp));
    vector<vector<char>> anss(2, vector<char>(now_comp));
    if (!check(comp[a], true, 0, comp[b], new_g, is_bad, sum_inside, used2, anss)) {
        cout << -1 << '\n';
    } else {
        vector<int> dp1(n), dp2(n);
        reverse(topsort.begin(), topsort.end());
        int start = -1;
        for (int i = 0; i < n; ++i) {
            if (topsort[i] == a) {
                start = i;
                break;
            }
        }
        dp2[start] = 1;
        for (int i = start; i < n; ++i) {
            for (auto& [v, w]: g[topsort[i]]) {
                if (is_bad[v])
                    continue;
                dp1[v] ^= (dp1[topsort[i]] ^ (w * (dp2[topsort[i]] & 1)));
                dp2[v] += dp2[topsort[i]];
            }
        }
        cout << dp1[b] << '\n';
    }
}



signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
