#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<queue>
#include<stack>
#include<algorithm>
using namespace std;

struct edge {
    int to, w;
};

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        bool ok1 = 1;
        vector<vector<int>> parents(n);
        vector<vector<edge>> g(n);
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--; v--;
            if ((u + 1) % n != v) ok1 = 0;
            g[u].push_back({v, w});
            parents[v].push_back(u);
        }

        int a, b;
        cin >> a >> b;
        a--;
        b--;

        if (n == m && ok1) {
            vector<int> weights(n);
            for (int i = 0; i < n; i++) {
                weights[i] = g[i][0].w;
            }

            int ans = 0;
            while (a != b) {
                ans ^= weights[a];
                a = (a + 1) % n;
            }

            int res = 0;
            for (int i = 0; i < n; i++)
                res ^= weights[i];

            if (res != 0 || ans != 0) cout << -1 << '\n';
            else cout << ans << '\n';

            continue;
        }

        vector<int> ans(n, 0), visit1(n, 0), visit2(n, 0);

        queue<int> q;
        q.push(a);
        visit1[a] = 1;
        while (!q.empty()) {
            int v = q.front();
            q.pop();

            for (auto u : g[v]) {
                q.push(u.to);
                visit1[u.to] = 1;
            }
        }

        q.push(a);
        visit2[a] = 1;
        vector<int> zero(n, 0), one(n, 0);
        zero[a] = 1;
        while (!q.empty()) {
            int v = q.front();
            q.pop();

            for (auto u : g[v]) {
                bool ok = 1;
                for (auto e : parents[u.to])
                    if (visit1[e] != visit2[e])
                        ok = 0;

                if (zero[v]) {
                    if (u.w) {
                        one[u.to] += zero[v];
                    } else {
                        zero[u.to] += zero[v];
                    }
                }
                if (one[v]) {
                    if (!u.w) {
                        one[u.to] += one[v];
                    } else {
                        zero[u.to] += one[v];
                    }
                }

                if (ok) {
                    q.push(u.to);
                    visit2[u.to] = 1;
                }
            }
        }

        /*for (auto e : ans)
            cout << e << ' ';
        cout << '\n';*/

        //cout << one[b] << '\n';
        cout << (one[b] & 1) << '\n';
    }

    return 0;
}
