#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator >> (istream &in, pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

template<typename T, typename G>
ostream& operator << (ostream &in, pair<T, G> &a) {
    in << a.X << ' ' << a.Y;
    return in;
}

const int MAXN = 2e5 + 1;
vector<pii> adj[MAXN];
bool used[MAXN];
vector<int> order;

int my_xr = 0;
void dfs(int v, int b, int xr) {
    if (v == b) {
        my_xr = xr;
        return;
    }
    used[v] = 1;

    for (pii &it : adj[v]) {
        if (!used[it.X]) {
            xr ^= it.Y;
            dfs(it.X, b, xr);
            xr ^= it.Y;
        }
    }

    order.push_back(v);
}


void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> d(n);
    for (int i = 0; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;

        adj[u].push_back({v, w});
        d[u - 1] = w;
    }

    int a, b;
    cin >> a >> b;

    --a; --b;
    dfs(a, b, 0);

    int xr_all = 0;
    int xr_path = 0;

    for (int i = 0; i < n; i++) {
        xr_all ^= d[i];
    }

    xr_path = my_xr;
    my_xr = 0;

    for (int i = 0; i < n; i++) {
        adj[i].clear();
    }

    xr_all ^= xr_path;

    if (xr_path == 0 && xr_all == 0) {
        cout << 0 << endl;
    } else {
        cout << -1 << endl;
    }

}

signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
//#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
    cin >> t;

    while (t--) {
        solve();
    }
}