#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

const int N = 2e5 + 5;
vc<std::pair<int, int>> g[N];
vc<std::pair<int, int>> rg[N];
bool da[N], used[N];

int a, b;

void ing(int v) {
    da[v] = true;
    for (auto [u, w]: rg[v]) if (!da[u]) ing(u);
}

std::pair<int, int> dp[N];

void calc(int v) {
    if (used[v]) return;
    used[v] = true;
    if (v == b) return void(dp[v] = {0, 1});
    dp[v] = {0, 0};
    for (auto [u, w]: g[v]) {
        calc(u);
        dp[v].first ^= dp[u].first ^ (dp[u].second * w);
        dp[v].second ^= dp[u].second;
    }
}

int color[N];

bool check(int v) {
    color[v] = 1;
    for (auto [u, w]: g[v]) {
        if (!da[u]) continue;
        if (color[u]) {
            if (color[u] == 1) return true;
        } else if (check(u)) return true;
    }
    color[v] = 2;
    return false;
}

int x[N];
bool loid[N];

void find_loids(int v) {
    used[v] = true;
    for (auto [u, w]: g[v]) {
        if (!da[u]) continue;
        if (used[u]) loid[v] = true;
        else find_loids(u), loid[v] |= loid[u];
    }
}

bool solve(int v) {
    if (v == b && x[v]) return false;
    used[v] = true;
    for (auto [u, w]: g[v]) {
        if (!da[u] || !loid[u]) continue;
        if (used[u]) {
            if (x[u] != (x[v] ^ w)) return false;
        } else {
            if (!(x[u] = x[v] ^ w, solve(u))) return false;
        }
    }
    return true;
}

void calc2(int v) {
    if (used[v]) return;
    used[v] = true;
    if (v == b) return void(dp[v] = {0, 1});
    dp[v] = {0, 0};
    for (auto [u, w]: g[v]) {
        if (!da[u]) continue;
        calc2(u);
        dp[v].first ^= dp[u].first ^ (dp[u].second * w);
        dp[v].second ^= dp[u].second;
    }
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t--) {
        int n, m;
        std::cin >> n >> m;
        for (int v = 0; v <= n; ++v) g[v].clear(), used[v] = da[v] = color[v] = x[v] = loid[v] = false;
        int c = 0;
        for (int v, u, w; m-- && std::cin >> v >> u >> w;) c ^= w, g[v].emplace_back(u, w), rg[u].emplace_back(v, w);
        std::cin >> a >> b;
        ing(b);
        if (!da[a]) {
            std::cout << 0 << '\n';
            continue;
        }
        find_loids(a);
        std::fill(used, used + n + 1, 0);
        if (!check(a)) {
            std::fill(used, used + n + 1, 0);
            calc(a);
            std::cout << dp[a].first << '\n';
        } else {
            std::fill(used, used + n + 1, 0);
            if (solve(a)) {
                std::fill(used, used + n + 1, 0);
                calc2(a);
                std::cout << dp[a].first << '\n';
            } else std::cout << -1 << '\n';
        }
    }
}
