#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u: v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u: v) {
        os << u << ' ';
    }
    return os;
}


vector<vector<pair<int, int>>> g;
vector<int> mark;

void dfs(int v, int p) {
    mark[v] = 1;
    for (auto [u, w]: g[v]) {
        if (u == p) {
            continue;
        }
        dfs(u, v);
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    mark.assign(n, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u -= 1;
        v -= 1;
        g[u].emplace_back(v, w);
    }
    int a, b;
    cin >> a >> b;
    a -= 1;
    b -= 1;

    dfs(a, a);

    for (int i = 0; i < n; ++i) {
        if (!mark[i]) {
            g[i].clear();
        }
    }

    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < n; ++i) {
        for (auto [u, w] : g[i]) {
            if (mark[u]) {
                gr[i].emplace_back(u, w);
            }
        }
    }


    int ans = 0;

    for (int bit = 0; bit < 30; ++bit) {
        vector<int> dp1(n), dp2(n);
        vector<int> in(n);
        for (int i = 0; i < n; ++i) {
            for (auto [v, w]: gr[i]) {
                in[v] += 1;
            }
        }

        queue<int> q;
        q.push(a);
        dp2[a] = 1;

        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto [u, w] : gr[v]) {
                in[u] -= 1;
                if (w & (1 << bit)) {
                    dp1[u] = (dp1[u] + dp2[v]) % 2;
                    dp2[u] = (dp2[u] + dp1[v]) % 2;
                } else {
                    dp1[u] = (dp1[u] + dp1[v]) % 2;
                    dp2[u] = (dp2[u] + dp2[v]) % 2;
                }
                if (in[u] == 0) {
                    q.push(u);
                }
            }
        }

        if (dp1[b]) {
            ans += (1 << bit);
        }


    }

    cout << ans << '\n';
}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day1/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}