#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;


using namespace std;

vector<vector<pair<int, int>>> edge, edge_rev;
vector<int> topsort, topsort2, used, used2, dost, pos, pos2, xor1, xor2, xor3, xor4, hm, ans;
int n, m;

void dfs1(int u) {
    dost[u] = 1;
    for (auto p : edge_rev[u]) {
        int v = p.first;
        if (dost[v] == 0) {
            dfs1(v);
        }
    }
}

void dfs2(int u) {
    used[u] = 1;
    for (auto p : edge[u]) {
        int v = p.first;
        if (dost[v] && used[v] == 0) {
            dfs2(v);
        }
    }
    topsort.push_back(u);
}

void dfs3(int u) {
    used2[u] = 1;
    for (auto p : edge_rev[u]) {
        int v = p.first;
        if (used2[v] == 0 && used[v]) {
            dfs3(v);
        }
    }
    topsort2.push_back(u);
}

void obr1(int u) {
    for (auto p : edge[u]) {
        int v = p.first;
        int w = p.second;
        if (dost[v] == 0 || used[v] == 0 || pos[v] <= pos[u]) {
            continue;
        }
        if (xor1[v] != -1) {
            if (xor2[v] == -1 && (w ^ xor1[u]) != xor1[v]) {
                xor2[v] = (xor1[u] ^ w);
            }
        } else {
            xor1[v] = (w ^ xor1[u]);
        }
        if (xor2[u] != -1) {
            if (xor2[v] == -1 && (w ^ xor2[u]) != xor1[v]) {
                xor2[v] = (xor2[u] ^ w);
            }
        }
    }
}

void obr2(int u) {
    for (auto p : edge_rev[u]) {
        int v = p.first;
        int w = p.second;
        if (dost[v] == 0 || used2[v] == 0 || pos2[v] <= pos2[u]) {
            continue;
        }
        if (xor3[v] != -1) {
            if (xor4[v] == -1 && (w ^ xor3[u]) != xor3[v]) {
                xor4[v] = (xor3[u] ^ w);
            }
        } else {
            xor3[v] = (w ^ xor3[u]);
        }
        if (xor4[u] != -1) {
            if (xor4[v] == -1 && (w ^ xor4[u]) != xor3[v]) {
                xor4[v] = (xor4[u] ^ w);
            }
        }
    }
}

void obr(int u) {
    for (auto p : edge[u]) {
        int v = p.first;
        int w = p.second;
        if (dost[v] == 0 || used[v] == 0 || pos[v] <= pos[u]) {
            continue;
        }
        ans[v] = (ans[v] ^ ans[u]);
        if (hm[u]) {
            hm[v] = (hm[v] ^ 1);
            ans[v] = (ans[v] ^ p.second);
        }
    }
}

void solve() {
    edge.clear(); edge_rev.clear();
    topsort.clear(); topsort2.clear(); used.clear(); used2.clear();
    dost.clear(); pos.clear(); pos2.clear(); xor1.clear();
    xor2.clear(); xor3.clear(); xor4.clear(); hm.clear(); ans.clear();
    cin >> n >> m;
    used2.resize(n, 0);
    edge.resize(n);
    edge_rev.resize(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        edge[u].push_back({ v, w });
        edge_rev[v].push_back({ u, w });
    }
    int a, b; cin >> a >> b; --a; --b;
    dost.resize(n, 0);
    dfs1(b);
    used.resize(n, 0);
    dfs2(a);
    reverse(all(topsort));
    dfs3(b);
    reverse(all(topsort2));
    pos.resize(n, -1);
    pos2.resize(n, -1);
    for (int i = 0; i < (int)topsort2.size(); ++i) {
        pos2[topsort2[i]] = i;
    }
    for (int i = 0; i < (int)topsort.size(); ++i) {
        pos[topsort[i]] = i;
    }
    xor1.resize(n, -1);
    xor2.resize(n, -1);
    xor3.resize(n, -1);
    xor4.resize(n, -1);
    xor1[a] = 0;
    for (int u : topsort) {
        obr1(u);
    }
    xor3[b] = 0;
    for (int v : topsort2) {
        obr2(v);
    }
    for (int u : topsort) {
        for (auto p : edge[u]) {
            int v = p.first;
            int w = p.second;
            if (used[v] && dost[v] && pos[v] <= pos[u]) {
                if (xor2[u] != -1 || xor2[v] != -1) {
                    cout << "-1\n";
                    return;
                }
                if ((xor1[u] ^ xor1[v] ^ w) != 0) {
                    cout << "-1\n";
                    return;
                }
                if (xor4[v] != -1) {
                    cout << "-1\n";
                    return;
                }
                /*if ((xor3[v] ^ xor1[v]) != 0) {
                    cout << "-1\n";
                    return;
                }*/
            }
        }
    }
    hm.resize(n, 0);
    hm[a] = 1;
    ans.resize(n, 0);
    for (int u : topsort) {
        obr(u);
    }
    cout << ans[b] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}