#include "bits/stdc++.h"
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#ifndef NT1E
//#pragma GCC target("tune=native")
//#pragma GCC optimize("O3,unroll-loops")
//#endif

using namespace std;
using ll = long long;

//#ifdef NT1E
int used[228337];
//#endif

void dfs(int v, int &timer, const vector<vector<int>> &graph, vector<int> &tout) {
//#ifdef NT1E
    used[v] = 1;
//#endif
    for (int ch : graph[v]) {
        if (used[ch]) continue;
        dfs(ch, timer, graph, tout);
    }
    tout[v] = timer++;
}

int main() {
#ifdef NT1E
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> n >> m;
        vector<int> u(m), v(m);
        bool is_cycle = (n == m);
        vector<int> w(m);
        int allxor = 0;
        for (int i = 0; i < m; ++i) {
            cin >> u[i] >> v[i] >> w[i];
            is_cycle = is_cycle && u[i] == i + 1 && v[i] == ((i + 1) % n) + 1;
            allxor ^= w[i];
        }
        int a, b;
        cin >> a >> b;
        --a, --b;
        if (is_cycle) {
            bool sw = false;
            if (a > b) {
                sw = true;
                swap(a, b);
            }
            int pathxor = 0;
            for (int uu = a; uu != b; uu = (uu + 1) % n) {
                pathxor ^= w[uu];
            }

            if (allxor != 0 || pathxor != 0) {
                cout << "-1\n";
                continue;
            }
            cout << (sw ? (pathxor ^ allxor) : pathxor) << '\n';
        } else {
            vector<vector<int>> graph(n);
            vector<vector<int>> graph_w(n);
            for (int i = 0; i < m; ++i) {
                --u[i];
                --v[i];
                graph[u[i]].push_back(v[i]);
                graph_w[u[i]].push_back(w[i]);
            }
            vector<int> tout(n);
            int dfs_timer = 0;
            dfs(a, dfs_timer, graph, tout);
            vector<int> topsort(n);
            std::iota(topsort.begin(), topsort.end(), 0);
            std::sort(topsort.begin(), topsort.end(), [&](int lhs, int rhs) {
                return tout[lhs] > tout[rhs];
            });
            vector<int> res(n);
            for (int now : topsort) {
                for (int chid = 0; chid < (int)graph[now].size(); ++chid) {
                    res[graph[now][chid]] ^= graph_w[now][chid] ^ res[now];
                }
            }
            cout << res[b] << '\n';
        }
    }
    return 0;
}
