#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--) solve();
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        gr[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    --a, --b;


    vector<bool> usea(n), useb(n);
    {
        queue<int> q;
        usea[a] = 1;
        q.push(a);
        while (q.size()) {
            int u = q.front();
            q.pop();
            for (auto [to, w] : g[u]) {
                if (!usea[to]) {
                    usea[to] = 1;
                    q.push(to);
                }
            }
        }
    }
    {
        queue<int> q;
        useb[b] = 1;
        q.push(b);
        while (q.size()) {
            int u = q.front();
            q.pop();
            for (auto [to, w] : gr[u]) {
                if (!useb[to]) {
                    useb[to] = 1;
                    q.push(to);
                }
            }
        }
    }

    vector<int> top;
    {
        bool ok = 1;
        vector<int> used(n, 0);
        vector<int> xr(n);
        auto dfs = [&](auto dfs, int u) -> void {
            if (!usea[u] || !useb[u]) {
                used[u] = 2;
                return;
            }
            used[u] = 1;
            for (auto[to, w] : g[u]) {
                if (!used[to]) {
                    xr[to] = xr[u] ^ w;
                    dfs(dfs, to);
                } else if (used[to] == 1) {
                    if ((xr[to] ^ xr[u] ^ w) != 0) {
                        ok = 0;
                    }
                }
            }
            used[u] = 2;
            top.push_back(u);
        };
        dfs(dfs, a);
        reverse(all(top));

        if (!ok) {
            cout << "-1\n";
            return;
        }
    }
    vector<int> cnt(n);
    vector<int> dp(n);
    cnt[a] = 1;
    for (auto u : top) {
        for (auto [to, w] : g[u]) {
            cnt[to] ^= cnt[u];
            dp[to] ^= (w * cnt[u]) ^ dp[u];
        }
    }
    cout << dp[b] << '\n';
}