#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;

vector<int> tin, tout;
int curt = 0;
vector<pair<int, ll>> par;
vector<vector<pair<int, ll>>> g;
void dfs(int u, int p, ll pw) {
	if (p != -1) {
		par[u] = { p, pw };
	}
	tin[u] = curt;
	curt++;
	for (auto el : g[u]) {
		int v = el.first;
		ll w = el.second;
		if (v != p) {
			dfs(v, u, w);
		}
	}
	tout[u] = curt;
	curt++;
}
bool is_pred(int u, int v) {
	return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n, m;
		cin >> n >> m;
		g.resize(n);
		vector<ll> weight(n);
		ll all_xor = 0;
		bool flag = true;
		for (int _ = 0; _ < m; ++_) {
			int u, v; ll w;
			cin >> u >> v >> w;
			u--; v--;
			if (u >= v) flag = true;
			g[u].push_back({ v, w });
			g[v].push_back({ u, w });
			weight[u] = w;
			all_xor = (all_xor ^ w);
		}
		int a, b;
		cin >> a >> b;
		a--; b--;
		if (flag) {
			tin.resize(n); tout.resize(n);
			par.resize(n);
			dfs(0, -1, -1);
			int u = a;
			ll ans = 0;
			while (!is_pred(u, b)) {
				ans ^= par[u].second;
				u = par[u].first;
			}
			u = b;
			while (!is_pred(u, a)) {
				ans ^= par[u].second;
				u = par[u].first;
			}
			cout << ans << "\n";
		}
		else {
			ll xor1 = 0;
			int u = a;
			while (u != b) {
				xor1 = (xor1 ^ weight[u]);
				u = (u + 1) % n;
			}
			if (xor1 == 0 && all_xor == 0)
				cout << 0 << "\n";
			else
				cout << -1 << "\n";
		}
	}

	return 0;
}