#include <iostream>
#include <vector>
#include <map>
using namespace std;
typedef long long ll;

vector<int> tin, tout;
int curt = 0;
vector<int> par;
vector<vector<ll>> pw;
vector<vector<pair<int, ll>>> g;
vector<vector<int>> g2;

void dfs(int u, int p) {
	par[u] = p;
	tin[u] = curt;
	curt++;
	for (int v : g2[u]) {
		if (v != p) {
			dfs(v, u);
		}
	}
	tout[u] = curt;
	curt++;
}
bool is_pred(int u, int v) {
	return (tin[u] <= tin[v] && tout[u] >= tout[v]);
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	for (int _ = 0; _ < t; ++_) {
		int n, m;
		cin >> n >> m;
		g.resize(n);
		g2.resize(n);
		vector<ll> weight(n);
		ll all_xor = 0;
		bool flag = true;
		for (int _ = 0; _ < m; ++_) {
			int u, v; ll w;
			cin >> u >> v >> w;
			u--; v--;
			if (u >= v) flag = false;
			g[u].push_back({ v, w });
			g2[u].push_back(v);
			weight[u] = w;
			all_xor = (all_xor ^ w);
		}
		int a, b;
		cin >> a >> b;
		a--; b--;
		if (flag) {
			tin.resize(n); tout.resize(n);
			par.resize(n);
			dfs(0, -1);
			pw.resize(n);
			for (int u = 0; u < n; ++u) {
				for (auto el : g[u]) {
					int v = el.first;
					ll w = el.second;
					if (v == par[u]) {
						pw[u].push_back(w);
					}
				}
			}
			int cnt1_1 = 0, cnt0_1 = 0;
			int u = a;
			while (!is_pred(u, b)) {
				int new_cnt1_1, new_cnt0_1;
				for (ll w : pw[u]) {
					if (w == 1) {
						new_cnt1_1 += cnt0_1;
						new_cnt0_1 += cnt1_1;
					}
					else {
						new_cnt0_1 += cnt0_1;
						new_cnt1_1 += cnt1_1;
					}
				}
				cnt1_1 = new_cnt1_1; cnt0_1 = new_cnt0_1;
				u = par[u];
			}
			u = b;
			while (!is_pred(u, a)) {
				int new_cnt1_1, new_cnt0_1;
				for (ll w : pw[u]) {
					if (w == 1) {
						new_cnt1_1 += cnt0_1;
						new_cnt0_1 += cnt1_1;
					}
					else {
						new_cnt0_1 += cnt0_1;
						new_cnt1_1 += cnt1_1;
					}
				}
				cnt1_1 = new_cnt1_1; cnt0_1 = new_cnt0_1;
				u = par[u];
			}
			ll ans = 0;
			if (cnt1_1 % 2 == 1) ans = 1;
			cout << ans << "\n";
		}
		else {
			ll xor1 = 0;
			int u = a;
			while (u != b) {
				xor1 = (xor1 ^ weight[u]);
				u = (u + 1) % n;
			}
			if (xor1 == 0 && all_xor == 0)
				cout << 0 << "\n";
			else
				cout << -1 << "\n";
		}
	}

	return 0;
}