// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt,tune=native")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

int st_c, ed_c;

bool dfs_cycle(int v, vector<vector<pi>> &g, vector<int> &color) {
    color[v] = 1;
    bool out = false;
    for (auto to : g[v]) {
        if (color[to.F] == 0)
            out |= dfs_cycle(to.F, g, color);
        else if (color[to.F] == 1) {
            st_c = to.F;
            ed_c = v;
            return true;
        }
    }
    color[v] = 2;
    return out;
}

void dfs_sort(int v, vector<vector<pi>> &g, vector<int> &order,
              vector<bool> &used) {
    used[v] = true;
    for (auto [to, len] : g[v])
        if (!used[to])
            dfs_sort(to, g, order, used);
    order.pb(v);
    return;
}
void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pi>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        g[--a].pb({--b, w});
    }
    int st, ed;
    cin >> st >> ed;
    if (st == ed) {
        cout << 0 << "\n";
        return;
    }
    --st;
    --ed;
    vector<int> color(n, 0), used(n, 0);
    int timer = 1;
    bool cycle = false;
    for (int i = 0; i < n; i++)
        if (color[i] == 0)
            if (dfs_cycle(i, g, color)) {
                queue<pi> q;
                q.push({st_c, 0});
                bool ok = true;
                while (!q.empty()) {
                    auto [v, val] = q.front();
                    q.pop();
                    used[v] = timer;
                    for (auto [to, len] : g[v]) {
                        if (v == ed_c && to == st_c) {
                            ok &= (val ^ len) == 0;
                        }
                        if (used[to] == timer)
                            continue;
                        q.push({to, len ^ val});
                    }
                }
                if (!ok) {
                    cout << -1 << "\n";
                    return;
                } else {
                    cycle = true;
                }
            }
    vector<int> order;
    vector<bool> usedd(n, false);
    dfs_sort(st, g, order, usedd);
    reverse(all(order));
    vector<vector<int>> dp(n);
    dp[st].pb(0);
    for (auto v : order) {
        for (auto x : dp[v]) {
            for (auto [to, len] : g[v]) {
                dp[to].pb(x ^ len);
            }
        }
    }
    int res = 0;
    for (auto x : dp[ed]) {
        res ^= x;
        if (x != 0 && cycle) {
            cout << -1 << "\n";
            return;
        }
    }
    cout << res << "\n";
    st_c = ed_c = -1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}