#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

using ll = long long;
using vl = vector<long long>;
using vvl = vector<vector<long long>>;

struct solution{
    ll n, m;
    ll a, b;
    map<pair<ll, ll>, ll> edges;
    vvl edge_list;
    vl is_good;
    vl xor_from_a;
    ll answer = 0;

    void find_good_vertex(ll v, vl& used){
        used[v] = 1;
        if (v == b){
            is_good[v] = 1;
            return;
        }
        for (auto u : edge_list[v]){
            if (!used[u]){
                find_good_vertex(u, used);
            }
            if (is_good[u]){
                is_good[v] = 1;
            }
        }
    }

    void go(ll v, vl& used, ll& local_xor){
        used[v] = 1;
        xor_from_a[v] = local_xor;
        for (auto u : edge_list[v]){
            if (used[u] == 1){
                if (is_good[u] && xor_from_a[v] ^ edges[make_pair(v, u)] != xor_from_a[u]){
                    answer = -1;
                }
            }
        }
        used[v] = 2;
    }
};

void solve(){
    ll n, m;
    cin >> n >> m;
    vl W(n);
    ll x, y, w;
    for (ll i = 0; i < n; i++){
        cin >> x >> y >> W[i];
    }
    ll a, b;
    cin >> a >> b;
    ll global_xor = 0;
    for (ll i = 0; i < n; i++){
        global_xor ^= W[i];
    }
    ll local_xor = 0;
    for (ll i = a - 1; i != b - 1; i = (i + 1) % n){
        local_xor ^= W[i];
    }
    if (global_xor == 0 && local_xor == 0){
        cout << 0;
    }
    else{
        cout << -1;
    }
    return;
}

int main(){
    ll t;
    cin >> t;
    for (ll t_ = 0; t_ < t; t_++){
        solve();
        cout << '\n';
    }
    return 0;
}