#include <iostream>
#include <iomanip>

#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

bool loop(int v, int p, vector<multimap<int, int>>& adj, vector<int>& times, vector<int>& path, int time)
{
	times[v] = time++;

	set<int> next;
	for (auto i : adj[v])
		next.insert(i.first);

	path.push_back(0);
	for (auto u : next)
		if (u != v)
			if (times[u] != -1)
			{
				path[path.size() - 1] = u;
				unordered_map<int, int> cnts;
				
				for (auto j_ : adj[path[path.size() - 1]])
					if (j_.first == path[times[u]])
						cnts[j_.second]++;
				for (int i = times[u]; i < path.size() - 1; ++i)
				{
					for (auto j : adj[path[i]])
						if (j.first == path[i + 1])
							cnts[j.second]++;
				}

				for (auto i : cnts)
					if (i.second % 2 == 1 && i.first != 0)
						return true;

				return false;
			}
			else
			{
				path[path.size() - 1] = u;
				if (loop(u, v, adj, times, path, time))
					return true;
			}
	return false;
}

void dfs(int v, int p, vector<multimap<int, int>>& adj, vector<int>& colors, int color)
{
	queue<int> q;
	q.push(v);
	colors[v] = color;
	while (!q.empty())
	{
		int v = q.front();
		q.pop();

		for (auto i : adj[v])
		if (colors[i.first] != color && i.first != p)
		{
			colors[i.first] = color;
			q.push(i.first);
		}
	}
}

void solve()
{
	int n, m;
	cin >> n >> m;
	vector<multimap<int, int>> adj(n);
	for (int i = 0; i < m; ++i)
	{
		int u, v, d;
		cin >> u >> v >> d;
		u--, v--;
		adj[v].insert({ u, d });
	}

	int a, b;
	cin >> a >> b;
	a--, b--;

	vector<int> times(n, -1);
	vector<int> path;
	if (loop(a, -1, adj, times, path, 0))
	{
		cout << "-1\n";
		return;
	}

	vector<int> colors(n);
	dfs(b, -1, adj, colors, 1);

	if (colors[a] == 0)
	{
		cout << 0 << endl;
		return;
	}

	vector<int> field(n, -1);
	field[a] = 0;
	vector<bool> done(n);
	done[a] = true;

	bool flag = false;
	while (!flag)
	{
		flag = true;

		for (int i = 1; i < n; ++i) if (colors[i] == 1 && !done[i])
		{
			bool all_done = true;
			for (auto j : adj[i])
				if (!done[j.first])
				{
					all_done = false;
					break;
				}

			if (all_done)
			{
				flag = false;
				done[i] = true;
				int val = 0;
				for (auto j : adj[i])
					val = val ^ (field[j.first] ^ j.second);
				field[i] = val;
				break;
			}
		}
	}

	cout << field[b] << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int t;
	cin >> t;
	while (t--)
		solve();
}
