#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}


void solve_case() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int a, b, x;
        cin >> a >> b >> x;
        a--, b--;
        g[a].push_back({b, x});
    }
    int s, t;
    cin >> s >> t;
    s--, t--;
    vector<int> ord;
    vector<bool> us(n);
    function<void(int)> dfs = [&](int v) {
        us[v] = true;
        for (auto uw : g[v]) {
            int u = uw.fi;
            if (!us[u]) {
                dfs(u);
            }
        }
        ord.push_back(v);
    };
    dfs(s);
    if (!us[t]) {
        // no path to t
        cout << 0 << "\n";
        return;
    }
    for (int i = 0; i < n; i++) {
        if (!us[i]) {
            dfs(i);
        }
    }
    reverse(ord.begin(), ord.end());
    vector<vector<int>> gr(n);
    for (int v = 0; v < n; v++) {
        for (auto uw : g[v]) {
            int u = uw.fi;
            gr[u].push_back(v);
        }
    }
    vector<int> color(n);
    int c = 0;
    vector<vector<int>> zxc;
    function<void(int)> dfs2 = [&](int v) {
        color[v] = c;
        us[v] = true;
        zxc.back().push_back(v);
        for (int u : gr[v]) {
            if (!us[u]) {
                dfs2(u);
            }
        }
    };
    fill(us.begin(), us.end(), 0);
    for (int i : ord) {
        if (!us[i]) {
            zxc.emplace_back();
            dfs2(i);
            c++;
        }
    }
    vector<vector<pair<int, int>>> ng(n);
    vector<bool> bad(c);
    vector<vector<pair<int, int>>> gg(c);
    vector<int> dist(n);
    vector<bool> us2(n);
    vector<bool> one(c);
    for (int cc = 0; cc < c; cc++) {
        int de = 0;
        function<void(int)> dfs4 = [&](int v) {
            us2[v] = true;
            for (auto uw : g[v]) {
                int u = uw.fi, w = uw.se;
                if (color[v] != color[u]) continue;
                if (!us2[u]) {
                    dist[u] = dist[v] ^ w;
                    dfs4(u);
                } else if (dist[u] != (dist[v] ^ w)) {
                    bad[cc] = true;
                }
            }
        };
        dfs4(zxc[cc][0]);
        for (int v : zxc[cc]) {
            for (auto uw : g[v]) {
                int u = uw.fi, w = uw.se;
                if (u == v) {
                    de++;
                }
            }
        }
        if (de == 0 && zxc[cc].size() == 1) {
            one[cc] = true;
        }
    }
    if (bad[color[s]] || bad[color[t]]) {
        cout << -1 << "\n";
        return;
    }
    for (int v = 0; v < n; v++) {
        if (bad[color[v]]) continue;
        for (auto uw : g[v]) {
            int u = uw.fi, w = uw.se;
            if (!bad[color[u]] && color[u] != color[v]) {
                gg[color[v]].push_back({color[u], dist[u] ^ dist[v] ^ w});
            }
        }
    }
    vector<int> topsort;
    vector<bool> vis(c);
    function<void(int)> dfs3 = [&](int v) {
        vis[v] = true;
        for (auto uw : gg[v]) {
            int u = uw.fi;
            if (!vis[u]) {
                dfs3(u);
            }
        }
        topsort.push_back(v);
    };
    for (int i = 0; i < gg.size(); i++) {
        if (!vis[i]) {
            dfs3(i);
        }
    }
    reverse(topsort.begin(), topsort.end());
    for (int bit = 0; bit < 30; bit++) {
        vector<vector<int>> dp(c, vector<int>(2));
        dp[color[s]][0] = 1;
        for (int v : topsort) {
            if (dp[v][1] && !one[v]) {
                bad[v] = true;
            }
            for (auto uw : gg[v]) {
                int u = uw.fi, w = uw.se;
                if (!(w & (1 << bit))) continue;
                dp[u][1] |= dp[v][1 ^ w];
                dp[u][0] |= dp[v][w];
            }
        }
    }
    vector<int> dp(c), cnt(c), bad_dp(c);
    cnt[color[s]] = 1;
    for (int cc = 0; cc < c; cc++) {
        if (bad[cc]) {
            bad_dp[cc] = 1;
        }
    }
    for (int v : topsort) {
        for (auto uw : gg[v]) {
            int u = uw.fi, w = uw.se;
            cnt[u] = (cnt[v] + cnt[u]) % 2;
            if (cnt[v] % 2 == 0) {
                dp[u] ^= w;
            }
            dp[u] ^= dp[v] ^ w;
            if (bad_dp[v]) {
                bad_dp[u] = 1;
            }
        }
    }
    if (bad_dp[color[t]]) {
        cout << -1 << "\n";
    } else {
        cout << (dp[color[t]] ^ dist[t] ^ dist[s]) << "\n";
    }

}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    freopen("inputik.txt", "r", stdin);
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}