#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;

const int MAX_N = 2e5 + 5;
vector<pair<int, int>> g[MAX_N];
bool used[MAX_N];
vector<int> order;
int dp[MAX_N];

void dfs(int v) {
    used[v] = true;
    for (const auto& [u, w] : g[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
    order.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
    }

    int a, b;
    cin >> a >> b;
    --a, --b;

    for (int v = 0; v < n; ++v) {
        if (!used[v]) {
            dfs(v);
        }
    }

    reverse(order.begin(), order.end());

    int idx = find(order.begin(), order.end(), a) - order.begin();

    for (auto i = idx; i < n; ++i) {
        int v = order[i];
        for (const auto& [u, w] : g[v]) {
            dp[u] ^= dp[v] ^ w;
        }
    }

//    cout << dp[b] << '\n';
    cout << "-1\n";
    order.clear();
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        used[i] = false;
        dp[i] = 0;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}