#include <vector>
#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;


const int MAX_N = 2e5 + 5;
vector<pair<int, int>> g[MAX_N];
bool used[MAX_N];

int dfs(int v, int b) {
    used[v] = true;
    if (v == b) return 0;
    for (const auto& edge : g[v]) {
        if (used[edge.first]) continue;
        return dfs(edge.first, b) ^ edge.second;
    }
}


void solve() {
    int n, m;
    cin >> n >> m;

    int xor_sum = 0;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        xor_sum ^= w;
    }
    int a, b;
    cin >> a >> b;
    --a, --b;

    if (xor_sum == 0 && dfs(a, b) == 0) {
        cout << "0\n";
    }
    else {
        cout << "-1\n";
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}