#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, m;
    vector<vector<pair<int, int>>> graph;
    vector<vector<pair<int, int>>> reverse_graph;
    vector<int> dp;

    void DFS(int v) {
        dp[v] = -2;
        int cur_dp = 0;
        for (auto [u, w] : reverse_graph[v]) {
            if (dp[u] == -2) {
                cerr << "CYCLE\n";
            } else {
                if (dp[u] == -1) {
                    DFS(u);
                }
                cur_dp ^= dp[u] ^ w;
            }
        }
        dp[v] = cur_dp;
    }

    solve() : graph(n), reverse_graph(n), dp(n, -1) {
        for (int i = 0; i < m; ++i) {
            in<int> v, u, w;
            graph[v - 1].emplace_back(u - 1, w);
            reverse_graph[u - 1].emplace_back(v - 1, w);
        }

        in<int> a, b;
        if (a == b) {
            cout << "0\n";
            return;
        }
        dp[a - 1] = 0;
        DFS(b - 1);
        cout << dp[b - 1] << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
