#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, m;
    vector<vector<pair<int, int>>> graph;
    vector<vector<pair<int, int>>> reverse_graph;
    vector<int> dp;

    void BFS(int x) {
        queue<int> q;
        q.push(x);
        dp[x] = 0;
        while (!q.empty()) {
            int v = q.front();
            //cerr << v << "\n";
            q.pop();
            for (auto [u, w] : graph[v]) {
                q.push(u);
                if (dp[u] == -1) {
                    dp[u] = 0;
                }
                dp[u] ^= dp[v] ^ w;
            }
        }
    }

    solve() : graph(n), reverse_graph(n), dp(n, -1) {
        for (int i = 0; i < m; ++i) {
            in<int> v, u, w;
            graph[v - 1].emplace_back(u - 1, w);
            reverse_graph[u - 1].emplace_back(v - 1, w);
        }

        in<int> a, b;
        BFS(a - 1);
        if (dp[b - 1] < 0) {
            cout << "-1\n";
        } else {
            cout << dp[b - 1] << "\n";
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
