#include<bits/stdc++.h>

#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;
vector<pair<int, int>> g[N], gr[N], g2[N];
int comp[N], cur = 0;
bool ok[N][2], used[N];
bool good[N];
vector<int> ord, all[N];

void zhfs(int v) {
    used[v] = 1;
    for (auto to : g[v]) {
        if (good[to.first] && !used[to.first]) {
            zhfs(to.first);
        }
    }
    ord.pb(v);
}

void dfs(int v) {
    comp[v] = cur;
    all[cur].pb(v);
    for (auto to : gr[v]) {
        if (comp[to.first] == -1 && good[to.first]) {
            dfs(to.first);
        }
    }
}

vector<array<int, 3>> u;

void add_edge(int a, int b, int c) {
    u.pb({a, b, c});
    g[a].pb({b, c});
    gr[b].pb({a, c});
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i < n; i++) {
            g[i].clear();
            gr[i].clear();
            g2[i].clear();
            ok[i][0] = ok[i][1] = 0;
            used[i] = 0;
            good[i] = 0;
            comp[i] = -1;
            all[i].clear();
        }
        cur = 0;
        ord.clear();
        u.clear();
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            add_edge(u, v, w);
        }
        int s, t;
        cin >> s >> t;
        s--, t--;
        {
            deque<int> q{s};
            ok[s][0] = 1;
            while (q.size() > 0) {
                int v = q.front();
                q.pop_front();
                for (auto to : g[v]) {
                    if (!ok[to.first][0]) {
                        ok[to.first][0] = 1;
                        q.pb(to.first);
                    }
                }
            }
        }
        {
            deque<int> q{t};
            ok[t][1] = 1;
            while (q.size() > 0) {
                int v = q.front();
                q.pop_front();
                for (auto to : gr[v]) {
                    if (!ok[to.first][1]) {
                        ok[to.first][1] = 1;
                        q.pb(to.first);
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (ok[i][0] && ok[i][1]) {
                good[i] = 1;
            }
        }
        for (int i = 0; i < n; i++) {
            if (!used[i] && good[i]) {
                zhfs(i);
            }
        }
        reverse(all(ord));
        for (auto v : ord) {
            if (comp[v] == -1) {
                dfs(v);
                cur++;
            }
        }
        vector<int> val(n, -1);
        bool good = 1;
        vector<bool> bad(cur);
        for (int i = 0; i < cur; i++) {
            int v = all[i][0];
            val[v] = 0;
            deque<int> q{v};
            while (q.size() > 0) {
                int u = q.front();
                q.pop_front();
                for (auto to : g[u]) {
                    if (comp[to.first] != comp[u]) continue;
                    if (val[to.first] == -1) {
                        val[to.first] = val[u] ^ to.second;
                        q.pb(to.first);
                        g2[u].pb(to);
                    }
                    good &= val[to.first] == (val[u] ^ to.second);
                }
            }
            if (all[i].size() > 1) {
                bad[i] = 1;
            }
        }
        for (auto to : u) {
            if (comp[to[0]] == -1 || comp[to[1]] == -1) continue;
            //assert(comp[to[0]] != comp[to[1]]);
            if (comp[to[0]] != comp[to[1]]) {
                g2[to[0]].pb({to[1], to[2]});
            } else {
                if (to[0] == to[1]) {
                    bad[comp[to[0]]] = 1;
                }
            }
        }
        //assert(good);
        if (!good) {
            cout << -1 << endl;
            continue;
        }
        {
            vector<int> cnt(n), res(n);
            map<int, int> mp;
            deque<int> q{s};
            cnt[s] = 1;
            mp[s] = 1;
            for (int v = s; v <= t; v++) {
               // int v = q.front();
               // q.pop_front();
                for (auto to : g[v]) {
                    if (!mp[to.first]) {
                        q.pb(to.first);
                        mp[to.first] = 1;
                    }
                    cnt[to.first] ^= cnt[v];
                    res[to.first] ^= res[v];
                    if (cnt[v]) {
                        res[to.first] ^= to.second;
                    }
                }
            }
            cout << res[t] << endl;
        }
    }
    return 0;
}
