#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>

#define int long long
#define double long double

using namespace std;

const int MAXN = 201'000;
const int inf = 1e18;

vector <int> g[MAXN];
vector <int> gt[MAXN];
vector <int> e, w;
vector <int> et, wt;

void solve(){
    e.clear(); w.clear();
    et.clear(); wt.clear();
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; i ++) g[i].clear();
    for (int i = 0; i < n; i ++) gt[i].clear();
    int fl = 1;
    for (int i = 0; i < m; i ++){
        int u, v, wc; cin >> u >> v >> wc; u--; v--;
        if (u > v) fl = 0;
        g[u].push_back(e.size());
        e.push_back(v); w.push_back(wc);
        gt[v].push_back(et.size());
        et.push_back(u); wt.push_back(wc);
    }
    int a, b; cin >> a >> b; a--; b--;
    if (fl == 1){
        vector <int> dp1(n, 0), dp2(n, 0);
        dp1[a] = 1, dp2[b] = 1;
        for (int i = 0; i < n; i ++){
            for (int id : g[i]){
                dp1[e[id]] += dp1[i];
            }
        }
        for (int i = n - 1; i >= 0; i--){
            for (int id : gt[i]){
                dp2[et[id]]+= dp2[i];
            }
        }
        int ans = 0;
        for (int i = 0; i < n; i ++){
            for (int id : g[i]){
                if (dp1[i] % 2 == 1 && dp2[e[id]] % 2 == 1)
                    ans ^= w[id];
            }
        }
        cout << ans << endl;
    }
    else{
        exit(1329);
    }
}

signed main() {
    cout << setprecision(11) << fixed;
    int t; cin >> t;
    while (t--){
        solve();
    }
    return 0;
}
