#include <bits/stdc++.h>
#define int long long

using namespace std;

struct edge{
    int v, w;
};

const int maxn = 2e5 + 5;

vector < vector <edge> > g(maxn, vector <edge> ());
vector < vector <int> > h(maxn, vector <int> ());
int used[maxn], col[maxn], tout[maxn];
int tme = 0;
void set_time(int v) {
    used[v] = 1;
    for (auto u : h[v]) {
        if (!used[u]) {
            set_time(u);
        }
    }
    tout[tme++] = v;
}

void set_col(int v, int c) {
    col[v] = c;
    for (auto [u, w] : g[v]) {
        if (!col[u]) {
            set_col(u, c);
        }
    }
}

vector < vector <int> > cssg(maxn, vector <int> ());
vector <int> path;
bool find_path(int v, int target) {
    path.push_back(v);
    if (v == target) return 1;
    for (auto u : cssg[v]) {
        if (find_path(u, target)) {
            return 1;
        }
    }
    path.pop_back();
    return 0;
}

int tp[maxn];

void set_tp(int v, int x, int pw) {
    tp[v] = v;
    for (auto [u, w] : g[v]) {
        if (col[u] == col[v] && tp[u] == -1) {
            if (w & (1 << pw)) {
                set_tp(u, x ^ 1, pw);
            } else {
                set_tp(u, x, pw);
            }
        }
    }
}

int dp[maxn][2];

void solve() {
    int n, m; cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        h[i].clear();
        used[i] = 0; col[i] = 0;
    }
    tme = 0;
    for (int i = 0; i < m; ++i) {
        int v, u, w; cin >> v >> u >> w;
        v--; u--;
        g[v].push_back({u, w});
        h[u].push_back(v);
    }
    int a, b; cin >> a >> b;
    a--; b--;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) set_time(i);
    }
    int colors = 1;
    for (int i = n - 1; i >= 0; --i) {
        if (!col[tout[i]]) {
            set_col(tout[i], colors++);

        }
    }
    vector < vector <int> > css(colors, vector <int> ());
    for (int i = 0; i < n; ++i) {
        css[col[i]].push_back(i);
    }
    for (int i = 1; i < colors; ++i) {
        used[i] = 0;
    }
    for (int i = 1; i < colors; ++i) {
        for (auto v : css[i]) {
            for (auto [u, w] : g[v]) {
                if (col[u] != i && !used[col[u]]) {
                    used[col[u]] = 1;
                    cssg[i].push_back(col[u]);
                }
            }
        }
        for (auto u : cssg[i]) {
            used[u] = 0;
        }
    }
    path.clear();
    if (!find_path(col[a], col[b])) {
        cout << "0\n";
        return;
    }
    return;
    int maxw = 30;
    int res = 0;
    for (int w = 0; w < maxw; ++w) {
        for (int i = 0; i < n; ++i) {
            tp[i] = -1;
        }
        for (auto c : path) {
            set_tp(css[c][0], 0, w);
            for (auto v : css[c]) {
                for (auto [u, wt] : g[v]) {
                    if (col[u] == col[v]) {
                        int need = (wt & (1 << w)) > 0;
                        if (need != (tp[u] ^ tp[v])) {
                            cout << "-1\n";
                            return;
                        }
                    }
                }
            }
        }
        int ln = path.size();
        int ok = 1, bad = -1;
        for (auto c : path) {
            if (css[c].size() > 1) {
                ok = 0;
                bad = c;
            }
        }
        if (ok) {
            dp[a][0] = 1;
            dp[a][1] = 0;
            for (int i = 1; i < ln; ++i) {
                int v = css[path[i]][0];
                dp[v][0] = 0;
                dp[v][1] = 0;
                int d = css[path[i - 1]][0];
                for (auto [u, wt] : g[d]) {
                    if (col[u] == path[i]) {
                        if (wt & (1 << w)) {
                            dp[v][0] = dp[v][0] ^ dp[d][1];
                            dp[v][1] = dp[v][1] ^ dp[d][0];
                        } else {
                            dp[v][0] = dp[v][0] ^ dp[d][0];
                            dp[v][1] = dp[v][1] ^ dp[d][1];
                        }
                    }
                }
            }
            if (dp[b][1]) {
                res += (1 << w);
            }
        }
    }
    cout << res << "\n";
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
