#include <iostream>
#include "array"
#include "climits"
#include "cmath"
#include "algorithm"
#include "vector"
#include "string"
#include "map"
using namespace std;
struct dsu {
    vector<int> p;
    void init(int n) {
        p.assign(n, {});
        for (int i = 0; i < n; ++i) {
            p[i] = i;
        }
    }
    int getv(int v) {
        if (p[v] == v)
            return v;
        return p[v] = getv(p[v]);
    }
    bool mrg(int a, int b) {
        a = getv(a);
        b = getv(b);
        if (a == b)
            return 0;
        p[a] = b;
        return 1;
    }
};
vector<vector<pair<int, int>>> g;
dsu usd;
vector<int> seen;
vector<int> depth;
void dfsdepth(int v, int vl) {
    if (seen[v] == 1)
        return;
    seen[v] = 1;
    depth[v] = vl;
    for (auto [i, beba] : g[v])
        dfsdepth(i, vl + 1);
}
int dfs(int v, int p) {
    if (seen[v] == 2)
        return 1e7;
    if (seen[v] == 1)
        return depth[v];
    seen[v] = 1;
    int res = depth[v];
    for (auto [i, beba] : g[v]) {
        res = min(res, dfs(i, v));
    }
    //cout << v << ' ' << depth[v] << ' ' << res << '\n';
    seen[v] = 2;
    if (res != depth[v])
        usd.mrg(v, p);
    return res;
}
vector<int> cnts;
vector<int> clr;
vector<int> clrbd;
vector<int> sumcic;
void dfscmp(int v, int val) {
    //cout << v << ' ' << clr[v] << ' ' << val << '\n';
    if (seen[v]) {
        if (val != cnts[v])
            clrbd[clr[v]] = 1;
        return;
    }
    seen[v] = 1;
    cnts[v] = val;
    for (auto [i, beba] : g[v]) {
        //cout << v << "->" << i << '\n';
        if (clr[i] == clr[v])
            dfscmp(i, val ^ beba);
    }
}
vector<pair<int, int>> slv(vector<vector<pair<int, int>>> g, int s) {
    vector<int> tosee;
    vector<int> cnt(g.size());
    vector<pair<int, int>> vals(g.size(), {-1, 0});
    for (int i = 0; i < g.size(); ++i) {
        for (auto [j, rer] : g[i])
            cnt[j]++;
    }
    for (int i = 0; i < g.size(); ++i) {
        if (cnt[i] == 0)
            tosee.push_back(i);
    }

    while (!tosee.empty()) {
        int vl = tosee.back();
        tosee.pop_back();
        //cout << vl << '\n';
        for (auto [i,brbr] : g[vl]) {
            cnt[i]--;
            if (cnt[i] == 0)
                tosee.push_back(i);
        }
        if (vl == clr[s]) {
            //cout << "DA\n";
            vals[vl].first = cnts[s];
        }
        if (vals[vl].first != -1) {
            for (auto[i, brbr] : g[vl]) {
                if (vals[vl].second)
                    vals[i].second = 1;
                if (vals[i].first == -1)
                    vals[i].first = vals[vl].first ^ brbr;
                if (vals[i].first != (vals[vl].first ^ brbr))
                    vals[i].second = 1;
            }
        }
    }
    return vals;
}
int slvv2(vector<vector<pair<int, int>>> g, int s, int f, vector<vector<int>> elems) {
    vector<int> tosee;
    vector<int> cnt(g.size());
    vector<pair<int, int>> vals(g.size(), {0, 0});
    for (int i = 0; i < g.size(); ++i) {
        for (auto [j, rer] : g[i])
            cnt[j]++;
    }
    for (int i = 0; i < g.size(); ++i) {
        if (cnt[i] == 0)
            tosee.push_back(i);
    }
    while (!tosee.empty()) {
        int vl = tosee.back();
        tosee.pop_back();
        for (auto [i,brbr] : g[vl]) {
            cnt[i]--;
            if (cnt[i] == 0)
                tosee.push_back(i);
        }
        if (elems[vl].size() > 1 or (elems[vl].size() == 1 and sumcic[vl])) {
            continue;
        }
        if (vl == clr[s]) {
            vals[vl] = {cnts[s], 1};
        }
        //cout << vl << ' ' << vals[vl].first << ' ' << vals[vl].second << '\n';
        for (auto[i, brbr] : g[vl]) {
            vals[i].second ^= vals[vl].second;
            vals[i].first ^= vals[vl].first;
            if (vals[vl].second == 1)
                vals[i].first ^= brbr;
        }

    }
    return vals[clr[f]].first ^ cnts[f];
}vector<vector<pair<int, int>>> betcmp;
void solve() {
    int n, m;
    cin >> n >> m;
    sumcic.assign(n, {});
    clrbd.assign(n, {});
    g.assign(n, {});
    usd.init(n);
    cnts.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;b--;
        if (a == b) {
            sumcic[a] = 1;
        }
        g[a].push_back({b, c});
    }
    int s, f;
    cin >> s >> f;
    s--;f--;
    depth.assign(n, {});
    seen.assign(n, 0);
    dfsdepth(s, 0);
    seen.assign(n, 0);
    dfs(s, -1);
    vector<vector<int>> elems(n);
    clr.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        clr[i] = usd.getv(i);
        //cout << clr[i] << '\n';
        elems[clr[i]].push_back(i);
    }
    seen.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!elems[i].empty()) {
            dfscmp(elems[i][0], 0);
        }
    }
    vector<vector<pair<int, int>>> rewbetcmp(n);
    betcmp.assign(n, {});
    for (int i = 0; i < n; ++i) {
        for (auto [u, c] : g[i]) {
            if (clr[u] != clr[i]) {
                rewbetcmp[clr[u]].push_back({clr[i], c ^ cnts[i] ^ cnts[u]});
                betcmp[clr[i]].push_back({clr[u], c ^ cnts[i] ^ cnts[u]});
            }
        }
    }

    vector<pair<int, int>> a1 = slv(betcmp, s), a2 = slv(rewbetcmp, f);
    for (int i = 0; i < n; ++i) {
        if (elems[i].size() > 1 or (elems[i].size() == 1 and sumcic[i])) {
            //cout << elems[i][0] << ' ' << a1[i].first << ' ' << a2[i].first << '\n';
            //cout << elems[i][0] << ' ' << a1[i].second << ' ' << a2[i].second << '\n';
            //cout << clrbd[i] << '\n';
            if (a1[i].first != -1 and a2[i].first != -1) {
                if (clrbd[i]) {
                    cout << "-1\n";
                    return;
                }
                if (a1[i].second or a2[i].second or (a1[i].first != a2[i].first)) {
                    cout << "-1\n";
                    return;
                }
            }
        }
    }
    cout << slvv2(betcmp, s, f, elems) << '\n';
}
int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}
/*
5
1 1
1 1 0
1 1

3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3

2 2
1 2 1
2 1 2
1 2

3 3
1 2 7
2 3 0
3 1 7
2 3

4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4

2
 4 4
1 2 1
2 3 1
3 4 1
4 1 1
1 3
4 4
1 2 1
2 3 1
3 4 1
4 1 1
1 4
*/