#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

struct Rib{
    int from, to, w;
    friend istream& operator>>(istream &is, Rib &a) {is >> a.from >> a.to >> a.w, a.from--, a.to--; return is;}
};

struct Test{
    int n, m;
    vector <Rib> r;
    int st, fn;
    friend istream& operator>>(istream &is, Test &a) {
        is >> a.n >> a.m;
        a.r.resize(a.m);
        cin >> a.r >> a.st >> a.fn;
        a.st--, a.fn--;
        return is;
    }
};

const int N = 1010;
int a[N][N], r[N][N], xr[N][N];

int mergexr(int a, int b){
    if (a == -2) return b;
    if (b == -2) return a;
    if (a == b) return a;
    return -1;
}

int getxr(int a, int b) {
    if (a == -2 || b == -2) return -2;
    if (a == -1 || b == -1) return -1;
    return a ^ b;
}

void solve(const Test &test){
    int n = test.n, m = test.m;
    for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) a[i][j] = 0, r[i][j] = 0, xr[i][j] = -2;
    for (int i = 0; i < m; i++){
        auto [u, v, w] = test.r[i];
        a[u][v] ^= w;
        r[u][v] ^= 1;
        xr[u][v] = mergexr(xr[u][v], w);
    }
    int st = test.st, fn = test.fn;
    for (int k = 0; k < n; k++){
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++){
                xr[i][j] = mergexr(xr[i][j], getxr(xr[i][k], xr[k][j]));
                r[i][j] ^= r[i][k] && r[k][j];
                a[i][j] ^= r[k][j] * a[i][k] ^ r[i][k] * a[k][j];
            }
        }
    }
    for (int k = 0; k < n; k++){
        int x = getxr(xr[st][k], getxr(xr[k][k], xr[k][fn]));
        if (x != -2 && x != 0) {
            cout << -1 << endl;
            return;
        }
    }
    cout << a[st][fn] << endl;
}

int dag(const Test &test){
    for (auto [u, v, w] : test.r) if (u >= v) return 0;
    return 1;
}

int cycle(const Test &test){
    if (test.m != test.n) return 0;
    for (int i = 0; i < test.n; i++) if (test.r[i].from != i || test.r[i].to != (i + 1) % test.n) return 0;
    return 1;
}

void solvecycle(const Test &test){
    int n = test.n, st = test.st, fn = test.fn;
    int xrall = 0, xrab = 0;
    for (auto t : test.r) {
        xrall ^= t.w;
        if (t.from >= min(st, fn) && t.to <= max(st, fn)) xrab ^= t.w;
    }
    if (st > fn) xrab ^= xrall;
    if (xrab == 0 && xrall == 0) cout << 0 << endl;
    else cout << -1 << endl;
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    cin >> ttt;
    Test t;
    for (int i = 0; i < ttt; i++) {
        cin >> t;
        solve(t);
        if (cycle(t)) solvecycle(t);
        //else if (dag(t)) solvedag(t);
        else solve(t);
    }
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}
