#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

#pragma optimize("O2, inline, avx2");
using namespace std;

vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}


struct st{
    int to;
    int len;
};
vector <vector<st>> graph;
void solve(){
    int n;
    cin >> n;
    graph.assign(n + 1, vector <st>(2));
    int m;
    cin >> m;
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        graph[u][0] = {v, w};
        graph[v][1] = {u, w};
    }
    int a, b;
    cin >> a >> b;
    int ans1 = 0;
    int temp1 = a;
    while (temp1 != b){
        ans1 ^= graph[temp1][0].len;
        temp1 = graph[temp1][0].to;
    }
    int ans2 = 0;
    int temp2 = a;
    while (temp2 != b){
        ans2 ^= graph[temp2][1].len;
        temp2 = graph[temp2][1].to;
    }
    cout << (ans1 ^ ans2) << endl;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--){
        solve();
    }
    return 0;
}

