#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <iomanip>
#include <cassert>

using namespace std;
typedef long long ll;
typedef long double ld;
#define endl '\n'

int n, m;
vector <pair <int, int>> g[200010];
vector <pair <int, int>> g_[200010];
bool cans[200010];
bool cant[200010];
bool ok[200010];
int s, t;

void dfs(int u, bool* can, vector <pair <int, int>>* g)
{
	if (can[u]) return;
	can[u] = true;

	for (auto ed : g[u]) dfs(ed.first, can, g);
}

vector <int> srt;
int used[200010];
bool cht[200010];
bool chs[200010];
int pos[200010];

void dfs(int u)
{
	used[u] = 1;

	for (auto ed : g[u])
	{
		auto v = ed.first;
		if (!ok[v]) continue;
		if (used[v] == 1)
		{
			continue;
		}
		if (used[v] == 2) continue;
		dfs(v);
	}
	pos[u] = srt.size();
	srt.push_back(u);
	used[u] = 2;
}

bool ma[1010][1010][2];

void dfs(int u, int v, bool c, int j)
{
	if (ma[u][v][c]) return;
	ma[u][v][c] = true;
	for (auto ed : g[v]) if (ok[ed.first])
	{
		dfs(u, ed.first, c ^ ((ed.second >> j) & 1), j);
	}
}

inline void solve()
{
	cin >> n >> m;
	for (int i = 1; i <= n; ++i)
	{
		g[i].clear();
		g_[i].clear();
		cans[i] = cant[i] = used[i] = chs[i] = cht[i] = false;
	}

	for (int i = 1; i <= m; ++i)
	{
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({ v, w });
		g_[v].push_back({ u, w });
	}

	cin >> s >> t;
	dfs(s, cans, g);
	dfs(t, cant, g_);

	for (int i = 1; i <= n; ++i) ok[i] = cans[i] && cant[i];

	bool norm = true;

	for (int j = 0; j < 30; ++j)
	{
		for (int i = 1; i <= n; ++i) for (int j = 1; j <= n; ++j) ma[i][j][0] = ma[i][j][1] = false;
		for (int i = 1; i <= n; ++i) if (ok[i]) dfs(i, i, 0, j);

		for (int i = 1; i <= n; ++i) if (ok[i]) for (auto ed : g[i]) if (ok[ed.first])
		{
			for (int x = 0; x < 2; ++x)
			{
				for (int y = 0; y < 2; ++y)
				{
					for (int z = 0; z < 2; ++z)
					{
						if (((((ed.second >> j) & 1) ^ x ^ y ^ z ) && ma[ed.first][i][y] && ma[s][i][x] && ma[i][t][z]) ||
							ma[s][i][x] && ma[i][t][z] && (x ^ z) && (ma[ed.first][i][0] || ma[ed.first][i][1]))
						{
							norm = false;
							break;
						}
					}
					if (!norm) break;
				}
				if (!norm) break;
			}
			if (!norm) break;
		}
		if (!norm) break;
	}

	if (!norm)
	{
		cout << -1 << endl;
		return;
	}

	srt.clear();
	dfs(s);

	reverse(srt.begin(), srt.end());

	int ans = 0;
	for (auto i : srt)
	{
		if (i == s) chs[i] = 1;
		else for (auto ed : g_[i]) if (ok[ed.first] && pos[ed.first] < pos[i]) chs[i] ^= chs[ed.first];
	}

	reverse(srt.begin(), srt.end());

	for (auto i : srt)
	{
		if (i == t) cht[i] = 1;
		else for (auto ed : g[i]) if (ok[ed.first] && pos[ed.first] < pos[i]) cht[i] ^= cht[ed.first];
	}


	for (auto i : srt)
	{
		for (auto ed : g[i]) if (ok[ed.first] && chs[i] && cht[ed.first] && pos[ed.first] <  pos[i])
		{
			ans ^= ed.second;
		}
	}

	cout << ans << endl;
}

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
	
	int t;
	cin >> t;
	while (t--)
	{
		solve();
	}

	return 0;
}