#include <bits/stdc++.h>

using namespace std;

struct edge {
    int v, w;
    edge(int V = 0, int W = 0) {
        v = V; w = W;
    }
};

void solve1(int n, int m, vector<vector<edge>> &gr, int a, int b) {
    --a; --b;
    int xr = 0;
    int cr = a;
    while (cr != b) {
        xr ^= gr[cr][0].w;
        cr = gr[cr][0].v;
    }

    int allxr = 0;
    for (auto &x : gr) {
        allxr ^= x[0].w;
    }
    if ((allxr ^ xr) != 0 or xr != 0)
        cout << -1 << '\n';
    else
        cout << xr << '\n';
}
vector<bool> used;
void go(int v, vector<vector<edge>> &revg, vector<int> &num, vector<int> &xr) {
    if (used[v])
        return;
    used[v] = 1;
    for (auto &e : revg[v]) {
        go(e.v, revg, num, xr);
        num[v] += num[e.v];
        xr[v] ^= xr[e.v];
        if (num[e.v] & 1)
            xr[v] ^= e.w;
    }
}

void solve23(int n, int m, vector<vector<edge>> &gr, int a, int b) {
    used = {};
    used.assign(n, 0);
    --a; --b;
    vector<int> num(n);
    vector<int> xr(n);
    xr[a] = 0;
    num[a] = 1;

    vector<vector<edge>> revg(n);
    for (int i = 0; i < n; ++i) {
        for (auto &e : gr[i])
            revg[e.v].emplace_back(i, e.w);
    }

    go(b, revg,num, xr);
    cout << xr[b] << '\n';
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> gr(n);
    bool c = 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        if ((u + 1) % n != v)
            c = 0;
        gr[u].emplace_back(v, w);
    }
    for (auto &x : gr)
        if (x.size() != 1)
             c = 0;
    int a, b;
    cin >> a >> b;
    if (c)
        solve1(n, m, gr, a, b);
    else
        solve23(n, m, gr, a, b);
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}