#include <bits/stdc++.h>

using namespace std;

// #include "debug.h"
// #define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"

#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

void dfs(int u, vector<bool>& used, vector<int>& ts, const vector<vector<pair<int, int>>>& g) {
    used[u] = true;
    for (auto [v, w] : g[u]) {
        if (used[v]) continue;
        dfs(v, used, ts, g);
    }
    ts.push_back(u);
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n), gt(n);
    vector<tuple<int, int, int>> e(m);

    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        gt[v].emplace_back(u, w);
        e[i] = { u, v, w };
    }

    bool is_cycle = (n == m);
    for (auto [u, v, w] : e) {
        is_cycle &= (v == (u + 1) % n);
    }

    int a, b;
    cin >> a >> b;
    --a, --b;

    if (is_cycle) {
        dbg(1);
        int xor_ab = 0;
        for (int i = a; i != b; i = (i + 1) % n) {
            xor_ab ^= g[i][0].second;
        }

        int xor_ba = 0;
        for (int i = b; i != a; i = (i + 1) % n) {
            xor_ba ^= g[i][0].second;
        }

        if (xor_ab == 0) {
            if (xor_ba == 0) {
                cout << 0 << '\n';
            } else {
                cout << 0 << '\n';
            }
        } else {
            cout << -1 << '\n';
        }

        return;
    }

    vector<bool> con_a(n);
    vector<int> ts_a;
    dfs(a, con_a, ts_a, g);
    reverse(ts_a.begin(), ts_a.end());

    vector<int> dp_a(n);
    dp_a[a] = 1;
    for (int u : ts_a) {
        for (auto [v, w] : g[u]) {
            dp_a[v] ^= dp_a[u];
        }
    }

    vector<bool> con_b(n);
    vector<int> ts_b;
    dfs(b, con_b, ts_b, gt);
    reverse(ts_b.begin(), ts_b.end());

    vector<int> dp_b(n);
    dp_b[b] = 1;
    for (int u : ts_b) {
        for (auto [v, w] : gt[u]) {
            dp_b[v] ^=  dp_b[u];
        }
    }

    int ans = 0;
    for (auto [u, v, w] : e) {
        if (con_a[u] && con_b[v] && dp_a[u] && dp_b[v]) {
            ans ^= w;
        }
    }

    cout << ans << '\n';
}

/*
1
3 2
1 2 1
2 3 2
1 3
*/

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    cin >> T;

    while (T--) {
        solve();
    }
}