#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;

vector <pair <int, ll>> g[MAXN];
vector <int> revg[MAXN];
vector <int> deg(MAXN, 0);
vector <bool> used(MAXN, false);
vector <ll> ans(MAXN, 0);

void dfs(int v) {
    used[v] = true;
    for (auto u : revg[v]) {
        if (!used[u]) {
            dfs(u);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        ans[i] = 0;
        g[i].clear();
        revg[i].clear();
        deg[i] = 0;
    }
    int v, u;
    ll w;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> w;
        v--;
        u--;
        deg[u]++;
        g[v].push_back({u, w});
        revg[u].push_back(v);
    }
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    dfs(f);
    queue <int> go;

    go.push(s);
    while (!go.empty()) {
        v = go.front();
        go.pop();
        for (auto [vv, c] : g[v]) {
            ans[vv] ^= (ans[c] ^ c);
            deg[vv]--;
            if (deg[vv] == 0) {
                go.push(vv);
            }
        }
    }
    cout << ans[f];
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
