#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;

vector <pair <int, ll>> g[MAXN];
vector <int> revg[MAXN];
vector <int> deg(MAXN, 0);
vector <int> used(MAXN, 0);
vector <ll> ans(MAXN, 0);

void dfs(int v, ll c) {
    ans[v] ^= c;
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (used[u] == 0) {
            dfs(u, (c ^ w));
        }
    }
    used[v] = 0;
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        used[i] = 0;
        ans[i] = 0;
        g[i].clear();
        revg[i].clear();
        deg[i] = 0;
    }
    int v, u;
    ll w;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> w;
        v--;
        u--;
        deg[u]++;
        g[v].push_back({u, w});
        revg[u].push_back(v);
    }
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    dfs(s, 0);
    cout << ans[f] << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
