#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

struct edge {
    ll to, weight;
};
const int sz = 31;
const vector<vector<ll>> mine(31, vector<ll>(2, 0));
vector<vector<edge>> gr;
vector<ll> top_sort;
vector<bool> used;

struct xui {
    vector<vector<ll>> f = mine;

    xui operator+=(xui b) {
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 31; j++) {
                f[j][i] += b.f[j][i];
                f[j][i] %= 2;
            }
        }
        return *this;
    }

    xui operator^(ll x) {
        xui ans;
        ans.f = f;
        int t = 0;
        while (x > 0) {
            if (x % 2) {
                swap(ans.f[t][0], ans.f[t][1]);
            }
            x /= 2;
            t++;
        }
        return ans;
    }
};

struct xui2{
    vector<vector<ll>> f = mine;

    xui2 operator+=(xui2 b) {
        for (int i = 0; i < 2; i++) {
            for (int j = 0; j < 31; j++) {
                f[j][i] += b.f[j][i];
                f[j][i] %= ll(1e9 + 6);
            }
        }
        return *this;
    }

    xui2 operator^(ll x) {
        xui2 ans;
        ans.f = f;
        int t = 0;
        while (x > 0) {
            if (x % 2) {
                swap(ans.f[t][0], ans.f[t][1]);
            }
            x /= 2;
            t++;
        }
        return ans;
    }

    bool check(xui2 b){
        bool is = false;
        for (int i  =0; i < 31; i++){
            is |= f[i][0] & b.f[i][1];
            is |= f[i][1] & b.f[i][0];
        }
        return is;
    }
};

void dfs(int v) {
    used[v] = true;
    for (auto el: gr[v]) {
        if (!used[el.to]) {
            dfs(el.to);
        }
    }
    top_sort.push_back(v);
}

void solve() {
    gr.clear();
    top_sort.clear();
    used.clear();
    int n, m;
    cin >> n >> m;
    gr.resize(n);
    used.resize(n);
    vector<vector<edge>> rev(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        gr[u].push_back({v, w});
        rev[v].push_back({u, w});
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    std::reverse(top_sort.begin(), top_sort.end());
    vector<xui2> dp2(n);
    vector<xui2> dp3(n);
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    for (int i = 0; i < 31; i++) {
        dp2[a].f[i][0] = 1;
        dp3[b].f[i][0] = 1;
    }
    vector<ll> por(n);
    for (int i = 0; i < n; i++) {
        por[top_sort[i]] = i;
    }
    for (auto j: top_sort) {
        for (auto el: gr[j]) {
            dp2[el.to] += (dp2[j] ^ el.weight);
        }
    }
    std::reverse(top_sort.begin(), top_sort.end());
    for (auto j: top_sort) {
        for (auto el: rev[j]) {
            dp3[el.to] += (dp3[j] ^ el.weight);
        }
    }
    std::reverse(top_sort.begin(), top_sort.end());
    for (auto j: top_sort) {
        for (auto el: gr[j]) {
            if (por[el.to] > por[j]) {

            }
            else{
                if (dp2[j].check(dp3[j])){
                    cout << -1 << "\n";
                    return;
                }
            }
        }
    }
    ll my_ans = 0;
    ll step = 1;
    for (int i = 0; i < 31; i++) {
        my_ans += step * (dp2[b].f[i][1] % 2);
        step *= 2;
    }
    for (int i = 0; i < 2; i++){
        for (auto j: top_sort) {
            for (auto el: gr[j]) {
                dp2[el.to] += (dp2[j] ^ el.weight);
            }
        }
    }
    ll my_ans2 = 0;
    ll step2 = 1;
    for (int i = 0; i < 31; i++) {
        my_ans2 += step2 * (dp2[b].f[i][1] % 2);
        step2 *= 2;
    }
    if (my_ans != my_ans2){
        cout << "-1" << "\n";
        return;
    }
    cout << my_ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}