#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

vector<vector<pair<ll, ll>>> graph;

ll dfs(ll from, ll target, ll p = -1) {
    if (from == target) {
        return 0;
    }

    for (const auto &to: graph[from]) {
        if (to.first == p) {
            continue;
        }

        ll sub = dfs(to.first, target, from);
        if (sub != -1) {
            return sub ^ to.second;
        }
    }

    return -1;
}

void resolve() {
    ll n, m;
    cin >> n >> m;
    ll xr = 0;
    graph.resize(n);
    for (ll i = 0; i < m; ++i) {
        ll v, u, w;
        cin >> v >> u >> w;
        xr ^= w;
        --v;
        --u;
        graph[v].emplace_back(u, w);
    }

    ll start, finish;
    cin >> start >> finish;
    --start;
    --finish;
    if (xr == 0) {
        cout << dfs(start, finish) << '\n';
    } else {
        cout << "-1\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll testN;
    cin >> testN;
    while (testN--) {
        resolve();
    }

    return 0;
}
