#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <map>
#include <math.h>
#include <stack>
#define int long long

using namespace std;

void dfs(int x, vector<vector<pair<int, int>>> &a, vector<int> &st, vector<bool> &used, vector<bool> &good) {
    used[x] = 1;
    st.push_back(x);
    for (pair<int, int> i : a[x]) {
        int y = i.first;
        if (good[y]) {
            for (int j = st.size() - 1; j >= 0; j--) {
                if (good[st[j]]) break;
                good[st[j]] = 1;
            }
        }
        if (!used[y]) {
            dfs(y, a, st, used, good);
        }
    }
    st.pop_back();
}

bool dfs2(int x, vector<vector<pair<int, int>>> &a, vector<int> &dist, vector<bool> &used, vector<bool> &good, vector<bool> &st, int e, int s) {
    used[x] = 1;
    st[x] = 1;
    for (int i = 0; i < a[x].size(); i++) {
        int to = a[x][i].first, w = a[x][i].second;
        if (!good[to]) {
            continue;
        }
        if (st[a[x][i].first]) {
            if (dist[to] == (dist[x] ^ w) && to == s - 1 && s == e) {
                a[x][i].first = a.size();
            } else {
                cout << x << " " << to << endl;
                return true;
            }
        }
        if (!used[to]) {
            dist[to] = dist[x] ^ w;
            if (dfs2(to, a, dist, used, good, st, e, s)) {
                return true;
            }
        }
    }
    st[x] = 0;
    return false;
}

void dfs3(int x, vector<vector<pair<int, int>>> &a, vector<int> &dist, int XOR, vector<bool> &good) {
    dist[x] ^= XOR;
    for (pair<int, int> i : a[x]) {
        if (good[i.first]) {
            XOR ^= i.second;
            dfs3(i.first, a, dist, XOR, good);
            XOR ^= i.second;
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> a(n);
    for (int i = 0 ; i < m; i++) {
        int x, y, w;
        cin >> x >> y >> w;
        a[x - 1].push_back({y - 1, w});
    }
    int s, e;
    cin >> s >> e;
    vector<bool> good(n + 1, 0), used(n, 0), uu(n, 0), susu(n, 0);
    good[e - 1] = 1;
    vector<int> dist(n, 0), st, dd(n, 0);
    dfs(s - 1, a, st, used, good);
    if (dfs2(s - 1, a, dd, uu, good, susu, s, e)) {
        cout << "-1\n";
        return;
    } else {
        if (n <= 1000) {
            dfs3(s - 1, a, dist, 0, good);
        } else {
            for (int i = 0; i < n; i++) {
                if (good[i]) {
                    for (pair<int, int> j: a[i]) {
                        dist[j.first] ^= dist[i] ^ j.second;
                    }
                }
            }
        }
        cout << dist[e - 1] << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
}
