#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;

#define int long long

void solve() {
	int n, m; cin >> n >> m;
	vector <vector <pair <int, int>>> g(n);
	vector <vector <pair <int, int>>> rg(n);
	vector <tuple <int, int, int>> edge(m);
	vector <bool> bad(n, false);
	for (int i = 0; i < m; ++i) {
		int u, v, w; cin >> u >> v >> w;
		--u; --v;
		if (u == v) bad[u] = true;

		g[u].push_back({ v, w });
		rg[v].push_back({ u, w });
		edge[i] = { u, v, w };
	}
	int start, finish; cin >> start >> finish; --start; --finish;

	
	vector <int> cnt(n, 0);
	vector <int> col(n, -1);
	vector <int> order;
	{
		vector <bool> used(n, false);
		function <void(int)> topsort = [&](int v) {
			used[v] = true;
			for (auto& [u, w] : g[v]) {
				if (!used[u]) topsort(u);
			}
			order.push_back(v);
		};
		for (int i = 0; i < n; ++i) {
			if (!used[i]) {
				topsort(i);
			}
		}
		reverse(all(order));


		int cur = 0;
		function <void(int)> dfs = [&](int v) {
			col[v] = cur;
			for (auto [u, w] : rg[v]) {
				if (col[u] == -1) dfs(u);
			}
		};
		for (auto i : order) {
			if (col[i] == -1) {
				dfs(i);
				++cur;
			}
		}
		for (auto x : col) {
			++cnt[x];
		}
	}
	
	for (int i = 0; i < n; ++i) {
		bad[i] = (bad[i] || cnt[col[i]] > 1);
	}

	for (int cb = 0; cb < 30; ++cb) {
		function <void(int, vector <bool>&, const vector <vector <pair <int, int>>>&)> dfs = [&](int v, vector <bool>& used, const vector <vector <pair <int, int>>>& cg) {
			used[v] = true;
			if (v < n) {
				for (auto [u, w] : cg[v]) {
					if (w >> cb & 1) u += n;
					if (!used[u]) dfs(u, used, cg);
				}
			}
			else {
				for (auto [u, w] : cg[v - n]) {
					u += n;
					if (w >> cb & 1) u -= n;
					if (!used[u]) dfs(u, used, cg);
				}
			}
		};

		vector <bool> used1(2 * n, false), used2(2 * n, false);
		dfs(start, used1, g);
		dfs(finish, used2, rg);

		for (int i = 0; i < n; ++i) {
			if ((used1[i] && used2[i + n] || used1[i + n] && used2[i]) && bad[i]) {
				cout << -1;
				return;
			}
		}
	}

	vector <vector <pair <int, int>>> compg(n);
	vector <vector <pair <int, int>>> rcompg(n);
	vector <bool> badcomp(n, false);
	vector <vector <int>> comp(n);
	for (int i = 0; i < n; ++i) {
		for (auto& [u, w] : g[i]) {
			if (col[u] != col[i]) {
				compg[col[i]].push_back({ col[u], w });
				rcompg[col[u]].push_back({ col[i], w });
			}
		}
		comp[col[i]].push_back(i);
		if (bad[i]) badcomp[col[i]] = true;
	}

	vector <bool> used(n, false);
	order.clear();
	function <void(int)> topsort = [&](int v) {
		used[v] = true;
		for (auto& [u, w] : compg[v]) {
			if (!used[u]) topsort(u);
		}
		order.push_back(v);
	};
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			topsort(i);
		}
	}
	reverse(all(order));

	vector <int> dp1(n, 0), dp2(n, 0); dp1[col[start]] = 1; dp2[col[finish]] = 1;
	vector <bool> rdp1(n, false), rdp2(n, false); rdp1[col[start]] = true; rdp2[col[finish]] = true;
	for (auto v : order) {
		if (!rdp1[v]) continue;
		if (badcomp[v]) {
			dp1[v] = -1;
		}
		for (auto [u, w] : compg[v]) {
			if (dp1[v] == -1) {
				dp1[u] = -1;
			}
			else {
				dp1[u] ^= dp1[v];
			}
			rdp1[u] = true;
		}
	}

	compg = rcompg;
	used.assign(n, false);
	order.clear();
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			topsort(i);
		}
	}
	reverse(all(order));
	for (auto v : order) {
		if (!rdp2[v]) continue;
		if (badcomp[v]) {
			dp2[v] = -1;
		}
		for (auto [u, w] : compg[v]) {
			if (dp2[v] == -1) {
				dp2[u] = -1;
			}
			else {
				dp2[u] ^= dp2[v];
			}
			rdp2[u] = true;
		}
	}

	int ans = 0;
	for (auto [u, v, w] : edge) {
		if (dp1[col[u]] == 1 && dp2[col[v]] == 1) {
			ans ^= w;
		}
	}

	cout << ans;
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}