#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) <<": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
int bin_pow_make(int a, int n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        int t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    int x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b) {
    return (a * b) % mod;
}
struct segtree {
    vector<int> tree;
    int size = 1;
    void init(int n) {
        while (size < n) size *= 2;
        tree = vector<int>(2 * size - 1, 0);
    }
    void upd(int i, int a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = a;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            upd(i, a, 2 * x + 1, lx, m);
        }
        else {
            upd(i, a, 2 * x + 2, m, rx);
        }
        tree[x] = max(tree[2 * x + 1], tree[2 * x + 2]);
    }
    int get(int l, int r, int x, int lx, int rx) {
        if (rx <= l || lx >= r) {
            return -INF;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        int mx1 = get(l, r, 2 * x + 1, lx, m);
        int mx2 = get(l, r, 2 * x + 2, m, rx);
        return max(mx1, mx2);
    }
};
struct node {
    int u, w;
};
vector<int> calc, good, cnt;
vector<vector<node> > gr;
void dfs_make_good(int u,int fin) {
    for (auto to : gr[u]) {
        if (to.u > fin) continue;
        dfs_make_good(to.u, fin);
    }
    if (u == fin) good[u] = 1;
    for (auto c : gr[u]) {
        int to = c.u;
        good[u] = max(good[to], good[u]);
    }
}
void dfs(int u) {
    for (auto to : gr[u]) {
        if (!good[to.u]) continue;
        dfs(to.u);
    }
    for (auto c : gr[u]) {
        int to = c.u, w = c.w;
        if (!good[to]) continue;
        cnt[u] += cnt[to];
        calc[u] = calc[u] ^ calc[to];
        if (cnt[to] % 2 == 1) calc[u] = calc[u] ^ w;
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    calc = vector<int>(n, 0);
    good = vector<int>(n, 0);
    cnt = vector<int>(n, 0);
    gr = vector<vector<node> >(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        gr[u].pb({ v,w });
    }
    int a, b;
    cin >> a >> b;
    a--; b--;
    if (a > b) swap(a, b);
    dfs_make_good(a,b);
    cnt[b] = 1;
    dfs(a);
    cout << calc[a] << '\n';
    
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}
/*
1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
*/