#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 5;
const int MAXLOG = 20;

struct Edge {
    int from, to, w;
};

int solve1(int n, vector<Edge> e, int start, int finish) {
    int m = (int)e.size();
    int x = 0;
    for (int i = 0; i < m; ++i) {
        x ^= e[i].w;
    }
    for (int i = 0; i < m; ++i) e.push_back(e[i]);
    int ans = 0;
    for (int i = start;; ++i) {
        if (i % n == finish) break;
        ans ^= e[i].w;
    }
    if (x != 0 || ans != 0) return -1;
    else return ans;
}

int solveTopsort(int n, vector<Edge> e, int start, int finish) {
    vector<vector<Edge>> g(n);
    for (auto [from, to, w] : e) {
        g[from].push_back({from, to, w});
    }
    vector<int> cnt(n), dp(n);
    if (start > finish) return 0;
    cnt[start] = 1;
    dp[start] = 0;
    for (int i = start; i < finish; ++i) {
        for (auto [from, to, w] : g[i]) {
            cnt[to] += cnt[from];
            cnt[to] %= 2;
            dp[to] ^= dp[from];
            if (cnt[from] % 2 == 1) dp[to] ^= w;
        }
    }
    return dp[finish];
}

void solve() {
    int n, m; cin >> n >> m;
    vector<Edge> e;
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--;
        e.push_back({u, v, w});
    }
    int a, b; cin >> a >> b; a--; b--;
    if (e.back().from == n - 1 && e.back().to == 0 && n == m) {
        cout << solve1(n, e, a, b) << '\n';
    } else {
        cout << solveTopsort(n, e, a, b) << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}
