﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(2e9);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


struct st {
	array<ll, 31> x;
	ll size = 0;

	st() {
		x.fill(0);
	}

	st(const ll val) :size(1) {
		x.fill(0);
		for (ll i = 0; i < x.size(); ++i)
			if ((val >> i) & 1)
				x[i] = 1;
	}


	ll operator()() const {
		ll res = 0;
		for (ll i = 0; i < x.size(); ++i)
			res += x[i] * (1ll << i);
		return res;
	}


	friend st operator+(st a, const st& b) {
		a.size += b.size;
		for (ll i = 0; i < a.x.size(); ++i)
			a.x[i] += b.x[i];
		return a;
	}


	friend st operator^(st a, const ll val) {
		for (ll i = 0; i < a.x.size(); ++i)
			if ((val >> i) & 1)
				a.x[i] = a.size - a.x[i];
		return a;
	}
};


vector<vector<pair<ll, ll>>> g, f;
vector<ll> used, cnt1, cnt2, dp;
ll n, m;
ll a, b;


const bool dfsDist(const ll v) {
	if (v == b)
		return true;
	used[v] = 100;
	for (auto& [u, w] : g[v]) {
		if (used[u] != 100 && dfsDist(u))
			return true;
	}
	return false;
}


void solve(istream& cin, ostream& cout) {
	g.clear();
	f.clear();
	used.clear();
	cnt1.clear();
	cnt2.clear();
	dp.clear();
	cin >> n >> m;
	g.resize(n);
	f.resize(n);

	for (ll i = 0; i < m; ++i) {
		ll a, b, w;
		cin >> a >> b >> w;
		--a, --b;
		g[a].emplace_back(b, w);
		f[b].emplace_back(a, w);
	}
	cin >> a >> b;
	--a, --b;


	used.resize(n);
	cnt1.resize(n, 0);
	cnt2.resize(n, 0);
	dp.resize(n);
	queue<ll> q;
	q.push(a);
	cnt1[a] = 1;

	while (!q.empty()) {
		ll v = q.front();
		q.pop();

		for (auto& [u, w] : g[v]) {
			cnt1[u] ^= cnt1[v];
			if (++used[u] == f[u].size())
				q.push(u);
		}
	}

	fill(used.begin(), used.end(), 0);
	q.push(b);
	cnt2[b] = 1;

	while (!q.empty()) {
		ll v = q.front();
		q.pop();

		for (auto& [u, w] : f[v]) {
			cnt2[u] ^= cnt2[v];
			if (++used[u] == f[u].size())
				q.push(u);
		}
	}

	fill(used.begin(), used.end(), 0);
	for (ll i = 0; i < n; ++i) {
		if (cnt2[i] == 0) {
			used[i] = f[i].size();
			q.push(i);
		}
	}
	q.push(a);

	while (!q.empty()) {
		ll v = q.front();
		q.pop();

		dp[v] *= cnt2[v];
		for (auto& [u, w] : g[v]) {
			dp[u] ^= (dp[v] ^ (w * cnt1[v]));
			if (++used[u] == f[u].size())
				q.push(u);
		}
	}


	if (dfsDist(a)) {
		cout << dp[b] << '\n';
	} else {
		cout << "0\n";
	}
}
