﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = long long;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(2e9);
constexpr ll MOD = static_cast<ll>(1e9 + 7);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	cin >> _;
	while (_--)
		solve(cin, cout);
}


struct st {
	array<ll, 31> x;
	ll size = 0;

	st() {
		x.fill(0);
	}

	st(const ll val) :size(1) {
		x.fill(0);
		for (ll i = 0; i < x.size(); ++i)
			if ((val >> i) & 1)
				x[i] = 1;
	}


	ll operator()() const {
		ll res = 0;
		for (ll i = 0; i < x.size(); ++i)
			res += x[i] * (1ll << i);
		return res;
	}


	friend st operator+(st a, const st& b) {
		a.size += b.size;
		for (ll i = 0; i < a.x.size(); ++i)
			a.x[i] += b.x[i];
		return a;
	}


	friend st operator^(st a, const ll val) {
		for (ll i = 0; i < a.x.size(); ++i)
			if ((val >> i) & 1)
				a.x[i] = a.size - a.x[i];
		return a;
	}
};


vector<vector<pair<ll, ll>>> g, f;
ll n, m;
ll a, b;
ll res = 0;


const bool dfs(const ll x, const ll v) {
	if (v == b) {
		if (x != 0) {
			res = -1;
			return true;
		}
		return false;
	}

	for (auto& [u, w] : g[v]) {
		if (dfs(x ^ w, u))
			return true;
	}
	return false;
}

const bool dfs1(const ll x, const ll v) {
	if (v == b) {
		if (x != 0) {
			res = -1;
			return true;
		}
		return false;
	}

	for (auto& [u, w] : f[v]) {
		if (dfs(x ^ w, u))
			return true;
	}
	return false;
}



void solve(istream& cin, ostream& cout) {
	g.clear();
	f.clear();
	cin >> n >> m;
	g.resize(n);
	f.resize(n);
	res = 0;

	for (ll i = 0; i < m; ++i) {
		ll a, b, w;
		cin >> a >> b >> w;
		--a, --b;
		g[a].emplace_back(b, w);
		f[b].emplace_back(a, w);
	}
	cin >> a >> b;
	--a, --b;

	dfs(0, a);
	dfs1(0, a);

	cout << res << '\n';
}