#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2")
const int maxn = 1 << 18;
const int inf = 1e9;
const int mod = 1e9 + 7;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

int f[maxn];

int get(int i) {
    int ans = 0;
    while (i >= 0) {
        ans = max(ans, f[i]);
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

void upd(int i, int x) {
    while (i < maxn) {
        f[i] = max(f[i], x);
        i = i | (i + 1);
    }
}

vector<int> ord;
int N;
int dS[maxn * 2];
int dT[maxn * 2];
void bfss(int v, vector<int> *g) {
    fill(dS, dS + N, inf);
    deque<int> q{v};
    dS[v] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int u : g[v]) {
            if (dS[u] > dS[v] + 1) {
                dS[u] = dS[v] + 1;
                q.push_back(u);
            }
        }
    }
}

void bfst(int v, vector<int> *g) {
    fill(dT, dT + N, inf);
    deque<int> q{v};
    dT[v] = 0;
    while (!q.empty()) {
        int v = q.front();
        q.pop_front();
        for (int u : g[v]) {
            if (dT[u] > dT[v] + 1) {
                dT[u] = dT[v] + 1;
                q.push_back(u);
            }
        }
    }
}

vector<pair<int, int>> g[maxn];
vector<pair<int, int>> rg[maxn];
vector<int> gpp[maxn * 2];
vector<int> rgpp[maxn * 2];

void dfs(int v, vector<int> &dp) {
    dp[v] = 0;
    for (auto [u, w] : g[v]) {
        if (dp[u] == -1) {
            dfs(u,  dp);
        }
    }
    ord.push_back(v);
}

void dfs(int v, vector<bool> &used) {
    used[v] = 1;
    for (int u : gpp[v]) {
        if (!used[u]) {
            dfs(u, used);
        }
    }
    ord.push_back(v);
}

void dfs2(int v, vector<int> &used, int color) {
    used[v] = color;
    for (int u : rgpp[v]) {
        if (!used[u]) {
            dfs2(u, used,  color);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    N = n * 2;
    for (int i = 0; i < n; ++i) {
        g[i].clear();
        rg[i].clear();
    }
    int mxw = 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        g[u].push_back({ v, w });
        rg[v].push_back({ u, w });
        mxw = max(mxw, w);
    }
    int s, t;
    cin >> s >> t;
    --s; --t;
    int ans = 0;
    vector<int> flex(n, -1);
    dfs(s, flex);
    reverse(ord.begin(), ord.end());
    vector<int> ordp = ord;
    for (int bit = 0; bit < 30; ++bit) {
        for (int i = 0; i < n * 2; ++i) {
            gpp[i].clear();
            rgpp[i].clear();
        }
        vector<bool> even(n, false);
        vector<bool> odd(n, false);
        for (int j = 0; j < n; ++j) {
            for (auto [u, w] : g[j]) {
                if (w & (1 << bit)) {
                    if (u == j) odd[j] = true;
                    gpp[j].push_back(u + n);
                    gpp[j + n].push_back(u);
                    rgpp[u + n].push_back(j);
                    rgpp[u].push_back(j + n);
                } else {
                    if (u == j) even[j] = true;
                    gpp[j].push_back(u);
                    gpp[j + n].push_back(u + n);
                    rgpp[u].push_back(j);
                    rgpp[u + n].push_back(j + n);
                }
            }
        }
        vector<bool> used(n * 2, false);
        ord.clear();
        for (int i = 0; i < n * 2; ++i) {
            if (!used[i]) {
                dfs(i, used);
            }
        }
        reverse(ord.begin(), ord.end());
        int color = 1;
        vector<int> comp(n * 2, 0);
        for (int i : ord) {
            if (!comp[i]) {
                dfs2(i, comp, color++);
            }
        }
        vector<int> sz(color, 0);
        for (int i = 0; i < n * 2; ++i) {
            ++sz[comp[i]];
        }
        for (int i = 0; i < n; ++i) {
            if (comp[i] == comp[i + n]) {
                odd[i] = true;
            }
            if (sz[comp[i]] > 1) {
                even[i] = true;
            }
        }
        bfss(s, gpp);
        bfst(t, rgpp);
        ord.clear();
        vector<int> dp = flex;
        vector<int> cnt(n, 0);
        cnt[s] = 1;
        for (int i : ordp) {
            if (dp[i] == -1) continue;
            if (odd[i] && (dT[i] != inf || dT[i + n] != inf)) {
                cout << -1 << '\n';
                return;
            }
            if (even[i]) {
                if (dS[i + n] != inf & dT[i] != inf) {
                    cout << -1 << '\n';
                    return;
                }
                if (dS[i] != inf & dT[i + n] != inf) {
                    cout << -1 << '\n';
                    return;
                }
                dp[i] = -1;
                continue;
            }
            for (auto [u, w] : rg[i]) {
                if ((1 << bit) & w) w = 1;
                else w = 0;
                if (dp[u] != -1) {
                    cnt[i] ^= cnt[u];
                    dp[i] ^= (dp[u] ^ (w * cnt[u]));
                }
            }
        }
        dp[t] = max(dp[t], 0);
        ans ^= ((1 << bit) * dp[t]);
    }
    cout << ans << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
