#include <algorithm>
#include <cassert>
#include <iostream>
#include <vector>

using namespace std;

vector<vector<pair<int, int>>> gr;

namespace Solvendag {
    void solve(int n, int m, int a, int b) {
        int xr = 0;
        for (int i = 0; i < n; i++) {
            assert(gr[i].size() == 1);
            for (auto [to, w] : gr[i]) {
                xr ^= w;
            }
        }
        if (xr != 0) {
            cout << "-1\n";
            return;
        }
        while (a != b) {
            xr ^= gr[a][0].second;
            a = gr[a][0].first;
        }

        if (xr != 0) {
            cout << "-1\n";
        } else {
            cout << xr << "\n";
        }
    }
} // namespace Solvendag

vector<int> xr;
vector<int> cnt;
vector<bool> used;

void dfs(int v) {
    used[v] = true;
    for (auto [to, w] : gr[v]) {
        if (!used[to]) {
            dfs(to);
        }
        cnt[v] += cnt[to];
        xr[v] ^= xr[to];
        if (cnt[to] % 2 != 0) {
            xr[v] ^= w;
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    gr.assign(n, vector<pair<int, int>>(0));
    bool dag = true;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        gr[a].emplace_back(b, c);
        if (a >= b) {
            dag = false;
        }
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;

    if (!dag) {
        Solvendag::solve(n, m, a, b);
        return;
    }
    xr.assign(n, 0);
    cnt.assign(n, 0);
    used.assign(n, false);
    cnt[b] = 1;
    used[b] = true;

    dfs(a);

    cout << xr[a] << "\n";
}

int main() {
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
    return 0;
}
