#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

struct Solution {
    Solution() = default;

    int n, m;
    int a, b;
    vector<vector<int>> g;
    vector<int> edge;
    vector<pii> edges;
    vector<int> w;

    void operator()() {
        cin >> n >> m;
        g.resize(n);
        edge.resize(m);
        edges.resize(m);
        w.resize(m);
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u >> w[i];
            --v; --u;
            g[v].emplace_back(i);
            edge[i] = u;
            edges[i] = {v, u};
        }
        cin >> a >> b;
        --a; --b;

        bool gr_1 = (n == m);
        for (int i = 0; i < m; ++i) {
            if (edge[i] != (i + 1) % n) {
                gr_1 = false;
            }
        }
        if (gr_1) {
            solve_gr_1();
            return;
        }

        bool gr_23 = true;
        for (int v = 0; v < n; ++v) {
            for (auto i : g[v]) {
                if (v > edge[i]) {
                    gr_23 = false;
                }
            }
        }
        if (gr_23) {
            solve_gr_23();
            return;
        }
    }

    void solve_gr_1() {
        int res = 0;
        for (int i = 0; i < m; ++i) {
            res ^= w[i];
        }
        int kek = 0;
        int v = a;
        while (v != b) {
            for (auto i : g[v]) {
                kek ^= w[i];
                v = edge[i];
            }
        }
        if ((kek ^ res) == 0 && kek == 0) {
            cout << 0 << en;
        } else {
            cout << -1 << en;
        }
    }

    void solve_gr_23() {
        if (b < a) {
            cout << 0 << en;
            return;
        }
        if (a == b) {
            for (auto i : g[a]) {
                if (edge[i] == a && w[i] > 0) {
                    cout << -1 << en;
                    return;
                }
            }
            cout << 0 << en;
            return;
        }
        vector<int> redge(m);
        vector<vector<int>> rg(n);
        for (int v = 0; v < n; ++v) {
            for (auto i : g[v]) {
                rg[edge[i]].emplace_back(i);
                redge[i] = v;
            }
        }
        vector<int> dp1(n), dp2(n);
        dp1[b] = 1;
        for (int v = b - 1; v >= a; --v) {
            for (auto i : g[v]) {
                dp1[v] += dp1[edge[i]];
            }
        }

        dp2[a] = 1;
        for (int v = a + 1; v <= b; ++v) {
            for (auto i : rg[v]) {
                dp2[v] += dp2[redge[i]];
            }
        }
        int res = 0;
        for (int i = 0; i < m; ++i) {
            int v = edges[i].first;
            int u = edges[i].second;
            ll kek = dp1[u] * dp2[v];
            if (kek & 1) {
                res ^= w[i];
            }
        }
        cout << res << en;
    }
};

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        Solution()();
    }
    return 0;
}
