﻿// C.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <iostream>
#include <bits/stdc++.h>

using namespace std;
using ll = long long;

struct group_solve
{
    ll n, m;
    vector <vector<pair<size_t, size_t>>> g;
    ll group_run(int)
    {
        ll a, b;
        cin >> a >> b;
        a--; b--;
        int xor1 = 0, xor2 = 0;
        for (auto& i : g)
        {
            xor2 ^= i[0].second;
        }
        while (a != b)
            xor1 ^= g[a][0].second, a = g[a][0].first;
        if (xor2 == 0)
            return xor1;
        return -1;
    }
};

struct solver : public group_solve
{
    vector <bool> tmp, used, twice;
    vector <size_t> ans, topsort;
    vector <int> buff;
    ll a, b;

    // fill tmp
    void dfs1(size_t u)
    {
        used[u] = 1;
        for (auto& v : g[u])
        {
            if (!used[v.first])
                dfs1(v.first);
            if (tmp[v.first])
                tmp[u] = 1;
        }
    }

    // cycle finder
    int dfs2(size_t u)
    {
        int ans = 0;
        buff[u] = 1;
        for (auto& i : g[u])
        {
            auto& v = i.first;
            if (tmp[v] && (!buff[v]))
                ans |= dfs2(v);
            if (buff[v] == 1)
                return 1;
        }
        buff[u] = 2;
        return ans;
    }

    // topsort
    void dfs3(size_t u)
    {
        used[u] = 1;
        for (auto& i : g[u])
        {
            auto& v = i.first;
            if (!used[v] && tmp[v])
                dfs3(v);
        }
        topsort.push_back(u);
    }

    // answer fill
    void dfs4(size_t u)
    {
        for (auto& i : g[u])
        {
            size_t v = i.first;
            if (!tmp[v])
                continue;
            ans[v] ^= ans[u];
            if (twice[u])
            {
                ans[v] ^= i.second;
                twice[v] = !twice[v];
            }
        }
    }

    ll run()
    {
        cin >> n >> m;
        g.resize(n);
        ans.resize(n, 0);
        tmp.assign(n, 0);
        used.assign(n, 0);
        for (size_t i = 0; i < m; i++)
        {
            ll u, v, w;
            cin >> u >> v >> w;
            u--; v--;
            g[u].emplace_back(v, w);
        }
        if (n == m)
        {
            bool grun = 1;
            for (size_t i = 0; i < n; i++)
            {
                if (g[i].size() != 1)
                    grun = false;
            }
            if (grun)
                return group_run(1);
        }
        cin >> a >> b;
        a--; b--;
        tmp[b] = true;
        used[b] = 1;
        dfs1(a);
        if (!tmp[a])
            return 0;
        buff.assign(n, 0);
        if (dfs2(a))
            return -1;
        used.assign(n, 0);
        dfs3(a);
        twice.assign(n, 0);
        twice[a] = 1;
        reverse(topsort.begin(), topsort.end());
        for (auto& i : topsort)
        {
            dfs4(i);
        }
        return ans[b];
    }
};

void solve()
{
    solver x;
    cout << x.run() << '\n';
}

int main()
{
    ll t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
