#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;

int n, m;
vector<pair<int, int>> g[N];
vector<int> gr[N];
int s, t;
int dpsum[N], dpcnt[N];
bool used[N];
vector<int> ord;
int comp[N];
int cntcomps;
int szcomp[N];
int bad[N];
vector<int> kek[N][2];

void dfs(int v) {
	used[v] = 1;
	for (auto [u, w] : g[v]) {
		if (!used[u]) {
			dfs(u);
		}
	}
	ord.push_back(v);
}

void zhfs(int v) {
	used[v] = 1;
	comp[v] = cntcomps;
	for (int u : gr[v]) {
		if (!used[u]) {
			zhfs(u);
		}
	}
}

void dfs1(int v) {
	used[v] = 1;
	for (auto [u, w] : g[v]) {
		if (!used[u] && !bad[u]) {
			dfs1(u);
		}
	}
	ord.push_back(v);
}

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
		gr[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int v, u, w;
		cin >> v >> u >> w;
		--v, --u;
		g[v].push_back({u, w});
		gr[u].push_back(v);
	}
	ord.clear();
	for (int i = 0; i < n; ++i) {
		used[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i);
		}
	}
	reverse(ord.begin(), ord.end());
	for (int i = 0; i < n; ++i) {
		used[i] = 0;
	}
	cntcomps = 0;
	for (int v : ord) {
		if (!used[v]) {
			zhfs(v);
			++cntcomps;
		}
	}
	for (int i = 0; i < cntcomps; ++i) {
		szcomp[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		++szcomp[comp[i]];
	}
	for (int i = 0; i < n; ++i) {
		bad[i] = szcomp[comp[i]] >= 2;
		for (auto [u, w] : g[i]) {
			if (u == i) {
				bad[i] = 1;
			}
		}
	}
	cin >> s >> t;
	--s, --t;
	for (int i = 0; i < n; ++i) {
		for (int f = 0; f < 2; ++f) {
			kek[i][f].clear();
		}
	}
	kek[s][bad[s]].push_back(0);
	queue<pair<int, int>> q;
	q.push({s, bad[s]});
	while (!q.empty()) {
		auto [v, f] = q.front();
		q.pop();
		for (auto [u, w] : g[v]) {
			int f1 = f | bad[u];
			if (kek[u][f1].size() == 2) {
				continue;
			}
			int oldsz = kek[u][f1].size();
			for (int x : kek[v][f]) {
				int cur = x ^ w;
				if (kek[u][f1].size() < 2 && (kek[u][f1].empty() || kek[u][f1][0] != cur)) {
					kek[u][f1].push_back(cur);
				}
			}
			int newsz = kek[u][f1].size();
			if (newsz > oldsz) {
				q.push({u, f1});
			}
		}
	}
	for (int x : kek[t][1]) {
		if (x != 0) {
			cout << "-1\n";
			return;
		}
	}
	ord.clear();
	for (int i = 0; i < n; ++i) {
		used[i] = 0;
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i] && !bad[i]) {
			dfs1(i);
		}
	}
	reverse(ord.begin(), ord.end());
	for (int i = 0; i < n; ++i) {
		dpsum[i] = 0;
		dpcnt[i] = 0;
	}
	if (!bad[s]) {
		dpsum[s] = 0;
		dpcnt[s] = 1;
	}
	for (int v : ord) {
		for (auto [u, w] : g[v]) {
			dpsum[u] ^= dpsum[v];
			dpcnt[u] ^= dpcnt[v];
			if (dpcnt[v]) dpsum[u] ^= w;
		}
	}
	cout << dpsum[t] << endl;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t; 
	while (t--) {
		solve();
	}
	return 0;
}