#include <bits/stdc++.h>

using namespace std;

using ll = long long;

struct edge {
    int u, v, w;
};

void cnt1(int cur, int f, vector<vector<int>>& g, vector<int>& a) {
    if (a[cur] != -1) {
        return;
    }
    a[cur] = 0;
    for (auto v : g[cur]) {
        if (a[v] == -1) {
            cnt1(v, f, g, a);
        }
        a[cur] += a[v];
        a[cur] %= 2;
    }
}

void cnt2(int cur, int f, vector<vector<pair<int, int>>>& g, vector<int>& a) {
    if (a[cur] != -1) {
        return;
    }
    a[cur] = 0;
    for (auto& [v, w] : g[cur]) {
        if (a[v] == -1) {
            cnt2(v, f, g, a);
        }
        a[cur] += a[v];
        a[cur] %= 2;
    }
}


void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    vector<edge> edges(m);
    vector<vector<int>> rg(n);
    int xor_sum = 0;
    bool f = true;
    for (int i = 0, u, v, w; i < m; ++i) {
        cin >> u >> v >> w;
        xor_sum ^= w;
        --u, --v;
        if (!((i < m - 1 && u == v - 1) || (i == m - 1 && u == n - 1 && v == 0))) {
            f = false;
        }
        g[u].emplace_back(v, w);
        rg[v].push_back(u);
        edges[i] = {u, v, w};
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (f) {
        if (xor_sum != 0) {
            cout << -1 << '\n';
            return;
        }
        int path = 0;
        if (a < b) {
            while (a != b) {
                path ^= g[a][0].second;
                ++a;
            }
        } else {
            while (b != a) {
                path ^= g[b][0].second;
                ++b;
            }
        }
        if (path != 0) {
            cout << -1 << '\n';
            return;
        }
        cout << 0 << '\n';
    } else {
        if (a >= b) {
            cout << 0 << '\n';
        }
        vector<int> cnt_a(n, -1);
        vector<int> cnt_b(n, -1);
        cnt_a[a] = 1;
        cnt_b[b] = 1;
        for (int i = 0; i < n; ++i) {
            cnt1(i, a, rg, cnt_a);
            cnt2(i, b, g, cnt_b);
        }
        int ans = 0;
        for (auto [u, v, w]: edges) {
            if (cnt_a[u] * cnt_b[v] == 1) {
                ans ^= w;
            }
        }
        cout << ans << '\n';
    }
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}