#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

const int N = 2e5 + 7;

struct Edge {
	int v, w;
};

int n, m, k, A, B;

vector<Edge> edges[N], rev_edges[N];

set<int> xr[N], rev_xr[N], xr2[N];

vector<int> topsort, topsort2;

bool cyc[N], dost[N];
int vis[N];
int p[N], outd[N];

bool vis2[N], del[N];

void tp(int v) {
	vis[v] = 1;
	dost[v] = 1;
	for (auto u : edges[v]) {
		if (!vis[u.v]) {
			tp(u.v);
		}
		else {
			cyc[v] = 1;
		}
	}
	topsort.push_back(v);
}

int dfs(int v) {
	vis[v] = 1;
	int cc = -1;
	for (auto u : edges[v]) {
		if (!vis[u.v]) {
			 int c = dfs(u.v);
			 if (c != -1) {
				 if(c != v)
				 cc = c;
				 cyc[v] = 1;
			 }
		}
		else {
			if (vis[u.v] == 1) {
				cyc[u.v] = 1;
				cc = u.v;
			}
		}
	}
	vis[v] = 2;
	return cc;
}

void dfs2(int v) {
	vis2[v] = 1;
	for (auto u : rev_edges[v]) {
		if (!vis2[u.v]) {
			dfs2(u.v);
		}
	}
}

void ClearVis() {
	for (int i = 1; i <= n; i++) {
		vis[i] = 0;
		vis2[i] = 0;
		del[i] = 0;
	}
}

int cnt[N], cnt2[N], ind[N];
void solve() {
	cin >> n >> m;
	for (int i = 1; i <= n; i++) {
		edges[i].clear();
		rev_edges[i].clear();
		xr[i].clear();
		rev_xr[i].clear();
		xr2[i].clear();
		cnt[i] = 0;
		cnt2[i] = 0;
		ind[i] = 0;
		del[i] = 0;
		cyc[i] = 0;
		outd[i] = 0;
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		edges[u].push_back({ v,w });
		rev_edges[v].push_back({ u,w });
		ind[v] ++;
		outd[u]++;
	}
	cin >> A >> B;
	ClearVis();
	dfs(A);
	dfs2(B);
	for (int i = 1; i <= n; i++) {
		dost[i] = vis[i] && vis2[i];
		if (!dost[i]) {
			for (auto u : edges[i]) {
				ind[u.v]--;
			}
			for (auto u : rev_edges[i]) {
				outd[u.v]--;
			}
		}
	}

	set<pair<int, int> > s;
	for (int i = 1; i <= n; i++) {
		if (dost[i]) {
			s.insert({ ind[i], i });
		}
	}
	topsort.clear();
	while (!s.empty()) {
		topsort.push_back(s.begin()->second);
		int cur = s.begin()->second;
		del[cur] = 1;
		s.erase(s.begin());
		for (auto u : edges[cur]) {
			if (dost[u.v] && !del[u.v]) {
				s.erase({ ind[u.v], u.v });
				ind[u.v]--;
				s.insert({ ind[u.v], u.v });
			}
		}
	}

	s.clear();
	for (int i = 1; i <= n; i++) {
		if (dost[i]) {
			s.insert({ outd[i], i });
		}
	}
	topsort2.clear();
	ClearVis();
	while (!s.empty()) {
		topsort2.push_back(s.begin()->second);
		int cur = s.begin()->second;
		del[cur] = 1;
		s.erase(s.begin());
		for (auto u : rev_edges[cur]) {
			if (dost[u.v] && !del[u.v]) {
				s.erase({ outd[u.v], u.v });
				outd[u.v]--;
				s.insert({ outd[u.v], u.v });
			}
		}
	}

	xr[A].insert(0);
	xr2[B].insert(0);

	for (auto cur : topsort) {
		for (auto u : edges[cur]) {
			for (auto X1 : xr[cur]) {
				if (dost[u.v] && dost[cur]) {
					xr[u.v].insert(X1 ^ u.w);
					if (xr[u.v].size() > 2) {
						xr[u.v].erase(xr[u.v].begin());
					}
				}
			}
		}
	}

	for (auto cur : topsort2) {
		for (auto u : rev_edges[cur]) {
			for (auto X1 : xr2[cur]) {
				if (dost[u.v] && dost[cur]) {
					xr2[u.v].insert(X1 ^ u.w);
					if (xr2[u.v].size() > 2) {
						xr2[u.v].erase(xr2[u.v].begin());
					}
				}
			}
		}
	}

	for (int i = 1; i <= n; i++) {
		if (dost[i] && cyc[i]) {
			for (auto X : xr[i]) {
				for (auto X2 : xr2[i]) {
					if (X != X2) {
						cout << "-1\n";
						return;
					}
				}
			}
		}
	}
	
	cnt[A] = 1;
	for (auto u : topsort) {
		for (auto v : edges[u]) {
			cnt[v.v] += cnt[u];
			cnt[v.v] %= 2;
		}
	}
	reverse(topsort.begin(), topsort.end());
	cnt2[B] = 1;
	for (auto u : topsort) {
		for (auto v : rev_edges[u]) {
			cnt2[v.v] += cnt2[u];
			cnt2[v.v] %= 2;
		}
	}

	int ANSW = 0;
	for (int i = 1; i <= n; i++) {
		for (auto e : edges[i]) {
			if ( (cnt[i] == 1 && cnt2[e.v] == 1) && dost[e.v] && dost[i]) {
				ANSW ^= e.w;
				//cout << e.w << "\n";
			}
		}
	}
	cout << ANSW << "\n";
	

}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	
}
