#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <numeric>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef set<pi> spi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef vector<bool> vb;

template<typename T> bool minravno(T& a, const T& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> bool maxravno(T& a, const T& b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename T> void print(const T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}
template<typename T> void sort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void rsort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
	reverse(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void reverse(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	reverse(a.begin() + i, a.begin() + (j + 1));
}

int a, b;
vvpi g, gc, gcr;
vvi dp, dpb;
vvi gr;
vi xr, used, cmp, gay, usedb, sz;
vi topsort;
vi ans, c;
vb usedans;
vb cycle;

void dfs(int v) {
	used[v] = 1;
	for (auto [u, w] :g[v]) {
		if (!used[u]) {
			xr[u] = (xr[v] ^ w);
			dfs(u);
		}
		else if (used[u] == 1) {
			if (xr[u] != (xr[v] ^ w))
				gay.push_back(v);
		}
	}
	used[v] = 2;
	topsort.push_back(v);
}

void dfsb(int v) {
	usedb[v] = 1;
	for (auto u : gr[v]) {
		if (!usedb[u])
			dfsb(u);
	}
	usedb[v] = 2;
}

void condense(int v) {
	for (auto u : gr[v]) {
		if (!cmp[u]) {
			cmp[u] = cmp[v];
			sz[cmp[v]]++;
			cycle[cmp[v]] = true;
			condense(u);
		}
		if (cmp[u] == cmp[v])
			cycle[cmp[v]] = true;
	}
}

void dfsdp(int v) {
	for (auto [u, w] :gc[v]) {
		if (dp[u][1] != -1)
			continue;
		bool flag = false;
		int j = 0;
		int i = 0;
		while (i < 2 && j < 2) {
			if (dp[v][i] == -1)
				break;
			if (dp[u][j] != -1) {
				j++;
				continue;
			}
			if (j == 1 && (dp[v][i] ^ w) == dp[u][0]) {
				i++;
				continue;
			}
			dp[u][j] = (dp[v][i] ^ w);
			flag = true;
			i++;
			j++;
		}
		if (flag)
			dfsdp(u);
	}
}

void dfsdpb(int v) {
	for (auto [u, w] : gcr[v]) {
		if (dpb[u][1] != -1)
			continue;
		bool flag = false;
		int j = 0;
		int i = 0;
		while (i < 2 && j < 2) {
			if (dpb[v][i] == -1)
				break;
			if (dpb[u][j] != -1) {
				j++;
				continue;
			}
			if (j == 1 && (dpb[v][i] ^ w) == dpb[u][0]) {
				i++;
				continue;
			}
			dpb[u][j] = (dpb[v][i] ^ w);
			flag = true;
			i++;
			j++;
		}
		if (flag)
			dfsdpb(u);
	}
}

void dfsans(int v) {
	usedans[v] = true;
	if (v == cmp[b]) {
		ans[v] = 0;
		c[v] = 1;
	}
	for (auto [u, w] : gc[v]) {
		if (!usedans[u])
			dfsans(u);
		ans[v] ^= ans[u];
		if (c[u]) {
			ans[v] ^= w;
			c[v] ^= 1;
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	g.assign(n + 1, {});
	gr.assign(n + 1, {});
	gc.assign(n + 1, {});
	gcr.assign(n + 1, {});
	xr.assign(n + 1, 0);
	sz.assign(n + 1, 0);
	used.assign(n + 1, 0);
	usedb.assign(n + 1, 0);
	cmp.assign(n + 1, 0);
	topsort.clear();
	gay.clear();
	dp.assign(n + 1, { -1, -1 });
	dpb.assign(n + 1, { -1, -1 });
	ans.assign(n + 1, 0);
	c.assign(n + 1, 0);
	usedans.assign(n + 1, false);
	cycle.assign(n + 1, false);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		g[u].push_back({ v,w });
		gr[v].push_back(u);		
	}
	cin >> a >> b;
	dfs(a);
	if (!used[b]) {
		cout << "0\n";
		return;
	}
	dfsb(b);
	for (auto i : gay)
		if (usedb[i]) {
			cout << "-1\n";
			return;
		}

	reverse(topsort);
	int timer = 0;
	for (auto i : topsort) {
		if (!cmp[i]) {
			cmp[i] = ++timer;
			sz[timer] = 1;
			condense(i);
		}
	}
	for (int i = 1; i <= n; ++i) {
		if (used[i] && usedb[i]) {
			for (auto [u, w] : g[i]) {
				if (used[u] && usedb[u]) {
					if (cmp[u] != cmp[i]) {
						gc[cmp[i]].push_back({ cmp[u], w });
						gcr[cmp[u]].push_back({ cmp[i], w });
					}
				}
			}
		}
	}
	dp[a][0] = 0;
	dfsdp(a);
	dpb[b][0] = 0;
	dfsdpb(b);
	for (int i = 1; i <= timer; ++i) {
		if (cycle[i] && (dp[i][1] != -1 || dpb[i][1] != -1 || dp[i][0] != dpb[i][0])) {
			cout << "-1\n";
			return;
		}
	}
	dfsans(a);
	cout << ans[a] << '\n';
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t;
	cin >> t;
	while (t--)
		solve();

	return 0;
}