#include "bits/stdc++.h"

using namespace std;
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
#define int long long
const int inf = 1e18;
const int mod = 1e9 + 7;
const int R = 1 << 18;
vector<vector<pair<int, int>>> g, rev;
vector<vector<pair<int, int>>> G, REV;
int n, m;
vector<int> used;
vector<int> topsort;
vector<int> c;
vector<int> good_comp;
vector<int> tick;
vector<int> p;
vector<int> cycle;

void dfs1(int v) {
    used[v] = 1;
    for (auto [u, w]: g[v])
        if (!used[u])
            dfs1(u);
    topsort.push_back(v);
}

int CLR;

void dfs2(int v) {
    c[v] = CLR;
    for (auto [u, w]: rev[v])
        if (!c[u])
            dfs2(u);

}

void dfs3(int v) {
    used[v] = 1;
    for (auto [u, w]: g[v])
        if (c[v] == c[u]) {
            cycle[c[v]] = 1;
            if (used[u]) {
                if (((p[v] ^ w) ^ p[c[v]]) != 0)
                    good_comp[c[v]] = 0;
            } else {
                p[u] = p[v] ^ w;
                dfs3(u);
            }
        }
}

void dfs4(int v, vector<vector<pair<int, int>>> &tg) {
    tick[v]++;
    used[v] = 1;
    for (auto [u, w]: tg[v])
        if (!used[u])
            dfs4(u, tg);
}

vector<pair<int, int>> dpl, dpr;


void solve() {
    cin >> n >> m;
    g.assign(n + 1, {});
    rev.assign(n + 1, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].emplace_back(v, w);
        rev[v].emplace_back(u, w);
    }
    int a, b;
    cin >> a >> b;
    used.assign(n + 1, 0);
    topsort.assign(0, 0);
    for (int i = 1; i <= n; ++i)
        if (!used[i])
            dfs1(i);
    c.assign(n + 1, 0);
    CLR = 0;
    reverse(all(topsort));
    for (auto v: topsort)
        if (!c[v]) {
            ++CLR;
            dfs2(v);
        }

    used.assign(n + 1, 0);
    good_comp.assign(CLR + 1, 1);
    p.assign(n + 1, 0);
    cycle.assign(CLR + 1, 0);
    for (int i = 1; i <= n; ++i)
        if (!used[i])
            dfs3(i);
    G.assign(CLR + 1, {});
    REV.assign(CLR + 1, {});
    for (int v = 1; v <= n; ++v)
        for (auto [u, w]: g[v])
            if (c[v] != c[u]) {
                G[c[v]].emplace_back(c[u], w);
                REV[c[u]].emplace_back(c[v], w);
            }
    if (c[a] > c[b])
        swap(a, b);
    if (c[a] == c[b]) {
        if (good_comp[c[a]])
            cout << "0\n";
        else
            cout << "-1\n";
        return;
    }
    tick.assign(n + 1, 0);
    used.assign(n + 1, 0);
    dfs4(c[a], G);
    used.assign(n + 1, 0);
    dfs4(c[b], REV);
    dpl.assign(CLR + 1, {-1, 0});
    dpr.assign(CLR + 1, {-1, 0});
    dpl[c[a]] = {1, 0};
    for (int v = c[a] + 1; v <= c[b]; ++v) {
        if (tick[v] != 2)
            continue;
        for (auto [u, w]: REV[v]) {
            if (tick[u] == 2) {
                if (dpl[u].first >= 2 || dpl[v].first >= 2) {
                    dpl[v] = {2, 0};
                    continue;
                }
                assert(dpl[u].first == 1);
                if (dpl[v].first == -1)
                    dpl[v] = {1, dpl[u].second ^ w};
                else {
                    if ((dpl[u].second ^ w) != dpl[v].second)
                        dpl[v] = {2, 0};
                    else
                        continue;
                }
            }
        }
    }
    dpr[c[b]] = {1, 0};
    for (int v = c[b] - 1; v >= c[a]; --v) {
        if (tick[v] != 2)
            continue;
        for (auto [u, w]: G[v]) {
            if (tick[u] == 2) {
                if (dpr[u].first >= 2 || dpr[v].first >= 2) {
                    dpr[v] = {2, 0};
                    continue;
                }
                assert(dpr[u].first == 1);
                if (dpr[v].first == -1)
                    dpr[v] = {1, dpr[u].second ^ w};
                else {
                    if ((dpr[u].second ^ w) != dpr[v].second)
                        dpr[v] = {2, 0};
                    else
                        continue;
                }
            }
        }
    }
    for (int v = c[a]; v <= c[b]; ++v)
        if (tick[v] == 2 && cycle[v])
            if (!good_comp[v] || dpl[v].first >= 2 || dpr[v].first >= 2 || dpl[v].second != dpr[v].second) {
                cout << "-1\n";
                return;
            }
    vector<pair<int, int>> dp(CLR + 1, {0, 0});
    dp[c[a]] = {0, 1};
    for (int v = c[a] + 1; v <= c[b]; ++v) {
        if (tick[v] != 2)
            continue;
        if (cycle[v])
            dp[v] = {0, 0};
        else {
            for (auto [u, w]: REV[v]) {
                if (tick[u] == 2) {
                    dp[v].first ^= w ^ dp[u].second ^ dp[u].first;
                    dp[v].second ^= dp[u].second;
                }
            }
        }
    }
    cout << dp[c[b]].first << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
