#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 1e18, MOD = 1e9 + 7;

struct edge
{
	long long to, w;
};

long long n;
vector<edge> g[200000], rg[200000];
vector<long long> comp;
long long A, B;
vector<edge> gc[200000], rgc[200000];
vector<bool> cyc;

void topsort(long long v, vector<bool>& used, vector<long long>& order)
{
	used[v] = true;
	for (auto& i : g[v])
	{
		if (used[i.to])
		{
			continue;
		}

		topsort(i.to, used, order);
	}
	order.push_back(v);
}

void mark_comp(long long v, long long cnt_comp, long long& cnt)
{
	comp[v] = cnt_comp;
	cnt++;
	for (auto& i : rg[v])
	{
		if (comp[i.to] != -1)
		{
			continue;
		}

		mark_comp(i.to, cnt_comp, cnt);
	}
}

vector<long long> totwo[200000], fromtwo[200000];

void calctotwoxxx(long long v, long long p)
{
	totwo[v].push_back(p);
	for (auto& i : gc[v])
	{
		if (totwo[i.to].size() >= 2 || find(totwo[i.to].begin(), totwo[i.to].end(), (p ^ i.w)) != totwo[i.to].end() || comp[v] != comp[i.to])
		{
			continue;
		}

		calctotwoxxx(i.to, p ^ i.w);
	}
}

void calcfromtwoxxx(long long v, long long p)
{
	fromtwo[v].push_back(p);
	for (auto& i : rgc[v])
	{
		if (fromtwo[i.to].size() >= 2 || find(fromtwo[i.to].begin(), fromtwo[i.to].end(), (p ^ i.w)) != fromtwo[i.to].end() || comp[v] != comp[i.to])
		{
			continue;
		}

		calcfromtwoxxx(i.to, p ^ i.w);
	}
}

void calctotwo(long long v, long long p)
{
	totwo[v].push_back(p);
	for (auto& i : gc[v])
	{
		if (totwo[i.to].size() >= 2 || find(totwo[i.to].begin(), totwo[i.to].end(), (p ^ i.w)) != totwo[i.to].end())
		{
			continue;
		}

		calctotwo(i.to, p ^ i.w);
	}
}

void calcfromtwo(long long v, long long p)
{
	fromtwo[v].push_back(p);
	for (auto& i : rgc[v])
	{
		if (fromtwo[i.to].size() >= 2 || find(fromtwo[i.to].begin(), fromtwo[i.to].end(), (p ^ i.w)) != fromtwo[i.to].end())
		{
			continue;
		}

		calcfromtwo(i.to, p ^ i.w);
	}
}

vector<long long> cntto, cntfrom;

void calc_to(long long v)
{
	if (cyc[v] || cntto[v] != -1)
	{
		return;
	}

	cntto[v] = 0;
	for (auto& i : rgc[v])
	{
		calc_to(i.to);
		cntto[v] += cntto[i.to];
		cntto[v] %= 2;
	}
}

void calc_from(long long v)
{
	if (cyc[v] || cntfrom[v] != -1)
	{
		return;
	}

	cntfrom[v] = 0;
	for (auto& i : gc[v])
	{
		calc_from(i.to);
		cntfrom[v] += cntfrom[i.to];
		cntfrom[v] %= 2;
	}
}

void canreach(long long v, vector<bool>& used)
{
	used[v] = true;
	for (auto& i : rg[v])
	{
		if (used[i.to])
		{
			continue;
		}

		canreach(i.to, used);
	}
}

void solve()
{
	long long m;
	cin >> n >> m;
	long long cntdag = 0;
	long long xrall = 0;
	for (long long i = 0; i < m; i++)
	{
		long long a, b, w;
		cin >> a >> b >> w;
		xrall ^= w;
		a--; b--;
		g[a].push_back({ b, w });
		rg[b].push_back({ a, w });
		if (a < b)
		{
			cntdag++;
		}
	}
	cin >> A >> B;
	A--; B--;

	vector<bool> used(n);
	vector<long long> order;
	topsort(A, used, order);
	reverse(order.begin(), order.end());
	if (!used[B])
	{
		cout << 0 << "\n";
		return;
	}

	comp.resize(n, -1);
	cyc.resize(n);
	long long cnt_comps = 0;
	for (auto& i : order)
	{
		long long cntcolor = 0;
		mark_comp(i, cnt_comps, cntcolor);
		if (cntcolor >= 2)
		{
			cyc[cnt_comps] = true;
		}
		cnt_comps++;
	}
	for (long long i = 0; i < n; i++)
	{
		for (auto& j : g[i])
		{
			if (comp[i] == comp[j.to])
			{
				continue;
			}

			gc[comp[i]].push_back({ comp[j.to], j.w });
			rgc[comp[j.to]].push_back({ comp[i], j.w });
		}
	}

	for (auto& i : order)
	{
		calctotwoxxx(i, 0);
	}
	used.assign(n, false);
	canreach(B, used);
	for (auto& i : order)
	{
		if (totwo[i].size() >= 2 && used[i])
		{
			cout << -1 << "\n";
			return;
		}
	}
	for (long long i = 0; i < n; i++)
	{
		totwo[i] = {};
	}

	calctotwo(comp[A], 0);
	calcfromtwo(comp[B], 0);
	for (long long i = 0; i < n; i++)
	{
		if (cyc[i])
		{
			if (!totwo[i].size() || !fromtwo[i].size())
			{
				continue;
			}
			if (totwo[i].size() >= 2 || fromtwo[i].size() >= 2)
			{
				cout << -1 << "\n";
				return;
			}
			if (totwo[i][0] ^ fromtwo[i][0])
			{
				cout << -1 << "\n";
				return;
			}
		}
	}

	cntto.resize(n, -1);
	cntfrom.resize(n, -1);
	cntto[comp[A]] = 1;
	cntfrom[comp[B]] = 1;
	for (long long i = 0; i < n; i++)
	{
		calc_to(i);
		calc_from(i);
	}
	long long ans = 0;
	for (long long i = 0; i < n; i++)
	{
		for (auto& j : gc[i])
		{
			if (cyc[i] || cyc[j.to])
			{
				continue;
			}

			long long mul = cntto[i] * cntfrom[j.to];
			ans ^= mul * j.w;
		}
	}
	
}

void reset()
{
	for (long long i = 0; i < n; i++)
	{
		g[i] = rg[i] = {};
		gc[i] = {};
		rgc[i] = {};
		totwo[i] = {};
		fromtwo[i] = {};
	}
	comp = {};
	cyc = {};
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int tst = 1;
	cin >> tst;
	while (tst--)
	{
		solve();
		reset();
	}

	return 0;
}

/*























*/
