#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

vector<bool> used;
vector<int> el;
vector<int> color;

void dfs(int v, vector<vector<pair<int, int>>> &gr) {
    used[v] = true;
    for (auto u: gr[v]) {
        if (!used[u.first]) {
            dfs(u.first, gr);
        }
    }
    el.push_back(v);
}

void dfs_col(int v, vector<vector<pair<int, int>>> &gr, int c) {
    color[v] = c;
    for (auto u: gr[v]) {
        if (!color[u.first]) {
            dfs_col(u.first, gr, c);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> new_gr(n);
    vector<vector<pair<int, int>>> new_gr_rev(n);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        --v;
        --u;
        new_gr[v].push_back({u, w});
        new_gr_rev[u].push_back({v, w});
    }
    int a, b;
    cin >> a >> b;
    --a;
    --b;
    int st = a;
    int fin = b;
    int c = n;
    el.clear();
    used.assign(c, false);
    for (int i = 0; i < c; ++i) {
        if (!used[i]) {
            dfs(i, new_gr);
        }
    }
    reverse(el.begin(), el.end());
    vector<bool> cnt1(c);
    vector<bool> used1(c);
    cnt1[st] = 1;
    used1[st] = true;
    for (auto v: el) {
        if (used1[v]) {
            for (auto u: new_gr[v]) {
                used1[u.first] = true;
                cnt1[u.first] = cnt1[v] ^ cnt1[u.first];
            }
        }
    }
    reverse(el.begin(), el.end());
    vector<bool> used2(c);
    vector<int> cnt2(c);
    cnt2[fin] = 1;
    used2[fin] = true;
    for (auto v: el) {
        if (used2[v]) {
            for (auto u: new_gr_rev[v]) {
                used2[u.first] = true;
                cnt2[u.first] = cnt2[v] ^ cnt2[u.first];
            }
        }
    }
    if (!used1[fin]) {
        cout << 0 << "\n";
        return;
    }
    int res = 0;
    for (int i = 0; i < c; ++i) {
        for (auto v: new_gr[i]) {
            if (used1[i] && used2[v.first]) {
                bool h = cnt1[i] ^ cnt2[v.first];
                if (h) {
                    res ^= v.second;
                }
            }
        }
    }
    cout << res << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}