#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<tuple<int, int, int>> E;
	vector<vector<int>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u;
		--v;
		assert(u < v);
		E.emplace_back(u, v, w);
		g[u].push_back(v);
	}
	int s, t;
	cin >> s >> t;
	--s;
	--t;
	vector<int> dp1(n, 0), dp2(n, 0);
	for (int i = 0; i < n; ++i) {
		for (const int &j : g[i]) {
			dp1[j] ^= dp1[i];
		}
	}
	for (int i = n - 1; i >= 0; --i) {
		for (const int &j : g[i]) {
			dp2[i] ^= dp2[j];
		}
	}
	int ans = 0;
	for (const tuple<int, int, int> &e : E) {
		int u, v, w;
		tie(u, v, w) = e;
		if (dp1[u] % 2 == 1 && dp2[v] % 2 == 1) {
			ans ^= w;
		}
	}
	cout << ans << endl;
}

int32_t main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	int T;
	cin >> T;
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
