#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <deque>
#include <random>
#include <numeric>
#include <unordered_set>
using namespace std;

mt19937 rnd(1000 - 7);

using ll = long long;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll MOD = 1e9 + 7;

int n, m;
int a, b;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> rg;
vector<int> cnt, rcnt;

void bfs() {
	vector<int> left(n, 0);
	for (int i = 0; i < n; ++i) {
		left[i] = rg[i].size();
	}
	cnt[a] = 1;
	deque<int> q;
	q.push_back(a);
	for (int i = 0; i < n; ++i) {
		if (i != a && rg[i].empty()) {
			q.push_back(i);
		}
	}

	while (!q.empty()) {
		auto u = q.front();
		q.pop_front();
		for (auto [v, w] : g[u]) {
			cnt[v] += cnt[u];
			left[v]--;
			if (left[v] == 0) {
				q.push_back(v);
			}
		}
	}
	left.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		left[i] = g[i].size();
	}
	rcnt[b] = 1;
	q.clear();
	q.push_back(b);
	for (int i = 0; i < n; ++i) {
		if (i != a && g[i].empty()) {
			q.push_back(i);
		}
	}

	while (!q.empty()) {
		auto u = q.front();
		q.pop_front();
		for (auto [v, w] : rg[u]) {
			rcnt[v] += rcnt[u];
			left[v]--;
			if (left[v] == 0) {
				q.push_back(v);
			}
		}
	}
}

void solve3() {
	cin >> n >> m;
	g.assign(n, vector<pair<int, int>>());
	rg.assign(n, vector<pair<int, int>>());
	cnt.assign(n, 0);
	rcnt.assign(n, 0);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		g[u].push_back({ v, w });
		rg[v].push_back({ u, w });
	}
	cin >> a >> b;
	a--, b--;

	bfs();

	int res = 0;
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if ((cnt[u] * rcnt[v]) % 2 == 1) {
				res = res ^ w;
			}
		}
	}
	cout << res << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	while (t--)
		solve3();
}