#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <deque>
#include <random>
#include <numeric>
#include <unordered_set>
using namespace std;

mt19937 rnd(1000 - 7);

using ll = long long;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll MOD = 1e9 + 7;

int n, m;
int a, b;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> rg;
vector<int> cnt, rcnt;

void bfs() {
	vector<int> left(n, 0);
	for (int i = 0; i < n; ++i) {
		left[i] = rg[i].size();
	}
	cnt[a] = 1;
	deque<int> q;
	q.push_back(a);
	for (int i = 0; i < n; ++i) {
		if (i != a && rg[i].empty()) {
			q.push_back(i);
		}
	}

	while (!q.empty()) {
		auto u = q.front();
		q.pop_front();
		for (auto [v, w] : g[u]) {
			cnt[v] = (cnt[v] + cnt[u]) % 2;
			left[v]--;
			if (left[v] == 0 && v != a) {
				q.push_back(v);
			}
		}
	}
	left.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		left[i] = g[i].size();
	}
	rcnt[b] = 1;
	q.clear();
	q.push_back(b);
	for (int i = 0; i < n; ++i) {
		if (i != b && g[i].empty()) {
			q.push_back(i);
		}
	}

	while (!q.empty()) {
		auto u = q.front();
		q.pop_front();
		for (auto [v, w] : rg[u]) {
			rcnt[v] = (rcnt[v] + rcnt[u]) % 2;
			left[v]--;
			if (left[v] == 0 && v != b) {
				q.push_back(v);
			}
		}
	}
}

void solve3() {
	cnt.assign(n, 0);
	rcnt.assign(n, 0);
	bfs();

	int res = 0;
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if ((cnt[u] % 2 == 1) && (rcnt[v] % 2 == 1)) {
				res = res ^ w;
			}
		}
	}
	cout << res << "\n";
}

vector<bool> bVis;
void bReachableDfs(int u) {
	bVis[u] = true;
	for (auto [v, w] : rg[u]) {
		if (bVis[v])
			continue;
		bReachableDfs(v);
	}
}

vector<bool> aVis;
void aReachableDfs(int u) {
	aVis[u] = true;
	for (auto [v, w] : g[u]) {
		if (aVis[v])
			continue;
		aReachableDfs(v);
	}
}

vector<bool> vis, cur;
bool cycleDfs(int u) {
	if (!bVis[u]) {
		return false;
	}
	vis[u] = true;
	cur[u] = true;
	for (auto [v, w] : g[u]) {
		if (cur[v]) {
			return true;
		}
		if (vis[v]) {
			continue;
		}
		if (cycleDfs(v))
			return true;
	}
	cur[u] = false;
	return false;
}

vector<int> paint;
bool checkPaint(int u) {
	for (auto [v, w] : rg[u]) {
		if (!aVis[v])
			continue;
		if (paint[v] == -1) {
			paint[v] = paint[u] ^ w;
			if (checkPaint(v)) {
				return true;
			}
		}
		else if (paint[v] != (paint[u] ^ w)) {
			return true;
		}
	}
	return false;
}

void solve6() {
	aVis.assign(n, false);
	aVis[a] = true;
	aReachableDfs(a);
	bVis.assign(n, false);
	bVis[b] = true;
	bReachableDfs(b);
	vis.assign(n, false);
	cur.assign(n, false);
	bool c = cycleDfs(a);
	if (!c) {
		solve3();
		return;
	}
	paint.assign(n, -1);
	paint[b] = 0;
	if (checkPaint(b)) {
		cout << "-1\n";
	}
	else {
		if (paint[a] != 0) {
			cout << "-1\n";
		} else {
			cout << "0\n";
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		g.assign(n, vector<pair<int, int>>());
		rg.assign(n, vector<pair<int, int>>());
		for (int i = 0; i < m; ++i) {
			int u, v, w;
			cin >> u >> v >> w;
			u--, v--;
			g[u].push_back({ v, w });
			rg[v].push_back({ u, w });
		}
		cin >> a >> b;
		a--, b--;
		solve6();
	}
}