#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <deque>
#include <random>
#include <numeric>
#include <unordered_set>
using namespace std;

mt19937 rnd(1000 - 7);

using ll = long long;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ll MOD = 1e9 + 7;

int n, m;
int a, b;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> rg;
vector<int> cnt, rcnt;

vector<bool> bVis;
void bReachableDfs(int u) {
	bVis[u] = true;
	for (auto [v, w] : rg[u]) {
		if (bVis[v])
			continue;
		bReachableDfs(v);
	}
}

vector<bool> aVis;
void aReachableDfs(int u) {
	aVis[u] = true;
	for (auto [v, w] : g[u]) {
		if (aVis[v])
			continue;
		aReachableDfs(v);
	}
}

void bfs() {
	vector<int> left(n, 0);
	for (int i = 0; i < n; ++i) {
		left[i] = rg[i].size();
	}
	cnt[a] = 1;
	deque<int> q;
	vector<bool> used(n, false);
	q.push_back(a);
	used[a] = true;

	while (!q.empty()) {
		auto u = q.front();
		q.pop_front();
		for (auto [v, w] : g[u]) {
			cnt[v] = (cnt[v] + cnt[u]) % 2;
			left[v]--;
			if (left[v] == 0 && v != a && !used[v]) {
				q.push_back(v);
				used[v] = true;
			}
		}
	}
	left.assign(n, 0);
	for (int i = 0; i < n; ++i) {
		left[i] = g[i].size();
	}
	rcnt[b] = 1;
	q.clear();
	used.assign(n, false);
	q.push_back(b);
	used[b] = true;

	while (!q.empty()) {
		auto u = q.front();
		q.pop_front();
		for (auto [v, w] : rg[u]) {
			rcnt[v] = (rcnt[v] + rcnt[u]) % 2;
			left[v]--;
			if (left[v] == 0 && v != b && !used[v]) {
				q.push_back(v);
				used[v] = true;
			}
		}
	}
}

int solve3() {
	cnt.assign(n, 0);
	rcnt.assign(n, 0);
	bfs();

	int res = 0;
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if ((cnt[u] % 2 == 1) && (rcnt[v] % 2 == 1)) {
				res = res ^ w;
			}
		}
	}
	return res;
}

vector<bool> vis, cur;
bool cycleDfs(int u) {
	vis[u] = true;
	cur[u] = true;
	for (auto [v, w] : g[u]) {
		if (cur[v]) {
			return true;
		}
		if (vis[v]) {
			continue;
		}
		if (cycleDfs(v)) {
			return true;
		}
	}
	cur[u] = false;
	return false;
}

vector<int> paint;
bool checkPaint(int u) {
	for (auto [v, w] : g[u]) {
		if (paint[v] == -1) {
			paint[v] = paint[u] ^ w;
			if (checkPaint(v)) {
				return true;
			}
		}
		else if (paint[v] != (paint[u] ^ w)) {
			return true;
		}
	}
	return false;
}

vector<int> za, zb;
void aZeroDfs(int u) {
	for (auto [v, w] : g[u]) {
		if (za[v] == -2)
			continue;
		if (za[v] == -1) {
			za[v] = paint[u] ^ w;
		}
		else if (za[v] != (za[u] ^ w)) {
			za[v] = -2;
		}
	}
}

void bZeroDfs(int u) {
	for (auto [v, w] : rg[u]) {
		if (zb[v] == -2)
			continue;
		if (zb[v] == -1) {
			zb[v] = zb[u] ^ w;
		}
		else if (zb[v] != (zb[u] ^ w)) {
			zb[v] = -2;
		}
	}
}

int solve6() {
	aVis.assign(n, false);
	aVis[a] = true;
	aReachableDfs(a);
	bVis.assign(n, false);
	bVis[b] = true;
	bReachableDfs(b);

	vector<vector<pair<int, int>>> ng(n);
	vector<vector<pair<int, int>>> nrg(n);
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if (aVis[u] && aVis[v] && bVis[u] && bVis[v]) {
				ng[u].push_back({ v, w });
				nrg[v].push_back({ u, w });
			}
		}
	}
	g = ng;
	rg = nrg;

	if (!aVis[b] || !bVis[a]) {
		return 0;
	}

	za.assign(n, 0);
	zb.assign(n, 0);
	aZeroDfs(a);
	bZeroDfs(b);
	
	vector<vector<pair<int, int>>> nng(n);
	vector<vector<pair<int, int>>> nnrg(n);
	for (int u = 0; u < n; ++u) {
		for (auto [v, w] : g[u]) {
			if (!(za[u] == 0 && zb[v] == 0 && w == 0)) {
				nng[u].push_back({ v, w });
				nnrg[v].push_back({ u, w });
			}
		}
	}
	g = nng;
	rg = nnrg;

	vis.assign(n, false);
	cur.assign(n, false);
	bool c = cycleDfs(a);
	if (!c) {
		return solve3();
	}
	paint.assign(n, -1);
	paint[a] = 0;
	if (checkPaint(a)) {
		return -1;
	}
	if (paint[b] != 0) {
		return -1;
	}
	return 0;
}

vector<int> solutions;
int solutionsWithZeroes;
int hitLimit = 0;
void dumBfs(int u, int e, int cur, int d) {
	if (hitLimit >= 1e6) {
		return;
	}
	if (d >= 5 * n || solutionsWithZeroes >= 1000 * n) {
		hitLimit++;
		return;
	}
	if (u == e && cur != 0) {
		solutions.push_back(cur);
		solutionsWithZeroes++;
	}
	else if (u == e) {
		solutionsWithZeroes++;
	}
	for (auto [v, w] : g[u]) {
		dumBfs(v, e, cur ^ w, d + 1);
	}
}

int solveSlow() {
	solutions.clear();
	solutionsWithZeroes = 0;
	hitLimit = 0;
	dumBfs(a, b, 0, 0);
	if (solutions.size() > 0 && hitLimit) {
		return -1;
	}
	int res = 0;
	for (auto el : solutions) {
		res = res ^ el;
	}
	return res;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	int t;
	cin >> t;
	while (t--) {
		cin >> n >> m;
		g.assign(n, vector<pair<int, int>>());
		rg.assign(n, vector<pair<int, int>>());
		for (int i = 0; i < m; ++i) {
			int u, v, w;
			cin >> u >> v >> w;
			u--, v--;
			g[u].push_back({ v, w });
			rg[v].push_back({ u, w });
		}
		cin >> a >> b;
		a--, b--;
		//int r1 = solve6();
		//int r2 = solveSlow();
		//cout << r1 << " " << r2 << "\n";
		//if (r1 != r2 && r2 != 0) {
		//	cout << "alarm\n";
		//	solve6();
		//	solveSlow();
		//}
		cout << solve6() << "\n";
	}
}