#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1000000007;

vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> rev_g;
vector<pair<pair<int, int>, int>> edges;
vector<bool> used;
vector<int> topsort;

vector<int> cycle;
vector<int> cnt_up0;
vector<int> cnt_end0;
vector<int> cnt_up1;
vector<int> cnt_end1;
vector<int> xor_root;

vector<bool> color_a, color_b;
vector<bool> false_color;
vector<int> xor_a, xor_b;
vector<bool> false_color_a;
vector<bool> false_color_b;

void dfs(int v) {
    used[v] = true;
    cout << v << endl;
    for (const pair<int, int> &e : g[v]) {
        if (used[e.X]) {
            if ((xor_root[e.X] ^ xor_root[v] ^ e.Y) == 0) {
                cnt_up0[v]++;
                cnt_end0[e.X]++;
            } else {
                cnt_up1[v]++;
                cnt_end1[e.X]++;
            }
        }
    }
    for (const pair<int, int> &e : g[v]) {
        if (!used[e.X]) {
            xor_root[e.X] = xor_root[v] ^ e.Y;
            dfs(e.X);
            cnt_up0[v] += cnt_up0[e.X];
            cnt_up1[v] += cnt_up1[e.X];
        }
    }
    if (cnt_up1[v] > 0) {
        cycle[v] = 1;
    } else if (cnt_up0[v] > 0) {
        cycle[v] = 0;
    } else {
        cycle[v] = -1;
    }
    cnt_up0[v] -= cnt_end0[v];
    cnt_up1[v] -= cnt_end1[v];
}

void dfs_color_a(int v) {
    color_a[v] = true;
    for (const pair<int, int> &e : g[v]) {
        if (!color_a[e.X]) {
            dfs_color_a(e.X);
        }
    }
}

void dfs_color_b(int v) {
    color_b[v] = true;
    for (const pair<int, int> &e : rev_g[v]) {
        if (!color_b[e.X]) {
            dfs_color_b(e.X);
        }
    }
}

void dfs_calc_a(int v) {
    used[v] = true;
    for (const pair<int, int> &e : g[v]) {
        if (!used[e.X]) {
            xor_a[e.X] = xor_a[v] ^ e.Y;
            dfs_calc_a(e.X);
        }
    }
}

void dfs_calc_b(int v) {
    used[v] = true;
    for (const pair<int, int> &e : rev_g[v]) {
        if (!used[e.X]) {
            xor_b[e.X] = xor_b[v] ^ e.Y;
            dfs_calc_b(e.X);
        }
    }
}

void dfs_false_color_a(int v) {
    used[v] = true;
    for (const pair<int, int> &e : g[v]) {
        if (!used[e.X]) {
            false_color_a[e.X] = true;
            dfs_false_color_a(e.X);
        }
    }
}

void dfs_false_color_b(int v) {
    used[v] = true;
    for (const pair<int, int> &e : rev_g[v]) {
        if (!used[e.X]) {
            false_color_b[e.X] = true;
            dfs_false_color_b(e.X);
        }
    }
}

void dfs_topsort(int v) {
    used[v] = true;
    for (const pair<int, int> &e : g[v]) {
        if (!used[e.X]) {
            dfs_topsort(e.X);
        }
    }
    topsort.push_back(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, vector<pair<int, int>>());
    edges.clear();
    rev_g.assign(n, vector<pair<int, int>>());
    cycle.assign(n, 0);
    cnt_up0.assign(n, 0);
    cnt_up1.assign(n, 0);
    cnt_end0.assign(n, 0);
    cnt_end1.assign(n, 0);
    xor_root.assign(n, 0);
    bool f = true;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        g[a].emplace_back(b, c);
        rev_g[b].emplace_back(a, c);
        edges.push_back({{a, b}, c});
        if (a >= b) {
            f = false;
        }
    }
    int a, b;
    cin >> a >> b;
    a--, b--;

    if (!f) {
        used.assign(n, false);
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        color_a.assign(n, false);
        color_b.assign(n, false);
        dfs_color_a(a);
        dfs_color_b(b);
        false_color.assign(n, false);
        for (int i = 0; i < n; i++) {
            false_color[i] = !color_a[i] || !color_b[i] || cycle[i] == 1;
        }
        xor_a.assign(n, 0);
        xor_b.assign(n, 0);
        used.assign(n, false);
        dfs_calc_a(a);
        used.assign(n, false);
        dfs_calc_b(b);
        false_color_a.assign(n, false);
        false_color_b.assign(n, false);
        for (const auto p : edges) {
            if ((xor_a[p.X.X] ^ xor_a[p.X.Y]) != p.Y) {
                false_color_a[p.X.Y] = true;
            }
            if ((xor_b[p.X.X] ^ xor_b[p.X.Y]) != p.Y) {
                false_color_b[p.X.Y] = true;
            }
        }
        used.assign(n, false);
        for (int i = 0; i < n; i++) {
            if (false_color_a[i]) {
                dfs_false_color_a(i);
            }
        }
        used.assign(n, false);
        for (int i = 0; i < n; i++) {
            if (false_color_b[i]) {
                dfs_false_color_b(i);
            }
        }
        for (int i = 0; i < n; i++) {
            false_color[i] = false_color[i] || (cycle[i] == 0 && (false_color_a[i] || false_color_b[i] || xor_a[i] != xor_b[i]));
        }

        for (int i = 0; i < n; i++) {
            if (false_color[i]) {
                cout << -1 << endl;
                return;
            }
        }

        used.assign(n, false);
        for (int i = 0; i < n; i++) {
            if (cycle[i] != -1) {
                used[i] = true;
            }
        }
    } else {
        used.assign(n, false);
    }
    
    topsort.clear();
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs_topsort(i);
        }
    }
    reverse(all(topsort));
    vector<int> pref(n), suf(n);
    pref[a] = 1;
    for (int x : topsort) {
        for (const pair<int, int> &e : rev_g[x]) {
            pref[x] += pref[e.X];
        }
        pref[x] %= 2;
    }
    reverse(all(topsort));
    suf[b] = 1;
    for (int x : topsort) {
        for (const pair<int, int> &e : g[x]) {
            suf[x] += suf[e.X];
        }
        suf[x] %= 2;
    }
    int ans = 0;
    for (const auto &p : edges) {
        if (pref[p.X.X] % 2 == 1 && suf[p.X.Y] % 2 == 1) {
            ans ^= p.Y;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t;
    cin >> t;
    while (t--) solve();
}