#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<pair<int, int>>> graph;

int ans = 0, b;

bool findb(int v, vi& used, vi& cnt, graph& g) {
	used[v] = 2;
	if (v == b)
		return true;
	for (auto [u, len] : g[v]) {
		if (used[u] == 2) {
			if (cnt[u] > 0)
				return true;
		} else {
			if (findb(u, used, cnt, g))
				return true;
		}
	}
	return false;
}

bool dfs(int v, vi& used, graph& g, vi& x0, vi& x1, vi& cnt, int curxor = 0) {
	used[v] = 1;
	x0[v] = curxor;
	if (v == b) {
		ans ^= curxor;
		cnt[v] = 1;
	}
	for (auto [u, len] : g[v]) {
		if (used[u] == 2) {
			if (cnt[v] == 0)
				continue;
			ans ^= x1[u];
			x1[v] ^= x1[u];
			cnt[v] += cnt[u];
			if (cnt[u] % 2) {
				ans ^= curxor ^ len;
				x1[v] ^= len;
			}
		} else if (used[u] == 1) {
			int cyclexor = curxor ^ len ^ x0[u];
			if (cyclexor != 0 && cnt[u] > 0) {
				ans = -1;
				return false;
			} else if (cyclexor != 0) {
				if (findb(u, used, cnt, g)) {
					ans = -1;
					return false;
				}
			}
		} else {
			bool res = dfs(u, used, g, x0, x1, cnt, curxor ^ len);
			if (ans == -1)
				return false;
			if (res == false)
				continue;
			x1[v] ^= x1[u];
			if (cnt[u] % 2)
				x1[v] ^= len;
			cnt[v] += cnt[u];
		}
	}
	used[v] = 2;
	return cnt[v] > 0;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u; --v;
		g[u].push_back({ v, w });
	}
	int a;
	cin >> a >> b;
	--a; --b;
	vector<int> x0(n), x1(n), cnt(n), used(n);
	ans = 0;
	dfs(a, used, g, x0, x1, cnt);
	cout << ans << "\n";
	/*
	cout << "\nx0: ";
	for (auto f : x0)
		cout << f << " ";
	cout << "\nx1: ";
	for (auto f : x1)
		cout << f << " ";
	cout << "\n\n";
	*/
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}