#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vector<pair<int, int>>> graph;

vector<int> nxt, xnxt;

int b;

bool fillcycle(int start, int v, vi& used, graph& g, vi& cycle, vi& cnt, vi& paths, vi& x0, int curxor) {
	xnxt[v] = (curxor ^ x0[v]);
	nxt[v] = start;
	used[v] = 2;
	cycle[v] = max(cycle[v], cycle[start]);
	for (auto [u, len] : g[v]) {
		if (cnt[u] > 0) {
			if (cycle[v] == 2 || (cycle[v] == 1 && (paths[u] == -1 || (curxor ^ len ^ paths[u]) != 0)))
				return false;
		}
		if (used[u] == 1) {
			if (fillcycle(start, u, used, g, cycle, cnt, paths, x0, curxor ^ len) == false)
				return false;
		}
	}
	return true;
}

bool dfs(int v, vi& used, graph& g, vi& x0, vi& x1, vi& cnt, vi& cycle, vi& paths, int curxor = 0) {
	used[v] = 1;
	x0[v] = curxor;
	if (v == b) {
		if ((cycle[v] == 1 && curxor != 0) || cycle[v] == 2) {
			return false;
		}
		cnt[v] = 1;
	}
	for (auto [u, len] : g[v]) {
		if (nxt[u] != -1 && used[nxt[u]] == 1) {
			int cyclexor = curxor ^ len ^ xnxt[u] ^ x0[nxt[u]];
			if (cyclexor == 0)
				cycle[u] = 1;
			else
				cycle[u] = 2;
			if (fillcycle(nxt[u], nxt[u], used, g, cycle, cnt, paths, x0, x0[nxt[u]]) == false)
				return false;
			used[nxt[u]] = 1;
		}
		if (used[u] == 1) {
			int cyclexor = curxor ^ len ^ x0[u];
			if (cyclexor == 0)
				cycle[u] = 1;
			else
				cycle[u] = 2;
			if (fillcycle(u, u, used, g, cycle, cnt, paths, x0, curxor ^ len) == false)
				return false;
			used[u] = 1;
		}
		else {
			if (used[u] == 0) {
				cycle[u] = max(cycle[u], cycle[v]);
				if (dfs(u, used, g, x0, x1, cnt, cycle, paths, curxor ^ len) == false)
					return false;
			}
			if (cnt[u] == 0)
				continue;
			if (used[u] == 2) {
				if (cycle[v] == 2 || (cycle[v] == 1 && (paths[u] == -1 || (curxor ^ len ^ paths[u]) != 0))) {
					return false;
				}
			}
			if (paths[u] == -1)
				paths[v] = -1;
			if (paths[v] == 0)
				paths[v] = (paths[u] ^ len);
			else if (paths[v] != (paths[u] ^ len))
				paths[v] = -1;
			x1[v] ^= x1[u];
			if (cnt[u] % 2)
				x1[v] ^= len;
			cnt[v] += cnt[u];
		}
	}
	used[v] = 2;
	return true;
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w;
		--u; --v;
		g[u].push_back({ v, w });
	}
	int a;
	cin >> a >> b;
	--a; --b;
	vector<int> x0(n), x1(n), cnt(n), cycle(n), paths(n), used(n);
	nxt.resize(n);
	xnxt.resize(n);
	fill(nxt.begin(), nxt.end(), -1);
	fill(xnxt.begin(), xnxt.end(), 0);
	if (dfs(a, used, g, x0, x1, cnt, cycle, paths) == false)
		cout << -1 << "\n";
	else
		cout << x1[a] << "\n";
	/*
	cout << "\nx0: ";
	for (auto f : x0)
		cout << f << " ";
	cout << "\nx1: ";
	for (auto f : x1)
		cout << f << " ";
	cout << "\n\n";
	*/
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}