#ifndef DEBUG
#pragma GCC optimize("-Ofast")
#pragma GCC target("avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ld = long double;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#ifdef DEBUG
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  ll t;
  cin >> t;
  while (t--)
    solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ---


void solve() {
  ll n, m;
  cin >> n >> m;
  vvii gr(n);
  vvii grev(n);
  bool test_2 = true;
  for (int i = 0; i < m; ++i) {
    ll u, v, w;
    cin >> u >> v >> w;
    --u, --v;
    gr[u].emplace_back(v, w);
    grev[v].emplace_back(u, w);
    if (v <= u) test_2 = false;
  }

  ll a, b;
  cin >> a >> b;
  --a, --b;

  if (test_2) {

    vii dp(n, {0, 0});
    dp[a] = {0, 1};
    for (int v = 0; v < n; ++v) {
      for (auto [u, w] : gr[v]) {
        dp[u].first ^= dp[v].first;
        if (dp[v].second) {
          dp[u].first ^= w;
        }
        dp[u].second ^= dp[v].second;
      }
    }

    cout << dp[b].first << endl;

  } else {
    ll xa = 0;
    bool acc = false;
    {
      ll v = a;
      bool f = true;
      while (v != a || f) {
        xa ^= gr[v][0].second;
        v = gr[v][0].first;
        f = false;
        if (v == b) acc = true;
      }
    }

    if (!acc) {
      cout << 0 << endl;
      return;
    }

    if (xa != 0) {
      cout << -1 << endl;
      return;
    }

    ll x = 0;
    {
      ll v = a;
      while (v != b) {
        x ^= gr[v][0].second;
        v = gr[v][0].first;
      }
      if (x == 0) cout << 0 << endl;
      else cout << -1 << endl;
    }
  }
}