#ifndef DEBUG
#pragma GCC optimize("-Ofast")
#pragma GCC target("avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using ld = long double;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;
using vvii = vector<vii>;

template<class T, class Y>
using umap = __gnu_pbds::gp_hash_table<T, Y>;
template<class T>
using uset = __gnu_pbds::gp_hash_table<T, __gnu_pbds::null_type>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#ifdef DEBUG
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  ll t;
  cin >> t;
  while (t--)
    solve();
}

ll modpow(ll base, ll exp, ll mod) {
  ll res = 1;
  while (exp) {
    if (exp & 1) {
      res = (res * base) % mod;
    }
    base = (base * base) % mod;
    exp >>= 1;
  }
  return res;
}

// ----------

constexpr ll mod = 1e9 + 7;

ll modinv(ll x) {
  return modpow(x, mod - 2, mod);
}

// ---

ll n, m;
vvii gr;
vvii grev;
ll a, b;

vi order;

vi used;
vi x;

bool cycle;
bool failed;
bool b_nonzero;
bool b_acc;

void dfs(ll v) {
  used[v] = 1;

  if (v == a) {
    if (x[v] != 0) b_nonzero = true;
    b_acc = true;
  }
  for (auto [u, w] : grev[v]) {
    if (used[u] == 1 && !failed) {
      ll xa = x[v] ^ w ^ x[u];
      cycle = true;
      failed = xa != 0;
    } else if (used[u] == 0) {
      x[u] = x[v] ^ w;
      dfs(u);
    }
  }

  order.emplace_back(v);

  used[v] = 2;
}

void solve() {
  cin >> n >> m;
  gr.assign(n, {});
  grev.assign(n, {});

  cycle = false;
  failed = false;
  b_nonzero = false;
  b_acc = false;

  for (int i = 0; i < m; ++i) {
    ll u, v, w;
    cin >> u >> v >> w;
    --u, --v;
    gr[u].emplace_back(v, w);
    grev[v].emplace_back(u, w);
  }

  cin >> a >> b;
  --a, --b;

  used.assign(n, 0);
  x.assign(n, 0);

  order.clear();
  dfs(b);

  if (!b_acc) {
    cout << 0 << endl;
    return;
  }

  if (failed || (cycle && b_nonzero)) {
    cout << -1 << endl;
    return;
  }

  if (cycle) {
    cout << 0 << endl;
    return;
  }

  vii dp(n, {0, 0});
  dp[a] = {0, 1};
  for (auto v : order) {
    for (auto [u, w] : gr[v]) {
      dp[u].first ^= dp[v].first;
      if (dp[v].second) {
        dp[u].first ^= w;
      }
      dp[u].second ^= dp[v].second;
    }
  }

  cout << dp[b].first << endl;
}