#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <random>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll) || typeid(T) == typeid(char))
        end_char = ' ';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

struct Edge {
    int v;
    ll w;
    Edge(int vert, ll weight): v(vert), w(weight) {}
    Edge(): v(0), w(0) {}
};

int solution_cycle(const vector<vector<Edge>>& g, int s, int f) {
    int n = g.size();
    vector<ll> w(n);
    for (int i = 0; i < n; ++i) {
        w[i] = g[i][0].w;
    }
    ll to = 0, bk = 0;
    for (int i = s; i != f; i = (i + 1) % n) {
        to ^= w[i];
    }
    if (s == f) {
        for (int i = 0; i < n; ++i) {
            bk ^= w[i];
        }
    }
    else {
        for (int i = f; i != s; i = (i + 1) % n) {
            bk ^= w[i];
        }
    }
    if (to == 0 && bk == 0) {
        return 0;
    }
    else {
        return -1;
    }
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef DUDE
    freopen("input.txt", "r", stdin);
#else
    freopen("input.txt", "r", stdin);
#endif
    int test;
    cin >> test;
    while(test--) {
        int n, m;
        cin >> n >> m;
        vector<vector<Edge>> g(n);
        bool cycle = true;
        for (int i = 0; i < m; ++i) {
            int a, b;
            ll c;
            cin >> a >> b >> c;
            --a; --b;
            if (a != i || b != (i + 1) % n)
                cycle = false;
            g[a].emplace_back(b, c);
        }
        int s, f;
        cin >> s >> f;
        --s; --f;
        if (cycle) {
            cout << solution_cycle(g, s, f) << '\n';
        }
        else {
            if (f == s) {
                cout << "1\n";
                continue;
            }
            vector<ll> dp(n, 0);
            vector<ll> dp2(n, 0);
            dp[f] = 1;
            ll res = 0;
            for (int i = f - 1; i >= s; --i) {
                for (Edge e :g[i]) {
                    dp[i] += dp[e.v];
                }
//                dp[i] %= 2;
            }
            dp2[s] = 1;
            for (int i = s; i < f; ++i) {
//                dp2[i] %= 2;
                for (Edge e: g[i]) {
                    dp2[e.v] += dp2[i];
                    res ^= (dp[e.v] * dp2[i]) % 2 * e.w;
                }
            }
            cout << res << '\n';
        }

    }
}
