#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <deque>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef long double ld;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define len(a) (ll)a.size()
#define endl '\n'
#define debug(a) cout << #a << ": " << a << endl;

const ll mod = 1e9 + 7;
const ll mxl = 24;

// author: @cot-in

void fin() {
#ifdef cot_in
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
}

ll ev = 0;

void dfs(ll v, vector<vector<pair<ll, ll>>> &g, vector<vector<ll>> &ed, vector<bool> &used,
         vector<pair<pair<ll, ll>, ll>> &edges, ll xr, ll b) {
    if (v == b) {
        ev ^= xr;
        return;
    }
    for (auto el: ed[v]) {
        if (!used[el]) {
            ll u = edges[el].first.second;
            ll w = edges[el].second;
            used[el] = true;
            dfs(u, g, ed, used, edges, xr ^ w, b);
        }
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<pair<ll, ll>> nxt(n);
    vector<vector<pair<ll, ll>>> g(n);
    vector<vector<ll>> ed(n);
    vector<pair<pair<ll, ll>, ll>> edges(m);
    bool other = false;
    for (ll i = 0; i < m; i++) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        if (v > u)
            other = true;
        nxt[v] = make_pair(u, w);
        ed[v].push_back(i);
        edges[i] = {{v, u}, w};
    }
    ll a, b;
    cin >> a >> b;
    a--;
    b--;
    if (!other) {
        ll xr = 0;
        while (a != b) {
            xr ^= nxt[a].second;
            a = nxt[a].first;
        }
        ll cycle = nxt[b].second;
        ll right_b = b;
        b = nxt[b].first;
        while (b != right_b) {
            cycle ^= nxt[b].second;
            b = nxt[b].first;
        }
        if (xr == 0 && cycle == 0) {
            cout << 0 << endl;
        } else {
            cout << -1 << endl;
        }
    } else {
        vector<bool> used(m, false);
        dfs(a, g, ed, used, edges, 0, b);
        cout << ev << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), fin();
    ll tt;
    cin >> tt;
    while (tt--)
        solve();
    return 0;
}