#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
random_device rd;
mt19937 rnd(rd());

struct edge {
    ll b, c;

    edge() = default;

    edge(ll b, ll c) : b(b), c(c) {}
};

ll n, m, s, f;
vector<vector<edge>> g, gr;
vector<ll> sorte, col, col_cnt, is_ok, cnt_vert, cnt_comp, now_vert, now_comp, used_comp;
vector<ll> used, suicide;
vector<set<ll>> starts, can;

void topsort(int v) {
    used[v] = 1;
    for (auto &u: g[v]) {
        if (used[u.b])
            continue;
        topsort(u.b);
    }
    sorte.push_back(v);
}

void recolor(int v, int color) {
    col[v] = color;
    used[v] = 1;
    for (auto &u: gr[v]) {
        if (used[u.b])
            continue;
        recolor(u.b, color);
    }
}

void dfs(int v) {
    used[v] = true;
    is_ok[v]++;
    for (auto &u: g[v]) {
        if (used[u.b])
            continue;
        dfs(u.b);
    }
}

void rdfs(int v) {
    used[v] = true;
    is_ok[v]++;
    for (auto &u: gr[v]) {
        if (used[u.b])
            continue;
        rdfs(u.b);
    }
}

bool check_path() {
    used.assign(n, false);
    dfs(s);
    used.assign(n, false);
    rdfs(f);

    return is_ok[f] >= 2;
}

void init() {
    cin >> n >> m;

    if (true) {
        g.clear();
        gr.clear();
        starts.clear();
        is_ok.clear();
        col_cnt.clear();
        used.clear();
        sorte.clear();
        col.clear();
        suicide.clear();
        can.clear();
        cnt_vert.clear();
        cnt_comp.clear();
        used_comp.clear();
    }
    if (true) {
        g.resize(n);
        gr.resize(n);
        starts.resize(n);
        is_ok.resize(n, 0);
        col_cnt.resize(n, 0);
        used.resize(n, 0);
        col.resize(n);
        suicide.resize(n, 0);
        cnt_vert.resize(n, 0);
        cnt_comp.resize(n, 0);
        used_comp.resize(n, 0);
    }

    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c, a--, b--;
        g[a].emplace_back(b, c);
        gr[b].emplace_back(a, c);
        if (a == b)
            suicide[a] = true;
    }
    cin >> s >> f, s--, f--;

    for (int i = 0; i < n; i++) {
        if (used[i])
            continue;
        topsort(i);
    }
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (used[sorte[n - i - 1]])
            continue;
        recolor(sorte[n - i - 1], sorte[n - i - 1]);
    }
    for (int i = 0; i < n; i++) {
        col_cnt[col[i]]++;
    }

    for (int i = 0; i < n; i++) {
        for (auto &j: g[i]) {
            if (col[i] == col[j.b]) {
                cnt_vert[j.b]++;
            } else {
                cnt_comp[col[j.b]]++;
            }
        }
    }
}

ll timer = 5, bad_timer = 5;
queue<ll> Q;

void bfs(int color, int k) {
    queue<ll> q;
    for (auto &i: starts[color]) {
        q.push(i);
        used[i] = timer;
    }


    while (!q.empty()) {
        int v = q.front();
        q.pop();

        for (auto &u: g[v]) {
            ll c = (u.c >> k) & 1;
            for (auto &costs: can[v]) {
                can[u.b].insert(costs ^ c);
            }
            if (col[u.b] != color) {
                cnt_comp[col[u.b]]--;
                if (used_comp[col[u.b]] != bad_timer)
                    Q.push(col[u.b]), used_comp[col[u.b]] = bad_timer;
                starts[col[u.b]].insert(u.b);
                continue;
            }

            if (used[u.b] != timer)
                q.push(u.b), used[u.b] = timer;
        }
    }
    timer++;
}

void solve() {
    init();

    if (!check_path()) {
        cout << 0 << '\n';
        return;
    }

    bool flag = false;
    ll C = 32;
    for (int k = C; k >= 0; k--) {
        can.clear();
        can.resize(n);
        starts.clear();
        while (!Q.empty())
            Q.pop();

        bad_timer++;
        Q.push(col[s]);
        used_comp[col[s]] = bad_timer;
        starts[col[s]].insert(s);
        can[s].insert(0);

        while (!Q.empty()) { //это бфс по компонентам
            int comp = Q.front();
            Q.pop();

            bfs(comp, k);
            bfs(comp, k);
            bfs(comp, k);
            bfs(comp, k);
        }
        if (can[f].find(1) != can[f].end()) {
            flag = true;
        }
    }
    if (!flag) {
        cout << "0\n";
        return;
    }

    //проверка на циклы
    for (int i = 0; i < n; i++) {
        if (is_ok[i] >= 2 && (suicide[i] || col_cnt[col[i]] > 1)) {
            cout << "-1\n";
            return;
        }
    }

    ll ans = 0;
    for (int k = C; k >= 0; k--) {
        timer++;
        queue<ll> q;
        q.push(s);
        used[s] = timer;

        vector<vector<ll>> info(n, vector<ll>(2, 0));
        info[s][0] = 1;
        while (!q.empty()) {
            ll v = q.front();
            q.pop();

            for (auto &u: g[v]) {

                ll c = (u.c >> k) & 1;
                for (int i = 0; i < 2; i++) {
                    ll would = i ^ c;
                    info[u.b][would] += info[v][i];
                }
                if (used[u.b] != timer)
                    used[u.b] = timer, q.push(u.b);
            }
        }
        ans ^= ((info[f][1] & 1) << k);
    }

    cout << ans << '\n';
}

int main() {
    cin.tie(0), cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll tt = 1;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
