#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

const int MAXN = 4e5 + 7;
vector <pair <int, int>> g[MAXN];
vector <int> gt[MAXN];

vector <int> topsort;
bool used[MAXN];

void dfs1(int v) {
	used[v] = true;
	for (auto to : gt[v])
		if (!used[to])
			dfs1(to);
	topsort.push_back(v);
}

int comp[MAXN];
int compsz[MAXN];

vector <int> order;
void dfs2(int v) {
	used[v] = true;
	order.push_back(v);
	for (auto to : g[v])
		if (!used[to.first])
			dfs2(to.first);
}

int ways[MAXN];
void dfs3(int v) {
	ways[v] = 0;
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to.first])
			dfs3(to.first);
		ways[v] += ways[to.first];
	}
}

int ways_in[MAXN];
void dfs4(int v) {
	ways_in[v] = 0;
	used[v] = true;
	for (auto to : gt[v]) {
		if (!used[to])
			dfs4(to);
		ways_in[v] += ways_in[to];
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < 2 * n; i++) {
		g[i].clear();
		gt[i].clear();
	}
	int v, u, w;
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> w;
		v--; u--;
		g[v].push_back({ u, w });
		gt[u].push_back(v);
	}
	int a, b;
	cin >> a >> b;
	a--; b--;
	topsort.clear();
	fill(used, used + n, false);
	for (int i = 0; i < n; i++)
		if (!used[i])
			dfs1(i);
	reverse(topsort.begin(), topsort.end());
	int c = n;
	fill(used, used + n, false);
	for (auto e : topsort) {
		if (used[e])
			continue;
		order.clear();
		dfs2(e);
		for (auto el : order)
			comp[el] = c;
		compsz[c] = (int)order.size();
		c++;
	}
	for (int i = 0; i < n; i++) {
		for (auto to : g[i]) {
			if (comp[i] != comp[to.first]) {
				g[comp[i]].push_back({ comp[to.first], to.second });
				gt[comp[to.first]].push_back(comp[i]);
			}
		}
	}
	a = comp[a], b = comp[b];
	fill(used, used + 2 * n, false);
	fill(ways, ways + 2 * n, 0);
	ways[b] = 1;
	used[b] = true;
	dfs3(a);
	fill(used, used + 2 * n, false);
	fill(ways_in, ways_in + 2 * n, 0);
	ways_in[a] = 1;
	used[a] = true;
	dfs4(b);
	int ans = 0;
	for (int i = n; i < c; i++) {
		for (auto to : g[i]) {
			long long cnt = ways_in[i] * 1ll * ways[to.first];
			if (cnt & 1)
				ans ^= to.second;
		}
	}
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}