#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <queue>
#include <vector>

using namespace std;

const int MAXN = 4e5 + 7;
vector <pair <int, int>> g[MAXN];
vector <int> gt[MAXN];
vector <pair <int, int>> gs[MAXN][2];
vector <pair <int, int>> gst[MAXN][2];

vector <int> topsort;
bool used[MAXN];

void dfs1(int v) {
	used[v] = true;
	for (auto to : gt[v])
		if (!used[to])
			dfs1(to);
	topsort.push_back(v);
}

int comp[MAXN];

vector <int> order;
void dfs2(int v) {
	used[v] = true;
	order.push_back(v);
	for (auto to : g[v])
		if (!used[to.first])
			dfs2(to.first);
}

int ways[MAXN];
void dfs3(int v) {
	ways[v] = 0;
	used[v] = true;
	for (auto to : g[v]) {
		if (!used[to.first])
			dfs3(to.first);
		ways[v] += ways[to.first];
	}
}

int ways_in[MAXN];
void dfs4(int v) {
	ways_in[v] = 0;
	used[v] = true;
	for (auto to : gt[v]) {
		if (!used[to])
			dfs4(to);
		ways_in[v] += ways_in[to];
	}
}

bool useds[MAXN][2];
bool useds2[MAXN][2];
void dfs5(int v, int color) {
	useds[v][color] = true;
	for (auto to : gs[v][color])
		if (!useds[to.first][to.second])
			dfs5(to.first, to.second);
}

void dfs6(int v, int color) {
	useds2[v][color] = true;
	for (auto to : gst[v][color])
		if (!useds2[to.first][to.second])
			dfs6(to.first, to.second);
}

vector <pair <int, int>> topsort2;
void dfs7(int v, int color) {
	useds[v][color] = true;
	for (auto to : gst[v][color])
		if (!useds[to.first][to.second])
			dfs7(to.first, to.second);
	topsort2.push_back({ v, color });
}

vector <pair <int, int>> order2;
void dfs8(int v, int color) {
	useds[v][color] = true;
	order2.push_back({ v, color });
	for (auto to : gs[v][color])
		if (!useds[to.first][to.second])
			dfs8(to.first, to.second);
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < 2 * n; i++) {
		g[i].clear();
		gt[i].clear();
	}
	int v, u, w;
	vector <bool> badv(n, false);
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> w;
		v--; u--;
		if (v == u)
			badv[v] = true;
		g[v].push_back({ u, w });
		gt[u].push_back(v);
	}
	int a, b;
	cin >> a >> b;
	a--; b--;
	topsort.clear();
	fill(used, used + n, false);
	for (int i = 0; i < n; i++)
		if (!used[i])
			dfs1(i);
	reverse(topsort.begin(), topsort.end());
	int c = n;
	fill(used, used + n, false);
	vector <bool> bad_comp(2 * n, false);
	for (auto e : topsort) {
		if (used[e])
			continue;
		order.clear();
		dfs2(e);
		for (auto el : order)
			comp[el] = c;
		if ((int)order.size() > 1 || badv[order[0]])
			bad_comp[c] = true;
		c++;
	}
	for (int i = 0; i < n; i++) {
		for (auto to : g[i]) {
			if (comp[i] != comp[to.first]) {
				g[comp[i]].push_back({ comp[to.first], to.second });
				gt[comp[to.first]].push_back(comp[i]);
			}
		}
	}
	int a0 = a, b0 = b;
	a = comp[a], b = comp[b];
	fill(used, used + 2 * n, false);
	fill(ways, ways + 2 * n, 0);
	ways[b] = 1;
	used[b] = true;
	dfs3(a);
	fill(used, used + 2 * n, false);
	fill(ways_in, ways_in + 2 * n, 0);
	ways_in[a] = 1;
	used[a] = true;
	dfs4(b);
	int ans = 0;
	bool damn = false;
	if (bad_comp[a])
		damn = true;
	for (int i = n; i < c; i++) {
		for (auto to : g[i]) {
			if (bad_comp[to.first] && ways[to.first])
				damn = true;
			long long cnt = ways_in[i] * 1ll * ways[to.first];
			if (cnt & 1)
				ans ^= to.second;
		}
	}
	if (!damn) {
		cout << ans << "\n";
	}
	else {
		bool zer = true;
		for (int bit = 0; bit < 30 && zer; bit++) {
			for (int i = 0; i < n; i++) {
				useds[i][0] = useds[i][1] = false;
				useds2[i][0] = useds2[i][1] = false;
				gs[i][0].clear();
				gs[i][1].clear();
				gst[i][0].clear();
				gst[i][1].clear();
			}
			vector <vector <bool>> badv2(n, vector <bool>(2, false));
			for (int i = 0; i < n; i++) {
				for (auto to : g[i]) {
					if ((to.second >> bit) & 1) {
						gs[i][0].push_back({ to.first, 1 });
						gs[i][1].push_back({ to.first, 0 });
						gst[to.first][1].push_back({ i, 0 });
						gst[to.first][0].push_back({ i, 1 });
					}
					else {
						if (to.first == i)
							badv2[i][0] = badv2[i][1] = true;
						gs[i][0].push_back({ to.first, 0 });
						gs[i][1].push_back({ to.first, 1 });
						gst[to.first][1].push_back({ i, 1 });
						gst[to.first][0].push_back({ i, 0 });
					}
				}
			}
			topsort2.clear();
			for (int i = 0; i < n; i++) {
				if (!useds[i][0])
					dfs7(i, 0);
				if (!useds[i][1])
					dfs7(i, 1);
			}
			reverse(topsort2.begin(), topsort2.end());
			for (int i = 0; i < n; i++)
				useds[i][0] = useds[i][1] = false;
			vector <vector <int>> comp2(n, vector <int>(2, -1));
			c = 0;
			bad_comp.assign(2 * n, false);
			for (auto e : topsort2) {
				if (useds[e.first][e.second])
					continue;
				order2.clear();
				dfs8(e.first, e.second);
				for (auto el : order2)
					comp2[el.first][el.second] = c;
				if ((int)order2.size() > 1 || badv2[order2[0].first][order2[0].second])
					bad_comp[c] = true;
				c++;
			}
			for (int i = 0; i < n; i++)
				useds[i][0] = useds[i][1] = false;
			dfs5(a0, 0);
			dfs6(b0, 1);
			for (int i = 0; i < n; i++) {
				for (int j = 0; j <= 1; j++) {
					if (bad_comp[comp2[i][j]] && useds[i][j] && useds2[i][j])
						zer = false;
				}
			}
		}
		if (zer)
			cout << "0\n";
		else
			cout << "-1\n";
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}