#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
const int MOD = 1e9 + 7;
struct edge{
    int u, len;
};
vector<vector<edge>> gr, r_gr;
vector<int> good, cnt, used, check, tout, tin;
int cntime = 1;

int dfs(int v){
    used[v] = 1;
    tin[v] = cntime++;
    //cout << v << ' ' << gr[v].size() << '\n';
    for (edge e : gr[v]){
        int u = e.u;
        if (!check[u]) continue;
        if (used[u] && tout[u] < tin[u]) return -1;
        if (!used[u] && dfs(u) == -1) return -1;
        cnt[v] += cnt[u];
        good[v] ^= good[u] ^ ((cnt[u]%2) * e.len);
    }
    tout[v] = cntime++;
    return good[v];
}
void can_go(int v, vector<vector<edge>> & graph){
    check[v] = 1;
    for (edge e : graph[v]){
        int u = e.u;
        if (!check[u]) can_go(u, graph);
    }
}

void main0(){
    cntime = 1;
    gr.clear(); good.clear(); cnt.clear(); used.clear(); check.clear(); r_gr.clear();
    tin.clear(); tout.clear();
    int n, m; cin >> n >> m;
    tout.resize(n + 1);
    tin.resize(n + 1);
    gr.resize(n + 1); good.resize(n + 1); cnt.resize(n + 1); used.resize(n + 1); check.resize(n + 1);
    r_gr.resize(n + 1);
    int a, b;
    for (int i = 0; i < m; i++){
        int v, u, l; cin >> v >> u >> l;
        edge e; e.u = u; e.len = l;
        if (v == u && l == 0) continue;
        gr[v].push_back(e);
        e.u = v;
        r_gr[u].push_back(e);
    } cin >> a >> b;
    can_go(a, gr);
    int c1 = check[b]; // a -> b?
    check.assign(n + 1, 0);
    can_go(b, gr);
    int c2 = check[a]; // b -> a?
    check.assign(n + 1, 0);
    //cout << c2 << ' ';
    if (c1 + c2 == 0 || a == b && gr[a].size() == 0) {
        cout << 0 << '\n';
        return;
    } if (c2) {
        cout << -1 << '\n';
        return;
    }
    can_go(b, r_gr);
    cnt[b] = 1;
    if (dfs(a) == -1) {
        cout << -1 << '\n';
        return;
    }
    for (int i = 1; i <= n; i++){
        //cout << cnt[i] << ' ';
    }
    cout << good[a] << '\n';
}

signed main() {
    speed();
    cout << fixed << setprecision(10);
    int t = 1; cin >> t;
    while (t--){
        main0();
        cout << '\n';
    }
}
