#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>
#include <cmath>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <random>
#include <numeric>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const int LL_INF = 2e18 + 10;

template <typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

struct Edge {
    int v, w;
    Edge() : v(0), w(0) {}
    Edge(int _v, int _w) : v(_v), w(_w) {}
};

int n, m;
vector<vector<Edge>> g;
bool is_circle() {    
    for (int i = 0; i < n; i++) {
        if (g[i].size() != 1 || g[i][0].v != (i + 1) % n) {
            return false;
        }
    }
    return true;
}

bool topsorted() {
    for (int i = 0; i < n; i++) {
        for (auto e : g[i]) {
            if (i >= e.v) {
                return false;
            }
        }
    }
    return true;
}

vector<bool> used;

void dfs(int u) {
    used[u] = true;
    for (auto e : g[u]) {
        if (!used[e.v]) {
            dfs(e.v);
        }
    }
}

int main() {
    int t_num;
    cin >> t_num;
    while (t_num--) {
        cin >> n >> m;
        g.assign(n, vector<Edge>());
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--;
            v--;
            g[u].push_back(Edge(v, w));
        }
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        if (is_circle()) {
            int x = 0;
            for (int i = 0; i < n; i++) {
                x ^= g[i][0].w;
            }
            if (x != 0) {
                cout << -1 << '\n';
            } else {
                for (int u = a; u != b; u = g[u][0].v) {
                    x ^= g[u][0].w;
                }
                if (x == 0) {
                    cout << 0 << '\n';
                } else {
                    cout << -1 << '\n';
                }
            }
            continue;
        } else if (topsorted()) {
            used.assign(n, false);
            dfs(a);
            vector<int> dp(n);
            dp[a] = 1;
            vector<int> val(n);
            for (int u = a; u <= b; u++) {
                for (auto e : g[u]) {
                    dp[e.v] = (dp[e.v] + dp[u]) % 2;
                    val[e.v] ^= (val[u] ^ (e.w * dp[u]));
                }
            }
            cout << val[b] << '\n';
        }
    }
}
