#include <iostream>
#include <string>
#include<vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <complex>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<vector<int> > vvi;
typedef vector<vector<ll>> vvl;
typedef vector<bool> vb;

#define int long long
#define all(v) v.begin(), v.end()
#define pb push_back();

/*

void build(vl & t, int v, int l, int r, vi & a) {
    if(l == r) t[v] = a[l];
    else {
        int m = (l + r) / 2;
        build(t, 2 * v, l, m, a);
        build(t, 2 * v + 1, m + 1, r, a);
        t[v] = (t[2 * v] + t[2 * v + 1]);
    }
}
int sum(vl & t, int v, int tl, int tr, int l, int r) {
    if(l == tl && r == tr) return t[v];
    // look out
    if(l > r) return 0;
    // look out
    int tm = (tl + tr) / 2;
    return sum(t, 2 * v, tl, tm, l, min(tm, r)) +
            sum(t, 2 * v + 1, tm + 1, tr, max(tm + 1, l), r);

}
void update(vl & t, int v, int tl, int tr, int pos, int x) {
    if(tl == tr) t[v] = x;
    else {
        int tm = (tl + tr) / 2;
        if(pos <= tm) update(t, 2 * v, tl, tm, pos, x);
        else update(t, 2 * v + 1, tm + 1, tr, pos, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}
*/
bool ansminus = false;

void dfs(ll v,vector<vector<pair<ll, ll>>> & g, vl & used, set<pair<int,int>> & circle, vl & dp) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(used[u.first] == 1) {
            if((dp[v] ^ dp[u.first] ^ u.second) != 0) ansminus = true;
            circle.insert({v, u.first});
        }
        if(used[u.first]) continue;
        dp[u.first] ^= dp[v] ^ u.second;
        dfs(u.first, g, used, circle, dp);
    }
    used[v] = 2;
}
/*void dfs(ll v,vector<vector<pair<ll, ll>>> & g, vl & used) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(used[u.first]) continue;
        dfs(u.first, g, used);
    }
}*/
void solve() {
    ll n;
    cin >> n;
    int m; cin >> m;
    vector<vector<pair<ll, ll>>> g(n), e(n);
    for(int i = 0; i < m; ++i) {
        ll v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].push_back({u, w});
        e[u].push_back({v, w});
    }

    ll a, b;
    cin >> a >> b;
    a--;
    b--;

    set<pair<int,int>> circle1, circle2;
    vl used(n), used1(n), used2(n);
    vl dp(n);
    ansminus = false;
    dfs(a, g, used1, circle1, dp);
    for(int i = 0; i < n; ++i) dp[i] = 0;
    dfs(b, e, used2, circle2, dp);

    bool ok = true;
    vector<vector<pair<ll, ll>>> bfg(n), bfe(n);
    for(int v = 0; v < n; ++v) {
        for(auto u: g[v]) {
            if(circle1.count({v, u.first})) {
                if(used1[v] && used2[v]) ok = false;
            } else {
                bfg[v].push_back(u);
            }
        }
    }
    swap(bfg, g);
    for(int v = 0; v < n; ++v) {
        for(auto u: e[v]) {
            if(circle2.count({v, u.first})) {
                if(used1[v] && used2[v]) ok = false;
            } else {
                bfe[v].push_back(u);
            }
        }
    }
    swap(bfe, e);

    vl l(n), r(n);
    queue<ll> q;
    //q.push(a);
    l[a] = 1;
    for(int i = 0; i < n; ++i) used[i] = false;
    vi cnt(n);
    for(int i = 0; i < n; ++i) cnt[i] = e[i].size();
    for(int i = 0; i < n; ++i) if(cnt[i] == 0) q.push(i);
    while(!q.empty()) {
        ll v = q.front();
        q.pop();
        if(used[v]) continue;
        used[v] = true;
        for(auto u : g[v]) {
            l[u.first] =  (l[u.first] + l[v]) % 2;
            cnt[u.first]--;
            if(cnt[u.first] == 0)
                q.push(u.first);
        }
    }
    //////////
    ////////
    ///
    ///
    ///
    ///
    ///
    ///
    r[b] = 1;
    for(int i = 0; i < n; ++i) used[i] = false;
    for(int i = 0; i < n; ++i) cnt[i] = g[i].size();
    for(int i = 0; i < n; ++i) if(cnt[i] == 0) q.push(i);
    while(!q.empty()) {
        ll v = q.front();
        q.pop();
        if(used[v]) continue;
        used[v] = true;
        for(auto u : e[v]) {
            r[u.first] = (r[u.first] + r[v]) % 2;
            cnt[u.first]--;
            if(cnt[u.first] == 0)
                q.push(u.first);
        }
    }
    ll ans = 0;

    for(int v = 0; v < n; ++v) for(auto u : g[v]) {
        if( (l[v] * r[u.first]) % 2) {
            ans ^= u.second;
        }
    }
    if(ansminus) cout << -1;
    else
    if(ans == 0)
        cout << ans;
    else if(ok) cout << ans;
    else cout << -1;

    //ll ans = 0;

    // ll k; cin >> k;
    // ll a, b, c; cin >> a >> b >> c;
    //ll d; cin >> d;
    // string s; cin >> s; n = s.length();



    // cout << ans;
    // cout << (ans ? "YES" : "NO");
    // cout << ans.size() << '\n';
    // for(auto x : ans) cout << x << '\n';
    // for(auto p : ans) cout << p.first << ' ' << p.second << "\n";
    cout << "\n";
}
signed main() {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}
