#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
//#define endl '\n'
#define pb push_back
//#define int long long

const int INF = 2e9 + 333, N = 2e5 + 10;

vec<int> p(N, 1);

struct fenwick {
    int n;
    vec<int> tree;
    void init(int n_) {
        n = n_;
        tree.resize(n + 1);
    }
    void upd(int i, int a) {
        i++;
        for (; i <= n; i += i & -i) tree[i] = max(a, tree[i]);
    }
    int get(int x) {
        int s = 0;
        x++;
        for (; x > 0; x -= x & -x) s = max(s, tree[x]);
        return s;
    }
    int get(int l, int r) {
        return get(r) - get(l - 1);
    }
};

struct Vector {
    ld x, y;
    Vector(ld x_, ld y_) {
        x = x_, y = y_;
    }
    friend Vector operator+(Vector& a, Vector& b) {
        return { a.x + b.x, a.y + b.y };
    }
    friend Vector operator-(Vector& a, Vector& b) {
        return { a.x + b.x, a.y + b.y };
    }
    friend ld operator*(Vector& a, Vector& b) {
        return a.x * b.x + a.y * b.y;
    }
    friend ld operator%(Vector& a, Vector& b) {
        return a.x * b.y - a.y * b.x;
    }
    ld len() {
        return x * x + y * y;
    }
    ld len2() {
        return sqrt(x * x + y * y);
    }
    void norm() {
        ld l = len2();
        x /= l, y /= l;
    }
};

struct Line {
    ld a, b, c;
    Line(ld a_, ld b_, ld c_) {
        a = a_, b = b_, c = c_;
    }
    ld rast(Vector p) {
        return (a * p.x + b * p.y + c) / ((sqrt(a * a + b * b)));
    }
};

struct Hash {
    vec<int> h;
    int n;
    void init(string& s) {
        n = (int)s.size();
        h.assign(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            h[i] = (h[i - 1] * 37 + s[i] - 'a' + 1) % INF;
        }
    }
    int get(int l, int r) {
        return (((h[r + 1] - h[l] + INF) % INF) * p[N - l - 1]) % INF;
    }
};

bool comp(pair<int, vec<int>>& a, pair<int, vec<int>>& b) {
    return a.first < b.first;
}

vec<vec<pi>> g;

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, vec<pi>());
    bool flag = 1;
    int s = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        a--; b--;
        s = s ^ w;
        g[b].push_back({ a, w });
        if ((a + 1) % n != b) flag = 0;
    }
    //cout << flag << endl;
    if (n == m && flag) {
        int a, b;
        cin >> a >> b;
        a--; b--;
        int ans = 0;
        for (int i = a; i != b; i = (i + 1 + n) % n) {
            //cout << i << endl;
            ans = ans ^ g[(i + 1) % n][0].second;
        }
        if (s != 0) {
            cout << -1 << endl;
            return;
        }
        cout << ans << endl;
        return;
    }
    vec<int> dp(n);
    vec<bool> us(n);
    int a, b;
    cin >> a >> b;
    a--; b--;
    us[a] = 1;
    for (int i = 0; i < n; ++i) {
        for (pi j : g[i]) {
            dp[i] ^= dp[j.first];
            if (us[j.first]) dp[i] ^= j.second;
            us[i] = us[i] ^ us[j.first];
        }
        //cout << dp[i] << " " << us[i] << endl;
    }
    cout << dp[b] << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (; t > 0; --t) {
        solve();
    }
}