#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

bool dfs(int i, int e, vector<vector<pair<int, ll>>>& v, vector<bool>& good, vector<bool>& was) {
	if (was[i])re good[i];
	if (i == e) {
		good[i] = 1;
		re 1;
	}
	was[i] = true;

	bool ok = false;
	for (auto j : v[i]) {
		ok |= dfs(j.first, e, v, good, was);
	}

	good[i] = ok;
	re ok;
}

bool ok = true;

void dfs2(int i, vector<vector<pair<int, ll>>>& v, vector<bool>& was, ll n, vector<ll>& cnt, vector<bool>& good) {
	if (was[i])re;
	was[i] = true;

	for (auto j : v[i]) {
		if (!good[j.first])continue;

		if (was[j.first] && n != (cnt[j.first] ^ j.second))ok = false;

		cnt[j.first] = cnt[i] ^ j.second;
		dfs2(j.first, v, was, n ^ j.second, cnt, good);
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int t; cin >> t;
	while (t--) {
		int n, m; cin >> n >> m; 
		vector<vector<pair<int, ll>>> v(n);
		vector<bool> was(n), good(n);
		vector<ll> info(n);

		fori(m) {
			ll a, b, w; cin >> a >> b >> w;

			v[a - 1].push_back({ b - 1, w });
		}
		ll a, b; cin >> a >> b;

		bool ok = dfs(a - 1, b - 1, v, good, was);
		if (!ok) {
			cout << "-1\n";
			continue;
		}

		::ok = true;
		fill(all(was), false);
		dfs2(a - 1, v, was, 0, info, good);

		if (ok)cout << info[b - 1] << "\n";
		else cout << "-1\n";
	}
}