#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(1e18) + 13;
template<typename T> inline bool smin(T&a,T b) {
  if (b < a) { a = b; return true; }
  return false;
}
template<typename T> inline bool smax(T&a,T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T1, typename T2> istream & operator >> (istream & in, pair<T1, T2> & pr) {
  in >> pr.first >> pr.second;
  return in;
}
template<typename T> istream & operator >> (istream & in, vector<T> & vec) {
  for (int & x : vec) in >> x;
  return in;
}
template<typename T1, typename T2> ostream & operator << (ostream & out, pair<T1, T2> & pr) {
  out << pr.first << " " << pr.second;
  return out;
}
template<typename T> ostream & operator << (ostream & out, vector<T> & vec) {
  if (vec.empty()) return out;
  out << vec[0];
  for (size_t i = 1; i < vec.size(); ++i)
    out << " " << vec[i];
  return out;
}
mt19937 rng(1810u);
uniform_int_distribution<> uid(0, INF-1);

constexpr int N = 3e5 + 3;

template<int MOD1, int MOD2>
class HashBase {
public:
  using Type = HashBase<MOD1, MOD2>;
  HashBase(): x(0), y(0) {}
  explicit HashBase(int x) : x(x), y(x) {}
  HashBase(int x, int y) : x(x), y(y) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD1 ? x + rhs.x - MOD1 : x + rhs.x,
        y + rhs.y >= MOD2 ? y + rhs.y - MOD2 : y + rhs.y
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD1 : x - rhs.x,
        y - rhs.y < 0 ? y - rhs.y + MOD2 : y - rhs.y
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD1),
        static_cast<int>(1ll * y * rhs.y % MOD2)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return optimization < rhs.optimization; }
  bool operator == (const Type & rhs) const { return optimization == rhs.optimization; }
  bool operator != (const Type & rhs) const { return optimization != rhs.optimization; }

private:
  union {
    struct { int y, x; };
    ll optimization;
  };
};
typedef HashBase<int(1e9) + 7, int(1e9) + 9> Hash;
Hash P(911, 991), pws[N];

template<int MOD1, int MOD2>
HashBase<MOD1, MOD2> Substr(int l, int r, const vector<HashBase<MOD1, MOD2>> & hash) {
  return hash[r] - hash[l] * pws[r - l];
}

vector<int> ZFunc(const string & s) {
  vector<int> z(s.size());
  int n = static_cast<int>(s.size());
  for (int i = 1, l = 0, r = 0; i < n; ++i) {
    if (i < r)
      z[i] = min(z[i - l], r - i);
    while (i + z[i] < n && s[z[i]] == s[i + z[i]])
      ++z[i];
    if (i + z[i] > r)
      l = i, r = i + z[i];
  }
  return z;
}

vector<vector<pair<int, int>>> g;

void Solve() {

  int n, m;
  cin >> n >> m;
  g.assign(n, vector<pair<int, int>>());
  int full = 0;
  bool cycle = n == m;
  for (int i = 0, u, v, w; i < m; ++i) {
    cin >> u >> v >> w; --u, --v;
    cycle &= u == i && v == (i + 1) % n;
    g[u].emplace_back(v, w);
    g[v].emplace_back(u, w);
    full ^= w;
  }
  int a, b;
  cin >> a >> b;
  --a, --b;
  if (cycle) {
    int lmao = 0;
    for (int i = a; i < b; i = (i + 1) % n) {
      int fw;
      if (g[i][0].first == (i + 1) % n) fw = g[i][0].second;
      else fw = g[i][1].second;
      lmao ^= fw;
    }
    if (lmao == 0 && full == 0) {
      cout << 0 << endl;
    } else cout << -1 << endl;
    return;
  }
  vector<int> dp(n);
  vector<int> cnt(n);
  vector<int> used(n);
  function<void(int)> Dfs = [&](int v) {
    used[v] = 1;
    cnt[v] = v == b;
    for (auto [u, w] : g[v]) {
      if (!used[u]) Dfs(u);
      cnt[v] += cnt[u] & 1;
      cnt[v] &= 1;
      if (cnt[u]) dp[v] ^= dp[u] ^ w;
    }
  };
  for (int i = 0; i < n; ++i)
    if (!used[i]) Dfs(i);
  cout << dp[a] << endl;

}


int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

  pws[0] = Hash(1);
  for (int i = 1; i < N; ++i) {
    pws[i] = pws[i-1] * P;
  }

  int T;
  cin >> T;
  while (T--)
    Solve();

  return 0;
}
