#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

int n, m, a, b;
vector< pair<int, int> > G[MAXN + 5];
int odd[MAXN + 5][30], even[MAXN + 5][30], cnt[30];

void solve()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
        for (int j = 0; j < 30; ++ j)
        {
            odd[i][j] = even[i][j] = 0;
        }
    }

    bool flag1 = true, flag23 = true;
    if (n != m) flag1 = false;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        int t = (i + 1) % n;
        if (t == 0) t = n;
        if (u != i or v != t) flag1 = false;
        G[u].push_back({v, w});
        if (!(u < v)) flag23 = false;
    }

    cin >> a >> b;

    if (flag1)
    {
        int x = 0;
        while (a != b)
        {
            x ^= G[a][0].second;
            a = G[a][0].first;
        }

        int y = 0;
        do
        {
            y ^= G[a][0].second;
            a = G[a][0].first;
        } while (a != b);

        if (x == 0 and y == 0) cout << 0 << endl;
        else cout << -1 << endl;
        return;
    }

    if (flag23)
    {
        for (int j = 0; j < 30; ++ j)
        {
            odd[a][j] = 0;
            even[a][j] = 1;
        }
        for (int u = a; u < b; ++ u)
        {
            if (G[u].size() == 0) continue;
            sort(G[u].begin(), G[u].end());

            int prv = G[u][0].first, br = 0;
            for (int j = 0; j < 30; ++ j)
            {
                cnt[j] = 0;
            }
            for (auto [v, w] : G[u])
            {
                if (v == prv)
                {
                    br++;
                    for (int j = 0; j < 30; ++ j)
                    {
                        if (w & (1ll << j)) cnt[j]++;
                    }
                }
                else
                {
                    for (int j = 0; j < 30; ++ j)
                    {
                        odd[prv][j] = (odd[prv][j] + odd[u][j] * (br - cnt[j]) + even[u][j] * cnt[j]) % 2;
                        even[prv][j] = (even[prv][j] + odd[u][j] * cnt[j] + even[u][j] * (br - cnt[j])) % 2;
                    }
                    prv = v;
                    br = 1;
                    for (int j = 0; j < 30; ++ j)
                    {
                        cnt[j] = 0;
                        if (w & (1ll << j)) cnt[j]++;
                    }
                }
            }
            for (int j = 0; j < 30; ++ j)
            {
                odd[prv][j] = (odd[prv][j] + odd[u][j] * (br - cnt[j]) + even[u][j] * cnt[j]) % 2;
                even[prv][j] = (even[prv][j] + odd[u][j] * cnt[j] + even[u][j] * (br - cnt[j])) % 2;
            }
        }

        int ans = 0;
        for (int j = 0; j < 30; ++ j)
        {
            ans += (1ll << j) * odd[b][j];
        }
        cout << ans << endl;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
