#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

void solve() {
  int n, m;
  cin >> n >> m;
  vector<int> nxt(n);
  int all = 0;
  for (int i = 0; i < m; i++) {
    int u, v, c;
    cin >> u >> v >> c;
    --u, --v;
    nxt[i] = c;
    all ^= c;
  }

  int from, to;
  cin >> from >> to;
  --from, --to;

  if (from == to) {
    if (all == 0) {
      cout << 0 << '\n';
    } else {
      cout << -1 << '\n';
    }
  } else {
    int ab = 0;
    int x = from;
    while (x != to) {
      ab ^= nxt[x];
      (x += 1) %= n;
    }
    x = to;
    int ba = 0;
    while (x != from) {
      ba ^= nxt[x];
      (x += 1) %= n;
    }
    if (ab == 0 && ba == 0) {
      cout << ab << '\n';
    } else {
      cout << -1 << '\n';
    }
  }
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int tc;
  cin >> tc;
  while (tc --> 0) solve();
  return 0;
}