#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <cmath>

#define int long long

using namespace std;
struct node {
	int sm = 0;
	int ps = 0;
};
vector <int> tin;
vector <int> tout;
vector <vector <int> > g;
vector <pair <int,int> > otr;
int tm = 0;
int n;
vector <int> p;
vector <int> prs;
vector <int> hs;
vector <int> h;
vector <vector <int> > up;
vector <node> tree;
vector <int> cnt;
vector <vector <int> > cmp;
int md = 1e9 + 7;

void init() {
	hs.resize(n);
	tin.resize(n);
	tout.resize(n);
	g.resize(n);
	p.resize(n);
	h.resize(n);
	cnt.resize(n);
	up.resize(n, vector <int>(20));
}
mt19937 rnd(222311);
void dfs(int v, int hh, int pr) {
	tin[v] = tm++;
	h[v] = hh;
	up[v][0] = pr;
	for (int i = 1; i < 20; ++i) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}
	for (auto u : g[v]) {
		dfs(u, hh + 1, v);
	}
	tout[v] = tm++;
}

void push(int v, int l, int r) {
	if (tree[v].ps != 0 && r - l > 1) {
		tree[v * 2 + 1].sm += tree[v].ps;
		tree[v * 2 + 2].sm += tree[v].ps;
		tree[v * 2 + 1].sm %= md;
		tree[v * 2 + 2].sm %= md;
		tree[v * 2 + 1].ps += tree[v].ps;
		tree[v * 2 + 2].ps += tree[v].ps;
		tree[v * 2 + 1].ps %= md;
		tree[v * 2 + 2].ps %= md;
		tree[v].ps = 0;
	}
}

int sm(int v, int l, int r, int ql, int qr) {
	push(v, l, r);
	if (ql <= l && r <= qr) {
		return tree[v].sm;
	}
	if (r <= ql || l >= qr) {
		return 0;
	}
	int mid = (r + l) / 2;
	return (sm(v * 2 + 1, l, mid, ql, qr) + sm(v * 2 + 2, mid, r, ql, qr)) % md;
}

void upd(int v, int l, int r, int ql, int qr, int x) {

	push(v, l, r);
	if (ql <= l && r <= qr) {
		tree[v].sm += x;
		tree[v].ps += x;
		tree[v].sm %= md;
		tree[v].ps %= md;
		return;
	}
	if (r <= ql || l >= qr) {
		return;
	}
	int mid = (r + l) / 2;
	upd(v * 2 + 1, l, mid, ql, qr, x);
	upd(v * 2 + 2, mid, r, ql, qr, x);
	tree[v].sm = tree[v * 2 + 1].sm + tree[v * 2 + 2].sm;
	tree[v].sm %= md;
}

int getp(int pp) {
	if (p[pp] == pp) {
		return pp;
	}
	return p[pp] = getp(p[pp]);
}

int gths(int v) {
	return hs[getp(v)];
}


void un(int a, int b) {
	a = getp(a);
	b = getp(b);
	int l1 = otr[a].first, r1 = otr[a].second, l2 = otr[b].first, r2 = otr[b].second;
	p[a] = b;
	otr[b] = { max(l1, l2), min(r1, r2) };

}

bool pr(int a, int b) {
	return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int lca(int a, int b) {
	if (pr(a, b)) {
		return a;
	}
	if (pr(b, a)) {
		return b;
	}
	for (int i = 19; i >= 0; --i) {
		if (!pr(up[a][i], b)) {
			a = up[a][i];
		}
	}
	return up[a][0];
}

int cpr(int a, int ind) {
	int st = 1 << 19;
	for (int i = 19; i >= 0; i--) {
		if (st <= ind) {
			ind -= st;
			a = up[a][i];
		}
		st /= 2;
	}
	return a;
}

int gtsm(int v) {
	return sm(0, 0, 2 * n, tin[v], tin[v] + 1);
}
int ipt(int a, int b, int cnt) {
	int lc = lca(a, b);
	if (cnt <= h[a] - h[lc] + 1) {
		int e = cpr(a, cnt - 1);
		return e;
	}
	else {
		cnt -= h[a] - h[lc] + 1;
		int e = cpr(b, h[b] - h[lc] - cnt);
		return e;
	}
}


int sr(int a, int b, int c, int d) {
	for (int i = 1; ; ++i) {
		int p1 = ipt(a, b, i);
		int p2 = ipt(c, d, i);
		if (getp(p1) != getp(p2)) {
			return 0;
		}
		if (p1 == b) {
			return 1;
		}
	}
}



signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	set <int> cmps;
	init();
	for (int i = 0; i < n; ++i) {
		p[i] = i;
		cnt[i] = 1;
		cmps.insert(i);
	}
	for (int i = 0; i < n - 1; ++i) {
		int pi;
		cin >> pi;
		pi--;
		g[pi].push_back(i + 1);
	}
	int ans = 0;
	for (int i = 0; i < n; ++i) {
		int l, r;
		cin >> l >> r;
		ans *= (r - l + 1);
		ans %= md;
		otr.push_back({ l,r });

	}
	dfs(0, 0, 0);

	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {	
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		int lc1 = lca(a, b);
		int dl = h[a] - h[lc1] + h[b] - h[lc1] + 1;
		while (true) {
			int l = 0, r = dl + 1;
			while (r - l > 1) {
				int mid = (r + l) / 2;
				if (!sr(a, ipt(a,b,mid), c,ipt(c, d,mid))) {
					r = mid;
				}
				else {
					l = mid;
				}
			}
			if (l == dl) {
				break;
			}
			int p1 = ipt(a, b, l + 1);
			int p2 = ipt(c, d, l + 1);
			cmps.erase(getp(p1));
			un(p1, p2);
		}
		int an = 1;
		for (auto c : cmps){
			an *= max((int)0, otr[c].second - otr[c].first + 1);
			an %= md;
		}
		cout << an << "\n";

	}


}