#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const int mod = 1e9 + 7;
const ld eps = 1e-6;

vector<vector<int> > g;
vector<int> l, r, h, p;
vector<int> order1, order2;
vector<int> par, sz, mn_r, mx_l;

int dsu_get(int v) {
    return (v == par[v] ? v : par[v] = dsu_get(par[v]));
}

ll bin_pow(ll a, ll n) {
    if (n == 0) {
        return 1;
    }
    ll b = bin_pow(a, n / 2);
    if (n & 1) {
        return b * b % mod * a % mod;
    } else {
        return b * b % mod;
    }
}

void dfs(int v) {
    for (auto to : g[v]) {
        h[to] = h[v] + 1;
        p[to] = v;
        dfs(to);
    }
}

int lca(int a, int b) {
    if (h[a] < h[b]) swap(a, b);
    while (h[a] > h[b]) {
        a = p[a];
    }
    while (a != b) {
        cout << a << ' ' << b << endl;
        a = p[a];
        b = p[b];
    }
    return a;
}

void dfs2(int v, int finish, vector<int> &order) {
    while (1) {
        order.push_back(v);
        if (v == finish) {
            break;
        }
        v = p[v];
    }
}

void dfs3(int v, int finish, vector<int> &order) {
    if (v == finish) {
        return;
    }
    dfs3(p[v], finish, order);
    order.push_back(v);
}

int main() {
    int n;
    cin >> n;
    g.resize(n);
    p.resize(n);
    h.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    l.resize(n), r.resize(n);
    par.resize(n), sz.resize(n), mn_r.resize(n), mx_l.resize(n);
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans *= r[i] - l[i] + 1;
        ans %= mod;
    }
    for (int i = 0; i < n; i++) {
        par[i] = i;
        sz[i] = 1;
        mn_r[i] = r[i];
        mx_l[i] = l[i];
    }
    dfs(0);
    int m;
    cin >> m;
    cout << "OK\n";
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans == 0) {
            cout << ans << endl;
            continue;
        }
        order1.clear();
        order2.clear();
        a--, b--, c--, d--;
        int lca1 = lca(a, b), lca2 = lca(c, d);
        dfs2(a, lca1, order1);
        dfs3(b, lca1, order1);
        dfs2(c, lca2, order2);
        dfs3(d, lca2, order2);
        for (int j = 0; j < order1.size(); j++) {
            int u = dsu_get(order1[j]), v = dsu_get(order2[j]);
            if (u == v) {
                continue;
            }
            if (max(mx_l[u], mx_l[v]) > min(mn_r[u], mn_r[v])) {
                ans = 0;
                break;
            }
            ans *= bin_pow(mn_r[u] - mx_l[u] + 1, mod - 2);
            ans %= mod;
            ans *= bin_pow(mn_r[v] - mx_l[v] + 1, mod - 2);
            ans %= mod;
            if (sz[u] < sz[v]) swap(u, v);
            sz[u] += sz[v];
            par[v] = u;
            mx_l[u] = max(mx_l[u], mx_l[v]);
            mn_r[u] = min(mn_r[u], mn_r[v]);
            ans *= mn_r[u] - mx_l[u] + 1;
            ans %= mod;
        }
        cout << ans << endl;
    }
    return 0;
}