#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9;
const int mod = 1e9 + 7;
const ld eps = 1e-6;
const ll b = 200001;

vector<vector<int> > g;
vector<int> l, r, h, p;
vector<ll> par, sz, mn_r, mx_l;
vector<vector<int> > st;
vector<ll> p_pow;

struct segtree{
    vector<ll> t, rev_t;
    int sz_t;
    void build(int v, int tl, int tr, vector<ll> &a) {
        if (tr - tl == 1) {
            t[v] = a[tl];
            rev_t[v] = a[tl];
            return;
        }
        build(v * 2, tl, (tl + tr) / 2, a);
        build(v * 2 + 1, (tl + tr) / 2, tr, a);
        t[v] = t[v * 2] + t[v * 2 + 1] * p_pow[(tl + tr) / 2 - tl];
        rev_t[v] = t[v * 2] * p_pow[tr - (tl + tr) / 2] + rev_t[v * 2 + 1];
        rev_t[v] %= mod;
        t[v] %= mod;
    }
    void build(vector<ll> &a) {
        t.resize(4 * a.size());
        rev_t.resize(4 * a.size());
        sz_t = a.size();
        build(1, 0, sz_t, a);
    }
    void upd(int v, int tl, int tr, int pos, int x) {
        if (tr - tl == 1) {
            t[v] = x;
            rev_t[v] = x;
            return;
        }
        if (pos < (tl + tr) / 2) {
            upd(v * 2, tl, (tl + tr) / 2, pos, x);
        } else {
            upd(v * 2 + 1, (tl + tr) / 2, tr, pos, x);
        }
        t[v] = t[v * 2] + t[v * 2 + 1] * p_pow[(tl + tr) / 2 - tl];
        rev_t[v] = t[v * 2] * p_pow[tr - (tl + tr) / 2] + rev_t[v * 2 + 1];
        rev_t[v] %= mod;
        t[v] %= mod;
    }
    void upd(int pos, int x) {
        upd(1, 0, sz_t, pos, x);
    }
    pair<ll, int> get_hash(int v, int tl, int tr, int l, int r, int add = 0) {
        if (l <= tl && tr <= r) {
            return {t[v] * p_pow[add], tr - tl + add};
        }
        if (max(l, tl) >= min(r, tr)) {
            return {0, 0};
        }
        auto t1 = get_hash(v * 2, tl, (tl + tr) / 2, l, r, add);
        auto t2 = get_hash(v * 2 + 1, (tl + tr) / 2, tr, l, r, add + t1.second);
        return {t1.first + t2.first, t2.second};
    }
    ll get_hash(int l, int r) {
        return get_hash(1, 0, sz_t, l, r + 1).first;
    }
    pair<ll, int> get_rev_hash(int v, int tl, int tr, int l, int r, int add = 0) {
        if (l <= tl && tr <= r) {
            return {rev_t[v] * p_pow[add], tr - tl + add};
        }
        if (max(l, tl) >= min(r, tr)) {
            return {0, 0};
        }
        auto t1 = get_rev_hash(v * 2 + 1, (tl + tr) / 2, tr, l, r, add);
        auto t2 = get_rev_hash(v * 2, tl, (tl + tr) / 2, l, r, add + t1.second);
        return {t1.first + t2.first, t2.second};
    }
    ll get_rev_hash(int l, int r) {
        return get_rev_hash(1, 0, sz_t, l, r + 1, 0).first;
    }
};

int dsu_get(int v) {
    return (v == par[v] ? v : par[v] = dsu_get(par[v]));
}

ll bin_pow(ll a, ll n) {
    if (n == 0) {
        return 1;
    }
    ll b = bin_pow(a, n / 2);
    if (n & 1) {
        return b * b % mod * a % mod;
    } else {
        return b * b % mod;
    }
}

int main() {
    int n;
    cin >> n;
    g.resize(n);
    p.resize(n);
    h.resize(n);
    st.resize(n);
    p_pow.resize(500000);
    p_pow[0] = 1;
    for (int i = 1; i < 500000; i++) {
        p_pow[i] = p_pow[i - 1] * b;
        p_pow[i] %= mod;
    }
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
    }
    l.resize(n), r.resize(n);
    par.resize(n), sz.resize(n), mn_r.resize(n), mx_l.resize(n);
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans *= r[i] - l[i] + 1;
        ans %= mod;
    }
    for (int i = 0; i < n; i++) {
        par[i] = i;
        sz[i] = 1;
        st[i] = {i};
        mn_r[i] = r[i];
        mx_l[i] = l[i];
    }
    segtree t;
    t.build(par);
    int m;
    cin >> m;
    for (int test = 0; test < m; test++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans == 0) {
            cout << ans << endl;
            continue;
        }
        a--, b--, c--, d--;
        bool f1 = (a <= b);
        while ((f1 ? a <= b : a >= b)) {
            int l = 0, r = max(a, b) - min(a, b) + 2;
            while (r - l > 1) {
                int m = (l + r) / 2;
                ll h1, h2;
                if (a <= b) {
                    if (a + m - 1 >= n) {
                        return 0;
                    }
                    h1 = t.get_hash(a, a + m - 1);
                } else {
                    if (a - m + 1 < 0) {
                        return 0;
                    }
                    h1 = t.get_rev_hash(a - m + 1, a);
                }
                if (c <= d) {
                    if (c + m - 1 >= n) {
                        return 0;
                    }
                    h2 = t.get_hash(c, c + m - 1);
                } else {
                    if (c - m + 1 < 0) {
                        return 0;
                    }
                    h2 = t.get_rev_hash(c - m + 1, c);
                }
                if (h1 == h2) {
                    l = m;
                } else {
                    r = m;
                }
            }
            if (l == max(a, b) - min(a, b) + 1) {
                break;
            }
            int u = (a <= b ? a + l : a - l), v = (c <= d ? c + l : c - l);
            if (u < 0 || u >= n || v < 0 || v >= n) {
                return 0;
            }
            u = dsu_get(u), v = dsu_get(v);
            if (u < 0 || u >= n || v < 0 || v >= n) {
                return 0;
            }
            if (max(mx_l[u], mx_l[v]) > min(mn_r[u], mn_r[v])) {
                ans = 0;
                break;
            }
            ans *= bin_pow(mn_r[u] - mx_l[u] + 1, mod - 2);
            ans %= mod;
            ans *= bin_pow(mn_r[v] - mx_l[v] + 1, mod - 2);
            ans %= mod;
            if (sz[u] < sz[v]) swap(u, v);
            sz[u] += sz[v];
            for (int i = 0; i < st[v].size(); i++) {
                par[st[v][i]] = u;
                t.upd(st[v][i], u);
            }
            st[v].clear();
            mx_l[u] = max(mx_l[u], mx_l[v]);
            mn_r[u] = min(mn_r[u], mn_r[v]);
            ans *= mn_r[u] - mx_l[u] + 1;
            ans %= mod;
            a = (a <= b ? a + l + 1 : a - l - 1);
            c = (c <= d ? c + l + 1 : c - l - 1);
        }
        cout << ans << endl;
    }
    return 0;
}