#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>
#include <numeric>

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = int;
using ld = long double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

ll sum(ll a, ll b) {
	a += b;
	if (a >= Mod) return a - Mod;
	return a;
}

ll sub(ll a, ll b) {
	a -= b;
	if (a < 0) return a + Mod;
	return a;
}

ll mul(ll a, ll b) {
	return ((long long)a * b) % Mod;
}

ll binpow(ll a, ll n) {
	ll ans = 1;
	while (n) {
		if (n & 1) {
			ans = mul(ans, a);
		}
		a = mul(a, a);
		n = n >> 1;
	}
	return ans;
}

ll divm(ll a, ll b) {
	return mul(a, binpow(b, Mod - 2));
}

struct dsu {
	v<ll> p, size;
	v<pll> ed;

	dsu(v<pll>& list) {
		ll n = list.size();
		p.resize(n);
		size.assign(n, 1);
		ed = list;
		std::iota(all(p), 0);
	}

	ll get(ll a) {
		if (p[a] == a) return a;
		return p[a] = get(p[a]);
	}

	pll getEd(ll a) {
		a = get(a);
		return ed[a];
	}

	bool un(ll a, ll b) {
		a = get(a);
		b = get(b);
		if (a == b) return 0;
		if (size[a] < size[b]) {
			std::swap(a, b);
		}
		size[a] += size[b];
		p[b] = a;
		pll now = { std::max(ed[a].first, ed[b].first), std::min(ed[a].second, ed[b].second) };
		if (now.first > now.second) now = { -1, -1 };
		ed[a] = now;
		return 1;
	}
};

v<ll> dist;

v<ll> find(v<ll>& p, ll a, ll b) {
	v<ll> bp, ans;
	while (a != b) {
		if (dist[a] > dist[b]) {
			ans.push_back(a);
			a = p[a];
		}
		else {
			bp.push_back(b);
			b = p[b];
		}
	}
	ans.push_back(a);
	while (!bp.empty()) {
		ans.push_back(bp.back());
		bp.pop_back();
	}
	return ans;
}

void countD(v<v<ll>>& gr, ll i, ll d) {
	dist[i] = d;
	for (auto j : gr[i]) {
		countD(gr, j, d + 1);
	}
}


void solve() {
	ll n;
	std::cin >> n;
	v<ll> p(n);
	v<v<ll>> gr(n);
	for (int i = 1; i < n; ++i) {
		ll now;
		std::cin >> now;
		--now;
		gr[now].push_back(i);
		p[i] = now;
	}
	v<pll> list(n);
	ll ans = 1;
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i].first >> list[i].second;
		ans = mul(ans, list[i].second - list[i].first + 1);
	}
	dist.assign(n, 0);
	countD(gr, 0, 0);
	dsu ch(list);
	ll m;
	std::cin >> m;
	for (int i = 0; i < m; ++i) {
		ll a, b, c, d;
		std::cin >> a >> b >> c >> d;
		--a, --b, --c, --d;
		v<ll> f = find(p, a, b);
		v<ll> s = find(p, c, d);
		for (int j = 0; j < f.size(); ++j) {
			pll nowf = ch.getEd(f[j]), nows = ch.getEd(s[j]);
			if (ch.un(f[j], s[j]) && ans != 0) {
				pll now = ch.getEd(f[j]);
				ans = divm(ans, nowf.second - nowf.first + 1);
				ans = divm(ans, nows.second - nows.first + 1);
				if (now.first != -1) {
					ans = mul(ans, now.second - now.first + 1);
				}
				else {
					ans = 0;
				}
			}
		}
		std::cout << ans << '\n';
	}
}

int main() {	
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}