#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

const int MAXN = 2e5;
const long long MOD = 1e9 + 7;

int n;
int par[MAXN];
vector<int> g[MAXN];

void clear() {
    for (int i = 0; i < n; ++i) {
        g[i].clear();
    }
}

int tin[MAXN], tout[MAXN];
int tt = -1;

void dfs(int v) {
    ++tt;
    tin[v] = tt;
    for (auto u : g[v]) {
        dfs(u);
    }
    ++tt;
    tout[v] = tt;
}

int lb[MAXN], rb[MAXN];
long long ans;

vector<int> get_path(int a, int b) {
    vector<int> path;
    int tin1 = min(tin[a], tin[b]);
    int tout1 = max(tout[a], tout[b]);
    while (true) {
        if (tin[a] <= tin1 && tout[a] >= tout1) break;
        path.push_back(a);
        a = par[a];
    }
    path.push_back(a);
    vector<int> pa;
    while (true) {
        if (tin[b] <= tin1 && tout[b] >= tout1) break;
        pa.push_back(b);
        b = par[b];
    }
    reverse(pa.begin(), pa.end());
    for (auto i : pa) {
        path.push_back(i);
    }
    return path;
}

int p_dsu[MAXN], sz[MAXN];

void init() {
    for (int i = 0; i < n; ++i) {
        p_dsu[i] = i;
        sz[i] = 1;
    }
}

int comp(int a) {
    if (p_dsu[a] == a) {
        return a;
    }
    p_dsu[a] = comp(p_dsu[a]);
    return p_dsu[a];
}

long long binpow(long long a, int n) {
    if (n == 0) return 1;
    long long h = binpow(a, n / 2);
    long long ans = h * h % MOD;
    if (n&1) {
        ans = ans * a % MOD;
    }
    return ans;
}

void div(int x) {
    if (x <= 0) return;
    ans = ans * binpow(x, MOD - 2) % MOD;
}

void mul(int x) {
    x = max(x, 0);
    ans = ans * x % MOD;
}

void unite(int a, int b) {
    a = comp(a);
    b = comp(b);
    if (a == b) return;
    if (sz[a] < sz[b]) swap(a, b);
    div(rb[a] - lb[a] + 1);
    div(rb[b] - lb[b] + 1);
    p_dsu[b] = a;
    sz[a] += sz[b];
    lb[a] = max(lb[a], lb[b]);
    rb[a] = min(rb[a], rb[b]);
    mul(rb[a] - lb[a] + 1);
}

void solve() {
    clear();
    par[0] = -1;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        par[i] = p;
        g[p].push_back(i);
    }
    tt = -1;
    dfs(0);
    ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> lb[i] >> rb[i];
        ans = ans * (long long)(rb[i] - lb[i] + 1) % MOD;
    }
    init();
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        vector<int> path1 = get_path(a, b);
        vector<int> path2 = get_path(c, d);
        int k = path1.size();
        for (int i = 0; i < k; ++i) {
            unite(path1[i], path2[i]);
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    while (cin >> n) {
        solve();
        cout << "\n";
    }
}
