#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 7;
const ld eps = 1e-9;
ll t = 0;

vector<ll> tin;
vector<ll> tout;
vector<ll> par;

void dfs(ll v, ll par, vector<vector<ll>>& gr) {
	tin[v] = t; t++;
	for (auto& it : gr[v]) {
		if (it == par) continue;
		dfs(it, v, gr);
	}
	tout[v] = t; t++;
}

void up(ll v, vector<ll>& way, ll end) {
	way.push_back(v);
	if (tin[v] <= tin[end] && tout[end] <= tout[v]) return;
	up(par[v], way, end);
}

pair<pair<ll, ll>, ll> DFS(vector<vector<ll>>& gr, vector<ll>& used, vector<pair<ll, ll>>& lr, ll v, ll t) {
	used[v] = t;
	pair<ll, ll> need = lr[v];
	ll cnt = 0;
	for (auto& it : gr[v]) {
		if (used[it] == t) continue;
		auto it1 = DFS(gr, used, lr, it, t);
		need.first = max(need.first, it1.first.first);
		need.second = min(need.second, it1.first.second);
		cnt += it1.second;
	}
	return { need, cnt + 1 };
}

ll fast_pow(ll num, ll pows) {
	if (num <= 0) return 0;
	if (pows == 0) return 1;
	if (pows % 2 == 0) {
		ll a = fast_pow(num, pows / 2);
		return (a * a) % INF;
	}
	return (fast_pow(num, pows - 1) * num) % INF;
}


signed main() {
	ll n; cin >> n;
	tin.resize(n);
	tout.resize(n);
	vector<vector<ll>> gr(n);
	par.resize(n);
	for (ll x = 1; x < n; x++) {
		ll p; cin >> p; p--;
		gr[p].push_back(x);
		par[x] = p;
	}
	vector<vector<ll>> newgr(n);
	vector<pair<ll, ll>> lr(n);
	for (auto& it : lr) cin >> it.first >> it.second;
	dfs(0, -1, gr);
	ll m; cin >> m;
	vector<ll> used(n, -1);
	for (ll x = 0; x < m; x++) {
		ll a, b, c, d; cin >> a >> b >> c >> d; a--; b--; c--; d--;
		vector<ll> fir_part1;
		vector<ll> sec_part1;
		vector<ll> fir_part2;
		vector<ll> sec_part2;
		up(a, fir_part1, b);
		up(b, sec_part1, a);
		up(c, fir_part2, d);
		up(d, sec_part2, c);
		reverse(sec_part1.begin(), sec_part1.end());
		reverse(sec_part2.begin(), sec_part2.end());
		fir_part1.pop_back();
		fir_part2.pop_back();
		for (auto& it : sec_part1) fir_part1.push_back(it);
		for (auto& it : sec_part2) fir_part2.push_back(it);
		for (ll i = 0; i < fir_part1.size(); i++) {
			newgr[fir_part1[i]].push_back(fir_part2[i]);
			newgr[fir_part2[i]].push_back(fir_part1[i]);
		}
		ll ans = 1;
		for (ll i = 0; i < n; i++) {
			if (used[i] != x) {
				auto it = DFS(newgr, used, lr, i, x);
				ll num = it.first.second - it.first.first + 1;
				ll pows = it.second;
				ans *= max(0ll, num);
				ans %= INF;
			}
		}
		cout << ans << endl;
	}
};