#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

struct dsu {
    vector<int> p;
    vector<pair<int, int>> bounds;

    void init(vector<pair<int, int>>& a) {
        p.resize(a.size());
        iota(p.begin(), p.end(), 0);
        bounds = a;
    }

    int get_root(int v) {
        if (p[v] == v)
            return v;
        return p[v] = get_root(p[v]);
    }

    void merge(int u, int v) {
        u = p[u];
        v = p[v];
        p[v] = u;
        bounds[u].first = min(bounds[u].first, bounds[v].first);
        bounds[u].second = min(bounds[u].second, bounds[v].second);
    }
};

void calc_depth(int u, int now, vector<vector<int>>& g, vector<int>& depth) {
    depth[u] = now;
    for (auto& v : g[u]) {
        calc_depth(v, now + 1, g, depth);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<int> p(n);
    vector<vector<int>> g(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    vector<int> depth(n);
    calc_depth(0, 0, g, depth);
    vector<pair<int, int>> bnds(n);
    for (int i = 0; i < n; ++i) {
        cin >> bnds[i].first >> bnds[i].second;
    }
    dsu ds;
    ds.init(bnds);
    int m;
    cin >> m;
    for (int i = 0; i < n; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        if (depth[a] < depth[b])
            swap(a, b);
        if (depth[c] < depth[d])
            swap(c, d);
        while (a != b) {
            ds.merge(a, c);
            a = p[a];
            c = p[c];
        }
        set<int> s;
        for (int j = 0; j < n; ++j) {
            s.insert(ds.get_root(j));
        }
        int ans = 1;
        for (auto& v : s) {
            ans *= max(ds.bounds[v].second - ds.bounds[v].first, 0ll);
            ans %= 1000000007;
        }
        cout << ans << '\n';
    }
}


signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}