#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define endl '\n'
#define len(a) (int)a.size()
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const ll MOD = 1000000007;
const int MAXI = 1e9 + 1e7;

const int MAXN = 2e5 + 100, LOGN = 19;
vector<int> g[MAXN];
int tin[MAXN], tout[MAXN], d[MAXN], go[MAXN][LOGN + 1];
int path[2][MAXN];
int timer = 0;

void fill_path(int *a, int pos, int inc, int u, int c, bool flag) {
    while (true) {
        if (u == c && flag) break;
        a[pos] = u;
        if (u == c) break;
        u = go[u][0];
        pos += inc;
    }
}

void dfs(int u, int p = 0) {
    tin[u] = timer++;
    d[u] = d[p] + 1;
    go[u][0] = p;
    for (int i = 1; i <= LOGN; i++)
        go[u][i] = go[go[u][i - 1]][i - 1];
    for (int v : g[u]) {
        if (v != p)
            dfs(v, u);
    }
    tout[u] = timer - 1;
}

bool is_ancestor(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca(int u, int v) {
    if (is_ancestor(u, v))
        return u;
    if (is_ancestor(v, u))
        return v;
    for (int i = LOGN; i >= 0; i--) {
        if (!is_ancestor(go[v][i], u))
            v = go[v][i];
    }
    return go[v][0];
}

int dsu_p[MAXN], sz[MAXN], max_l[MAXN], min_r[MAXN];
vector<int> in[MAXN];

void hang(int from, int to) {
    sz[to] += sz[from];
    for (int v : in[from]) {
        in[to].push_back(v);
        dsu_p[v] = to;
    }
    in[to].push_back(from);
    dsu_p[from] = to;
}

void join(int a, int b) {
    a = dsu_p[a], b = dsu_p[b];
    int ml = max(max_l[a], max_l[b]);
    int mr = min(min_r[a], min_r[b]);

    if (sz[a] > sz[b])
        swap(a, b);
    hang(a, b);
    max_l[b] = ml, min_r[b] = mr;
}

ll fp(ll a, ll n) {
    if (n == 0)
        return 1;
    ll x = fp(a, n / 2);
    if (n % 2)
        return x * x % MOD * a % MOD;
    return x * x % MOD;
}

int main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        g[x - 1].push_back(i);
        g[i].push_back(x - 1);
    }
    ll ans = 1;
    for (int i = 0; i < n; i++) {
        cin >> max_l[i] >> min_r[i];
        ans = ans * (min_r[i] - max_l[i] + 1) % MOD;
        sz[i] = 1;
        dsu_p[i] = i;
    }
    dfs(0);
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        if (ans == 0)
            cout << 0 << endl;
        else {
            int u, v, x, y;
            cin >> u >> v >> x >> y;
            u--, v--, x--, y--;
            int c1 = lca(u, v), c2 = lca(x, y);
            int length = d[u] - d[c1] + 1 + d[v] - d[c1];
            fill_path(path[0], 0, 1, u, c1, false);
            fill_path(path[0], length - 1, -1, v, c1, true);
            fill_path(path[1], 0, 1, x, c2, false);
            fill_path(path[1], length - 1, -1, y, c2, true);
            ll prev_res = 1, now_res = 1;
            for (int j = 0; j < length; j++) {
                int a = dsu_p[path[0][j]], b = dsu_p[path[1][j]];
                if (a != b) {
                    prev_res = prev_res * (min_r[a] - max_l[a] + 1) % MOD * (min_r[b] - max_l[b] + 1) % MOD;
                    int ml = max(max_l[a], max_l[b]);
                    int mr = min(min_r[a], min_r[b]);
                    join(a, b);
                    if (ml > mr)
                        now_res = 0;
                    else
                        now_res = now_res * (mr - ml + 1) % MOD;
                }
            }
            ans = ans * fp(prev_res, MOD - 2) % MOD * now_res % MOD;
            cout << ans << endl;
        }
    }
}