#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<algorithm>
using namespace std;

long long mod = 1'000'000'007;

vector<int> parent, rankk, leftp, rightp;
int get_set(int v) {
    if (v == parent[v])
        return v;
    return parent[v] = get_set(parent[v]);
}

void make_set(int v, int l, int r) {
    parent[v] = v;
    rankk[v] = 0;
    leftp[v] = l;
    rightp[v] = r;
}

void union_sets(int v, int u) {
    u = get_set(u);
    v = get_set(v);

    if (u != v) {
        if (rankk[u] < rankk[v])
            swap(u, v);
        parent[v] = u;
        if (rankk[u] == rankk[v])
            rankk[u]++;

        leftp[u] = max(leftp[u], leftp[v]);
        rightp[u] = min(rightp[u], rightp[v]);
    }
}

vector<int> logg;
void calc() {
    logg.resize(200001);
    logg[1] = 1;
    for (int i = 2; i <= logg.size(); i++)
        logg[i] = logg[(i + 1) / 2] + 1;
}

int timer = 0;
vector<int> visit, tin, tout;
vector<vector<int>> g, up;

void dfs(int v) {
    visit[v] = 1;
    tin[v] = ++timer;
    for (int i = 1; i < up[0].size(); i++)
        up[v][i] = up[up[v][i - 1]][i - 1];

    for (auto u : g[v]) {
        if (!visit[u]) {
            up[u][0] = v;
            dfs(u);
        }
    }

    tout[v] = ++timer;
}

bool ancestor(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca(int u, int v) {
    if (ancestor(u, v)) return u;
    if (ancestor(v, u)) return v;

    for (int i = up[0].size() - 1; i >= 0; i--) {
        if (!ancestor(up[u][i], v))
            u = up[u][i];
    }

    return up[u][0];
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    calc();

    int n;
    cin >> n;

    g.resize(n);
    for (int i = 1; i < n; i++) {
        int a;
        cin >> a;
        g[a - 1].push_back(i);
    }

    vector<pair<int, int>> vp(n);
    for (int i = 0; i < n; i++)
        cin >> vp[i].first >> vp[i].second;

    visit.resize(n);
    tout.resize(n);
    tin.resize(n);
    up.assign(n, vector<int>(logg[n] + 1));
    up[0][0] = 0;
    dfs(0);

    parent.resize(n);
    rankk.resize(n);
    leftp.resize(n);
    rightp.resize(n);
    for (int i = 0; i < n; i++)
        make_set(i, vp[i].first, vp[i].second);

    int q;
    cin >> q;

    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; c--;
        b--; d--;

        int lca1 = lca(a, b), lca2 = lca(c, d);

        vector<int> pab, pab2;
        while (a != lca1) {
            pab.push_back(a);
            a = up[a][0];
        }
        pab.push_back(lca1);
        while (b != lca1) {
            pab2.push_back(b);
            b = up[b][0];
        }
        for (int i = (int)pab2.size() - 1; i >= 0; i--)
            pab.push_back(pab2[i]);

        vector<int> pcd, pcd2;
        while (c != lca2) {
            pcd.push_back(c);
            c = up[c][0];
        }
        pcd.push_back(lca2);
        while (d != lca2) {
            pcd2.push_back(d);
            d = up[d][0];
        }
        for (int i = (int)pcd2.size() - 1; i >= 0; i--)
            pcd.push_back(pcd2[i]);

        vector<vector<int>> p;
        for (int i = 0; i < pab.size(); i++)
            union_sets(pab[i], pcd[i]);

        long long ans = 1;
        set<int> used;
        for (int i = 0; i < n; i++) {
            int findpar = get_set(i);
            if (used.find(findpar) == used.end()) {
                used.insert(findpar);
                ans = ans * (long long)(max(0, rightp[findpar] - leftp[findpar] + 1)) % mod;
            }
        }

        cout << ans << '\n';
    }

    return 0;
}
