#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back
//#define int long long

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

const int q = 19;

vector<vector<int>> jump(0);
vector<int> l(0);
vector<int> r(0);
vector<int> lv(0);
vector<vector<int>> g(0);
vector<int> p(0);

void dfs (int now, int pred) {
    if (pred == -1) {
        lv[now] = 0;
    } else {
        lv[now] = lv[pred] + 1;
    }
    for (auto j : g[now])
        dfs(j, now);
}

int pow2[q + 1];
int get_lca (int a, int b) {
    if (lv[a] < lv[b])
        swap(a, b);
    int cnt = lv[a] - lv[b];
    for (int i = q - 1; i >= 0; i--) {
        if (pow2[i] <= cnt) {
            cnt -= pow2[i];
            a = jump[a][i];
        }
    }
    if (a == b)
        return a;
    for (int i = q - 1; i >= 0; i--) {
        if (jump[a][i] != jump[b][i]) {
            a = jump[a][i];
            b = jump[b][i];
        }
    }
    return jump[a][0];
}

const ll mod = 1e9 + 7;

vector<int> sz(0);

int get_pred (int now) {
    if (p[now] == now) {
        return now;
    }
    p[now] = get_pred(p[now]);
    return p[now];
}

long long bin_pow (ll a, ll n) {
    if (a <= 0)
        return 0;
    if (n == 1) {
        return a;
    } else if (n == 0)
        return 1;
    if (n % 2) {
        return (a * bin_pow(a, n - 1)) % ll(mod);
    } else {
        ll b = bin_pow(a, n / 2);
        return (b * b) % ll(mod);
    }
}

signed main() {
    pow2[0] = 1;
    for (int i = 1; i <= q; i++)
        pow2[i] = pow2[i - 1] * 2;
    ios::sync_with_stdio(false);
    cin.tie(0);
    int n;
    cin >> n;
    sz.assign(n, 1);
    l.resize(n);
    r.resize(n);
    jump.resize(n);
    g.resize(n);
    lv.resize(n);
    for (int i  = 0; i < n; i++) {
        jump[i].resize(q);
    }
    for (int i = 1; i < n; i++) {
        int pi;
        cin >> pi;
        jump[i][0] = pi - 1;
        g[pi - 1].pb(i);
    }
    dfs(0, -1);
    jump[0][0] = 0;
    for (int i = 1; i < q; i++) {
        for (int j = 0; j < n; j++) {
            jump[j][i] = jump[jump[j][i - 1]][i - 1];
        }
    }
    p.resize(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    int m;
    cin >> m;
    long long ANS = 1;
    for (int i = 0; i < n; i++) {
        ANS = (ANS * ll(r[i] - l[i] + 1)) % ll(mod);
    }
   // cout << ANS << endl;
    for (int i = 0; i < m; i++) {
        int ai, bi, ci, di;
        cin >> ai >> bi >> ci >> di;
        ai--; bi--;
        ci--; di--;
        vector<int> way1, way2;
        int lca1 = get_lca(ai, bi);
        int lca2 = get_lca(ci, di);
        while (ai != lca1) {
            way1.pb(ai);
            ai = jump[ai][0];
        }
        stack<int> s1;
        while (bi != lca1) {
            s1.push(bi);
            bi = jump[bi][0];
        }
        way1.pb(lca1);
        while (!s1.empty()) {
            way1.pb(s1.top());
            s1.pop();
        }
        while (ci != lca2) {
            way2.pb(ci);
            ci = jump[ci][0];
        }
        while (di != lca2) {
            s1.push(di);
            di = jump[di][0];
        }
        way2.pb(lca2);
        while (!s1.empty()) {
            way2.pb(s1.top());
            s1.pop();
        }

        for (int j = 0; j < way1.size(); j++) {
            int a, b;
            a = way1[j]; b = way2[j];
            int p_a = get_pred(a);
            int p_b = get_pred(b);
            if (p_a == p_b) {
                continue;
            }

            if (sz[p_a] < sz[p_b]) {

                int del = r[p_b] - l[p_b] + 1;
                p[p_a] = p_b;
                sz[p_b] += sz[p_a];
                l[p_b] = max(l[p_b], l[p_a]);
                r[p_b] = min(r[p_b], r[p_a]);
                ANS *= bin_pow(del, mod - 2);
                ANS %= mod;
                ANS *= bin_pow(r[p_a] - l[p_a] + 1, mod - 2);
                //cout << ANS << endl;
                ANS = ((ANS % ll(mod)) * bin_pow(r[p_b] - l[p_b] + 1, 1)) % ll(mod);
            } else {
                int del = r[p_a] - l[p_a] + 1;
                p[p_b] = p_a;
                sz[p_a] += sz[p_b];
                l[p_a] = max(l[p_b], l[p_a]);
                r[p_a] = min(r[p_b], r[p_a]);
                ANS *= bin_pow(del, mod - 2);
                ANS %= mod;
                ANS *= bin_pow(r[p_b] - l[p_b] + 1, mod - 2);
                ANS = ((ANS % ll(mod)) * bin_pow(r[p_a] - l[p_a] + 1, 1)) % ll(mod);
            }
        }
        cout << ANS << '\n';

    }


    return 0;
}