#include <iostream>
#include <vector>
#include <algorithm>


#pragma GCC optimize "Og"

using namespace std;
typedef uint64_t ull;
typedef uint32_t uint;
int n;
vector<vector<int>> a;
vector<int> p;
vector<int> d;
vector<int> sz;
vector<int> gord;
int gordp = 0;
vector<int> gnum;
vector<int> cs;
vector<int> stac;
vector<int> hp;
vector<vector<int>> grv;
vector<pair<int, int>> clr;
constexpr int K = 20;
vector<vector<int>> binups(K);
constexpr int TREES = 400000;
constexpr ull MOD = 1000*1000*1000+7;
ull tree[TREES];
ull mtree[TREES];
constexpr ull HMOD = MOD;
constexpr ull mul = 2000107;
constexpr ull ad = 19;
ull mpow[200100];
uint cf = 0;
ull cacc = 1;
template<ull M> ull bpow(ull x, ull y) {
    ull rs = 1;
    for (ull i = 1; i <= y; i <<= 1) {
        if (i & y) rs = rs * x % M;
        x = x * x % M;
    }
    return rs;
}
void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = 0;
        return;
    }
    int m = (l + r) >> 1;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
}
void mbuild(int v, int l, int r) {
    if (l + 1 == r) {
        mtree[v] = 0;
        return;
    }
    int m = (l + r) >> 1;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
}

template<ull M> ull qmod(ull x) {
    return (x < M ? x : x - M);
}
ull query(int v, int l, int r, int ql, int qr) {
    if (ql >= qr) return 0;
    if (ql == l && r == qr) {
        return tree[v];
    }
    int m = (l + r) >> 1;

    int r1 = min(m, r);
    int l2 = max(l, m);
    ull h1 = query(2 * v + 1, l, m, ql, r1);
    ull h2 = query(2 * v + 2, m, r, l2, qr);
    return qmod<HMOD>(h1 + h2 * mpow[m - min(ql, m)] % HMOD);
}
ull mquery(int v, int l, int r, int ql, int qr) {
    if (ql >= qr) return 0;
    if (ql == l && r == qr) {
        return mtree[v];
    }
    int m = (l + r) >> 1;

    int r1 = min(m, r);
    int l2 = max(l, m);
    ull h1 = mquery(2 * v + 1, l, m, ql, r1);
    ull h2 = mquery(2 * v + 2, m, r, l2, qr);
    return qmod<HMOD>(h1 + h2 * mpow[m - min(ql, m)] % HMOD);
}

void st(int v, int l, int r, int qx, ull df) {
    if (qx < l || r <= qx) return;
    if (l + 1 == r) {
        tree[v] = qmod<HMOD>(tree[v] + df);
        return;
    }
    int m = (l + r) >> 1;
    st(2 * v + 1, l, m, qx, df);
    st(2 * v + 2, m, r, qx, df);
    tree[v] = qmod<HMOD>(tree[v] + df * mpow[qx - l] % HMOD);
}

void mst(int v, int l, int r, int qx, ull df) {
    if (qx < l || r <= qx) return;
    if (l + 1 == r) {
        mtree[v] = qmod<HMOD>(mtree[v] + df);
        return;
    }
    int m = (l + r) >> 1;
    mst(2 * v + 1, l, m, qx, df);
    mst(2 * v + 2, m, r, qx, df);
    mtree[v] = qmod<HMOD>(mtree[v] + df * mpow[qx - l] % HMOD);
}

int lca(int u, int v) {
    if (d[u] < d[v]) swap(u, v);
    int df = d[u] - d[v];
    for (int i = 0; (1 << i) <= df; i <<= 1) {
        if (df & (1 << i)) {
            df ^= (1 << i);
            u = binups[i][u];
        }
    }
    if (u == v) return u;
    for (int i = K; i--;) {
        if (binups[i][u] != binups[i][v]) {
            u = binups[i][u];
            v = binups[i][v];
        }
    }
    return p[u];
}

void mg(int g1, int g2) {
    if (g1 == g2) return;
    if (stac[g1] > stac[g2]) swap(g1, g2);
    int nl = max(clr[g1].first, clr[g2].first);
    int nr = min(clr[g1].second, clr[g2].second);
    if (nr - nl + 1 < 0) nr = nl - 1;
    for (int g : {g1, g2}) {
        bool m1 = (clr[g].second - clr[g].first + 1 == MOD);
        ull v1 = (m1 ? 1 : (ull)(clr[g].second - clr[g].first + 1));
        v1 = bpow<MOD>(v1, MOD-2);
        cacc = cacc * v1 % MOD;
        if (m1) cf -= stac[g];
    }
    for (int x : grv[g1]) {
        grv[g2].push_back(x);
        cs[x] = g2;
        st(0, 0, n, x, qmod<MOD>(g2 + MOD - g1));
        mst(0, 0, n, n-x-1, qmod<MOD>(g2 + MOD - g1));
    }
    grv[g1].clear();
    stac[g2] += stac[g1];
    stac[g1] = 0;
    clr[g2] = make_pair(nl, nr);
    {
        int g = g2;

        bool m1 = (clr[g].second - clr[g].first + 1 == MOD);
        ull v1 = (m1 ? 1 : (ull)(clr[g].second - clr[g].first + 1));
        cacc = cacc * v1  % MOD;
        if (m1) cf += stac[g];
    }

}



int main() {
    mpow[0] = 1;
    for (int i = 1; i < 200100; ++i) mpow[i] = mpow[i - 1] * mul % MOD;
    cin >> n;
    a.resize(n);
    p.resize(n);
    hp.resize(n);
    d.resize(n);
    stac.resize(n);
    gord.resize(n);
    gnum.resize(n);
    grv.resize(n);
    sz.resize(n);
    cs.resize(n); // current dsu
    for (auto &x : binups) x.resize(n);
    clr.resize(n);
    p[0] = 0;
    for (int i = 1; i < n; ++i) {
        int cp;
        cin >> cp;
        --cp;
        p[i] = cp;
        a[cp].push_back(i);
    }
    for (int i = 0; i < n; ++i) binups[0][i] = p[i];
    for (int k = 1; k < K; ++k) {
        for (int i = 0; i < n; ++i) {
            binups[k][i] = binups[k-1][binups[k-1][i]];
        }
    }
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        cs[i] = i;
        stac[i] = 1;
        clr[i] = make_pair(l, r);
        grv[i].push_back(i);
        if (r - l + 1 < MOD) {
            cacc = (cacc * (r - l + 1)) % MOD;
        } else {
            ++cf;
        }
    }
    {
        //sz, p
        auto dd = [&](int v, auto dd) -> void {
            sz[v] = 1;
            for (int u : a[v]) {
                d[u] = d[v] + 1;
                dd(u, dd);
                sz[v] += sz[u];
            }
        };
        dd(0, dd);
    }
    {
        //hld head
        auto dd = [&](int v, auto dd) -> void {
            sort(a[v].begin(), a[v].end(), [&](auto x, auto y){return sz[x] > sz[y];});
            for (size_t i = 0; i < a[v].size(); ++i) {
                if (i == 0) {
                    hp[a[v][i]] = v;
                    dd(a[v][i], dd);
                } else {
                    hp[a[v][i]] = a[v][i];
                    dd(a[v][i], dd);
                }
            }
            gnum[v] = gordp;
            gord[gordp++] = v;
        };
        dd(0, dd);
    }
    bool stup = true;
    for (int i = 1; i < n; ++i) stup &= p[i] == i - 1;
    int m;
    cin >> m;
    if (false && !stup) {
        while (m--) {
            int x, y, z, w;
            cin >> x >> y >> z >> w;
            --x, --y, --z, --w;
            int xy = lca(x, y);
            int zw = lca(z, w);
            vector<int> vs1;
            {
                vector<int> a1;
                a1.push_back(x);
                while (x != xy) {
                    x = p[x];
                    a1.push_back(x);
                }
                vector<int> a2;
                while (y != xy) {
                    a2.push_back(y);
                    y = p[y];
                }
                reverse(a2.begin(), a2.end());
                for (auto &x : a1) vs1.push_back(x);
                for (auto &x : a2) vs1.push_back(x);
            }
            vector<int> vs2;
            {
                int x = z;
                int y = w;
                int xy = zw;

                vector<int> a1;
                a1.push_back(x);
                while (x != xy) {
                    x = p[x];
                    a1.push_back(x);
                }
                vector<int> a2;
                while (y != xy) {
                    a2.push_back(y);
                    y = p[y];
                }
                reverse(a2.begin(), a2.end());
                for (auto &x : a1) vs2.push_back(x);
                for (auto &x : a2) vs2.push_back(x);
            }
            for (size_t i = 0; i < vs1.size(); ++i) {
                int l = cs[vs1[i]];
                int r = cs[vs2[i]];
                mg(l, r);
            }
            cout << (cf ? 0 : cacc) << '\n';
        }
    } else {

        build(0, 0, n);
        mbuild(0, 0, n);
        for (int i = 0; i < n; ++i) {
            st(0, 0, n, i, i + ad);
            mst(0, 0, n, n-i-1, i + ad);
        }

        while (m--) {
            int x, y, z, w;
            cin >> x >> y >> z >> w;
            --x, --y, --z, --w;
            if (x >= y && z >= w) {
                swap(x, y);
                swap(z, w);
            }
            if (x >= y) {
                swap(x, z);
                swap(y, w);
            }

            if (z <= w) {
                while (x != y + 1) {
                    int lgl = y - x + 1;
                    int l = 0, r = lgl + 1;
                    while (r - l > 1) {
                        int mm = (l + r) >> 1;
                        ull h1 = query(0, 0, n, x, x + mm);
                        ull h2 = query(0, 0, n, z, z + mm);
                        if (h1 == h2) l = mm;
                        else r = mm;
                    }
                    if (l == lgl) {
                        x = y + 1;
                        z = w + 1;
                        break;
                    }
                    int d1 = x + l;
                    int d2 = z + l;
                    int g1 = cs[d1];
                    int g2 = cs[d2];
                    mg(g1, g2);

                    x = d1 + 1;
                    z = d2 + 1;
                }
            } else {
                swap(z, w);
                while (x != y + 1) {
                    int lgl = y - x + 1;
                    int l = 0, r = lgl + 1;
                    while (r - l > 1) {
                        int mm = (l + r) >> 1;
                        ull h1 = query(0, 0, n, x, x + mm);
                        ull h2 = mquery(0, 0, n, n - (z + mm), n - z);
                        if (h1 == h2) l = mm;
                        else r = mm;
                    }
                    if (l == lgl) {
                        x = y + 1;
                        z = w + 1;
                        break;
                    }
                    int d1 = x + l;
                    int d2 = z + l;
                    int g1 = cs[d1];
                    int g2 = cs[d2];
                    mg(g1, g2);
                    x = d1 + 1;
                    z = d2 + 1;
                }

            }

            cout << (cf ? 0 : cacc) << '\n';
        }

    }
}

/**
5
1 2 3 4
1 2
2 3
3 4
4 5
5 6
10
1 1 1 1

*/