#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

long long mod = 1e9 + 7;

vector<long long> dsu;
vector<long long> sz;
vector<pair<long long, long long>> t;

bool zr = false;

long long get(long long v) {
    if (dsu[v] == v) {
        return v;
    }
    long long root = get(dsu[v]);
    dsu[v] = root;
    return root;
}

void merg(long long v, long long u) {
    v = get(v);
    u = get(u);
    if (u == v) {
        return;
    }
    if (sz[v] > sz[u]) {
        sz[v] += sz[u];
        dsu[u] = v;
        t[v].first = max(t[v].first, t[u].first);
        t[v].second = min(t[v].second, t[u].second);
        if (t[v].first > t[v].second) {
            zr = true;
        }
    } else {
        sz[u] += sz[v];
        dsu[v] = u;
        t[u].first = max(t[v].first, t[u].first);
        t[u].second = min(t[v].second, t[u].second);
        if (t[u].first > t[u].second) {
            zr = true;
        }
    }
}

vector<bool> used;
vector<long long> pr;
vector<long long> dist;

long long dfs(long long v) {
    if (used[v]) {
        return dist[v];
    }
    used[v] = true;
    if (pr[v] != -1) {
        dist[v] = dfs(pr[v]) + 1;
    }
    return dist[v];
}

int main()
{
    long long n;
    cin >> n;
    dsu.resize(n);
    sz.resize(n, 1);
    t.resize(n);
    used.resize(n, false);
    used[0] = true;
    pr.resize(n, -1);
    dist.resize(n, 0);
    for (int i = 0; i < n; i++) {
        dsu[i] = i;
    }
    for (int i = 1; i < n; i++) {
        cin >> pr[i];
        pr[i]--;
    }
    for (int i = 0; i < n; i++) {
        long long l, r;
        cin >> l >> r;
        t[i] = {l, r};
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i);
        }
    }
    long long m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        long long a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        if (zr) {
            cout <<"0" << endl;
            continue;
        }
        vector<long long> ida;
        vector<long long> idb;
        vector<long long> idc;
        vector<long long> idd;
        long long dst = 0;
        for (; a != b; ) {
            dst++;
            if (dist[a] < dist[b]) {
                idb.push_back(b);
                b = pr[b];
            } else {
                ida.push_back(a);
                a = pr[a];
            }
        }
        ida.push_back(a);
        /*for (auto j : ida) {
            cout << j << " ";
        } cout << endl;
        for (auto j : idb) {
            cout << j << " ";
        } cout << endl;*/
        reverse(idb.begin(), idb.end());
        for (int j = 0; j < idb.size(); j++) {
            ida.push_back(idb[j]);
        }

        for (; c != d; ) {
            if (dist[c] < dist[d]) {
                idd.push_back(d);
                d = pr[d];
            } else {
                idc.push_back(c);
                c = pr[c];
            }
        }
        idc.push_back(c);
        /*for (auto j : idc) {
            cout << j << " ";
        } cout << endl;
        for (auto j : idd) {
            cout << j << " ";
        } cout << endl;*/
        reverse(idd.begin(), idd.end());

        for (int j = 0; j < idd.size(); j++) {
            idc.push_back(idd[j]);
        }
        for (int j = 0; j <= dst; j++) {
            merg(ida[j], idc[j]);
            //cout << ida[j] << " " << idc[j] << " | ";
            if (zr) {
                break;
            }
        }
        /*cout << endl;
        for (auto [l, r] : t) {
            cout << l << " " << r << " | ";
        } cout << endl;*/
        if (zr) {
            cout << "0" << endl;
            continue;
        } else {
            set<long long> st;
            long long ans = 1;
            for (int j = 0; j < n; j++) {
                long long cur = get(j);
                if (st.find(cur) == st.end()) {
                    st.insert(cur);
                    ans *= (t[cur].second - t[cur].first + 1);
                    ans %= mod;
                }
            }
            cout << ans << endl;
        }

    }


    return 0;
}
