#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const int maxn = 1e6 + 1;

vector<vector<int>> g;
vector<itn> tin, tout;
vector<itn> p;
vector<pii> tmr;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for(auto to : g[v]) {
        if(tin[to] != -1) continue;
        dfs(to);
    }
    tout[v] = timer++;
}

bool isp(int v, int u) {//v - eto predok u?
    return (tin[v] <= tin[u] && tout[u] <= tout[v]);
}

vector<int> get_path(int v, int u) {
    vector<int> ans;
    if(isp(v, u)) {
        int cur = u;
        while(cur != v) {
            ans.pb(cur);
            cur = p[cur];
        }
        ans.pb(v);
        reverse(all(ans));
        return ans;
    }
    if(isp(u, v)) {
        int cur = v;
        while(cur != u) {
            ans.pb(cur);
            cur = p[cur];
        }
        ans.pb(u);
        return ans;
    }
    int cur = v;
    while(!isp(cur, u)) cur = p[cur];
    int lca = cur;
    vector<int> path1, path2;
    cur = v;
    while(cur != lca) {
        path1.pb(cur);
        cur = p[cur];
    }
    cur = u;
    while(cur != lca) {
        path2.pb(cur);
        cur = p[cur];
    }
    reverse(all(path2));
    for(auto to : path1) ans.pb(to);
    ans.pb(lca);
    for(auto to : path2) ans.pb(to);
    return ans;
}

pii per(pii a, pii b) {
    if(a.X > b.X) swap(a, b);
    if(b.X > a.Y) return {-INF, -INF};
    else {
        if(b.Y <= a.Y) return b;
        else return {b.X, a.Y};
    }
}

void dfs1(int v, vector<vector<int>> &ng, vector<bool> &nu, pii &cur_otr) {
    nu[v] = true;
    cur_otr = per(cur_otr, tmr[v]);
    for(auto to : ng[v]) {
        if(cur_otr.X == -INF) return;
        if(!nu[to]) dfs1(to, ng, nu, cur_otr);
    }
}

void solve() {
    int n;
    cin >> n;
    p.resize(n, 1);
    for(int i = 1; i < n; ++i) cin >> p[i];
    for(auto &to : p) --to;
    g.resize(n);
    for(int i = 1; i < n; ++i) {
        g[p[i]].pb(i);
        g[i].pb(p[i]);
    }
    tin.resize(n, -1);
    tout.resize(n);
    dfs(0);
    tmr.resize(n);
    for(int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        tmr[i] = {x, y};
    }
    int all_prod = 1;
    for(int i = 0; i < n; ++i) all_prod *= (tmr[i].Y - tmr[i].X + 1);
    itn m;
    cin >> m;
    set<pii> edg;
    while(m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        vector<itn> cur1 = get_path(a, b);
        vector<itn> cur2 = get_path(c, d);
        for(int i = 0; i < (int)cur1.size(); ++i) {
            if(cur1[i] == cur2[i]) continue;
            edg.insert({min(cur1[i], cur2[i]), max(cur1[i], cur2[i])});
        }
        vector<vector<int>> ng(n);
        for(auto to : edg) {
            ng[to.X].pb(to.Y);
            ng[to.Y].pb(to.X);
        }
        int ans = 1;
        vector<bool> nu(n, false);
        for(int i = 0; i < n; ++i) {
            if(!nu[i]) {
                pii cur_otr = tmr[i];
                dfs1(i, ng, nu, cur_otr);
                if(cur_otr.X == -INF) {
                    ans = 0;
                    break;
                }
                ans *= (cur_otr.Y - cur_otr.X + 1);
                if(ans >= MOD) ans = ans % MOD;
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}