///pandemonica, modeus, cerberus, malina, zdrada, azazel, justice, lucifer, judgement, beelzebub
#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

#define ll __int128
//#define int __int128
#define int long long
#define f first
#define s second
#define endl '\n'
#define diuble long double

int n;
vector <vector <int> > g,par;
vector <int> used;
vector <int> l,r,c,h,w;

void dfs(int v)
{
    used[v]=1;
    for (int u:g[v]){
        if (used[u])continue;
        par[0][u]=v;
        h[u]=h[v]+1;
        dfs(u);
    }
}

void build_lca()
{
    for (int j=1; j<20; j++){
        for (int i=0; i<n; i++){
            par[j][i]=par[j-1][par[j-1][i]];
        }
    }
}

int lca(int v, int u)
{
    if (h[v]<h[u])swap(v,u);
    for (int j=19; j>=0; j--){
        if (h[par[j][v]]<h[u])continue;
        v=par[j][v];
    }
    for (int j=19; j>=0; j--){
        if (par[j][v]==par[j][u])continue;
        v=par[j][v];
        u=par[j][u];
    }
    if (v!=u)v=par[0][v];
    return v;
}

vector <int> get_path(int v, int u)
{
    vector <int> a,b;
    int l=lca(v,u);
    //cout << v+1 << " " << u+1 << " " << l+1 << endl;
    while (1){
        a.push_back(v);
        if (v==l)break;
        v=par[0][v];
    }
    while (1){
        if (u==l)break;
        b.push_back(u);
        u=par[0][u];
    }
    reverse(b.begin(),b.end());
    for (int i:b)a.push_back(i);
    return a;
}

const int mod=1000000007;
int step(int a, int n)
{
    if (n==0)return 1;
    if (n==1)return a;
    int b=step(a,n/2);
    return b*b%mod*step(a,n%2)%mod;
}
int inv_step(int a, int n)
{
    return step(a,mod-1-n);
}
int mul(int a, int b)
{
    return a*b%mod;
}
int divv(int a, int b)
{
    return a*inv_step(b,1)%mod;
}

vector <int> p;

int get(int v)
{
    if (p[v]==v)return v;
    p[v]=get(p[v]);
    return p[v];
}
int ans=1;
void upd(int v, int u)
{
    v=get(v);
    u=get(u);
    //cout << "upd: " << v+1 << " " << u+1 << ": " << r[v]-l[v]+1 << "*" << c[v] << ", " << r[u]-l[u]+1 << "*" << c[u] << ", " << endl;
    if (v==u)return;
    if (c[v]>c[u])swap(v,u);
    ans=divv(ans,step(r[v]-l[v]+1,c[v]));
    ans=divv(ans,step(r[u]-l[u]+1,c[u]));
    p[v]=u;
    l[u]=max(l[u],l[v]);
    r[u]=min(r[u],r[v]);
    l[u]=min(l[u],r[u]+1);
    c[u]+=c[v];
    ans=mul(ans,step(r[u]-l[u]+1,1));
}

void solve()
{
    cin >> n;
    g.resize(n);
    par.resize(20,vector <int> (n,0));
    for (int i=1; i<n; i++){
        int j;
        cin >> j;
        j--;
        par[0][i]=j;
        g[i].push_back(j);
        g[j].push_back(i);
    }
    used.assign(n,0);
    h.assign(n,0);
    dfs(0);

    l.assign(n,0);
    r.assign(n,0);
    c.assign(n,0);
    for (int i=0; i<n; i++){
        cin >> l[i] >> r[i];
        c[i]=1;
    }

    build_lca();
    p.resize(n);
    for (int i=0; i<n; i++){
        p[i]=i;
    }

    int q;
    cin >> q;
    for (int i=0; i<n; i++){
        ans=mul(ans,step(r[i]-l[i]+1,1));
    }
    while (q--){
        if (ans==0){
            cout << ans << endl;
            continue;
        }
        int v1,u1,v2,u2;
        cin >> v1 >> u1 >> v2 >> u2;
        v1--;
        u1--;
        v2--;
        u2--;
        vector <int> a=get_path(v1,u1);
        vector <int> b=get_path(v2,u2);
        /*cout << "a: ";
        for (int i:a)cout << i << " ";
        cout << endl;
        cout << "b: ";
        for (int i:b)cout << i << " ";
        cout << endl;*/

        if (a.size()!=b.size())assert(0);
        for (int i=0; i<a.size(); i++){
            upd(a[i],b[i]);
            if (ans==0)break;
        }
        cout << ans << endl;
    }
}

signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL

    int n=1;
    ///cin >> n;
    while (n--){
        solve();
    }
}