//#pragma GCC target("fma")
//#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC comment(linker, "/64000000")
#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator >> (istream &in, pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

template<typename T, typename G>
ostream& operator << (ostream &in, pair<T, G> &a) {
    in << a.X << ' ' << a.Y;
    return in;
}

struct dsu {
    vector<int> par;
    vector<pii> ans;
    vector<int> sz;

    pii splay(pii a, pii b) {
        rmax(a.X, b.X);
        rmin(a.Y, b.Y);

        return a;
    }

    int find_par(int a) {
        if (a == par[a]) {
            return a;
        }
        return par[a] = find_par(par[a]);
    }

    int get(int a) {
        a = find_par(a);
        return max(0, ans[a].Y - ans[a].X + 1);
    }

    void unite(int a, int b) {
        a = find_par(a);
        b = find_par(b);

        if (a == b) {
            return;
        }

        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        par[b] = a;
        ans[a] = splay(ans[a], ans[b]);
    }

    bool are_same(int a, int b) {
        return find_par(a) == find_par(b);
    }

    void init(int n) {
        sz.assign(n, 1);
        par.resize(n);
        iota(all(par), 0);
        ans.resize(n);
    }
};

const int INF = 1e9 + 7;

int add(int a, int b) {
    int c = (a + b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

int mul(ll a, ll b) {
    ll c = (a * b) % INF;
    if (c < 0) {
        c += INF;
    }
    return c;
}

int bin_pow(int a, int b) {
    int res = 1;

    while (b > 0) {
        if (b & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}

int divide(int a, int b) {
    return mul(a, bin_pow(b, INF - 2));
}

int ans = 1;

const int MAXN = 2e5 + 1;
vector<int> adj[MAXN];
int par[MAXN];
int d[MAXN];
dsu snm;

void dfs(int v, int de) {
    d[v] = de;
    for (int &it : adj[v]) {
        dfs(it, de + 1);
    }
}

void get_vector(int a, int b, vector<int> &my) {
    vector<int> f2;

    if (d[a] > d[b]) {
        while (d[a] != d[b]) {
            my.push_back(a);
            a = par[a];
        }

        if (a == b) {
            my.push_back(b);
            return;
        }
    }

    if (d[b] > d[a]) {
        while (d[a] != d[b]) {
            f2.push_back(b);
            b = par[b];
        }

        if (a == b) {
            f2.push_back(a);
            my = f2;
            reverse(all(my));
            return;
        }
    }

    while (a != b) {
        my.push_back(a);
        f2.push_back(b);

        a = par[a];
        b = par[b];
    }

    my.push_back(a);

    while (f2.size() > 0) {
        my.push_back(f2.back());
        f2.pop_back();
    }
}

void apply_query(int a, int b, int c, int d) {
    vector<int> a1;
    vector<int> a2;

    get_vector(a, b, a1);
    get_vector(c, d, a2);

    for (int i = 0; i < a1.size(); i++) {
        int u = a1[i];
        int v = a2[i];

        if (snm.are_same(u, v)) {
            continue;
        }

        ans = divide(ans, snm.get(u));
        ans = divide(ans, snm.get(v));
        snm.unite(u, v);
        ans = mul(ans, snm.get(u));
    }
}

void solve() {
    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        --p;

        par[i] = p;
        adj[p].push_back(i);
    }

    dfs(0, 0);
//    cout << d[1] << ' ' << d[0] << endl;

    snm.init(n);

    for (int i = 0; i < n; i++) {
        cin >> snm.ans[i];
        ans = mul(ans, snm.get(i));
    }

    int q;
    cin >> q;

    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;

        apply_query(a, b, c, d);

        cout << ans << endl;
    }

//    cout << snm.ans[0] << endl;
//    cout << snm.ans[2] << endl;
//    cout << snm.get(4) << endl;
}

signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
//#else
//    freopen("./input.txt", "r", stdin);
//    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}