#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree <T, null_type, less<>,
        rb_tree_tag, tree_order_statistics_node_update>;

//#define int long long
#define sz(x) ((int) (x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define ff first
#define ss second

using pii = pair <int, int>;

template <typename T1, typename T2>
void mxr(T1& a, const T2& b) {
    if (a < b) {
        a = b;
    }
}

template <typename T1, typename T2>
void mnr(T1& a, const T2& b) {
    if (a > b) {
        a = b;
    }
}

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return 1ll * a * b % MOD;
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

int F(int a) {
    return binpow(a, MOD - 2);
}

pii inter(pii a, pii b) {
    if (a.ff > b.ff) {
        swap(a, b);
    }
    if (b.ff >= a.ff && b.ff <= a.ss) {
        return {b.ff, min(b.ss, a.ss)};
    }
    return {-1, -2};
}

struct DSU {
private:
    vector <int> p;
    vector <int> r;
    vector <pii> v;

public:
    int value{};
    explicit DSU(const vector <pii>& v) : v(v) {
        int n = sz(v);
        p.resize(n);
        r.resize(n);
        value = 1;
        iota(all(p), 0);
        for (auto [l1, r1] : v) {
            value = mul(value, r1 - l1 + 1);
        }
    }

    int get(int a) {
        return (a == p[a] ? a : p[a] = get(p[a]));
    }

    void unite(int a, int b) {
        a = get(a), b = get(b);
        if (a == b) {
            return;
        }
        pii t = inter(v[a], v[b]);
        value = mul(value, F(v[b].ss - v[b].ff + 1));
        value = mul(value, F(v[a].ss - v[a].ff + 1));
        value = mul(value, t.ss - t.ff + 1);
        if (r[a] > r[b]) {
            swap(r[a], r[b]);
        }
        p[a] = b;
        v[b] = t;
        r[b] += (r[a] == r[b]);
    }
};

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        a -= MOD;
    }
    return a;
}

int X = 1e5 + 3;
const int POW_MAX_N = 2e5 + 1;

int xPow[POW_MAX_N];

class ST {
private:
    vector <int> d;
    int n;

    void upd(int i, int len) {
        d[i] = add(d[2 * i  +1], mul(d[2 * i], xPow[len]));
    }

    void build(int l, int r, int i) {
        if (l + 1 == r) {
            d[i] = l;
            return;
        }
        int m = (l + r) / 2;
        build(l, m, 2 * i);
        build(m, r, 2 * i + 1);
        d[i] = add(d[2 * i + 1], mul(d[2 * i], xPow[m - l]));
    }

    void upd(int i, int id, int l, int r, int x) {
        if (l + 1 == r) {
            d[id] = x;
            return;
        }
        int m = (l + r) / 2;
        if (id >= m) {
            upd(2 * i + 1, id, m, r, x);
        } else {
            upd(2 * i, id, l, m, x);
        }
        upd(i, m - l);
    }

    void get(int ql, int qr, int l, int r, int i, vector <int>& s, vector <int>& rs) {
        if (l >= qr || ql >= r) {
            return;
        }
        if (l >= ql && r <= qr) {
            s.emplace_back(r - l);
            rs.push_back(d[i]);
            return;
        }
        int m = (l + r) /2 ;
        get(ql, qr, l, m, 2 * i, s, rs);
        get(ql, qr, m, r, 2 * i + 1, s, rs);
    }

public:
    explicit ST(int n1) {
        n = 1;
        while (n < n1) {
            n <<= 1;
        }
        d.resize(2 * n);
        build(0, n, 1);
    }

    int get(int l, int r) {
        vector <int> s, rs;
        get(l, r, 0, n, 1, s, rs);
        int res = 0;
        int pr = 0;
        for (int i = 0; i < sz(s); ++i) {
            res = mul(res, xPow[pr]);
            res = add(res, rs[i]);
            pr += s[i];
        }
        return res;
    }

    void upd1(int i, int x) {
        return upd(1, i, 0, n, x);
    }
};


class STr {
private:
    vector <int> d;
    int n;
    int n0;

    void upd(int i, int len) {
        d[i] = add(d[2 * i  +1], mul(d[2 * i], xPow[len]));
    }

    void build(int l, int r, int i) {
        if (l + 1 == r) {
            if (l < n0) {
                d[i] = n0 - l - 1;
            }
            return;
        }
        int m = (l + r) / 2;
        build(l, m, 2 * i);
        build(m, r, 2 * i + 1);
        d[i] = add(d[2 * i + 1], mul(d[2 * i], xPow[m - l]));
    }

    void upd(int i, int id, int l, int r, int x) {
        if (l + 1 == r) {
            d[id] = x;
            return;
        }
        int m = (l + r) / 2;
        if (id >= m) {
            upd(2 * i + 1, id, m, r, x);
        } else {
            upd(2 * i, id, l, m, x);
        }
        upd(i, m - l);
    }

    void get(int ql, int qr, int l, int r, int i, vector <int>& s, vector <int>& rs) {
        if (l >= qr || ql >= r) {
            return;
        }
        if (l >= ql && r <= qr) {
            s.emplace_back(r - l);
            rs.push_back(d[i]);
            return;
        }
        int m = (l + r) /2 ;
        get(ql, qr, l, m, 2 * i, s, rs);
        get(ql, qr, m, r, 2 * i + 1, s, rs);
    }

public:
    explicit STr(int n1) {
        n = 1;
        n0 = n1;
        while (n < n1) {
            n <<= 1;
        }
        d.resize(2 * n);
        build(0, n, 1);
    }

    int get(int l, int r) {
        vector <int> s, rs;
        get(l, r, 0, n, 1, s, rs);
        int res = 0;
        int pr = 0;
        for (int i = 0; i < sz(s); ++i) {
            res = mul(res, xPow[pr]);
            res = add(res, rs[i]);
            pr += s[i];
        }
        return res;
    }

    void upd1(int i, int x) {
        return upd(1, i, 0, n, x);
    }
};


class ST2 {
private:
    vector <pii> d;
    int n;

    void upd(int i) {
        d[i] = max(d[2 * i], d[2 * i + 1]);
    }

public:
    explicit ST2(int n1) {
        n = 1;
        while (n < n1) {
            n <<= 1;
        }
        d.resize(2 * n);
        for (int i = 0; i < n1; ++i) {
            d[i + n] = {1, i};
        }
        for (int i = n - 1; i; --i){
            upd(i);
        }
    }

    int get(int l, int r) {
        pii res{};
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                mxr(res, d[l++]);
            }
            if (r & 1) {
                mxr(res, d[--r]);
            }
        }
        return res.ss;
    }

    void upd(int i, int x) {
        d[i += n].ss = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};



class ST3 {
private:
    vector <pii> d;
    int n;

    void upd(int i) {
        d[i] = min(d[2 * i], d[2 * i + 1]);
    }

public:
    explicit ST3(int n1) {
        n = 1;
        while (n < n1) {
            n <<= 1;
        }
        d.resize(2 * n, {1e9, 1e9});
        for (int i = 0; i < n1; ++i) {
            d[i + n] = {1, i};
        }
        for (int i = n - 1; i; --i){
            upd(i);
        }
    }

    int get(int l, int r) {
        pii res = {1e9, 1e9};
        for (l += n, r += n; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                mnr(res, d[l++]);
            }
            if (r & 1) {
                mnr(res, d[--r]);
            }
        }
        return res.ss;
    }

    void upd(int i, int x) {
        d[i += n].ss = x;
        while (i >>= 1) {
            upd(i);
        }
    }
};


signed main() {
    ios_base::sync_with_stdio(false);
#ifdef SYSTY257
    freopen("inputik.txt", "r", stdin);
    freopen("outputik.txt", "w", stdout);
#else
    cin.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector <vector <int> > g(n);
    vector <int> par(n);
    bool falg = true;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        if (p != i) {
            falg = false;
        }
        g[--p].push_back(i);
        par[i] = p;
    }
    if (falg) {
        ST st1(n);
        STr st2(n);
        ST3 stmn(n);
        ST2 stmx(n);
        int VAL = 1;
        vector <pii> v(n);
        for (auto& [l, r] : v) {
            cin >> l >> r;
            VAL = mul(VAL, r - l + 1);
        }
        vector <int> comp(n);
        vector <vector <int> > comps;
        auto merge = [&](int a, int b) {
            a = comp[a], b = comp[b];
            if (a == b) {
                return;
            }
            if (sz(comps[a]) > sz(comps[b])) {
                swap(a, b);
            }
            for (auto i : comps[a]) {
                stmn.upd(i, comp[b]);
                stmx.upd(i, comp[b]);
                st1.upd1(i, comp[b]);
                st2.upd1(n - i - 1, comp[b]);
            }
            for (auto i : comps[a]) {
                comp[i] = b;
                comps[b].push_back(i);
            }
            auto seg1 = v[a];
            auto seg2 = v[b];
            VAL = mul(VAL, F(v[a].ss - v[a].ff + 1));
            VAL = mul(VAL, F(v[b].ss - v[b].ff + 1));
            auto t = inter(seg1, seg2);
            VAL = mul(VAL, t.ss - t.ff + 1);
            v[b] = t;
            comps[a].clear();
        };
        int m;
        cin >> m;
        while (m--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            int a1 = min(a, b), b1 = max(a, b);
            int c1 = min(c, d), d1 = max(c, d);
            if (a1 < c1) {
                swap(a1, c1);
                swap(b1, d1);
                int DD = max(d1, b1);
                if (c1 >= a1 && c1 <= b1) {
                    while (stmn.get(a1, DD + 1) != stmx.get(a1, DD + 1)) {
                        int f = stmn.get(a1, DD + 1);
                        int s = stmx.get(a1, DD + 1);
                        merge(f, s);
                    }
                    cout << VAL << "\n";
                    continue;
                }
            }
            if (c > d) {
                swap(a, c);
                swap(b, d);
            }
            if (c > d) {
                swap(a, b);
                swap(c, d);
            }
            if (a > b) {
                int beg1 = b;
                int beg2 = c;
                while (st1.get(b, a + 1) != st1.get(c, d + 1)) {
                    int l = 0, r = a - beg1 + 1;
                    while (l != r) {
                        int mid = (l + r) / 2;
                        if (st2.get(beg1 - mid, beg1 + 1) != st1.get(beg2, beg2 + mid + 1)) {
                            r = mid;
                        } else {
                            l = mid + 1;
                        }
                    }
                    beg1 -= l;
                    beg2 += l;
                    merge(beg1, beg2);
                }
            } else {
                int beg1 = a;
                int beg2 = c;
                while (st1.get(a, b + 1) != st1.get(c, d + 1)) {
                    int l = 0, r = b - beg1 + 1;
                    while (l != r) {
                        int mid = (l + r) / 2;
                        if (st1.get(beg1, beg1 + mid + 1) != st1.get(beg2, beg2 + mid + 1)) {
                            r = mid;
                        } else {
                            l = mid + 1;
                        }
                    }
                    beg1 += l;
                    beg2 += l;
                    merge(beg1, beg2);
                }
            }
            cout << VAL << "\n";
        }
        return 0;
    }
    const int K = 21;
    vector <vector <int> > binUp(K, vector <int> (n));
    binUp[0] = par;
    for (int k = 1; k < K; ++k) {
        for (int i = 0; i < n; ++i) {
            binUp[k][i] = binUp[k - 1][binUp[k - 1][i]];
        }
    }
    vector <int> depth(n);
    auto dfs = [&](auto& dfs, int cur) -> void {
        for (auto to : g[cur]) {
            depth[to] = depth[cur] + 1;
            dfs(dfs, to);
        }
    };
    dfs(dfs, 0);
    auto lca = [&](int u, int v) {
        if (depth[u] > depth[v]) {
            swap(u, v);
        }
        for (int i = K - 1; i >= 0; --i) {
            if (depth[binUp[i][v]] >= depth[u]) {
                v = binUp[i][v];
            }
        }
        if (u == v) {
            return u;
        }
        for (int i = K - 1; i >= 0; --i) {
            if (binUp[i][u] != binUp[i][v]) {
                u = binUp[i][u], v = binUp[i][v];
            }
        }
        return par[u];
    };
    vector <pii> v(n);
    for (auto& [l, r] : v) {
        cin >> l >> r;
    }
    auto dst = [&](int u, int v) {
        return depth[u] + depth[v] - 2 * depth[lca(u, v)];
    };
    DSU dsu(v);
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        int l1 = lca(a, b);
        int l2 = lca(c, d);
        int ds = 1 + dst(a, b);
        int* path1 = new int[ds];
        int* path2 = new int[ds];
        int ptr = 0;
        while (a != l1) {
            path1[ptr++] = a;
            a = par[a];
        }
        path1[ptr++] = l1;
        ptr = ds - 1;
        while (b != l1) {
            path1[ptr--] = b;
            b = par[b];
        }
        ptr = 0;
        while (c != l2) {
            path2[ptr++] = c;
            c = par[c];
        }
        path2[ptr++] = l2;
        ptr = ds -1 ;
        while (d != l2) {
            path2[ptr--] = d;
            d = par[d];
        }
        for (int i = 0; i < ds; ++i) {
            dsu.unite(path1[i], path2[i]);
        }
        cout << dsu.value << "\n";
    }
}
