#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

cosnt int MOD = 1e9 + 7;

pair<int, int> inter(const pair<int, int>& a, const pair<int, int>& b) {
    return make_pair(max(a.first, b.first), min(a.second, b.second));
}

int len(const pair<int, int>& a) {
    return max(0, a.second - a.first + 1);
}

ll qpow(ll a, int n) {
    if (n == 0)
        return 1;
    if (n % 2 == 0)
        return qpow(a * a % MOD, n / 2);
    return a * qpow(a * a % MOD, n / 2) % MOD;
}

ll inv(ll n) {
    return qpow(n, MOD - 2);
}

struct DSU {
    ll cnt = 1;
    vector<int> p, sz;
    vector<pair<int, int>> a;

    DSU() = default;
    DSU(const vector<pair<int, int>>& a_) : a(a_) {
        int n = a.size();
        p.assing(n, 0);
        iota(all(p), 0);
        sz.assing(n, 1);
        for (auto& i : a)
            cnt = cnt * len(i) % MOD;
    }

    int root(int v) {
        if (p[v] == v)
            return v;
        return p[v] = root(p[v]);
    }

    void merge(int u, int v) {
        u = root(u), v = root(v);
        if (u == v)
            return;
        if (sz[u] < sz[v])
            swap(u, v);
        p[v] = u;
        sz[u] += sz[v];
        cnt = (cnt * inv(len(a[u])) % MOD) * inv(len(a[v])) % MOD;
        a[u] = inter(a[u], a[v]);
        cnt = cnt * len(a[u]) % MOD;
    }
};

vector<vector<int>> g;
vector<int> tin, tout;
vector<int> p;

void get_t(int v, int p, int& t) {
    tin[v] = t++;
    for (auto u : g[v])
        if (u != p)
            get_t(u, v, t);
    tout[v] = t++;
}

vector<int> path(int u, int v) {
    vector<int> ans;
    while (!(tin[u] <= tin[v] && tout[v] <= tout[u])) {
        ans.push_back(u);
        u = p[u];
    }
    ans.push_back(u);
    int it = ans.size();
    while (v != u) {
        ans.push_back(v);
        v = p[v];
    }
    reverse(ans.begin() + it, ans.end());
    return ans;
}

void solve() {
    int n;
    cin >> n;
    p.assing(n, -1);
    for (int i = 1; i < n; ++i)
        cin >> p[i], --p[i];
    vector<pair<int, int>> a(n, {0 ,0});
    for (auto& [l, r] : a)
        cin >> l >> r;

    g.assing(n, {});
    for (int i = 1; i < n; ++i) {
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }

    tin.assing(n, 0);
    tout.assing(n, 0);
    int timer = 0;
    get_t(0, -1, timer);

    int m;
    cin >> m;
    vector<ll> ans(m);
    DSU dsu(a);
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        auto v1 = path(a, b), v2 = path(c, d);
        for (int i = 0; i < v1.size(); ++i)
            dsu.merge(v1[i], v2[i]);
        cout << dsu.cnt << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
