#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

const int N = 200005;
vc<int> g[N];
const ll MOD = 1e9 + 7;

int cur = 0;
int tin[N], tout[N], p[N];

void dfs(int v) {
    tin[v] = cur++;
    for (auto u: g[v]) {
        dfs(u);
    }
    tout[v] = cur++;
}

ll pw(ll a, int b) {
    ll ans = 1;
    while (b) {
        if (b & 1) ans = ans * a % MOD;
        a = a * a % MOD, b /= 2;
    }
    return ans;
}

ll ans = 1;

ll get(std::pair<int, int> ok) {
    return std::max(0, ok.second - ok.first + 1);
}

struct DSU {
    vc<int> p;
    vc<std::pair<int, int>> lol;

    DSU(int n) : p(n + 1), lol(n + 1) { std::iota(p.begin(), p.end(), 0); }

    int leader(int v) {
        while (v != p[v]) v = p[v] = p[p[v]];
        return v;
    }

    void merge(int v, int u) {
        v = leader(v), u = leader(u);
        if (v != u) {
            p[v] = u;
            ans *= pw(get(lol[u]), MOD - 2);
            ans %= MOD;
            ans *= pw(get(lol[v]), MOD - 2);
            ans %= MOD;
            lol[u].first = std::max(lol[u].first, lol[v].first);
            lol[u].second = std::min(lol[u].second, lol[v].second);
            ans *= get(lol[u]);
            ans %= MOD;
        }
    }
};

bool check(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

vc<int> build(int a, int b) {
    vc<int> f1 = {a}, f2;
    while (!check(a, b)) {
        a = p[a];
        f1.push_back(a);
    }
    while (a != b) {
        f2.push_back(b);
        b = p[b];
    }
    std::reverse(f2.begin(), f2.end());
    for (auto v: f2) f1.push_back(v);
    return f1;
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int n, m;
    std::cin >> n;
    for (int v = 2; v <= n; ++v) {
        std::cin >> p[v];
        g[p[v]].push_back(v);
    }
    dfs(1);
    DSU f(n + 1);
    for (int v = 1; v <= n; ++v) {
        std::cin >> f.lol[v].first >> f.lol[v].second;
        ans *= (f.lol[v].second - f.lol[v].first + 1);
        ans %= MOD;
    }
    std::cin >> m;
    while (m--) {
        int a, b, c, d;
        std::cin >> a >> b >> c >> d;
        vc<int> f1 = build(a, b), f2 = build(c, d);
        for (int i = 0; i < f1.size(); ++i) f.merge(f1[i], f2[i]);
        std::cout << ans << '\n';
    }
}

