#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<random>
#include<stack>
#include<deque>
#include<iomanip>

using namespace std;

#pragma optimize("O3")
#pragma optimize("avx2")
#pragma optimize("unrool-loops")

#define int long long

int mod = 1e9 + 7;

random_device rd;
mt19937 gen(rd());

int fpow(int x, int deg) {
	if (deg == 0)
		return 1;
	if (deg % 2 == 1)
		return x * fpow(x, deg - 1) % mod;
	int y = fpow(x, deg / 2);
	return y * y % mod;
}

struct comp {
	int size = 1;
	int l, r;
};

int num[300005];
comp dsu[300005];
int get(int v) {
	if (num[v] != v)
		num[v] = get(num[v]);
	return num[v];
}

int ans = 1;

void merge(int u, int v) {
	u = get(u), v = get(v);
	if (u == v)
		return;
	if (dsu[v].size > dsu[u].size) {
		swap(u, v);
	}
	ans = ans * fpow((dsu[u].r - dsu[u].l + 1), mod - 2) % mod;
	ans = ans * fpow((dsu[v].r - dsu[v].l + 1), mod - 2) % mod;
	dsu[u].l = max(dsu[u].l, dsu[v].l);
	dsu[u].r = min(dsu[u].r, dsu[v].r);
	dsu[u].size += dsu[v].size;
	ans = ans * max(0ll, (dsu[u].r - dsu[u].l + 1)) % mod;
	num[v] = u;
}

vector<int> gr[300005];
int dep[300005];
int par[300005];
int tin[300005];
int tout[300005];

int t = 0;
void dfs(int v) {
	tin[v] = t++;
	for (auto u : gr[v]) {
		dfs(u);
	}
	tout[v] = t;
	t++;
}

void solve() {
	int n;
	cin >> n;
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;
		par[i] = p;
		gr[p].push_back(i);
	}
	for (int i = 0; i < n; i++) {
		int l, r;
		cin >> dsu[i].l >> dsu[i].r;
		num[i] = i;
		dsu[i].size = 1;
		ans = ans * max(0ll, (dsu[i].r - dsu[i].l + 1)) % mod;
	}
	dfs(0);
	int m;
	cin >> m;
	for (int i = 0; i < m; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--; b--; c--; d--;
		vector<int>g11, g12;
		vector<int>g21, g22;
		while (!(tin[a] <= tin[b] && tout[b] <= tout[a])) {
			g11.push_back(a);
			a = par[a];
		}while (a != b) {
			g12.push_back(b);
			b = par[b];
		}
		g11.push_back(a);
		for (int j = g12.size() - 1; j >= 0; j--) {
			g11.push_back(g12[j]);
		}
		a = c; b = d;
		while (!(tin[a] <= tin[b] && tout[b] <= tout[a])) {
			g21.push_back(a);
			a = par[a];
		}while (a != b) {
			g22.push_back(b);
			b = par[b];
		}
		g21.push_back(a);
		for (int j = g22.size() - 1; j >= 0; j--) {
			g21.push_back(g22[j]);
		}
		for (int j = 0; j < g11.size(); j++) {
			merge(g11[j], g21[j]);
		}
		if (ans == 0) {
			while (i != m) {
				cout << 0 << "\n";
				i++;
			}
			return;
		}
	}
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//freopen("Text.txt", "r", stdin);
	//freopen("", "w", stdout)

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}