#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream &operator>>(istream &is, vector<T> &v) {
    for (auto &u: v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &u: v) {
        os << u << ' ';
    }
    return os;
}

const int mod = 1'000'000'007;
int ans;

int binpow(int a, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int v = binpow(a, p / 2);
        return v * v % mod;
    } else {
        return a * binpow(a, p - 1) % mod;
    }
}

struct dsu {
    int n;

    vector<int> p;
    vector<int> sz;
    vector<pair<int, int>> lr;

    dsu(int _n, vector<pair<int, int>> _lr) {
        n = _n;
        p.resize(n);
        sz.resize(n, 1);
        lr = _lr;
        iota(p.begin(), p.end(), 0ll);
    }

    int get(int v) {
        if (p[v] == v) {
            return v;
        }
        p[v] = get(p[v]);
        return p[v];
    }


    void merge(int v, int u) {
        v = get(v);
        u = get(u);
        if (u == v) {
            return;
        }
        if (sz[v] < sz[u]) {
            swap(u, v);
        }

        ans = ans * binpow(lr[u].second - lr[u].first + 1, mod - 2) % mod;
        ans = ans * binpow(lr[v].second - lr[v].first + 1, mod - 2) % mod;
        lr[v].first = max(lr[v].first, lr[u].first);
        lr[v].second = min(lr[v].second, lr[u].second);
        if (lr[v].first > lr[v].second) {
            ans = 0;
        }
        ans = ans * (lr[v].second - lr[v].first + 1) % mod;
        sz[v] += sz[u];
        p[u] = v;
    }
};


int n;
vector<int> p;
vector<vector<int>> g;
vector<int> de;

void dfs(int v) {
    for (auto u : g[v]) {
        de[u] = de[v] + 1;
        dfs(u);
    }
}

vector<int> way(int a, int b) {
    vector<int> one, two;
    while (a != b) {
        if (de[a] > de[b]) {
            one.push_back(a);
            a = p[a];
        } else {
            two.push_back(b);
            b = p[b];
        }
    }
    one.push_back(a);
    for (int i = two.size() - 1; i >= 0; --i) {
        one.push_back(two[i]);
    }
    return one;
}

void solve() {
    cin >> n;
    p.resize(n);
    g.resize(n);
    de.resize(n);
    vector<pair<int, int>> lr;
    lr.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i] -= 1;
        g[p[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].first >> lr[i].second;
    }

    dsu ds(n, lr);

    ans = 1;
    for (int i = 0; i < n; ++i) {
        ans = ans * (lr[i].second - lr[i].first + 1) % mod;
    }

    dfs(0);

    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a -= 1;
        b -= 1;
        c -= 1;
        d -= 1;
        vector<int> way1 = way(a, b);
        vector<int> way2 = way(c, d);

        for (int i = 0; i < way1.size(); ++i) {
            ds.merge(way1[i], way2[i]);
        }

        cout << ans << '\n';
    }


}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day1/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}