#include <bits/stdc++.h>

//#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int N = 3200, mod = 1e9 + 7;

int add(int a, int b) { return a + b >= mod ? a + b - mod : a + b; }

int sub(int a, int b) { return a - b < 0 ? a + b - mod : a - b; }

int mul(int a, int b) { return a * 1ll * b % mod; }

int binpow(int a, int p) {
    int res = 1;
    while (p) {
        if (p & 1) res = mul(res, a);
        a = mul(a, a);
        p >>= 1;
    }
    return res;
}

int inv(int a) { return binpow(a, mod - 2); }

vector<int> g[N];
int l[N], r[N], p[N], sz[N];

int get(int i) { return p[i] == i ? i : p[i] = get(p[i]); }

void merge(int i, int j) {
    i = get(i), j = get(j);
    if (i == j) return;
    if (sz[i] < sz[j]) swap(sz[i], sz[j]);
    l[i] = max(l[i], l[j]), r[i] = min(r[i], r[j]);
    sz[i] += sz[j], p[j] = i;
}

vector<int> path[N][N];

vector<int> st;

void dfs(int s, int v, int par) {
    st.push_back(v);
    path[s][v] = st;
    for (int u: g[v])
        if (u != par)
            dfs(s, u, v);
    st.pop_back();
}

int used[N];

void solve() {
    iota(p, p + N, 0);
    fill(sz, sz + N, 1);
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int par;
        cin >> par;
        g[par].push_back(i);
        g[i].push_back(par);
    }
    for (int i = 1; i <= n; i++)
        cin >> l[i] >> r[i];
    for (int i = 1; i <= n; i++)
        dfs(i, i, -1);
    int q;
    cin >> q;
    int cur = 1;
    for (int i = 1; i <= n; i++)
        cur = mul(cur, (r[i] - l[i] + 1));
    while (q--) {
        fill(used, used + N, 0);
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        auto p1 = path[a][b], p2 = path[c][d];
        int k = p1.size();
        for (int i = 0; i < k; i++) {
            int v = get(p1[i]), u = get(p2[i]);
            if (v == u) continue;
            cur = mul(cur, inv(max(0, r[v] - l[v] + 1)));
            cur = mul(cur, inv(max(0, r[u] - l[u] + 1)));
            merge(v, u);
            v = get(v);
            cur = mul(cur, max(0, r[v] - l[v] + 1));
        }
        cout << cur << '\n';
    }
}

int32_t main() {
    ios::sync_with_stdio(NULL);
    cin.tie(0), cout.tie(0);

    solve();
}
