#include <bits/stdc++.h>

using namespace std;

constexpr int mod = 1e9 + 7;

int binpow(int n, int k) {
    int ans = 1;
    while (k) {
        if (k & 1) {
            ans = ans * 1LL * n % mod;
        }
        n = n * 1LL * n % mod;
        k >>= 1;
    }
    return ans;
}

struct DSU {
    int n;
    vector<int> sz, p;
    vector<pair<int, int>> lr;
    vector<vector<int>> cmp;

    DSU(int _n, vector<pair<int, int>> _lr) {
        n = _n;
        sz.assign(n, 1);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        lr = _lr;
        for (int i = 0; i < n; ++i) {
            cmp[i] = {i};
        }
    }

    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }

    int get_len(int v) {
        v = pr(v);
        return lr[v].second - lr[v].first;
    }

    void unite(int a, int b) {
        a = pr(a), b = pr(b);
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
        lr[a].first = max(lr[a].first, lr[b].first);
        lr[a].second = min(lr[a].second, lr[b].second);
        for (auto v : cmp[b]) {
            cmp[a].push_back(b);
        }
    }
};

constexpr int maxn = 2e5 + 5;

int pr[maxn];

vector<int> g[maxn];

int t = 0;

int tin[maxn], tout[maxn];

void dfs(int v) {
    tin[v] = t++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = t;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
    }
    vector<pair<int, int>> lr(n);
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].first >> lr[i].second;
        lr[i].first--;
        ans = ans * 1LL * (lr[i].second - lr[i].first) % mod;
    }
    DSU dsu(n, lr);
    int m;
    cin >> m;
    vector<int> ord1(n), ord2(n);
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int nw_a = a, nw_c = c;
        while (true) {
            if (dsu.pr(nw_a) != dsu.pr(nw_c)) {
                ans = ans * 1LL * binpow(dsu.get_len(nw_a), mod - 2) % mod;
                ans = ans * 1LL * binpow(dsu.get_len(nw_c), mod - 2) % mod;
                dsu.unite(nw_a, nw_c);
                if (dsu.get_len(nw_a) <= 0) {
                    ans = 0;
                } else {
                    ans = ans * 1LL * dsu.get_len(nw_a) % mod;
                }
            }
            if (nw_a == b) {
                break;
            }
            if (nw_a < b) {
                nw_a++;
            } else {
                nw_a--;
            }
            if (nw_c < d) {
                nw_c++;
            } else {
                nw_c--;
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
