#include <bits/stdc++.h>
#define hash hash_228

using namespace std;

constexpr int mod = 1e9 + 7;

int binpow(int n, int k) {
    int ans = 1;
    while (k) {
        if (k & 1) {
            ans = ans * 1LL * n % mod;
        }
        n = n * 1LL * n % mod;
        k >>= 1;
    }
    return ans;
}

struct DSU {
    int n;
    vector<int> sz, p;
    vector<pair<int, int>> lr;
    vector<vector<int>> cmp;

    DSU(int _n, vector<pair<int, int>> _lr) {
        n = _n;
        sz.assign(n, 1);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        lr = _lr;
        cmp.resize(n);  
        for (int i = 0; i < n; ++i) {
            cmp[i] = {i};
        }
    }

    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }

    int get_len(int v) {
        v = pr(v);
        return lr[v].second - lr[v].first;
    }

    vector<int> get_v(int v) {
        v = pr(v);
        return cmp[v];
    }

    void unite(int a, int b) {
        a = pr(a), b = pr(b);
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
        lr[a].first = max(lr[a].first, lr[b].first);
        lr[a].second = min(lr[a].second, lr[b].second);
        for (auto v : cmp[b]) {
            cmp[a].push_back(v);
        }
    }
};

constexpr int maxn = 2e5 + 5;

int pr[maxn];

vector<int> g[maxn];

int t = 0;

int tin[maxn], tout[maxn];

void dfs(int v) {
    tin[v] = t++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = t;
}

vector<int> get_ord(int a, int b) {
    vector<int> ans, _ans;
    int v = a;
    while (!(tin[v] <= tin[b] && tout[b] <= tout[v])) {
        ans.push_back(v);
        v = pr[v];
    }
    ans.push_back(v);
    v = b;
    while (!(tin[v] <= tin[a] && tout[a] <= tout[v])) {
        _ans.push_back(v);
        v = pr[v];
    }
    reverse(_ans.begin(), _ans.end());
    for (auto vl : _ans) {
        ans.push_back(vl);
    }
    return ans;
}

constexpr int base = 2e5 + 11;

int pw[maxn];

constexpr int R = 1 << 18;

int hash[R * 2], _hash[R * 2];

void build(int node = 1, int nl = 0, int nr = R) {
    if (nl == nr - 1) {
        return;
    }
    int nm = (nl + nr) / 2;
    build(node * 2, nl, nm);
    build(node * 2 + 1, nm, nr);
    hash[node] = (hash[node * 2] * 1LL * pw[nr - nm] % mod + hash[node * 2 + 1]);
    if (hash[node] >= mod) {
        hash[node] -= mod;
    }
    _hash[node] = (_hash[node * 2 + 1] * 1LL * pw[nm - nl] % mod + _hash[node * 2]);
    if (_hash[node] >= mod) {
        _hash[node] -= mod;
    }
}

pair<int, int> get(int l, int r) {
    if (l > r) {
        swap(l, r);
    }
    l += R;
    r += R;
    int hash_pr = 0, hash_suf = 0, pr_len = 0, suf_len = 0;
    int _hash_pr = 0, _hash_suf = 0;
    int len = 1;
    while (l < r) {
        if (l & 1) {
            hash_pr = hash_pr * 1LL * pw[len] % mod + hash[l];
            if (hash_pr >= mod) {
                hash_pr -= mod;
            }
            _hash_pr = _hash_pr + _hash[l] * 1LL * pw[pr_len] % mod;
            if (_hash_pr >= mod) {
                _hash_pr -= mod;
            }
            pr_len += len;
            l++;
        }
        if (r & 1) {
            --r;
            hash_suf = hash[r] * 1LL * pw[suf_len] % mod + hash_suf;
            if (hash_suf >= mod) {
                hash_suf -= mod;
            }
            _hash_suf = _hash[r] + _hash_suf * 1LL * pw[len] % mod;
            if (_hash_suf >= mod) {
                _hash_suf -= mod;
            }
            suf_len += len;
        }
        l >>= 1;
        r >>= 1;
        len *= 2;
    }
    hash_pr = hash_pr * 1LL * pw[suf_len] % mod + hash_suf;
    if (hash_pr >= mod) {
        hash_pr -= mod;
    }
    _hash_pr = _hash_pr + _hash_suf * 1LL * pw[pr_len] % mod;
    if (_hash_pr >= mod) {
        _hash_pr -= mod;
    }
    return {hash_pr, _hash_pr};
}

void change(int pos, int val) {
    pos += R;
    hash[pos] = _hash[pos] = val;
    int len = 1;
    for (pos /= 2; pos > 0; pos /= 2, len *= 2) {
        hash[pos] = hash[pos * 2] * 1LL * pw[len] % mod + hash[pos * 2 + 1];
        if (hash[pos] >= mod) {
            hash[pos] -= mod;
        }
        _hash[pos] = _hash[pos * 2] + _hash[pos * 2 + 1] * 1LL * pw[len] % mod;
        if (_hash[pos] >= mod) {
            _hash[pos] -= mod;
        }
    }
}

/*
4
1 2 3
1 5
1 5
1 5
1 5
2
1 4 4 1
1 2 2 1
*/

void solve() {
    int n;
    cin >> n;
    bool check = true;
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
        if (pr[i] != i - 1) {
            check = false;
        }
        g[pr[i]].push_back(i);
    }
    dfs(0);
    vector<pair<int, int>> lr(n);
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].first >> lr[i].second;
        lr[i].first--;
        ans = ans * 1LL * (lr[i].second - lr[i].first) % mod;
    }
    DSU dsu(n, lr);
    if (!check) {
        int m;
        cin >> m;
        while (m--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            a--, b--, c--, d--;
            vector<int> ord1 = get_ord(a, b), ord2 = get_ord(c, d);
            for (int i = 0; i < (int)ord1.size(); ++i) {
                int nw_a = ord1[i], nw_c = ord2[i];
                if (dsu.pr(nw_a) != dsu.pr(nw_c)) {
                    ans = ans * 1LL * binpow(dsu.get_len(nw_a), mod - 2) % mod;
                    ans = ans * 1LL * binpow(dsu.get_len(nw_c), mod - 2) % mod;
                    dsu.unite(nw_a, nw_c);
                    if (dsu.get_len(nw_a) <= 0) {
                        ans = 0;
                    } else {
                        ans = ans * 1LL * dsu.get_len(nw_a) % mod;
                    }
                }
            }
            cout << ans << '\n';
        }
    } else {
        pw[0] = 1;
        for (int i = 1; i < maxn; ++i) {
            pw[i] = pw[i - 1] * 1LL * base % mod;
        }
        for (int i = 0; i < n; ++i) {
            hash[i + R] = _hash[i + R] = i + 1;
        }
        build();
        int m;
        cin >> m;
        while (m--) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            a--, b--, c--, d--;
            if (tin[a] > tin[b]) {
                swap(a, b);
                swap(c, d);
            }
            int prv_l = -1;
            while (true) {
                auto p1 = get(a, b + 1), p2 = get(min(c, d), max(c, d) + 1);
                if (c < d) {
                    if (p1.first == p2.first) {
                        break;
                    }
                } else {
                    if (p1.first == p2.second) {
                        break;
                    }
                }
                int l = 0, r = abs(a - b) + 1;
                while (l < r - 1) {
                    int m = (l + r) / 2;
                    if (c < d) {
                        auto p1 = get(a, a + m), p2 = get(c, c + m);
                        if (p1.first == p2.first) {
                            l = m;
                        } else {
                            r = m;
                        }
                    } else {
                        auto p1 = get(a, a + m), p2 = get(c - m + 1, c + 1);
                        if (p1.first == p2.second) {
                            l = m;
                        } else {
                            r = m;
                        }
                    }
                }
                assert(l > prv_l);
                prv_l = l;
                int v1 = a + l, v2 = c + l;
                if (c > d) {
                    v2 = c - l;
                }
                int nw_a = v1, nw_c = v2;
                vector<int> ord;
                if (dsu.sz[dsu.pr(v1)] >= dsu.sz[dsu.pr(v2)]) {
                    ord = dsu.get_v(v2);
                } else {
                    ord = dsu.get_v(v1);
                }
                if (dsu.pr(nw_a) != dsu.pr(nw_c)) {
                    ans = ans * 1LL * binpow(dsu.get_len(nw_a), mod - 2) % mod;
                    ans = ans * 1LL * binpow(dsu.get_len(nw_c), mod - 2) % mod;
                    dsu.unite(nw_a, nw_c);
                    if (dsu.get_len(nw_a) <= 0) {
                        ans = 0;
                    } else {
                        ans = ans * 1LL * dsu.get_len(nw_a) % mod;
                    }
                }
                for (auto v : ord) {
                    change(v, dsu.pr(v) + 1);
                }
                // for (int v = 0; v < n; ++v) {
                //     change(v, dsu.pr(v) + 1);
                // }
            }
            cout << ans << '\n';
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
