#include <bits/stdc++.h>
#define hash hash_228

using namespace std;

constexpr int mod = 1e9 + 7;

int binpow(int n, int k) {
    int ans = 1;
    while (k) {
        if (k & 1) {
            ans = ans * 1LL * n % mod;
        }
        n = n * 1LL * n % mod;
        k >>= 1;
    }
    return ans;
}

struct DSU {
    int n;
    vector<int> sz, p;
    vector<pair<int, int>> lr;
    vector<vector<int>> cmp;

    DSU(int _n, vector<pair<int, int>> _lr) {
        n = _n;
        sz.assign(n, 1);
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        lr = _lr;
        cmp.resize(n);  
        for (int i = 0; i < n; ++i) {
            cmp[i] = {i};
        }
    }

    int pr(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pr(p[v]);
    }

    int get_len(int v) {
        v = pr(v);
        return lr[v].second - lr[v].first;
    }

    vector<int> get_v(int v) {
        v = pr(v);
        return cmp[v];
    }

    void unite(int a, int b) {
        a = pr(a), b = pr(b);
        if (sz[a] < sz[b]) {
            swap(a, b);
        }
        sz[a] += sz[b];
        p[b] = a;
        lr[a].first = max(lr[a].first, lr[b].first);
        lr[a].second = min(lr[a].second, lr[b].second);
        for (auto v : cmp[b]) {
            cmp[a].push_back(v);
        }
    }
};

constexpr int maxn = 2e5 + 5;

int pr[maxn], pr_hld[maxn];

int d[maxn];

int sz[maxn];

vector<int> g[maxn];

void calc_sz(int v) {
    sz[v] = 1;
    for (auto u : g[v]) {
        d[u] = d[v] + 1;
        calc_sz(u);
        sz[v] += sz[u];
    }
    for (int i = 1; i < (int)g[v].size(); ++i) {
        if (sz[g[v][i]] > sz[g[v][0]]) {
            swap(g[v][i], g[v][0]);
        }
    }
}

int t = 0;

int tin[maxn], tout[maxn];

vector<int> ord;

void dfs(int v) {
    tin[v] = t++;
    ord.push_back(v);
    for (auto u : g[v]) {
        if (u == g[v][0]) {
            pr_hld[u] = pr_hld[v];
            dfs(u);
        } else {
            pr_hld[u] = u;
            dfs(u);
        }
    }
    tout[v] = t;
}

vector<int> get_ord(int a, int b) {
    vector<int> ans, _ans;
    int v = a;
    while (!(tin[v] <= tin[b] && tout[b] <= tout[v])) {
        ans.push_back(v);
        v = pr[v];
    }
    ans.push_back(v);
    v = b;
    while (!(tin[v] <= tin[a] && tout[a] <= tout[v])) {
        _ans.push_back(v);
        v = pr[v];
    }
    reverse(_ans.begin(), _ans.end());
    for (auto vl : _ans) {
        ans.push_back(vl);
    }
    return ans;
}

constexpr int base = 2e5 + 11;

int pw[maxn];

constexpr int R = 1 << 18;

int hash[R * 2], _hash[R * 2];

void build(int node = 1, int nl = 0, int nr = R) {
    if (nl == nr - 1) {
        return;
    }
    int nm = (nl + nr) / 2;
    build(node * 2, nl, nm);
    build(node * 2 + 1, nm, nr);
    hash[node] = (hash[node * 2] * 1LL * pw[nr - nm] % mod + hash[node * 2 + 1]);
    if (hash[node] >= mod) {
        hash[node] -= mod;
    }
    _hash[node] = (_hash[node * 2 + 1] * 1LL * pw[nm - nl] % mod + _hash[node * 2]);
    if (_hash[node] >= mod) {
        _hash[node] -= mod;
    }
}

pair<int, int> get(int l, int r) {
    if (l > r) {
        swap(l, r);
    }
    l += R;
    r += R;
    int hash_pr = 0, hash_suf = 0, pr_len = 0, suf_len = 0;
    int _hash_pr = 0, _hash_suf = 0;
    int len = 1;
    while (l < r) {
        if (l & 1) {
            hash_pr = hash_pr * 1LL * pw[len] % mod + hash[l];
            if (hash_pr >= mod) {
                hash_pr -= mod;
            }
            _hash_pr = _hash_pr + _hash[l] * 1LL * pw[pr_len] % mod;
            if (_hash_pr >= mod) {
                _hash_pr -= mod;
            }
            pr_len += len;
            l++;
        }
        if (r & 1) {
            --r;
            hash_suf = hash[r] * 1LL * pw[suf_len] % mod + hash_suf;
            if (hash_suf >= mod) {
                hash_suf -= mod;
            }
            _hash_suf = _hash[r] + _hash_suf * 1LL * pw[len] % mod;
            if (_hash_suf >= mod) {
                _hash_suf -= mod;
            }
            suf_len += len;
        }
        l >>= 1;
        r >>= 1;
        len *= 2;
    }
    hash_pr = hash_pr * 1LL * pw[suf_len] % mod + hash_suf;
    if (hash_pr >= mod) {
        hash_pr -= mod;
    }
    _hash_pr = _hash_pr + _hash_suf * 1LL * pw[pr_len] % mod;
    if (_hash_pr >= mod) {
        _hash_pr -= mod;
    }
    return {hash_pr, _hash_pr};
}

void change(int pos, int val) {
    pos += R;
    hash[pos] = _hash[pos] = val;
    int len = 1;
    for (pos /= 2; pos > 0; pos /= 2, len *= 2) {
        hash[pos] = hash[pos * 2] * 1LL * pw[len] % mod + hash[pos * 2 + 1];
        if (hash[pos] >= mod) {
            hash[pos] -= mod;
        }
        _hash[pos] = _hash[pos * 2] + _hash[pos * 2 + 1] * 1LL * pw[len] % mod;
        if (_hash[pos] >= mod) {
            _hash[pos] -= mod;
        }
    }
}

/*
4
1 2 3
1 5
1 5
1 5
1 5
2
1 4 4 1
1 2 2 1
*/

constexpr int lg = 20;

int go[lg][maxn];

int lca(int a, int b) {
    if (tin[a] <= tin[b] && tout[b] <= tout[a]) {
        return a;
    }
    if (tin[b] <= tin[a] && tout[a] <= tout[b]) {
        return b;
    }
    int v = a;
    for (int i = lg - 1; i >= 0; --i) {
        if (!(tin[go[i][v]] <= tin[b] && tout[b] <= tout[go[i][v]])) {
            v = go[i][v];
        }
    }
    return go[0][v];
}

vector<pair<int, int>> get_path(int a, int b) {
    int c = lca(a, b);
    vector<pair<int, int>> ans, _ans;
    int nw = a;
    while (!(tin[nw] <= tin[b] && tout[b] <= tout[nw])) {
        ans.emplace_back(tin[nw], max(tin[c] + 1, tin[pr_hld[nw]]));
        nw = pr[pr_hld[nw]];
    }
    ans.emplace_back(tin[c], tin[c]);
    nw = b;
    while (!(tin[nw] <= tin[a] && tout[a] <= tout[nw])) {
        _ans.emplace_back(max(tin[c] + 1, tin[pr_hld[nw]]), tin[nw]);
        nw = pr[pr_hld[nw]];
    }
    reverse(_ans.begin(), _ans.end());
    for (auto p : _ans) {
        ans.push_back(p);
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;
    bool check = true;
    for (int i = 1; i < n; ++i) {
        cin >> pr[i];
        pr[i]--;
        if (pr[i] != i - 1) {
            check = false;
        }
        g[pr[i]].push_back(i);
    }
    for (int i = 0; i < n; ++i) {
        go[0][i] = pr[i];
    }
    for (int i = 1; i < lg; ++i) {
        for (int j = 0; j < n; ++j) {
            go[i][j] = go[i - 1][go[i - 1][j]];
        }
    }
    calc_sz(0);
    dfs(0);
    vector<pair<int, int>> lr(n);
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> lr[i].first >> lr[i].second;
        lr[i].first--;
        ans = ans * 1LL * (lr[i].second - lr[i].first) % mod;
    }
    DSU dsu(n, lr);
    pw[0] = 1;
    for (int i = 1; i < maxn; ++i) {
        pw[i] = pw[i - 1] * 1LL * base % mod;
    }
    for (int i = 0; i < n; ++i) {
        hash[tin[i] + R] = _hash[tin[i] + R] = i + 1;
    }
    build();
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        auto path1 = get_path(a, b), path2 = get_path(c, d);
        int pos1 = 0, ind1 = 0, pos2 = 0, ind2 = 0;
        while (pos1 < (int) path1.size()) {
            int len = min(abs(path1[pos1].first - path1[pos1].second) + 1 - ind1, abs(path2[pos2].first - path2[pos2].second) + 1 - ind2);
            auto check = [&](int len) {
                pair<int, int> p1, p2;
                int hash1, hash2;
                if (path1[pos1].first < path1[pos1].second) {
                    p1 = get(path1[pos1].first + ind1, path1[pos1].first + ind1 + len);
                    hash1 = p1.first;
                } else {
                    p1 = get(path1[pos1].first - ind1 - len + 1, path1[pos1].first - ind1 + 1);
                    hash1 = p1.second;
                }
                if (path2[pos2].first < path2[pos2].second) {
                    p2 = get(path2[pos2].first + ind2, path2[pos2].first + ind2 + len);
                    hash2 = p2.first;
                } else {
                    p2 = get(path2[pos2].first - ind2 - len + 1, path2[pos2].first - ind2 + 1);
                    hash2 = p2.second;
                }
                return hash1 == hash2;
            };
            if (check(len)) {
                ind1 += len;
                if (ind1 == abs(path1[pos1].first - path1[pos1].second) + 1) {
                    pos1++;
                    ind1 = 0;
                }
                ind2 += len;
                if (ind2 == abs(path2[pos2].first - path2[pos2].second) + 1) {
                    pos2++;
                    ind2 = 0;
                }
                continue;
            }
            int l = 0, r = len;
            while (l < r - 1) {
                int m = (l + r) / 2;
                if (check(m)) {
                    l = m;
                } else {
                    r = m;
                }
            }
            int v1, v2;
            if (path1[pos1].first < path1[pos1].second) {
                v1 = path1[pos1].first + ind1 + l;
            } else {
                v1 = path1[pos1].first - ind1 - l;
            }
            if (path2[pos2].first < path2[pos2].second) {
                v2 = path2[pos2].first + ind2 + l;
            } else {
                v2 = path2[pos2].first - ind2 - l;
            }
            int nw_a = ord[v1], nw_c = ord[v2];
            v1 = ord[v1], v2 = ord[v2];
            // cout << v1 << ' ' << tin[nw_a] << ' ' << v2 << ' ' << tin[nw_c] << endl;
            vector<int> ord_nw;
            if (dsu.sz[dsu.pr(v1)] >= dsu.sz[dsu.pr(v2)]) {
                ord_nw = dsu.get_v(v2);
            } else {
                ord_nw = dsu.get_v(v1);
            }
            if (dsu.pr(nw_a) != dsu.pr(nw_c)) {
                ans = ans * 1LL * binpow(dsu.get_len(nw_a), mod - 2) % mod;
                ans = ans * 1LL * binpow(dsu.get_len(nw_c), mod - 2) % mod;
                dsu.unite(nw_a, nw_c);
                if (dsu.get_len(nw_a) <= 0) {
                    ans = 0;
                } else {
                    ans = ans * 1LL * dsu.get_len(nw_a) % mod;
                }
            }
            for (auto v : ord_nw) {
                change(tin[v], dsu.pr(v) + 1);
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
