#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
typedef long long ll;
using namespace std;

vector<int> g[200500];
int up[20][200500];
int deep[200500];
int tin[200500];
int tout[200500];
int timer = 0;
void dfs(int u) {
    tin[u] = timer++;
    for (int v : g[u]) {
        deep[v] = deep[u] + 1;
        dfs(v);
    }
    tout[u] = timer++;
}

int la(int u, int dist) {
    for (int i = 19; i >= 0; i--) {
        if (dist & (1 << i)) {
            u = up[i][u];
        }
    }
    return u;
}

bool is_parent(int a, int b) {
    return tin[a] <= tin[b] && tin[b] <= tout[a];
}

int lca(int a, int b) {
    if (is_parent(a, b)) return a;
    if (is_parent(b, a)) return b;
    for (int i = 19; i >= 0; i--) {
        if (!is_parent(up[i][a], b)) {
            a = up[i][a];
        }
    }
    return up[0][a];
}

int dist(int u, int v) {
    int c = lca(u, v);
    return deep[u] + deep[v] - 2 * deep[c];
}

int ith(int a, int b, int i) {
    int c = lca(a, b);
    int len = deep[b] + deep[a] - 2 * deep[c];
    if (deep[a] - deep[c] >= i) {
        return la(a, i);
    } else {
        return la(b, len - i);
    }
}

constexpr ll mod = 1e9 + 7;

ll bpow(ll a, ll b) {
    ll res = 1;
    while (b) {
        if (b & 1) {
            res = res * a % mod;
        }
        a = a * a % mod;
        b >>= 1;
    }
    return res;
}

struct dsu {
    int n = 0;
    vector<int> p;
    vector<int> sz;
    vector<pair<int, int>> seg;
    ll val = 1;
    dsu(int n) : n(n) {
        p.resize(n + 1);
        iota(p.begin(), p.end(), 0);
        sz.assign(n + 1, 1);
        seg.resize(n + 1);
        for (int u = 1; u <= n; u++) {
            cin >> seg[u].first >> seg[u].second;
            val = val * (seg[u].second - seg[u].first + 1) % mod;
        }
    }
    int get(int i) {
        if (i == p[i]) {
            return i;
        } else {
            return p[i] = get(p[i]);
        }
    }
    void join(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) return;
        if (sz[v] > sz[u]) swap(u, v);
        val = val * bpow((seg[u].second - seg[u].first + 1), mod - 2) % mod;
        val = val * bpow((seg[v].second - seg[v].first + 1), mod - 2) % mod;
        p[v] = u;
        sz[u] += sz[v];
        seg[u].first = max(seg[u].first, seg[v].first);
        seg[u].second = min(seg[u].second, seg[v].second);
        if (seg[u].first > seg[u].second) {
            val = 0;
        } else {
            val = val * (seg[u].second - seg[u].first + 1) % mod;
        }
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    up[0][1] = 1;
    for (int u = 2; u <= n; u++) {
        int v;
        cin >> v;
        up[0][u] = v;
        g[v].push_back(u);
    }
    dfs(1);
    for (int u = 1; u <= n; u++) {
        for (int i = 1; i < 20; i++) {
            up[i][u] = up[i - 1][up[i - 1][u]];
        }
    }

    dsu Q(n);

    int m;
    cin >> m;

    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int len = dist(a, b);
        for (int i = 0, j = 0; i <= len && j <= len; i++, j++) {
            int u = ith(a, b, i);
            int v = ith(c, d, j);
            Q.join(u, v);
        }
//        for (int i = 0, j = 0; i <= len && j <= len;) {
//            int u = ith(a, b, i);
//            int v = ith(c, d, j);
//            Q.join(u, v);
//            {
//                int l = i, r = len + 1;
//                while (r - l > 1) {
//                    int mid = (l + r) / 2;
//                    if (Q.get(ith(a, b, mid)) == Q.get(u)) {
//                        l = mid;
//                    } else {
//                        r = mid;
//                    }
//                }
//                i = r;
//            }
//            {
//                int l = j, r = len + 1;
//                while (r - l > 1) {
//                    int mid = (l + r) / 2;
//                    if (Q.get(ith(c, d, mid)) == Q.get(v)) {
//                        l = mid;
//                    } else {
//                        r = mid;
//                    }
//                }
//                j = r;
//            }
//            tie(i, j) = tuple(min(i, j), min(i, j));
//        }
        cout << Q.val << "\n";
    }
    return 0;
}
