#include <bits/stdc++.h>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

typedef int64_t ll;
typedef uint64_t ull;

const int INF = 1e9 + 117;
const int lg = 19;
const int M = 1e9 + 7;

int n, m;
vector<int> p, tin, tout;
vector<vector<int>> g, binpws;
vector<pair<int, int>> edges;
int kkk = 1;

void calc_binpws(int v) {
    if (v != 0) {
        binpws[v][0] = p[v];
        for (int i = 1; i < lg; ++i) {
            binpws[v][i] = binpws[binpws[v][i - 1]][i - 1];
        }
    }
    tin[v] = kkk++;
    for (auto& e : g[v]) {
        calc_binpws(e);
    }
    tout[v] = kkk++;
}

bool is_pred(int u, int v) { // is u pred_dsu v
    if (tin[u] <= tin[v] && tout[u] >= tout[v]) return true;
    return false;
}

int get_lca(int u, int v) {
    if (is_pred(u, v)) return u;
    if (is_pred(v, u)) return v;
    int ind = lg - 1;
    while (ind >= 0) {
        if (!is_pred(binpws[v][ind], u)) {
            v = binpws[v][ind];
        }
        ind--;
    }
    return p[v];
}

vector<int> get_way(int u, int v) {
    int lca = get_lca(u, v);
    vector<int> way;
    if (lca == u) {
        while (v != u) {
            way.push_back(v);
            v = p[v];
        }
        way.push_back(u);
        reverse(way.begin(), way.end());
        return way;
    }
    if (lca == v) {
        while (u != v) {
            way.push_back(u);
            u = p[u];
        }
        way.push_back(v);
        return way;
    }
    while (u != lca) {
        way.push_back(u);
        u = p[u];
    }
    vector<int> sc;
    while (v != lca) {
        sc.push_back(v);
        v = p[v];
    }
    sc.push_back(lca);
    reverse(sc.begin(), sc.end());
    for (auto& e : sc) way.push_back(e);
    return way;
}

pair<int, int> unite_edges(pair<int, int>& fs, pair<int, int>& sc) {
    if (sc.first > fs.second || sc.second < fs.first) return {-INF, -INF - 1};
    if (sc.first >= fs.first && sc.second <= fs.second) return sc;
    if (fs.first >= sc.first && fs.second <= sc.second) return fs;
    if (fs.first < sc.first) {
        return {sc.first, fs.second};
    } else {
        return {fs.first, sc.second};
    }
}

struct DSU {
    int n;
    vector<int> pred_dsu;
    vector<vector<int>> st_dsu;
    vector<pair<int, int>> edges_dsu;


    DSU (int _n) {
        n = _n;
        pred_dsu.resize(n);
        st_dsu.resize(n);
        edges_dsu.resize(n);
        for (int i = 0; i < n; ++i) {
            pred_dsu[i] = i;
            st_dsu[i].push_back(i);
            edges_dsu[i] = edges[i];
        }
    }

    void unite(int u, int v) {
        if (pred_dsu[u] == pred_dsu[v]) return;
        int from, to;
        if (st_dsu[pred_dsu[u]].size() < st_dsu[pred_dsu[v]].size()) {
            from = pred_dsu[u];
            to = pred_dsu[v];
        } else {
            from = pred_dsu[v];
            to = pred_dsu[u];
        }
        edges_dsu[to] = unite_edges(edges_dsu[from], edges_dsu[to]);
        while (!st_dsu[from].empty()) {
            pred_dsu[st_dsu[from].back()] = to;
            st_dsu[to].push_back(st_dsu[from].back());
            st_dsu[from].pop_back();
        }
    }
};

int main() {
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fast();
    cin >> n;
    p.resize(n, 0); g.resize(n);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    edges.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> edges[i].first >> edges[i].second;
    }
    binpws.resize(n, vector<int> (lg, 0));
    tin.resize(n); tout.resize(n);
    calc_binpws(0);
    cin >> m;
    DSU dsu(n);
    ll ans;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vector<int> way1 = get_way(a, b);
        vector<int> way2 = get_way(c, d);
        for (int j = 0; j < way1.size(); ++j) {
            dsu.unite(way1[j], way2[j]);
        }
        ans = 1;
        set<int> usd;
        for (int j = 0; j < n; ++j) {
            if (usd.find(dsu.pred_dsu[j]) != usd.end()) continue;
            usd.insert(dsu.pred_dsu[j]);
            auto& [l, r] = dsu.edges_dsu[dsu.pred_dsu[j]];
            if (r - l + 1 == 0) {
                for (int k = i; k < m; ++k) cout << "0\n";
                return 0;
            }
            ans *= (r - l + 1);
            ans %= M;
        }
        cout << ans << '\n';
    }
    return 0;
}
