#include<iostream>
#include<vector>
#include<queue>
#include<algorithm>
#include<map>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;
const int mod = 1e9 + 7;
vec<int> id;
vec<int> rang;
vec<int> p;
vec<int> tin;
vec<int> tout;
vec<vec<int>> g;
vec<vec<int>> du;
int t = 0, deg = 30;

int get(int a) {
	if (id[a] == a)
		return a;
	id[a] = get(id[a]);
	return id[a];
}

void merge(int a, int b) {
	a = get(a);
	b = get(b);
	if (a == b)
		return;
	if (rang[a] > rang[b])
		swap(a, b);
	rang[b] += rang[a];
	id[a] = b;
}

void dfs(int v, int pr) {
	tin[v] = t++;
	du[0][v] = pr;
	for (int i = 1; i < deg; i++) {
		du[i][v] = du[i - 1][du[i - 1][v]];
	}
	for (auto u : g[v])
		if (u != pr) {
			dfs(u, v);
		}
	tout[v] = t++;
}

int is_accessor(int a, int b) {
	return (tin[a] < tin[b] && tout[a] > tout[b]);
}

int lca(int a, int b) {
	if (is_accessor(a, b))
		return a;
	if (is_accessor(b, a))
		return b;
	for (int i = deg - 1; i >= 0; i--)
		if (!is_accessor(du[i][a], b))
			a = du[i][a];
	return du[0][a];
}

vec<int> getpath(int a, int b) {
	int ab = lca(a, b);
	vec<int> ap;
	if (a == ab) {
		while (b != ab) {
			ap.push_back(b);
			b = p[b];
		}
		ap.push_back(ab);
		reverse(all(ap));
	}
	else if (b == ab) {
		while (a != ab) {
			ap.push_back(a);
			a = p[a];
		}
		ap.push_back(ab);
	}
	else {
		vec<int> tmp;
		while (a != ab) {
			ap.push_back(a);
			a = p[a];
		}
		ap.push_back(ab);
		while (b != ab) {
			tmp.push_back(b);
			b = p[b];
		}
		for (int i = sz(tmp) - 1; i >= 0; i--)
			ap.push_back(tmp[i]);
	}
	return ap;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n;
	cin >> n;
	p.resize(n);
	id.resize(n);
	g.resize(n);
	tin.resize(n);
	tout.resize(n);
	du.assign(deg, vec<int>(n));
	rang.assign(n, 1);
	for (int i = 0; i < n; i++)
		id[i] = i;
	for (int i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
		g[p[i]].push_back(i);
	}
	g[0].push_back(0);
	vec<ll> l(n);
	vec<ll> r(n);
	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	int m;
	cin >> m;
	dfs(0, 0);
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--, c--, d--;
		vec<int> ap = getpath(a, b);
		vec<int> cp = getpath(c, d);
		for (int i = 0; i < sz(ap); i++)
			merge(ap[i], cp[i]);
		map<int, vec<int>> s;
		for (int i = 0; i < n; i++)
			s[get(i)].push_back(i);
		ll res = 1;
		for (auto& el : s) {
			ll l0 = -1e10, r0 = 1e10;
			for (auto num : el.second) {
				l0 = max(l0, l[num]);
				r0 = min(r0, r[num]);
			}
			if (r0 < l0)
				res = 0;
			res *= 1LL * (r0 - l0 + 1);
			res %= mod;
		}
		cout << res << "\n";
	}

} 