#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;


using namespace std;

vector<vector<int>> edge;
vector<int> p, sz, L, R, maxl, minr, tin, tout, parents;
vector<int> V1, V2, V3, V4;
int NXT = 0;
int n, m;

void cntt(int u, int p) {
    tin[u] = NXT++;
    for (int v : edge[u]) {
        if (v != p) {
            cntt(v, u);
        }
    }
    tout[u] = NXT++;
}

int get_p(int u) {
    if (p[u] == u) {
        return u;
    }
    return p[u] = get_p(p[u]);
}

void unite(int u, int v) {
    u = get_p(u);
    v = get_p(v);
    if (u == v) {
        return;
    }
    sz[u] += sz[v];
    p[v] = u;
    minr[u] = min(minr[u], minr[v]);
    maxl[u] = max(maxl[u], maxl[v]);
}

bool check_p(int p, int u) {
    return (tin[p] <= tin[u] && tout[u] <= tout[p]);
}

ll solve(int a, int b, int c, int d) {
    V1.clear(); V2.clear();
    V3.clear(); V4.clear();
    while (!check_p(a, b)) {
        V1.push_back(a);
        a = parents[a];
    }
    V1.push_back(a);
    while (b != a) {
        V2.push_back(b);
        b = parents[b];
    }
    while (!check_p(c, d)) {
        V3.push_back(c);
        c = parents[c];
    }
    V3.push_back(c);
    while (c != d) {
        V4.push_back(d);
        d = parents[d];
    }
    reverse(all(V2));
    reverse(all(V4));
    for (int i = 0; i < (int)V1.size() + (int)V2.size(); ++i) {
        int u;
        if (i < (int)V1.size()) {
            u = V1[i];
        } else {
            u = V2[i - (int)V1.size()];
        }
        int v;
        if (i < (int)V3.size()) {
            v = V3[i];
        } else {
            v = V4[i - (int)V3.size()];
        }
        unite(u, v);
    }
    ll ans = 1;
    for (int i = 0; i < n; ++i) {
        int P = get_p(i);
        if (i != P) {
            continue;
        }
        if (maxl[i] > minr[i]) {
            ans = 0;
        } else {
            ans = ans * (ll)(minr[i] - maxl[i] + 1) % MOD;
        }
    }
    return ans;
}

void solve() {
    cin >> n;
    p.resize(n);
    iota(all(p), 0);
    sz.resize(n, 1);
    L.resize(n);
    R.resize(n);
    edge.resize(n);
    tin.resize(n);
    tout.resize(n);
    parents.resize(n, 0);
    for (int i = 1; i < n; ++i) {
        cin >> parents[i]; --parents[i];
        edge[parents[i]].push_back(i);
    }
    cntt(0, 0);
    for (int i = 0; i < n; ++i) {
        cin >> L[i] >> R[i];
    }
    maxl = L;
    minr = R;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        cout << solve(a, b, c, d) << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}