#include "bits/stdc++.h"
//#include <bits/extc++.h>

#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

using float_type = double;

constexpr int MAXN = 200005;
int p[MAXN];
vector<int> graph[MAXN];
int h[MAXN];
int l[MAXN], r[MAXN];

constexpr int MOD = 1000000007;

void dfs(int v) {
    for (int ch : graph[v]) {
        h[ch] = h[v] + 1;
        dfs(ch);
    }
}

int pathbuf[4][MAXN];

constexpr inline int invert(int a) {
    ll res = 1;
    for (int shift = 29; shift >= 0; --shift) {
        res = res * res % MOD;
        if ((MOD - 2) >> shift & 1) {
            res = res * a % MOD;
        }
    }
    return res;
}

int ans = 1;
struct StasDSU {
    vector<int> dsu;
    StasDSU(int n) {
        dsu.resize(n, -1);
    }
    int get_root(int v) {
        if (dsu[v] < 0) {
            return v;
        }
        return dsu[v] = get_root(dsu[v]);
    }
    void unite(int u, int v) {
        u = get_root(u);
        v = get_root(v);
        if (u == v) {
            return;
        }
        if (dsu[u] < dsu[v]) {
            swap(u, v);
        }
        if (dsu[u] == dsu[v]) {
            --dsu[v];
        }
        ans = (ans * 1ll * invert(r[u] - l[u] + 1)) % MOD;
        ans = (ans * 1ll * invert(r[v] - l[v] + 1)) % MOD;
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);
        if (l[v] > r[v]) {
            ans = 0;
        } else {
            ans = (ans * 1ll * (r[v] - l[v] + 1)) % MOD;
        }
        dsu[u] = v;
    }
};

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        cin >> p[i];
        graph[p[i]].push_back(i);
    }
    dfs(1);
    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
        ans = ans * 1ll * (r[i] - l[i] + 1) % MOD;
    }
    StasDSU dsu(n + 1);
    int m;
    cin >> m;
    for (int qi = 0; qi < m; ++qi) {
        if (ans == 0) {
            cout << "0\n";
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int pptr[4] = {0, 0, 0, 0};
        while (h[a] > h[b]) {
            pathbuf[0][pptr[0]++] = a;
            a = p[a];
        }
        while (h[b] > h[a]) {
            pathbuf[1][pptr[1]++] = b;
            b = p[b];
        }
        while (h[c] > h[d]) {
            pathbuf[2][pptr[2]++] = c;
            c = p[c];
        }
        while (h[d] > h[c]) {
            pathbuf[3][pptr[3]++] = d;
            d = p[d];
        }
        while (a != b) {
            pathbuf[0][pptr[0]++] = a;
            pathbuf[1][pptr[1]++] = b;
            a = p[a];
            b = p[b];
        }
        pathbuf[0][pptr[0]++] = a;
        while (c != d) {
            pathbuf[2][pptr[2]++] = c;
            pathbuf[3][pptr[3]++] = d;
            c = p[c];
            d = p[d];
        }
        pathbuf[2][pptr[2]++] = c;

        reverse(pathbuf[1], pathbuf[1] + pptr[1]);
        reverse(pathbuf[3], pathbuf[3] + pptr[3]);

        memcpy(pathbuf[0] + pptr[0], pathbuf[1], sizeof(pathbuf[0][0]) * pptr[1]);
        memcpy(pathbuf[2] + pptr[2], pathbuf[3], sizeof(pathbuf[0][0]) * pptr[3]);

        int size = pptr[0] + pptr[1];

        for (int v = 0; v < size; ++v) {
//            cerr << "merging " << pathbuf[0][v] << ' ' << pathbuf[2][v];
            dsu.unite(pathbuf[0][v], pathbuf[2][v]);
//            cerr << "\nans=" << ans << '\n';
        }

        cout << ans << '\n';
//        cerr << ">>> ans = " << ans << "\n\n";
    }
    return 0;
}
