#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<int> pred;
int n;
int m;
vector<pair<ll, ll>> costs;
vector<int> parents;
vector<pair<pair<int, int>, pair<int, int>>> que;
vector<vector<int>> g;
vector<int> sz;
vector<int> levels;
ll ans=1;
ll mod = 1e9+7;
vector<vector<int>>binup;

ll binpow(ll a, ll step) {
    if(step==0)
        return 1;
    if(step&1)
        return a*binpow(a, step-1)%mod;
    ll now = binpow(a, step/2);
    return now*now%mod;
}

int findp(int a){
    if(parents[a]==a)
        return a;
    return parents[a] = findp(parents[a]);
}

void dfs(int st) {
    for(auto &i:g[st]) {
        levels[i]=levels[st]+1;
        dfs(i);
    }
}

int lca(int a, int b) {
    if(levels[a]<levels[b])
        swap(a, b);
    for(int i=24;i>=0;i--){
        if (binup[a][i]!=-1 && levels[binup[a][i]]>=levels[b])
            a=binup[a][i];
    }
    if(a==b)
        return a;
    for(int i=24;i>=0;i--){
        if (binup[a][i]!=binup[b][i]) {
            a = binup[a][i];
            b = binup[b][i];
        }
    }
    return pred[a];
}

void unite(int a, int b) {
    a = findp(a);
    b = findp(b);
    if(a==b)
        return;
    if(sz[a]<sz[b])
        swap(a, b);
    parents[b]=a;
    sz[a]+=sz[b];
    ans*=binpow(costs[a].second-costs[a].first+1, mod-2);
    ans%=mod;
    ans*=binpow(costs[b].second-costs[b].first+1, mod-2);
    ans%=mod;
    costs[a]={max(costs[a].first, costs[b].first), min(costs[a].second, costs[b].second)};
    ans*=(costs[a].second - costs[a].first+1);
    ans%=mod;
}

void solveKv() {
    for(int i=0;i<n;i++){
        ans*=(costs[i].second-costs[i].first+1);
        ans%=mod;
    }
    for(int i = 0; i < m; i++) {
        if(ans==0){
            cout<<0<<"\n";
            continue;
        }
        vector<int>fir;
        vector<int>sec;
        stack<int>bro;
        int a=que[i].first.first, b=que[i].first.second, c=que[i].second.first, d=que[i].second.second;
        while(a!=b) {
            if(levels[a]>levels[b]) {
                fir.push_back(a);
                a = pred[a];
            }
            else
            {
                bro.push(b);
                b=pred[b];
            }
        }
        bro.push(a);
        while(!bro.empty()) {
            fir.push_back(bro.top());
            bro.pop();
        }
        while(c!=d) {
            if(levels[c]>levels[d]) {
                sec.push_back(c);
                c = pred[c];
            }
            else
            {
                bro.push(d);
                d=pred[d];
            }
        }
        bro.push(c);
        while(!bro.empty()) {
            sec.push_back(bro.top());
            bro.pop();
        }
        for(int k = 0;k<fir.size();k++)
            unite(fir[k], sec[k]);
        cout<<ans<<"\n";
    }
}

void solve() {
    cin >> n;
    pred.resize(n);
    costs.resize(n);
    parents.resize(n);
    binup.resize(n, vector<int>(25, -1));
    g.resize(n);
    sz.resize(n, 1);
    levels.resize(n);
    for(int i=1;i<n;i++){
        cin>>pred[i];
        pred[i]--;
        g[pred[i]].push_back(i);
        binup[i][0]=pred[i];
    }

    dfs(0);

    for(int k = 1; k<25;k++)
        for(int i= 0;i<n;i++)
            if(binup[i][k-1]!=-1) binup[i][k] = binup[binup[i][k-1]][k-1];

    for(int i=0; i<n;i++) {
        parents[i]=i;
        cin>> costs[i].first>> costs[i].second;
    }
    cin>>m;
    que.resize(m);
    for(int i = 0; i<m;i++) {
        cin>>que[i].first.first >> que[i].first.second >> que[i].second.first>> que[i].second.second;
        que[i].first.first--; que[i].first.second--; que[i].second.first--; que[i].second.second--;
    }
    solveKv();

}

int main() {
    //cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}