#include <bits/stdc++.h>
#define ff first
#define ss second
#define forn(i, n) for (int i = 0; i < n; i++)

using namespace std;
typedef long long ll;
typedef long double ld;

const ll N = 2e5 + 100, MOD = 1e9 + 7, INF = 0x3f3f3f3f3f3f3f3f;

ll binpow(ll x, ll n) {
    if (n == 0)
        return 1;
    if (n % 2)
        return (x * binpow(x, n - 1)) % MOD;
    ll z = binpow(x, n / 2);
    return (z * z) % MOD;
}

ll n, m, l[N], r[N], sm = 1, x, prec[N], a, b, c, d, binup[N][27], depth[N], ans;
vector<ll> g[N], path[4];

ll dsu[N];

ll find_root(ll v) {
    if (dsu[v] == v)
        return v;
    dsu[v] = find_root(dsu[v]);
    return dsu[v];
}

void merge(ll xx, ll yy) {
    if (rand() % 2)
        swap(xx, yy);
    xx = find_root(xx);
    yy = find_root(yy);
    if (xx == yy)
        return;
    ans = (ans * prec[xx]) % MOD;
    ans = (ans * prec[yy]) % MOD;
    r[xx] = min(r[xx], r[yy]);
    l[xx] = max(l[xx], l[yy]);
    ans = (ans * max(0ll, r[xx] - l[xx] + 1)) % MOD;
    prec[xx] = binpow(max(0ll, r[xx] - l[xx] + 1), MOD - 2);
    dsu[yy] = xx;
}

void precalc(ll v, ll p, ll dd) {
    depth[v] = dd;
    binup[v][0] = p;
    forn(i, 26)
        binup[v][i + 1] = binup[binup[v][i]][i];

    for (auto u : g[v])
        if (u != p)
            precalc(u, v, dd + 1);
}

ll lca(ll xx, ll yy) {
    if (depth[yy] > depth[xx])
        swap(xx, yy);
    for (int i = 26; i > -1; i--) {
        if (depth[binup[xx][i]] > depth[yy])
            xx = binup[xx][i];
    }
    if (depth[xx] > depth[yy])
        xx = binup[xx][0];
    for (int i = 26; i > -1; i--) {
        if (binup[xx][i] != binup[yy][i]) {
            xx = binup[xx][i];
            yy = binup[yy][i];
        }
    }
    if (xx != yy) {
        xx = binup[xx][0];
    }
    return xx;
}

void get_path(ll v, ll f, ll i, bool calclca) {
    if (v == f) {
        if (calclca)
            path[i].push_back(v);
        return;
    }
    path[i].push_back(v);
    for (auto u : g[v])
        if (depth[u] < depth[v])
            get_path(u, f, i, calclca);
}



int main() {
    cout << fixed << setprecision(12);
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    cin >> n;
    forn(i, n - 1) {
        cin >> x; x--;
        g[x].push_back(i + 1);
        g[i + 1].push_back(x);
    }
    forn(i, n) {
        dsu[i] = i;
        cin >> l[i] >> r[i];
        sm = (sm * (r[i] - l[i] + 1)) % MOD;
        prec[i] = binpow((r[i] - l[i] + 1), MOD - 2);
    }
    precalc(0, 0, 0);
    cin >> m;
    ans = sm;
    while (m--) {
        path[0].clear();
        path[1].clear();
        path[2].clear();
        path[3].clear();
        cin >> a >> c >> b >> d; a--; b--; c--; d--;
        ll a1 = lca(a, c), b1 = lca(b, d);

        get_path(a, a1, 0, true);
        get_path(c, a1, 1, false);
        for (int i = path[1].size() - 1; i > -1; i--)
            path[0].push_back(path[1][i]);

        get_path(b, b1, 2, true);
        get_path(d, b1, 3, false);
        for (int i = path[3].size() - 1; i > -1; i--)
            path[2].push_back(path[3][i]);

        forn(i, path[0].size())
            merge(path[0][i], path[2][i]);

        cout << ans << "\n";
    }
    return 0;
}
