#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll K = 2e5 + 10;

ll binpow(ll a, ll n){
    ll ans = 1;
    ll k = a;
    while(n > 0){
        if (n % 2) ans = (ans * k)%MOD;
        k = (k*k)%MOD;
        n/=2;
    }
    return ans;
}

vector<ll> p;
vector<ll> h;
vector<vector<ll>> g;

void dfsh(ll v) {
    h[v] = 0;
    if (p[v] != -1) h[v] = h[p[v]] + 1;
    for (ll i : g[v]) {
        dfsh(i);
    }
}

vector<ll> r;
void getp(ll u, ll v, vector<ll> &ans) {
    ans.clear();
    r.clear();
    while (u != v) {
        if (h[u] == h[v]) {
            ans.push_back(u);
            r.push_back(v);
            u = p[u];
            v = p[v];
        } else if (h[u] < h[v]) {
            r.push_back(v);
            v = p[v];
        } else {
            ans.push_back(u);
            u = p[u];
        }
    }
    r.push_back(v);
    for (ll i = r.size()-1;i>=0;i--){
        ans.push_back(r[i]);
    }
}

struct O{
    ll l, r;
    O() : l(0), r(-1) {}
    O(ll l_, ll r_) : l(l_), r(r_) {
        if (l > r) l = r+1;
    }
    O operator+(const O& a) const{
        return O(max(l, a.l), min(r, a.r));
    }
    ll len() const {
        return r-l+1;
    }
};

int main() {
    fastio();
    ll n;
    cin >> n;
    p.resize(n, -1);
    g.resize(n);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }
    h.resize(n);
    dfsh(0);
    vector<vector<ll>> komp(n);
    vector<ll> col(n);
    vector<O> ot(n);
    ll ans = 1;
    for (ll i = 0;i<n;i++){
        cin >> ot[i].l >> ot[i].r;
        ans = (ans * (ot[i].r - ot[i].l + 1)) % MOD;
    }
    for (ll i = 0;i<n;i++){
        col[i] = i;
        komp[i] = {i};
    }
    ll q;
    cin >> q;
    vector<ll> res1, res2;
    while(q--){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        getp(a, b, res1);
        getp(c, d, res2);
        for (ll i = 0;i<res1.size();i++){
            if (col[res1[i]] != col[res2[i]]){
                ll u = col[res1[i]], v = col[res2[i]];
                if (komp[u].size() < komp[v].size()) swap(u, v);
                ans = ans * binpow(ot[u].len(), MOD - 2) % MOD * binpow(ot[v].len(), MOD - 2) % MOD;
                ot[u] = ot[u]+ot[v];
                ans = ans * ot[u].len() % MOD;
                for (ll j : komp[v]){
                    komp[u].push_back(j);
                    col[j] = u;
                }
            }
        }
        cout << ans << "\n";
    }
    return 0;
}