#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>


using namespace std;
typedef int ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 2e9;
const ll MOD = 1e9 + 7;
const ll K = 2e5 + 10;

long long binpow(ll a, ll n) {
    long long ans = 1;
    long long k = a;
    while (n > 0) {
        if (n % 2) ans = (ans * k) % MOD;
        k = (k * k) % MOD;
        n /= 2;
    }
    return ans;
}

vector<ll> p;
vector<ll> h;
vector<vector<ll>> g;

void dfsh(ll v) {
    h[v] = 0;
    if (p[v] != -1) h[v] = h[p[v]] + 1;
    for (ll i : g[v]) {
        dfsh(i);
    }
}

vector<ll> r;

void getp(ll u, ll v, vector<ll> &ans) {
    ans.clear();
    r.clear();
    while (u != v) {
        if (h[u] == h[v]) {
            ans.push_back(u);
            r.push_back(v);
            u = p[u];
            v = p[v];
        } else if (h[u] < h[v]) {
            r.push_back(v);
            v = p[v];
        } else {
            ans.push_back(u);
            u = p[u];
        }
    }
    r.push_back(v);
    for (ll i = r.size() - 1; i >= 0; i--) {
        ans.push_back(r[i]);
    }
}

struct O {
    ll l, r;

    O() : l(0), r(-1) {}

    O(ll l_, ll r_) : l(l_), r(r_) {
        if (l > r) l = r + 1;
    }

    O operator+(const O &a) const {
        return O(max(l, a.l), min(r, a.r));
    }

    ll len() const {
        return r - l + 1;
    }
};

const ll T = 239017, MAX = 2e5 + 20;
ll powt[MAX];

struct Node {
    ll hash, len;

    Node() : hash(0), len(0) {}

    Node(ll c) : hash(c), len(1) {}

    Node(ll h, ll l) : hash(h), len(l) {}

    Node operator+(const Node &a) const {
        Node ans = Node();
        ans.hash = (((long long)hash * powt[a.len]) + a.hash) % MOD;
        ans.len = len + a.len;
        return ans;
    }
};

struct Segtree {
    vector<Node> t;
    ll sz;

    Segtree() {}

    Segtree(vector<ll> &v) {
        ll n = v.size();
        sz = 1;
        while (sz < n) sz *= 2;
        t.resize(sz * 2, Node());
        for (ll i = 0; i < v.size(); i++) t[sz + i] = Node(v[i]);
        for (ll i = sz - 1; i >= 1; i--) {
            t[i] = t[i * 2] + t[i * 2 + 1];
        }
    }

    void change(ll v, ll c) {
        t[sz + v] = Node(c);
        v = (v + sz) / 2;
        while (v >= 1) {
            t[v] = t[v * 2] + t[v * 2 + 1];
            v /= 2;
        }
    }

    Node get(ll lx, ll rx, ll v = 1, ll l = 0, ll r = -1) {
        if (r == -1) r = sz;
        if (lx <= l && r <= rx) return t[v];
        if (lx >= r || l >= rx) return Node();
        ll mid = (l+r)/2;
        Node res = Node();
        res = res + get(lx, rx, v*2, l, mid);
        res = res + get(lx, rx, v*2+1, mid, r);
        return res;
    }
};

int main() {
    fastio();
    powt[0] = 1;
    for (ll i = 1; i < MAX; i++) {
        powt[i] = ((long long)powt[i - 1] * T) % MOD;
    }
    ll n;
    cin >> n;
    p.resize(n, -1);
    vector<ll> ideal_p(n, -1);
    g.resize(n);
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        ideal_p[i] = i - 1;
        g[p[i]].push_back(i);
    }
    if (ideal_p == p) {
        vector<vector<ll>> komp(n);
        vector<ll> col(n), rcol(n);
        vector<O> ot(n);
        long long ans = 1;
        for (ll i = 0; i < n; i++) {
            cin >> ot[i].l >> ot[i].r;
            ans = (ans * (ot[i].r - ot[i].l + 1)) % MOD;
        }
        for (ll i = 0; i < n; i++) {
            col[i] = i;
            rcol[i] = n-1-i;
            komp[i] = {i};
        }
        vector<Segtree> seg = {Segtree(col), Segtree(rcol)};
        ll q;
        cin >> q;
        while (q--) {
            ll a, b, c, d;
            cin >> a >> b >> c >> d;
            a--;
            b--;
            c--;
            d--;
            ll num1 = 0, num2 = 0;
            if (a > b){
                a = n-1-a;
                b = n-1-b;
                num1=1;
            }
            if (c > d){
                c = n-1-c;
                d=  n-1-d;
                num2=1;
            }
            while(seg[num1].get(a, b+1).hash != seg[num2].get(c, d+1).hash){
                ll l = 0, r = b+1-a;
                while(l+1<r){
                    ll mid = (l+r)/2;
                    if (seg[num1].get(a, a+mid).hash == seg[num2].get(c, c+mid).hash){
                        l = mid;
                    }else{
                        r = mid;
                    }
                }
                ll u = a + r - 1, v = c + r -1;
                a = u+1, c = v+1;
                if (num1) u = n-1-u;
                if (num2) v = n-1-v;
                u = col[u], v = col[v];
                if (komp[u].size() < komp[v].size()) swap(u, v);
                ans = ans * binpow(ot[u].len(), MOD - 2) % MOD * binpow(ot[v].len(), MOD - 2) % MOD;
                ot[u] = ot[u] + ot[v];
                ans = ans * ot[u].len() % MOD;
                for (ll j : komp[v]) {
                    komp[u].push_back(j);
                    col[j] = u;
                    seg[0].change(j, u);
                    seg[1].change(n-1-j, u);
                }
            }
            /*getp(a, b, res1);
            getp(c, d, res2);
            for (ll i = 0; i < res1.size(); i++) {
                if (col[res1[i]] != col[res2[i]]) {
                    ll u = col[res1[i]], v = col[res2[i]];
                    if (komp[u].size() < komp[v].size()) swap(u, v);
                    ans = ans * binpow(ot[u].len(), MOD - 2) % MOD * binpow(ot[v].len(), MOD - 2) % MOD;
                    ot[u] = ot[u] + ot[v];
                    ans = ans * ot[u].len() % MOD;
                    for (ll j : komp[v]) {
                        komp[u].push_back(j);
                        col[j] = u;
                    }
                }
            }*/
            cout << ans << "\n";
        }
    } else {
        h.resize(n);
        dfsh(0);
        vector<vector<ll>> komp(n);
        vector<ll> col(n);
        vector<O> ot(n);
        long long ans = 1;
        for (ll i = 0; i < n; i++) {
            cin >> ot[i].l >> ot[i].r;
            ans = (ans * (ot[i].r - ot[i].l + 1)) % MOD;
        }
        for (ll i = 0; i < n; i++) {
            col[i] = i;
            komp[i] = {i};
        }
        ll q;
        cin >> q;
        vector<ll> res1, res2;
        while (q--) {
            ll a, b, c, d;
            cin >> a >> b >> c >> d;
            a--;
            b--;
            c--;
            d--;
            getp(a, b, res1);
            getp(c, d, res2);
            for (ll i = 0; i < res1.size(); i++) {
                if (col[res1[i]] != col[res2[i]]) {
                    ll u = col[res1[i]], v = col[res2[i]];
                    if (komp[u].size() < komp[v].size()) swap(u, v);
                    ans = ans * binpow(ot[u].len(), MOD - 2) % MOD * binpow(ot[v].len(), MOD - 2) % MOD;
                    ot[u] = ot[u] + ot[v];
                    ans = ans * ot[u].len() % MOD;
                    for (ll j : komp[v]) {
                        komp[u].push_back(j);
                        col[j] = u;
                    }
                }
            }
            cout << ans << "\n";
        }
    }
    return 0;
}
/*

4
1 2 3
1 2
2 3
1 3
1 3
3
3 4 4 3
1 2 4 3
2 3 4 3
 */