#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int mod = 1e9 + 7;
int add(int a, int b) {
    a += b;
    if (a >= mod) a -= mod;
    return a;
}
int sub(int a, int b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}
int mul(int a, int b) {
    return 1ll * a * b % mod;
}
int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}
int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t = 1;
    while (t--) solve();
}

struct DSU {
    vector<int> p, sz, mx, mn;

    void init(vector<int> l, vector<int> r) {
        mx = l;
        mn = r;
        int n = l.size();
        p.assign(n, 0);
        iota(all(p), 0);
        sz.assign(n, 1);
    }

    int anc(int u) {
        return u == p[u] ? u : p[u] = anc(p[u]);
    }

    bool unite(int u, int v) {
        u = anc(u), v = anc(v);
        if (u == v) return 0;
        if (sz[u] < sz[v]) swap(u, v);
        p[v] = u;
        mn[u] = min(mn[u], mn[v]);
        mx[u] = max(mx[u], mx[v]);
        sz[u] += sz[v];
        return 1;
    }

    int MX(int u) {
        return mx[anc(u)];
    }
    int MN(int u) {
        return mn[anc(u)];
    }
};



void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    vector<int> p(n, -1);
    for (int i = 1; i < n; ++i) {
        cin >> p[i], --p[i];
        g[p[i]].push_back(i);
    }
    int all = 1;
    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        ++r[i];
        all = mul(all, r[i] - l[i]);
    }
    vector<int> tin(n), tout(n);
    {
        int t = 0;
        auto dfs = [&](auto dfs, int u) -> void {
            tin[u] = t++;
            for (auto to : g[u]) dfs(dfs, to);
            tout[u] = t++;
        };
        dfs(dfs, 0);
    }
    auto is_anc = [&](int u, int v) {
        return tin[u] <= tin[v] && tin[v] <= tout[u];
    };
    vector<int> p1, p2, p3;
    p1.reserve(n);
    p2.reserve(n);
    p3.reserve(n);
    auto get_path = [&](int u, int v) -> void {
        p1.clear();
        p2.clear();
        while (!is_anc(u, v)) {
            p1.push_back(u);
            u = p[u];
        }
        p1.push_back(u);
        while (!is_anc(v, u)) {
            p2.push_back(v);
            v = p[v];
        }
        reverse(all(p2));
        for (auto i : p2) p1.push_back(i);
        p2.clear();
    };
    DSU dsu;
    dsu.init(l, r);
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        get_path(a, b);
        swap(p1, p3);
        get_path(c, d);
        for (int i = 0; i < p1.size(); ++i) {
            int u = p1[i], v = p3[i];
            if (dsu.anc(u) != dsu.anc(v)) {
                all = mul(all, binpow(max(dsu.MN(u) - dsu.MX(u), 0), mod - 2));
                all = mul(all, binpow(max(dsu.MN(v) - dsu.MX(v), 0), mod - 2));
                dsu.unite(u, v);
                all = mul(all, max(dsu.MN(u) - dsu.MX(u), 0));
            }
        }
        cout << all << '\n';
    }
}