#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define x first
#define y second
#define pb emplace_back

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int MAXN = 2e5 + 10;
const int MOD = 1e9 + 7;

vector<int> gr[MAXN];
int p[MAXN];
int pv[MAXN];
int r[MAXN];
ptll val[MAXN];
ptll seg[MAXN];

int get(int x){
    if (x == pv[x])
        return x;
    return pv[x] = get(pv[x]);
}

void Union(int x, int y){
    x = get(x), y = get(y);
    if (r[x] > r[y])
        swap(x, y);
    pv[x] = y;
    if (r[x] == r[y])
        r[y]++;
    val[y] = {max(val[x].x, val[y].x), min(val[x].y, val[y].y)};
}

vector<int> path1, path2;

bool dfs(int v, int to, int prv){
    path1.push_back(v);
    if (v == to){
        return true;
    }
    for (int u: gr[v]){
        if (u != prv && dfs(u, to, v))
            return true;
    }
    path1.pop_back();
    return false;
}

ll ans;

ll fastpow(ll x, ll y){
    if (!y)
        return 1;
    if (y & 1)
        return fastpow(x, y - 1) * x % MOD;
    ll tmp = fastpow(x, y >> 1);
    return tmp * tmp % MOD;
}

ll rev(ll x){
    return fastpow(x, MOD - 2);
}

void calc(){
    int a, b, c, d;
    cin >> a >> b >> c >> d;
    if (ans == 0)
        return;
    a--, b--, c--, d--;
    path1.clear();
    dfs(a, b, -1);
    swap(path1, path2);
    path1.clear();
    dfs(c, d, -1);
    for (int i = 0; i < sz(path1); i++){
        int u = path1[i], v = path2[i];
        u = get(u), v = get(v);
        if (u != v){
            ans = (ans * rev(val[u].y - val[u].x + 1)) % MOD;
            ans = (ans * rev(val[v].y - val[v].x + 1)) % MOD;
            Union(u, v);
            u = get(u);
            ll nw = max(0ll, (val[u].y - val[u].x + 1));
            ans = (ans * nw) % MOD;
        }
        if (ans == 0)
            return;
    }
}

void run(){
    int n;
    cin >> n;
    for (int i = 1; i < n; i++){
        cin >> p[i];
        p[i]--;
        gr[p[i]].push_back(i);
        gr[i].push_back(p[i]);
    }
    ans = 1;
    for (int i = 0; i < n; i++){
        cin >> seg[i].x >> seg[i].y;
        val[i] = {seg[i].x, seg[i].y};
        ans = (ans * (val[i].y - val[i].x + 1)) % MOD;
    }
    iota(pv, pv + n, 0);
    fill(r, r + n, 1);
    int q;
    cin >> q;
    while (q--){
        calc();
        cout << ans << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
