#include<iostream>
#include<vector>
#include<algorithm>
#include<utility>
#include<cmath>


using namespace std;
typedef long long ll;


vector<int> p;
int mod = 1e9 + 7;
vector<int> tin;
vector<int> tout;
vector<int> pred;
int tim = 0;
vector<vector<int>> g;
vector<int> sz;
vector<int> l;
vector<int> r;
ll ans = 1;


ll power(ll a, ll b)
{
    if (b == 0)
    {
        return 1;
    }
    if (b % 2 == 0)
    {
        ll x = power(a, b / 2);
        return x * x % mod;
    }
    return power(a, b - 1) * a % mod;
}



void dfs(int v, int p)
{
    tim += 1;
    tin[v] = tim;
    for (auto el: g[v])
    {
        if (el != p)
        {
            dfs(el, v);
        }
    }
    tout[v] = tim;
    return;
}


bool is_pred(int u, int v)
{
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}


int find_set(int v)
{
    if (v == pred[v])
    {
        return v;
    }
    return pred[v] = find_set(pred[v]);
}


void union_set(int u, int v)
{
    u = find_set(u);
    v = find_set(v);
    if (u != v)
    {
        if (sz[u] > sz[v])
        {
            swap(u, v);
        }
        sz[v] += sz[u];
        pred[u] = v;
        ans *= power(r[v] - l[v] + 1, mod - 2);
        ans %= mod;
        ans *= power(r[u] - l[u] + 1, mod - 2);
        ans %= mod;
        if (l[v] > r[u] || l[u] > r[v] || min({l[v], r[v], l[u], r[u]}) == -1)
        {
            l[v] = -1;
            r[v] = -1;
            ans = 0;
        }
        else
        {
            l[v] = max(l[v], l[u]);
            r[v] = min(r[v], r[u]);
            ans *= r[v] - l[v] + 1;
            ans %= mod;
        }
    }
    return;
}


void way(vector<int>& ans, int a, int b)
{
    while (!is_pred(a, b))
    {
        ans.push_back(a);
        a = p[a];
    }
    ans.push_back(a);
    vector<int> ans1;
    while (b != a)
    {
        ans1.push_back(b);
        b = p[b];
    }
    for (int i = ans1.size() - 1; i >= 0; i--)
    {
        ans.push_back(ans1[i]);
    }
    return;
}


void get_zapr(int a, int b, int c, int d)
{
    vector<int> way1;
    way(way1, a, b);
    vector<int> way2;
    way(way2, c, d);
    for (int i = 0; i < way1.size(); i++)
    {
        union_set(way1[i], way2[i]);
    }
    return;
}


int main()
{
    int n;
    cin >> n;
    sz.resize(n, 1);
    p.resize(n);
    pred.resize(n);
    g.resize(n);
    l.resize(n);
    tin.resize(n);
    tout.resize(n);
    r.resize(n);
    for (int i = 0; i < n - 1; i++)
    {
        pred[i] = i;
        cin >> p[i + 1];
        p[i + 1]--;
        g[p[i + 1]].push_back(i + 1);
    }
    pred[n - 1] = n - 1;
    for (int i = 0; i < n; i++)
    {
        cin >> l[i] >> r[i];
    }
    dfs(0, 0);
    int m;
    cin >> m;
    for (int i = 0; i < n; i++)
    {
        ans *= r[i] - l[i] + 1;
        ans %= mod;
    }
    for(int i = 0; i < m; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans != 0)   get_zapr(a - 1, b - 1, c - 1, d - 1);
        cout << ans << endl;
    }
    return 0;
}
