#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n;
    vector<in<int>> p;
    vector<pair<in<int>, in<int>>> lim;
    in<int> m;
    struct kek {
        in<int> a, b, c, d;
    };

    vector<kek> children;
    vector<vector<int>> graph;

    struct dsu {
        vector<int> p;

        dsu(int n) : p(n) {
            iota(p.begin(), p.end(), 0);
        }

        int getc(int v) {
            if (p[v] != v) {
                return (p[v] = getc(p[v]));
            }
            return v;
        }

        void merge_two(int v, int u) {
            v = getc(v);
            u = getc(u);
            p[u] = v;
        }
    };

    dsu lol;

    vector<int> depth;
    void DFS(int v, int u) {
        if (v != u) {
            depth[v] = depth[u] + 1;
        }
        for (int w : graph[v]) {
            if (w != u) {
                DFS(w, v);
            }
        }
    }

    int get_lca(int v, int u) {
        if (depth[u] > depth[v]) {
            swap(v, u);
        }
        while (depth[v] > depth[u]) {
            v = p[v];
        }
        while (v != u) {
            v = p[v];
            u = p[u];
        }
        return v;
    }

    const long long MOD = 1'000'000'007;

    long long bin_pow_mod(long long base, unsigned pow) {
        long long res = 1;
        while (pow > 0) {
            if (pow & 1) {
                res = (res * base) % MOD;
            }
            base = (base * base) % MOD;
            pow >>= 1;
        }
        return res;
    }

    solve() : p(n - 1), lim(n), children(m), graph(n), lol(n), depth(n) {
        for (int i = 1; i < n; ++i) {
            --p[i];
            graph[p[i]].push_back(i);
        }
        depth[0] = 0;
        DFS(0, 0);

        for (auto child : children) {
            --child.a;
            --child.b;
            --child.c;
            --child.d;
            int l1 = get_lca(child.a, child.b), l2 = get_lca(child.c, child.d);

            vector<int> p1;
            vector<int> p2;
            int cur = child.a;
            while (cur != l1) {
                p1.push_back(cur);
                cur = p[cur];
            }
            vector<int> tmp;
            cur = child.b;
            while (cur != l1) {
                tmp.push_back(cur);
                cur = p[cur];
            }
            p1.push_back(l1);
            copy(tmp.rbegin(), tmp.rend(), back_inserter(p1));

            cur = child.c;
            while (cur != l2) {
                p2.push_back(cur);
                cur = p[cur];
            }
            tmp.clear();
            cur = child.d;
            while (cur != l2) {
                tmp.push_back(cur);
                cur = p[cur];
            }
            p2.push_back(l2);
            copy(tmp.rbegin(), tmp.rend(), back_inserter(p2));


            for (int i = 0; i < p1.size(); ++i) {
                lol.merge_two(p1[i], p2[i]);
            }

            vector<vector<int>> comps(n);
            for (int i = 0; i < n; ++i) {
                comps[lol.getc(i)].push_back(i);
            }

            long long res = 0;
            for (const auto &comp : comps) {
                if (comp.size() == 0) {
                    continue;
                }

                int cur_min = -1;
                int cur_max = 1'000'000'010;

                for (int x : comp) {
                    cur_min = max(cur_min, (int) lim[x].first);
                    cur_max = min(cur_max, (int) lim[x].second);
                }

                if (cur_min > cur_max) {
                    res = 0;
                    break;
                }
                res = (res + bin_pow_mod(cur_max - cur_min + 1, comp.size())) % MOD;
            }

            cout << res << "\n";
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}
