#include<bits/stdc++.h>

#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10, MOD = 1e9 + 7;
int l[N], r[N];
vector<int> g[N];
int par[N];
int po[20][N], d[N];
int ans = 1;

int mul(int a, int b) {
    return (1ll * a * b % MOD);
}

int binpow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1) {
            res = mul(res, a);
        }
        a = mul(a, a);
        n /= 2;
    }
    return res;
}

int inv(int a) {
    return binpow(a, MOD - 2);
}

int find_set(int v) {
    if (v == par[v]) {
        return v;
    } else {
        return par[v] = find_set(par[v]);
    }
}

void union_set(int a, int b) {
    a = find_set(a);
    b = find_set(b);
    if (a == b) {
        return;
    }
    ans = mul(ans, inv(r[a] - l[a] + 1)), ans = mul(ans, inv(r[b] - l[b] + 1));
    par[b] = a;
    l[a] = max(l[a], l[b]);
    r[a] = min(r[a], r[b]);
    if (l[a] > r[a]) {
        ans = 0;
    } else {
        ans = mul(ans, r[a] - l[a] + 1);
    }
}

void dfs(int v, int p) {
    for (auto to : g[v]) {
        if (to != p) {
            d[to] = d[v] + 1;
            po[0][to] = v;
            dfs(to, v);
        }
    }
}

int lca(int a, int b) {
    if (d[a] < d[b]) {
        swap(a, b);
    }
    for (int i = 19; i >= 0; i--) {
        if (d[po[i][a]] >= d[b]) {
            a = po[i][a];
        }
    }
    if (a == b) return a;
    for (int i = 19; i >= 0; i--) {
        if (po[i][a] != po[i][b]) {
            a = po[i][a];
            b = po[i][b];
        }
    }
    return po[0][a];
}

int len(int a, int b) {
    return d[a] + d[b] - 2 * d[lca(a, b)] + 1;
}

int q1[N], q2[N];

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    for (int i = 0; i < N; i++) {
        par[i] = i;
    }
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].pb(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
    }
    dfs(0, -1);
    for (int i = 1; i < 20; i++) {
        for (int j = 0; j < n; j++) {
            po[i][j] = po[i - 1][po[i - 1][j]];
        }
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        int g1 = lca(a, b), g2 = lca(c, d);
        int L = len(a, b);
        int l = 0, r = L - 1;
        while (a != g1) {
            q1[l++] = a;
            a = po[0][a];
        }
        q1[l++] = a;
        while (b != g1) {
            q1[r--] = b;
            b = po[0][b];
        }

        l = 0, r = L - 1;
        while (c != g2) {
            q2[l++] = c;
            c = po[0][c];
        }
        q2[l++] = c;
        while (d != g2) {
            q2[r--] = d;
            d = po[0][d];
        }

        for (int j = 0; j < L; j++) {
            union_set(q1[j], q2[j]);
        }
        cout << ans << endl;
    }
    return 0;
}
