#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <climits>
#include <random>
#include <bitset>

using namespace std;

#define int long long
#define endl '\n'

mt19937_64 engine;

const long long mod = 1e9 + 7;
const long double pi = acosl(-1.0);
const long double eps = 1e-10;

long long gcd(long long x, long long y)
{
    if (y == 0) return x;
    return gcd(y, x % y);
}

long long lcm(long long x, long long y)
{
    return x / gcd(x, y) * y;
}

long long binpow(long long x, long long y)
{
    if (y == 0) return 1;
    if (y == 1) return x;
    int f = binpow(x, y / 2);
    if (y % 2 == 0) return (f * f) % mod;
    else return (((f * f) % mod) * x) % mod;
}

/*void task()
{
    int n, k;
    cin >> n >> k;

    vector<int> v(n);
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
    }

    if (n == 1)
    {
        cout << (long double)((v[0] / k) * k) / (long double)v[0] << endl;
        return;
    }

    if (n == 2)
    {
        long double maxans = 0;
        for (int i = 1; i <= k; i++)
        {
            int b0 = i;
            int b1 = (k + i - 1) / i;
            int a0 = v[0];
            int a1 = v[1];
            maxans = max(maxans, (long double)(a0 / b0) * (long double)(a1 / b1) / (long double)(a0) / (long double)(a1)*k);
        }
        cout << maxans << endl;
        return;
    }

    vector<vector<long double>> dp(n + 1, vector<long double>(k + 1, 0));
    dp[0][1] = 1;

    for (int i = 0; i < n; i++)
    {
        for (int j = 1; j <= k; j++)
        {
            for (int f = 1; f <= (k + j - 1) / j; f++)
            {
                dp[i + 1][min(j * f, k)] = max(dp[i + 1][min(j * f, k)], dp[i][j] * (int)(v[i] / f) / (long double)v[i]);
            }
        }
    }

    cout << dp[n][k]*k << endl;
}*/

struct Node
{
    int tin, tout;
    vector<int> to;
    vector<int> up = vector<int>(22);
};

vector<Node> tree;
vector<int> rnk;
vector<int> parent;
vector<pair<int, int>> dm;

int ans = 1;

int get_parent(int x)
{
    if (x != parent[x])
    {
        parent[x] = get_parent(parent[x]);
        return parent[x];
    }
    return x;
}

bool in_one(int x, int y)
{
    return get_parent(x) == get_parent(y);
}

void merge(int x, int y)
{
    x = get_parent(x);
    y = get_parent(y);

    ans *= binpow(dm[x].second - dm[x].first + 1, mod - 2);
    ans %= mod;
    ans *= binpow(dm[y].second - dm[y].first + 1, mod - 2);
    ans %= mod;

    if (rnk[x] > rnk[y])
    {
        parent[y] = x;
        dm[x].first = max(dm[x].first, dm[y].first);
        dm[x].second = min(dm[x].second, dm[y].second);
        ans *= max((int)0, dm[x].second - dm[x].first + 1);
        ans %= mod;
    }
    else if (rnk[y] < rnk[x])
    {
        parent[x] = y;
        dm[y].first = max(dm[y].first, dm[x].first);
        dm[y].second = min(dm[y].second, dm[x].second);
        ans *= max((int)0, dm[y].second - dm[y].first + 1);
        ans %= mod;
    }
    else
    {
        parent[y] = x;
        dm[x].first = max(dm[x].first, dm[y].first);
        dm[x].second = min(dm[x].second, dm[y].second);
        rnk[x]++;
        ans *= max((int)0, dm[x].second - dm[x].first + 1);
        ans %= mod;
    }
}

int timer = 0;

void dfs(int v)
{
    tree[v].tin = timer++;

    for (int u : tree[v].to)
    {
        dfs(u);
    }

    tree[v].tout = timer++;
}

bool is_parent(int v, int u)
{
    return tree[v].tin <= tree[u].tin && tree[v].tout >= tree[u].tout;
}

int lca(int v, int u)
{
    if (is_parent(v, u)) return v;
    if (is_parent(u, v)) return u;

    for (int i = 21; i >= 0; i--)
    {
        if (!is_parent(tree[v].up[i], u))
        {
            v = tree[v].up[i];
        }
    }

    return tree[v].up[0];
}

void task()
{
    int n;
    cin >> n;

    tree.resize(n);
    tree[0].up[0] = 0;

    for (int i = 1; i < n; i++)
    {
        int p;
        cin >> p;
        p--;
        tree[p].to.push_back(i);
        tree[i].up[0] = p;
    }

    vector<pair<int, int>> dd(n);
    for (int i = 0; i < n; i++)
    {
        cin >> dd[i].first >> dd[i].second;
    }

    dfs(0);

    rnk.resize(n, 1);
    parent.resize(n);
    for (int i = 0; i < n; i++)
    {
        parent[i] = i;
    }
    dm.resize(n);
    for (int i = 0; i < n; i++)
    {
        dm[i] = dd[i];
    }

    for (int i = 1; i < 22; i++)
    {
        for (int j = 0; j < n; j++)
        {
            tree[j].up[i] = tree[tree[j].up[i - 1]].up[i - 1];
        }
    }

    for (int i = 0; i < n; i++)
    {
        ans *= dm[i].second - dm[i].first + 1;
        ans %= mod;
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; i++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;

        int l1 = lca(a, b);
        int l2 = lca(c, d);

        vector<int> p1, p2, p3, p4;
        while (a != l1)
        {
            p1.push_back(a);
            a = tree[a].up[0];
        }
        while (b != l1)
        {
            p2.push_back(b);
            b = tree[b].up[0];
        }
        while (c != l2)
        {
            p3.push_back(c);
            c = tree[c].up[0];
        }
        while (d != l2)
        {
            p4.push_back(d);
            d = tree[d].up[0];
        }

        reverse(p2.begin(), p2.end());
        reverse(p4.begin(), p4.end());

        p1.push_back(l1);
        p3.push_back(l2);

        for (int j = 0; j < p2.size(); j++)
        {
            p1.push_back(p2[j]);
        }
        for (int j = 0; j < p4.size(); j++)
        {
            p3.push_back(p4[j]);
        }

        for (int j = 0; j < p1.size(); j++)
        {
            if (!in_one(p1[j], p3[j]))
            {
                merge(p1[j], p3[j]);
            }
        }

        cout << ans << endl;
    }
}

signed main()
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << fixed << setprecision(15);
    engine.seed(58);

    int t = 1;
    bool multitest = false;
    if (multitest) cin >> t;
    while (t--) task();

    return 0;
}
