#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

const int MOD = 1e9 + 7;

vector <vector <int>> graph;
vector <int> tin, tout;

struct DSU {
    int n;
    multiset <int> nuggets;
    vector <int> parent, ranks, l, r;

    DSU (int n): n(n), parent(n), ranks(n, 1), l(n), r(n) {
        iota(parent.begin(), parent.end(), 0);
    }

    int get(int u) {
        if (parent[u] == u) return u;
        return parent[u] = get(parent[u]);
    }

    void merge(int u, int v) {
        u = get(u), v = get(v);

        if (u == v)
            return;

        if (ranks[u] < ranks[v])
            swap(u, v);
        if (ranks[u] == ranks[v])
            ranks[u]++;

        nuggets.erase(nuggets.find(r[v] - l[v] + 1));
        nuggets.erase(nuggets.find(r[u] - l[u] + 1));

        parent[v] = u;
        l[u] = max(l[u], l[v]);
        r[u] = min(r[u], r[v]);

        nuggets.insert({r[u] - l[u] + 1});
    }

    ll get_answer() {
        ll answer = 1;
        for (ll x: nuggets) {
            answer = (answer * max(0ll, x)) % MOD;
        }

        return answer;
    }
};

void dfs(int u, int &t) {
    tin[u] = t++;
    for (int v: graph[u]) {
        dfs(v, t);
    }

    tout[u] = t++;
}

bool is_ancestor(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

void solve() {
    int n;
    cin >> n;

    graph.resize(n);

    vector <int> p(n);
    for (int i = 1; i < n;i ++) {
        cin >> p[i], p[i]--;
        graph[p[i]].emplace_back(i);
    }

    DSU dsu(n);

    for (int i = 0; i < n; i++) {
        cin >> dsu.l[i] >> dsu.r[i];
        dsu.nuggets.insert(dsu.r[i] - dsu.l[i] + 1);
    }


    tin.resize(n);
    tout.resize(n);

    int t = 0;
    dfs(0, t);

    int m;
    cin >> m;

    int a, b, c, d;
    while (m--) {
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;

        vector <int> patha = {a}, pathb, pathc = {c}, pathd;
        while (!is_ancestor(a, b)) {
            a = p[a];
            patha.emplace_back(a);
        }

        while (b != a) {
            pathb.emplace_back(b);
            b = p[b];
        }

        while (!is_ancestor(c, d)) {
            c = p[c];
            pathc.emplace_back(c);
        }
        while (d != c) {
            pathd.emplace_back(d);
            d = p[d];
        }

        vector <int> path1 = patha;
        for (auto it = pathb.rbegin(); it != pathb.rend(); it++)
            path1.push_back(*it);

        vector <int> path2 = pathc;
        for (auto it = pathd.rbegin(); it != pathd.rend(); it++)
            path2.push_back(*it);

        assert(path1.size() == path2.size());

        for (int i = 0; i < path1.size(); i++) {
            int u = path1[i], v = path2[i];

            dsu.merge(u, v);
        }


        cout << dsu.get_answer() << '\n';
    }
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
