//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cmath>
#include <math.h>
#include <algorithm>

#define int long long

using namespace std;

mt19937 rnd(12);

const int N = 2e5 + 11, inf = 1e9 + 111, mod = 1e9 + 7;

inline int add(int a, int b) {
    if (a + b >= mod) {
        return a + b - mod;
    }
    return a + b;
}

inline int sub(int a, int b) {
    if (a - b < 0) {
        return a - b + mod;
    }
    return a - b;
}

inline int mul(long long a, long long b) {
    return (a * b) % mod;
}

int n;
int p[N];
pair<int, int> have[N];
vector<int> grWas[N];
vector<int> gr[N];
int deep[N];
int jump[20][N];
int degree[20];
int near[N];

void dfs(int v, int last) {
    deep[v] = deep[last] + 1;
    for (int to : grWas[v]) {
        dfs(to, v);
    }
}

void build() {
    degree[0] = 1;
    for (int i = 1; i < 20; i++) {
        degree[i] = degree[i - 1] * 2;
    }
    int now = 4, num = 1;
    near[0] = 0, near[1] = 0, near[2] = 1;
    for (int i = 3; i < N; i++) {
        if (i == now) {
            num++;
            now *= 2;
        }
        near[i] = num;
    }
    for (int i = 0; i < N; i++) {
        jump[0][i] = p[i];
    }
    for (int k = 1; k < 20; k++) {
        for (int i = 0; i < N; i++) {
            jump[k][i] = jump[k - 1][jump[k - 1][i]];
        }
    }
}

int lca(int a, int b) {
    if (deep[a] < deep[b]) {
        swap(a, b);
    } // a is deeper than b

    for (int k = 19; k >= 0; k--) {
        if (deep[a] == deep[b]) break;
        if (deep[jump[k][a]] >= deep[b]) {
            a = jump[k][a];
        }
    }
    if (a == b) return a;
    for (int k = 19; k >= 0; k--) {
        if (jump[k][a] != jump[k][b]) {
            a = jump[k][a];
            b = jump[k][b];
        }
    }
    return p[a];
}

pair<int, int> connect(pair<int, int> a, pair<int, int> b) {
    if (a.first > b.first) {
        swap(a, b);
    }
    if (a.first <= b.first && a.second >= b.second) {
        return b;
    }
    if (a.second < b.first) {
        return { -11, -12 };
    }
    if (a.second < b.second) {
        return { b.first, a.second };
    }
    return { -11, -12 };
}

int used[N];
pair<int, int> pNow;

void dfsUpd(int v) {
    if (used[v]) return;
    used[v] = 1;
    pNow = connect(pNow, have[v]);
    for (int to : gr[v]) {
        if (!used[to]) {
            dfsUpd(to);
        }
    }
    have[v] = pNow;
}

int resNow = 1;
int parent[N], sz[N];
pair<int, int> nowPair[N];

int getLider(int a) {
    if (parent[a] == a) return a;
    int l = getLider(parent[a]);
    parent[a] = l;
    return l;
}

int binPow(int a, int d) {
    if (d == 0) return 1;
    int m = binPow(a, d / 2);
    m = mul(m, m);
    if (d % 2 == 1) {
        m = mul(m, a);
    }
    return m;
}

int del(int a, int b) {
    return mul(a, binPow(b, mod - 2));
}

void con(int a, int b) {
    a = getLider(a);
    b = getLider(b);
    if (a == b) return;
    if (sz[a] > sz[b]) swap(a, b);
    resNow = del(resNow, nowPair[b].second - nowPair[b].first + 1);
    resNow = del(resNow, nowPair[a].second - nowPair[a].first + 1);
    parent[a] = b;
    sz[b] += sz[a];
    nowPair[b] = connect(nowPair[b], nowPair[a]);
    resNow = mul(resNow, nowPair[b].second - nowPair[b].first + 1);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        grWas[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> have[i].first >> have[i].second;
    }
    deep[0] = -1;
    dfs(0, 0);
    build();
    int m;
    cin >> m;
    int flag = 0;
    for (int i = 0; i < n; i++) {
        parent[i] = i;
        sz[i] = 1;
        resNow = mul(resNow, have[i].second - have[i].first + 1);
        nowPair[i] = have[i];
    }
    for (int y = 0; y < m; y++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (flag) {
            cout << "0\n";
            continue;
        }
        a--, b--, c--, d--;
        int f = lca(a, b), s = lca(c, d);
        vector<int> pathF, pathS;
        while (a != f) {
            pathF.push_back(a);
            a = p[a];
        }
        pathF.push_back(a);
        vector<int> help;
        while (b != f) {
            help.push_back(b);
            b = p[b];
        }
        for (int i = help.size() - 1; i >= 0; i--) {
            pathF.push_back(help[i]);
        }
        while (c != s) {
            pathS.push_back(c);
            c = p[c];
        }
        pathS.push_back(s);
        help.clear();
        while (d != s) {
            help.push_back(d);
            d = p[d];
        }
        for (int i = help.size() - 1; i >= 0; i--) {
            pathS.push_back(help[i]);
        }
        vector<vector<int>> with(n, vector<int>(0));

        for (int i = 0; i < pathF.size(); i++) {
            con(pathF[i], pathS[i]);
        }
        for (int i = 0; i < n; i++) {
            used[i] = 1;
        }
        cout << resNow << "\n";
        if (resNow == 0) {
            flag = 1;
        }
    }
}

