//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cmath>
#include <math.h>
#include <algorithm>

using ll = long long;

using namespace std;

mt19937 rnd(12);

const ll N = 2e5 + 11, inf = 1e9 + 111, mod = 1e9 + 7;

inline int add(int a, int b) {
    if (a + b >= mod) {
        return a + b - mod;
    }
    return a + b;
}

inline int sub(int a, int b) {
    if (a - b < 0) {
        return a - b + mod;
    }
    return a - b;
}

inline int mul(long long a, long long b) {
    return (a * b) % mod;
}

int n;
int p[N];
vector<int> grWas[N];
vector<int> gr[N];
int deep[N];
int jump[20][N];
int degree[20];

void dfs(int v, int last) {
    deep[v] = deep[last] + 1;
    for (int to : grWas[v]) {
        dfs(to, v);
    }
}

void build() {
    degree[0] = 1;
    for (int i = 1; i < 20; i++) {
        degree[i] = degree[i - 1] * 2;
    }
    for (int i = 0; i < N; i++) {
        jump[0][i] = p[i];
    }
    for (int k = 1; k < 20; k++) {
        for (int i = 0; i < N; i++) {
            jump[k][i] = jump[k - 1][jump[k - 1][i]];
        }
    }
}

int lca(int a, int b) {
    if (deep[a] < deep[b]) {
        swap(a, b);
    } // a is deeper than b

    for (int k = 19; k >= 0; k--) {
        if (deep[a] == deep[b]) break;
        if (deep[jump[k][a]] >= deep[b]) {
            a = jump[k][a];
        }
    }
    if (a == b) return a;
    for (int k = 19; k >= 0; k--) {
        if (jump[k][a] != jump[k][b]) {
            a = jump[k][a];
            b = jump[k][b];
        }
    }
    return p[a];
}

inline void connect(pair<int, int> &a, pair<int, int> &b) {
    if (a.first > b.first) {
        swap(a, b);
    }
    if (a.first <= b.first && a.second >= b.second) {
        a = b;
    }
    if (a.second < b.first) {
        a = { -11, -12 };
        b = { -11, -12 };
    }
    if (a.second < b.second) {
        a = { b.first, a.second };
        b = a;
    }
}

int used[N];
pair<int, int> pNow;

int resNow = 1;
int parent[N], sz[N];
pair<int, int> nowPair[N];

int getLider(int a) {
    if (parent[a] == a) return a;
    int l = getLider(parent[a]);
    parent[a] = l;
    return l;
}

int binPow(int a, int d) {
    if (d == 0) return 1;
    int m = binPow(a, d / 2);
    m = mul(m, m);
    if (d % 2 == 1) {
        m = mul(m, a);
    }
    return m;
}

int del(int a, int b) {
    return mul(a, binPow(b, mod - 2));
}

inline void con(int a, int b) {
    a = getLider(a);
    b = getLider(b);
    if (a == b) return;
    if (sz[a] > sz[b]) swap(a, b);
    resNow = del(resNow, nowPair[b].second - nowPair[b].first + 1);
    resNow = del(resNow, nowPair[a].second - nowPair[a].first + 1);
    parent[a] = b;
    sz[b] += sz[a];
    connect(nowPair[b], nowPair[a]);
    resNow = mul(resNow, nowPair[b].second - nowPair[b].first + 1);
}

int pathF[N], pathS[N];
int pathFrev[N], pathSrev[N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        grWas[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> nowPair[i].first >> nowPair[i].second;
    }
    deep[0] = -1;
    dfs(0, 0);
    build();
    int m;
    cin >> m;
    int flag = 0;
    for (int i = 0; i < n; i++) {
        parent[i] = i;
        sz[i] = 1;
        resNow = mul(resNow, nowPair[i].second - nowPair[i].first + 1);
    }
    while(m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (flag) {
            cout << "0\n";
            continue;
        }
        a--, b--, c--, d--;
        int f = lca(a, b), s = lca(c, d);
        int fId = 0, sId = 0;
        int fIdRev = 0, sIdRev = 0;
        while (a != f) {
            pathF[fId] = a;
            fId++;
            a = p[a];
        }
        pathF[fId] = a;
        fId++;
        while (b != f) {
            pathFrev[fIdRev] = b;
            fIdRev++;
            b = p[b];
        }
        while (fIdRev > 0) {
            fIdRev--;
            pathF[fId] = pathFrev[fIdRev];
            fId++;
        }
        while (c != s) {
            pathS[sId] = c;
            sId++;
            c = p[c];
        }
        pathS[sId] = s;
        sId++;
        while (d != s) {
            pathSrev[sIdRev] = d;
            sIdRev++;
            d = p[d];
        }
        while (sIdRev > 0) {
            sIdRev--;
            pathS[sId] = pathSrev[sIdRev];
            sId++;
        }
        for (int i = 0; i < fId; i++) {
            if (parent[pathF[i]] == parent[pathS[i]]) continue;
            con(pathF[i], pathS[i]);
        }
        for (int i = 0; i < n; i++) {
            used[i] = 1;
        }
        cout << resNow << "\n";
        if (resNow == 0) {
            flag = 1;
        }
    }
}

