#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 2E5, sq = 447;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return uint64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int step (uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * m.step(MOD - 2);
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

int par[MAXN], range[MAXN];
pair <int, int> val[MAXN];
bool used[MAXN];

void dfs(int x)
{
	if (range[x] != -1)
	{
		return;
	}
	dfs(par[x]);
	range[x] = range[par[x]] + 1;
	return;
}

int parent[MAXN], sz[MAXN];
pair <int, int> val_gr[MAXN];
Mod_int tot = 1;

int get_parent(int x)
{
	if (parent[x] < 0)
	{
		return x;
	}
	return parent[x] = get_parent(parent[x]);
}

void unit(int x, int y)
{
	x = get_parent(x);
	y = get_parent(y);
	if (x == y)
	{
		return;
	}

	if (parent[y] < parent[x])
	{
		swap(x, y);
	}
	rmin(parent[x], parent[y] - 1);
	tot /= Mod_int(val_gr[x].second - val_gr[x].first + 1);
	tot /= Mod_int(val_gr[y].second - val_gr[y].first + 1);
	rmax(val_gr[x].first, val_gr[y].first);
	rmin(val_gr[x].second, val_gr[y].second);
	parent[y] = x;
	tot *= Mod_int(max(0, val_gr[x].second - val_gr[x].first + 1));
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	for (int i = 0; i < n - 1; i++)
	{
		cin >> par[i + 1];
		par[i + 1]--;
	}

	for (int i = 0; i < n; i++)
	{
		cin >> val[i].first >> val[i].second;
		tot *= val[i].second - val[i].first + 1;
	}

	fill(range, range + n, -1);
	range[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (range[i] == -1)
		{
			dfs(i);
		}
	}

	int m;
	cin >> m;
	vector <int> f, s, dop;
	for (int i = 0; i < n; i++)
	{
		parent[i] = -1;
		val_gr[i] = val[i];
	}
	for (int z = 0; z < m; z++)
	{
		f.clear();
		s.clear();
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a;
		--b;
		--c;
		--d;
		
		dop.clear();
		while (range[a] < range[b])
		{
			dop.push_back(b);
			b = par[b];
		}
		while (range[b] < range[a])
		{
			f.push_back(a);
			a = par[a];
		}
		while (a != b)
		{
			f.push_back(a);
			dop.push_back(b);
			a = par[a];
			b = par[b];
		}
		f.push_back(a);
		reverse(ALL(dop));
		for (int i = 0; i < dop.size(); i++)
		{
			f.push_back(dop[i]);
		}

		dop.clear();
		while (range[c] < range[d])
		{
			dop.push_back(d);
			d = par[d];
		}
		while (range[d] < range[c])
		{
			s.push_back(c);
			c = par[c];
		}
		while (c != d)
		{
			s.push_back(c);
			dop.push_back(d);
			c = par[c];
			d = par[d];
		}
		s.push_back(c);
		reverse(ALL(dop));
		for (int i = 0; i < dop.size(); i++)
		{
			s.push_back(dop[i]);
		}
		
		for (int i = 0; i < f.size(); i++)
		{
			unit(f[i], s[i]);
		}

		cout << tot.ans << endl;
		if (tot.ans == 0)
		{
			for (int i = z + 1; i < m; i++)
			{
				cout << 0 << endl;
			}
			exit(0);
		}
	}
}