#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pp;

vector<vector<ll>> graph;
vector<ll> depth;

void dfs1(ll v, ll deep) {
    depth[v] = deep;
    for (ll to:graph[v]) {
        dfs1(to, deep + 1);
    }
}

vector<ll> roots, sz;

ll get_root(ll v) {
    while (roots[v] != v) {
        v = roots[v] = get_root(roots[v]);
    }
    return roots[v];
}

const ll mod = 1e9 + 7;

ll bin_pow(ll x, ll y) {
    if (y == 0) {
        return 1;
    }
    if (y == 1) {
        return x % mod;
    }
    ll res = bin_pow(x, y / 2) % mod;
    return res * res % mod * bin_pow(x, y % 2) % mod;
}

ll divide_mod(ll x) {
    return bin_pow(x, mod - 2);
}

void solve() {
    ll n;
    cin >> n;
    vector<ll> p(n);
    vector<pp> bounds(n);
    depth.assign(n, 0);
    graph.assign(n, {});
    for (ll i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        graph[p[i]].push_back(i);
    }
    for (ll i = 0; i < n; i++) {
        cin >> bounds[i].first >> bounds[i].second;
    }
    dfs1(0, 0);
    ll m;
    cin >> m;
    roots.assign(n, 0);
    sz.assign(n, 1);
    vector<pp> bds(n);
    ll ans = 1;
    for (ll i = 0; i < n; i++) {
        roots[i] = i;
        bds[i] = bounds[i];
        ans *= bds[i].second - bds[i].first + 1;
        ans %= mod;
    }

    for (ll it = 0; it < m; it++) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector<ll> path1, tmp;
        while (depth[a] > depth[b]) {
            path1.push_back(a);
            a = p[a];
        }
        while (depth[b] > depth[a]) {
            tmp.push_back(b);
            b = p[b];
        }
        while (a != b) {
            path1.push_back(a);
            tmp.push_back(b);
            a = p[a];
            b = p[b];
        }
        path1.push_back(a);
        reverse(tmp.begin(), tmp.end());
        for (ll el:tmp) {
            path1.push_back(el);
        }

        vector<ll> path2;
        tmp.clear();
        while (depth[c] > depth[d]) {
            path2.push_back(c);
            c = p[c];
        }
        while (depth[d] > depth[c]) {
            tmp.push_back(d);
            d = p[d];
        }
        while (c != d) {
            path2.push_back(c);
            tmp.push_back(d);
            c = p[c];
            d = p[d];
        }
        path2.push_back(c);
        reverse(tmp.begin(), tmp.end());
        for (ll el:tmp) {
            path2.push_back(el);
        }

        /*for (ll el:path1) {
            cout << el << ' ';
        }
        cout << '\n';
        for (ll el:path2) {
            cout << el << ' ';
        }
        cout << "\n\n";*/

        for (ll j = 0; j < path1.size(); j++) {
            //cout << "merged " << path1[j] << ' ' << path2[j] << '\n';
            ll r1 = get_root(path1[j]), r2 = get_root(path2[j]);
            if (r1 == r2) {
                //cout << "skip em\n";
                continue;
            }
            ans *= divide_mod( bds[r1].second - bds[r1].first + 1);
            ans %= mod;
            ans *= divide_mod( bds[r2].second - bds[r2].first + 1);
            ans %= mod;

            if (sz[r1] > sz[r2]) {
                swap(r1, r2);
            }
            roots[r1] = r2;
            sz[r2] += sz[r1];


            bds[r2].first = max(bds[r2].first, bds[r1].first);
            bds[r2].second = min(bds[r2].second, bds[r1].second);
            ans *= max(0ll, bds[r2].second - bds[r2].first + 1);
            ans %= mod;
            if (ans == 0) {
                for (ll id = it; id < m; id++) {
                    cout << "0\n";
                }
                return;
            }
            //cout << "size of set containing is " << sz[r2] << '\n';
            //cout << "bouns " << bds[r2].first << ' ' << bds[r2].second << '\n';
        }
        cout << ans << '\n';
    }


}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
