#include <iostream>
#include <vector>
#include <set>


using namespace std;
using ll = long long;
ll MOD = 1000000007;


vector<int> pred;
vector<pair<int, int>> gran;
set<int> real_roots;


void DFS(int vertex, int ness, vector<int> &way, vector<vector<int>> &graph, vector<bool> &used) {
    for (auto kid : graph[vertex]) {
        if (!used[kid]) {
            used[kid]  =true;
            if (kid == ness) {
                way.push_back(kid);
                break;
            } else {
                DFS(kid, ness, way, graph, used);
                if (!way.empty()) {
                    break;
                }
            }
        }
    }
    if (!way.empty()) {
        way.push_back(vertex);
    }
}


int Findroot(int vertex) {
    if (pred[vertex] == vertex) {
        return vertex;
    }
    pred[vertex] = Findroot(pred[vertex]);
    return pred[vertex];
}


void Merge(int v1, int v2) {
    int r1 = Findroot(v1);
    int r2 = Findroot(v2);
    if (r1 != r2) {
        pred[r1] = r2;
        real_roots.erase(r1);
        if (gran[r2].second < gran[r1].first || gran[r1].second < gran[r2].first ||
        gran[r1].first > gran[r1].second || gran[r2].first > gran[r2].second) {
            gran[r2] = {1, 0};
        } else {
            gran[r2] = {max(gran[r2].first, gran[r1].first), min(gran[r2].second, gran[r1].second)};
        }
    }
}

int main() {
    int num_of_vertices;
    cin >> num_of_vertices;
    vector<vector<int>> graph(num_of_vertices);
    for (int i = 0; i < num_of_vertices - 1; ++i) {
        int num;
        cin >> num;
        graph[num - 1].push_back(i + 1);
        graph[i + 1].push_back(num - 1);
    }
    pred.resize(num_of_vertices);
    gran.resize(num_of_vertices);
    for (int i = 0; i < num_of_vertices; ++i) {
        pred[i] = i;
        cin >> gran[i].first >> gran[i].second;
        real_roots.insert(i);
    }
    int num_of_reqs;
    cin >> num_of_reqs;
    for (int t = 0; t < num_of_reqs; ++t) {
        int v1, v2, v3, v4;
        cin >> v1 >> v2 >> v3 >> v4;
        --v1;
        --v2;
        --v3;
        --v4;
        vector<int> wayb;
        vector<int> waya;
        if (v1 != v2) {
            vector<bool> used(num_of_vertices, false);
            used[v1] = true;
            DFS(v1, v2, waya, graph, used);
            used.assign(num_of_vertices, false);
            used[v3] = true;
            DFS(v3, v4, wayb, graph, used);
        } else {
            waya.push_back(v1);
            wayb.push_back(v3);
        }
        for (int i = 0; i < waya.size(); ++i) {
            Merge(waya[i], wayb[i]);
        }
        ll ans = 1;
        for (auto kid : real_roots) {
            ans *= (ll)(gran[kid].second - gran[kid].first +1);
            ans %= MOD;
        }
        cout << ans << "\n";
    }
    return 0;
}
