#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define int ll

const int maxn = 2e5 + 5, MOD = 1e9 + 7;
vector <int> g[maxn];
int n, tin[maxn], tout[maxn], timer, pr[maxn], l[maxn], r[maxn];
const int maxa = 1e6 + 5;
int inv[maxa];

void dfs(int v) {
	tin[v] = timer++;
	for (int u: g[v]) dfs(u);
	tout[v] = timer++;
}
bool anc(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tout[u];
}

vector <int> path(int v, int u) {
	vector <int> a, b;
	while (!anc(v, u)) {
		a.push_back(v);
		v = pr[v];
	}
	a.push_back(v);
	while (u != v) {
		b.push_back(u);
		u = pr[u];
	}
	reverse(all(b));
	for (int i: b) a.push_back(i);
	return a;
}

int p[maxn], sz[maxn], ans = 1;
int binpow(int n, int k) {
	if (k == 0) return 1;
	if (k % 2) return (binpow(n, k - 1) * n) % MOD;
	int y = binpow(n, k / 2);
	return (y * y) % MOD;
}
int inverse(int n) {
	if (n < maxa) return inv[n];
	return binpow(n, MOD - 2);
}
void init_dsu() {
	for (int i = 1; i <= n; i++) {
		p[i] = i;
		sz[i] = 1;
		ans = (ans * (r[i] - l[i] + 1)) % MOD;
	}
}
int get_root(int i) {
	if (p[i] == i) return i;
	return p[i] = get_root(p[i]);
}
void merge(int a, int b) {
	a = get_root(a);
	b = get_root(b);
	if (a == b) return;
	
	ans = (ans * inverse(max(0LL, r[a] - l[a] + 1))) % MOD;
	ans = (ans * inverse(max(0LL, r[b] - l[b] + 1))) % MOD;
	
	if (sz[a] > sz[b]) swap(a, b);
	p[a] = b;
	sz[b] += sz[a];
	l[b] = max(l[a], l[b]);
	r[b] = min(r[a], r[b]);
	ans = (ans * max(0LL, r[b] - l[b] + 1)) % MOD;
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	for (int i = 0; i < maxa; i++) inv[i] = binpow(i, MOD - 2);
	
	cin >> n;
	for (int i = 2; i <= n; i++) {
		cin >> pr[i];
		g[pr[i]].push_back(i);
	}
	for (int i = 1; i <= n; i++) cin >> l[i] >> r[i];
	
	dfs(1);
	init_dsu();
	
	int q;
	cin >> q;
	while (q--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		
		if (!ans) {
			cout << 0 << '\n';
			continue;
		}
		
		vector <int> A = path(a, b), B = path(c, d);
		assert(sz(A) == sz(B));
		for (int i = 0; i < sz(A); i++) merge(A[i], B[i]);
		
		cout << ans << '\n';
	}
	
	return 0;
}
