#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
struct st {
    int x, y;
};

bool comp1(st a, st b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
};

bool comp2(st a, st b) {
    if (a.y == b.y) {
        return a.x < b.x;
    }
    return a.y < b.y;
};
vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

long long ans = 1;
vector<vector<int>> graph;
vector<int> p;
vector<pair<int, int>> prices;
const long long mod = 1e9 + 7;

void walk(int a, int b, int c, int d) {
    while (a != b) {
        auto [l1, r1] = prices[a];
        auto [l2, r2] = prices[c];
        int l_ans = max(l1, l2);
        int r_ans = min(r1, r2);
        long long len = 0;
        /*if (l1 <= l2 && r2 <= r1){
            l_ans = l2;
            r_ans = r2;
        }
        if (l2 <= l1 && r1 <= r2){
            l_ans = l1;
            r_ans = r1;
        }
        if (l2 < l1 && r2 <= r1){
            l_ans = l1;
            r_ans = r2;
        }
        if (l1 < l2 && r1 <= r2){
            l_ans = l2;
            r_ans = r1;
        }
        if (l1 <= l2 && r1 < r2){
            l_ans = l2;
            r_ans = r1;
        }
        if (l2 <= l1 && r2 < r1){
            l_ans = l1;
            r_ans = r2;
        }*/
        prices[a] = {l_ans, r_ans};
        prices[c] = {l_ans, r_ans};
        //cout << a << " prices[a]: " << prices[a].first << " " << prices[a].second << endl;
        //cout << c << " prices[c]: " << prices[c].first << " " << prices[c].second << endl;
        if (b < a) {
            a = graph[a][0];
        } else {
            a = graph[a][1];
        }
        if (d < c) {
            c = graph[c][0];
        } else {
            c = graph[c][1];
        }
    }
    auto [l1, r1] = prices[a];
    auto [l2, r2] = prices[c];
    int l_ans = max(l1, l2);
    int r_ans = min(r1, r2);
    prices[a] = {l_ans, r_ans};
    prices[c] = {l_ans, r_ans};
}

void walk_ans(int a, int b, int c, int d) {
    while (a != b) {
        auto [l1, r1] = prices[a];
        auto [l2, r2] = prices[c];
        int l_ans = max(l1, l2);
        int r_ans = min(r1, r2);
        long long len = r_ans - l_ans + 1;
        if (len <= 0) {
            ans = 0;
        } else {
            ans = ((ans % mod) * (len) % mod) % mod;
        }
        if (b < a) {
            a = graph[a][0];
        } else {
            a = graph[a][1];
        }
        if (d < c) {
            c = graph[c][0];
        } else {
            c = graph[c][1];
        }
    }
    auto [l1, r1] = prices[a];
    auto [l2, r2] = prices[c];
    int l_ans = max(l1, l2);
    int r_ans = min(r1, r2);
    long long len = r_ans - l_ans + 1;
    if (len <= 0) {
        ans = 0;
    } else {
        ans = ((ans % mod) * (len) % mod) % mod;
    }

}

int main() {
    int n;
    cin >> n;
    graph.resize(n + 1, vector<int>(2));
    p.resize(n + 1);
    prices.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        graph[i][0] = p[i];
        graph[p[i]][1] = i;
    }
    for (int i = 1; i <= n; i++) {
        int l, r;;
        cin >> l >> r;
        prices[i] = {l, r};
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        ans = 1;
        walk(a, b, c, d);
        walk_ans(a, b, c, d);
        cout << ans << endl;
    }
    return 0;
}
