#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <iomanip>
#include <cmath>
#include <map>
#include <unordered_set>
#include <unordered_map>

using namespace std;

#define setpr setprecision(15)

typedef int64_t ll;
typedef uint64_t ull;
typedef pair<int, int> pii;

ll mod = 1e9 + 7;

vector<int> p;
vector<vector<int>> eList;
int target;

void dfs(int v, int prev, vector<int> & path) {
    if (target != -1) {
        path.push_back(v);
    }
    if (v == target) {
        target = -1;
    }
    for (auto to : eList[v]) {
        if (to != prev) {
            dfs(to, v, path);
        }
    }
    if (target != -1) {
        path.pop_back();
    }
}

pair<ll, ll> calc(ll l1, ll r1, ll l2, ll r2) {
    return {max(l1, l2), min(r1, r2)};
}


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    p.resize(n, 0);
    eList.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        eList[p[i]].push_back(i);
        eList[i].push_back(p[i]);
    }
    vector<ll> l(n), r(n);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }

    int m;
    cin >> m;
    bool failed = false;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        if (failed) {
            cout << "0\n";
            continue;
        }
        vector<int> path1, path2;
        target = b;
        dfs(a, a, path1);
        target = d;
        dfs(c, c, path2);

        set<int> used;
        set<set<int>> pairs;
        int sz = path1.size();
        ll ans = 1;
        for (int i = 0; i < sz; i++) {
            if (pairs.count({path1[i], path2[i]})) {
                continue;
            }
            ll l1 = max(l[path1[i]], l[path2[i]]), r1 = min(r[path1[i]], r[path2[i]]);
            if (r1 < l1) {
                failed = true;
                ans = 0;
                break;
            }
            l[path1[i]] = l1, l[path2[i]] = l1;
            r[path1[i]] = r1, r[path2[i]] = r1;
            ans = (ans * (r1 - l1 + 1)) % mod;
            used.insert(path1[i]);
            used.insert(path2[i]);
            pairs.insert({path1[i], path2[i]});
        }

        for (int i = 0; i < n; i++) {
            if (!used.count(i)) {
                ans = (ans * (r[i] - l[i] + 1)) % mod;
            }
        }

        cout << ans << "\n";


    }



    return 0;
}
