//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
T square(T a) {
	return a * a;
}

ll binpow(ll a, ll b) {
	return (b == 0 ? 1 : square(binpow(a, b / 2)) % MOD * (b % 2 ? a : 1) % MOD);
}

ll inv(ll x) {
	return binpow(x, MOD - 2);
}

struct DSU {
	vector<ll> p, sz, l, r;
	DSU(ll n, vector<ll> l, vector<ll> r): l(l), r(r) {
		p.resize(n);
		sz.resize(n, 0);
		for (ll i = 0; i < n; i++) {
			p[i] = i;
		}
	}
	ll get(ll v) {
		return (p[v] == v ? v : p[v] = get(p[v]));
	}
	ll g(ll v) {
		v = get(v);
		return max(0ll, r[v] - l[v] + 1);
	}
	bool unite(ll a, ll b) {
		a = get(a);
		b = get(b);
		if (a == b) {
			return true;
		}
		if (sz[a] < sz[b]) {
			swap(a, b);
		}
		sz[a] += sz[b];
		p[b] = a;
		assign_max(l[a], l[b]);
		assign_min(r[a], r[b]);
		return false;
	}
	bool check(ll a, ll b) {
		return get(a) == get(b);
	}
};

ll dfs(ll v, vector<ll>& p, vector<ll>& h) {
	if (h[v] != -1) {
		return h[v];
	}
	return h[v] = dfs(p[v], p, h) + 1;
}

void solve() {
	ll n;
	cin >> n;
	vector<ll> p(n, 0);
	for (ll i = 1; i < n; i++) {
		cin >> p[i];
		p[i]--;
	}
	vector<ll> h(n, -1);
	h[0] = 0;
	for (ll i = 1; i < n; i++) {
		dfs(i, p, h);
	}
	vector<ll> l(n), r(n);
	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	DSU dsu(n, l, r);
	ll ans = 1;
	for (ll i = 0; i < n; i++) {
		ans *= dsu.g(i);
		ans %= MOD;
	}
	ll m;
	cin >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		vector<ll> upa, upb, upc, upd;
		while (h[a] > h[b]) {
			upa.push_back(a);
			a = p[a];
		}
		while (h[b] > h[a]) {
			upb.push_back(b);
			b = p[b];
		}
		while (h[c] > h[d]) {
			upc.push_back(c);
			c = p[c];
		}
		while (h[d] > h[c]) {
			upd.push_back(d);
			d = p[d];
		}
		while (a != b) {
			upa.push_back(a);
			upb.push_back(b);
			a = p[a];
			b = p[b];
		}
		while (c != d) {
			upc.push_back(c);
			upd.push_back(d);
			c = p[c];
			d = p[d];
		}
		upa.push_back(a);
		upc.push_back(c);
		while (!upb.empty()) {
			upa.push_back(upb.back());
			upb.pop_back();
		}
		while (!upd.empty()) {
			upc.push_back(upd.back());
			upd.pop_back();
		}
		for (ll i = 0; i < upa.size(); i++) {
			if (!dsu.check(upa[i], upc[i])) {
				ans *= inv(dsu.g(upa[i]));
				ans %= MOD;
				ans *= inv(dsu.g(upc[i]));
				ans %= MOD;
				dsu.unite(upa[i], upc[i]);
				ans *= dsu.g(upa[i]);
				ans %= MOD;
			}
		}
		cout << ans << '\n';
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}
