#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5 + 1;
const ll MOD = 1e9 + 7;

int up[MAXN];
vector <int> h(MAXN, -1);

ll bin_pow(ll a, ll deg) {
    if (deg == 0) {
        return 1;
    }
    if (deg & 1) {
        return bin_pow(a, deg - 1) * a % MOD;
    }
    ll k = bin_pow(a, deg / 2);
    return k * k % MOD;
}

struct CHT {
    vector <ll> l, r;
    vector <int> p;
    vector <int> sz;
    ll ans;
    CHT(int n = MAXN) {
        ans = 1;
        p.resize(n);
        sz.resize(n, 1);
        l.resize(n);
        r.resize(n);
        for (int i = 0; i < n; i++) {
            p[i] = i;
        }
    }
    int pred(int v) {
        if (p[v] == v) {
            return v;
        }
        return p[v] = pred(p[v]);
    }
    void merge(int u, int v) {
        u = pred(u);
        v = pred(v);
        if (u == v) {
            return;
        }
        if (sz[u] > sz[v]) {
            swap(u, v);
        }
        sz[v] += sz[u];
        p[u] = v;

        if (max(l[v], l[u]) > min(r[v], r[u])) {
            ans = 0;
        } else {
            ans *= bin_pow(r[v] - l[v] + 1, MOD - 2);
            ans %= MOD;
            ans *= bin_pow(r[u] - l[u] + 1, MOD - 2);
            ans %= MOD;
            l[v] = max(l[v], l[u]);
            r[v] = min(r[v], r[u]);
            ans *= (r[v] - l[v] + 1);
            ans %= MOD;
        }
    }
};

void dfs(int v) {
    if (v == 0) {
        h[v] = 0;
    }
    if (h[up[v]] == -1) {
        dfs(up[v]);
    }
    h[v] = h[up[v]] + 1;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    h[0] = 0;
    for (int i = 1; i < n; i++) {
        cin >> up[i];
        up[i]--;
    }
    for (int i = 0; i < n; i++) {
        if (h[i] == -1) {
            dfs(i);
        }
    }
    CHT z(n);
    for (int i = 0; i < n; i++) {
        cin >> z.l[i] >> z.r[i];
        z.ans = (z.ans * (z.r[i] - z.l[i] + 1) % MOD);
    }
    int m;
    cin >> m;
    int a, b, c, d;
    while (m--) {
        cin >> a >> b >> c >> d;
        if (z.ans == 0) {
            cout << z.ans << "\n";
            continue;
        }
        a--;
        b--;
        c--;
        d--;
        vector <int> fa, fb, fc, fd;
        while (h[a] > h[b]) {
            fa.push_back(a);
            a = up[a];
        }
        while (h[a] < h[b]) {
            fb.push_back(b);
            b = up[b];
        }
        while (a != b) {
            fa.push_back(a);
            a = up[a];
            fb.push_back(b);
            b = up[b];
        }
        fa.push_back(a);
        while (h[c] > h[d]) {
            fc.push_back(c);
            c = up[c];
        }
        while (h[c] < h[d]) {
            fd.push_back(d);
            d = up[d];
        }
        while (c != d) {
            fc.push_back(c);
            c = up[c];
            fd.push_back(d);
            d = up[d];
        }
        fc.push_back(c);
        for (int i = (int)fb.size() - 1; i >= 0; i--) {
            fa.push_back(fb[i]);
        }
        for (int i = (int)fd.size() - 1; i >= 0; i--) {
            fc.push_back(fd[i]);
        }
        for (int i = 0; i < fa.size(); i++) {
            z.merge(fa[i], fc[i]);
            if (z.ans == 0) {
                break;
            }
        }
        cout << z.ans << "\n";
    }
}
