#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstring>
#include <cstdlib>
#include <map>
#include <unordered_map>
#include <set>
#include <iomanip>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

int n;
vector<int> p, tin, tout, way, anc, anc_sz;
vector<vector<int> > g;
vector<pair<int, int> > a;
vector<bool> used;
int timer;

const int mod = 1e9 + 7;

void dfs_precalc(int v){
    used[v] = true;
    tin[v] = sz(way);
    way.push_back(v);
    for(auto u : g[v])
        if (!used[u]){
            dfs_precalc(u);
            tout[v] = sz(way);
            way.push_back(v);
        }
    if (tout[v] == 0){
        tout[v] = sz(way);
        way.push_back(v);
    }
}

bool in(int v, int u){
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int find_anc(int v){
    if (anc[v] == v)
        return v;
    return anc[v] = find_anc(anc[v]);
}

bool unite(int v, int u){
    v = find_anc(v);
    u = find_anc(u);
    if (v == u)
        return false;
    if (anc_sz[v] < anc_sz[u])
        swap(v, u);
    a[v].first = max(a[v].first, a[u].first);
    a[v].second = min(a[v].second, a[u].second);
    anc_sz[v] += anc_sz[u];
    anc[u] = v;
    return true;
}

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    anc.resize(n);
    anc_sz.resize(n);
    tin.resize(n);
    tout.resize(n);
    p.resize(n);
    g.resize(n);
    a.resize(n);
    used.resize(n);
    for(int i = 1; i < n; i ++){
        cin >> p[i];
        p[i] --;
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }

    for(int i = 0; i < n; i ++){
        anc[i] = i;
        anc_sz[i] = 1;
    }

    for(int i = 0; i < n; i ++)
        cin >> a[i].first >> a[i].second;


    dfs_precalc(0);
//    for(int i = 0; i < sz(way); i ++)
//        cout << way[i] + 1;
//    cout << '\n';


    int q;
    cin >> q;
    while(q --){
        int s[2], f[2];
        cin >> s[0] >> f[0] >> s[1] >> f[1];
        s[0] --; f[0] --; s[1] --; f[1] --;

        int top[2], ma[2] = {-1, -1};
        for(int i = 0; i < n; i ++){
            if (in(i, s[0]) && in(i, f[0]) && tin[i] > ma[0]){
                ma[0] = tin[i];
                top[0] = i;
            }
            if (in(i, s[1]) && in(i, f[1]) && tin[i] > ma[1]){
                ma[1] = tin[i];
                top[1] = i;
            }
        }

        vector<int> go[2];
        for(int i = 0; i < 2; i ++){
            int pos = s[i];
            while(pos != top[i]){
                go[i].push_back(pos);
                pos = p[pos];
            }
            go[i].push_back(pos);
            int mem = sz(go[i]);
            pos = f[i];
            while(pos != top[i]){
                go[i].push_back(pos);
                pos = p[pos];
            }
            reverse(go[i].begin() + mem, go[i].end());
        }
        int len = sz(go[0]);

        for(int i = 0; i < len; i ++)
            unite(go[0][i], go[1][i]);

        set<int> now;
        for(int i = 0; i < n; i ++)
            now.insert(find_anc(i));
        int ans = 1;
        for(auto i : now){
            if (a[i].first > a[i].second)
                ans = 0;
            else
                ans *= a[i].second - a[i].first + 1;
            ans %= mod;
        }
        cout << ans << '\n';
    }
}
