#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) (a.size())

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 2e5 + 100;

vector <vector <int>> g(nmax);
vector <int> cnt(nmax), p(nmax), dep(nmax);
vector <set<pair<int, int>>> st(nmax);

vector <vector <int>> jump(22, vector <int> (nmax));
/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
 */

void dfs(int v, int par = -1) {
    if (par != -1) dep[v] = dep[par] + 1, jump[0][v] = par;
    for (auto to : g[v])
        if (to != par)
            dfs(to, v);
}

int up(int u, int v) {
    for (int i = 21; i >= 0; i--) {
        if (dep[u] - (1LL << i) >= dep[v]) {
            u = jump[i][u];
        }
    }
    return u;
}

int lca(int u, int v) {
    if (dep[u] > dep[v])
        u = up(u, v);
    if (dep[u] < dep[v])
        v = up(v, u);
    if (u == v)
        return u;

    for (int i = 21; i >= 0; i--) {
        if (jump[i][u] != jump[i][v])
            u = jump[i][u], v = jump[i][v];
    }

    return jump[0][u];
}

struct DSU {
    vector <int> par, siz;

    DSU(int n) {
        par.assign(n + 1, 0);
        siz.assign(n + 1, 1);
        iota(all(par), 0);
    }

    int getpar(int v) {
        return par[v] == v ? v : par[v] = getpar(par[v]);
    }

    void union_sets(int a, int b) {
        int A = getpar(a);
        int B = getpar(b);
        if (A == B) return;
        if (siz[A] < siz[B]) {
            par[A] = B;
        }
        else if (siz[A] > siz[B]) {
            par[B] = A;
        }
        else {
            par[B] = A;
            siz[A]++;
        }
    }
};

int binpow(int a, int m) {
    if (m == 0) return 1;
    if (m & 1) {
        return a * binpow(a, m - 1) % mod;
    }
    else {
        int b = binpow(a, m / 2);
        return b * b % mod;
    }
}

int inv(int x) {
    return binpow(x, mod - 2);
}

vector <int> invv(1e7);

void solve() {
    for (int i = 0; i < sz(invv); i++)
        invv[i] = inv(i);
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int x;
        cin >> x;
        g[i].push_back(x);
        g[x].push_back(i);
        p[i] = x;
    }
    p[1] = 1;

    jump[0][1] = 1;
    dep[1] = 1;
    dfs(1);

    for (int i = 1; i < 22; i++) {
        for (int j = 1; j <= n; j++) {
            jump[i][j] = jump[i - 1][jump[i - 1][j]];
        }
    }

    int ans = 1;
    for (int i = 1; i <= n; i++) {
        int l, r;
        cin >> l >> r;
        st[i].insert({l, r});
        cnt[i] += r - l + 1;
        ans = ans * cnt[i] % mod;
    }

    DSU dsu(n);

    int q, F = 0;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        if (F == 1) {
            cout << 0 << '\n';
            continue;
        }

        int u = lca(a, b), v = lca(c, d);
        vector <int> patha, pathb;
        while (a != u)
            patha.emplace_back(a), a = p[a];
        patha.emplace_back(a);
        vector <int> pa;
        while (a != b)
            pa.emplace_back(b), b = p[b];
        for (int i = sz(pa) - 1; i >= 0; i--)
            patha.emplace_back(pa[i]);

        while (c != v)
            pathb.emplace_back(c), c = p[c];
        pathb.emplace_back(c);
        pa.clear();
        while (c != d)
            pa.emplace_back(d), d = p[d];
        for (int i = sz(pa) - 1; i >= 0; i--)
            pathb.emplace_back(pa[i]);

        for (int i = 0; i < sz(patha); i++) {
            int o = dsu.getpar(patha[i]), e = dsu.getpar(pathb[i]);
            dsu.union_sets(o, e);
            int A = dsu.getpar(o), B = dsu.getpar(e);
            if (o != e) {
                if (o == A) swap(o, e);
                for (auto x: st[o]) {
                    set<pair<int, int>> stn;
                    for (auto y : st[e]) {
                        if (x.second < y.first) break;
                        if (x.second < y.first || x.first > y.second) continue;
                        if (x.first >= y.first && x.second <= y.second) stn.insert(x);
                        else if (y.first >= x.first && y.second <= x.second) stn.insert(y);
                        else if (x.second >= y.first && x.second <= y.second) stn.insert({y.first, x.second});
                        else if (x.first <= y.second && y.second <= x.second) stn.insert({x.first, y.second});
                    }

                    st[e].clear();
                    st[e] = stn;
                }
                if (cnt[e] < sz(invv))
                    ans = ans * invv[cnt[e]] % mod;
                else
                    ans = ans * inv(cnt[e]) % mod;
                if (cnt[o] < sz(invv))
                    ans = ans * invv[cnt[o]] % mod;
                else
                    ans = ans * inv(cnt[o]) % mod;
                cnt[e] = 0;
                if (st[e].empty()) {
                    F = 1;
                    break;
                }

                for (auto x : st[e]) {
                    cnt[e] += x.second - x.first + 1;
                }
                ans = ans * cnt[e] % mod;
            }
        }

        if (F == 1) {
            cout << 0 << '\n';
            continue;
        }

        cout << ans << '\n';

    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}