#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
//random_device rd;
//mt19937 gen(rd);
const int SZ = 2e5 + 1;
vector<int> g[SZ], rg[SZ];
vector<int> pr(SZ, 1);

struct segment_tree {
    struct Node {
        int add, mx, cnt;
        Node(int x = 0) {
            add = 0;
            mx = x;
            cnt = 1;
        }
    };
    int sz;
    vector<Node> tree;

    segment_tree(int n) {
        int k = 1;
        while (k < n)
            k <<= 1;
        sz = k;
        tree.assign(sz * 2 - 1, Node());
        build(0, 0, sz);
    }

    void push(int v) {
        tree[v * 2 + 1].add += tree[v].add;
        tree[v * 2 + 1].mx += tree[v].add;
        tree[v * 2 + 2].add += tree[v].add;
        tree[v * 2 + 2].mx += tree[v].add;
        tree[v].add = 0;
    }
    void mer(Node& a, Node& b, Node& c) {
        c = a;
        if (c.mx < b.mx) {
            c = b;
        }
        else {
            if (c.mx == b.mx)
                c.cnt += b.cnt;
        }
        c.add = 0;
    }
    void build(int v, int l, int r) {
        if (r - l == 1)
            return;
        int m = (l + r) / 2;
        build(v * 2 + 1, l, m);
        build(v * 2 + 2, m, r);
        mer(tree[v * 2 + 1], tree[v * 2 + 2], tree[v]);
    }


    void add(int v, int l, int r, int ql, int qr, int x) {
        if (r <= ql || qr <= l)
            return;
        if (ql <= l && r <= qr) {
            tree[v].add += x;
            tree[v].mx += x;
            return;
        }
        push(v);
        int m = (l + r) / 2;
        add(v * 2 + 1, l, m, ql, qr, x);
        add(v * 2 + 2, m, r, ql, qr, x);
        mer(tree[v * 2 + 1], tree[v * 2 + 2], tree[v]);
    }
};

vector<int> pred(SZ, 1), ranks(SZ, 1);

int get_root(int v) {
    if (pred[v] == v)
        return v;
    return pred[v] = get_root(pred[v]);
}

void mer(int u, int v) {
    u = get_root(u);
    v = get_root(v);
    if (u == v)
        return;
    if (ranks[u] < ranks[v]) {
        ranks[v] = max(ranks[v], ranks[u] + 1);
        pred[u] = v;
    }
    else {
        ranks[u] = max(ranks[u], ranks[v] + 1);
        pred[v] = u;
    }
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    ll mod = 1e9 + 7;
    bool px = 1;
    cin >> n;
    vector<pair<int, int>> seg(n + 1, { 0, 0 });
    for (int i = 2; i <= n; i++) {
        pred[i] = i;
        int x;
        cin >> x;
        g[x].push_back(i);
        pr[i] = x;
        if (pr[i] != i - 1)
            px = 0;
    }
    for (int i = 1; i <= n; i++)
        cin >> seg[i].first >> seg[i].second;
    int m;
    cin >> m;
    if (px) {
        for (int i = 0; i < m; i++) {
            int a, b, k1 = 1;
            int c, d, k2 = 1;
            cin >> a >> b >> c >> d;
            if (a > b)
                k1 = -1;
            if (c > d)
                k2 = -1;
            mer(a, c);
            while (a != b) {
                a += k1;
                c += k2;
                mer(a, c);
            }
            vector<int> sz(n + 1, 0);
            vector<bool> used(n + 1, 0);
            vector<segment_tree> tr(n + 1, segment_tree(0));
            for (int i = 1; i <= n; i++) {
                int x = get_root(i);
                if (sz[x] == 0) {
                    tr[x] = segment_tree(8);
                }
                tr[x].add(0, 0, tr[x].sz, seg[i].first, seg[i].second + 1, 1);
                sz[x]++;
            }
            ll ans = 1;
            for (int i = 1; i <= n; i++) {
                int x = get_root(i);
                if (used[x])
                    continue;
                used[x] = 1;
                if (tr[x].tree[0].mx < sz[x])
                    ans = 0;
                ans = ans * (ll)tr[x].tree[0].cnt % mod;
            }
            cout << ans << ' ';
        }
    }
}