#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <iomanip>
#include <algorithm>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>

using namespace std;
typedef long long ll;
typedef long double ld;
//random_device rd;
//mt19937 gen(rd);
const int SZ = 2e5 + 1;
vector<int> g[SZ], rg[SZ];
vector<int> pr(SZ, 1);

struct segment_tree {
    struct Node {
        int add, mx, cnt, l, r;
        Node(int x = 0) {
            add = 0;
            mx = x;
            cnt = 1;
            l = -1;
            r = -1;
        }
    };
    int sz;
    vector<Node> tree;

    segment_tree(int n = 1e9 + 8) {
        int k = 1;
        while (k < n)
            k <<= 1;
        sz = k;
        tree.assign(1, Node());
        tree[0].cnt = sz;
    }

    void push(int v, int l, int r) {
        if (tree[v].l == -1) {
            tree[v].l = tree.size();
            tree.push_back(Node());
            tree.back().cnt = (r - l) / 2;
        }
        if (tree[v].r == -1) {
            tree[v].r = tree.size();
            tree.push_back(Node());
            tree.back().cnt = (r - l) / 2;
        }
        tree[tree[v].l].add += tree[v].add;
        tree[tree[v].l].mx += tree[v].add;
        tree[tree[v].r].add += tree[v].add;
        tree[tree[v].r].mx += tree[v].add;
        tree[v].add = 0;
    }

    void mer(Node& a, Node& b, Node& c) {
        if (a.mx < b.mx) {
            c.mx = b.mx;
            c.cnt = b.cnt;
        }
        else {
            if (a.mx == b.mx) {
                c.cnt = a.cnt + b.cnt;
                c.mx = a.mx;
            }
            else {
                c.mx = a.mx;
                c.cnt = a.cnt;
            }
        }
        c.add = 0;
    }


    void add(int v, int l, int r, int ql, int qr, int x) {
        if (r <= ql || qr <= l)
            return;
        if (ql <= l && r <= qr) {
            tree[v].add += x;
            tree[v].mx += x;
            return;
        }
        push(v, l, r);
        int m = (l + r) / 2;
        add(tree[v].l, l, m, ql, qr, x);
        add(tree[v].r, m, r, ql, qr, x);
        mer(tree[tree[v].l], tree[tree[v].r], tree[v]);
    }
};

vector<int> pred(SZ, 1), ranks(SZ, 1);
vector<int> cnm_g[SZ];
vector<segment_tree> tr(SZ, segment_tree());
vector<pair<int, int>> seg(SZ, { 0, 0 }), ti(SZ, { 0, 0 });
vector<int> sz(SZ, 1);
int up[20][SZ];

int get_root(int v) {
    if (pred[v] == v)
        return v;
    return pred[v] = get_root(pred[v]);
}

void mer_dfs(int v, int p) {
    for (auto u : cnm_g[v])
        mer_dfs(u, p);
    sz[p]++;
    tr[p].add(0, 0, tr[p].sz, seg[v].first, seg[v].second + 1, 1);
}

void mer(int u, int v) {
    u = get_root(u);
    v = get_root(v);
    if (u == v)
        return;
    if (ranks[u] < ranks[v]) {
        ranks[v] = max(ranks[v], ranks[u] + 1);
        pred[u] = v;
        mer_dfs(u, v);
        cnm_g[v].push_back(u);
    }
    else {
        ranks[u] = max(ranks[u], ranks[v] + 1);
        pred[v] = u;
        mer_dfs(v, u);
        cnm_g[u].push_back(v);
    }
}

void dfs(int v, int& time) {
    time++;
    ti[v].first = time;
    for (auto u : g[v]) {
        time++;
        dfs(u, time);
    }
    time++;
    ti[v].second = time;
}

void make_up(int n) {
    for (int i = 1; i <= n; i++)
        up[0][i] = pr[i];
    for (int i = 1; i < 20; i++) {
        for (int j = 1; j <= n; j++)
            up[i][j] = up[i - 1][up[i - 1][j]];
    }
    int time = 0;
    dfs(1, time);
}

int get_lca(int v, int u) {
    if (ti[v].first <= ti[u].first && ti[u].second <= ti[v].second)
        return v;
    for (int i = 19; i >= 0; i--) {
        if (ti[up[i][v]].first <= ti[u].first && ti[u].second <= ti[up[i][v]].second)
            continue;
        v = up[i][v];
    }
    v = up[0][v];
    return v;
}

int main()
{
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n;
    ll mod = 1e9 + 7;
    bool px = 1;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        pred[i] = i;
        int x;
        cin >> x;
        g[x].push_back(i);
        pr[i] = x;
        if (pr[i] != i - 1)
            px = 0;
    }
    for (int i = 1; i <= n; i++) {
        cin >> seg[i].first >> seg[i].second;
        tr[i].add(0, 0, tr[i].sz, seg[i].first, seg[i].second + 1, 1);
    }
    make_up(n);
    int m;
    cin >> m;
    for (int k = 0; k < m; k++) {
        int a, b, k1 = 1;
        int c, d, k2 = 1;
        cin >> a >> b >> c >> d;
        if (a > b)
            k1 = -1;
        if (c > d)
            k2 = -1;
        /*mer(a, c);
        while (a != b) {
            a += k1;
            c += k2;
            mer(a, c);
        }*/
        vector<int> p1, p2;
        vector<int> v1;
        int l1 = get_lca(a, b);
        while (a != l1) {
            p1.push_back(a);
            a = pr[a];
        }
        p1.push_back(l1);
        while (b != l1) {
            v1.push_back(b);
            b = pr[b];
        }
        while (!v1.empty()) {
            p1.push_back(v1.back());
            v1.pop_back();
        }
        int l2 = get_lca(c, d);
        while (c != l2) {
            p2.push_back(c);
            c = pr[c];
        }
        p2.push_back(l2);
        while (d != l2) {
            v1.push_back(d);
            d = pr[d];
        }
        while (!v1.empty()) {
            p2.push_back(v1.back());
            v1.pop_back();
        }
        for (int i = 0; i < p1.size(); i++) {
            mer(p1[i], p2[i]);
        }
        vector<bool> used(n + 1, 0);
        ll ans = 1;
        for (int i = 1; i <= n; i++) {
            int x = get_root(i);
            if (used[x])
                continue;
            used[x] = 1;
            if (tr[x].tree[0].mx < sz[x])
                ans = 0;
            ans = ans * (ll)tr[x].tree[0].cnt % mod;
        }
        cout << ans << ' ';
    }
}