#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define f(n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

typedef long long ll;
typedef vector<int> vei;
typedef string str;

const int mod = 1e9+7;

struct DSU {
    vector<int> l, r, p, sz;
    DSU(vector<int> l, vector<int> r) : r(r), l(l) {
        int n = l.size();
        p.resize(n);
        f(n) p[i] = i;
        sz.resize(n, 1);
    }
    int get_root(int v) {
        if(p[v]==v) return v;
        p[v] = get_root(p[v]);
        return p[v];
    };

    void merge(int a, int b) {
        l[a] = max(l[a], l[b]);
        r[a] = min(r[a], r[b]);
    }

    void unite(int a, int b) {
        a = get_root(a);
        b = get_root(b);
        if(sz[a] > sz[b]) {
            sz[a] += sz[b];
            merge(a, b);
            p[b] = a;
        }
        else{
            sz[b] += sz[a];
            merge(b, a);
            p[a] = b;
        }
    }

    int gt(int a) {
        a = get_root(a);
        return r[a]-l[a]+1;
    }
};

int n;
vector<vector<int>> gr;
vector<int> tin, tout;
int timer;

void dfs(int v) {
    tin[v] = timer++;
    for(auto e : gr[v]) dfs(e);
    tout[v] = timer++;
}

bool is_anc(int u, int v) {
    return tin[u]<=tin[v]&&tout[u]>=tout[v];
}

void solve() {
    cin >> n;
    gr.resize(n);
    tin.resize(n);
    tout.resize(n);
    vector<int> p(n);
    f(n - 1) {
        int tt;
        cin >> tt;
        --tt;
        p[i + 1] = tt;
        gr[tt].push_back(i + 1);
    }
    dfs(0);
    vector<int> l(n), r(n);
    f(n) cin >> l[i] >> r[i];
    DSU cr(l, r);
    int q;
    cin >> q;
    f(q) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        vector<int> r1, r2;
        while (!is_anc(b, a)) {
            r1.push_back(b);
            b = p[b];
        }
        r1.pb(b);
        vector<int> tt;
        while (a != b) {
            tt.pb(a);
            a = p[a];
        }
        reverse(all(tt));
        for (auto e: tt) r1.pb(e);
        while (!is_anc(d, c)) {
            r2.push_back(d);
            d = p[d];
        }
        r2.pb(d);
        tt.clear();
        while (d != c) {
            tt.pb(c);
            c = p[c];
        }
        reverse(all(tt));
        for (auto e: tt) r2.pb(e);
        for (int i = 0; i < r2.size(); ++i) {
            cr.unite(r1[i], r2[i]);
        }
        int ans = 1;
        map<int, bool> used;
        f(n) {
            if(used[cr.get_root(i)]) continue;
            used[cr.get_root(i)] = 1;
            ans *= cr.gt(i);
            ans %= mod;
        }
        cout<<ans<<'\n';

    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
    for(int i = 0; i < tc; ++i) {
        // cout << "Test case: " << i+1 << endl;
        solve();
    }
    return 0;
}
