#include "iostream"
#include "vector"
#include "algorithm"
#include "iomanip"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"
#include "deque"

using namespace std;

#define ll long long
//#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const ll MOD = 1e9 + 7;

vector<vector<int>> g;
vector<int> par, tin, tout;
int t = 0;

void dfs(int v) {
    tin[v] = t;
    t++;
    for (auto u: g[v]) {
        dfs(u);
    }
    tout[v] = t;
    t++;
}

bool is_ch(int a, int b) {
    return tin[a] <= tin[b] and tout[b] <= tout[a];
}

vector<int> make_path(int a, int b) {
    vector<int> p1, p2;
    while (not is_ch(a, b)) {
        p1.push_back(a);
        a = par[a];
    }
    p1.push_back(a);
    while (b != a) {
        p2.push_back(b);
        b = par[b];
    }
    reverse(p2.begin(), p2.end());
    for (auto el: p2) {
        p1.push_back(el);
    }
    return p1;
}

vector<pair<int, int>> brn;
vector<int> p, sz;

pair<int, int> inter(pair<int, int> a, pair<int, int> b) {
    return {max(a.first, b.first), min(a.second, b.second)};
}

int get_p(int v) {
    if (v == p[v]) return v;
    return p[v] = get_p(p[v]);
}

void unite(int a, int b) {
    a = get_p(a);
    b = get_p(b);
    if (a == b) return;
    if (sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    brn[a] = inter(brn[a], brn[b]);
    p[b] = a;
}

ll get_len(pair<int, int> a) {
    if (a.first > a.second) return 0;
    return a.second - a.first + 1;
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int n; cin >> n;
    g.resize(n);
    par.resize(n, -1);
    for (int i = 1; i < n; ++i) {
        cin >> par[i];
        par[i]--;
        g[par[i]].push_back(i);
    }
    tin.resize(n); tout.resize(n);
    dfs(0);
    vector<pair<int, int>> br(n);
    for (int i = 0; i < n; ++i) {
        cin >> br[i].first >> br[i].second;
    }
    brn = br;
    p.resize(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
    }
    sz.resize(n, 1);
    int m; cin >> m;
    while (m--) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        auto p1 = make_path(a, b), p2 = make_path(c, d);
        for (int i = 0; i < p1.size(); ++i) {
            unite(p1[i], p2[i]);
        }
        ll ans = 1;
        for (int i = 0; i < n; ++i) {
            if (p[i] == i) {
                ans *= get_len(brn[i]);
                ans %= MOD;
            }
        }
        cout << ans << '\n';
    }
}