#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define all(a) (a).begin(), (a).end()


const int MOD = 1e9 + 7;
ll answ = 1;


int fast_pow(int a, int p) {
    if (p == 0)
        return 1;

    if (p % 2 == 0) {
        int g = fast_pow(a, p / 2);
        return ((ll)g * g) % MOD;
    }
    else {
        return ((ll)a * fast_pow(a, p - 1)) % MOD;
    }
}


struct INFO {
    int l, r;
    int sz;

    INFO() {}

    INFO(int a, int b, int c) : l(a), r(b), sz(c) {}

    INFO(int a, int b) : l(a), r(b) {}
};


struct SNM {
    vector<int> root;
    vector<INFO> a;

    SNM(int n) {
        a.resize(n);
        root.resize(n);

        for (int i = 0; i < n; ++i) {
            int l, r;
            cin >> l >> r;
            a[i] = INFO(l, r, 1);
            answ = ((ll)answ * (r - l + 1)) % MOD;
            root[i] = i;
        }
    }

    int getRoot(int v) {
        if (root[v] == v)
            return v;

        return root[v] = getRoot(root[v]);
    }

    void merg(int v, int u) {
        int p1 = getRoot(v), p2 = getRoot(u);
        if (p1 == p2)
            return;

        //cout << a[p1].r - a[p1].l + 1 << ' ' << fast_pow(a[p1].r - a[p1].l + 1, MOD - 2) << ' ';
        answ = (answ * fast_pow(a[p1].r - a[p1].l + 1, MOD - 2)) % MOD;
        answ = (answ * fast_pow(a[p2].r - a[p2].l + 1, MOD - 2)) % MOD;

        int l = max(a[p1].l, a[p2].l);
        int r = min(a[p1].r, a[p2].r);

        if (r < l)
            answ = 0;

        answ = ((ll)answ * (r - l + 1)) % MOD;
        if (a[p1].sz < a[p2].sz) {
            root[p1] = p2;
            a[p2] = INFO(l, r);
        }
        else if (a[p1].sz > a[p2].sz) {
            root[p2] = p1;
            a[p1] = INFO(l, r, a[p1].sz + a[p2].sz);
        }
        else {
            root[p1] = p2;
            a[p2] = INFO(l, r, a[p1].sz + 1);
        }
    }
};


vector<vector<int>> graph;
vector<int> parent, lvl;


void dfs(int v, int p, int lev) {
    lvl[v] = lev;
    for (auto u : graph[v]) {
        if (u != p) {
            dfs(u, v, lev + 1);
        }
    }
}


vector<int> find_path(int s, int f) {
    vector<int> beg, fin;
    bool flag = false;
    if (lvl[s] < lvl[f]) {
        swap(s, f);
        flag = true;
    }

    while (lvl[s] != lvl[f]) {
        beg.push_back(s);
        s = parent[s];
    }

    while (s != f) {
        beg.push_back(s);
        fin.push_back(f);
        s = parent[s];
        f = parent[f];
    }

    beg.push_back(s);
    for (int i = (int)fin.size() - 1; 0 <= i; --i) {
        beg.push_back(fin[i]);
    }

    if (flag)
        reverse(all(beg));

    return beg;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    graph.resize(n);
    parent.resize(n);
    lvl.resize(n);

    for (int i = 1; i < n; ++i) {
        int now;
        cin >> now;
        graph[i].push_back(now - 1);
        graph[now - 1].push_back(i);
        parent[i] = now - 1;
    }

    dfs(0, 0, 0);

    SNM snm = SNM(n);

    int m;
    cin >> m;

    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<int> pa1 = find_path(a - 1, b - 1);
        cout << pa1.size() << '|';
        vector<int> pa2 = find_path(c - 1, d - 1);

        for (int j = 0; j < (int)pa1.size(); ++j) {
            snm.merg(pa1[j], pa2[j]);
        }

        cout << answ << '\n';
    }

    return 0;
}
