#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>

#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

typedef long long ll;
typedef long double ld;

#define vec vector 
#define pii pair<ll, ll>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

using namespace std;

#pragma warning(disable: 4996)

map<int, vec<pii>> g;
vec<bool> used;
vec<int> tin, tout;
int timer;
vec<pii> par;

void dfs(int v) {
    used[v] = 1;
    tin[v] = timer++;
    for (auto [to, w] : g[v]) {
        if (!used[to]) {
            dfs(to);
        }
    }
    tout[v] = timer++;
}

bool anc(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

ll makeway(int a, int b) {
    ll nw = 0;
    vec<int> res;
    vec<int> tmp;
    if (anc(a, b)) {
        while (b != a) {
            res.push_back(b);
            nw ^= par[b].second;
            b = par[b].first;
        }
        res.push_back(a);
        reverse(res.begin(), res.end());
    }
    else if (anc(b, a)) {
        while (a != b) {
            res.push_back(a);
            nw ^= par[a].second;
            a = par[a].first;
        }
        res.push_back(b);
    }
    else {
        while (!anc(a, b)) {
            res.push_back(a);
            nw ^= par[a].second;
            a = par[a].first;

        }
        res.push_back(a);

        while (!anc(b, a)) {
            tmp.push_back(b);
            nw ^= par[b].second;
            b = par[b].first;
        }
        reverse(tmp.begin(), tmp.end());
        for (int i = 0; i < tmp.size(); i++) {
            res.push_back(tmp[i]);
        }
    }
    //for (auto elem : res) {
    //    cout << elem << " ";
    //}
    //cout << "\n";
    return nw;
}

void solve() {
    bool sub3 = 1;
    timer = 0;
    used = vec<bool>(0);
    tin = vec<int>(0);
    tout= vec<int>(0);
    par = vec<pii>(0);
    g.clear();
    ll axor = 0;
    int n, m; cin >> n >> m;
    par = vec<pii>(n);
    used = vec<bool>(n);
    tin = vec<int>(n);
    tout = vec<int>(n);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        par[v - 1] = { u - 1 , w};
        g[u - 1].push_back({ v - 1, w });
        axor ^= w;
        if (u >= v)
            sub3 = 0;
    }
    int a, b; cin >> a >> b;
    a--;
    b--;

    if (sub3) {
        dfs(0);
        cout << makeway(a, b) << "\n";
    }

    ll now;

    if (a == b) {
        cout << (axor != 0 ? -1 : axor) << "\n";
        return;
    }

    ll var1 = 0;
    now = a;
    while (now != b) {
        var1 ^= g[now][0].second;
        now = g[now][0].first;
    }

    ll var2 = 0;
    now = b;
    while (now != a) {
        var2 ^= g[now][0].second;
        now = g[now][0].first;
    }

    if (var1 != 0 || var2 != 0) {
        cout << -1 << "\n";
        return;
    }
    cout << 0 << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}