#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 1e6 + 300, mod = 1e9 + 7;
vector<vector<ll>> tree;
vector<pair<ll, ll>> op;
vector<ll> deep;
vector<ll> parent;
struct DSU{
    ll size;
    vector<ll> p, sz;
    void init(ll x){
        size = x;
        for(int i = 0; i <= x; i++){
            p.push_back(i);
            sz.push_back(1);
        }
    }
    ll get(ll x){
        if(p[x] != x)
            return p[x] = get(p[x]);
        return x;
    }
    void unions(ll a, ll b){
        ll pra = get(a), prb = get(b);
        if(pra == prb)
            return;
        if(sz[pra] > sz[pra])
            swap(pra, prb);
        sz[prb] += sz[pra];
        p[pra] = p[prb];
    }
};
void dfs(ll cur){
    for(ll nxt : tree[cur]){
        deep[nxt] = deep[cur] + 1;
        dfs(nxt);
    }
}
void solve(){
    ll n, m;
    cin >> n;
    parent = vector<ll>(n + 1);
    deep = vector<ll>(n + 1);
    tree = vector<vector<ll>>(n + 1);
    op = vector<pair<ll, ll>>(n + 1);
    for(int i = 2; i <= n; i++){
        ll p;
        cin >> p;
        tree[p].push_back(i);
        parent[i] = p;
    }
    DSU dsu;
    dsu.init(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> op[i].first >> op[i].second;
    cin >> m;
    dfs(1);
    auto get_path = [&](ll a, ll b, vector<ll> &path){
        vector<ll> temp_path;
        while(a != b){
            if(deep[a] > deep[b]){
                path.push_back(a);
                a = parent[a];
            }
            else{
                temp_path.push_back(b);
                b = parent[b];
            }
        }
        path.push_back(a);
        for(int j = temp_path.size() - 1; j >= 0; j--)
            path.push_back(temp_path[j]);
    };
    for(int i = 0; i < m; i++){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<ll> path_a, path_b;
        get_path(a, b, path_a);
        get_path(c, d, path_b);
        /*cout << "PATH A: ";
        for(ll num : path_a)
            cout << num << " ";
        cout << "\nPATH B: ";
        for(ll num : path_b)
            cout << num << " ";
        cout << "\n";*/
        for(int j = 0; j < path_a.size(); j++){
            ll l = max(op[dsu.get(path_a[j])].first, op[dsu.get(path_b[j])].first),
            r = min(op[dsu.get(path_a[j])].second, op[dsu.get(path_b[j])].second);
            dsu.unions(path_a[j], path_b[j]);
            op[dsu.get(path_a[j])] = make_pair(l, r);
        }
        ll ans = 1;
        vector<bool> was(n + 1, false);
        for(int j = 1; j <= n; j++) {
            if(was[dsu.get(j)])
                continue;
            was[dsu.get(j)] = true;
            ans = (ans * max((ll) 0, op[dsu.get(j)].second - op[dsu.get(j)].first + 1)) % mod;
        }
        /*for(int j = 1; j <= n; j++){
            cout << j << " " << dsu.get(j) << " " << op[j].first << " " << op[j].second << "\n";
        }*/
        cout << ans << "\n";
    }
}
int main(){
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}
