#pragma GCC optimize("unroll-loops")
#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 1e6 + 300, mod = 1e9 + 7;
vector<vector<int>> tree;
vector<pair<ll, ll>> op;
vector<int> deep;
vector<int> parent;
struct DSU{
    ll size;
    vector<ll> p, sz;
    void init(ll x){
        size = x;
        for(int i = 0; i <= x; i++){
            p.push_back(i);
            sz.push_back(1);
        }
    }
    ll get(ll x){
        if(p[x] != x)
            return p[x] = get(p[x]);
        return x;
    }
    void unions(ll a, ll b){
        ll pra = get(a), prb = get(b);
        if(pra == prb)
            return;
        if(sz[pra] > sz[pra])
            swap(pra, prb);
        sz[prb] += sz[pra];
        p[pra] = p[prb];
    }
};
void dfs(ll cur){
    for(ll nxt : tree[cur]){
        deep[nxt] = deep[cur] + 1;
        dfs(nxt);
    }
}
inline ll bin_pow(ll x, ll p){
    ll ans = 1, a = x;
    while(p > 0){
        if(p % 2)
            ans = (ans * a) % mod;
        a = (a * a) % mod;
        p /= 2;
    }
    return ans;
}
inline ll inverse_element(ll x){
    return bin_pow(x, mod - 2);
}
void solve(){
    ll n, m;
    cin >> n;
    parent = vector<int>(n + 1);
    deep = vector<int>(n + 1);
    tree = vector<vector<int>>(n + 1);
    op = vector<pair<ll, ll>>(n + 1);
    for(int i = 2; i <= n; i++){
        ll p;
        cin >> p;
        tree[p].push_back(i);
        parent[i] = p;
    }
    DSU dsu;
    dsu.init(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> op[i].first >> op[i].second;
    cin >> m;
    ll ans = 1;
    for(int i = 1; i <= n; i++)
        ans = (ans * max((ll)0, op[i].second - op[i].first + 1)) % mod;
    dfs(1);
    auto get_path = [&](ll a, ll b, vector<int> &path){
        vector<int> temp_path;
        while(a != b){
            if(deep[a] > deep[b]){
                path.push_back(a);
                a = parent[a];
            }
            else{
                temp_path.push_back(b);
                b = parent[b];
            }
        }
        path.push_back(a);
        for(int j = temp_path.size() - 1; j >= 0; j--)
            path.push_back(temp_path[j]);
    };
    for(int i = 0; i < m; i++){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<int> path_a, path_b;
        get_path(a, b, path_a);
        get_path(c, d, path_b);
        for(int j = 0; j < path_a.size(); j++){
            if(ans == 0)
                continue;
            ll l = max(op[dsu.get(path_a[j])].first, op[dsu.get(path_b[j])].first),
                    r = min(op[dsu.get(path_a[j])].second, op[dsu.get(path_b[j])].second);
            if(l > r){
                ans = 0;
                continue;
            }
            if(dsu.get(path_a[j]) != dsu.get(path_b[j])) {
                ans = (ans * inverse_element(op[dsu.get(path_a[j])].second - op[dsu.get(path_a[j])].first + 1)) % mod;
                ans = (ans * inverse_element(op[dsu.get(path_b[j])].second - op[dsu.get(path_b[j])].first + 1)) % mod;
                ans = (ans * (r - l + 1)) % mod;
                dsu.unions(path_a[j], path_b[j]);
                op[dsu.get(path_a[j])] = make_pair(l, r);
            }
        }
        cout << ans << "\n";
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}