#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld long double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return (rng() % (r - l + 1)) + l;
}

const int N = 2e5 + 10;

vector<int> g[N];
const int Log = 18;

int up[N][Log];

int tin[N], tout[N], timer = 0;

void dfs (int u, int p = -1) {
    for (int j = 0; j < Log - 1; j++) {
        up[u][j + 1] = up[up[u][j]][j];
    }
    tin[u] = timer++;
    for (auto v : g[u]) {
        if (v == p) continue;
        up[v][0] = u;
        dfs(v, u);
    }
    tout[u] = timer;
}

int p[N];

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca (int u, int v) {
    if (is_ancestor(u, v)) return u;
    if (is_ancestor(v, u)) return v;
    for (int i = Log - 1; i >= 0; i--) {
        if (!is_ancestor(up[u][i], v)) u = up[u][i];
    }
    return up[u][0];
}

const int mod = 1e9 + 7;

int add (int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int mul (int a, int b) {
    return 1ll * (1ll * a * b) % mod;
}

pair<int, int> seg[N];
const int inf = 2e9 + 100;

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        int u;
        cin >> u;
        u--;
        p[i] = u;
        g[u].push_back(i);
        g[i].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        cin >> seg[i].first >> seg[i].second;
    }
    dfs(0);
    int m;
    cin >> m;
    vector<vector<int>> G(n);
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        int ab = lca(a, b);
        int cd = lca(c, d);
        vector<int> A, C;
        while (b != ab) {
            A.push_back(b);
            b = p[b];
        }
        vector<int> additional;
        while (a != ab) {
            additional.push_back(a);
            a = p[a];
        }
        additional.push_back(ab);
        reverse(all(additional));
        for (auto v : additional) A.push_back(v);
        additional.clear();
        reverse(all(A));
        while (d != cd) {
            C.push_back(d);
            d = p[d];
        }
        additional.clear();
        while (c != cd) {
            additional.push_back(c);
            c = p[c];
        }
        additional.push_back(cd);
        reverse(all(additional));
        for (auto v : additional) C.push_back(v);
        additional.clear();
        reverse(all(C));
        int ans = 1;
        for (int j = 0; j < sz(A); j++) {
            G[A[j]].push_back(C[j]);
        }
        vector<bool> used(n, false);
        int mn = inf, mx = 0;
        vector<int> t;
        function<void(int)> dfs = [&] (int u) {
            used[u] = true;
            mx = max(mx, seg[u].first);
            mn = min(mn, seg[u].second);
            for (auto v : G[u]) {
                if (!used[v]) dfs(v);
            }
            t.push_back(u);
        };
        for (int j = 0; j < n; j++) {
            if (!used[j]) {
                mn = inf, mx = 0;
                dfs(j);
                int cost = max(0ll, mn - mx + 1);
                ans = mul(ans, cost);
                t.clear();
            }
        }
        cout << ans << endl;
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
*/