#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld long double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return (rng() % (r - l + 1)) + l;
}

const int N = 2e5 + 10;

vector<int> g[N];
const int Log = 18;

int up[N][Log];

int tin[N], tout[N], timer = 0;

void dfs (int u, int p = -1) {
    for (int j = 0; j < Log - 1; j++) {
        up[u][j + 1] = up[up[u][j]][j];
    }
    tin[u] = timer++;
    for (auto v : g[u]) {
        if (v == p) continue;
        up[v][0] = u;
        dfs(v, u);
    }
    tout[u] = timer;
}

int p[N];

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int lca (int u, int v) {
    if (is_ancestor(u, v)) return u;
    if (is_ancestor(v, u)) return v;
    for (int i = Log - 1; i >= 0; i--) {
        if (!is_ancestor(up[u][i], v)) u = up[u][i];
    }
    return up[u][0];
}

const int mod = 1e9 + 7;

int add (int a, int b) {
    if (a + b >= mod) return a + b - mod;
    return a + b;
}

int mul (int a, int b) {
    return 1ll * (1ll * a * b) % mod;
}

vector<pair<int, int>> seg;
const int inf = 2e9 + 100;

int ans = 1;

int bin_pow (int n, int k) {
    if (k == 0) return 1;
    if (k == 1) return n;
    if (k & 1) return mul(n, bin_pow(n, k - 1));
    int t = bin_pow(n, k / 2);
    return mul(t, t);
}

int rev (int x) {
    x = max(x, 0ll);
    return bin_pow(x, mod - 2);
}

struct dsu {
    vector<int> d;
    vector<int> p;
    vector<pair<int, int>> comp;
    void init (int k) {
        d.assign(k, 0);
        p.assign(k, 0);
        iota(all(p), 0ll);
        comp = seg;
    }
    int find (int u) {
        if (u == p[u]) return u;
        return p[u] = find(p[u]);
    }
    void unite (int u, int v) {
        u = find(u);
        v = find(v);
        if (u == v) return;
        if (d[u] < d[v]) swap(u, v);
        d[u] += d[v];
        p[v] = u;
        ans = mul(ans, rev(comp[u].second - comp[u].first + 1));
        comp[u].first = max(comp[u].first, comp[v].first);
        comp[u].second = min(comp[u].second, comp[v].second);
        ans = mul(ans, rev(comp[v].second - comp[v].first + 1));
        ans = mul(ans, comp[u].second - comp[u].first + 1);
    }
};

void solve() {
    int n;
    cin >> n;
    seg.resize(n);
    for (int i = 1; i < n; i++) {
        int u;
        cin >> u;
        u--;
        p[i] = u;
        g[u].push_back(i);
        g[i].push_back(u);
    }
    for (int i = 0; i < n; i++) {
        cin >> seg[i].first >> seg[i].second;
        ans = mul(ans, seg[i].second - seg[i].first + 1);
    }
    dfs(0);
    dsu x;
    x.init(n);
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        if (ans == 0) {
            cout << ans << '\n';
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        int ab = lca(a, b);
        int cd = lca(c, d);
        vector<int> A, C;
        while (b != ab) {
            A.push_back(b);
            b = p[b];
        }
        vector<int> additional;
        while (a != ab) {
            additional.push_back(a);
            a = p[a];
        }
        additional.push_back(ab);
        reverse(all(additional));
        for (auto v : additional) A.push_back(v);
        additional.clear();
        reverse(all(A));
        while (d != cd) {
            C.push_back(d);
            d = p[d];
        }
        additional.clear();
        while (c != cd) {
            additional.push_back(c);
            c = p[c];
        }
        additional.push_back(cd);
        reverse(all(additional));
        for (auto v : additional) C.push_back(v);
        additional.clear();
        reverse(all(C));
        for (int j = 0; j < sz(A); j++) {
            x.unite(A[j], C[j]);
        }
        cout << ans << endl;
    }
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
*/