#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;

const ll MOD = 1e9 + 7;

int find_set(int v, vii& p) {
	if (p[v] == v) {
		return v;
	}
	return p[v] = find_set(p[v], p);
}

void merge(int v, int u, vii& p, vii& r) {
	v = find_set(v, p);
	u = find_set(u, p);
	if (v == u) {
		return;
	}
	if (r[v] < r[u]) {
		swap(v, u);
	}
	p[u] = v;
	if (r[u] == r[v]) {
		r[v]++;
	}
}

bool dfs(int v, int u, int p, vvi& gr, vii& path) {
	if (u == v) {
		path.push_back(v);
		return 1;
	}
	for (auto& to : gr[v]) {
		if (to == p) {
			continue;
		}
		if (dfs(to, u, v, gr, path)) {
			path.push_back(v);
			return 1;
		}
	}
	return 0;
}

ll binpow(ll val, int q) {
	if (q == 0) {
		return 1;
	}
	if (q % 2) {
		return (val * binpow(val, q - 1)) % MOD;
	}
	return binpow((val * val) % MOD, q / 2);
}

void solve() {
	int n;
	cin >> n;
	vvi gr(n + 1);
	for (int i = 2; i <= n; i++) {
		int p;
		cin >> p;
		gr[i].push_back(p);
		gr[p].push_back(i);
	}
	vii l(n + 1), r(n + 1);
	ll tmp = 1;
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
		tmp = (tmp * max(r[i] - l[i] + 1, 0)) % MOD;
	}
	int m;
	cin >> m;
	vii p(n + 1), rr(n + 1, 1);
	for (int i = 1; i <= n; i++) {
		p[i] = i;
	}
	vbb used(n + 1);
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		vii p1, p2;
		dfs(a, b, a, gr, p1);
		dfs(c, d, c, gr, p2);
		vii q;
		for (int i = 0; i < p1.size(); i++) {
			if (!used[p1[i]]) {
				tmp = (tmp * binpow(max(r[p1[i]] - l[p1[i]] + 1, 0), MOD - 2)) % MOD;
				used[p1[i]] = 1;
			}
			if (!used[p2[i]]) {
				tmp = (tmp * binpow(max(r[p2[i]] - l[p2[i]] + 1, 0), MOD - 2)) % MOD;
				used[p2[i]] = 1;
			}
			l[p1[i]] = max(l[p1[i]], l[p2[i]]);
			l[p2[i]] = max(l[p1[i]], l[p2[i]]);
			r[p1[i]] = min(r[p1[i]], r[p2[i]]);
			r[p2[i]] = min(r[p1[i]], r[p2[i]]);
			merge(p1[i], p2[i], p, rr);
			q.push_back(p1[i]);
			q.push_back(p2[i]);
		}
		for (auto& i : q) {
			l[find_set(i, p)] = max(l[find_set(i, p)], l[i]);
			r[find_set(i, p)] = min(r[find_set(i, p)], r[i]);
		}
		for (auto& i : q) {
			l[i] = l[find_set(i, p)];
			r[i] = r[find_set(i, p)];
		}
		ll ans = tmp;
		for (auto& i : q) {
			if (l[i] > r[i]) {
				ans = 0;
				tmp = 0;
				continue;
			}
			if (find_set(i, p) != i || !used[i]) {
				continue;
			}
			ans = ans * (r[i] - l[i] + 1);
			tmp = (tmp * (r[i] - l[i] + 1)) % MOD;
			used[i] = 0;
			ans = ans % MOD;
		}
		cout << ans << '\n';
	}
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}