#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back

const int N = 5e5 + 1;
const int mod = 1e9 + 7;


struct segtree {
    vc <int> t; int n;
    segtree () {}
    segtree (int n): n(n) {
        t.resize(n * 2, -1);
        for (int i = 0; i < n; ++i)
            t[i + n] = i;
    }
    int merge (int i, int j) {
        return (i == -1 || j == -1 || i != j ? -1 : i);
    }
    void upd (int i, int x) {
        for (t[i += n] = x; i > 1; i >>= 1) {
            t[i >> 1] = merge(t[i], t[i ^ 1]);
        }
    }
    int get (int l, int r) {
        int rt = -2;
        for (l += n, r += n + 1; l < r; l >>= 1, r >>= 1) {
            if (l & 1) {
                if (rt == -2)
                    rt = t[l];
                else
                    rt = merge(rt, t[l]);
                l++;
            }
            if (r & 1) {
                --r;
                if (rt == -2)
                    rt = t[r];
                else
                    rt = merge(rt, t[r]);
            }
        }
        return rt;
    }
};

vc <int> g[N];
int l[N], r[N];
int tin[N], tout[N];
int pr[N];
int ans = 1;


vc <int> path;

int mul (int a, int b) {
    return a * 1ll * b % mod;
}

int bin_pow (int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1)
            res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}

bool is_ancestor (int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

void get_path (int u, int v) {
    path.clear();
    vc <int> tt;
    while (!is_ancestor(v, u)) {
        tt.pb(v);
        v = pr[v];
    }
    while (!is_ancestor(u, v)) {
        path.pb(u);
        u = pr[u];
    }
    path.pb(u);
    reverse(all(tt));
    for (int j : tt)
        path.pb(j);
}

int timer = 0;
void dfs (int u, int p = -1) {
    tin[u] = timer++;
    for (int v : g[u]) {
        if (v != p)
            dfs(v, u);
    }
    tout[u] = timer++;
}

int p[N];
vc <int> ls[N];
segtree t;

int unite (int u, int v) {
    u = p[u];
    v = p[v];
    if (u == v)
        return 0;
    if (sz(ls[u]) < sz(ls[v]))
        swap(u, v);
    for (int x : ls[v]) {
        p[x] = u;
        t.upd(x, u);
        ls[u].pb(x);
    }
    ans = mul(ans, bin_pow(r[v] - l[v] + 1, mod - 2));
    ans = mul(ans, bin_pow(r[u] - l[u] + 1, mod - 2));
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    if (l[u] > r[u]) {
        ans = 0;
    } else {
        ans = mul(ans, r[u] - l[u] + 1);
    }
    return 1;
}

void solve () {
    int n;
    cin >> n;
    int ba = 1;
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v; --v; pr[i] = v;
        g[i].pb(v);
        g[v].pb(i);
        ba &= v == i - 1;
    }
    t = segtree(n);
    dfs(0);
    iota(p, p + n, 0);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
    }
    int m;
    cin >> m;
//    if (ba) {
//
//        for (int i = 0; i < m; ++i) {
//            int a, b, c, d;
//            cin >> a >> b >> c >> d; --a; --b; --c; --d;
//        }
//        return;
//    }
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d; --a; --b; --c; --d;
        get_path(a, b);
        vc <int> v1 = path;
        get_path(c, d);
        vc <int> v2 = path;
        for (int j = 0; j < sz(v1); ++j) {
            unite(v1[j], v2[j]);
        }
        cout << ans << '\n';
    }
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    // cin >> t;
    while (t--)
        solve();
}