#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
//#define double long double
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f, P = 1e9 + 7;
const double EPS = 1e-5;

/*
random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);
*/

struct dsu {
    vector<int> p, l, r, sum;

    void init(int n, vector<pair<int, int>> &a) {
        p.assign(n + 1, 0);
        iota(all(p), 0);
        l.resize(n + 1, 0);
        r.resize(n + 1, 0);
        sum.assign(n + 1, 1);
        for (int i = 1; i <= n; i++) {
            l[i] = a[i].fi;
            r[i] = a[i].se;
        }
    }

    int get(int v) {
        if (v == p[v])
            return p[v];
        return p[v] = get(p[v]);
    }

    void merge(int a, int b) {
        a = get(a);
        b = get(b);
        if (a == b)
            return;
        if (sum[a] < sum[b])
            swap(a, b);
        p[b] = a;
        sum[a] += sum[b];
        l[a] = max(l[a], l[b]);
        r[a] = min(r[a], r[b]);
    }

    int get_ans(int v) {
        int u = get(v);
        if (u != v)
            return 1;
        return max(0LL, (r[v] - l[v] + 1)) % P;
    }
};

vector<int> p, tin, tout;
vector<vector<int>> g;
vector<vector<int>> up;
dsu dsu;

void dfs(int v, int &timer) {
    tin[v] = timer;
    timer++;
    for (auto it : g[v]) {
        if (it == p[v])
            continue;
        dfs(it, timer);
    }
    tout[v] = timer;
    timer++;
}

bool acs(int parent, int v) {
    return tin[parent] <= tin[v] && tout[v] <= tout[parent];
}

int lca(int u, int v) {
    for (int i = K - 1; i >= 0; i--) {
        if (!acs(up[v][i], u))
            v = up[v][i];
    }
    if (v != u)
        v = p[v];
    return v;
}

void get_path(pair<int, int> path, vector<int> &full_path) {
    int u = path.fi, v = path.se, q = lca(u, v);
    vector<int> first, second;
    while (u != q) {
        first.em(u);
        u = p[u];
    }
    while (v != q) {
        second.em(v);
        v = p[v];
    }
    full_path = first;
    full_path.em(q);
    reverse(all(second));
    for (auto it : second)
        full_path.em(it);
}

void update(pair<int, int> p1, pair<int, int> p2) {
    vector<int> ord1, ord2;
    get_path(p1, ord1);
    get_path(p2, ord2);
    int n = (int) ord2.size();
    for (int i = 0; i < n; i++) {
        dsu.merge(ord1[i], ord2[i]);
    }
}

void solve() {
    int n;
    cin >> n;
    p.resize(n + 1);
    g.resize(n + 1);
    tin.resize(n + 1);
    tout.resize(n + 1);
    p[1] = 1;
    for (int i = 2; i <= n; i++) {
        int v;
        cin >> v;
        p[i] = v;
        g[i].em(v);
        g[v].em(i);
    }
    int timer = 0;
    dfs(1, timer);
    vector<pair<int, int>> w(n + 1);
    for (int i = 1; i <= n; i++) {
        int l, r;
        cin >> l >> r;
        w[i] = {l, r};
    }
    up.resize(n + 1, vector<int> (K));
    for (int i = 1; i <= n; i++) {
        up[i][0] = i;
        up[i][1] = p[i];
    }
    for (int i = 2; i < K; i++) {
        for (int j = 1; j <= n; j++) {
            up[j][i] = up[up[j][i - 1]][i - 1];
        }
    }
    int m;
    cin >> m;
    vector<pair<int, int>> path1(m), path2(m);
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        path1[i] = {a, b};
        path2[i] = {c, d};
    }
    dsu.init(n, w);
    for (int i = 0; i < m; i++) {
        update(path1[i], path2[i]);
        int ans = 1;
        for (int j = 1; j <= n; j++) {
            ans = (ans * dsu.get_ans(j)) % P;
        }
        cout << ans << '\n';
    }
}

/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
 */

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}