#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

const int maxn = 400000;
const int inf = 1e9;
const int mod = 1e9 + 7;
int par[maxn];
pair<int, int> rng[maxn];
int tin[maxn];
int tout[maxn];
int timer = 0;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

void dfs(int v, vector<vector<int>> &g) {
    tin[v] = timer++;
    for (int u : g[v]) dfs(u, g);
    tout[v] = timer++;
}

bool isa(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int p[maxn];
int sz[maxn];
int col(int v) {
    if (v == p[v]) return v;
    return p[v] = col(p[v]);
}

long long ans = 1;

void unite(int u, int v) {
    u = col(u);
    v = col(v);
    if (u != v) {
        p[u] = v;
        ans *= bp(rng[u].second - rng[u].first + 1);
        ans %= mod;
        ans *= bp(rng[v].second - rng[v].first + 1);
        ans %= mod;
        sz[v] += sz[u];
        rng[v].first = max(rng[v].first, rng[u].first);
        rng[v].second = min(rng[v].second, rng[u].second);
        if (rng[v].second < rng[v].first) ans = 0;
        ans *= rng[v].second - rng[v].first + 1;
        ans %= mod;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        sz[i] = 1;
    }
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
        par[i] = p;
    }
    dfs(0, g);
    for (int i = 0; i < n; ++i) {
        cin >> rng[i].first >> rng[i].second;
    }
    for (int i = 0; i < n; ++i) {
        ans *= (rng[i].second - rng[i].first + 1);
        ans %= mod;
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        vector<int> p11{a}, p12, p21{c}, p22;
        while (a != b) {
            if (!isa(a, b)) {
                a = par[a];
                p11.push_back(a);
            } else {
                p12.push_back(b);
                b = par[b];
            }
            if (!isa(c, d)) {
                c = par[c];
                p21.push_back(c);
            } else {
                p22.push_back(d);
                d = par[d];
            }
        }
        reverse(p12.begin(), p12.end());
        reverse(p22.begin(), p22.end());
        for (int i : p12) {
            p11.push_back(i);
        }
        for (int i : p22) {
            p21.push_back(i);
        }
        for (int j = 0; j < p11.size(); ++j) {
            int u = p11[j];
            int v = p21[j];
            unite(u, v);
        }
        cout << ans << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
