#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

const int MOD = 1e9 + 7;
const int LOG = 20;

vector<vector<int>> gr;

vector<int> p, h;
vector<int> tin, tout;
int timer = 0;

void precalc(int v) {
    tin[v] = timer;
    timer++;
    for (auto to : gr[v]) {
        h[to] = h[v] + 1;
        precalc(to);
    }
    tout[v] = timer;
    timer++;
}

bool is_ancestor(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<vector<int>> bin_up;

int lca(int u, int v) {
    if (is_ancestor(u, v)) return u;
    for (int pw = LOG - 1; pw >= 0; --pw) {
        if (bin_up[pw][u] != -1 && !is_ancestor(bin_up[pw][u], v)) {
            u = bin_up[pw][u];
        }
    }
    return p[u];
}

vector<int> path(int u, int v) {
    vector<int> res;
    int z = lca(u, v);
    while (u != z) {
        res.push_back(u);
        u = p[u];
    }
    res.push_back(z);
    int len_v = h[v] - h[z];
    while (v != z) {
        res.push_back(v);
        v = p[v];
    }
    reverse(res.end() - len_v, res.end());
    return res;
}

int add(int a, int b) {
    if (a + b > MOD) {
        return a + b - MOD;
    } else {
        return a + b;
    }
}

int sub(int a, int b) {
    if (a - b >= 0) {
        return a - b;
    } else {
        return a - b + MOD;
    }
}

int mul(int a, int b) {
    return (int)((ll)a * b % MOD);
}

int binpow(int x, int n) {
    if (n == 0) return 1;
    if (n % 2 == 1) return mul(x, binpow(x, n - 1));
    int half = binpow(x, n / 2);
    return mul(half, half);
}

int rev(int x) {
    return binpow(x, MOD - 2);
}

struct DSU {
    int res;
    vector<int> p, r;
    vector<int> lo, hi;

    DSU(int n, vector<int> &lo, vector<int> &hi) : lo(lo), hi(hi) {
        p.resize(n);
        iota(p.begin(), p.end(), 0);
        r.assign(n, 1);
        res = 1;
        for (int i = 0; i < n; ++i) {
            res = mul(res, hi[i] - lo[i] + 1);
        }
    }

    int get(int v) {
        if (v == p[v]) return v;
        return p[v] = get(p[v]);
    }

    void unite(int u, int v) {
        u = get(u), v = get(v);
        if (u == v) return;
        if (r[u] < r[v]) swap(u, v);
        r[u] += r[v];
        p[v] = u;
        res = mul(res, rev(hi[u] - lo[u] + 1));
        res = mul(res, rev(hi[v] - lo[v] + 1));
        lo[u] = max(lo[u], lo[v]);
        hi[u] = min(hi[u], hi[v]);
        if (lo[u] > hi[u]) {
            res = 0;
        } else {
            res = mul(res, hi[u] - lo[u] + 1);
        }
    }
};

void solve() {
    int n;
    cin >> n;
    gr.resize(n);
    p.resize(n);
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
        gr[p[i]].push_back(i);
    }

    h.assign(n, 0);
    tin.resize(n);
    tout.resize(n);

    precalc(0);

    bin_up.assign(LOG, vector<int> (n, -1));
    bin_up[0] = p;
    for (int pw = 1; pw < LOG; ++pw) {
        for (int i = 0; i < n; ++i) {
            if (bin_up[pw - 1][i] != -1) {
                bin_up[pw][i] = bin_up[pw - 1][bin_up[pw - 1][i]];
            }
        }
    }

    vector<int> l(n), r(n);
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }

    DSU dsu(n, l, r);

    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        auto path1 = path(a, b);
        auto path2 = path(c, d);
        int len = sz(path1);
        for (int i = 0; i < len; ++i) {
            dsu.unite(path1[i], path2[i]);
        }
        cout << dsu.res << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("../in.txt", "r", stdin);
    freopen("../out.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif

    solve();

    return 0;
}