#include <iostream>
#include <algorithm>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;
#pragma GCC optimize("Ofast")
#define int long long 
#define _ << " " << 
#define ld long double
const int MAXN = 2e5 + 10, MAXA = 1e7 + 5, LOG = 33, mod = 1e9 + 7;
int32_t a[MAXN], n, k, l[MAXN], r[MAXN], sz[MAXN], parent[MAXN], h[MAXN];
int32_t lca[MAXN][LOG];
int d[MAXN], ans = 1;
void prepare() {
	for (int i = 1; i <= n; i++) sz[i] = 1;
	for (int i = 1; i <= n; i++) parent[i] = i;
}
int get(int a) {
	if (parent[a] == a) return a;
	else return parent[a] = get(parent[a]);
}
int fst_pow(int a, int b) {
	int ans = 1;
	while (b) {
		if (b & 1) {
			b--;
			ans *= a;
			ans %= mod;
		}
		else {
			b /= 2;
			a *= a;
			a %= mod;
		}
	}
	return ans;
}
bool used[MAXN];
void merge(int a, int b){
	int u = get(a);
	int v = get(b);
	if (u != v) {
		if (sz[u] < sz[v]) {
			swap(u, v);
		}
		int len1 = max(r[u] - l[u] + 1, 0);
		int len2 = max(r[v] - l[v] + 1, 0);

		ans *= fst_pow(len1, mod - 2);
		ans %= mod;
		ans *= fst_pow(len2, mod - 2);
		ans %= mod;

		parent[v] = u;
		sz[u] += sz[v];
		l[u] = max(l[u], l[v]);
		r[u] = min(r[u], r[v]);
		int len = r[u] - l[u] + 1;
		len = max(len, 0ll);

		ans *= len;
		ans %= mod;

		used[v] = true;
	}
}
vector<int> g[MAXN];
void dfs(int u, int p) {
	h[u] = h[p] + 1;
	lca[u][0] = p;
	for (auto v : g[u]) {
		if (v == p) continue;
		dfs(v, u);
	}
}
int getlca(int a, int b) {
	if (a == b) return a;
	if (h[a] < h[b]) swap(a, b);
	for (int i = LOG - 1; i >= 0; i--) {
		int nxta = lca[a][i];
		if (h[b] <= h[nxta]) a = nxta;
	}
	if (a == b) return a;
	for (int i = LOG - 1; i >= 0; i--) {
		int nxta = lca[a][i], nxtb = lca[b][i];
		if (nxta != nxtb) {
			a = nxta;
			b = nxtb;
		}
	}
	return lca[a][0];
}
void getpath(int a, int b, vector<int32_t> &ans) {
	vector<int32_t> tolca;
	int c = getlca(a, b);
	while (a != c) {
		ans.push_back(a);
		a = lca[a][0];
	}
	ans.push_back(c);

	tolca.clear();

	while (b != c) {
		tolca.push_back(b);
		b = lca[b][0];
	}
	reverse(tolca.begin(), tolca.end());
	for (auto v : tolca) ans.push_back(v);
}
int nxt(int &a, int &b) {
	int c = getlca(a, b);
	if (c == a) return b = lca[b][0];
	else return a = lca[a][0];
}
int32_t main()
{
	cin >> n;
	prepare();

	for (int i = 2; i <= n; i++) {
		int u;
		cin >> u;
		g[u].push_back(i);
		g[i].push_back(u);
	}
	dfs(1, 1);
	for (int j = 1; j < LOG; j++) {
		for (int i = 1; i <= n; i++) {
			int nxt = lca[i][j - 1];
			lca[i][j] = lca[nxt][j - 1];
		}
	}
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
		ans *= r[i] - l[i] + 1;
		ans %= mod;
	}
	int q;
	cin >> q;
	for (int i = 1; i <= q; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		bool ok = true;

		vector<int32_t> fst;
		vector<int32_t>sec;
		getpath(a, b, fst);
		getpath(c, d, sec);
		for (int i = 0; i < fst.size(); i++) {
			int u, v;
			u = fst[i];
			v = sec[i];
			merge(u, v);
		}
		cout << ans << '\n';
	}
}