#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <random>

using namespace std;

#define ll long long

int M = 1e9 + 7;

vector<vector<int>> r, pre;
vector<int> ls, rs, h;
int k = 18;

void dfs(int v, int p = -1, int hs = 0) {
	h[v] = hs;
	pre[v][0] = p;
	for (int i = 1; i < k; i++) {
		if (pre[v][i - 1] == -1) pre[v][i] = -1;
		else pre[v][i] = pre[pre[v][i - 1]][i - 1];
	}
	for (int u : r[v]) if (u != p) {
		dfs(u, v, hs + 1);
	}
}

int lca(int a, int b) {
	if (h[a] > h[b]) swap(a, b);
	int j = k - 1;
	while (h[a] != h[b]) {
		if (pre[b][j] != -1 && h[pre[b][j]] >= h[a]) b = pre[b][j];
		j--;
	}
	if (a == b) return a;
	j = k - 1;
	while (a != b && j >= 0) {
		if (pre[b][j] != pre[a][j]) {
			a = pre[a][j];
			b = pre[b][j];
		}
		j--;
	}
	return pre[a][0];
}


vector<int> p, sz;

int ansp = 1, ansq = 1;

int get(int v) {
	if (p[v] == v) return v;
	return p[v] = get(p[v]);
}

void merge(int a, int b) {
	a = get(a);
	b = get(b);
	if (a == b) return;
	if (sz[a] < sz[b]) swap(a, b);
	ansq = (ansq * 1ll * (((rs[a] - ls[a] + 1) * 1ll * (rs[b] - ls[b] + 1)) % M));
	p[b] = a;
	sz[a] += sz[b];
	rs[a] = min(rs[a], rs[b]);
	ls[a] = max(ls[a], ls[b]);
	if (rs[a] < ls[a]) ansp = 0;
	else ansp = (ansp * 1ll * (rs[a] - ls[a] + 1)) % M;
}

int pv(int a, int n) {
	if (n == 0) return 1;
	int ret = pv((a * 1ll * a) % M, n / 2);
	if (n % 2) ret = (ret * 1ll * a) % M;
	return ret;
}

int division(int a, int b) {
	if (a == 0) return 0;
	return (a * 1ll * pv(b, M - 2)) % M;
}

int main() {

	int n;
	int x;
	cin >> n;
	p.resize(n);
	for (int i = 0; i < n; i++) p[i] = i;
	sz.resize(n, 1);
	r.resize(n);
	h.resize(n);
	ls.resize(n);
	rs.resize(n);
	pre.resize(n, vector<int>(k, -1));
	for (int i = 1; i < n; i++) {
		cin >> x;
		x--;
		r[x].push_back(i);
	}
	dfs(0);

	for (int i = 0; i < n; i++) {
		cin >> ls[i] >> rs[i];
		ansp = (ansp * 1ll * (rs[i] - ls[i] + 1)) % M;
	}

	int m;
	cin >> m;
	int a, b, c, d, lc1, lc2;

	int ans = 1;

	for (int i = 0; i < n; i++) {
		ans = (ans * 1ll * (rs[i] - ls[i] + 1)) % M;
	}

	for (int i = 0; i < m; i++) {
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		lc1 = lca(a, b);
		lc2 = lca(c, d);
		//cout << lc1 << ' ' << lc2 << "X\n";
		vector<int> x, y;
		while (a != lc1) {
			x.push_back(a);
			a = pre[a][0];
		}
		x.push_back(lc1);
		int tmp = x.size();
		while (b != lc1) {
			x.push_back(b);
			b = pre[b][0];
		}
		reverse(x.begin() + tmp, x.end());
		while (c != lc2) {
			y.push_back(c);
			c = pre[c][0];
		}
		y.push_back(lc2);
		tmp = y.size();
		while (d != lc2) {
			y.push_back(d);
			d = pre[d][0];
		}
		reverse(y.begin() + tmp, y.end());

		for (int i = 0; i < x.size(); i++) {
			//cout << x[i] << ' ' << y[i] << "\n";
			merge(x[i], y[i]);
		}
		cout << division(ansp, ansq) << "\n";
	}



	return 0;
}