#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
using namespace std;

vector<int> g[2000 * 101];
int tin[2000 * 101];
int tout[2000 * 101];
int binup[2000 * 101][20];
int timer= 0 ;

void dfs(int v, int p) {
    tin[v] = timer;
    timer++;
    binup[v][0] = p;
    for (int i = 1; i < 20; i++) {
        binup[v][i] = binup[binup[v][i - 1]][i - 1];
    }
    for (auto u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = timer;
    timer++;
}

bool anc(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (anc(a, b)) {
        return a;
    }
    if (anc(b, a)) {
        return b;
    }
    for (int i = 19; i >= 0; i--) {
        if (!anc(binup[b][i], a)) {
            b = binup[b][i];
        }
    }
    return binup[b][0];
}

vector<int> fpath(int a, int b) {
    int l = lca(a, b);
    vector<int> p1 = {a};
    vector<int> p2 = {b};
    while (a != l) {
        a = binup[a][0];
        p1.push_back(a);
    }
    while (b != l) {
        b = binup[b][0];
        p2.push_back(b);
    }
    p2.pop_back();
    reverse(p2.begin(), p2.end());
    int f = p1.size();
    p1.resize(p1.size() + p2.size());
    for (int i = f; i < p1.size(); i++) {
        p1[i] = p2[i - f];
    }
    return p1;
}

pair<int, int> now[2000 * 101];

pair<int, int> inter(pair<int, int> a, pair<int, int> b) {
    if (a.first >= b.first) {
        swap(a, b);
    }
    if (a.second < b.first) {
        return {0, -1};
    }
    return {b.first, min(a.second, b.second)};
}

const long long mod = 1e9 + 7;

long long binpow(long long x, long y) {
    if (y == 0) {
        return 1;
    }
    if (y % 2 == 0) {
        return binpow(x * x % mod, y / 2);
    }
    return binpow(x, y - 1) * x % mod;
}

long long _rev(int x) {
    return binpow(x, mod - 2);
}

long long ans = 1;

int dsu[2000 * 101];
int rang[2000 * 101];
long long pr[1000 * 1000];
long long rev(int x) {
    if (x < 1000 * 1000) {
        return pr[x];
    }
    return binpow(x, mod - 2);
}
int pd(int x) {
    if (x == dsu[x]) {
        return x;
    }
    return dsu[x] = pd(dsu[x]);
}

void merge(int a, int b) {
    if (rang[a] < rang[b]) {
        swap(a, b);
    }
    rang[a] += rang[b];
    int pa = pd(a);
    int pb = pd(b);
    if (pa == pb) {
        return;
    }
    int sz1 = now[pa].second - now[pa].first + 1;
    int sz2 = now[pb].second - now[pb].first + 1;
    now[pa] = inter(now[pa], now[pb]);
    dsu[pb] = pa;
    int szn = now[pa].second - now[pa].first + 1;
    ans = ans * rev(sz1) % mod * rev(sz2) % mod * szn % mod;
}


signed main() {
    for (int i = 0; i < 1000 * 1000; i++) {
        pr[i] = _rev(i);
    }
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        int p;
        cin >> p;
        g[p].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        cin >> now[i].first >> now[i].second;
        ans = ans * (now[i].second - now[i].first + 1) % mod;
        dsu[i] = i;
    }

    dfs(1, 1);
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans == 0) {
            cout << 0 << '\n';
            continue;
        }
        auto p1 = fpath(a, b);
        auto p2 = fpath(c, d);
        for (int j = 0; j < p1.size(); j++) {
            merge(p1[j], p2[j]);
        }
        cout << ans << '\n';
    }
}

/*
/home/olymp/PreDay/cmake-build-debug/PreDay
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
 3 4 4 3
 3 4 3 5
 */