#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

const int mod = 1000000007;

int binpow(int n, int k){
    if(k == 0){
        return 1;
    }

    int x = binpow(n, k / 2);
    if(k % 2 == 0){
        return (x * x) % mod;
    }else{
        return (((x * x) % mod) * n) % mod;
    }
}

vector <int> pr, h;
vector < pair <int, int> > b;
int otv = 1;

int fund(int v){
    return (pr[v] == v) ? v : pr[v] = fund(pr[v]);
}

void unite(int v, int u){
    v = fund(v);
    u = fund(u);
    if(v == u){
        return;
    }

    if(h[v] < h[u]){
        swap(v, u);
    }

    pr[u] = v;
    h[v] += (h[v] == h[u]);

    otv = (otv * binpow(max(0ll, b[v].second - b[v].first + 1), mod - 2)) % mod;
    otv = (otv * binpow(max(0ll, b[u].second - b[u].first + 1), mod - 2)) % mod;

    b[v].first = max(b[v].first, b[u].first);
    b[v].second = min(b[v].second, b[u].second);

    otv = (otv * max(0ll, b[v].second - b[v].first + 1)) % mod;
}

void solve(){
    int n;
    cin >> n;

    b.resize(n);
    pr.resize(n);
    h.resize(n);

    vector < vector <int> > a(n);
    vector <int> p(n);
    for(int i = 1; i < n; ++i){
        int x;
        cin >> x;
        --x;

        p[i] = x;
        a[x].push_back(i);
        a[i].push_back(x);
    }

    for(int i = 0; i < n; ++i){
        cin >> b[i].first >> b[i].second;
        otv = (otv * max(0ll, b[i].second - b[i].first + 1)) % mod;

        pr[i] = i;
        h[i] = 0;
    }

    int bp = 0;
    while((1ll << bp) <= n){
        bp++;
    }

    vector < vector <int> > binup(n, vector <int> (bp));
    vector <int> depth(n);
    function <void(int, int, int)> dfs = [&](int v, int p, int d){
        binup[v][0] = p;
        depth[v] = d;
        for(int i = 1; i < bp; ++i){
            binup[v][i] = binup[binup[v][i - 1]][i - 1];
        }

        for(auto to : a[v]){
            if(to != p) {
                dfs(to, v, d + 1);
            }
        }
    };

    dfs(0, 0, 0);

    auto lca = [&](int v, int u){
        if(depth[v] < depth[u]){
            swap(v, u);
        }

        for(int i = bp - 1; i >= 0; --i){
            if(depth[v] - (1 << i) >= depth[u]){
                v = binup[v][i];
            }
        }

        if(v == u){
            return v;
        }

        for(int i = bp - 1; i >= 0; --i){
            if(binup[v][i] != binup[u][i]){
                v = binup[v][i];
                u = binup[u][i];
            }
        }

        return binup[v][0];
    };

    int m;
    cin >> m;
    while(m--){
        int x, y, z, t;
        cin >> x >> y >> z >> t;
        --x; --y; --z; --t;

        int l = lca(x, y);
        vector <int> c, put;
        int v = x;
        while(v != l){
            c.push_back(v);
            v = p[v];
        }
        c.push_back(l);

        v = y;
        while(v != l){
            put.push_back(v);
            v = p[v];
        }
        reverse(put.begin(), put.end());
        for(auto i : put){
            c.push_back(i);
        }

        l = lca(z, t);
        vector <int> d;
        put.clear();
        v = z;
        while(v != l){
            d.push_back(v);
            v = p[v];
        }
        d.push_back(l);

        v = t;
        while(v != l){
            put.push_back(v);
            v = p[v];
        }
        reverse(put.begin(), put.end());
        for(auto i : put){
            d.push_back(i);
        }

        for(int i = 0; i < c.size(); ++i){
            unite(c[i], d[i]);
        }

        cout << otv << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}
