#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma optimize("Ofast");

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

const int N = 2e5 + 3;
const int mod = 1e9 + 7;
vector<int> g[N];
int p[N], tin[N], tout[N], timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (auto u : g[v]) {
        //if (u == p[v]) continue;
        dfs(u);
    }
    tout[v] = timer++;
}

bool upper(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

int binpow(int x, int k) {
    if (k == 0) return 1ll;
    if (k & 1) return binpow(x, k - 1) * x % mod;
    else {
        ll c = binpow(x, k / 2);
        return c * c % mod;
    }
}

int inv(int x) {
    return binpow(x, mod - 2);
}

struct DSU {
    ll ans = 1;
    vector<int> p, sz;
    vector<pair<int, int>> v;
    DSU (int n, vector<pair<int, int>> &v) : v(v) {
        p.resize(n);
        iota(all(p), 0);
        sz.resize(n, 1);
        for (auto [l, r] : v) {
            ans = ans * (r - l + 1) % mod;
        }
    }
    int get(int i) {
        return (i == p[i] ? i : p[i] = get(p[i]));
    }
    void unite(int i, int j) {
        i = get(i); j = get(j);
        if (i == j) return;
        ans = ans * inv(v[j].S - v[j].F + 1) % mod * inv(v[i].S - v[i].F + 1) % mod;
        if (sz[i] < sz[j]) swap(i, j);
        v[i].F = max(v[j].F, v[i].F);
        v[i].S = min(v[j].S, v[i].S);
        ans = ans * max(0ll, v[i].S - v[i].F + 1) % mod;
        p[j] = i;
        sz[i] += sz[j];
    }
};

int ways1[2][N], ways2[2][N];

int get_way(int a, int b, int ind) {
    vector<int> f1, f2; // TODO: optimize
    int cnt1 = 0, cnt2 = 0;
    if (a == b) {
        ways1[ind][0] = a;
        return 1;
    };
    bool fl = false;
    if (upper(a, b)) {
        ways1[ind][0] = a, fl = true;
        cnt1 = 1;
    }
    if (upper(b, a)) {
        ways2[ind][0] = b, fl = true;
        cnt2 = 1;
    }
    while (!upper(a, b)) {
        //f1.emplace_back(a);
        ways1[ind][cnt1++] = a;
        a = p[a];
    }
    while (!upper(b, a)) {
        //f2.emplace_back(b);
        ways2[ind][cnt2++] = b;
        b = p[b];
    }
    if (!fl) ways1[ind][cnt1++] = a;
    //reverse(all(f2));
    for (int i = cnt2 - 1; i >= 0; i--)
        ways1[ind][cnt1++] = ways2[ind][i];
    return cnt1;
}

void solve() {
    int n, m;
    cin >> n;
    p[0] = 0;
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].emplace_back(i);
    }

    dfs(0);

    vector<pair<int, int>> v(n);
    for (auto &[l, r] : v) cin >> l >> r;
    DSU dsu(n, v);
    cin >> m;
    for (int i = 0; i < m; i++) {
        if (dsu.ans == 0) {
            cout << dsu.ans << '\n';
            continue;
        }
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        auto f1 = get_way(a, b, 0), s1 = get_way(c, d, 1);
//        dbg1(f1);
//        dbg1(s1);
        for (int k = 0; k < f1; k++) {
            dsu.unite(ways1[0][k], ways1[1][k]);
        }
        cout << dsu.ans << '\n';
    }
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}