#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5 + 1, mod = 1e9 + 7, INF = 1e18;

vector<ll> gr[N], cur, ot, p(N), rk(N);

set<ll> st;

vector<pair<ll, ll>> v(N);

struct str {
    ll a, b, c, d;
};

void dfs(ll v, ll f, ll p = -1){
    cur.push_back(v);
    if(v == f){
        ot = cur;
    }
    for(auto u : gr[v]){
        if(p != u){
            dfs(u, f, v);
        }
    }
    cur.pop_back();
}

pair<ll, ll> add(pair<ll, ll> a, pair<ll, ll> b){
    if(a.second > b.second){
        swap(a, b);
    }
    if(b.first >= a.first && b.first <= a.second){
        return {b.first, a.second};
    }
    if(b.first <= a.first){
        return a;
    }
    return {-1, -1};
}

void build() {
    for(ll i = 1; i < N; i++){
        rk[i] = 1;
        p[i] = i;
    }
}

ll get_root(ll v){
    if(p[v] == v){
        return v;
    }
    return p[v] = get_root(p[v]);
}

void join(ll a, ll b){
    ll x = get_root(a), y = get_root(b);
    if(x != y){
        if(rk[x] < rk[y]){
            st.erase(x);
            p[x] = y;
            v[y] = add(v[y], v[x]);
        } else if(rk[x] > rk[y]){
            st.erase(y);
            p[y] = x;
            v[x] = add(v[y], v[x]);
        } else {
            st.erase(x);
            p[x] = y;
            v[y] = add(v[y], v[x]);
            rk[y]++;
        }
    }
}


void solve() {
    build();
    ll n;
    cin >> n;
    for(ll i = 1; i <= n; i++){
        st.insert(i);
    }
    for(ll i = 2; i <= n; i++){
        ll x;
        cin >> x;
        gr[x].push_back(i);
        gr[i].push_back(x);
    }
    for(ll i = 1; i <= n; i++){
        cin >> v[i].first >> v[i].second;
    }
    ll m;
    cin >> m;
    vector<str> kids(m);
    for(ll i = 0; i < m; i++){
        cin >> kids[i].a >> kids[i].b >> kids[i].c >> kids[i].d;
        ot.clear();
        dfs(kids[i].a, kids[i].b);
        vector<ll> e = ot;
        ot.clear();
        dfs(kids[i].c, kids[i].d);
        vector<ll> f = ot;
        for(ll j = 0; j < (ll)e.size(); j++){
            join(e[j], f[j]);
        }
        ll ans = 1;
        for(auto u : st){
            if(v[u].first == -1){
                ans = 0;
            } else {
                ans *= (v[u].second - v[u].first + 1);
                ans %= mod;
            }
        }
        cout << ans << '\n';
    }

}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
