#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,unroll-loops,inline,fast-math")
#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}

int fast_pow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

int rev(int a) {
    return fast_pow(a, MOD - 2);
}

vector<vector<int>> g;
vector<int> par;
vector<int> tin, tout;
int timer = 0;

void dfs(int v, int p) {
    par[v] = p;
    tin[v] = timer++;
    for (auto to: g[v])
        if (to != p)
            dfs(to, v);
    tout[v] = timer;
}

bool is_anc(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<int> l, r;
int ans;
vector<vector<int>> dep;
vector<int> depid;

void do_paths(int a, int b, int c, int d) {
    if (ans == 0)
        return;
    vector<int> path1;
    while (!is_anc(a, b)) {
        path1.push_back(a);
        a = par[a];
    }
    path1.push_back(a);
    vector<int> temp;
    while (!is_anc(b, a)) {
        temp.push_back(b);
        b = par[b];
    }
    while (!temp.empty()) {
        path1.push_back(temp.back());
        temp.pop_back();
    }
    vector<int> path2;
    while (!is_anc(c, d)) {
        path2.push_back(c);
        c = par[c];
    }
    path2.push_back(c);
    while (!is_anc(d, c)) {
        temp.push_back(d);
        d = par[d];
    }
    while (!temp.empty()) {
        path2.push_back(temp.back());
        temp.pop_back();
    }
    for (int i = 0; i < path1.size(); ++i) {
        int u = path1[i], v = path2[i];
        if (depid[u] == depid[v])
            continue;
        int nl = max(l[depid[u]], l[depid[v]]);
        int nr = min(r[depid[u]], r[depid[v]]);
        ans = mul(ans, rev(r[depid[u]] - l[depid[u]] + 1));
        l[depid[u]] = nl;
        r[depid[u]] = nr;
        ans = mul(ans, rev(r[depid[v]] - l[depid[v]] + 1));
        l[depid[v]] = nl;
        r[depid[v]] = nr;
        if (dep[depid[u]].size() < dep[depid[v]].size()) {
            for (auto el: dep[depid[u]]) {
                depid[el] = depid[v];
                dep[depid[v]].push_back(el);
            }
        } else {
            for (auto el: dep[depid[v]]) {
                depid[el] = depid[u];
                dep[depid[u]].push_back(el);
            }
        }
        if (nr < nl) {
            ans = 0;
            return;
        }
        ans = mul(ans, r[depid[u]] - l[depid[u]] + 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    g.resize(n), par.resize(n), tin.resize(n), tout.resize(n);
    for (int i = 1; i < n; ++i) {
        int pi;
        cin >> pi;
        --pi;
        g[pi].push_back(i);
    }
    dfs(0, -1);
    l.resize(n), r.resize(n);
    ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
    }
    dep.resize(n, {});
    depid.resize(n);
    for (int i = 0; i < n; ++i) {
        depid[i] = i;
        dep[i] = {i};
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        do_paths(a, b, c, d);
        cout << ans << '\n';
    }
}