#pragma GCC target("avx2")
#pragma GCC optimize("Ofast,unroll-loops,inline,fast-math")

#include <bits/stdc++.h>

using namespace std;

const int MOD = 1e9 + 7;

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}

int fast_pow(int a, int n) {
    int res = 1;
    while (n) {
        if (n & 1)
            res = mul(res, a);
        a = mul(a, a);
        n >>= 1;
    }
    return res;
}

int rev(int a) {
    return fast_pow(a, MOD - 2);
}

vector<vector<int>> g;
vector<int> par;
vector<int> tin, tout;
int timer = 0;

void dfs(int v, int p) {
    par[v] = p;
    tin[v] = timer++;
    for (auto to: g[v])
        if (to != p)
            dfs(to, v);
    tout[v] = timer;
}

bool is_anc(int u, int v) {
    return tin[u] <= tin[v] && tout[v] <= tout[u];
}

vector<int> l, r;
int ans;
vector<int> dsu_par;
vector<int> dsu_sz;

int dsu_get(int v) {
    if (dsu_par[v] == v)
        return v;
    return dsu_par[v] = dsu_get(dsu_par[v]);
}

void dsu_merge(int u, int v) {
    u = dsu_get(u), v = dsu_get(v);
    if (u == v)
        return;
    if (dsu_sz[u] < dsu_sz[v])
        swap(u, v);
    dsu_par[v] = u;
    dsu_sz[u] += dsu_sz[v];
}

void do_paths(int a, int b, int c, int d) {
    if (ans == 0)
        return;
    vector<int> path1;
    while (!is_anc(a, b)) {
        path1.push_back(a);
        a = par[a];
    }
    path1.push_back(a);
    vector<int> temp;
    while (!is_anc(b, a)) {
        temp.push_back(b);
        b = par[b];
    }
    while (!temp.empty()) {
        path1.push_back(temp.back());
        temp.pop_back();
    }
    vector<int> path2;
    while (!is_anc(c, d)) {
        path2.push_back(c);
        c = par[c];
    }
    path2.push_back(c);
    while (!is_anc(d, c)) {
        temp.push_back(d);
        d = par[d];
    }
    while (!temp.empty()) {
        path2.push_back(temp.back());
        temp.pop_back();
    }
    for (int i = 0; i < path1.size(); ++i) {
        int u = path1[i], v = path2[i];
        u = dsu_get(u), v = dsu_get(v);
        if (u == v)
            continue;
        int nl = max(l[u], l[v]);
        int nr = min(r[u], r[v]);
        ans = mul(ans, rev(r[u] - l[u] + 1));
        l[u] = nl;
        r[u] = nr;
        ans = mul(ans, rev(r[v] - l[v] + 1));
        dsu_merge(u, v);
        if (nr < nl) {
            ans = 0;
            return;
        }
        u = dsu_get(u);
        ans = mul(ans, r[u] - l[u] + 1);
    }
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n;
    cin >> n;
    g.resize(n), par.resize(n), tin.resize(n), tout.resize(n);
    for (int i = 1; i < n; ++i) {
        int pi;
        cin >> pi;
        --pi;
        g[pi].push_back(i);
    }
    dfs(0, -1);
    l.resize(n), r.resize(n);
    ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
    }
    dsu_par.resize(n), dsu_sz.resize(n);
    for (int i = 0; i < n; ++i) {
        dsu_par[i] = i;
        dsu_sz[i] = 1;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        do_paths(a, b, c, d);
        cout << ans << '\n';
    }
}