#include<bits/stdc++.h>
using namespace std;

vector<int> parent;

int get(int i) {
    if (parent[i] == i) return i;
    parent[i] = get(parent[i]);
    return parent[i];
}

constexpr int mod = 1e9 + 7;

int binpow(int a, int deg) {
    if (deg == 0) return 1;
    if (deg % 2) return (1ll * a * binpow(a, deg - 1)) % mod;
    int tmp = binpow(a, deg / 2);
    return 1ll * tmp * tmp % mod;
}

vector<vector<int>> g;
vector<int> h;
void dfs(int i, int p, int he) {
    h[i] = he;
    for (auto j : g[i]) {
        if (j != p) {
            dfs(j, i, he + 1);
        }
    }
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n;
    cin >> n;
    long long ans = 1;

    h.assign(n, -1);
    h[0] = 0;
    vector<int> p(n);
    g.assign(n, {});

    parent = {0};
    h = {0};
    for (int i = 1; i < n; i++) {
        parent.push_back(i);
        h.push_back(0);
        int pr;
        cin >> pr;

        g[i].push_back(pr - 1);
        g[pr - 1].push_back(i);
        p[i] = pr - 1;
    }

    dfs(0, 0, 0);

    vector<pair<int, int>> val(n), inp;
    for (auto &i : val) {
        cin >> i.first >> i.second;
        ans = (ans * (i.second - i.first + 1)) % mod;
        inp.push_back({i.first, i.second});
    }

    int m;
    cin >> m;

    auto up = [&](int a, int b) -> vector<int> {
        vector<int> result;
        vector<int> from_b;

        while (h[a] > h[b]) {
            result.push_back(a);
            a = p[a];
        }

        while (h[b] > h[a]) {
            from_b.push_back(b);
            b = p[b];
        }

        while (a != b) {
            result.push_back(a);
            from_b.push_back(b);
            a = p[a];
            b = p[b];
        }

        result.push_back(a);

        reverse(from_b.begin(), from_b.end());
        for (auto i : from_b) {
            result.push_back(i);
        }

        return result;
    };

    vector<int> flag(n);
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        vector<int> vec1 = up(a - 1, b - 1);
        vector<int> vec2 = up(c - 1, d - 1);

        int ind = 0;

        for (int ind = 0; ind < vec1.size(); ind++) {
            if (vec1[ind] == vec2[ind]) continue;

            a = get(vec1[ind]);
            b = get(vec2[ind]);

            pair<int, int> pr = {max(val[a].first, val[b].first), min(val[a].second, val[b].second)};
            if (pr.first > pr.second) {ans = 0; break;}

            if (a == b) continue;
            
            if (ans != 0) {
                ans = (1ll * ans * binpow((val[a].second - val[a].first + 1), mod - 2)) % mod;
                ans = (1ll * ans * binpow((val[b].second - val[b].first + 1), mod - 2)) % mod;
                ans = (1ll * ans * (pr.second - pr.first + 1)) % mod;
            }

            val[a] = pr;
            val[b] = pr;

            parent[a] = b;
        }

        cout << ans << "\n";
    }
}

/*
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5

*/