#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

#pragma GCC optimize("Ofast")
#pragma GCC optimization("unroll-loops")

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}


const int maxn = 2e5;
const int mod = 1e9 + 7;

int pw(int a, int b) {
    if (b == 0)
        return 1;
    int res = pw(a, b / 2);
    res = (res * res) % mod;
    if (b & 1)
        res = (res * a) % mod;
    return res;
}

int inv(int a) {
    return pw(a, mod - 2);
}

vector<int> g[maxn + 1];
int l[maxn + 1];
int r[maxn + 1];

int h[maxn + 1];
int pr[maxn + 1];

void dfs(int u, int p) {
    h[u] = h[p] + 1;
    pr[u] = p;

    for (int v : g[u])
        dfs(v, u);
}

vector<int> get_path(int a, int b) {
    vector<int> l, r;

    while (a != b) {
        if (h[a] > h[b]) {
            l.push_back(a);
            a = pr[a];
        } else {
            r.push_back(b);
            b = pr[b];
        }
    }
    l.push_back(a);
    reverse(all(r));
    for (int x : r)
        l.push_back(x);
    return l;
}

struct DSU {
    int res = 1;

    vector<int> tree;

    DSU (int sz) {
        tree.resize(sz);
        iota(all(tree), 0);
    }

    int get(int u) {
        if (tree[u] == u)
            return u;
        return tree[u] = get(tree[u]);
    }

    int len(int u) {
        u = get(u);
        return max((int)0, r[u] - l[u] + 1);
    }

    void join(int u, int v) {
        if (res == 0)
            return;

        u = get(u);
        v = get(v);
        if (u == v)
            return;
        
        res = (res * inv(len(u))) % mod;
        res = (res * inv(len(v))) % mod;

        tree[u] = v;
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);

        res = (res * len(v)) % mod;
    }
};

DSU dsu(maxn + 1);

void solve() {
    int n;
    cin >> n;
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        g[p].push_back(i);
        // g[i].push_back(p);
    }

    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
    }

    for (int i = 1; i <= n; ++i) {
        dsu.res = (dsu.res * dsu.len(i)) % mod;
    }

    dfs(1, 0);

    int m;
    cin >> m;
    for (int i = 1; i <= m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        vector<int> x = get_path(a, b);
        vector<int> y = get_path(c, d);

        if (x.size() != y.size()) {
            cout << -1 << endl;
            return;
        }

        for (int i = 0; i < x.size(); ++i) {
            dsu.join(x[i], y[i]);
            // cout << "join " << x[i] << " " << y[i] << endl;
        }
        cout << dsu.res << endl;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    cout.precision(40);
    cout << fixed;
    solve();

    return 0;
}