#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

#pragma GCC optimize("Ofast")
#pragma GCC optimization("unroll-loops")

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}


const int maxn = 2e5;
const int mod = 1e9 + 7;

int pw(int a, int b) {
    if (b == 0)
        return 1;
    int res = pw(a, b / 2);
    res = (res * res) % mod;
    if (b & 1)
        res = (res * a) % mod;
    return res;
}

int inv(int a) {
    return pw(a, mod - 2);
}

vector<int> g[maxn + 1];
int l[maxn + 1];
int r[maxn + 1];

int h[maxn + 1];
int pr[maxn + 1];

void dfs(int u, int p) {
    h[u] = h[p] + 1;
    pr[u] = p;
    for (int v : g[u])
        dfs(v, u);
}

vector<int> get_path(int a, int b) {
    vector<int> l, r;

    while (a != b) {
        if (h[a] > h[b]) {
            l.push_back(a);
            a = pr[a];
        } else {
            r.push_back(b);
            b = pr[b];
        }
    }
    l.push_back(a);
    reverse(all(r));
    for (int x : r)
        l.push_back(x);
    return l;
}

struct DSU {
    int res = 1;

    vector<int> tree;
    vector<int> size;

    DSU (int sz) {
        tree.resize(sz);
        size.resize(sz);
        iota(all(tree), 0);
        fill(all(size), 1);
    }

    int get(int u) {
        if (tree[u] == u)
            return u;
        return tree[u] = get(tree[u]);
    }

    int len(int u) {
        u = get(u);
        return max((int)0, r[u] - l[u] + 1);
    }

    int join(int u, int v) {
        if (res == 0)
            return u;

        u = get(u);
        v = get(v);


        if (u == v)
            return u;

        if (size[u] > size[v])
            swap(u, v);

        res = (res * inv(len(u))) % mod;
        res = (res * inv(len(v))) % mod;

        tree[u] = v;
        size[v] += size[u];
        l[v] = max(l[v], l[u]);
        r[v] = min(r[v], r[u]);

        res = (res * len(v)) % mod;

        return v;
    }
};

const int P = 228228239;

int p[maxn + 1000];

namespace FENW {
    struct Fenw {
        vector<int> tree;

        int get(int x) {
            int res = 0;
            for (; x > 0; x -= x & -x)
                res += tree[x];
            return res;
        }

        void add(int x, int val) {
            for (; x < tree.size(); x += x & -x) {
                tree[x] += val;
            }
        }

        int get(int l, int r) {
            return get(r - 1) - get(l - 1);
        }

        int get_hash(int l, int r) {
            int val = get(l, r);
            val = (val * inv(p[l - 1]) % mod);
            return val;
        }

        void set(int x, int val) {
            int was = get(x, x + 1);
            val = (val * p[x]) % mod;
            add(x, val - was);
        }


        Fenw (int sz) {
            tree.resize(sz);
            for (int i = 1; i < sz; ++i)
                set(i, i);
        }
    };

    struct Fenw_inv {
        vector<int> tree;


        int get(int x) {
            int res = 0;
            for (; x > 0; x -= x & -x)
                res += tree[x];
            return res;
        }

        void add(int x, int val) {
            for (; x < tree.size(); x += x & -x) {
                tree[x] += val;
            }
        }

        int get(int l, int r) {
            return get(r - 1) - get(l - 1);
        }

        int get_hash(int l, int r) {
            int val = get(l, r);
            val = (val * inv(p[tree.size() - r]) % mod);
            return val;
        }

        void set(int x, int val) {
            int was = get(x, x + 1);
            val = (val * p[tree.size() - x]) % mod;
            add(x, val - was);
        }


        Fenw_inv (int sz) {
            tree.resize(sz);
            for (int i = 1; i < sz; ++i)
                set(i, i);
        }
    };
}

void precalc() {
    p[0] = 1;
    for (int i = 1; i <= maxn + 100; ++i)
        p[i] = (p[i - 1] * P) % mod;
}
using FENW::Fenw;
using FENW::Fenw_inv;

DSU dsu(maxn + 1);

void merge(int a, int b, int c, int d) {
    vector<int> x = get_path(a, b);

    int i = 0;
    int j = x.size() - 1;

    while (c != d) {
        if (h[c] > h[d]) {
            dsu.join(c, x[i]);
            c = pr[c];
            ++i;
        } else {
            dsu.join(d, x[j]);
            d = pr[d];
            --j;
        }
    }
    dsu.join(c, x[i]);
}

Fenw fenw(maxn + 1);
Fenw_inv fenw_inv(maxn + 1);

void flex_merge(int a, int b, int c, int d) {
    if (a > b) {
        swap(a, b);
        swap(c, d);
    }

    auto merge = [&](int u, int v) {
        int root = dsu.join(u, v);
        fenw.set(u, root);
        fenw.set(v, root);
        fenw_inv.set(u, root);
        fenw_inv.set(v, root);
    };

    merge(a, c);
    merge(b, d);

    while (a < b) {
        int jump = 0;
        for (int j = 30; j >= 0; --j) {
            int to = jump + (1LL << j);
            if (a + to > b)
                continue;

            int h1 = fenw.get_hash(a, a + to + 1);
            int h2;

            if (c < d)
                h2 = fenw.get_hash(c, c + to + 1);
            else
                h2 = fenw_inv.get_hash(c - to, c + 1);

            if (h1 == h2)
                jump = to;
        }

        jump += 1;

        a += jump;

        if (c < d)
            c += jump;
        else
            c -= jump;
        if (a >= b)
            break;
        merge(a, c);
    }
}

void solve() {
    int n;
    cin >> n;

    bool ok = true;
    for (int i = 2; i <= n; ++i) {
        int p;
        cin >> p;
        ok = ok & (p == i - 1);
        g[p].push_back(i);
    }

    for (int i = 1; i <= n; ++i) {
        cin >> l[i] >> r[i];
    }

    for (int i = 1; i <= n; ++i) {
        dsu.res = (dsu.res * dsu.len(i)) % mod;
    }

    dfs(1, 0);

    int m;
    cin >> m;
    for (int i = 1; i <= m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ok)
            flex_merge(a, b, c, d);
        else
            merge(a, b, c, d);
        cout << dsu.res << endl;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    precalc();

    cout.precision(40);
    cout << fixed;
    solve();

    return 0;
}