#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <stack>
using namespace std;
typedef long long ll;
typedef long double ld;
ll mod = 1e9 + 7;
struct st {
	ll l, r;
};
int n, m, t = 0;
st gr[200000];
vector <int> g[200000];
int binup[19][200000], p[200000], tin[200000], tout[200000];
void dfs(int v) {
	tin[v] = t++;
	for (auto i : g[v]) {
		p[i] = v;
		dfs(i);
	}
	tout[v] = t++;
}
bool check(int x, int y) {
	return (tin[x] <= tin[y] && tout[x] >= tout[y]);
}
int LCA(int x, int y) {
	if (check(x, y)) return x;
	if (check(y, x)) return y;
	for (int i = 18; i >= 0; i--) {
		if (!check(binup[i][x], y)) x = binup[i][x];
	}
	return p[x];
}
ll bin_pow(ll a, ll n) {
	if (n == 0) return 1;
	if (n & 1) return a * bin_pow(a, n - 1) % mod;
	ll b = bin_pow(a, n / 2);
	return b * b % mod;
}
ll ansall = 1;
struct DSU {
	vector <int> p, r;
	vector <ll> ans;
	vector <st> gr1;
	DSU(int n) {
		r.resize(n, 0);
		p.resize(n), ans.resize(n), gr1.resize(n);
		for (int i = 0; i < n; i++) p[i] = i, ans[i] = gr[i].r - gr[i].l + 1, gr1[i] = gr[i];
	}
	int get(int u) {
		if (u == p[u]) return u;
		return p[u] = get(p[u]);
	}
	bool join(int x, int y) {
		if (!ansall) return 0;
		x = get(x), y = get(y);
		if (x == y) return 0;
		if (r[x] < r[y]) swap(x, y);
		p[y] = x;
		ansall = ansall * bin_pow((gr1[x].r - gr1[x].l + 1), mod - 2) % mod;
		ansall = ansall * bin_pow((gr1[y].r - gr1[y].l + 1), mod - 2) % mod;
		gr1[x].r = min(gr1[x].r, gr1[y].r);
		gr1[x].l = max(gr1[x].l, gr1[y].l);
		ansall = ansall * max(0ll, (gr1[x].r - gr1[x].l + 1)) % mod;
		return 1;
	}
};
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	cin >> n;
	vector <ll> del(n);
	for (int i = 0; i < n - 1; i++) {
		int p; cin >> p; p--;
		g[p].push_back(i + 1);
	}
	for (int i = 0; i < n; i++) cin >> gr[i].l >> gr[i].r, ansall *= (gr[i].r - gr[i].l + 1), ansall %= mod, del[i] = bin_pow(gr[i].r - gr[i].l + 1, mod - 2);
	DSU x(n);
	dfs(0);
	for (int i = 0; i < n; i++) binup[0][i] = p[i];
	for (int i = 1; i < 19; i++) for (int j = 0; j < n; j++) binup[i][j] = binup[i - 1][binup[i - 1][j]];
	cin >> m;
	while (m--) {
		int a, b, c, d; cin >> a >> b >> c >> d; a--, b--, c--, d--;
		if (!ansall) { cout << "0\n"; continue; }
		int lca1 = LCA(a, b), lca2 = LCA(c, d);
		vector <int> p1, p2, c1;
		while (a != lca1) p1.push_back(a), a = p[a];
		p1.push_back(lca1);
		while (b != lca1) c1.push_back(b), b = p[b];
		reverse(c1.begin(), c1.end());
		for (auto i : c1) p1.push_back(i);
		c1.clear();
		while (c != lca2) p2.push_back(c), c = p[c];
		p2.push_back(lca2);
		while (d != lca2) c1.push_back(d), d = p[d];
		reverse(c1.begin(), c1.end());
		for (auto i : c1) p2.push_back(i);
		for (int i = 0; i < p1.size(); i++) x.join(p1[i], p2[i]);
		cout << ansall << "\n";
	}
	return 0;
}