#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;
const int md = 1e9 + 7;
const int hshp = 1e6 + 3;
const int hshmd = 1e9 + 97;

int hshpw[N];

int hshadd(int a, int b) {
	return a + b < hshmd ? a + b : a + b - hshmd;
}

int hshsub(int a, int b) {
	return a - b >= 0 ? a - b : a - b + hshmd;
}

int hshmul(int a, int b) {
	return a * 1ll * b % hshmd;
}

int add(int a, int b) {
	return a + b < md ? a + b : a + b - md;
}

int sub(int a, int b) {
	return a - b >= 0 ? a - b : a - b + md;
}

int mul(int a, int b) {
	return a * 1ll * b % md;
}

int pw(int a, int n) {
	int ret = 1;
	while (n > 0) {
		if (n & 1) {
			ret = mul(ret, a);
		}
		a = mul(a, a);
		n >>= 1;
	}
	return ret;
}

int inv(int a) {
	return pw(a, md - 2);
}

int n;
int p[N];
vector<int> g[N];
int L[N], R[N];
int sz[N];
int top[N];
int tin[N], tout[N], tmr;
vector<int> ord;
int ans;
int dsu[N];
vector<int> comp[N];
int t[2][N];

int tget(int f, int l, int r) {
	int ret = 0;
	for (; r > 0; r -= r & -r) {
		ret = hshadd(ret, t[f][r]);
	}
	for (; l > 0; l -= l & -l) {
		ret = hshsub(ret, t[f][l]);
	}
	return ret;
}

void tupd(int f, int i, int x) {
	x = hshmul(x, f == 0 ? hshpw[i] : hshpw[n - i - 1]);
	for (++i; i <= n; i += i & -i) {
		t[f][i] = hshadd(t[f][i], x);
	}
}

void dfssz(int v) {
	sz[v] = 1;
	for (int u : g[v]) {
		dfssz(u);
		sz[v] += sz[u];
	}
	sort(g[v].begin(), g[v].end(), [&](int u1, int u2) {
		return sz[u1] > sz[u2];
	});
}

void dfshld(int v) {
	tin[v] = tmr++;
	ord.push_back(v);
	for (int u : g[v]) {
		top[u] = u == g[v][0] ? top[v] : u;
		dfshld(u);
	}
	tout[v] = tmr;
}

bool anc(int v, int u) {
	return tin[v] <= tin[u] && tout[v] >= tout[u];
}
 
void merge(int v, int u) {
	v = dsu[v];
	u = dsu[u];
	if (v == u) {
		return;
	}
	if (comp[v].size() > comp[u].size()) {
		swap(v, u);
	}
	if (ans != 0) {
		ans = mul(ans, inv(R[v] - L[v] + 1));
		ans = mul(ans, inv(R[u] - L[u] + 1));
	}
	L[u] = max(L[u], L[v]);
	R[u] = min(R[u], R[v]);
	if (ans != 0) {
		if (L[u] > R[u]) {
			ans = 0;
		} else {
			ans = mul(ans, R[u] - L[u] + 1);
		}
	}
	for (int w : comp[v]) {
		dsu[w] = u;
		tupd(0, tin[w], u);
		tupd(1, tin[w], u);
		comp[u].push_back(w);
	}
}

vector<pair<int, int>> getpaths(int v, int u) {
	vector<pair<int, int>> l, r;
	while (top[v] != top[u]) {
		if (!anc(top[v], u)) {
			l.push_back({v, top[v]});
			v = p[top[v]];
		} else {
			r.push_back({top[u], u});
			u = p[top[u]];
		}
	}
	l.push_back({v, u});
	vector<pair<int, int>> ret;
	for (auto pp : l) {
		ret.push_back(pp);
	}
	reverse(r.begin(), r.end());
	for (auto pp : r) {
		ret.push_back(pp);
	}
	return ret;
}

bool cmpprefhsh(int v1, int u1, int v2, int u2, int len) {
	int h1 = 0, d1 = 0;
	if (tin[v1] < tin[u1]) {
		h1 = tget(0, tin[v1], tin[v1] + len);
		d1 = tin[v1];
	} else {
		h1 = tget(0, tin[v1] - len + 1, tin[v1] + 1);
		d1 = n - tin[v1] - 1;
	}
	int h2 = 0, d2 = 0;
	if (tin[v2] < tin[u2]) {
		h2 = tget(0, tin[v2], tin[v2] + len);
		d2 = tin[v2];
	} else {
		h2 = tget(0, tin[v2] - len + 1, tin[v2] + 1);
		d2 = n - tin[v2] - 1;
	}
	if (d1 <= d2) {
		return mul(h1, hshpw[d2 - d1]) == h2;
	}
	return mul(h2, hshpw[d1 - d2]) == h1;
}

void go(int &v, int &u, int &i, int d) {
	if (abs(tin[u] - tin[v]) + 1 == d) {
		++i;
	} else {
		if (tin[v] < tin[u]) {
			v = ord[tin[v] + d];
		} else {
			v = ord[tin[v] - d];
		}
	}
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	hshpw[0] = 1;
	for (int i = 1; i < N; ++i) {
		hshpw[i] = 1ll * hshpw[i - 1] * hshp % hshmd;
	}
	cin >> n;
	for (int i = 1; i < n; ++i) {
		cin >> p[i];
		--p[i];
 		g[p[i]].push_back(i);
	}
	for (int i = 0; i < n; ++i) {
		cin >> L[i] >> R[i];
	}
	p[0] = 0;
	dfssz(0);
	top[0] = 0;
	dfshld(0);
	ans = 1;
	for (int i = 0; i < n; ++i) {
		ans = mul(ans, R[i] - L[i] + 1);
	}
	for (int i = 0; i < n; ++i) {
		dsu[i] = i;
		comp[i] = {i};
	}
	for (int i = 0; i < n; ++i) {
		tupd(0, tin[i], dsu[i]);
		tupd(1, tin[i], dsu[i]);
	}
	int m;
	cin >> m;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a, --b, --c, --d;
		auto p1 = getpaths(a, b);
		auto p2 = getpaths(c, d);
		int i = 0, j = 0;
		while (i < (int)p1.size() && j < (int)p2.size()) {
			auto &[v1, u1] = p1[i];
			auto &[v2, u2] = p2[j];
			int len1 = abs(tin[v1] - tin[u1]) + 1;
			int len2 = abs(tin[v2] - tin[u2]) + 1;
			int mn = min(len1, len2);
			if (cmpprefhsh(v1, u1, v2, u2, mn)) {
				go(v1, u1, i, mn);
				go(v2, u2, j, mn);
				continue;
			}
			int l = 0, r = mn;
			while (r - l > 1) {
				int mid = (l + r) / 2;
				if (cmpprefhsh(v1, u1, v2, u2, mid)) {
					l = mid;
				} else {
					r = mid;
				}
			}
			go(v1, u1, i, l);
			go(v2, u2, j, l);
			merge(v1, v2);
			go(v1, u1, i, 1);
			go(v2, u2, j, 1);
		}
		cout << ans << "\n";
	}
	return 0;
}