#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

const int N = 2e5 + 7, MOD = 1e9+7;

struct Edge {
	int v, w;
};

int n, m, k;



bool vis[N], cyc[N], dost[N];
int p[N], d[N];

int cmp[N];
int l_cmp[N], r_cmp[N], l[N], r[N];

vector<int> edges[N], edges2[N];
int mark[N];

long long ANSW = 1;

void dfs(int v) {
	for (auto u : edges[v]) {
		d[u] = d[v] + 1;
		dfs(u);
	}
}
void dfs2(int v, int p, int par) {
	cmp[v] = p;
	l_cmp[p] = max(l_cmp[p], l[v]);
	r_cmp[p] = min(r_cmp[p], r[v]);
	int i = 0;
	vector<bool> mark;
	mark.resize(edges2[v].size());
	for (auto u : edges2[v]) {
		if (cmp[u] == 0) {
			dfs2(u, p, v);
			mark[i] = 1;
		}
		else {
			mark[i] = 0;
			if (u == par) {
				mark[i] = 1;
			}
		}
		i++;
	}
	int l = 0, r = 0;
	while (r < edges2[v].size()) {
		if (mark[r]) {
			edges2[v][l] = edges2[v][r];
			if (edges2[v][r] == 0) {
				cout << "";
			}
			l++;
		}
		r++;
	}
	edges2[v].resize(l);
}


vector<int>rev, A, B;

void way(vector<int>& v, int a, int b) {
	v.push_back(a);
	if (a == b) {
		return;
	}
	rev.clear();

	rev.push_back(b);
	while (true) {
		if (d[a] >= d[b]) {
			if (b == p[a]) {
				reverse(rev.begin(), rev.end());
				for (auto u : rev) {
					v.push_back(u);
				}
				return;
			}
			a = p[a];
			v.push_back(a);
		}
		else {
			if (a == p[b]) {
				reverse(rev.begin(), rev.end());
				for (auto u : rev) {
					v.push_back(u);
				}
				return;
			}
			b = p[b];
			rev.push_back(b);
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n;
	for (int i = 2; i <= n; i++) {
		cin >> p[i];
		edges[p[i]].push_back(i);
	}
	for (int i = 1; i <= n; i++) {
		cin >> l[i] >> r[i];
		r_cmp[i] = r[i];
		l_cmp[i] = l[i];
	}
	dfs(1);
	int q;
	cin >> q;
	for (int I = 0; I < q; I++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		A.clear();
		B.clear();
		way(A, a,b);
		way(B, c, d);
		for (int i = 0; i < A.size(); i++) {
			if (cmp[A[i]] != cmp[B[i]]]) {
				edges2[A[i]].push_back(B[i]);
				edges2[B[i]].push_back(A[i]);
			}
		ANSW = 1;
		for (int i = 1; i <= n; i++) {
			if (cmp[i] == i) {
				dfs2(i, i, -1);
				if (l_cmp[i] > r_cmp[i]) {
					ANSW = 0;
				}
				else {
					ANSW *= (r_cmp[i] - l_cmp[i] + 1);
					ANSW %= MOD;
				}
			}
		}
		cout << ANSW << '\n';
	}
	
}