#include <bits/stdc++.h>
#define int long long

using namespace std;


int n, m;
vector<vector<pair<int, int>>> g, rg;
vector<tuple<int, int, int>> edge;
vector<bool> used;
vector<int> topsort1, topsort2;

void dfs1(int v) {
  used[v] = true;
  for (auto& [to, w] : g[v]) {
    if (!used[to]) {
      dfs1(to);
    }
  }
  topsort1.push_back(v);
}

void dfs2(int v) {
  used[v] = true;
  for (auto& [to, w] : rg[v]) {
    if (!used[to]) {
      dfs2(to);
    }
  }
  topsort2.push_back(v);
}

void solve() {
  cin >> n >> m;
  g.resize(n);
  rg.resize(n);
  used.resize(n);
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    edge.emplace_back(u, v, w);
    g[u].emplace_back(v, w);
    rg[v].emplace_back(u, w);
  }
  int a, b;
  cin >> a >> b;
  a--, b--;
  dfs1(a);
  used.assign(n, 0);
  dfs2(b);
  reverse(topsort1.begin(), topsort1.end());
  reverse(topsort2.begin(), topsort2.end());
  vector<int> v1(n), v2(n);
  v1[a] = 1;
  for (int v : topsort1) {
    for (auto& [to, w] : rg[v]) {
      v1[v] += v1[to];
    }
  }
  v2[b] = 1;
  for (int v : topsort2) {
    for (auto& [to, w] : g[v]) {
      v2[v] += v2[to];
    }
  }
  int ans = 0;
  for (auto& [u, v, w] : edge) {
    if (w == 0)
      continue;
    if ((v1[u] * v2[v]) % 2) {
      ans ^= w;
    }
  }
  cout << ans << '\n';
  g.clear();
  rg.clear();
  edge.clear();
  used.clear();
  topsort1.clear();
  topsort2.clear();
}

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
}