#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const int INF = 1e18, MOD = 1e9 + 7;

long long inv(int a, int n = MOD - 2)
{
	if (!n)
	{
		return 1;
	}

	long long res = inv(a, n / 2);
	res = (res * res) % MOD;
	if (n % 2)
	{
		res = (res * a) % MOD;
	}
	return res;
}

struct dsu
{
	int n;
	long long ans = 1;
	vector<int> p, rk, mxl, mnr;

	dsu(int in, vector<int>& l, vector<int>& r)
	{
		n = in;
		p.resize(n);
		iota(p.begin(), p.end(), 0);
		rk.resize(n);
		mxl.resize(n, -INF);
		mnr.resize(n, INF);
		for (int i = 0; i < n; i++)
		{
			mxl[i] = l[i];
		}
		for (int i = 0; i < n; i++)
		{
			mnr[i] = r[i];
			ans *= (r[i] - l[i] + 1);
			ans %= MOD;
		}
	}

	int rt(int v)
	{
		return (p[v] == v ? v : p[v] = rt(p[v]));
	}

	int df(int v)
	{
		return max(0, mnr[v] - mxl[v] + 1);
	}

	void unite(int a, int b)
	{
		a = rt(a);
		b = rt(b);
		if (a == b)
		{
			return;
		}

		if (rk[a] < rk[b])
		{
			swap(a, b);
		}
		p[b] = a;
		rk[a] += (rk[a] == rk[b]);
		ans = (ans * inv(df(a))) % MOD;
		ans = (ans * inv(df(b))) % MOD;
		mxl[a] = max(mxl[a], mxl[b]);
		mnr[a] = min(mnr[a], mnr[b]);
		ans = (ans * df(a)) % MOD;
	}
};

int n;
vector<int> g[200000], par, l, r;

bool dfs(int v, int p, int nd, vector<int>& pth)
{
	pth.push_back(v);
	if (v == nd)
	{
		return true;
	}

	for (auto& i : g[v])
	{
		if (i == p)
		{
			continue;
		}

		if (dfs(i, v, nd, pth))
		{
			return true;
		}
	}
	pth.pop_back();
	return false;
}

void solve()
{
	cin >> n;
	par.resize(n, -1);
	l.resize(n);
	r.resize(n);
	for (int i = 1; i < n; i++)
	{
		cin >> par[i];
		par[i]--;
		g[par[i]].push_back(i);
	}
	for (int i = 1; i < n; i++)
	{
		g[i].push_back(par[i]);
	}
	for (int i = 0; i < n; i++)
	{
		cin >> l[i] >> r[i];
	}

	int q;
	cin >> q;
	dsu kek(n, l, r);
	while (q--)
	{
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--; b--; c--; d--;
		vector<int> p1, p2;
		dfs(a, -1, b, p1);
		dfs(c, -1, d, p2);
		for (int i = 0; i < p1.size(); i++)
		{
			while (i < p1.size() && kek.rt(p1[i]) == kek.rt(p2[i]))
			{
				i++;
			}
			if (i == p1.size())
			{
				break;
			}
			kek.unite(p1[i], p2[i]);
		}
		cout << kek.ans << "\n";
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*























*/
