#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

vector<vector<int>> up;
vector<int> dist;

void dfs(int v, vector<vector<int>> &gr) {
    for (int i = 1; i < 18; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto u: gr[v]) {
        dist[u] = dist[v] + 1;
        up[u][0] = v;
        dfs(u, gr);
    }
}

int jump(int v, int d) {
    for (int i = 17; i > -1; --i) {
        if ((d >> i) & 1) {
            v = up[v][i];
        }
    }
    return v;
}

int lca(int v, int u) {
    if (dist[v] > dist[u]) {
        swap(v, u);
    }
    u = jump(u, dist[u] - dist[v]);
    for (int i = 17; i > -1; --i) {
        if (up[v][i] != up[u][i]) {
            v = up[v][i];
            u = up[u][i];
        }
    }
    if (v != u) {
        v = up[v][0];
    }
    return v;
}

vector<int> ps;

int get(int v) {
    if (ps[v] == v) {
        return v;
    }
    ps[v] = get(ps[v]);
    return ps[v];
}

long long mod = 1e9 + 7;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    int n;
    cin >> n;
    vector<int> pr(n - 1);
    vector<vector<int>> gr(n);
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        --p;
        pr[i + 1] = p;
        gr[p].push_back(i + 1);
    }
    up.resize(n, vector<int>(18));
    dist.resize(n);
    dfs(0, gr);
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    int m;
    cin >> m;
    ps.resize(n);
    for (int i = 0; i < n; ++i){
        ps[i] = i;
    }
    while (m--) {
        int v1, u1, v2, u2;
        cin >> v1 >> u1 >> v2 >> u2;
        --v1;
        --u1;
        --v2;
        --u2;
        vector<int> vers1;
        int lca1 = lca(v1, u1);
        vers1.push_back(v1);
        while (v1 != lca1) {
            v1 = pr[v1];
            vers1.push_back(v1);
        }
        vector<int> vers2;
        while (u1 != lca1) {
            vers2.push_back(u1);
            u1 = pr[u1];
        }
        reverse(vers2.begin(), vers2.end());
        for (auto i: vers2) {
            vers1.push_back(i);
        }

        vector<int> vers3;
        int lca2 = lca(v2, u2);
        vers3.push_back(v2);
        while (v2 != lca2) {
            v2 = pr[v2];
            vers3.push_back(v2);
        }
        vector<int> vers4;
        while (u2 != lca2) {
            vers4.push_back(u2);
            u2 = pr[u2];
        }
        reverse(vers4.begin(), vers4.end());
        for (auto i: vers4) {
            vers3.push_back(i);
        }
        for (int ind = 0; ind < vers1.size(); ++ind) {
            int v = vers1[ind];
            int u = vers3[ind];
            v = get(v);
            u = get(u);
            if (v != u) {
                ps[u] = v;
                int l = max(a[v].first, a[u].first);
                int r = min(a[v].second, a[u].second);
                a[v].first = l;
                a[v].second = r;
            }
        }
        long long res = 1;
        for (int i = 0; i < n; ++i) {
            if (get(i) == i) {
                res *= max(0, a[i].second - a[i].first + 1);
                res %= mod;
            }
        }
        cout << res << "\n";
    }
}