#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 3e3 + 10, M = 1e9 + 7;
vector <int> g[N];
vector <int> l(N), r(N);
int p[N], gl[N];

void dfs(int v) {
    for (auto& u : g[v])
        gl[u] = gl[v] + 1, dfs(u);
}

vector <int> put(int a, int b) {
    vector <int> A, B;
    while (a != b) {
        if (gl[b] > gl[a]) {
            B.push_back(b);
            b = p[b];
        }
        else {
            A.push_back(a);
            a = p[a];
        }
    }
    A.push_back(a);
    reverse(B.begin(), B.end());
    for (auto& r : B) {
        A.push_back(r);
    }
    return A;
}

ll mypow(ll a, ll b) {
    if (!b)
        return 1;
    ll e = mypow(a, b / 2);
    if (b & 1)
        return (((e * e) % M) * a) % M;
    return (e * e) % M;
}

vector <int> W, P;
int get(int a) {
    if (P[a] == -1)
        return a;
    return P[a] = get(P[a]);
}
void merge(int a, int b) {
    a = get(a);
    b = get(b);
    if (a != b) {
        if (W[a] > W[b])
            swap(a, b);
        W[b] += W[a];
        P[a] = b;
        l[b] = max(l[b], l[a]);
        r[b] = min(r[b], r[a]);
    }
}


int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n;
    cin >> n;
    W.assign(n + 1, 1);
    P.assign(n + 1, -1);
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    ll res = 1;
    for (int i = 1; i <= n; i++) {
        cin >> l[i] >> r[i];
        res *= (r[i] - l[i] + 1);
        res %= M;
    }
    dfs(1);
    int m;
    cin >> m;
    while (m--) {
        ll ans = 1;
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector <int> L = l, R = r;
        vector <int> x = put(a, b);
        vector <int> y = put(c, d);
        for (int i = 0; i < x.size(); i++) {
            merge(x[i], y[i]);
        }
        vector <int> z;
        for (int r = 1; r <= n; r++)
            z.push_back(get(r));
        sort(z.begin(), z.end());
        z.erase(unique(z.begin(), z.end()), z.end());
        
        for (int i = 0; i < z.size(); i++) {
            ans *= max(0, r[z[i]] - l[z[i]] + 1);
            ans %= M;
        }
        cout << (ans) % M << endl;
    }
} 
