#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

const int mod = (int) 1e9 + 7;

struct dsu {
	int n;
	vector<int> pr, sz;
	int ans;
	vector<int> l, r;
	dsu(const vector<int> &l, const vector<int> &r) : l(l), r(r) {
		n = (int) l.size();
		pr.resize(n);
		for (int i = 0; i < n; ++i) {
			pr[i] = i;
		}
		sz.assign(n, 1);
		ans = 1;
		for (int i = 0; i < n; ++i) {
			ans = (ans * max(0ll, r[i] - l[i] + 1)) % mod;
		}
	}
	int get_pr(int u) {
		while (pr[pr[u]] != pr[u]) {
			pr[u] = pr[pr[u]];
		}
		return pr[u];
	}
	void unity(int u, int v) {
		u = get_pr(u);
		v = get_pr(v);
		if (u == v) {
			return;
		}
		if (sz[u] < sz[v]) {
			swap(u, v);
		}
		if (ans) {
			ans = (ans * mpow(max(0ll, r[u] - l[u] + 1), mod - 2, mod)) % mod;
			ans = (ans * mpow(max(0ll, r[v] - l[v] + 1), mod - 2, mod)) % mod;
		}
		sz[u] += sz[v];
		pr[v] = u;
		ckmax(l[u], l[v]);
		ckmin(r[u], r[v]);
		ans = (ans * max(0ll, r[u] - l[u] + 1)) % mod;
	}
};

int n;
vector<int> pr;
vector<vector<int>> g;
vector<int> tin, tout;
int timer;

void dfs(int u) {
	tin[u] = timer++;
	for (const int &v : g[u]) {
		dfs(v);
	}
	tout[u] = timer;
}

vector<int> get_path(int u, int v) {
	vector<int> path1, path2;
	while (!(tin[u] <= tin[v] && tin[v] < tout[u])) {
		path1.push_back(u);
		u = pr[u];
	}
	path1.push_back(u);
	while (v != u) {
		path2.push_back(v);
		v = pr[v];
	}
	while (!path2.empty()) {
		path1.push_back(path2.back());
		path2.pop_back();
	}
	return path1;
}


void solve() {
	g.clear();
	cin >> n;
	pr.resize(n);
	pr[0] = -1;
	g.resize(n);
	for (int i = 1; i < n; ++i) {
		cin >> pr[i];
		--pr[i];
		g[pr[i]].push_back(i);
	}
	tin.resize(n);
	tout.resize(n);
	timer = 0;
	dfs(0);
	vector<int> l(n), r(n);
	for (int i = 0; i < n; ++i) {
		cin >> l[i] >> r[i];
	}
	dsu ds(l, r);
	int m;
	cin >> m;
	for (int i = 0; i < m; ++i) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a;
		--b;
		--c;
		--d;
		vector<int> path1 = get_path(a, b);
		vector<int> path2 = get_path(c, d);
		for (int j = 0; j < (int) path1.size(); ++j) {
			ds.unity(path1[j], path2[j]);
		}
		cout << ds.ans << endl;
	}
}

int32_t main() {
	int T = 1;
#ifdef LOCAL
	cin >> T;
#else
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
