#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = (int) 1e9 + 7;
const int N = (int) 1e5 * 2 + 1;
int pr[N], l[N], r[N], tin[N], tout[N], timer = 0, num[N], q[N];
vector<int> g[N];

void dfs(int v, int p) {
    tin[v] = timer++;
    for (auto u: g[v]) {
        if (u != p)
            dfs(u, v);
    }
    tout[v] = timer;
}

bool anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

vector<int> path(int u, int v) {
    vector<int> p1, p2;
    int cur = u;
    while (true) {
        p1.emplace_back(cur);
        if (anc(cur, v))
            break;
        cur = pr[cur];
    }
    while (true) {
        if (v == cur)
            break;
        p2.emplace_back(v);
        v = pr[v];
    }
    reverse(p2.begin(), p2.end());
    for (auto elem: p2)
        p1.emplace_back(elem);
    return p1;
}

int binpow(int n, int p) {
    if (n == 0)
        return 1;
    if (n == 1)
        return p % mod;
    int ans = 1;
    if (n % 2 == 1)
        ans = p % mod;
    return (binpow(n / 2, (p * p) % mod) % mod * ans) % mod;
}

int inv(int n) {
    n %= mod;
    return binpow(mod - 2, n);
}

int find(int p){
    int cur = p;
    while(num[p] != p){
        p = num[p];
    }
    num[cur] = p;
    return p;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i = 0; i < n - 1; i++) {
        int p;
        cin >> p;
        g[i + 1].emplace_back(p - 1);
        g[p - 1].emplace_back(i + 1);
        pr[i + 1] = p - 1;
    }
    pr[0] = -1;
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    dfs(0, -1);
    int ans = 1;
    for (int i = 0; i < n; i++) {
        ans = (ans * ((r[i] - l[i] + 1) % mod)) % mod;
        num[i] = i;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<int> t1 = path(a, b), t2 = path(c, d);
        for (int j = 0; j < (int) t1.size(); j++) {
            if(t1[j] == t2[j])
                continue;
            int n1 = find(t1[j]), n2 = find(t2[j]);
            if(n1 == n2)
                continue;
            ans = (ans * inv(r[n1] - l[n1] + 1) % mod) % mod;
            ans = (ans * inv(r[n2] - l[n2] + 1) % mod) % mod;
            if(q[n1] > q[n2]) {
                l[n1] = max(l[n1], l[n2]);
                r[n1] = min(r[n1], r[n2]);
                num[n2] = n1;
                if (l[n1] > r[n1])
                    ans = 0;
                ans = (ans * (r[n1] - l[n1] + 1) % mod) % mod;
            }else{
                l[n2] = max(l[n1], l[n2]);
                r[n2] = min(r[n1], r[n2]);
                num[n1] = n2;
                if (l[n2] > r[n2])
                    ans = 0;
                ans = (ans * (r[n2] - l[n2] + 1) % mod) % mod;
            }
        }
        cout << ans << "\n";
    }
    return 0;
}