#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define ll long long

const int maxn = 2e5 + 100, mod = 1e9 + 7;

int binpow(ll a, int n) {
    if (!n) return 1ll;
    ll res = binpow(a, n / 2);
    res *= res;
    res %= mod;
    if (n & 1) res *= a, res %= mod;
    return (int) res;
}

int obr(int a) {
    return binpow(a, mod - 2);
}

int pred[maxn], sz[maxn], l[maxn], r[maxn], res[maxn];
ll ans = 1;
int n;

void init() {
    for (int i = 0; i < n; i++) {
        pred[i] = i, sz[i] = 1;
        res[i] = max(0, r[i] - l[i] + 1);
        ans = (ans * res[i]) % mod;
    }
}

int find(int v) {
    if (v == pred[v]) return v;
    return pred[v] = find(pred[v]);
}

void merge(int a, int b) {
    a = find(a);
    b = find(b);
    if (a != b) {
        ans = (ans * obr(res[a])) % mod;
        ans = (ans * obr(res[b])) % mod;
        if (sz[a] < sz[b]) swap(a, b);
        l[a] = max(l[a], l[b]);
        r[a] = min(r[a], r[b]);
        res[a] = max(0, r[a] - l[a] + 1);
        pred[b] = a;
        sz[a] += sz[b];
        ans = (ans * res[a]) % mod;
    }
}

const int logn = 19;
pair<int, int> sparce[logn][2 * maxn];

int tin[maxn], tout[maxn];
int timer = 0;
vector<vector<int>> g;

void dfs(int v = 0, int h = 0) {
    tin[v] = timer;
    tout[v] = timer;
    sparce[0][timer++] = {h, v};
    for (auto to: g[v]) {
        dfs(to, h + 1);
        tout[v] = timer;
        sparce[0][timer++] = {h, v};
    }
}

pair<int, int> rmq(int lq, int rq) {
    int t = __lg(rq - lq + 1);
    return min(sparce[t][lq], sparce[t][rq - (1 << t) + 1]);
}

int lca(int u, int v) {
    int lq = min(tin[u], tin[v]), rq = max(tout[u], tout[v]);
    return rmq(lq, rq).ss;
}

void solve() {
    cin >> n;
    g.resize(n);
    vector<int> ded(n);
    for (int i = 1; i < n; i++) {
        cin >> ded[i];
        g[--ded[i]].pb(i);
    }
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    init();
    dfs();
    for (int p = 1; p < logn; p++)
        for (int i = 0; i + (1 << p) <= 2 * n; i++)
            sparce[p][i] = min(sparce[p - 1][i], sparce[p - 1][i + (1 << (p - 1))]);
    int m;
    cin >> m;
    int a, b, c, d, l1, l2, x;
    while (m--) {
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        l1 = lca(a, b);
        l2 = lca(c, d);

        vector<int> res1;
        for (int i = a; i != l1; i = ded[i]) res1.pb(i);
        res1.pb(l1);
        x = res1.size();
        for (int i = b; i != l1; i = ded[i]) res1.pb(i);
        reverse(res1.begin() + x, res1.begin() + res1.size());

        vector<int> res2;
        for (int i = c; i != l2; i = ded[i]) res2.pb(i);
        res2.pb(l2);
        x = res2.size();
        for (int i = d; i != l2; i = ded[i]) res2.pb(i);
        reverse(res2.begin() + x, res2.begin() + res2.size());


        for (int i = 0; i < res1.size(); i++)
            merge(res1[i], res2[i]);
        cout << ans << '\n';
    }
}

signed main() {
#ifdef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}
