#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

const ll mod=1e9+7;

ll bpow(ll a, ll b)
{
    if(b==0) return 1;
    if(b%2==1) return bpow(a,b-1)*a%mod;
    ll x=bpow(a,b/2);
    return x*x%mod;
}

ll inv(ll x)
{
    return bpow(x,mod-2);
}

ll cost(pll seg)
{
    return max(0ll,seg.S-seg.F+1);
}

ll ans=1;

struct dsu
{
    ve<ll> link,sz;
    ve<pll> seg;

    void init(ve<pll> seg)
    {
        this->seg=seg;
        link.assign(seg.size(),0);
        sz.assign(seg.size(),1);
        iota(all(link),0);
    }

    ll fset(ll x)
    {
        if(x==link[x]) return x;
        return link[x]=fset(link[x]);
    }

    void unite(ll a, ll b)
    {
        a=fset(a);
        b=fset(b);
        if(a==b) return;
        if(sz[a]<sz[b]) swap(a,b);
        link[b]=a;
        sz[a]+=sz[b];
        ans=ans*inv(cost(seg[a]))%mod;
        ans=ans*inv(cost(seg[b]))%mod;
        seg[a].F=max(seg[a].F,seg[b].F);
        seg[a].S=min(seg[a].S,seg[b].S);
        ans=ans*cost(seg[a])%mod;
    }
};

ve<ll> gr[N];
ll pr[N],used[N];
ll n,timer=0;

ve<ll> get_path(ll a, ll b)
{
    timer++;
    queue<ll> q;
    fill(used,used+n,0);
    used[a]=timer;
    q.push(a);

    while(!q.empty())
    {
        ll x=q.front();
        q.pop();

        for(ll i:gr[x])
        {
            if(used[i]!=timer)
            {
                used[i]=timer;
                pr[i]=x;
                q.push(i);
            }
        }
    }

    ve<ll> v;
    ll pos=b;

    while(pos!=a)
    {
        v.PB(pos);
        pos=pr[pos];
    }

    v.PB(a);
    reverse(all(v));
    return v;
}

void solve()
{
    cin>>n;

    for(ll i=1;i<n;i++)
    {
        ll x;
        cin>>x;
        x--;
        gr[x].PB(i);
        gr[i].PB(x);
    }

    ve<pll> seg(n);

    for(ll i=0;i<n;i++)
    {
        cin>>seg[i].F>>seg[i].S;
        ans=ans*cost(seg[i])%mod;
    }

    dsu d;
    d.init(seg);
    ll q;
    cin>>q;

    while(q--)
    {
        ll s1,t1,s2,t2;
        cin>>s1>>t1>>s2>>t2;
        s1--, t1--, s2--, t2--;
        ve<ll> p1=get_path(s1,t1),p2=get_path(s2,t2);

        for(ll i=0;i<p1.size();i++)
            d.unite(p1[i],p2[i]);

        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
