#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;

vector<vector<int>> g;
vector<int> dep;

const int mod = 1e9 + 7;

void dfs(int v) {
    for (auto u : g[v]) {
        dep[u] = dep[v] + 1;
        dfs(u);
    }
}

ll binpow(ll x, ll p) {
    if (p == 0) {
        return 1;
    }

    ll res = binpow((x * x) % mod, p / 2);
    if (p % 2 == 1) {
        res = (res * x) % mod;
    }
    return res;
}

int inv(int x) {
    return binpow(x, mod - 2);
}


struct DSU {
    vector<int> r, p;

    DSU() {}
    DSU(int n) {
        r.assign(n, 0);
        p.resize(n);
        iota(all(p), 0);
    }

     int get(int a) {
        if (p[a] != a) {
            p[a] = get(p[a]);
        }
        return p[a];
    }

    bool unite(int a, int b) {
        a = get(a);
        b = get(b);

        if (a == b) {
            return false;
        }

        if (r[a] < r[b]) swap(a, b);
        r[a] += r[a] == r[b];
        p[b] = a;

        return true;
    }
};

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> p(n);
    g.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }

    dep.assign(n, 0);
    dfs(0);

    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];

    auto up = [&](int& v, vector<int>& path) {
        path.push_back(v);
        v = p[v];
    };

    auto get_path = [&](int u, int v, vector<int>& path) {
        vector<int> p1, p2;
        while (dep[u] > dep[v]) up(u, p1);
        while (dep[v] > dep[u]) up(v, p2);
        while (u != v) {
            up(u, p1);
            up(v, p2);
        }
        p1.push_back(u);
        reverse(all(p2));

        int cur = 0;
        path.resize(p1.size() + p2.size());
        for (auto el : p1) path[cur++] = el;
        for (auto el : p2) path[cur++] = el;
    };

    ll ans = 1;
    for (int i = 0; i < n; i++) ans = (ans * (r[i] - l[i] + 1)) % mod;

    DSU dsu(n);

    int m;
    cin >> m;

    for (int year = 0; year < m; year++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;

        if (ans == 0) {
            cout << 0 << '\n';
            continue;
        }

        vector<int> path[2];
        get_path(a, b, path[0]);
        get_path(c, d, path[1]);

        int len = path[0].size();
        for (int i = 0; i < len && ans != 0; i++) {
            if (dsu.get(path[0][i]) == dsu.get(path[1][i])) {
                continue;
            }

            int a = dsu.get(path[0][i]);
            int b = dsu.get(path[1][i]);

            int nl = max(l[a], l[b]);
            int nr = min(r[a], r[b]);
            nr = max(nr, nl - 1);

            ans = (ans * inv(r[a] - l[a] + 1)) % mod;
            ans = (ans * inv(r[b] - l[b] + 1)) % mod;
            ans = (ans * (nr - nl + 1)) % mod;

            dsu.unite(a, b);
            int root = dsu.get(a);
            l[root] = nl;
            r[root] = nr;
        }

        cout << ans << '\n';
    }

    return 0;
}