#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize(Ofast)
#pragma GCC optimize(unroll-lops)

using namespace std;

#define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

#ifdef Local
#define debug(x) cerr << "$ " << #x << " = " << x << endl
#else
#define debug(...) 1337
#endif

vec<vec<int>> c;
vec<int> p;

struct dsu {
    int n;
    struct node {
        int p, s, l, r;
    };
    vec<node> t;

    dsu(int np) {
        n = np;
        t.resize(n);
        for (int i = 0; i < n; ++i)
            t[i].p = i, t[i].s = 1;
    }

    int find(int v) {
        return (t[v].p == v ? v : t[v].p = find(t[v].p));
    }

    void unit(int v, int u) {
        v = find(v), u = find(u);
        if (t[u].s > t[v].s)
            swap(v, u);
        t[u].p = v, t[v].s += t[u].s, t[v].l = max(t[v].l, t[u].l), t[v].r = min(t[v].r, t[u].r);
    }
};

vec<int> h, tin, tout;
vec<int> up;
int t = 0;

void dfs(int v) {
    tin[v] = t++;
    h[v] = h[p[v]] + 1;
    if (h[p[v]] - h[up[p[v]]] == h[up[p[v]]] - h[up[up[p[v]]]])
        up[v] = up[up[p[v]]];
    else
        up[v] = p[v];
    for (int &u: c[v])
        dfs(u);
    tout[v] = t++;
}

bool isPar(int pr, int v) {
    return (tin[pr] <= tin[v] && tout[v] <= tout[pr]);
}

int lca(int v, int u) {
    if (h[v] > h[u])
        swap(v, u);
    if (isPar(v, u))
        return v;
    while (!isPar(p[v], u)) {
        if (isPar(up[v], u))
            v = p[v];
        else
            v = up[v];
    }
    return p[v];
}

const int mod = (int) 1e9 + 7;

int bpow(int x, int b) {
    int r = 1;
    while (b) {
        if (b & 1)
            r = r * x % mod;
        x = x * x % mod, b >>= 1;
    }
    return r;
}

int s1, t1, s2, t2, c1, c2;

void solve() {
    int n;
    cin >> n;
    c.resize(n), p.resize(n);
    h.resize(n), tin.resize(n), tout.resize(n);
    up.resize(n);
    p[0] = h[0] = up[0] = 0;
    for (int i = 1; i < n; ++i)
        cin >> p[i], --p[i], c[p[i]].pb(i);
    dfs(0);
    dsu dsu(n);
    int cur = 1;
    for (int i = 0, l, r; i < n; ++i) {
        cin >> l >> r;
        dsu.t[i].l = l, dsu.t[i].r = r;
        cur = cur * (r - l + 1) % mod;
    }
    int m;
    cin >> m;
    for (int i = 0; i < m; ++i) {
        cin >> s1 >> t1 >> s2 >> t2, --s1, --s2, --t1, --t2;
        c1 = lca(s1, t1), c2 = lca(s2, t2);
        vec<int> pt1, pt2;
        while (s1 != c1)
            pt1.pb(s1), s1 = p[s1];
        while (s2 != c2)
            pt2.pb(s2), s2 = p[s2];
        vec<int> pt12, pt22;
        while (t1 != c1)
            pt12.pb(t1), t1 = p[t1];
        while (t2 != c2)
            pt22.pb(t2), t2 = p[t2];
        pt1.pb(c1);
        pt2.pb(c2);
        reverse(all(pt12));
        reverse(all(pt22));
        for (int &j: pt12)
            pt1.pb(j);
        for (int &j: pt22)
            pt2.pb(j);
        for (int j = 0; j < sz(pt1); ++j) {
            int v = dsu.find(pt1[j]), u = dsu.find(pt2[j]);
            if (v == u)
                continue;
            cur = cur * bpow(max(0ll, dsu.t[v].r - dsu.t[v].l + 1), mod - 2) % mod * bpow(max(0ll, dsu.t[u].r - dsu.t[u].l + 1), mod - 2) % mod;
            dsu.unit(v, u);
            cur = cur * max(0ll, dsu.t[dsu.find(v)].r - dsu.t[dsu.find(v)].l + 1) % mod;
        }
        cout << cur << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}