#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize(Ofast)
#pragma GCC optimize(unroll - lops)

using namespace std;

// #define int long long

typedef long long ll;
typedef long double ld;

#define vec vector
#define pb push_back
#define sz(x) (int) (x).size()
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
using str = string;

#ifdef Local
#define debug(x) cerr << "$ " << #x << " = " << x << endl
#else
#define debug(...) 1337
#endif

vec<vec<int>> c;
vec<int> p;

struct dsu {
    int n;
    struct node {
        int p, s, l, r;
    };
    vec<node> t;

    dsu(int np) {
        n = np;
        t.resize(n);
        for (int i = 0; i < n; ++i)
            t[i].p = i, t[i].s = 1;
    }

    int find(int v) {
        return (t[v].p == v ? v : t[v].p = find(t[v].p));
    }

    void unit(int v, int u) {
        v = find(v), u = find(u);
        if (t[u].s > t[v].s)
            swap(v, u);
        t[u].p = v, t[v].s += t[u].s, t[v].l = max(t[v].l, t[u].l), t[v].r = min(t[v].r, t[u].r);
    }
};

vec<int> h, tin, tout;
vec<int> up;
int t = 0;

void dfs(int v) {
    tin[v] = t++;
    h[v] = h[p[v]] + 1;
    if (h[p[v]] - h[up[p[v]]] == h[up[p[v]]] - h[up[up[p[v]]]])
        up[v] = up[up[p[v]]];
    else
        up[v] = p[v];
    for (int &u: c[v])
        dfs(u);
    tout[v] = t++;
}

bool isPar(int pr, int v) {
    return (tin[pr] <= tin[v] && tout[v] <= tout[pr]);
}

int lca(int v, int u) {
    if (h[v] > h[u])
        swap(v, u);
    if (isPar(v, u))
        return v;
    while (!isPar(p[v], u)) {
        if (isPar(up[v], u))
            v = p[v];
        else
            v = up[v];
    }
    return p[v];
}

const ll mod = (int) 1e9 + 7;

ll bpow(ll x, int b) {
    ll r = 1;
    while (b) {
        if (b & 1)
            r = r * x % mod;
        x = x * x % mod, b >>= 1;
    }
    return r;
}

int s1, t1, s2, t2, c1, c2;


struct node {
    int l, r;
};

void solve() {
    int n;
    cin >> n;
    c.resize(n), p.resize(n);
    h.resize(n), tin.resize(n), tout.resize(n);
    up.resize(n);
    p[0] = h[0] = up[0] = 0;
    int gr = 0;
    for (int i = 1; i < n; ++i) {
        cin >> p[i], --p[i], c[p[i]].pb(i);
        if (p[i] != i)
            gr = 1;
    }
    dfs(0);
    ll cur = 1;
    vec<node> k(n);
    for (auto &[l, r]: k) {
        cin >> l >> r;
        cur = cur * (r - l + 1) % mod;
    }
    int m;
    cin >> m;
    dsu dsu(n);
    for (int i = 0; i < n; ++i)
        dsu.t[i].l = k[i].l, dsu.t[i].r = k[i].r;
    vec<int> pt1, pt2;
    vec<int> pt12, pt22;
    unordered_map<ll, int> hm;
    int v, u;
    int z1, z2;
    map<pair<int, int>, int> ws, wt;
    for (int i = 0; i < m; ++i) {
        cin >> s1 >> t1 >> s2 >> t2, --s1, --s2, --t1, --t2;
        if (gr) {
            int gh = (s2 > t2 ? -1 : 1);
            if (s1 > t1)
                swap(s1, t1), swap(s2, t2);
            if (ws.count({s1, s2 * gh})) {
                int d = ws[{s1, s2 * gh}];
                s1 += d, s2 += d * gh;
                if (s1 >= t1)
                    continue;
                ws[{s1, s2 * gh}] = d + t1 - s1;
            } else
                ws[{s1, s2 * gh}] = t1 - s1;
        }
        c1 = lca(s1, t1), c2 = lca(s2, t2);
        pt1 = {}, pt2 = {};
        while (s1 != c1)
            pt1.pb(s1), s1 = p[s1];
        while (s2 != c2)
            pt2.pb(s2), s2 = p[s2];
        pt12 = {}, pt22 = {};
        while (t1 != c1)
            pt12.pb(t1), t1 = p[t1];
        while (t2 != c2)
            pt22.pb(t2), t2 = p[t2];
        pt1.pb(c1);
        pt2.pb(c2);
        for (int j = sz(pt12) - 1; j >= 0; --j)
            pt1.pb(pt12[j]);
        for (int j = sz(pt22) - 1; j >= 0; --j)
            pt2.pb(pt22[j]);
        for (int j = 0; j < sz(pt1); ++j) {
            v = dsu.find(pt1[j]), u = dsu.find(pt2[j]);
            if (v == u)
                continue;
            z1 = max(0, dsu.t[v].r - dsu.t[v].l + 1), z2 = max(0, dsu.t[u].r - dsu.t[u].l + 1);
            if (hm.find(z1) == hm.end())
                hm[z1] = bpow(z1, mod - 2);
            cur = cur * hm[z1] % mod;
            if (hm.find(z2) == hm.end())
                hm[z2] = bpow(z2, mod - 2);
            cur = cur * hm[z2] % mod;
            dsu.unit(v, u);
            cur = cur * max(0, dsu.t[dsu.t[v].p].r - dsu.t[dsu.t[v].p].l + 1) % mod;
        }
        if (dsu.t[dsu.find(0)].s == n) {
            for (; i < m; ++i)
                cout << cur << '\n';
            return;
        }
        cout << cur << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();

    return 0;
}