#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second
#define endl '\n'

vector<int> h(1000007), p(1000007);

int get_pr(int a) {
    if (a == p[a]) {
        return a;
    }
    p[a] = get_pr(p[a]);
    return p[a];
}

void unite(int a, int b) {
    a = get_pr(a);
    b = get_pr(b);

    if (a == b) {
        return;
    }

    if (h[a] > h[b]) {
        swap(a, b);
    }

    h[b]++;
    p[a] = b;
}

vector<vector<int>> g(1000007);
void dfs(int v, vector<int> used, vector<int> &path, int vv, bool &fl) {
    if (v == vv) {
        fl = 1;
        return;
    }
    used[v] = 1;
    for (auto u : g[v]) {
        if (used[u] == 0) {
            path.push_back(u);
            dfs(u, used, path, vv, fl);
            if (fl) {
                return;
            }
            path.pop_back();
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    srand(time(0));
    cout << setprecision(13);

    int n;
    cin >> n;

    for (int i = 1; i < n + 3; i++) {
        p[i] = i;
    }

    int ans = 0;

    vector<int> vc(n + 1);
    for (int i = 2; i <= n; i++) {
        cin >> vc[i];
        g[i].push_back(vc[i]);
        g[vc[i]].push_back(i);
    }

    vector<int> L(n + 1), R(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> L[i] >> R[i];
    }

    int m;
    cin >> m;

    int mod = 1e9 + 7;

    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        vector<int> path1, path2;

        path1 = {a};
        path2 = {c};

        vector<int> used(n + 4);
        bool fl = 0;
        dfs(a, used, path1, b, fl);

        used.assign(n + 4, 0);
        fl = 0;
        dfs(c, used, path2, d, fl);

        for (int j = 0; j < path1.size(); j++) {
            int v = path1[j];
            int u = path2[j];

            v = get_pr(v);
            u = get_pr(u);

            int ll = max(L[u], L[v]);
            int rr = min(R[u], R[v]);

            unite(v, u);

            v = get_pr(v);

            L[v] = ll;
            R[v] = rr;
        }
        used.assign(n + 4, 0);
        int aans = 1;
        for (int j = 1; j <= n; j++) {
            int v = get_pr(j);
            if (used[v] == 0) {
                used[v] = 1;

                int tm = max(0LL, R[v] - L[v] + 1);

                aans *= tm;
                aans %= mod;
            }
        }

        cout << aans << endl;
    }

    return 0;
}

/*
 5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
3 4 4 3
3 4 3 5
 */

/*
 8
1 2 3 4 5 8 6
3 7
2 6
3 8
5 10
5 8
2 9
3 8
6 8
4
1 3 7 6
4 1 5 7
1 7 7 1
1 8 2 7
 */
