#ifndef DEBUG
#pragma GCC optimize("-Ofast")
#pragma GCC target("avx,avx2")
#endif

#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using vi = vector<ll>;
using vb = vector<bool>;
using ii = pair<ll, ll>;
using vii = vector<ii>;
using vvi = vector<vi>;

template<class T, class Y>
istream &operator>>(istream &s, pair<T, Y> &p) {
  return s >> p.first >> p.second;
}

template<class T>
istream &operator>>(istream &s, vector<T> &v) {
  for (auto &e : v) s >> e;
  return s;
}

template<class T>
ostream &operator<<(ostream &s, const vector<T> &v) {
  for (const auto &e : v) s << e << ' ';
  return s;
}

void solve();

int main() {
#ifdef DEBUG
  freopen("../in.txt", "r", stdin);
  freopen("../out.txt", "w", stdout);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  cout.setf(ios::fixed);
  cout.precision(20);

  solve();
}

// ----------

constexpr ll mod = 1e9 + 7;

ll n;
vvi gr;
vi p;
vii range;

bool pathfind(ll v, ll t, vi &path, ll par = -1) {
  if (v == t) return true;
  for (auto u : gr[v]) {
    if (u == par)continue;
    path.emplace_back(u);
    if (pathfind(u, t, path, v)) return true;
    path.pop_back();
  }
  return false;
}

vi pathfind(ll a, ll b) {
  vi path = {a};
  assert(pathfind(a, b, path));
  return path;
}

class dsu_t {
 public:
  dsu_t() {
    p.resize(n);
    for (int i = 0; i < n; ++i) {
      p[i] = i;
    }
    rank.resize(n, 0);
    rng.resize(n, {});
    for (int i = 0; i < n; ++i) {
      rng[i] = range[i];
      rng[i].second += 1;
    }
  }

  ll unite(ll a, ll b) {
    a = get(a), b = get(b);
    if (a == b) return a;
    if (rank[a] < rank[b]) swap(a, b);
    p[b] = a;
    if (rank[a] == rank[b]) rank[a] += 1;
    rng[a] = {max(rng[a].first, rng[b].first), min(rng[a].second, rng[b].second)};
    if (rng[a].first >= rng[a].second) rng[a] = {0, 0};
    return a;
  }

  ll get(ll v) {
    while (p[v] != p[p[v]]) {
      p[v] = p[p[v]];
    }
    return p[v];
  }

  vi p;
  vi rank;
  vii rng;
};

void solve() {
  cin >> n;
  p.assign(n, -1);
  range.assign(n, {});
  gr.assign(n, {});
  for (int i = 1; i < n; ++i) {
    cin >> p[i];
    --p[i];
    gr[i].emplace_back(p[i]);
    gr[p[i]].emplace_back(i);
  }
  cin >> range;

  dsu_t dsu;

  ll m;
  cin >> m;
  for (int qq = 0; qq < m; ++qq) {
    ll a, b, c, d;
    cin >> a >> b >> c >> d;
    --a, --b, --c, --d;
    vi ab = pathfind(a, b);
    vi cd = pathfind(c, d);
    for (int i = 0; i < cd.size(); ++i) {
      dsu.unite(ab[i], cd[i]);
    }
    ll ans = 1;
    unordered_map<ll, bool> taken;
    for (int i = 0; i < n; ++i) {
      ll v = dsu.get(i);
      if (taken[v]) continue;
      taken[v] = true;
      auto [x, y] = dsu.rng[v];
      ans *= (y - x);
      ans %= mod;
    }
    cout << ans << endl;
  }
}