#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

#define int long long

const int mod=1e9 + 7;

struct graph{
    vector<vector<int>> g;
    vector<vector<int>> binpow;
    vector<int> p;
    vector<int> h;
    vector<pair<int, int>> b;

    graph(int n){
        g.resize(n, vector<int> ());
        p.resize(n, 0);
        b.resize(n, {0, 0});
    }

    void init(){
        int n= p.size();

        binpow.resize(25, p);
        h.resize(n, 0);

        for(int i=1; i < binpow.size();i++){
            for(int j=0; j < n; j++){
                binpow[i][j] = binpow[i-1][binpow[i-1][j]];
            }
        }
    }

    int la(int v, int h){
        for(int i=binpow.size()-1; i >= 0; i--){
            if((1 << i) <= h){
                h -= (1 << i);
                v = binpow[i][v];
            }
        }

        return v;
    }

    int lca(int v, int u){
        if(h[u] < h[v]){
            v = la(v, h[v] - h[u]);
        }

        if(h[v] < h[u]){
            u = la(u, h[u] - h[v]);
        }

        if(u == v){
            return v;
        }

        for(int i=binpow.size()-1; i >= 0; i--){
            if(binpow[i][v] != binpow[i][u]){
                v = binpow[i][v];
                u = binpow[i][u];
            }
        }

        return p[v];
    }
};

void dfs(int v, graph &g){
    for(auto el: g.g[v]){
        g.h[el] = g.h[v] + 1;

        dfs(el, g);
    }
}

vector<int> get_path(graph &g, int a, int b){
    vector<int> ans1;
    vector<int> ans2;

    int lca_a_b = g.lca(a, b);

    while(a != lca_a_b){
        ans1.push_back(a);

        a = g.p[a];
    }

    ans1.push_back(lca_a_b);

    while(b != lca_a_b){
        ans2.push_back(b);

        b = g.p[b];
    }

    reverse(ans2.begin(), ans2.end());

    for(auto el: ans2){
        ans1.push_back(el);
    }

    return ans1;
}

void solve(){
    int n; cin >> n;

    graph g=graph(n);

    for(int i=1; i < n; i++){
        cin >> g.p[i];

        g.p[i]--;

        g.g[g.p[i]].push_back(i);
    }

    vector<pair<int, int>> b(n);

    for(int i=0; i < n; i++){
        cin >> b[i].first >> b[i].second;
    }

    g.init();

    dfs(0, g);

    int m; cin >> m;

    vector<vector<int>> same(n, vector<int> ());
    vector<int> used(n, 1);
    vector<int> cnt(n, 0);

    for(int i=0; i < n; i++){
        same[i].push_back(i);
        cnt[i] = i;
    }

    for(int i=0; i < m; i++){
        int a, b1, c, d; cin >> a >> b1 >> c >> d; a--; b1--;c--; d--;

        vector<int> f = get_path(g, a, b1);
        vector<int> s = get_path(g, c, d);

        for(int i=0; i < f.size(); i++){
            int u=f[i];
            int v=s[i];

            int l = max(b[u].first, b[v].first);
            int r = min(b[u].second, b[v].second);

            u = cnt[u];
            v = cnt[v];

            if(u == v){
                continue;
            }


            for(auto el: same[u]){
                same[v].push_back(el);
                cnt[el] = v;
            }

            for(auto el: same[v]){
                b[el] = {l, r};
                used[u] = 0;
            }
        }

        int ans = 1;

        for(int i=0; i < n; i++){
            if(!used[i]){
                continue;
            }

            auto el = b[same[i][0]];

            if(el.first <= el.second){
                ans *= (el.second -el.first + 1);
            }else{
                ans = 0;
            }

            ans %= mod;
        }

        cout << ans << "\n";
    }
}

int32_t main(){
    /*ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    */

    int t=1; //cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
