#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

const int mod=1e9 + 7;

struct graph{
    vector<vector<int>> g;
    vector<vector<int>> binpow;
    vector<int> p;
    vector<int> h;
    vector<pair<int, int>> b;

    graph(int n){
        g.resize(n, vector<int> ());
        p.resize(n, 0);
        b.resize(n, {0, 0});
    }

    void init(){
        int n= p.size();

        binpow.resize(25, p);
        h.resize(n, 0);

        for(int i=1; i < binpow.size();i++){
            for(int j=0; j < n; j++){
                binpow[i][j] = binpow[i-1][binpow[i-1][j]];
            }
        }
    }

    int la(int v, int h){
        for(int i=binpow.size()-1; i >= 0; i--){
            if((1 << i) <= h){
                h -= (1 << i);
                v = binpow[i][v];
            }
        }

        return v;
    }

    int lca(int v, int u){
        if(h[u] < h[v]){
            v = la(v, h[v] - h[u]);
        }

        if(h[v] < h[u]){
            u = la(u, h[u] - h[v]);
        }

        if(u == v){
            return v;
        }

        for(int i=binpow.size()-1; i >= 0; i--){
            if(binpow[i][v] != binpow[i][u]){
                v = binpow[i][v];
                u = binpow[i][u];
            }
        }

        return p[v];
    }
};

int binpow(int a, int st){
    if(st == 0){
        return 1;
    }

    if(st % 2 == 0){
        int res = binpow(a, st/2);

        return 1ll*res*res % mod;
    }else{
        return 1ll*binpow(a, st-1)*a % mod;
    }
}

struct DSU{
    vector<int> sz;
    vector<int> p;
    vector<pair<int, int>> b;
    int ans=1;

    DSU(int n){
        sz.resize(n, 1);
        p.resize(n, 0);
        b.resize(n, {0, 0});

        for(int i=0; i < n; i++){
            p[i]= i;
        }
    }

    int get(int v){
        if(p[v] == v){
            return v;
        }

        p[v] = get(p[v]);

        return p[v];
    }

    void merge(int u, int v){
        u=get(u);
        v=get(v);

        if(u == v){
            return;
        }

        if(sz[u] < sz[v]){
            swap(u, v);
        }

        p[v] = u;
        sz[u] += sz[v];

        int l = max(b[u].first, b[v].first);
        int r = min(b[u].second, b[v].second);

        int was1 = b[u].second - b[u].first + 1;
        int was2 = b[v].second - b[v].first + 1;

        if(was1 < 0){
            was1 = 0;
        }
        if(was2 < 0){
            was2 = 0;
        }


        ans =1ll*ans*binpow(was1, mod-2) % mod;
        ans =1ll*ans*binpow(was2, mod-2) % mod;

        b[u] = {l, r};

        if(l <= r){
            ans = 1ll*ans*(r-l+1) % mod;
        }else{
            ans = 0;
        }
    }
};

void dfs(int v, graph &g){
    for(auto el: g.g[v]){
        g.h[el] = g.h[v] + 1;

        dfs(el, g);
    }
}

vector<int> get_path(graph &g, int a, int b){
    vector<int> ans1;
    vector<int> ans2;

    int lca_a_b = g.lca(a, b);

    while(a != lca_a_b){
        ans1.push_back(a);

        a = g.p[a];
    }

    ans1.push_back(lca_a_b);

    while(b != lca_a_b){
        ans2.push_back(b);

        b = g.p[b];
    }

    reverse(ans2.begin(), ans2.end());

    for(auto el: ans2){
        ans1.push_back(el);
    }

    return ans1;
}

void solve(){
    int n; cin >> n;

    graph g=graph(n);

    for(int i=1; i < n; i++){
        cin >> g.p[i];

        g.p[i]--;

        g.g[g.p[i]].push_back(i);
    }

    DSU d=DSU(n);

    for(int i=0; i < n; i++){
        cin >> d.b[i].first >> d.b[i].second;

        d.ans = 1ll*d.ans * (d.b[i].second - d.b[i].first+1) % mod;
    }

    g.init();

    dfs(0, g);

    int m; cin >> m;

    for(int i=0; i < m; i++){
        int a, b1, c, d1; cin >> a >> b1 >> c >> d1; a--; b1--;c--; d1--;

        vector<int> f = get_path(g, a, b1);
        vector<int> s = get_path(g, c, d1);

        for(int i=0; i < f.size(); i++){
            int u=f[i];
            int v=s[i];

            d.merge(u, v);
        }

        cout << d.ans << "\n";
    }
}

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int t=1; //cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
