#include<bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

#define fast ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
#define all(a) a.begin(), a.end()
using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using vi = vector<int>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = 1e9 + 7;

int bin_pow(int x, int s) {
    if (s == 0)
        return 1;
    int y = bin_pow(x, s >> 1);
    y = (ll)y * y % MOD;
    if (s & 1)
        y = (ll)y * x % MOD;
    return y;
}

int f(int x) {
    return bin_pow(x, MOD - 2);
}

vi pr, sz, l, r;
int curr = 1;

int variants(int u) {
    return max(r[u] - l[u] + 1, 0);
}

void multiply(int u) {
    curr = (ll)curr * variants(u) % MOD;
}

void divide(int u) {
    curr = (ll)curr * f(variants(u)) % MOD;
}

int root(int u) {
    if (pr[u] == u)
        return u;
    pr[u] = root(pr[u]);
    return pr[u];
}

void link(int u, int v) {
    u = root(u);
    v = root(v);
    if (u == v)
        return;
    if (sz[u] > sz[v])
        swap(u, v);
    divide(u);
    divide(v);
    pr[u] = v;
    sz[v] += sz[u];
    l[v] = max(l[v], l[u]);
    r[v] = min(r[v], r[u]);
    multiply(v);
}

vector<vi> g;
vi p, h;

void dfs(int u = 0) {
    for (int v: g[u]) {
        h[v] = h[u] + 1;
        dfs(v);
    }
}

vi get_way(int u, int v) {
    vi a, b;
    while (h[u] > h[v]) {
        a.push_back(u);
        u = p[u];
    }
    while (h[v] > h[u]) {
        b.push_back(v);
        v = p[v];
    }
    while (u != v) {
        a.push_back(u);
        b.push_back(v);
        u = p[u];
        v = p[v];
    }
    a.push_back(u);
    while (!b.empty()) {
        a.push_back(b.back());
        b.pop_back();
    }
    return a;
}

void match(int a, int b, int c, int d) {
    vi w1 = get_way(a, b), w2 = get_way(c, d);
    int n = (int)w1.size();
    for (int i = 0; i < n; ++i)
        link(w1[i], w2[i]);
}

int main() {
    fast;
    int n;
    cin >> n;
    pr.resize(n);
    iota(all(pr), 0);
    sz.assign(n, 1);
    l.resize(n);
    r.resize(n);
    p.resize(n);
    h.resize(n);
    g.resize(n);
    p[0] = -1;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
    }
    h[0] = 0;
    dfs();
    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        multiply(i);
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        match(a, b, c, d);
        cout << curr << '\n';
    }
}
