#include <bits/stdc++.h>

using namespace std;

const int N = 200'000, MOD = 1'000'000'007;

int mul(int a, int b) {
    return (int) (((int64_t) a * b) % MOD);
}

int binPow(int a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n & 1) {
        return mul(a, binPow(a, n ^ 1));
    } else {
        return binPow(mul(a, a), n >> 1);
    }
}

vector<int> g[N];

int p[N], l[N], r[N];

int tin[N], tout[N], timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for (auto u : g[v]) {
        dfs(u);
    }
    tout[v] = timer++;
}

bool is_p(int u, int v) { // u -> v;
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int pr[N], sz[N];

int get_p(int v) {
    while (v != pr[v]) {
        pr[v] = pr[pr[v]];
        v = pr[v];
    }
    return v;
}

int ans = 1;

void merge(int u, int v) {
    u = get_p(u);
    v = get_p(v);
    if (u == v) {
        return;
    }

    if (sz[v] > sz[u]) {
        swap(u, v);
    }

    if (r[u] - l[u] + 1 > 0) {
        ans = mul(ans, binPow(r[u] - l[u] + 1, MOD - 2));
    }
    if (r[v] - l[v] + 1 > 0) {
        ans = mul(ans, binPow(r[v] - l[v] + 1, MOD - 2));
    }
    pr[v] = u;
    sz[u] += sz[v];
    r[u] = min(r[u], r[v]);
    l[u] = max(l[u], l[v]);
    ans = mul(ans, max(0, r[u] - l[u] + 1));
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = mul(ans, r[i] - l[i] + 1);
        sz[i] = 1;
        pr[i] = i;
    }

    dfs(0);

    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;

        vector<int> p1, p1r;
        while (!is_p(a, b)) {
            p1.push_back(a);
            a = p[a];
        }
        while (b != a) {
            p1r.push_back(b);
            b = p[b];
        }
        p1.push_back(a);
        reverse(p1r.begin(), p1r.end());
        for (auto it : p1r) {
            p1.push_back(it);
        }

        vector<int> p2, p2r;
        while (!is_p(c, d)) {
            p2.push_back(c);
            c = p[c];
        }
        while (d != c) {
            p2r.push_back(d);
            d = p[d];
        }
        p2.push_back(c);
        reverse(p2r.begin(), p2r.end());
        for (auto it : p2r) {
            p2.push_back(it);
        }

        for (int i = 0; i < (int) p1.size(); i++) {
            merge(p1[i], p2[i]);
        }
        cout << ans << "\n";
    }
}