#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
vector<vector<ll>> g;
vector<pair<ll, ll>> lim;
vector<ll> p, r, pr;

ll get(ll a) {
    if (a != p[a]) p[a] = get(p[a]);
    return p[a];
}

void un(ll a, ll b) {
    ll x = get(a);
    ll y = get(b);
    if (x != y) {
        if (r[x] == r[y]) ++r[x];
        if (r[x] < r[y]) {
            p[x] = y;
            lim[y].second = min(lim[y].second, lim[x].second);
            lim[y].first = max(lim[y].first, lim[x].first);
        }
        else {
            p[y] = x;
            lim[x].second = min(lim[y].second, lim[x].second);
            lim[x].first = max(lim[y].first, lim[x].first);
        }
    }
}

void dfs(ll v, ll w = -1) {
    pr[v] = w;
    for (ll to : g[v]) {
        if (to == w) continue;
        dfs(to, v);
    }
}


int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        ll pr; cin >> pr;
        --pr;
        g[pr].push_back(i + 1);
        g[i + 1].push_back(pr);
    }
    p.assign(n, 0);
    r.assign(n, 0);
    for (int i = 0; i < n; ++i) p[i] = i;
    lim.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> lim[i].first >> lim[i].second;
    }
    ll m;
    cin >> m;
    ll mod = 1e9 + 7;
    for (int i = 0; i < m; ++i) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        pr.assign(n, -1);
        dfs(a);
        ll now = b;
        vector<ll> path1;
        while (now != -1) {
            path1.push_back(now);
            now = pr[now];
        }
        pr.assign(n, -1);
        dfs(c);
        now = d;
        vector<ll> path2;
        while (now != -1) {
            path2.push_back(now);
            now = pr[now];
        }
        for (int j = 0; j < path1.size(); ++j) {
            un(path1[j], path2[j]);
        }
        ll ans = 1;
        for (int j = 0; j < n; ++j) {
            if (p[j] == j) {
                ll cnt = max(0LL, lim[j].second - lim[j].first + 1);
                ans = ans * cnt % mod;
            }
        }
        cout << ans << '\n';
    }
}