#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#define ll long long
#define ld long double

// login: open-2023-382
// passw: fx5mmuap

using namespace std;

const ll inf = 1e18;
const ll MOD = 1e9 + 7;

ll n;
vector<vector<ll>> gr;
vector<ll> p;
vector<ll> l, r;

ll findP(ll x) {
	if (x == p[x]) return x;
	return p[x] = findP(p[x]);
}

void unionSet(ll a, ll b) {
	a = findP(a);
	b = findP(b);
	if (a == b) return;
	p[a] = b;
}

void read() {
	cin >> n;
	gr = vector<vector<ll>>(n);
	for (ll i = 1; i < n; i++) {
		ll x;
		cin >> x;
		x--;
		gr[i].push_back(x);
		gr[x].push_back(i);
	}
	l = r = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}
	p = vector<ll>(n);
	for (ll i = 0; i < n; i++) {
		p[i] = i;
	}
}

vector<ll> cur;
void getPath(ll v, ll pr, ll last) {
	cur.push_back(v);
	if (cur.back() == last) return;
	for (auto& to : gr[v]) {
		if (to == pr) continue;
		getPath(to, v, last);
		if (cur.back() == last) return;
	}
	cur.pop_back();
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	
	read();
	ll m;
	cin >> m;
	while (m--) {
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--;
		c--, d--;
		getPath(a, -1, b);
		vector<ll> p1 = cur;
		cur.clear();
		getPath(c, -1, d);
		vector<ll> p2 = cur;
		cur.clear();
		ll k = p1.size();
		for (ll i = 0; i < k; i++) {
			unionSet(p1[i], p2[i]);
		}
		vector<ll> L(n, 0), R(n, inf);
		for (ll i = 0; i < n; i++) {
			p[i] = findP(i);
			L[p[i]] = max(L[p[i]], l[i]);
			R[p[i]] = min(R[p[i]], r[i]);
		}
		ll ans = 1;
		for (ll i = 0; i < n; i++) {
			if (L[i] == 0) continue;
			ans = (ans * max(0ll, R[i] - L[i] + 1)) % MOD;
		}
		cout << ans << "\n";
	}

	return 0;
} 