#include <bits/stdc++.h>

#define int long long
#define double long double
using namespace std;
int n, m;
vector<vector<int>> g;
vector<pair<int, int>> og;
vector<int> parent;
vector<int> depth;
vector<vector<int>> up;

void dfs(int v, int d) {
    depth[v] = d;
    up[0][v] = parent[v];
    for (int i = 1; i < 20; ++i) {
        up[i][v] = up[i - 1][up[i - 1][v]];
    }
    for (int to: g[v]) {
        dfs(to, d + 1);
    }
}

int lca(int u, int v) {
    if (depth[u] > depth[v])swap(u, v);
    for (int i = 19; i >= 0; --i) {
        if (depth[up[i][v]] >= depth[u]) {
            v = up[i][v];
        }
    }
    if (u == v) {
        return v;
    } else {
        for (int i = 19; i >= 0; --i) {
            if (up[i][v] != up[i][u]) {
                v = up[i][v];
                u = up[i][u];
            }
        }
        return parent[u];
    }
}

vector<int> pred;
vector<int> sz;

int par(int v) {
    if (pred[v] == -1)return v;
    return par(pred[v]);
}

void unite(int u, int v) {
    u = par(u);
    v = par(v);
    if (u == v)return;
    if (sz[u] > sz[v])swap(u, v);
    sz[v] += sz[u];
    pred[u] = v;
}


signed main() {
    cin >> n;
    g.resize(n);
    parent.resize(n, 0);
    depth.resize(n, 0);
    up.resize(20, vector<int>(n));
    pred.resize(n, -1);
    sz.resize(n, 1);
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v;
        v--;
        g[v].push_back(i);
        parent[i] = v;
    }
    og.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> og[i].first >> og[i].second;
    }
    dfs(0, 0);
    cin >> m;
    while (m--) {
        int ans = 1;
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        int lca1 = lca(a, b);
        int lca2 = lca(c, d);
        vector<int> a1, b1, c1, d1;
        while (a != lca1) {
            a1.push_back(a);
            a = parent[a];
        }
        a1.push_back(a);
        while (b != lca1) {
            b1.push_back(b);
            b = parent[b];
        }
        while (c != lca2) {
            c1.push_back(c);
            c = parent[c];
        }
        c1.push_back(c);
        while (d != lca2) {
            d1.push_back(d);
            d = parent[d];
        }
        for (int i = (int) b1.size() - 1; i >= 0; --i) {
            a1.push_back(b1[i]);
        }
        for (int i = (int) d1.size() - 1; i >= 0; --i) {
            c1.push_back(d1[i]);
        }
        for (int i = 0; i < a1.size(); ++i) {
            a1[i] = par(a1[i]);
            c1[i] = par(c1[i]);
            og[a1[i]].first = max(og[a1[i]].first, og[c1[i]].first);
            og[c1[i]].first = og[a1[i]].first;
            og[a1[i]].second = min(og[a1[i]].second, og[c1[i]].second);
            og[c1[i]].second = og[a1[i]].second;
            unite(a1[i], c1[i]);
        }
        for (int i = 0; i < n; ++i) {
            if (pred[i] == -1) {
                ans *= (max((int) 0, og[i].second - og[i].first + 1));
                ans %= 1000000007;
            }
        }
        cout << ans << "\n";
    }
}