#include <bits/stdc++.h>


#define newline cout << '\n'
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = 1e18;
const int nmax = 2e5 + 5;
const int logn = 22;
const int mod = 1e9 + 7;
mt19937 rnd(time(0));


vector<int> g[nmax];
vector<int> t;
bool used[nmax];
int h[nmax], p[nmax];
int up[nmax][logn];

void dfs(int v, int p = -1) {
	used[v] = true;
	if (p == -1) {
		h[v] = 0;
	} else {
		h[v] = h[p] + 1;
		up[v][0] = p;
	}

	for (int i = 1; i < logn; ++i) {
		up[v][i] = up[up[v][i - 1]][i - 1];
	}

	for (int u : g[v]) {
		if (!used[u]) {
			dfs(u, v);
		}
	}
}

int lca(int u, int v) {
	if (h[u] > h[v]) {
		swap(u, v);
	} else if (h[u] == h[v]) {
		return v;
	}
	// h[u] < h[v]
	int c = h[v] - h[u];
	for (int i = 0; i < logn; ++i) {
		if (c & (1 << i)) {
			v = up[v][i];
		}
	}
	if (u == v) {
		return u;
	}
	// h[u] = h[v]
	for (int cnt = 0; cnt < logn; ++cnt) {
		bool q = false;
		for (int i = logn - 1; i > -1; --i) {
			if (up[v][i] != up[u][i]) {
				u = up[u][i];
				v = up[v][i];
				q = true;
				break;
			}
		}
		if (!q) {
			u = p[u], v = p[v];
			break;
		}
	}
	return u;
}


struct dsu {
	vector<int> p, r, max_l, min_r;

	void init(int n) {
		p.assign(n, 0);
		r.assign(n, 0);
		max_l.assign(n, 0);
		min_r.assign(n, 0);

		for (int i = 0; i < n; ++i) {
			p[i] = i;
		}
	}

	int get(int x) {
		if (p[x] != x) {
			p[x] = get(p[x]);
		}
		return p[x];
	}

	void join(int x, int y) {
		x = get(x), y = get(y);
		if (x == y) {
			return ;
		} else if (r[x] > r[y]) {
			swap(x, y);
		} else if (r[x] == r[y]) {
			++r[y];
		}
		p[x] = y;
		max_l[y] = max(max_l[y], max_l[x]);
		min_r[y] = min(min_r[y], min_r[x]);
	}
};

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	for (int i = 0; i < nmax; ++i) {
		p[i] = -1;
		h[i] = 0;
	}

	int n, m, x;
	cin >> n;

	vector<pair<int, int>> c(n + 1);

	for (int i = 2; i <= n; ++i) {
		cin >> x;
		p[i] = x;
		g[i].push_back(x);
		g[x].push_back(i);
	}

	for (int i = 1; i <= n; ++i) {
		cin >> c[i].f >> c[i].s;
	}

	memset(h, 0, sizeof h);
	memset(up, 0, sizeof up);
	dfs(1);

	dsu comp;
	comp.init(n + 1);

	for (int i = 1; i <= n; ++i) {
		comp.min_r[i] = c[i].s;
		comp.max_l[i] = c[i].f;
	}

	cin >> m;
	while (m--) {
		int a, b, u, v;
		cin >> a >> b >> u >> v;
		int l1 = lca(a, b), l2 = lca(u, v);
		vector<int> p1, p2, t;
		while (a != l1) {
			p1.push_back(a);
			a = p[a];
		}
		while (b != l1) {
			t.push_back(b);
			b = p[b];
		}
		reverse(t.begin(), t.end());
		p1.push_back(l1);
		for (int x : t) {
			p1.push_back(x);
		}
		t.clear();
		while (u != l2) {
			p2.push_back(u);
			u = p[u];
		}
		while (v != l2) {
			t.push_back(v);
			v = p[v];
		}
		reverse(t.begin(), t.end());
		p2.push_back(l2);
		for (int x : t) {
			p2.push_back(x);
		}

		ll cr = 1ll;

		vector<vector<int>> con(n + 1);
		for (int i = 0; i < (int)p1.size(); ++i) {
			a = p1[i], u = p2[i];
			comp.join(a, u);
		}

		cr = max(0ll, cr);
		ll ans = 1ll;
		memset(used, 0, sizeof used);
		for (int i = 1; i <= n; ++i) {
			int type = comp.get(i);
			if (used[type]) {
				continue;
			}
			used[type] = true;
			ans = 1ll * max(0, comp.min_r[type] - comp.max_l[type] + 1) * ans % mod;
		}


		cout << ans % mod << '\n';
	}
	

	return 0;
}