/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;



struct segtree {
    int sz;
    vector <ll> tree;

    void init (int n) {
        sz = 1;
        while (sz < n) {
            sz *= 2;
        }
        tree.assign(2 * sz - 1, 0ll);
    }

    void update (int i, ll v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = v;
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            update(i, v, 2 * x + 1, lx, m);
        }
        else {
            update(i, v, 2 * x + 2, m, rx);
        }
        tree[x] = (tree[2 * x + 1] + tree[2 * x + 2]) % mod;
    }

    ll get (int l, int r, int x, int lx, int rx) {
        if (lx >= r || l >= rx) {
            return 0ll;
        }
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        int m = (lx + rx) / 2;
        return (get(l, r, 2 * x + 1, lx, m) + get(l, r, 2 * x + 2, m, rx)) % mod;
    }
}; segtree st, st1;


inline ll binpow (ll a, ll n) {
    ll res = 1;
    while (n) {
        if (n & 1) {
            res *= a; res %= mod;
        }
        a *= a; a %= mod;
        n >>= 1;
    }
    return res;
}


const int N = 2e5 + 1, k = 20;
const ll base = 31;
ll pw[N], ipw[N], l[N], r[N], ans[N], ANS = 1, val[N], val1[N];

int n, q, p[N], lev[N], dp[N][k], sz[N];
vector <int> g[N];


int lca (int u, int v) {
    if (lev[u] < lev[v]) {
        swap(u, v);
    }
    for (int i = k - 1; i >= 0; --i) {
        if (dp[u][i] != -1 && lev[dp[u][i]] >= lev[v]) {
            u = dp[u][i];
        }
    }
    if (u == v) {
        return u;
    }
    for (int i = k - 1; i >= 0; --i) {
        if (dp[u][i] != dp[v][i]) {
            u = dp[u][i]; v = dp[v][i];
        }
    }
    return p[u];
}


void dfs (int vert, int par, int level) {
    lev[vert] = level;
    sz[vert] = 1;
    for (auto i : g[vert]) {
        if (i != par) {
            dfs(i, vert, level + 1);
            sz[vert] += sz[i];
        }
    }
}

vector <int> A;
int pos[N];
bool heavy[N], heavy_head[N];

bool cmp (int i, int j) {
    return sz[i] > sz[j];
}

void dfs_HLD (int vert, int par) {
    A.pb(vert);
    sort(all(g[vert]), cmp);
    int ind = -1;
    for (auto i : g[vert]) {
        if (i != par) {
            if (ind == -1) {
                ind = i;
            }
            dfs_HLD(i, vert);
        }
    }
    if (ind != -1) {
        // heavy[ind] = true;
    }
}

void dfs1 (int vert, int par) { // calc heavy_head
    if (par == -1) {
        if (heavy[vert]) {
            heavy_head[vert] = vert;
        }
    }
    else {
        if (heavy[par]) {
            heavy_head[vert] = heavy_head[par];
        }
        else {
            heavy_head[vert] = vert;
        }
    }
    for (auto i : g[vert]) {
        if (i != par) {
            dfs1(i, vert);
        }
    }
}

// DSU
int head[N], dsu_sz[N];
vector <int> component[N];

void unite (int u, int v) {
    u = head[u]; v = head[v];
    if (u == v) {
        return;
    }
    if (dsu_sz[u] < dsu_sz[v]) {
        swap(u, v);
    }
    for (auto i : component[v]) {
        head[i] = u;
        component[u].emplace_back(i);
        ++dsu_sz[u];
        val[i] = pw[lev[i]] * (1 + head[i]) % mod;
        val1[i] = pw[n - lev[i]] * (1 + head[i]) % mod;
        st.update(pos[i], val[i], 0, 0, n);
        st1.update(pos[i], val1[i], 0, 0, n);
    }
    component[v].clear();
    ANS *= binpow(ans[u], mod - 2); ANS %= mod;
    ANS *= binpow(ans[v], mod - 2); ANS %= mod;
    l[u] = max(l[u], l[v]);
    r[u] = min(r[u], r[v]);
    ans[u] = max(0ll, r[u] - l[u] + 1);
    ANS *= ans[u]; ANS %= mod;
}


inline vector <int> get_path (int a, int b) {
    int L = lca(a, b);
    // debug(L << ' ' << a << ' ' << b);
    vector <int> v1, v2;
    while (a != L) {
        v1.emplace_back(a); a = p[a];
    }
    while (b != L) {
        v2.emplace_back(b); b = p[b];
    }
    reverse(all(v2));
    v1.emplace_back(L);
    for (auto i : v2) {
        v1.emplace_back(i);
    }
    return v1;
}


inline int up (int a, int len) {
    // debug(len);
    // debug(len);
    for (int i = k - 1; i >= 0; --i) {
        if ((1 << i) <= len) {
            len -= (1 << i);
            a = dp[a][i];
        }
    }
    // debug(a);
    return a;
}


int gt (int a, int b, int lc, int len) {
    if (lev[a] - len + 1 >= lev[lc]) {
        return up(a, len - 1);
    }
    else {
        len -= (lev[a] - lev[lc]);
        return up(b, lev[b] - lev[lc] - (len - 1));
    }
}


ll hsh (int a, int b, int lc, int len) {
    // debug(a << ' ' << b << ' ' << lc << ' ' << len);
    if (lev[a] - len + 1 >= lev[lc]) {
        // debug(a);
        ll res = 0, need = lev[a] - len + 1;
        while (a != -1 && lev[a] >= need) {
            if (heavy[a]) {
                int c = heavy_head[a];
                if (lev[c] >= need) {
                    res += st.get(pos[c], pos[a] + 1, 0, 0, n);
                    a = p[c];
                }
                else {
                    res += st.get(pos[a] - (lev[a] - need + 1) + 1, pos[a] + 1, 0, 0, n);
                    res %= mod;
                    break;
                }
            }
            else {
                // debug(28);
                res += val[a]; a = p[a];
            }
            res %= mod;
        }
        return res * ipw[need] % mod;
    }
    else {
        ll res1 = 0, res2 = 0, need = lev[lc], aa = a;
        while (a != -1 && lev[a] >= need) {
            if (heavy[a]) {
                int c = heavy_head[a];
                if (lev[c] >= need) {
                    res1 += st.get(pos[c], pos[a] + 1, 0, 0, n);
                    a = p[c];
                }
                else {
                    res1 += st.get(pos[a] - (lev[a] - need + 1) + 1, pos[a] + 1, 0, 0, n);
                    res1 %= mod;
                    break;
                }
            }
            else {
                res1 += val[a]; a = p[a];
            }
            res1 %= mod;
        }
        ll remain = len - (lev[aa] - lev[lc]);
        res1 *= ipw[need] * pw[remain - 1] % mod; res1 %= mod;
        // cout << res1 << endl;
        int B = up(b, lev[b] - lev[lc] - remain + 1);
        while (B != -1 && lev[B] > need) {
            if (heavy[B]) {
                int c = heavy_head[B];
                if (lev[c] > need) {
                    res2 += st1.get(pos[c], pos[B] + 1, 0, 0, n);
                    B = p[c];
                }
                else {
                    res2 += st1.get(pos[B] - (lev[B] - need) + 1, pos[B] + 1, 0, 0, n);
                    res2 %= mod;
                    break;
                }
            }
            else {
                res2 += val1[B]; B = p[B];
                res2 %= mod;
            }
            res2 %= mod;
        }
        return (res1 + res2 * ipw[n - (need + remain - 1)] % mod) % mod;
    }
}


void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i]; --p[i];
        g[i].pb(p[i]);
        g[p[i]].pb(i);
        dp[i][0] = p[i];
    }
    p[0] = -1;
    dp[0][0] = -1;
    for (int j = 1; j < k; ++j) {
        for (int i = 0; i < n; ++i) {
            dp[i][j] = (dp[i][j - 1] == -1 ? -1 : dp[dp[i][j - 1]][j - 1]);
        }
    }
    dfs(0, -1, 0);
    for (int i = 0; i < n; ++i) {
        head[i] = i; dsu_sz[i] = 1;
        component[i].pb(i);
        cin >> l[i] >> r[i];
        ans[i] = r[i] - l[i] + 1;
        ANS *= ans[i]; ANS %= mod;
    }
    // HLD

    dfs_HLD(0, -1);
    dfs1(0, -1);
    for (int i = 0; i < n; ++i) {
        pos[A[i]] = i;
    }
    st.init(n); st1.init(n);
    for (int i = 0; i < n; ++i) {
        val[i] = pw[lev[i]] * (1 + head[i]) % mod;
        val1[i] = pw[n - lev[i]] * (1 + head[i]) % mod;
        st.update(pos[i], val[i], 0, 0, n);
        st1.update(pos[i], val1[i], 0, 0, n);
    }
    // cout << hsh(2, 3, 0, 2) << endl;
    // exit(0);
    // vout(val);
    // return;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        /*
        vector <int> v1 = get_path(a, b), v2 = get_path(c, d);
        for (int i = 0; i < v1.size(); ++i) {
            if (head[v1[i]] != head[v2[i]]) {
                unite(v1[i], v2[i]);
            }
        }
         */
        // with HLD
        int L1 = lca(a, b), L2 = lca(c, d);
        int len = lev[a] + lev[b] - 2 * lev[L1] + 1;
        // cout << len << endl;
        int cnt = 0;
        while (true) {
            ++cnt;
            int left = 0, right = len + 1;
            while (right - left > 1) {
                // debug("dora");
                int mid = (left + right) >> 1; // debug(mid);
                if (hsh(a, b, L1, mid) == hsh(c, d, L2, mid)) {
                    // cout << hsh(a, b, L1, mid) << ' ' <<  hsh(c, d, L2, mid) << endl;
                    left = mid;
                }
                else {
                    right = mid;
                }
            }
            if (cnt >= len + 3) {
                exit(1);
            }
            /*
            for (int i = 0; i < 10; ++i) {
                cout << i << ' ' << head[i] << endl;
            }
             */
            // debug(right);
            // debug(hsh(a, b, L1, right) << ' ' <<  hsh(c, d, L2, right) << endl);
            // cout << right << endl;
            // exit(0);
            if (right == len + 1) {
                break;
            }
            else {
                // debug(right);
                // debug(gt(a, b, L1, right) << ' ' << gt(c, d, L2, right));
                unite(gt(a, b, L1, right), gt(c, d, L2, right));
                // exit(0);
            }
        }
        cout << ANS << endl;
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    pw[0] = 1; ipw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = pw[i - 1] * base % mod;
        ipw[i] = binpow(pw[i], mod - 2);
    }
    int t = 1; // cin >> t;
    while (t--) {
        solve();
    }
}

