#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

const ll MOD = 1e9+7;

ll binpow(ll a, ll b) {
    ll r = 1, p = a;
    for (; b > 0; b >>= 1) {
        if (b & 1) {
            r *= p;
            r %= MOD;
        }
        p *= p;
        p %= MOD;
    }

    return r;
}

ll rev(ll n) {
    return binpow(n, MOD - 2);
}

struct dsu {

    dsu() {}
    dsu(int n) : n(n) {
        p.resize(n);
        sz.resize(n, 1);
        iota(all(p), 0);
    }

    int get(int v) {
        if (p[v] != v) {
            p[v] = get(p[v]);
        }
        return p[v];
    }

    pair<int, int> merge(int a, int b) {
        a = get(a), b = get(b);

        if (a != b) {
            if (sz[a] < sz[b]) swap(a, b);
            sz[a] += sz[b];
            p[b] = a;
        }

        return {a, b};
    }

    int n;
    vector<int> p, sz;

};

int n, m;
vector<vector<int>> g;
vector<int> p, d;
vector<int> l, r;
vector<pair<pair<int, int>, pair<int, int>>> pth;

int lgn;
vector<vector<int>> binups;

void calcd(int v) {
    for (int to : g[v]) {
        if (to == p[v]) continue;
        d[to] = d[v] + 1;
        calcd(to);
    }
}

int lca(int a, int b) {
    if (d[a] > d[b]) swap(a, b);
    for (int l = lgn - 1; l >= 0; l--) {
        if (d[binups[l][b]] >= d[a]) b = binups[l][b];
    }

    if (a == b) return a;
    for (int l = lgn - 1; l >= 0; l--) {
        if (binups[l][a] != binups[l][b]) {
            a = binups[l][a];
            b = binups[l][b];
        }
    }

    return binups[0][a];
}


bool get_path(vector<int>& path, int v, int pr, int u) {
    path.push_back(v);
    if (v == u) return true;
    bool is = false;
    for (int to : g[v]) {
        if (to == pr) continue;
        is = get_path(path, to, v, u) || is;
    }

    if (!is) path.pop_back();
    return is;
}

void solve() {

    d.resize(n);
    calcd(0);

    lgn = __lg(n) + 1;
    binups.resize(lgn, vector<int>(n));
    binups[0] = p;
    for (int l = 1; l < lgn; l++) {
        for (int i = 0; i < n; i++) {
            binups[l][i] = binups[l - 1][binups[l - 1][i]];
        }
    }

    dsu ds(n);
    vector<int> nl = l, nr = r;

    ll ans = 1;
    for (int i = 0; i < n; i++) {
        ans *= (r[i] - l[i] + 1);
        ans %= MOD;
    }

    for (int id = 0; id < m; id++) {
        auto [a, b] = pth[id].first;
        auto [c, d] = pth[id].second;
        vector<int> p1, p2;

        {
            int l = lca(a, b);
            while (a != l) {
                p1.push_back(a);
                a = p[a];
            }
            vector<int> tm;
            while (b != l) {
                tm.push_back(b);
                b = p[b];
            }

            p1.push_back(l);
            reverse(all(tm));
            for (auto x : tm) p1.push_back(x);
        }

        {
            int l = lca(c, d);
            while (c != l) {
                p2.push_back(c);
                c = p[c];
            }
            vector<int> tm;
            while (d != l) {
                tm.push_back(d);
                d = p[d];
            }

            p2.push_back(l);
            reverse(all(tm));
            for (auto x : tm) p2.push_back(x);
        }

        for (int i = 0; i < p1.size(); i++) {
            if (ans == 0) break;

            auto [e, f] = ds.merge(p1[i], p2[i]);
            if (e != f) {
                ans *= rev(nr[e] - nl[e] + 1);
                ans %= MOD;
                ans *= rev(nr[f] - nl[f] + 1);
                ans %= MOD;
                nl[e] = max(nl[e], nl[f]);
                nr[e] = min(nr[e], nr[f]);
                if (nl[e] <= nr[e]) {
                    ans *= (nr[e] - nl[e] + 1);
                    ans %= MOD;
                } else ans = 0;
            }
        }

        cout << ans << "\n";
    }

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    cin >> n;
    p.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i]; p[i]--;
    }

    g.resize(n);
    for (int i = 1; i < n; i++) {
        g[i].push_back(p[i]);
        g[p[i]].push_back(i);
    }

    l.resize(n);
    r.resize(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];

    cin >> m;

    pth.resize(m);
    for (int i = 0; i < m; i++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        pth[i] = {make_pair(a, b), make_pair(c, d)};
    }

    solve();

}