#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
random_device rd;
mt19937 rnd(rd());
ll n, timer = 0;
const ll mod = 1e9 + 7;
vector<ll> tin, tout, L, R, par;
vector<vector<ll>> g, st;

bool is_anc(ll a, ll b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void dfs(int v, int p) {
    tin[v] = timer++;
    st[0][v] = p;
    for (int k = 1; k < 20; k++) {
        st[k][v] = st[k - 1][st[k - 1][v]];
    }

    for (auto &u: g[v]) {
        dfs(u, v);
    }
    tout[v] = timer;
}

ll lca(ll a, ll b) {
    if (is_anc(a, b))
        return a;
    if (is_anc(b, a))
        return b;
    for (ll k = 19; k >= 0; k--) {
        ll pa = st[k][a];
        if (!is_anc(pa, b))
            a = pa;
    }
    return st[0][a];
}

vector<ll> make_path(ll a, ll b) {
    vector<ll> res;
    if (is_anc(a, b)) {
        while(b != a) {
            res.push_back(b);
            b = st[0][b];
        }
        res.push_back(b);
        reverse(all(res));
    }
    else if (is_anc(b, a)) {
        while (a != b) {
            res.push_back(a);
            a = st[0][a];
        }
        res.push_back(a);
    } else {
        ll c = lca(a, b);
        vector<ll> s;
        while (a != c) {
            res.push_back(a);
            a = st[0][a];
        }
        res.push_back(a);
        while (b != c) {
            s.push_back(b);
            b = st[0][b];
        }
        reverse(all(s));
        for(auto &i : s)
            res.push_back(i);
    }
    return res;
}

ll find(ll v) {
    if(v == par[v])
        return v;
    return par[v] = find(par[v]);
}

void unite(ll a, ll b) {
    a = find(a), b = find(b);
    if(a == b)
        return;
    par[b] = a;
}

void solve() {
    cin >> n;
    g.resize(n);
    st.resize(20, vector<ll>(n, 0));
    L.resize(n), R.resize(n);
    tin.resize(n), tout.resize(n);
    par.resize(n);
    for (int i = 1; i < n; i++) {
        ll p;
        cin >> p, p--;
        g[p].push_back(i);
    }
    dfs(0, 0);
    for (int i = 0; i < n; i++) {
        cin >> L[i] >> R[i];
        par[i] = i;
    }
    ll q;
    cin >> q;
    ll res = 1;
    while (q--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<ll> p1 = make_path(a, b), p2 = make_path(c, d);
        for(int i = 0; i < sz(p1); i++) {
            ll new_l = max(L[p1[i]], L[p2[i]]);
            ll new_r = min(R[p1[i]], R[p2[i]]);
            if(new_l > new_r)
                res = 0;
            L[p1[i]] = new_l, L[p2[i]] = new_l;
            R[p1[i]] = new_r, R[p2[i]] = new_r;
            unite(p1[i], p2[i]);
        }
        vector<ll> used(n, 0);
        for(int i = 0; i < n; i++) {
            ll p = find(i);
            if(used[p])
                continue;
            (res *= (R[i] - L[i] + 1)) %= mod;
            used[p] = 1;
        }
        cout << res << '\n';
        if(res)
            res = 1;
    }
}

int main() {
    cin.tie(0), cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll tt = 1;
    while (tt--) {
        solve();
    }
    return 0;
}
