#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;

#define ALL(a) (a).begin(), (a).end()
#define RALL(a) (a).rbegin(), (a).rend()

using i32 = int32_t;
using i64 = int64_t;
using f64 = double;
using f128 = long double;

template <typename K, typename V, typename Cmp = less<K>>
using ordered_map =
    __gnu_pbds::tree<K, V, Cmp, __gnu_pbds::rb_tree_tag,
                     __gnu_pbds::tree_order_statistics_node_update>;

template <typename T, typename Cmp = less<T>>
using ordered_set = ordered_map<T, __gnu_pbds::null_type, Cmp>;

template <typename T1, typename T2>
istream& operator>>(istream& is, pair<T1, T2>& p) {
  return is >> p.first >> p.second;
}
template <typename T1, typename T2>
ostream& operator<<(ostream& os, const pair<T1, T2>& p) {
  return os << p.first << " " << p.second;
}
template <typename T>
istream& operator>>(istream& is, vector<T>& v) {
  for (T& e : v) is >> e;
  return is;
}
template <typename T>
ostream& operator<<(ostream& os, const vector<T>& v) {
  for (const T& e : v) os << e << " ";
  return os;
}

template <typename T>
void chmax(T& a, const T& b) {
  if (a < b) a = b;
}
template <typename T>
void chmin(T& a, const T& b) {
  if (a > b) a = b;
}

void solve();

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}

constexpr i64 kMod = 1e9 + 7;

i64 mpow(i64 a, i64 p) {
  i64 r = 1;
  while (p > 0) {
    if (p & 1) r = r * a % kMod;
    a = (a * a) % kMod;
    p /= 2;
  }
  return r;
}
i64 mdiv(i64 a, i64 b) {
  return a * mpow(b, kMod - 2) % kMod;
}

struct dsu {
  vector<i32> p, w;

  explicit dsu(i32 n) {
    p.resize(n);
    iota(ALL(p), 0);
    w.resize(n, 1);
  }

  i32 find_set(i32 a) {
    if (a == p[a]) return a;
    return p[a] = find_set(p[a]);
  }
  i32 merge_sets(i32 a, i32 b) {
    if (w[a] < w[b]) swap(a, b);
    w[a] += w[b];
    p[b] = a;
    return a;
  }
};

void solve() {
  i32 n;
  cin >> n;
  vector<i32> p(n - 1);
  cin >> p;
  p.insert(p.begin(), 1);
  for (auto& e : p) --e;
  vector<vector<i32>> g(n);
  for (int i = 1; i < n; ++i) {
    g[p[i]].push_back(i);
  }
  vector<i32> d(n);
  auto dfs1 = [&](i32 u, i32 _d, auto&& dfs1) -> void {
    d[u] = _d;
    for (i32 v : g[u]) {
      dfs1(v, _d + 1, dfs1);
    }
  };
  dfs1(0, 0, dfs1);

  vector<pair<i64, i64>> price(n);
  cin >> price;
  i32 m;
  cin >> m;
  i64 ans = 1;
  for (int i = 0; i < n; ++i) {
    if (price[i].second < price[i].first) ans = 0;
    ans *= price[i].second - price[i].first + 1;
    ans %= kMod;
  }
  auto trace_path = [&](i32 u, i32 v) -> vector<i32> {
    vector<i32> pu, pv;
    while (d[u] > d[v]) { pu.push_back(u); u = p[u]; }
    while (d[v] > d[u]) { pv.push_back(v); v = p[v]; }
    while (u != v) {
      pu.push_back(u);
      pv.push_back(v);
      u = p[u], v = p[v];
    }
    pu.push_back(u);
    reverse(ALL(pv));
    pu.insert(pu.end(), ALL(pv));
    return pu;
  };
  dsu dsu(n);
  for (int i = 0; i < m; ++i) {
    i32 u1, v1, u2, v2;
    cin >> u1 >> v1 >> u2 >> v2;
    if (ans == 0) {
      cout << "0\n";
      continue;
    }
    --u1, --v1, --u2, --v2;
    auto r1 = trace_path(u1, v1), r2 = trace_path(u2, v2);
    for (int j = 0; j < ssize(r1); ++j) {
      i32 u = dsu.find_set(r1[j]), v = dsu.find_set(r2[j]);
      if (u == v) continue;
      i64 l = max(price[u].first, price[v].first), r = min(price[u].second, price[v].second);
      ans = mdiv(ans, price[u].second - price[u].first + 1);
      ans = mdiv(ans, price[v].second - price[v].first + 1);
      i32 s = dsu.merge_sets(u, v);
      price[s] = {l, r};
      if (r < l) ans = 0;
      ans *= r - l + 1;
    }
    cout << ans << "\n";
  }
}
