#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
const int MOD = 1e9 + 7;
vector<int> head, prew, lvl;
vector<vector<int>> gr;
vector<int> sz;

vector<int> sq;
vector<int> len;
vector<int> L_d, R_d;
int dad(int v){
    if (sq[v] == v) return v;
    sq[v] = dad(sq[v]);
    return sq[v];
}
void merge(int v, int u){
    v = dad(v);
    u = dad(u);
    if (v == u) return;
    if (len[v] < len[u]) swap(v, u);
    sq[u] = v;
    if (len[v] == len[u]) len[v]++;
    R_d[v] = min(R_d[v], R_d[u]);
    L_d[v] = max(L_d[v], L_d[u]);
}

int rev(int a, int p = MOD - 2){
    if (p == 1) return a;
    if (p == 0) return 1;
    int out = rev(a, p/2);
    out = out * out % MOD;
    if (p % 2) out = out * a % MOD;
    return out;
}

int dfs(int v){
    int cnt = 1; for (int u : gr[v]) cnt += dfs(u);
    sz[v] = cnt;
    return cnt;
}

bool comp(int v, int u){
    return sz[v] > sz[u];
}

void build(int v, int p_s, int levl = 0){
    if (p_s == -1) p_s = v;
    head[v] = p_s;
    bool fl = 0;
    lvl[v] = levl;
    sort(gr[v].begin(), gr[v].end(), comp);
    for (int u : gr[v]){
        if (!fl) build(u, p_s, levl + 1);
        else build(u, -1, levl + 1);
        fl = 1;
    }
}

int lca(int v, int u){
    while (head[v] != head[u]){
        if (lvl[head[v]] > lvl[head[u]]) swap(v, u);
        u = prew[head[u]];
    }
    if (lvl[u] < lvl[v]) swap(u, v);
    return v;
}

vector<int> used;
int n;

int pr(){
    int X = 1;
    used.assign(n + 1, 0);
    for (int i = 1; i <= n; i++){
        int d = dad(i);
        if (!used[d]){
            used[d] = 1;
            X = X * max((int)0, R_d[d] - L_d[d] + 1) % MOD;
        }
    } return X;
}

void main0(){
    cin >> n;
    len.resize(n + 1, 1);
    sq.resize(n + 1); for (int i = 0; i <= n; i++) sq[i] = i;
    head.resize(n + 1);
    lvl.resize(n + 1);
    prew.resize(n + 1);
    gr.resize(n + 1);
    sz.resize(n + 1);
    L_d.resize(n + 1);
    R_d.resize(n + 1);
    for (int i = 2; i <= n; i++) {
        cin >> prew[i];
        gr[prew[i]].push_back(i);
    }
    dfs(1);
    build(1, -1);
    for (int i = 1; i <= n; i++){
        cin >> L_d[i] >> R_d[i];
    }
    int m; cin >> m;
    vector<int> to1, to2, w1, w2;
    while (m--){
        to1.clear();
        to2.clear();
        w1.clear();
        w2.clear();
        int a, b, c, d; cin >> a >> b >> c >> d;
        int e = lca(a, b);
        int f = lca(c, d);
        while (a != e) {
            //cout << 1;
            to1.push_back(a); a = prew[a];
        } while (c != f) {
            //cout << 2;
            to2.push_back(c); c = prew[c];
        } to1.push_back(e); to2.push_back(f);
        while (b != e) {
            //cout << 3;
            w1.push_back(b); b = prew[b];
        } while (d != f) {
            //cout << 4;
            w2.push_back(d); d = prew[d];
        }
        //cout << a << ' ' << b << ' ' << e << ';' << c << ' ' << d << ' ' << f << '\n';
        reverse(w1.begin(), w1.end());
        reverse(w2.begin(), w2.end());
        for (int i : w1) to1.push_back(i);
        for (int i : w2) to2.push_back(i);
        for (int i = 0; i < to1.size(); i++){
            merge(to1[i], to2[i]);
        }
        cout << pr() << '\n';
    }
}

signed main() {
    speed();
    cout << fixed << setprecision(10);
    int t = 1;
    while (t--){
        main0();
        cout << '\n';
    }
}
