#include <bits/stdc++.h>
#include <bits/extc++.h>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;



#define int long long
const int N = 2e5 + 7;
const int K = 20;
const int M = 1e9 + 7;

vector<int> gr[N];

int tin[N];
int tout[N];
int hs[N];
int up[N][K];

int timer = 1;

void dfs(int u, int pr, int h) {
    tin[u] = timer;
    timer++;
    hs[u] = h;
    up[u][0] = pr;
    for (int i = 1; i < K; ++i) {
        up[u][i] = up[up[u][i - 1]][i - 1];
    }
    for (auto c: gr[u]) {
        dfs(c, u, h + 1);
    }
    tout[u] = timer;
}

bool is_pr(int u, int v) {
    return tin[u] <= tin[v] and tout[v] <= tout[u];
}


int prd[N];
int pr[N];

pair<int, int> vec[N];

int bin_pow(int a, int p) {
    if (p == 0) return 1;
    if (p % 2) {
        return bin_pow(a, p - 1) * a % M;
    }
    int c = bin_pow(a, p / 2);
    return c * c % M;
}

int path1[N];
int path2[N];
int ans = 1;
vector<int> childs[N];

void unite(int u, int v) {
    u = prd[u], v = prd[v];
    if (u == v) return;
    int maxl = max(vec[u].first, vec[v].first), minr = min(vec[u].second, vec[v].second);
    ans *= bin_pow(vec[u].second - vec[u].first + 1, M - 2);
    ans %= M;
    ans *= bin_pow(vec[v].second - vec[v].first + 1, M - 2);
    ans %= M;
    if (childs[u].size() < childs[v].size()) {
        swap(u, v);
    }
    for (auto c: childs[v]) {
        prd[c] = u;
        childs[u].push_back(c);
    }
    vec[u] = {maxl, minr};
    if (maxl > minr) {
        ans = 0;
    }
    ans *= minr - maxl + 1;
    ans %= M;
}

int get_lca(int u, int v) {
    if (is_pr(u, v)) return u;
    if (is_pr(v, u)) return v;
    for (int i = K - 1; i >= 0; --i) {
        if (!is_pr(up[u][i], v)) {
            u = up[u][i];
        }
    }
    return up[u][0];
}

int a, b, c, d;

bool check(int mid) {
    for (int i = 0; i <= mid; ++i) {
        if (prd[path1[i]] != prd[path2[i]]) return true;
    }
    return false;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        childs[i].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        prd[i] = i;
        int a1;
        cin >> a1;
        a1--;
        pr[i] = a1;
        gr[a1].push_back(i);
    }
    dfs(0, 0, 0);

    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first >> vec[i].second;
        ans *= vec[i].second - vec[i].first + 1;
        ans %= M;
    }
//    cout << ans << endl;
    int m;
    cin >> m;
    for (int j = 0; j < m; ++j) {

        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        int len = hs[a] + hs[b] - 2 * hs[get_lca(a, b)] + 1;
//        cout << a << " " << b << " " << get_lca(a, b) << endl;
        int uk = 0;
        while (!is_pr(a, b)) {
            path1[uk] = a;
            uk++;
            a = pr[a];
        }
        path1[uk] = a;
        uk++;
        int dt = hs[b] - hs[a];
        while (dt > 0) {
            dt--;
            path1[uk + dt] = b;
            b = pr[b];

        }

        uk = 0;

        while (!is_pr(c, d)) {
            path2[uk] = c;
            uk++;
            c = pr[c];
        }
        path2[uk] = c;
        uk++;
        dt = hs[d] - hs[c];
        while (dt > 0) {
            dt--;
            path2[dt + uk] = d;
            d = pr[d];

        }
        while (true) {
            int l = -1, r = len;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (check(mid)) {
                    r = mid;
                } else {
                    l = mid;
                }
            }
            if (r == len) break;

            unite(path1[r], path2[r]);
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
