#include <bits/stdc++.h>

#define int long long
#define double long double

using namespace std;

int ans = 1, timer = 0;
const int MOD = 1e9 + 7, MAX_N = 2e5;

vector<int> weight(2e5, 1), p(2e5, -1), tin(2e5), tout(2e5);
vector<pair<int, int>> mi(2e5);

pair<int, int> gcd_ex(int a, int b, int c) {
    //ax + by + c = 0
    if (a == 0) {
        return {0, -c * 1.0 / b};
    }
    auto [y0, x0] = gcd_ex(b % a, a, c);
    double x = -x0, y = (a * x + c) / b;
    return {x, -y};
}

int gcd(int a, int b) {
    if (a == 0) {
        return b;
    }
    return gcd(b % a, a);
}

int get_obr(int n) {
    int a = -MOD, b = n, c = 1;
    auto p = gcd_ex(a, b, c);
    return p.second;
}

int get_p(int v) {
    if (p[v] == v) {
        return v;
    }
    p[v] = get_p(p[v]);
    return p[v];
}

void merge(int a, int b) {
    a = get_p(a), b = get_p(b);
    if (a == b) {
        return;
    }
    if (weight[a] < weight[b]) {
        swap(a, b);
    }
    ans *= get_obr(mi[a].second - mi[a].first + 1), ans %= MOD;
    ans *= get_obr(mi[b].second - mi[b].first + 1), ans %= MOD;
    mi[a].first = max(mi[a].first, mi[b].first);
    mi[a].second = min(mi[a].second, mi[b].second);
    ans *= (mi[a].second - mi[a].first + 1);
    ans %= MOD;
    weight[a] += weight[b], p[b] = a;
}

void get_tin(int v, vector<vector<int>> &children) {
    tin[v] = timer++;
    for (int u : children[v]) {
        get_tin(u, children);
    }
    tout[v] = timer++;
}

bool is_up(int a, int b) {
    if (tin[a] <= tin[b] && tout [a] >= tout[b]) {
        return true;
    }
    return false;
}

void dfs(int a, int b, int c, int d, vector<long long> &parent) {
    vector<int> a_one, a_two, c_one, c_two;
    while (!false) {
        a_one.push_back(a);
        if (is_up(a, b)) {
            break;
        }
        a = parent[a];
    }
    while (!is_up(b, a)) {
        a_two.push_back(b);
        b = parent[b];
    }
    reverse(a_two.begin(), a_two.end());
    while (!false) {
        c_one.push_back(c);
        if (is_up(c, d)) {
            break;
        }
        c = parent[c];
    }
    while (!is_up(d, c)) {
        c_two.push_back(d);
        d = parent[d];
    }
    reverse(c_two.begin(), c_two.end());
    for (int u : a_two) {
        a_one.push_back(u);
    }
    for (int u : c_two) {
        c_one.push_back(u);
    }
    if (c_one.size() != a_one.size()) {
        vector<int> error(1e9);
    }
    for (int i = 0; i < c_one.size(); i++) {
        merge(a_one[i], c_one[i]);
    }
}

signed main() {
    ifstream cin("text.in");
    ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    mt19937_64 gen(time(nullptr));
    long long n, i, a, b, c, d, m;
    cin >> n;
    vector<long long> parent(n, -1), l(n), r(n);
    vector<vector<int>> children(n);
    for (i = 1; i < n; i++) {
        cin >> parent[i];
        parent[i]--;
        children[parent[i]].push_back(i);
    }
    get_tin(0, children);
    for (i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        mi[i] = {l[i], r[i]}, p[i] = i;
        ans *= (r[i] - l[i] + 1), ans %= MOD;
    }
    cin >> m;
    while (m--) {
        cin >> a >> b >> c >> d;
        dfs(a - 1, b - 1, c - 1, d - 1, parent);
        cout << ((long long)(ans % MOD)) << '\n';
    }
    return 0;
}