#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <deque>
#include <chrono>
#include <random>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <string>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define int long long
ll inf = 1e9 + 7;
ll inf_ = 1e18 + 4;
const int mod = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());


vector<vector<int>> g;
vector<pair<int, int>> s;
vector<vector<int>> dp;
vector<int> lg;
vector<bool> used;
vector<pair<int, int>> t;
int ti = 0;

void dfs(int v) {
    used[v] = 1;
    t[v].first = ti++;
    for (auto u: g[v]) {
        if (!used[u]) {
            dp[0][u] = v;
            dfs(u);
        }
    }
    t[v].second = ti++;
}

bool Parent(int u, int v) { return t[u].first <= t[v].first && t[v].second <= t[u].second; }

int n;

int lca(int u, int v) {
    if (Parent(u, v)) return u;
    if (Parent(v, u)) return v;
    for (int l = lg[n] + 1; l >= 0; l--) {
        if (!Parent(dp[l][u], v)) {
            u = dp[l][u];
        }
    }
    return dp[0][u];
}

vector<int> p, r;
vector<pair<int, int>> ob;

int find(int a) {
    while (p[a] != a) a = p[a];
    return a;
}

multiset<pair<int, int>> st;

void update(int a, int b) {
    a = find(a);
    b = find(b);
    if (r[a] < r[b]) swap(a, b);
    if (r[a] == r[b]) r[a]++;
    p[b] = a;
    st.erase(st.find(ob[a]));
    st.erase(st.find(ob[b]));
    ob[a] = {max(ob[a].first, ob[b].first), min(ob[a].second, ob[b].second)};
    st.insert(ob[a]);
}

signed main() {
    //freopen("collider.in", "r", stdin);
    //freopen("collider.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    t.resize(n);
    g.resize(n);
    used.resize(n);
    lg.resize(n + 4);
    for (int i = 2; i <= n + 2; i++) lg[i] = lg[i / 2] + 1;
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        g[x].push_back(i);
        g[i].push_back(x);
    }
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        s.push_back({x, y});
    }
    ob = s;
    dp.resize(lg[n + 1] + 2, vector<int>(n));
    dfs(0);
    for (int l = 0; l < lg[n + 1]; l++) {
        for (int i = 0; i < n; i++) {
            dp[l + 1][i] = dp[l][dp[l][i]];
        }
    }
    int q;
    cin >> q;
    r.resize(n);
    p.resize(n);
    iota(p.begin(), p.end(), 0);
    for (auto i: ob) st.insert(i);
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        int e = lca(a, b);
        int f = lca(c, d);
        vector<int> t1(1, a), t2(1, b);
        if (a != e) {
            while (dp[0][a] != e) {
                a = dp[0][a];
                t1.push_back(a);
            }
            t1.push_back(e);
        }
        if (b != e) {
            while (b != e && dp[0][b] != e) {
                b = dp[0][b];
                t2.push_back(b);
            }
        }
        for (int j = t2.size() - 1; j >= 0; j--) t1.push_back(t2[j]);
        auto ab = t1;
        t1.assign(1, c);
        t2.assign(1, d);
        e = f;
        a = c;
        b = d;
        if (a != e) {
            while (dp[0][a] != e) {
                a = dp[0][a];
                t1.push_back(a);
            }
            t1.push_back(e);
        }
        if (b != e) {
            while (b != e && dp[0][b] != e) {
                b = dp[0][b];
                t2.push_back(b);
            }
        }
        for (int j = t2.size() - 1; j >= 0; j--) t1.push_back(t2[j]);
        auto cd = t1;
        for (int i = 0; i < ab.size(); i++) {
            if (find(ab[i]) != find(cd[i])) update(ab[i], cd[i]);
        }
        int ans = 1;
        for (auto i: st) {
            ans *= (i.second - i.first + 1 > 0 ? (i.second - i.first + 1) : 0);
            ans %= mod;
        }
        cout << ans << '\n';
    }
    return 0;
}