#include<bits/stdc++.h>
#define endl '\n'
#define fr first
#define sc second
using namespace std;

const int MAXN=2e5+5;
const int MAXLOG=20;
const int MOD=1e9+7;

int n,m;
int par[MAXN][MAXLOG+2];
pair<int,int> rng[MAXN];
vector<int> adj[MAXN];
int depth[MAXN];
int root[MAXN];
int sz[MAXN];
set<int> rts;

void dfs(int v,int d)
{
    depth[v]=d;
    for(int i=0;i<adj[v].size();i++)
    {
        dfs(adj[v][i],d+1);
    }
}

void precomp_lca()
{
    for(int i=1;(1<<i)<=n;i++)
    {
        for(int j=2;j<=n;j++)
        {
            par[j][i]=par[par[j][i-1]][i-1];
            //cout<<par[j][i]<<" ";
        }//cout<<endl;
    }
}

int find_lca(int u,int v)
{
    if(u==v) return u;
    if(depth[u]>depth[v]) swap(u,v);
    int diff=depth[v]-depth[u];
    for(int i=MAXLOG;i>=0;i--)
    {
        if((1<<i)>diff) continue;
        v=par[v][i];
        diff-=(1<<i);
    }
    if(u==v) return u;
    //cout<<u<<v<<endl;
    for(int i=MAXLOG;i>=0;i--)
    {
        if(par[u][i]==par[v][i]) continue;//cout<<i<<" "<<par[u][i]<<" "<<par[v][i]<<endl;
        u=par[u][i];
        v=par[v][i];
    }
    return par[u][0];
}

pair<int,int> _merge(pair<int,int> r1,pair<int,int> r2)
{
    if(r1.sc<r2.fr) return {0,0};
    if(r1.fr>r2.sc) return {0,0};
    return {max(r1.fr,r2.fr), min(r1.sc,r2.sc)};
}

int get_root(int v)
{
    int x=v;
    while(x!=root[x]) x=root[x];
    return root[v]=x;
}

void join(int u,int v)
{
    u=get_root(u);
    v=get_root(v);
    if(u==v) return;
    if(sz[u]>sz[v])
    {
        root[v]=u;
        sz[u]+=sz[v];
        rts.erase(v);
        rng[u]=_merge(rng[u],rng[v]);
    }
    else
    {
        root[u]=v;
        sz[v]+=sz[u];
        rts.erase(u);
        rng[v]=_merge(rng[u],rng[v]);
    }
    return;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;
for(int i=2;i<=n;i++)
{
    cin>>par[i][0];
    adj[par[i][0]].push_back(i);
}
for(int i=1;i<=n;i++)
{
    cin>>rng[i].fr>>rng[i].sc;
}

dfs(1,1);
precomp_lca();
for(int i=1;i<=n;i++)
{
    root[i]=i;
    rts.insert(i);
    sz[i]=1;
}

cin>>m;
vector<int> tmp;
stack<int> st;
for(int i=0;i<m;i++)
{
    int a,b,c,d;
    cin>>a>>b>>c>>d;
    int x=find_lca(a,b);//cout<<x<<endl;
    while(a!=x)
    {
        tmp.push_back(a);
        a=par[a][0];
    }
    tmp.push_back(x);
    while(b!=x)
    {
        st.push(b);
        b=par[b][0];
    }
    while(!st.empty())
    {
        tmp.push_back(st.top());
        st.pop();
    }

    int j=0;
    x=find_lca(c,d);//cout<<x<<endl;
    while(c!=x)
    {
        join(c,tmp[j++]);
        c=par[c][0];
    }
    join(x,tmp[j++]);
    while(d!=x)
    {
        st.push(d);
        d=par[d][0];
    }
    while(!st.empty())
    {
        join(st.top(),tmp[j++]);
        st.pop();
    }
    tmp.clear();

    int ans=1;
    for(auto it=rts.begin();it!=rts.end();it++)
    {
        if(rng[(*it)].fr==0)
        {//cout<<(*it)<<endl;
            for(;i<m;i++)
            {
                cout<<0<<endl;
            }
            return 0;
        }
        ans=(long long) ans*(rng[(*it)].sc-rng[(*it)].fr+1)%MOD;
    }
    cout<<ans<<endl;
}

return 0;
}
