/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const ll mod = 1e9 + 7;
const int maxn = 4e5 + 10, maxlog = 21;

ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2 == 1)
            ans = (ans * base) % mod;
        base = (base * base) % mod;
        st /= 2;
    }
    return ans;
}

int n, p[maxn], par_idx[maxn];
ll l[maxn], r[maxn];
vector < int > child[maxn];

void input()
{
    cin >> n;
    for (int i = 2; i <= n; i ++)
    {
        cin >> p[i];
        par_idx[i] = child[p[i]].size();
        child[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i ++)
        cin >> l[i] >> r[i];
}

int f[2 * maxn], tin[maxn], tout[maxn], timer;
int depth[maxn];

void dfs(int v)
{
    f[++ timer] = v;
    tin[v] = timer;
    for (int u : child[v])
    {
        depth[u] = depth[v] + 1;
        dfs(u);
        f[++ timer] = v;
    }
    tout[v] = timer;
}

int dp[maxlog][maxn * 2], lg[maxn * 2];
void build_sparse_table()
{
    for (int i = 1; i <= timer; i ++)
    {
        dp[0][i] = f[i];
        lg[i] = lg[i / 2] + 1;
    }

    for (int j = 1; j < lg[timer]; j ++)
    {
        for (int i = 1; i <= timer - (1 << j) + 1; i ++)
        {
            dp[j][i] = dp[j - 1][i];
            if (depth[dp[j - 1][i + (1 << (j - 1))]] < depth[dp[j][i]])
                dp[j][i] = dp[j - 1][i + (1 << (j - 1))];
        }
    }

}

int lca_visit[maxn];
int get_lca(int v, int u)
{
    int sv = v;
    while(v != 1)
    {
        lca_visit[v] = 1;
        v = p[v];

    }
    lca_visit[v] = 1;
    int lca = u;
    while(!lca_visit[lca])
        lca = p[lca];
    while(sv != 1)
    {
        lca_visit[sv] = 0;
        sv = p[sv];

    }
    lca_visit[sv] = 0;
    return lca;

    int left = tin[v], right = tin[u];
    if (left > right)
        swap(left, right);
    int len = lg[right - left + 1] - 1;
    int ans = dp[len][left];
    if (depth[dp[len][right - (1 << len) + 1]] < depth[ans])
        ans = dp[len][right - (1 << len) + 1];
    return ans;
}

ll all_ways, inv[maxn];
void get_math()
{
    all_ways = 1;
    for (int i = 1; i <= n; i ++)
    {
        all_ways = (all_ways * (ll)(r[i] - l[i] + 1)) % mod;
        inv[i] = power(r[i] - l[i] + 1, mod - 2);
    }
}

int q;
int path[2][maxn], used[maxn];
ll up[maxn], down[maxn];
int lead[maxn];
int find_leader(int v)
{
    if (lead[v] == v)
        return v;
    return (lead[v] = find_leader(lead[v]));
}

void  unite(int v, int u)
{
    v = find_leader(v);
    u = find_leader(u);
    if (v == u)
        return;

    if (rand() % 2)
        swap(v, u);
    lead[u] = v;
    up[v] = min(up[u], up[v]);
    down[v] = max(down[u], down[v]);
}
int get_path(int a, int b, int t)
{
    int lca = get_lca(a, b), len = depth[a] + depth[b] - 2 * depth[lca] + 1;
    int front_index = 1, back_index = len;
    while(a != lca)
    {
        path[t][front_index ++] = a;
        ///used[a] = 1;
        a = p[a];
    }
    path[t][front_index ++] = a;
    ///used[a] = 1;

    while(b != lca)
    {
        path[t][back_index --] = b;
        ///used[b] = 1;
        b = p[b];
    }

    return len;
}

void solve_queries()
{
    cin >> q;
    for (int i = 1; i <= n; i ++)
    {
        lead[i] = i;
        up[i] = r[i];
        down[i] = l[i];
    }
    for (int i = 1; i <= q; i ++)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        int sz = get_path(a, b, 0);
        get_path(c, d, 1);
        ll ans = 1;

        for (int j = 1; j <= sz; j ++)
        {
            unite(path[0][j], path[1][j]);

        }

        for (int j = 1; j <= n; j ++)
            used[j] = 0;
        for (int j = 1; j <= n; j ++)
        {
            int v = find_leader(j);
            if (used[v])
                continue;
            ///cout << v << " " << up[v] << " " << down[v] << endl;
            used[v] = 1;
            ans = (ans * (up[v] - down[v] + 1)) % mod;
        }

        cout << ans << endl;
    }
}
void solve()
{
    input();
    dfs(1);
    build_sparse_table();
    get_math();
    solve_queries();
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
3 4 3 5
*/
