#include<bits/stdc++.h>
using namespace std;

long long const MAXN=3001;
long long n, par[MAXN], m, used[MAXN], mod = 1e9+7, lvl[MAXN], p[MAXN];
vector<long long> v[MAXN], a1, b1, c1, d1;

struct edge
{
    long long l, r;
};

edge ver[MAXN], d[MAXN];

void DFS(long long i, long long par)
{
    lvl[i] = lvl[par]+1;
    p[i] = par;
    long long sz = v[i].size();
    for(long long j=0;j<sz;j++)
    {
        long long nb = v[i][j];
        if(!lvl[nb])
        {
            DFS(nb, i);
        }
    }
}

void fill_array()
{
    for(long long i=1;i<=MAXN;i++)
    {
        par[i] = i;
        d[i] = ver[i];
    }
}

long long find_leader(long long x)
{
    if(par[x] == x) return x;
    else return par[x] = find_leader(par[x]);
}

void DSU(long long x, long long y)
{
    x = find_leader(x);
    y = find_leader(y);
    if(x == y) return;
    d[x].l = max(d[x].l, d[y].l);
    d[y].l = d[x].l;
    d[x].r = min(d[x].r, d[y].r);
    d[y].r = d[x].r;
    par[y] = x;
}

void path(int a, int b, int c, int e)
{
    a1.clear();
    b1.clear();
    c1.clear();
    d1.clear();
    b1.push_back(b);
    a1.push_back(a);
    while(lvl[a] < lvl[b])
    {
        b = p[b];
        b1.push_back(b);
    }
    while(lvl[a] > lvl[b])
    {
        a = p[a];
        a1.push_back(a);
    }
    while(a != b)
    {
        a = p[a];
        b = p[b];
        a1.push_back(a);
        b1.push_back(b);
    }
    b1.pop_back();
    for(int i=b1.size()-1;i>=0;i--)
    {
        a1.push_back(b1[i]);
    }

    d1.push_back(e);
    c1.push_back(c);
    while(lvl[c] < lvl[e])
    {
        e = p[e];
        d1.push_back(e);
    }
    while(lvl[c] > lvl[e])
    {
        c = p[c];
        c1.push_back(c);
    }
    while(c != e)
    {
        c = p[c];
        e = p[e];
        c1.push_back(c);
        d1.push_back(e);
    }
    d1.pop_back();
    for(int i=d1.size()-1;i>=0;i--)
    {
        c1.push_back(d1[i]);
    }
}

void read()
{
    long long lf, rf, a, b, c, e;
    long long ans = 1, x;
    cin>>n;
    for(long long i=2;i<=n;i++)
    {
        cin>>x;
        v[x].push_back(i);
        v[i].push_back(x);
    }
    DFS(1, 0);
    for(long long i=1;i<=n;i++)
    {
        cin>>lf>>rf;
        ver[i] = {lf,rf};
    }
    fill_array();
    cin>>m;
    for(long long i=1;i<=m;i++)
    {
        ans = 1;
        cin>>a>>b>>c>>e;
        path(a, b, c, e);
        for(int j=0;j<a1.size();j++)
        {
            //cout<<c1[j]<<" ";
            DSU(a1[j], c1[j]);

        }
        //cout<<endl;
        for(long long j=1;j<=n;j++)
        {
            x = find_leader(j);
            if(x == j)
            {
                if(d[x].r - d[x].l < 0)
                {
                    ans = 0;
                    break;
                }
                ans *= (d[x].r - d[x].l + 1);
                ans %= mod;
            }
        }
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}

/*
8
1 2 3 4 5 6 7
3 7
2 6
3 8
5 10
5 8
2 9
6 8
3 8
4
1 3 8 6
4 1 5 8
1 8 8 1
1 7 2 8
*/
