#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

vll pred, depth;
vector<vll> bin_up, tree;

void calc(ll n){
    ll log_n = 0;
    while ((1 << log_n) <= n){
        log_n++;
    }
    bin_up.resize(log_n, vll(n));
    F0R(i, n){
        bin_up[0][i] = pred[i];
    }
    FOR(i, 1, log_n){
        F0R(j, n){
            bin_up[i][j] = bin_up[i - 1][bin_up[i - 1][j]];
        }
    }
}

void dfs(ll v, ll p = -1, ll d = 0){
    depth[v] = d;
    F0R(i, sz(tree[v])){
        ll u = tree[v][i];
        if (u == p){
            continue;
        }
        dfs(u, v, d + 1);
    }
}

ll lca(ll a, ll b){
    if (depth[a] > depth[b]){
        swap(a, b);
    }
    R0F(i, sz(bin_up)){
        while(depth[bin_up[i][b]] > depth[a]){
            b = bin_up[i][b];
        }
    }
    if (a == b){
        return a;
    }
    b = pred[b];
    if (a == b){
        return a;
    }
    R0F(i, sz(bin_up)){
        while(bin_up[i][b] != bin_up[i][a]){
            b = bin_up[i][b];
            a = bin_up[i][a];
        }
    }
    return pred[a];
}

vll dsu;
vll dist;

ll get(ll v){
    if (dsu[v] == -1){
        return v;
    }
    dsu[v] = get(dsu[v]);
    return dsu[v];
}

void merge(ll v, ll u){
    v = get(v);
    u = get(u);
    if (v == u){
        return;
    }
    if (dist[v] > dist[u]){
        swap(v, u);
    }
    dist[u] += dist[v];
    dsu[v] = u;
}

void solve(){
    ll n;
    cin >> n;
    pred.resize(n);
    depth.resize(n);
    tree.resize(n);
    F0R(i, n - 1){
        ll u;
        cin >> u;
        u--;
        pred[i + 1] = u;
        tree[i + 1].pub(u);
        tree[u].pub(i + 1);
    }
    calc(n);
    dfs(0);
    vpl cost(n);
    F0R(i, n){
        ll l, r;
        cin >> l >> r;
        cost[i] = {l, r};
    }
    ll m;
    cin >> m;
    dsu.resize(n, -1);
    dist.resize(n, 1);
    F0R(i, m){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        ll v = lca(a, b);
        ll u = lca(c, d);
        vll x, y;
        while(a != v){
            x.pub(a);
            a = pred[a];
        }
        x.pub(v);
        while(b != v){
            y.pub(b);
            b = pred[b];
        }
        R0F(j, sz(y)){
            x.pub(y[j]);
        }
        vll m1 = x;
        x.clear(); y.clear();
        while(c != u){
            x.pub(c);
            c = pred[c];
        }
        x.pub(u);
        while(d != u){
            y.pub(d);
            d = pred[d];
        }
        R0F(j, sz(y)){
            x.pub(y[j]);
        }
        vll m2 = x;
        F0R(j, sz(m1)){
            ll l1 = cost[m1[j]].first, l2 = cost[m2[j]].first;
            ll r1 = cost[m1[j]].second, r2 = cost[m2[j]].second;
            ll l = max(l1, l2);
            ll r = min(r1, r2);
            merge(m1[j], m2[j]);
            v = get(m1[j]);
            cost[v].first = max(cost[v].first, l);
            cost[v].second = min(cost[v].second, r);
        }
        ll ans = 1;
        F0R(j, n){
            if (dsu[j] != -1){
                continue;
            }
            if (cost[j].second < cost[j].first){
                ans = 0;
                break;
            }
            ans *= cost[j].second - cost[j].first + 1;
        }
        cout << ans << '\n';
    }
}

int main() {
    fastio;
    int t = 0; //cin >> t;
    F0R(i, t)
        return 0;{
        solve();
    }
}