#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <queue>
#include <set>
#include <map>
#include <unordered_map>
#include <deque>
#include <string>
#include <random>
#include <chrono>
#include <iomanip>
#include <utility>

#pragma GCC optimize("Ofast, unroll-loops");
#pragma GCC target("avx2");

#define v std::vector
#define all(a) (a).begin(), (a).end()

using ll = long long;
using ld = double;
using pll = std::pair<ll, ll>;
using str = std::string;

const ll Max = 1e17, Min = -1e17;
const ld Pi = std::acos(-1);
const ld eps = 1e-12;
const ll Mod = 1e9 + 7;
const ll lg = 20;

std::mt19937 rnd(42);

void solve() {
	ll n, k;
	std::cin >> n >> k;
	v<ll> list(n);
	for (int i = 0; i < n; ++i) {
		std::cin >> list[i];
	}
	ll mul = 1;
	for (auto i : list) {
		mul *= i;
	}
	ld ans = 0;
	if (n == 1) {
		ans = list[0] / k;
		std::cout << ans * ((ld)k / mul);
	}
	else if (n == 2) {
		for (int a = 1; a <= list[0]; ++a) {
			ll b = (k + a - 1) / a;
			if (b <= list[1]) {
				ans = std::max(ans, (ld)(list[0] / a) * (list[1] / b));
			}
		}
		std::cout << ans * ((ld)k / mul);
	}
	else {
		v<v<ld>> dp(n + 1, v<ld>(k, 0));
		dp[0][1] = 1;
		for (int i = 0; i < n; ++i) {
			for (ll j = 1; j < k; ++j) {
				if (dp[i][j] == 0) continue;
				if (dp[i][j] > dp[i + 1][j]) {
					dp[i + 1][j] = dp[i][j];
				}
				for (ll d = 1; d <= list[i]; ++d) {
					ld tmp = (dp[i][j] / list[i]) * (list[i] / d);
					if (d * j < k) {
						if (tmp > dp[i + 1][d * j]) {
							dp[i + 1][d * j] = tmp;
						}
					}
					else {
						if (tmp > ans) {
							ans = tmp;
						}
						break;
					}
				}
			}
		}
		std::cout << ans * k;
	}
}

int main() {
	std::ios::sync_with_stdio(0);
	std::cin.tie(0);
	std::cout.tie(0);
	std::cout << std::fixed << std::setprecision(15);
	ll t = 1;
	// std::cin >> t;
	while (t--) {
		solve();
	}
}