#include <bits/stdc++.h>
using namespace std;
const long double eps = 1e-9;

int sign(long double x) {
    if (x > eps) { return 1; }
    if (x < -eps) { return -1; }
    return 0;
}

long double _max(long double a, long double b) {
    if (sign(a - b) == -1) {
        return b;
    }
    return a;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    vector<vector<pair<int, int>>> cut(n);
    vector<pair<int, int>> tmp;
    // int maxa = 0;
    long double part = 1;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        part /= a[i];
        tmp.clear();
        for (int x = 1; x * 1ll * x <= a[i]; ++x) {
            tmp.emplace_back(a[i] / x, x);
            int y = a[i] / x;
            for (int dy = 1; dy >= -1; --dy) {
                if (y + dy >= 1 && y + dy <= a[i] && a[i] / (y + dy) == x) {
                    tmp.emplace_back(x, y + dy);
                    break;
                }
            }
        }
        sort(tmp.begin(), tmp.end());
        for (const auto& [cost, b] : tmp) {
            if (cut[i].empty() || cut[i].back().first != cost) {
                cut[i].emplace_back(cost, b);
            }
            cut[i].back().second = b;
        }
        // maxa = max(maxa, a[i]);
    }
    vector<vector<long double>> dp(2, vector<long double>(k + 1));
    int layer = 0;
    dp[0][1] = 1;
    for (int i = 0; i < n; ++i) {
        layer ^= 1;
        for (int j = k; j >= 1; --j) {
            dp[layer][j] = 0;
            for (int l = 0; l < (int)cut[i].size(); ++l) {
                int cost = cut[i][l].first, b = cut[i][l].second;
                dp[layer][j] = _max(dp[layer][j], dp[layer ^ 1][(j + b - 1) / b] * cost);
            }
            if (j != k) {
                dp[layer][j] = _max(dp[layer][j], dp[layer][j + 1]);
            }
        }
    }
    cout << fixed << setprecision(10);
    cout << dp[layer][k] * k * part << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
