#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdio>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <iomanip>
#include <cmath>
#include <vector>
#include <string>
#include <stack>
#include <deque>
#include <queue>
#define endl '\n'
#define ALL(v) begin(v),end(v)

using namespace std;

constexpr int MAXN = 2E5, sq = 447;
constexpr uint64_t MOD = 1E9 + 7;
const long double Pi = acosl(-1);

template <typename T>
bool rmin(T& x, const T& y)
{
	if (y < x)
	{
		x = y;
		return true;
	}
	return false;
}
template <typename T>
bool rmax(T& x, const T& y)
{
	if (x < y)
	{
		x = y;
		return true;
	}
	return false;
}

struct Mod_int
{
	uint32_t ans;
	Mod_int(uint64_t ans = 0) :ans(ans% MOD) {}
	Mod_int operator* (const Mod_int& m) const
	{
		return int64_t(ans) * m.ans;
	}
	Mod_int operator*= (const Mod_int& m)
	{
		return *this = *this * m;
	}
	Mod_int operator^ (uint64_t step) const
	{
		Mod_int ans = 1, t = *this;
		while (step > 0)
		{
			if (step & 1)
			{
				ans *= t;
			}
			t *= t;
			step >>= 1;
		}
		return ans;
	}
	Mod_int operator/ (const Mod_int& m) const
	{
		return *this * (m ^ (MOD - 2));
	}
	Mod_int operator/= (const Mod_int& m)
	{
		return *this = *this / m;
	}
};

int par[MAXN], bin_up[19][MAXN], range[MAXN];
pair <int, int> val[MAXN];
bool used[MAXN];

void dfs(int x)
{
	if (range[x] != -1)
	{
		return;
	}
	dfs(par[x]);
	range[x] = range[par[x]] + 1;
	return;
}

int parent[MAXN];
pair <int, int> val_gr[MAXN];

int get_parent(int x)
{
	if (parent[x] < 0)
	{
		return x;
	}
	return parent[x] = get_parent(parent[x]);
}

void unit(int x, int y)
{
	x = get_parent(x);
	y = get_parent(y);
	if (x == y)
	{
		return;
	}

	if (parent[y] < parent[x])
	{
		swap(x, y);
	}
	rmin(parent[x], parent[y] - 1);
	rmax(val_gr[x].first, val_gr[y].first);
	rmin(val_gr[x].second, val_gr[y].second);
	parent[y] = x;
	return;
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout << fixed << setprecision(10);

	int n;
	cin >> n;
	for (int i = 0; i < n - 1; i++)
	{
		cin >> par[i + 1];
		par[i + 1]--;
	}

	Mod_int tot = 1;
	for (int i = 0; i < n; i++)
	{
		cin >> val[i].first >> val[i].second;
		tot *= val[i].second - val[i].first + 1;
	}

	fill(range, range + n, -1);
	range[0] = 0;
	for (int i = 0; i < n; i++)
	{
		if (range[i] == -1)
		{
			dfs(i);
		}
	}

	for (int i = 0; i < n; i++)
	{
		bin_up[0][i] = par[i];
	}
	for (int st = 1; st < 19; st++)
	{
		for (int i = 0; i < n; i++)
		{
			bin_up[st][i] = bin_up[st - 1][bin_up[st - 1][i]];
		}
	}

	int m;
	cin >> m;
	vector <int> f, s, dop;
	for (int i = 0; i < n; i++)
	{
		parent[i] = -1;
		val_gr[i] = val[i];
	}
	for (int z = 0; z < m; z++)
	{
		f.clear();
		s.clear();
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		--a;
		--b;
		--c;
		--d;
		int l_a = a, l_b = b;

		int t;
		if (range[l_a] < range[l_b])
		{
			t = 18;
			while (t >= 0)
			{
				if (range[bin_up[t][l_b]] > range[l_a])
				{
					l_b = bin_up[t][l_b];
				}
				--t;
			}
			l_b = par[l_b];
		}
		else if (range[l_a] > range[l_b])
		{
			t = 18;
			while (t >= 0)
			{
				if (range[bin_up[t][l_a]] > range[l_b])
				{
					l_a = bin_up[t][l_a];
				}
				--t;
			}
			l_a = par[l_a];
		}

		int to;
		if (l_a != l_b)
		{
			t = 18;
			while (t >= 0)
			{
				if (bin_up[t][l_a] != bin_up[t][l_b])
				{
					l_a = bin_up[t][l_a];
					l_b = bin_up[t][l_b];
				}
				--t;
			}
			to = par[l_a];
		}
		else
			to = l_a;

		dop.clear();
		while (b != to)
		{
			dop.push_back(b);
			b = par[b];
		}
		while (a != to)
		{
			f.push_back(a);
			a = par[a];
		}
		f.push_back(to);
		for (int i = int(dop.size()) - 1; i >= 0; i--)
		{
			f.push_back(dop[i]);
		}






		l_a = c, l_b = d;
		if (range[l_a] < range[l_b])
		{
			t = 18;
			while (t >= 0)
			{
				if (range[bin_up[t][l_b]] > range[l_a])
				{
					l_b = bin_up[t][l_b];
				}
				--t;
			}
			l_b = par[l_b];
		}
		else if (range[l_a] > range[l_b])
		{
			t = 18;
			while (t >= 0)
			{
				if (range[bin_up[t][l_a]] > range[l_b])
				{
					l_a = bin_up[t][l_a];
				}
				--t;
			}
			l_a = par[l_a];
		}

		if (l_a != l_b)
		{
			t = 18;
			while (t >= 0)
			{
				if (bin_up[t][l_a] != bin_up[t][l_b])
				{
					l_a = bin_up[t][l_a];
					l_b = bin_up[t][l_b];
				}
				--t;
			}
			to = par[l_a];
		}
		else
			to = l_a;

		dop.clear();
		while (d != to)
		{
			dop.push_back(d);
			d = par[d];
		}
		while (c != to)
		{
			s.push_back(c);
			c = par[c];
		}
		s.push_back(to);
		for (int i = int(dop.size()) - 1; i >= 0; i--)
		{
			s.push_back(dop[i]);
		}

		Mod_int ans = tot;
		for (int i = 0; i < f.size(); i++)
		{
			unit(f[i], s[i]);
		}
		for (int i = 0; i < f.size(); i++)
		{
			if (!used[f[i]])
			{
				used[f[i]] = true;
				ans /= val[f[i]].second - val[f[i]].first + 1;

				if (f[i] == get_parent(f[i]))
				{
					ans *= max(0, val_gr[f[i]].second - val_gr[f[i]].first + 1);
				}
			}
		}
		for (int i = 0; i < s.size(); i++)
		{
			if (!used[s[i]])
			{
				used[s[i]] = true;
				ans /= val[s[i]].second - val[s[i]].first + 1;

				if (s[i] == get_parent(s[i]))
				{
					ans *= max(0, val_gr[s[i]].second - val_gr[s[i]].first + 1);
				}
			}
		}

		for (int i = 0; i < f.size(); i++)
		{
			used[f[i]] = false;
		}
		for (int i = 0; i < s.size(); i++)
		{
			used[s[i]] = false;
		}
		cout << ans.ans << endl;
	}
}