#include <iostream>
#include <utility>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <cassert>
#include <iomanip>

using namespace std;

typedef long long ll;
typedef long double ld;

//struct LCA{
//    int n, k;
//    vector<int> depths, parents;
//    vector<vector<int>> dp;
//
//    void dfs(int v, int par, vector<vector<int>>& g, vector<bool>& used){
//        used[v] = true;
//        parents[v] = par;
//        for(auto to : g[v]){
//            if(!used[to])
//                dfs(to, v, g, used);
//        }
//        if(par != -1)
//            depths[v] = depths[par] + 1;
//
//    }
//
//    int get_log2(int n){
//        ll num = 1;
//        k = 0;
//        while (num < n) {
//            num *= 2;
//            k++;
//        }
//        return k;
//    }
//
//    void LA(){
//        for(int i = 0; i < n; i++)
//            dp[0][i] = parents[i];
//        for(int i = 1; i <= k; i++){
//            for(int j = 0; j < n; j++){
//                dp[k][i] = dp[k - 1][dp[k - 1][i]];
//            }
//        }
//    }
//
//    void build(vector<vector<int>>& g){
//        n = g.size();
//        vector<bool> used(n);
//        depths.assign(n, 0);
//        parents.assign(n, 0);
//        dfs(0,-1,g,used);
//
//        int k = get_log2(n);
//        dp.assign(k + 1, vector<int>(n));
//        LA();
//    }
//
//    int up(int v, int level){
//        for(int i = k; i >= 0; i--){
//            if(depths[v] - (1ll << i) >= level){
//                v = dp[i][v];
//            }
//        }
//        return v;
//    }
//
//    int lca(int v, int u){
//        if(depths[v] < depths[u])
//            u = up(u, depths[v]);
//        if (depths[u] < depths[v])
//            v = up(v, depths[u]);
//
//
//    }
//
//
//};
//
//struct segtree{
//    vector<ll> tree;
//    int size;
//
//    int init(int n){
//        size = 1;
//        while(size < n)
//            size *= 2;
//        tree.assign(2 * size - 1, 0);
//    }
//};

int timer;
//void dfs1(int v, vector<vector<pair<int, int>>>& g, vector<int>& used, vector<int>& tout){
//    used[v] = true;
//
//    for(auto e : g[v]){
//        int to = e.first;
//        if(!used[to]){
//            dfs1(to, g, used, tout);
//        }
//    }
//    tout[v] = timer++;
//}

void condense(int v, vector<vector<int>>& g, vector<vector<int>>& cond,vector<int>&used){
    used[v] = true;
    cond.back().push_back(v);

    for(auto to : g[v]){
        if(!used[to])
            condense(to, g, cond, used);
    }
}

//void solve1(){
//    timer = 0;
//    int n, m;
//    cin >> n >> m;
//
//    vector<vector<pair<int, int>>> g(n);
//    for(int i = 0;  i < m; i++){
//        int v,u,w;
//        cin >> v >> u >> w;
//        v--, u--;
//        g[v].push_back({u, w});
//    }
//
//    vector<int> tout(n), used(n);
//    for(int i = 0; i < n; i++){
//        if(!used[i]){
//            dfs(i,g, used, tout);
//        }
//    }
//
//    vector<vector<int>> cond, inv_g(n);
//    used.assign(n, 0);
//    for(int i = 0; i < n; i++){
//        for(auto e : g[i]){
//            inv_g[e.first].push_back(i);
//        }
//    }
//    for(int i = 0; i < n; i++){
//        if(!used[i])
//            condense(i, inv_g, cond, used);
//    }
//
//    for(int i = 0;  i< cond.size(); i++){
//        cout<<i <<"\n";
//        for(auto j : cond[i])
//            cout<<j << ' ';
//        cout<<"\n";
//    }
//
//}

void dfs(int v, vector<vector<pair<int, int>>>& g, vector<int>& used){
    used[v] = true;

    for(auto e : g[v]){
        int to = e.first;
        if(!used[to]){
            dfs(to, g, used);
        }
    }


}

void solve(){
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n);
    for(int i = 0;  i < m; i++){
        int v,u,w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].push_back({u, w});
    }

    int a, b;
    cin >> a >> b;
    a--, b--;

    if (a == b){
        bool flag = false;
        for (auto e : g[a]){
            if(e.first == a && e.second > 0)
                flag = true;
        }
        if(flag){
            cout<<"-1\n";
            return;
        }
        else{
            cout<<"0\n";
            return;
        }
    }

    vector<vector<pair<int, int>>> inv_g(n);
    vector<int> used1(n), used(n);
    for(int i = 0; i < n; i++){
        for(auto e : g[i]){
            inv_g[e.first].push_back({i, e.second});
        }
    }

    dfs(a, g, used);
    dfs(b,inv_g,used1);

    vector<bool> valid(n);
    for(int i = 0; i < n; i++){
        valid[i] = (used[i] & used1[i]);
    }
    if(!valid[a] || !valid[b]){
        cout<<"0\n";
        return;
    }

//    for(auto i : valid)
//        cout<<i<<' ';
//    cout<<"\n";

    vector<vector<pair<int, int>>> g1(n);
    for(int v = 0; v < n; v++){
        if(valid[v]) {
            for (auto e: g[v]) {
                if (valid[e.first])
                    g1[v].push_back(e);
            }
        }
    }
    g = g1;

    for(int i = 0; i < n; i++){
        if(valid[i])
            cout<<i << ' ';
    }
    cout<<"\n";
}

void solve2(int n, int m){
    vector<vector<pair<int, int>>> g(n);
    int xr = 0;
    for(int i = 0;  i < m; i++){
        int v,u,w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].push_back({u, w});
        xr = xr ^ w;
    }

    int a, b;
    cin >> a >> b;
    a--, b--;
//    if(n == 1){
//        bool flag = false;
//        for(auto to : g[a])
//            if(to.second != 0)
//                flag = true;
//        if(flag)
//            cout<<"-1\n";
//        else
//            cout<<"0\n";
//        return;
//    }
    if(xr == 0) {
        if(a == b){
            cout<<"0\n";
            return;
        }
        int v = a;
        xr = 0;
        while(v != b){
            xr = xr ^ g[v][0].second;
            v = g[v][0].first;
        }
        cout<<xr<<"\n";
    }
    else
        cout<<"-1\n";

}

int main() {
    //freopen("input", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(nullptr);
    cout<<fixed<<setprecision(10);

    int n, k;
    cin >> n >> k;
    double a;
    cin >> a;

    if(n == 1){
        if(a < k)
            cout<<0;
        else{
            cout<<((int)a / k) * k / a;
        }
    }
    else{
        double b;
        cin >> b;
        double mn = 0;
        double c = k / a / b;
        for(int i = 1; i <=  a; i++){
            int b1 = ceil(k / i);
            if(b1 * i < k)
                b1++;
            double res = ((int)a / i) * ((int)b / b1) * c;
            mn = max(mn, res);
        }
        cout<<mn;
    }


    return 0;
}