#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

// #define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld long double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return (rng() % (r - l + 1)) + l;
}

const int N = 4e4 + 10;

long double dp[2][N];

const ld eps = 1e-12;

int sign (ld x) {
    if (x > eps) return 1;
    if (x < -eps) return -1;
    return 0;
}

int n, k;
vector<int> a;

void read () {
    cin >> n >> k;
    a.resize(n);
    cin >> a;
}

vector<pair<int, int>> interesting (int x) {
    vector<pair<int, int>> zxc;
    int last = 0;
    for (int i = x; i >= 1; i--) {
        int now = x / i;
        if (now != last) {
            zxc.push_back({now, i});
            last = now;
        }
    }
    return zxc;
}

void solve_two () {
    if (n == 1) {
        auto A = interesting(a[0]);
        long double ans = 0;
        for (int i = 0; i < sz(A); i++) {
            if (A[i].second >= k) {
                ld c = (ld)(A[i].first) / (ld)(a[0]);
                ans = max(ans, c * k);
            }
        }
        cout << ans << '\n';
    } else {
        auto A = interesting(a[0]);
        auto B = interesting(a[1]);
        long double ans = 0;
        for (int i = 0; i < sz(A); i++) {
            for (int j = 0; j < sz(B); j++) {
                if (A[i].second * B[j].second >= k) {
                    ld c = (ld)(A[i].first) / (ld)(a[0]);
                    ld d = (ld)(B[j].first) / (ld)(a[1]);
                    ans = max(ans, c * d * k);
                }
            }
        }
        cout << ans << '\n';
    }
}

void solve() {
    read();
    if (n <= 2) {
        solve_two();
        return;
    }
    dp[0][1] = 1;
    for (int i = 0; i < n; i++) {
        int A = (i + 1) & 1;
        for (int j = 0; j <= k; j++) {
            dp[A][j] = 0;
        }
        auto X = interesting(a[i]);
        for (auto z : X) {
            int x = z.first;
            for (int from = 1; from <= k; from++) {
                int nxt = min(k, from * z.second);
                long double z = (ld)(x) / (ld)(a[i]);
                dp[A][nxt] = max(dp[A][nxt], dp[A ^ 1][from] * z);
            }
        }
    }
    cout << dp[(n) & 1][k] * k << '\n';
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */