#pragma GCC optimize("O3")
#pragma GCC target("avx2")

#include <bits/stdc++.h>

// #define double long double

void solve() {
    int n, k;
    std::cin >> n >> k;
    std::vector<int> input(n);
    for (int& i : input) {
        std::cin >> i;
    }
    std::sort(input.rbegin(), input.rend());

    std::vector<double> dp(k + 1);
    dp[1] = 1;

    auto suf_max = [](auto& vec) {
        for (int i = (int)vec.size() - 1; i >= 1; i--) {
            vec[i - 1] = std::max(vec[i - 1], vec[i]);
        }
    };

    auto gen_cum = [&](int val) {
        static std::vector<std::pair<int, int>> cum;
        cum.clear();

        cum.push_back({1, val});
        int bd = std::min(val, k);
        for (int i = 1; i <= val;) {
            int x = (val % i) / (val / i) + 1;
            i += x;
            if (i - 1 <= val) {
                cum.push_back({i - 1, val / (i - 1)});
            } else {
                break;
            }
            if (i - 1 >= k) {
                break;
            }
        }
        assert(cum.size() * cum.size() <= val * 4 + 5);
        return cum;
    };

    for (int t = 0; t < n - 1; t++) {
        suf_max(dp);

        int val = input[t];

        auto cum = gen_cum(val);

        for (int i = k, j = 0; i >= 1; i--) {
            double sh = dp[i] / val;

            for (int j = 0; j < cum.size(); j++) {
                int pos = std::min<int>(k, i * cum[j].first);

                dp[pos] = std::max(dp[pos], sh * cum[j].second);
                if (pos == k) {
                    break;
                }
            }
        }
    }
    suf_max(dp);

    double ans = 0;
    {
        int val = input.back();
        auto cum = gen_cum(val);
        auto get = [&](int i, int j) {
            return dp[(i - 1) / cum[j].first + 1] * cum[j].second;
        };
        for (int j = 0; j < cum.size(); j++) {
            ans = std::max(ans, get(k, j));
        }
        ans /= val;
    }
    // double denom = std::accumulate(input.begin(), input.end(), (double)1.0, std::multiplies<double>());
    // ans /= denom;
    ans *= k;

    if (ans == 0) {
        std::cout << "0\n";
        return;
    }

    assert(ans > 0.4);
    std::cout << ans << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cout.precision(10);
    std::cout << std::fixed;

    int t = 1;
#ifdef LOCAL
    std::cin >> t;
#endif
    while (t--) {
        solve();
    }

    return 0;
}
