#include <iostream>
#include <vector>
#include <algorithm>
#include <assert.h>
#include <iomanip>
#include <utility>
#include <set>
#include <map>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef unsigned int uint;

const int MOD = (int)1e9 + 7;
struct mint {
	int x = 0;
	mint() {};
	mint(ll value) {
		value %= MOD;
		if (value < 0) value += MOD;
		x = value;
	}
	mint& pow(int n) const {
		mint res(1);
		mint a(x);
		while (n) {
			if (n & 1) {
				res *= a;
			}
			a *= a;
			n /= 2;
		}
		return res;
	}

	mint& rev() const {
		return (*this).pow(MOD - 2);
	}

	mint& operator+=(const mint& b) {
		x += b.x;
		if (x >= MOD) x -= MOD;
		return *this;
	}
	mint& operator-=(const mint& b) {
		x -= b.x;
		if (x < 0) x += MOD;
		return *this;
	}
	mint& operator*=(const mint& b) {
		x = (1ll * x * b.x) % MOD;
		return *this;
	}
	mint& operator/=(const mint& b) {
		assert(b.x != 0);
		*this *= b.rev();
		return *this;
	}
	mint operator+(const mint& b) {
		return mint(x + b.x);
	}
	mint operator-(const mint& b) {
		return mint(x - b.x);
	}
	mint operator*(const mint& b) {
		return mint(1ll * x * b.x);
	}
	mint operator/(const mint& b) {
		return mint(x) * b.rev();
	}
};

vector<int> get(vector<int>& b) {
	vector<int> res;
	res.push_back(b[0]);
	for (int i = 1; i < b.size(); i++) {
		if (res.back() < b[i]) {
			res.push_back(b[i]);
		}
	}
	reverse(res.begin(), res.end());
	return res;
}

const int maxn = (int)41000 + 10;

ld dp[110][maxn];
ld eps = 1e-6;

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n + 1);
	for (int i = 1; i <= n; i++) {
		cin >> a[i];
	}

	if (n == 2) {
		ld ans = 0;
		for (ll i = 1; i <= a[1]; i++) {
			ll need = k / i;
			while (i * need < k) need++;
			if (need > a[2]) continue;
			ll one = a[1] / i;
			ll two = a[2] / need;
			ans = max(ans, (ld)k * one / a[1] * two / a[2]);
		}
		cout << setprecision(20) << fixed << ans << '\n';
		return;
	}

	dp[0][1] = k;
	for (int i = 0; i < n; i++) {
		vector<pair<int, int>> go;
		int cur = 1;
		while (cur <= a[i + 1]) {
			int k = a[i + 1] / cur;
			int mx = a[i + 1] / k;
			go.push_back({ mx, k });
			cur = mx + 1;
		}
		for (int j = 1; j < maxn; j++) {
			if (dp[i][j] < eps) continue;
			int cur = 1;
			for (auto& [mx, k] : go) {
				ll go = min(1ll * j * mx, maxn - 1ll);
				dp[i + 1][go] = max(dp[i + 1][go], 1. * dp[i][j] * k / a[i + 1]);
			}
		}
	}

	ld ans = 0;
	for (int i = k; i < maxn; i++) {
		ans = max(ans, dp[n][i]);
	}
	cout << setprecision(20) << fixed << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int t = 1;
	//cin >> t;

	while (t--) {
		solve();
	}
}
