#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}

vector<int> factor(int x) {
    vector<int> res;
    for (int i = 2; i * i <= x; ++i) {
        while (x % i == 0) {
            x /= i;
            res.push_back(i);
        }
    }

    if (x != 1) {
        res.push_back(x);
    }
    return res;
}

string f(int a, int b, int c) {
    __int128_t x = a;
    x *= b;
    x *= INF;
    x /= c;

    string res = "";
    while (x > 0) {
        res += to_string(int(x % 10));
        x /= 10;
    }
    reverse(all(res));
    return res;
}

int solve_2(int n, int k, vector<int> & a) {
    while (a.size() < 2)
        a.push_back(1);
    int res = 0;
    for (int i = 1; i <= a[0]; ++i) {
        int other = (k + i - 1) / i;
        int x = a[0] / i;
        int y = a[1] / other;
        res = max(res, x * y);
    }
    return res;
}

int solve_all(int n, int k, vector<int> & a) {
    vector<vector<int>> dp(n + 1, vector<int>(k + 1));
    dp[0][1] = 1;

    for (int i = 1; i <= n; ++i) {
        for (int x = 1; x <= a[i - 1]; ++x) {
            for (int u = 1; u <= k; ++u) {
                dp[i][min(k, u * x)] = max(dp[i][min(k, u * x)], dp[i - 1][u] * (a[i - 1] / x));
            }
        }
    }
    return dp[n][k];
}

void stress() {
    for (int k = 1; k < 50; ++k) {
        for (int a = 1; a < 50; ++a) {
            for (int b = 1; b < 50; ++b) {
                int n = 2;
                vector<int> v = {a, b};
                int cor = solve_2(n, k, v);
                int sol = solve_all(n, k, v);

                if (cor != sol) {
                    cout << cor << " " << sol << endl;
                    cout << n << " " << k << endl;
                    for (int x : v)
                        cout << x << " ";
                    cout << endl;
                    break;
                }
            }
        }
    }
}
void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &e: a)
        cin >> e;

    if (k == 1) {
        cout << 1 << endl;
        return;
    }

    int m = 1;
    for (int i: a)
        m *= i;

    if (m < k) {
        cout << 0 << endl;
        return;
    }

    int r;
    if (n <= 2) {
        r = solve_2(n, k, a);
    } else {
        r = solve_all(n, k, a);
    }

    if (r * k == m) {
        cout << 1 << endl;
        return;
    }
    cout << "0." << f(k, r, m) << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    cout.precision(40);
    cout << fixed;
    solve();

    return 0;
}