#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

const int maxk = 1e7;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}

vector<int> factor(int x) {
    vector<int> res;
    for (int i = 2; i * i <= x; ++i) {
        while (x % i == 0) {
            x /= i;
            res.push_back(i);
        }
    }

    if (x != 1) {
        res.push_back(x);
    }
    return res;
}

double solve_2(int n, int k, vector<int> &a) {
    while (a.size() < 2)
        a.push_back(1);
    int res = 0;
    for (int i = 1; i <= a[0]; ++i) {
        int other = (k + i - 1) / i;
        int x = a[0] / i;
        int y = a[1] / other;
        res = max(res, x * y);
    }
    return 1.0 * k * res / a[0] / a[1];
}

double dp[maxk + 1];

double solve_all(int n, int k, vector<int> &a) {
    dp[1] = k;

    auto nxt = [&](int a, int x) {
        if (a / (x + 1) == 0)
            return a + 1;
        return a / (a / (x + 1));
    };

    set<int> ind = {-1};

    for (int i = 1; i <= n; ++i) {
        vector<int> v;

        vector<int> factor;
        for (int x = 1; x <= a[i - 1]; x = nxt(a[i - 1], x)) {
            factor.push_back(x);
        }

        for (int y : ind) {
            int u = -y;
            for (int x : factor) {
                int take = a[i - 1] / x;
                dp[min(k, u * x)] = max(dp[min(k, u * x)],
                                           dp[u] * take / a[i - 1]);
                v.push_back(min(k, u * x));
            }
        }
        for (int e : v)
            ind.insert(-e);
    }
    return dp[k];
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int &e: a)
        cin >> e;

    if (k == 1) {
        cout << 1 << endl;
        return;
    }

#ifdef LOCAL
    double r = solve_all(n, k, a);
    cout << r << endl;
#endif

    if (n <= 2) {
        cout << solve_2(n, k, a) << endl;
        return;
    } else {
        double r = solve_all(n, k, a);
        cout << r << endl;
    }
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    cout.precision(40);
    cout << fixed;
    solve();

    return 0;
}