#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 3e5 + 42;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);



void solve_smallk(int n, int k, vector<int> a) {
    vector<ld> dp(k + 1), ndp(k + 1);
    vector<vector<pair<int, int>>> pr(n + 1, vector<pair<int, int>>(k + 1));
    dp[1] = 1;
    for(int i = 0; i < n; i++) {
        for(int p = 1; p <= k; p++) {
            ld v = dp[p];
            if(!v) continue;
            for(int l = 1; l <= a[i]; l++) {
                int val = a[i] / l;
                int b = a[i] / val;
                int np = min(p * b, k);
                ld nv = v * val / a[i] ;
                if(umax(ndp[np], nv)) pr[i + 1][np] = {p, b};
                if(np == k) break;
                l = b;
            }
        }
        fill(all(dp), 0);
        dp.swap(ndp);
    }
    vector<int> ans(n + 1);
    int p = k;
    for(int i = n; i; i--) {
        ans[i] = pr[i][p].s;
        p = pr[i][p].f;
    }
    dp[k] *= k;
    cout << fixed << setprecision(15) << dp[k] << '\n';
}

void solve_two(int k, int x, int y) {
    vector<int> f, s;
    for(int l = 1; l <= x; l++) {
        int val = x / l;
        int b = x / val;
        f.pb(b);
        l = b;
    }
    for(int l = 1; l <= y; l++) {
        int val = y / l;
        int b = y / val;
        s.pb(b);
        l = b;
    }
    ld ans = 0;
    for(auto b1 : f) {
        for(auto b2 : s) {
            if(b1 * b2 < k) continue;
            int X = x / b1;
            int Y = y / b2;
            umax(ans, (ld) X * Y / x / y);
        }
    }
    ans *= k;
    cout << fixed << setprecision(15) << ans << '\n';
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for(auto &i : a) {
        cin >> i;
    }
    if(n == 2) {
        solve_two(k, a[0], a[1]);
        return;
    }
    if(k <= 4e4) {
        solve_smallk(n, k, a);
        return;
    }
    cout << fixed << setprecision(15);
    map<int, ld> dp, ndp;
    dp[1] = 1;
    for(int i = 0; i < n; i++) {
        for(auto [p, v] : dp) {
            for(int l = 1; l <= a[i]; l++) {
    //            cout << a[i] << ' ' << l << " " << sz(dp) << endl;
                int val = a[i] / l;
                int b = a[i] / val;
                int np = min(p * b, k);
                ld nv = v * val / a[i] ;
                umax(ndp[np], nv);
                if(np == k) break;
                l = b;
            }
        }
        dp.clear();
        dp.swap(ndp);
    }
    dp[k] *= k;
    cout << fixed << setprecision(15) << dp[k] << '\n';
}

/*
2 10000000
10000000 10000000
*/

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
