#include <iostream>
#include <iomanip>
#include <cmath>
#include <algorithm>
#include <numeric>
#include <ctime>
#include <chrono>
#include <cassert>
#include <random>
#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <deque>
#include <bitset>
using namespace std;
mt19937_64 rnd(time(NULL));

const long long INF = 1e18, MOD = 1e9 + 7;

long long n, k;
vector<long long> a;

long double ans = 0;

void check(vector<long long>& d, long double cur, long double zn, long long idx, long long prev)
{
	if (idx == d.size())
	{
		ans = max(ans, cur * k / zn);
		return;
	}

	for (long long i = prev + 1; i < a.size(); i++)
	{
		if (a[i] < d[idx])
		{
			continue;
		}
		if (d.size() - idx > a.size() - i)
		{
			break;
		}

		check(d, cur * (long long)(a[i] / d[idx]), zn * a[i], idx + 1, i);
	}
}

void rec(long long idx, long long mul, long long prev, vector<long long>& d)
{
	if (idx == d.size())
	{
		if (mul >= k)
		{
			check(d, 1, 1, 0, -1);
		}
		return;
	}

	long long here = prev;
	mul /= 2;
	while (mul * (here - 1) < k)
	{
		d[idx] = here;
		if (here > a[a.size() - d.size() + idx])
		{
			break;
		}

		rec(idx + 1, mul * here, here, d);
		here++;
	}
}

void solve()
{
	cin >> n >> k;
	a.resize(n);
	long long mul = 1;
	bool ok = false;
	for (long long i = 0; i < n; i++)
	{
		cin >> a[i];
		mul *= a[i];
		if (mul >= k)
		{
			ok = true;
		}
	}
	if (!ok)
	{
		cout << 0 << "\n";
		return;
	}
	if (k == 1)
	{
		cout << 1 << "\n";
		return;
	}
	sort(a.begin(), a.end());

	long long lg2 = 0;
	long long kk = k;
	while (kk > 1)
	{
		lg2++;
		kk /= 2;
	}
	if ((1ll << lg2) < k)
	{
		lg2++;
	}

	for (long long notone = 1; notone <= min(n, lg2); notone++)
	{
		vector<long long> d(notone, 2);
		long long mul = (1ll << notone);
		rec(0,  mul, 2, d);
	}
	cout << fixed << setprecision(20) << ans << "\n";
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	solve();

	return 0;
}

/*























*/
