#include <iostream>
#include <map>
#include <vector>
#include <set>
#include <random>
#include <bitset>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <deque>
#include <numeric>

using namespace std;

mt19937 rn;
vector<int> fen;

void add(int i, int x) {
    for (; i < fen.size(); i = i | (i + 1)) {
        fen[i] = max(x, fen[i]);
    }
}

int get(int r) {
    int res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1) {
        res = max(res, fen[r]);
    }
    return res;
}

struct line {
    int a, b, c;
};

struct point {
    int x, y;

    point operator-(point a) {
        return point{x - a.x, y - a.y};
    }

    int operator*(point a) {
        return x * a.y - y - a.x;
    }

    int operator%(point a) {
        return x * a.x + y * a.y;
    }

    point operator-(int d) {
        return point{x - d, y - d};
    }

    point operator+(int d) {
        return point{x + d, y + d};
    }
};

int lcd(vector<int> a, vector<int> b) {
    vector<vector<int>> dp(a.size() + 1, vector<int>(b.size() + 1));
    int n = a.size();
    int m = b.size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i] == b[j]) {
                dp[i + 1][j + 1] = dp[i][j] + 1;
            } else {
                dp[i + 1][j + 1] = max(dp[i][j + 1], dp[i + 1][j]);
            }
        }
    }
    return dp[n][m];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    long long n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    if (n <= 2) {
        vector<vector<pair<long long, double>>> b(2);
        int ind = 0;
        if (a.size() == 1) {
            a.push_back(1);
        }
        for (auto now: a) {
            int cnt = now;
            b[ind].push_back({1, 1});
            while (cnt > 0) {
                int num = now / cnt;
                double ln = 1.0 / now * (double) num;
                b[ind].push_back({cnt, ln});
                cnt = now / (num + 1);
            }
            ++ind;
        }
        double ans = 0;
        for (auto i: b[0]) {
            for (auto j: b[1]) {
                if (j.first * i.first >= k) {
                    ans = max(ans, k * j.second * i.second);
                }
            }
        }
        cout.precision(20);
        cout << ans << "\n";
    } else {
        for (int i = 0; i < n; ++i) {
            swap(a[i], a[rn() % n]);
        }
        vector<double> dp(k * 2);
        dp[1] = k;
        auto c = clock();
        for (int i = 0; i < n; ++i) {
            auto new_dp = dp;
            long long cnt = min(k, (long long) a[i]);
            while (cnt > 1) {
                int num = a[i] / cnt;
                double ln = 1.0 / a[i] * (double) num;
                for (int j = 1; j * cnt < dp.size(); ++j) {
                    new_dp[j * cnt] = max(new_dp[j * cnt], dp[j] * ln);
                }
                cnt = a[i] / (num + 1);
            }
            swap(dp, new_dp);
        }
        double ans = 0;
        for (int i = k; i < dp.size(); ++i) {
            ans = max(ans, dp[i]);
        }
        cout.precision(30);
        cout << ans << "\n";
    }
}