#pragma GCC optimize("O3")

#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#include <queue>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <random>
#include <iomanip>
#include <fstream>

using namespace std;

#ifdef LOCAL
ifstream input("input");
#define cin input
#define debug(x) cerr << #x << "=" << (x) << endl
#else
#define debug(x) ;
#endif

#define endl '\n'
#define int long long
#define float long double

random_device rd;
#ifndef int
mt19937 rng(rd());
#else
mt19937_64 rng(rd());
#endif

template<class T> int ckmin(T &a, const T &b) {
	if (b < a) {
		a = b;
		return 1;
	}
	return 0;
}

template<class T> int ckmax(T &a, const T &b) {
	if (b > a) {
		a = b;
		return 1;
	}
	return 0;
}

int mpow(int a, int n, int mod) {
	int ans = 1;
	while (n) {
		if (n & 1) {
			ans *= a;
			ans %= mod;
		}
		a *= a;
		a %= mod;
		n >>= 1;
	}
	return ans;
}

void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
	}
	vector<float> dp(k * 2, 0.0);
	dp[1] = 1.0;
	for (int i = 0; i < n; ++i) {
		vector<float> dp2(k * 2, 0.0);
		for (int j = 1; j < k * 2; ++j) {
			for (int l = 1; l <= a[i]; ++l) {
				if (j % l == 0) {
					ckmax(dp2[j], dp[j / l] * (a[i] / l) / (float) a[i]);
				}
			}
		}
		dp = dp2;
	}
	float ans = 0.0;
	for (int i = k; i < k * 2; ++i) {
		ckmax(ans, dp[i]);
	}
	cout << fixed << setprecision(20) << ans * k << endl;
}

int32_t main() {
#ifndef LOCAL
	ios_base::sync_with_stdio(false);
	cout.tie(nullptr);
	cin.tie(nullptr);
#endif
	int T;
	cin >> T;
	for (int i = 1; i <= T; ++i) {
		cerr << "TEST #" << i << endl;
		solve();
	}
}
