#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <random>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll))
        end_char = ' ';
    if (typeid(T) == typeid(ld))
        end_char = '\t';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef DUDE
    freopen("input.txt", "r", stdin);
#else
    freopen("input.txt", "r", stdin);
#endif

    int n, k;
    cin >> n >> k;
    if (n == 2) {
        ll a, b;
        cin >> a >> b;
        if (a > b)
            swap(a, b);
        ll best = 0;
        for (int i = 1; i <= a; ++i) {
            int j = (k + i - 1) / i;
            maxi(best, (a / i) * (b / j));
        }
        cout << setprecision(15) << fixed << best / (ld) (a * b) * k << '\n';
    }
    else if (n == 1) {
        ll a;
        cin >> a;
        ll best = a / k;
        cout << setprecision(15) << fixed << best / (ld) a * k << '\n';
    }
    else {
        vector<ll> a(n);
        cin >> a;
        vector<vector<ld>> dp(n, vector<ld>(k + 1));
        ld best = 0;
        for (int i = 1; i <= a[0]; ++i) {
            if (i > k) {
                maxi(best, (a[0] / i) / (ld) a[0]);
                continue;
            }
            dp[0][i] = (a[0] / i) / (ld) a[0];
        }
        for (int i = 1; i < n; ++i) {
            for (int j = k; j > 0; --j) {
                if (j < k)
                    dp[i][j] = dp[i - 1][j + 1];
                for (int d = 1; d <= a[i]; ++d) {
                    maxi(dp[i][j], dp[i - 1][(j + d - 1) / d] * (a[i] / d) / (ld) a[i]);
                }
            }
        }
        debugb("dp:\n", dp);
        cout << setprecision(15) << fixed << max(best, dp[n - 1][k]) * k;
    }
    return 0;
}
