#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <queue>
#include <cmath>
#include <cassert>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <random>
#include <numeric>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const int LL_INF = 2e18 + 10;

template <typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

int n, k;
vector<int> a;
bool operator < (const vector<int>& b1, const vector<int>& b2) {
    if (b1[0] == -1) {
        return false;
    }
    if (b2[0] == -1) {
        return true;
    }
    ld vol1 = 1, vol2 = 1;
    for (int i = 0; i < n; i++) {
        vol1 *= (a[i] / b1[i]);
        vol2 *= (a[i] / b2[i]);
        ld to_div = max(vol1, vol2);
        vol1 /= to_div;
        vol2 /= to_div;
    }
    return vol1 < vol2;
}

int main() {
    cin >> n >> k;
    a.resize(n);
    cin >> a;
    vector<vector<int>> state(k + 1, vector<int>(n, -1));
    state[1] = vector<int>(n, 1);
    for (int i = 1; i < k; i++) {
        vector<int> t = state[i];
        for (int j = 2; j == 2 || i * j <= k; j++) {
            for (int p = 0; p < n; p++) {
                if (t[p] * j > a[p]) {
                    continue;
                }
                t[p] *= j;
                if (t < state[max(i * j, k)]) {
                    state[max(i * j, k)] = t;
                }
                t[p] /= j;
            }
        }
    }
    ld ans = k;
    for (int i = 0; i < n; i++) {
        ans *= (a[i] / state[k][i]);
        ans /= a[i];
    }
    cout.precision(100);
    cout << ans;
}

