#if !defined(SSLOCAL) && 0
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx2")
#endif
#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
constexpr int INF = int(1e9) + 7;
constexpr ll LLINF = ll(1e18) + 13;
template<typename T> inline bool smin(T&a,T b) {
  if (b < a) { a = b; return true; }
  return false;
}
template<typename T> inline bool smax(T&a,T b) {
  if (a < b) { a = b; return true; }
  return false;
}
template<typename T1, typename T2> istream & operator >> (istream & in, pair<T1, T2> & pr) {
  in >> pr.first >> pr.second;
  return in;
}
template<typename T> istream & operator >> (istream & in, vector<T> & vec) {
  for (int & x : vec) in >> x;
  return in;
}
template<typename T1, typename T2> ostream & operator << (ostream & out, pair<T1, T2> & pr) {
  out << pr.first << " " << pr.second;
  return out;
}
template<typename T> ostream & operator << (ostream & out, vector<T> & vec) {
  if (vec.empty()) return out;
  out << vec[0];
  for (size_t i = 1; i < vec.size(); ++i)
    out << " " << vec[i];
  return out;
}
mt19937 rng(1810u);
uniform_int_distribution<> uid(0, INF-1);

template<int MOD>
class MintBase {
 public:
  using Type = MintBase<MOD>;
  MintBase(): x(0) {}
  explicit MintBase(int x) : x(x) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD ? x + rhs.x - MOD : x + rhs.x
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD : x - rhs.x
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return x < rhs.x; }
  bool operator == (const Type & rhs) const { return x == rhs.x; }
  bool operator != (const Type & rhs) const { return x != rhs.x; }

 private:
  int x;
};
typedef MintBase<int(1e9) + 7> Mint;

template<int MOD1, int MOD2>
class HashBase {
public:
  using Type = HashBase<MOD1, MOD2>;
  HashBase(): x(0), y(0) {}
  explicit HashBase(int x) : x(x), y(x) {}
  HashBase(int x, int y) : x(x), y(y) {}

  Type operator + (const Type & rhs) const {
    return {
        x + rhs.x >= MOD1 ? x + rhs.x - MOD1 : x + rhs.x,
        y + rhs.y >= MOD2 ? y + rhs.y - MOD2 : y + rhs.y
    };
  }
  Type operator - (const Type & rhs) const {
    return {
        x - rhs.x < 0 ? x - rhs.x + MOD1 : x - rhs.x,
        y - rhs.y < 0 ? y - rhs.y + MOD2 : y - rhs.y
    };
  }
  Type operator * (const Type & rhs) const {
    return {
        static_cast<int>(1ll * x * rhs.x % MOD1),
        static_cast<int>(1ll * y * rhs.y % MOD2)
    };
  }
  Type& operator += (const Type & rhs) { return *this = *this + rhs; }
  Type& operator -= (const Type & rhs) { return *this = *this - rhs; }
  Type& operator *= (const Type & rhs) { return *this = *this * rhs; }

  bool operator < (const Type & rhs) const { return optimization < rhs.optimization; }
  bool operator == (const Type & rhs) const { return optimization == rhs.optimization; }
  bool operator != (const Type & rhs) const { return optimization != rhs.optimization; }

private:
  union {
    struct { int y, x; };
    ll optimization;
  };
};
typedef HashBase<int(1e9) + 7, int(1e9) + 9> Hash;
//Hash P(911, 991), pws[N];
//
//template<int MOD1, int MOD2>
//HashBase<MOD1, MOD2> Substr(int l, int r, const vector<HashBase<MOD1, MOD2>> & hash) {
//  return hash[r] - hash[l] * pws[r - l];
//}

vector<int> ZFunc(const string & s) {
  vector<int> z(s.size());
  int n = static_cast<int>(s.size());
  for (int i = 1, l = 0, r = 0; i < n; ++i) {
    if (i < r)
      z[i] = min(z[i - l], r - i);
    while (i + z[i] < n && s[z[i]] == s[i + z[i]])
      ++z[i];
    if (i + z[i] > r)
      l = i, r = i + z[i];
  }
  return z;
}

constexpr int N = int(2e5) + 3;
vector<int> dv[N];

void Solve() {

  int n, k;
  cin >> n >> k;
  vector<int> a(n);
  for (int & x : a) cin >> x;
  if (n == 1) {
    ld ans = k;
    ans /= a[0];
    ans *= (a[0] / k);
    cout << ans << endl;
    return;
  }
  if (n == 2) {
    ld ans = k;
    ans /= 1ll * a[0] * a[1];
    ll opt = 0;
    for (int b1 = 1; b1 <= k; ++b1) {
      int b2 = (k + b1 - 1) / b1;
      smax(opt, 1ll * (a[0] / b1) * (a[1] / b2));
    }
    cout << ans * opt << endl;
    return;
  }
  vector<vector<ld>> dp(2, vector<ld>(k + 1));
  ld st = k;
  for (int i = 0; i < n; ++i)
    st /= (ld) a[i];
  dp[0][1] = st;
  int cur = 0, nxt = 1;
  for (int i = 0; i < n; ++i, swap(cur, nxt)) {
    for (int j = 1; j < k; ++j) {
      dp[nxt][j] = 0;
      for (int x : dv[j])
        if (x <= a[i])
          smax(dp[nxt][j], dp[cur][j / x] * (a[i] / x));
    }
    for (int j = 1; j <= k; ++j) {
      int x = (k + j - 1) / j;
      if (x > a[i]) continue;
      smax(dp[nxt][k], dp[cur][j] * (a[i] / x));
    }
  }
  cout << dp[cur][k] << endl;

}


int main() {
  ios_base::sync_with_stdio(0);
  cin.tie(0);

//  pws[0] = Hash(1);
//  for (int i = 1; i < N; ++i) {
//    pws[i] = pws[i-1] * P;
//  }

  for (int i = 1; i < N; ++i)
    for (int j = i; j < N; j += i)
      dv[j].push_back(i);

  cout << fixed << setprecision(12);
  Solve();

  return 0;
}
